#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 4150
#define LARGE_STATE_COUNT 850
#define SYMBOL_COUNT 348
#define ALIAS_COUNT 8
#define TOKEN_COUNT 156
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 39
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 260

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  anon_sym_LT = 46,
  anon_sym_GT = 47,
  anon_sym_SLASH = 48,
  anon_sym_DOT = 49,
  anon_sym_class = 50,
  anon_sym_async = 51,
  anon_sym_function = 52,
  anon_sym_EQ_GT = 53,
  anon_sym_QMARK_DOT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_AMP_AMP_EQ = 68,
  anon_sym_PIPE_PIPE_EQ = 69,
  anon_sym_QMARK_QMARK_EQ = 70,
  anon_sym_DOT_DOT_DOT = 71,
  anon_sym_AMP_AMP = 72,
  anon_sym_PIPE_PIPE = 73,
  anon_sym_GT_GT = 74,
  anon_sym_GT_GT_GT = 75,
  anon_sym_LT_LT = 76,
  anon_sym_AMP = 77,
  anon_sym_CARET = 78,
  anon_sym_PIPE = 79,
  anon_sym_PLUS = 80,
  anon_sym_DASH = 81,
  anon_sym_PERCENT = 82,
  anon_sym_STAR_STAR = 83,
  anon_sym_LT_EQ = 84,
  anon_sym_EQ_EQ = 85,
  anon_sym_EQ_EQ_EQ = 86,
  anon_sym_BANG_EQ = 87,
  anon_sym_BANG_EQ_EQ = 88,
  anon_sym_GT_EQ = 89,
  anon_sym_QMARK_QMARK = 90,
  anon_sym_instanceof = 91,
  anon_sym_TILDE = 92,
  anon_sym_void = 93,
  anon_sym_delete = 94,
  anon_sym_PLUS_PLUS = 95,
  anon_sym_DASH_DASH = 96,
  anon_sym_DQUOTE = 97,
  anon_sym_SQUOTE = 98,
  sym_unescaped_double_string_fragment = 99,
  sym_unescaped_single_string_fragment = 100,
  sym_escape_sequence = 101,
  sym_comment = 102,
  anon_sym_BQUOTE = 103,
  anon_sym_DOLLAR_LBRACE = 104,
  anon_sym_SLASH2 = 105,
  sym_regex_pattern = 106,
  sym_regex_flags = 107,
  sym_number = 108,
  sym_private_property_identifier = 109,
  anon_sym_target = 110,
  sym_this = 111,
  sym_super = 112,
  sym_true = 113,
  sym_false = 114,
  sym_null = 115,
  sym_undefined = 116,
  anon_sym_AT = 117,
  anon_sym_static = 118,
  anon_sym_readonly = 119,
  anon_sym_get = 120,
  anon_sym_set = 121,
  anon_sym_QMARK = 122,
  anon_sym_declare = 123,
  anon_sym_public = 124,
  anon_sym_private = 125,
  anon_sym_protected = 126,
  anon_sym_override = 127,
  anon_sym_module = 128,
  anon_sym_any = 129,
  anon_sym_number = 130,
  anon_sym_boolean = 131,
  anon_sym_string = 132,
  anon_sym_symbol = 133,
  anon_sym_abstract = 134,
  anon_sym_require = 135,
  anon_sym_extends = 136,
  anon_sym_implements = 137,
  anon_sym_global = 138,
  anon_sym_interface = 139,
  anon_sym_enum = 140,
  anon_sym_DASH_QMARK_COLON = 141,
  anon_sym_QMARK_COLON = 142,
  anon_sym_asserts = 143,
  anon_sym_infer = 144,
  anon_sym_is = 145,
  anon_sym_keyof = 146,
  anon_sym_unknown = 147,
  anon_sym_never = 148,
  anon_sym_object = 149,
  anon_sym_LBRACE_PIPE = 150,
  anon_sym_PIPE_RBRACE = 151,
  sym__automatic_semicolon = 152,
  sym__template_chars = 153,
  sym__ternary_qmark = 154,
  sym__function_signature_automatic_semicolon = 155,
  sym_program = 156,
  sym_export_statement = 157,
  sym_export_clause = 158,
  sym__import_export_specifier = 159,
  sym_declaration = 160,
  sym_import = 161,
  sym_import_statement = 162,
  sym_import_clause = 163,
  sym__from_clause = 164,
  sym_namespace_import_export = 165,
  sym_named_imports = 166,
  sym_expression_statement = 167,
  sym_variable_declaration = 168,
  sym_lexical_declaration = 169,
  sym_variable_declarator = 170,
  sym_statement_block = 171,
  sym_else_clause = 172,
  sym_if_statement = 173,
  sym_switch_statement = 174,
  sym_for_statement = 175,
  sym_for_in_statement = 176,
  sym__for_header = 177,
  sym_while_statement = 178,
  sym_do_statement = 179,
  sym_try_statement = 180,
  sym_with_statement = 181,
  sym_break_statement = 182,
  sym_continue_statement = 183,
  sym_debugger_statement = 184,
  sym_return_statement = 185,
  sym_throw_statement = 186,
  sym_empty_statement = 187,
  sym_labeled_statement = 188,
  sym_switch_body = 189,
  sym_switch_case = 190,
  sym_switch_default = 191,
  sym_catch_clause = 192,
  sym_finally_clause = 193,
  sym_parenthesized_expression = 194,
  sym_expression = 195,
  sym_primary_expression = 196,
  sym_yield_expression = 197,
  sym_object = 198,
  sym_object_pattern = 199,
  sym_assignment_pattern = 200,
  sym_object_assignment_pattern = 201,
  sym_array = 202,
  sym_array_pattern = 203,
  sym_nested_identifier = 204,
  sym_class = 205,
  sym_class_declaration = 206,
  sym_class_heritage = 207,
  sym_function = 208,
  sym_function_declaration = 209,
  sym_generator_function = 210,
  sym_generator_function_declaration = 211,
  sym_arrow_function = 212,
  sym__call_signature = 213,
  sym__formal_parameter = 214,
  sym_call_expression = 215,
  sym_new_expression = 216,
  sym_await_expression = 217,
  sym_member_expression = 218,
  sym_subscript_expression = 219,
  sym_assignment_expression = 220,
  sym__augmented_assignment_lhs = 221,
  sym_augmented_assignment_expression = 222,
  sym__initializer = 223,
  sym__destructuring_pattern = 224,
  sym_spread_element = 225,
  sym_ternary_expression = 226,
  sym_binary_expression = 227,
  sym_unary_expression = 228,
  sym_update_expression = 229,
  sym_sequence_expression = 230,
  sym_string = 231,
  sym_template_string = 232,
  sym_template_substitution = 233,
  sym_regex = 234,
  sym_meta_property = 235,
  sym_arguments = 236,
  sym_decorator = 237,
  sym_decorator_member_expression = 238,
  sym_decorator_call_expression = 239,
  sym_class_body = 240,
  sym_formal_parameters = 241,
  sym_pattern = 242,
  sym_rest_pattern = 243,
  sym_method_definition = 244,
  sym_pair = 245,
  sym_pair_pattern = 246,
  sym__property_name = 247,
  sym_computed_property_name = 248,
  sym_public_field_definition = 249,
  sym_non_null_expression = 250,
  sym_method_signature = 251,
  sym_abstract_method_signature = 252,
  sym_function_signature = 253,
  sym_type_assertion = 254,
  sym_as_expression = 255,
  sym_import_require_clause = 256,
  sym_extends_clause = 257,
  sym_implements_clause = 258,
  sym_ambient_declaration = 259,
  sym_abstract_class_declaration = 260,
  sym_module = 261,
  sym_internal_module = 262,
  sym__module = 263,
  sym_import_alias = 264,
  sym_nested_type_identifier = 265,
  sym_interface_declaration = 266,
  sym_extends_type_clause = 267,
  sym_enum_declaration = 268,
  sym_enum_body = 269,
  sym_enum_assignment = 270,
  sym_type_alias_declaration = 271,
  sym_accessibility_modifier = 272,
  sym_override_modifier = 273,
  sym_required_parameter = 274,
  sym_optional_parameter = 275,
  sym__parameter_name = 276,
  sym_omitting_type_annotation = 277,
  sym_opting_type_annotation = 278,
  sym_type_annotation = 279,
  sym_asserts = 280,
  sym__type = 281,
  sym_tuple_parameter = 282,
  sym_optional_tuple_parameter = 283,
  sym_optional_type = 284,
  sym_rest_type = 285,
  sym__tuple_type_member = 286,
  sym_constructor_type = 287,
  sym__primary_type = 288,
  sym_template_type = 289,
  sym_template_literal_type = 290,
  sym_infer_type = 291,
  sym_conditional_type = 292,
  sym_generic_type = 293,
  sym_type_predicate = 294,
  sym_type_predicate_annotation = 295,
  sym__type_query_member_expression = 296,
  sym__type_query_subscript_expression = 297,
  sym__type_query_call_expression = 298,
  sym_type_query = 299,
  sym_index_type_query = 300,
  sym_lookup_type = 301,
  sym_mapped_type_clause = 302,
  sym_literal_type = 303,
  sym__number = 304,
  sym_existential_type = 305,
  sym_flow_maybe_type = 306,
  sym_parenthesized_type = 307,
  sym_predefined_type = 308,
  sym_type_arguments = 309,
  sym_object_type = 310,
  sym_call_signature = 311,
  sym_property_signature = 312,
  sym_type_parameters = 313,
  sym_type_parameter = 314,
  sym_default_type = 315,
  sym_constraint = 316,
  sym_construct_signature = 317,
  sym_index_signature = 318,
  sym_array_type = 319,
  sym_tuple_type = 320,
  sym_readonly_type = 321,
  sym_union_type = 322,
  sym_intersection_type = 323,
  sym_function_type = 324,
  aux_sym_program_repeat1 = 325,
  aux_sym_export_statement_repeat1 = 326,
  aux_sym_export_clause_repeat1 = 327,
  aux_sym_named_imports_repeat1 = 328,
  aux_sym_variable_declaration_repeat1 = 329,
  aux_sym_switch_body_repeat1 = 330,
  aux_sym_object_repeat1 = 331,
  aux_sym_object_pattern_repeat1 = 332,
  aux_sym_array_repeat1 = 333,
  aux_sym_array_pattern_repeat1 = 334,
  aux_sym_string_repeat1 = 335,
  aux_sym_string_repeat2 = 336,
  aux_sym_template_string_repeat1 = 337,
  aux_sym_class_body_repeat1 = 338,
  aux_sym_formal_parameters_repeat1 = 339,
  aux_sym_extends_clause_repeat1 = 340,
  aux_sym_implements_clause_repeat1 = 341,
  aux_sym_extends_type_clause_repeat1 = 342,
  aux_sym_enum_body_repeat1 = 343,
  aux_sym_template_literal_type_repeat1 = 344,
  aux_sym_object_type_repeat1 = 345,
  aux_sym_type_parameters_repeat1 = 346,
  aux_sym_tuple_type_repeat1 = 347,
  alias_sym_import_specifier = 348,
  alias_sym_namespace_export = 349,
  alias_sym_property_identifier = 350,
  alias_sym_shorthand_property_identifier = 351,
  alias_sym_shorthand_property_identifier_pattern = 352,
  alias_sym_statement_identifier = 353,
  alias_sym_this_type = 354,
  alias_sym_type_identifier = 355,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_abstract] = "abstract",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import_export] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_namespace_export] = "namespace_export",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import_export] = sym_namespace_import_export,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_namespace_export] = alias_sym_namespace_export,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import_export] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constraint = 8,
  field_constructor = 9,
  field_declaration = 10,
  field_decorator = 11,
  field_finalizer = 12,
  field_flags = 13,
  field_function = 14,
  field_handler = 15,
  field_increment = 16,
  field_index = 17,
  field_index_type = 18,
  field_initializer = 19,
  field_key = 20,
  field_kind = 21,
  field_label = 22,
  field_left = 23,
  field_module = 24,
  field_name = 25,
  field_object = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_return_type = 32,
  field_right = 33,
  field_sign = 34,
  field_source = 35,
  field_type = 36,
  field_type_arguments = 37,
  field_type_parameters = 38,
  field_value = 39,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 1},
  [13] = {.index = 3, .length = 1},
  [15] = {.index = 12, .length = 2},
  [16] = {.index = 14, .length = 1},
  [17] = {.index = 15, .length = 2},
  [18] = {.index = 17, .length = 2},
  [19] = {.index = 19, .length = 2},
  [20] = {.index = 21, .length = 2},
  [21] = {.index = 23, .length = 2},
  [22] = {.index = 25, .length = 1},
  [23] = {.index = 26, .length = 2},
  [24] = {.index = 28, .length = 2},
  [25] = {.index = 30, .length = 2},
  [26] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 1},
  [31] = {.index = 35, .length = 2},
  [32] = {.index = 37, .length = 2},
  [33] = {.index = 39, .length = 1},
  [34] = {.index = 40, .length = 2},
  [35] = {.index = 42, .length = 2},
  [36] = {.index = 44, .length = 6},
  [37] = {.index = 50, .length = 1},
  [38] = {.index = 51, .length = 3},
  [39] = {.index = 54, .length = 3},
  [40] = {.index = 57, .length = 2},
  [41] = {.index = 59, .length = 2},
  [42] = {.index = 61, .length = 2},
  [43] = {.index = 63, .length = 2},
  [44] = {.index = 65, .length = 2},
  [45] = {.index = 67, .length = 1},
  [46] = {.index = 68, .length = 3},
  [47] = {.index = 71, .length = 2},
  [48] = {.index = 73, .length = 2},
  [49] = {.index = 75, .length = 2},
  [50] = {.index = 77, .length = 2},
  [51] = {.index = 79, .length = 2},
  [52] = {.index = 81, .length = 2},
  [54] = {.index = 77, .length = 2},
  [55] = {.index = 83, .length = 2},
  [56] = {.index = 85, .length = 1},
  [57] = {.index = 86, .length = 1},
  [58] = {.index = 87, .length = 2},
  [59] = {.index = 89, .length = 4},
  [60] = {.index = 93, .length = 2},
  [61] = {.index = 95, .length = 2},
  [62] = {.index = 26, .length = 2},
  [63] = {.index = 30, .length = 2},
  [64] = {.index = 83, .length = 2},
  [65] = {.index = 97, .length = 3},
  [66] = {.index = 100, .length = 2},
  [67] = {.index = 100, .length = 2},
  [68] = {.index = 102, .length = 3},
  [69] = {.index = 105, .length = 2},
  [70] = {.index = 107, .length = 4},
  [71] = {.index = 111, .length = 3},
  [72] = {.index = 114, .length = 2},
  [73] = {.index = 116, .length = 2},
  [74] = {.index = 118, .length = 1},
  [75] = {.index = 119, .length = 1},
  [76] = {.index = 120, .length = 1},
  [77] = {.index = 121, .length = 2},
  [78] = {.index = 118, .length = 1},
  [79] = {.index = 26, .length = 2},
  [80] = {.index = 123, .length = 2},
  [81] = {.index = 125, .length = 5},
  [82] = {.index = 130, .length = 1},
  [83] = {.index = 121, .length = 2},
  [84] = {.index = 131, .length = 2},
  [85] = {.index = 133, .length = 3},
  [86] = {.index = 136, .length = 2},
  [87] = {.index = 138, .length = 3},
  [88] = {.index = 141, .length = 6},
  [89] = {.index = 147, .length = 1},
  [90] = {.index = 148, .length = 1},
  [91] = {.index = 149, .length = 3},
  [92] = {.index = 152, .length = 3},
  [93] = {.index = 155, .length = 4},
  [94] = {.index = 159, .length = 2},
  [95] = {.index = 161, .length = 3},
  [96] = {.index = 164, .length = 1},
  [97] = {.index = 165, .length = 4},
  [98] = {.index = 169, .length = 4},
  [99] = {.index = 173, .length = 4},
  [100] = {.index = 177, .length = 2},
  [101] = {.index = 179, .length = 3},
  [102] = {.index = 182, .length = 2},
  [103] = {.index = 184, .length = 2},
  [104] = {.index = 186, .length = 2},
  [105] = {.index = 188, .length = 3},
  [106] = {.index = 191, .length = 2},
  [107] = {.index = 193, .length = 3},
  [108] = {.index = 196, .length = 2},
  [109] = {.index = 198, .length = 2},
  [110] = {.index = 200, .length = 4},
  [111] = {.index = 198, .length = 2},
  [112] = {.index = 204, .length = 4},
  [113] = {.index = 208, .length = 4},
  [114] = {.index = 212, .length = 5},
  [115] = {.index = 217, .length = 3},
  [116] = {.index = 136, .length = 2},
  [117] = {.index = 220, .length = 1},
  [118] = {.index = 220, .length = 1},
  [119] = {.index = 221, .length = 2},
  [120] = {.index = 223, .length = 3},
  [121] = {.index = 226, .length = 2},
  [122] = {.index = 228, .length = 3},
  [123] = {.index = 231, .length = 2},
  [124] = {.index = 233, .length = 3},
  [125] = {.index = 236, .length = 2},
  [126] = {.index = 238, .length = 2},
  [127] = {.index = 240, .length = 5},
  [128] = {.index = 245, .length = 1},
  [129] = {.index = 246, .length = 1},
  [130] = {.index = 247, .length = 4},
  [131] = {.index = 251, .length = 2},
  [132] = {.index = 253, .length = 2},
  [133] = {.index = 255, .length = 2},
  [134] = {.index = 257, .length = 2},
  [135] = {.index = 259, .length = 1},
  [136] = {.index = 260, .length = 2},
  [137] = {.index = 262, .length = 4},
  [138] = {.index = 266, .length = 4},
  [139] = {.index = 266, .length = 4},
  [140] = {.index = 270, .length = 4},
  [141] = {.index = 270, .length = 4},
  [142] = {.index = 274, .length = 4},
  [143] = {.index = 274, .length = 4},
  [144] = {.index = 278, .length = 2},
  [145] = {.index = 280, .length = 3},
  [146] = {.index = 283, .length = 2},
  [147] = {.index = 285, .length = 2},
  [148] = {.index = 287, .length = 3},
  [149] = {.index = 290, .length = 4},
  [150] = {.index = 294, .length = 4},
  [151] = {.index = 298, .length = 4},
  [152] = {.index = 302, .length = 4},
  [153] = {.index = 306, .length = 5},
  [154] = {.index = 311, .length = 2},
  [155] = {.index = 313, .length = 3},
  [156] = {.index = 316, .length = 2},
  [157] = {.index = 316, .length = 2},
  [158] = {.index = 318, .length = 3},
  [159] = {.index = 321, .length = 2},
  [160] = {.index = 323, .length = 2},
  [161] = {.index = 325, .length = 3},
  [162] = {.index = 328, .length = 4},
  [163] = {.index = 332, .length = 3},
  [164] = {.index = 335, .length = 3},
  [165] = {.index = 338, .length = 2},
  [166] = {.index = 340, .length = 3},
  [167] = {.index = 343, .length = 5},
  [168] = {.index = 348, .length = 3},
  [169] = {.index = 348, .length = 3},
  [170] = {.index = 351, .length = 3},
  [171] = {.index = 354, .length = 2},
  [172] = {.index = 356, .length = 4},
  [173] = {.index = 131, .length = 2},
  [174] = {.index = 360, .length = 1},
  [175] = {.index = 361, .length = 3},
  [176] = {.index = 364, .length = 2},
  [177] = {.index = 366, .length = 2},
  [178] = {.index = 368, .length = 1},
  [179] = {.index = 369, .length = 4},
  [180] = {.index = 373, .length = 4},
  [181] = {.index = 377, .length = 4},
  [182] = {.index = 381, .length = 3},
  [183] = {.index = 384, .length = 2},
  [184] = {.index = 386, .length = 2},
  [185] = {.index = 388, .length = 3},
  [186] = {.index = 391, .length = 3},
  [187] = {.index = 394, .length = 5},
  [188] = {.index = 399, .length = 3},
  [189] = {.index = 402, .length = 2},
  [190] = {.index = 404, .length = 2},
  [191] = {.index = 406, .length = 2},
  [192] = {.index = 408, .length = 1},
  [193] = {.index = 409, .length = 4},
  [194] = {.index = 413, .length = 3},
  [195] = {.index = 416, .length = 4},
  [196] = {.index = 420, .length = 5},
  [197] = {.index = 425, .length = 1},
  [198] = {.index = 426, .length = 2},
  [199] = {.index = 428, .length = 4},
  [200] = {.index = 432, .length = 4},
  [201] = {.index = 436, .length = 2},
  [202] = {.index = 438, .length = 4},
  [203] = {.index = 442, .length = 4},
  [204] = {.index = 446, .length = 2},
  [205] = {.index = 448, .length = 2},
  [206] = {.index = 450, .length = 1},
  [207] = {.index = 451, .length = 1},
  [208] = {.index = 452, .length = 4},
  [209] = {.index = 456, .length = 4},
  [210] = {.index = 460, .length = 4},
  [211] = {.index = 464, .length = 2},
  [212] = {.index = 466, .length = 3},
  [213] = {.index = 469, .length = 3},
  [214] = {.index = 472, .length = 2},
  [216] = {.index = 474, .length = 4},
  [217] = {.index = 478, .length = 5},
  [218] = {.index = 483, .length = 5},
  [219] = {.index = 488, .length = 5},
  [220] = {.index = 493, .length = 3},
  [221] = {.index = 496, .length = 3},
  [222] = {.index = 499, .length = 3},
  [223] = {.index = 496, .length = 3},
  [224] = {.index = 502, .length = 2},
  [225] = {.index = 504, .length = 4},
  [226] = {.index = 508, .length = 4},
  [227] = {.index = 512, .length = 2},
  [228] = {.index = 514, .length = 2},
  [229] = {.index = 516, .length = 4},
  [230] = {.index = 520, .length = 3},
  [231] = {.index = 523, .length = 2},
  [232] = {.index = 525, .length = 3},
  [233] = {.index = 528, .length = 2},
  [234] = {.index = 530, .length = 1},
  [235] = {.index = 531, .length = 5},
  [236] = {.index = 536, .length = 5},
  [237] = {.index = 541, .length = 4},
  [238] = {.index = 545, .length = 4},
  [239] = {.index = 549, .length = 3},
  [240] = {.index = 549, .length = 3},
  [241] = {.index = 552, .length = 2},
  [242] = {.index = 554, .length = 3},
  [243] = {.index = 557, .length = 2},
  [244] = {.index = 559, .length = 3},
  [245] = {.index = 562, .length = 2},
  [246] = {.index = 564, .length = 2},
  [247] = {.index = 566, .length = 5},
  [248] = {.index = 571, .length = 5},
  [249] = {.index = 576, .length = 4},
  [250] = {.index = 576, .length = 4},
  [251] = {.index = 580, .length = 4},
  [252] = {.index = 584, .length = 4},
  [253] = {.index = 588, .length = 3},
  [254] = {.index = 591, .length = 2},
  [255] = {.index = 593, .length = 2},
  [256] = {.index = 595, .length = 3},
  [257] = {.index = 598, .length = 5},
  [258] = {.index = 603, .length = 4},
  [259] = {.index = 607, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_pattern, 0},
  [9] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [11] =
    {field_body, 1},
  [12] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [14] =
    {field_constructor, 1},
  [15] =
    {field_argument, 0},
    {field_operator, 1},
  [17] =
    {field_arguments, 1},
    {field_function, 0},
  [19] =
    {field_parameters, 0},
    {field_return_type, 1},
  [21] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [23] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [25] =
    {field_declaration, 2},
  [26] =
    {field_left, 0},
    {field_right, 2},
  [28] =
    {field_body, 2},
    {field_label, 0},
  [30] =
    {field_body, 2},
    {field_parameter, 0},
  [32] =
    {field_body, 1},
    {field_name, 0},
  [34] =
    {field_source, 1},
  [35] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [37] =
    {field_name, 0},
    {field_type, 1},
  [39] =
    {field_kind, 0},
  [40] =
    {field_condition, 1},
    {field_consequence, 2},
  [42] =
    {field_body, 2},
    {field_value, 1},
  [44] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [50] =
    {field_pattern, 1},
  [51] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [54] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [57] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [59] =
    {field_body, 2},
    {field_condition, 1},
  [61] =
    {field_body, 1},
    {field_handler, 2},
  [63] =
    {field_body, 1},
    {field_finalizer, 2},
  [65] =
    {field_body, 2},
    {field_object, 1},
  [67] =
    {field_label, 1},
  [68] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [71] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [73] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [75] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [77] =
    {field_name, 0},
    {field_type_arguments, 1},
  [79] =
    {field_name, 0},
    {field_value, 1},
  [81] =
    {field_constraint, 1},
    {field_name, 0},
  [83] =
    {field_body, 2},
    {field_name, 1},
  [85] =
    {field_value, 1},
  [86] =
    {field_body, 2},
  [87] =
    {field_body, 2},
    {field_type_parameters, 1},
  [89] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [93] =
    {field_arguments, 2},
    {field_constructor, 1},
  [95] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [97] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [100] =
    {field_object, 0},
    {field_property, 2},
  [102] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [105] =
    {field_arguments, 2},
    {field_function, 0},
  [107] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [111] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [114] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [116] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [118] =
    {field_source, 2, .inherited = true},
  [119] =
    {field_value, 2},
  [120] =
    {field_name, 1},
  [121] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [123] =
    {field_key, 0},
    {field_value, 2},
  [125] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [130] =
    {field_source, 2},
  [131] =
    {field_name, 0},
    {field_type, 2},
  [133] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [136] =
    {field_body, 3},
    {field_name, 2},
  [138] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [141] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [147] =
    {field_type, 2},
  [148] =
    {field_pattern, 2},
  [149] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [152] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [155] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [159] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [161] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [164] =
    {field_parameters, 1},
  [165] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [169] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [173] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [177] =
    {field_module, 0},
    {field_name, 2},
  [179] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [182] =
    {field_parameters, 0},
    {field_return_type, 2},
  [184] =
    {field_flags, 3},
    {field_pattern, 1},
  [186] =
    {field_body, 3},
    {field_name, 1},
  [188] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [191] =
    {field_type_arguments, 2},
    {field_value, 1},
  [193] =
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1},
    {field_value, 2, .inherited = true},
  [196] =
    {field_body, 3},
    {field_type_parameters, 1},
  [198] =
    {field_body, 3},
    {field_parameter, 1},
  [200] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [204] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [208] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [212] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [217] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [220] =
    {field_type, 1},
  [221] =
    {field_index, 2},
    {field_object, 0},
  [223] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [226] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [228] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [231] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [233] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [236] =
    {field_alias, 2},
    {field_name, 0},
  [238] =
    {field_name, 1},
    {field_value, 3},
  [240] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [245] =
    {field_source, 3, .inherited = true},
  [246] =
    {field_pattern, 3},
  [247] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [251] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [253] =
    {field_body, 1},
    {field_condition, 3},
  [255] =
    {field_parameters, 1},
    {field_type, 2},
  [257] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [259] =
    {field_name, 2},
  [260] =
    {field_name, 1},
    {field_type, 2},
  [262] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [266] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [270] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [274] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [278] =
    {field_parameters, 1},
    {field_type, 3},
  [280] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [283] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [285] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [287] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [290] =
    {field_type_arguments, 2},
    {field_type_arguments, 3, .inherited = true},
    {field_value, 1},
    {field_value, 3, .inherited = true},
  [294] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [298] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [302] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [306] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [311] =
    {field_body, 4},
    {field_name, 2},
  [313] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [316] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [318] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [321] =
    {field_index, 3},
    {field_object, 0},
  [323] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [325] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [328] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [332] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [335] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [338] =
    {field_alias, 3},
    {field_name, 1},
  [340] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [343] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [348] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [351] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [354] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [356] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [360] =
    {field_type, 3},
  [361] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [364] =
    {field_name, 2},
    {field_type, 3},
  [366] =
    {field_name, 1},
    {field_type, 3},
  [368] =
    {field_name, 3},
  [369] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [373] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [377] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [381] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [384] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [386] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [388] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [391] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [394] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [399] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [402] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [404] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [406] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [408] =
    {field_name, 2, .inherited = true},
  [409] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [413] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [416] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [420] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [425] =
    {field_source, 4},
  [426] =
    {field_body, 3},
    {field_value, 1},
  [428] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [432] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [436] =
    {field_body, 4},
    {field_parameter, 2},
  [438] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [442] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [446] =
    {field_name, 2},
    {field_type, 4},
  [448] =
    {field_name, 3},
    {field_type, 4},
  [450] =
    {field_type, 4},
  [451] =
    {field_name, 4},
  [452] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [456] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [460] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [464] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [466] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [469] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [472] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [474] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [478] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [483] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [488] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [493] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [496] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [499] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [502] =
    {field_sign, 0},
    {field_type, 5},
  [504] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [508] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [512] =
    {field_name, 3},
    {field_type, 5},
  [514] =
    {field_name, 4},
    {field_type, 5},
  [516] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [520] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [523] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [525] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [528] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [530] =
    {field_name, 5},
  [531] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [536] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [541] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [545] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [549] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [552] =
    {field_name, 4},
    {field_type, 6},
  [554] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [557] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [559] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [562] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [564] =
    {field_name, 5},
    {field_type, 6},
  [566] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [571] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [576] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [580] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [584] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [588] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [591] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [593] =
    {field_name, 5},
    {field_type, 7},
  [595] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [598] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [603] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [607] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [13] = {
    [0] = alias_sym_type_identifier,
  },
  [14] = {
    [0] = alias_sym_this_type,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
  },
  [27] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [29] = {
    [1] = sym_identifier,
  },
  [45] = {
    [1] = alias_sym_statement_identifier,
  },
  [50] = {
    [0] = alias_sym_type_identifier,
  },
  [51] = {
    [0] = alias_sym_type_identifier,
  },
  [52] = {
    [0] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = alias_sym_type_identifier,
  },
  [55] = {
    [1] = alias_sym_type_identifier,
  },
  [66] = {
    [2] = alias_sym_property_identifier,
  },
  [78] = {
    [1] = alias_sym_namespace_export,
  },
  [79] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [83] = {
    [1] = alias_sym_import_specifier,
  },
  [100] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [0] = alias_sym_type_identifier,
  },
  [104] = {
    [1] = alias_sym_type_identifier,
  },
  [105] = {
    [1] = alias_sym_type_identifier,
  },
  [109] = {
    [1] = sym_identifier,
  },
  [116] = {
    [2] = alias_sym_type_identifier,
  },
  [117] = {
    [1] = alias_sym_type_identifier,
  },
  [122] = {
    [2] = alias_sym_type_identifier,
  },
  [126] = {
    [1] = alias_sym_type_identifier,
  },
  [138] = {
    [2] = alias_sym_property_identifier,
  },
  [140] = {
    [2] = alias_sym_property_identifier,
  },
  [142] = {
    [2] = alias_sym_property_identifier,
  },
  [148] = {
    [1] = alias_sym_type_identifier,
  },
  [154] = {
    [2] = alias_sym_type_identifier,
  },
  [155] = {
    [2] = alias_sym_type_identifier,
  },
  [156] = {
    [1] = alias_sym_type_identifier,
  },
  [161] = {
    [2] = alias_sym_type_identifier,
  },
  [162] = {
    [2] = alias_sym_type_identifier,
  },
  [164] = {
    [3] = alias_sym_type_identifier,
  },
  [166] = {
    [1] = alias_sym_type_identifier,
  },
  [168] = {
    [1] = sym_identifier,
  },
  [173] = {
    [0] = alias_sym_type_identifier,
  },
  [188] = {
    [2] = alias_sym_type_identifier,
  },
  [193] = {
    [2] = alias_sym_type_identifier,
  },
  [194] = {
    [3] = alias_sym_type_identifier,
  },
  [195] = {
    [3] = alias_sym_type_identifier,
  },
  [215] = {
    [3] = alias_sym_property_identifier,
  },
  [216] = {
    [3] = alias_sym_type_identifier,
  },
  [221] = {
    [1] = sym_identifier,
  },
  [222] = {
    [0] = alias_sym_type_identifier,
  },
  [239] = {
    [2] = sym_identifier,
  },
  [249] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_namespace_import_export, 2,
    sym_namespace_import_export,
    alias_sym_namespace_export,
  0,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_regex_pattern_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(200);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(69)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(201);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (sym_regex_pattern_character_set_1(lookahead)) ADVANCE(187);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(2)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(201);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(201);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(20);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(83);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(20);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(83);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(202);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(201);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(8)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          lookahead != '^') ADVANCE(201);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(10)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(10)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(19);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(83);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(11)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead == '\\') ADVANCE(32);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(170);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(33);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == '`') ADVANCE(184);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      END_STATE();
    case 14:
      if (lookahead == '$') ADVANCE(33);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '`') ADVANCE(184);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '\\') ADVANCE(32);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(176);
      if (lookahead != 0) ADVANCE(177);
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '?') ADVANCE(159);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(120);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(16);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == ':') ADVANCE(208);
      END_STATE();
    case 24:
      if (lookahead == ':') ADVANCE(209);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 26:
      if (lookahead == '?') ADVANCE(23);
      END_STATE();
    case 27:
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(202);
      END_STATE();
    case 28:
      if (lookahead == '\\') ADVANCE(67);
      if (lookahead == ']') ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(36);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(37);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(185);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 38:
      if (lookahead == '}') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 44:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(193);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(194);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(196);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(201);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(202);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(195);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(179);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 67:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 68:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 69:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(200);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(69)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(201);
      END_STATE();
    case 70:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(102);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(207);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(70)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(201);
      END_STATE();
    case 71:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(71)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(201);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(151);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(210);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(130);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(129);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(126);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(113);
      if (lookahead == '>') ADVANCE(128);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(122);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(121);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '|') ADVANCE(124);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(123);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(106);
      if (lookahead == '?') ADVANCE(23);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(169);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(167);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(175);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(173);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(31);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(201);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(180);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (sym_regex_pattern_character_set_1(lookahead)) ADVANCE(187);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(31);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(189);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(201);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == '0') ADVANCE(196);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(45);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(53);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(190);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(190);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == '_') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '{') ADVANCE(185);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(31);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(201);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(104);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '?') ADVANCE(159);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(53);
      if (lookahead == 'f') ADVANCE(54);
      if (lookahead == 'v') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 't') ADVANCE(60);
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'w') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      if (lookahead == 'y') ADVANCE(67);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(71);
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(76);
      if (lookahead == 'y') ADVANCE(77);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(81);
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(85);
      if (lookahead == 'c') ADVANCE(86);
      if (lookahead == 'f') ADVANCE(87);
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(89);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(90);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(91);
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(99);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(100);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(101);
      if (lookahead == 's') ADVANCE(102);
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(104);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(106);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(107);
      END_STATE();
    case 51:
      if (lookahead == 'v') ADVANCE(108);
      if (lookahead == 'w') ADVANCE(109);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(110);
      if (lookahead == 'm') ADVANCE(111);
      END_STATE();
    case 53:
      if (lookahead == 'j') ADVANCE(112);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(114);
      if (lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 57:
      if (lookahead == 'b') ADVANCE(116);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(117);
      if (lookahead == 'q') ADVANCE(118);
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(121);
      if (lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 63:
      if (lookahead == 'm') ADVANCE(125);
      END_STATE();
    case 64:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(127);
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 66:
      if (lookahead == 'u') ADVANCE(129);
      if (lookahead == 'y') ADVANCE(130);
      END_STATE();
    case 67:
      if (lookahead == 'p') ADVANCE(131);
      END_STATE();
    case 68:
      if (lookahead == 'd') ADVANCE(132);
      if (lookahead == 'k') ADVANCE(133);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(141);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(142);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(144);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 82:
      if (lookahead == 'c') ADVANCE(146);
      END_STATE();
    case 83:
      if (lookahead == 's') ADVANCE(147);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(148);
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 85:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 90:
      if (lookahead == 'm') ADVANCE(155);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 93:
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(159);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(160);
      END_STATE();
    case 97:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 99:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(163);
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 106:
      if (lookahead == 'u') ADVANCE(169);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 111:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 114:
      if (lookahead == 'v') ADVANCE(176);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 116:
      if (lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 117:
      if (lookahead == 'd') ADVANCE(179);
      END_STATE();
    case 118:
      if (lookahead == 'u') ADVANCE(180);
      END_STATE();
    case 119:
      if (lookahead == 'u') ADVANCE(181);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(183);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 125:
      if (lookahead == 'b') ADVANCE(186);
      END_STATE();
    case 126:
      if (lookahead == 'g') ADVANCE(187);
      END_STATE();
    case 127:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 128:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(190);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 133:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 135:
      if (lookahead == 'd') ADVANCE(194);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(195);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(196);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 139:
      if (lookahead == 'r') ADVANCE(198);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 141:
      if (lookahead == 'c') ADVANCE(200);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 144:
      if (lookahead == 'k') ADVANCE(203);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 146:
      if (lookahead == 'h') ADVANCE(204);
      END_STATE();
    case 147:
      if (lookahead == 's') ADVANCE(205);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 149:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 150:
      if (lookahead == 'g') ADVANCE(208);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(209);
      END_STATE();
    case 152:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 157:
      if (lookahead == 'n') ADVANCE(213);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 168:
      if (lookahead == 'f') ADVANCE(223);
      END_STATE();
    case 169:
      if (lookahead == 'l') ADVANCE(224);
      END_STATE();
    case 170:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 174:
      if (lookahead == 'c') ADVANCE(228);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 179:
      if (lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(236);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 185:
      if (lookahead == 'c') ADVANCE(239);
      END_STATE();
    case 186:
      if (lookahead == 'o') ADVANCE(240);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 189:
      if (lookahead == 'w') ADVANCE(242);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 192:
      if (lookahead == 'f') ADVANCE(244);
      END_STATE();
    case 193:
      if (lookahead == 'o') ADVANCE(245);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 197:
      if (lookahead == 'd') ADVANCE(247);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(248);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(249);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 202:
      if (lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 207:
      if (lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 208:
      if (lookahead == 'g') ADVANCE(252);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 210:
      if (lookahead == 'l') ADVANCE(254);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 213:
      if (lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 215:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 217:
      if (lookahead == 'l') ADVANCE(260);
      END_STATE();
    case 218:
      if (lookahead == 'm') ADVANCE(261);
      END_STATE();
    case 219:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 221:
      if (lookahead == 'n') ADVANCE(263);
      END_STATE();
    case 222:
      if (lookahead == 'f') ADVANCE(264);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 224:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 225:
      if (lookahead == 'p') ADVANCE(266);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 227:
      if (lookahead == 'r') ADVANCE(267);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(269);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(271);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(272);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(273);
      END_STATE();
    case 234:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 235:
      if (lookahead == 'n') ADVANCE(275);
      END_STATE();
    case 236:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 237:
      if (lookahead == 'g') ADVANCE(277);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 239:
      if (lookahead == 'h') ADVANCE(278);
      END_STATE();
    case 240:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 243:
      if (lookahead == 'f') ADVANCE(281);
      END_STATE();
    case 244:
      if (lookahead == 'i') ADVANCE(282);
      END_STATE();
    case 245:
      if (lookahead == 'w') ADVANCE(283);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 248:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 249:
      if (lookahead == 's') ADVANCE(285);
      END_STATE();
    case 250:
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 251:
      if (lookahead == 'u') ADVANCE(287);
      END_STATE();
    case 252:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 253:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 254:
      if (lookahead == 't') ADVANCE(290);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 257:
      if (lookahead == 's') ADVANCE(291);
      END_STATE();
    case 258:
      if (lookahead == 'y') ADVANCE(292);
      END_STATE();
    case 259:
      if (lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 263:
      if (lookahead == 'c') ADVANCE(295);
      END_STATE();
    case 264:
      if (lookahead == 'a') ADVANCE(296);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 266:
      if (lookahead == 'a') ADVANCE(297);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 269:
      if (lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 273:
      if (lookahead == 'l') ADVANCE(301);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 282:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 283:
      if (lookahead == 'n') ADVANCE(304);
      END_STATE();
    case 284:
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(306);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(307);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 293:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 294:
      if (lookahead == 'n') ADVANCE(309);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 296:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 297:
      if (lookahead == 'c') ADVANCE(312);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 300:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 301:
      if (lookahead == 'y') ADVANCE(315);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(317);
      END_STATE();
    case 310:
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 311:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 312:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 314:
      if (lookahead == 'd') ADVANCE(321);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 316:
      if (lookahead == 'd') ADVANCE(322);
      END_STATE();
    case 317:
      if (lookahead == 's') ADVANCE(323);
      END_STATE();
    case 318:
      if (lookahead == 'f') ADVANCE(324);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 71},
  [2] = {.lex_state = 2, .external_lex_state = 2},
  [3] = {.lex_state = 2, .external_lex_state = 2},
  [4] = {.lex_state = 71},
  [5] = {.lex_state = 71},
  [6] = {.lex_state = 71},
  [7] = {.lex_state = 71},
  [8] = {.lex_state = 71},
  [9] = {.lex_state = 71},
  [10] = {.lex_state = 71},
  [11] = {.lex_state = 71},
  [12] = {.lex_state = 71},
  [13] = {.lex_state = 71},
  [14] = {.lex_state = 71},
  [15] = {.lex_state = 71},
  [16] = {.lex_state = 71},
  [17] = {.lex_state = 71},
  [18] = {.lex_state = 71},
  [19] = {.lex_state = 71},
  [20] = {.lex_state = 71},
  [21] = {.lex_state = 71},
  [22] = {.lex_state = 71},
  [23] = {.lex_state = 71},
  [24] = {.lex_state = 71},
  [25] = {.lex_state = 71},
  [26] = {.lex_state = 71},
  [27] = {.lex_state = 71},
  [28] = {.lex_state = 71},
  [29] = {.lex_state = 71},
  [30] = {.lex_state = 71},
  [31] = {.lex_state = 71},
  [32] = {.lex_state = 71},
  [33] = {.lex_state = 71},
  [34] = {.lex_state = 71},
  [35] = {.lex_state = 71},
  [36] = {.lex_state = 71},
  [37] = {.lex_state = 71},
  [38] = {.lex_state = 71},
  [39] = {.lex_state = 71},
  [40] = {.lex_state = 71},
  [41] = {.lex_state = 71},
  [42] = {.lex_state = 71},
  [43] = {.lex_state = 71},
  [44] = {.lex_state = 71},
  [45] = {.lex_state = 71},
  [46] = {.lex_state = 71},
  [47] = {.lex_state = 71},
  [48] = {.lex_state = 7},
  [49] = {.lex_state = 3, .external_lex_state = 2},
  [50] = {.lex_state = 3, .external_lex_state = 2},
  [51] = {.lex_state = 7},
  [52] = {.lex_state = 7},
  [53] = {.lex_state = 7},
  [54] = {.lex_state = 7},
  [55] = {.lex_state = 7},
  [56] = {.lex_state = 3, .external_lex_state = 2},
  [57] = {.lex_state = 7},
  [58] = {.lex_state = 7},
  [59] = {.lex_state = 3, .external_lex_state = 2},
  [60] = {.lex_state = 3, .external_lex_state = 2},
  [61] = {.lex_state = 3, .external_lex_state = 2},
  [62] = {.lex_state = 3, .external_lex_state = 2},
  [63] = {.lex_state = 7},
  [64] = {.lex_state = 3, .external_lex_state = 2},
  [65] = {.lex_state = 7},
  [66] = {.lex_state = 7},
  [67] = {.lex_state = 7},
  [68] = {.lex_state = 7},
  [69] = {.lex_state = 7},
  [70] = {.lex_state = 7},
  [71] = {.lex_state = 7},
  [72] = {.lex_state = 7},
  [73] = {.lex_state = 7},
  [74] = {.lex_state = 7},
  [75] = {.lex_state = 7},
  [76] = {.lex_state = 7},
  [77] = {.lex_state = 7},
  [78] = {.lex_state = 7},
  [79] = {.lex_state = 7},
  [80] = {.lex_state = 7},
  [81] = {.lex_state = 7},
  [82] = {.lex_state = 7},
  [83] = {.lex_state = 7},
  [84] = {.lex_state = 7},
  [85] = {.lex_state = 7},
  [86] = {.lex_state = 70, .external_lex_state = 2},
  [87] = {.lex_state = 70, .external_lex_state = 3},
  [88] = {.lex_state = 70, .external_lex_state = 3},
  [89] = {.lex_state = 70, .external_lex_state = 2},
  [90] = {.lex_state = 70, .external_lex_state = 3},
  [91] = {.lex_state = 70, .external_lex_state = 2},
  [92] = {.lex_state = 70, .external_lex_state = 2},
  [93] = {.lex_state = 70, .external_lex_state = 2},
  [94] = {.lex_state = 2, .external_lex_state = 2},
  [95] = {.lex_state = 71},
  [96] = {.lex_state = 71},
  [97] = {.lex_state = 71},
  [98] = {.lex_state = 71},
  [99] = {.lex_state = 71},
  [100] = {.lex_state = 71},
  [101] = {.lex_state = 2, .external_lex_state = 3},
  [102] = {.lex_state = 2, .external_lex_state = 3},
  [103] = {.lex_state = 2, .external_lex_state = 2},
  [104] = {.lex_state = 2, .external_lex_state = 2},
  [105] = {.lex_state = 2, .external_lex_state = 2},
  [106] = {.lex_state = 2, .external_lex_state = 2},
  [107] = {.lex_state = 2, .external_lex_state = 2},
  [108] = {.lex_state = 2, .external_lex_state = 2},
  [109] = {.lex_state = 2, .external_lex_state = 3},
  [110] = {.lex_state = 2, .external_lex_state = 2},
  [111] = {.lex_state = 2, .external_lex_state = 2},
  [112] = {.lex_state = 2, .external_lex_state = 2},
  [113] = {.lex_state = 70, .external_lex_state = 3},
  [114] = {.lex_state = 70, .external_lex_state = 3},
  [115] = {.lex_state = 70, .external_lex_state = 3},
  [116] = {.lex_state = 71},
  [117] = {.lex_state = 70, .external_lex_state = 3},
  [118] = {.lex_state = 70, .external_lex_state = 3},
  [119] = {.lex_state = 70, .external_lex_state = 3},
  [120] = {.lex_state = 70, .external_lex_state = 3},
  [121] = {.lex_state = 70, .external_lex_state = 3},
  [122] = {.lex_state = 70, .external_lex_state = 3},
  [123] = {.lex_state = 70, .external_lex_state = 3},
  [124] = {.lex_state = 70, .external_lex_state = 3},
  [125] = {.lex_state = 70, .external_lex_state = 3},
  [126] = {.lex_state = 70, .external_lex_state = 3},
  [127] = {.lex_state = 70, .external_lex_state = 3},
  [128] = {.lex_state = 70, .external_lex_state = 3},
  [129] = {.lex_state = 70, .external_lex_state = 3},
  [130] = {.lex_state = 71},
  [131] = {.lex_state = 70, .external_lex_state = 3},
  [132] = {.lex_state = 70, .external_lex_state = 3},
  [133] = {.lex_state = 70, .external_lex_state = 3},
  [134] = {.lex_state = 70, .external_lex_state = 3},
  [135] = {.lex_state = 70, .external_lex_state = 3},
  [136] = {.lex_state = 70, .external_lex_state = 3},
  [137] = {.lex_state = 70, .external_lex_state = 3},
  [138] = {.lex_state = 70, .external_lex_state = 3},
  [139] = {.lex_state = 70, .external_lex_state = 3},
  [140] = {.lex_state = 70, .external_lex_state = 3},
  [141] = {.lex_state = 70, .external_lex_state = 3},
  [142] = {.lex_state = 71},
  [143] = {.lex_state = 71},
  [144] = {.lex_state = 71},
  [145] = {.lex_state = 71},
  [146] = {.lex_state = 71},
  [147] = {.lex_state = 71},
  [148] = {.lex_state = 71},
  [149] = {.lex_state = 71},
  [150] = {.lex_state = 71},
  [151] = {.lex_state = 71},
  [152] = {.lex_state = 71},
  [153] = {.lex_state = 71},
  [154] = {.lex_state = 71},
  [155] = {.lex_state = 71},
  [156] = {.lex_state = 71},
  [157] = {.lex_state = 71},
  [158] = {.lex_state = 71},
  [159] = {.lex_state = 71},
  [160] = {.lex_state = 71},
  [161] = {.lex_state = 71},
  [162] = {.lex_state = 71},
  [163] = {.lex_state = 71},
  [164] = {.lex_state = 71, .external_lex_state = 4},
  [165] = {.lex_state = 3, .external_lex_state = 2},
  [166] = {.lex_state = 71},
  [167] = {.lex_state = 71},
  [168] = {.lex_state = 71},
  [169] = {.lex_state = 3, .external_lex_state = 2},
  [170] = {.lex_state = 71},
  [171] = {.lex_state = 71},
  [172] = {.lex_state = 71},
  [173] = {.lex_state = 71},
  [174] = {.lex_state = 3, .external_lex_state = 2},
  [175] = {.lex_state = 3, .external_lex_state = 2},
  [176] = {.lex_state = 71},
  [177] = {.lex_state = 71},
  [178] = {.lex_state = 71},
  [179] = {.lex_state = 71},
  [180] = {.lex_state = 71},
  [181] = {.lex_state = 71},
  [182] = {.lex_state = 71},
  [183] = {.lex_state = 71},
  [184] = {.lex_state = 71},
  [185] = {.lex_state = 71},
  [186] = {.lex_state = 71},
  [187] = {.lex_state = 71},
  [188] = {.lex_state = 71},
  [189] = {.lex_state = 71},
  [190] = {.lex_state = 3, .external_lex_state = 3},
  [191] = {.lex_state = 3, .external_lex_state = 3},
  [192] = {.lex_state = 3, .external_lex_state = 3},
  [193] = {.lex_state = 71},
  [194] = {.lex_state = 71},
  [195] = {.lex_state = 71},
  [196] = {.lex_state = 71},
  [197] = {.lex_state = 71},
  [198] = {.lex_state = 71},
  [199] = {.lex_state = 71},
  [200] = {.lex_state = 71},
  [201] = {.lex_state = 71},
  [202] = {.lex_state = 71},
  [203] = {.lex_state = 71},
  [204] = {.lex_state = 71},
  [205] = {.lex_state = 71, .external_lex_state = 4},
  [206] = {.lex_state = 71},
  [207] = {.lex_state = 71},
  [208] = {.lex_state = 71},
  [209] = {.lex_state = 71},
  [210] = {.lex_state = 71},
  [211] = {.lex_state = 71},
  [212] = {.lex_state = 71},
  [213] = {.lex_state = 71},
  [214] = {.lex_state = 71},
  [215] = {.lex_state = 71},
  [216] = {.lex_state = 71},
  [217] = {.lex_state = 71},
  [218] = {.lex_state = 71},
  [219] = {.lex_state = 71},
  [220] = {.lex_state = 71},
  [221] = {.lex_state = 71},
  [222] = {.lex_state = 2, .external_lex_state = 3},
  [223] = {.lex_state = 2, .external_lex_state = 3},
  [224] = {.lex_state = 2, .external_lex_state = 3},
  [225] = {.lex_state = 71},
  [226] = {.lex_state = 71},
  [227] = {.lex_state = 71},
  [228] = {.lex_state = 71},
  [229] = {.lex_state = 71},
  [230] = {.lex_state = 71},
  [231] = {.lex_state = 71},
  [232] = {.lex_state = 71},
  [233] = {.lex_state = 71},
  [234] = {.lex_state = 71},
  [235] = {.lex_state = 71},
  [236] = {.lex_state = 71},
  [237] = {.lex_state = 71},
  [238] = {.lex_state = 71},
  [239] = {.lex_state = 71},
  [240] = {.lex_state = 71},
  [241] = {.lex_state = 71},
  [242] = {.lex_state = 71},
  [243] = {.lex_state = 71},
  [244] = {.lex_state = 71},
  [245] = {.lex_state = 71},
  [246] = {.lex_state = 71},
  [247] = {.lex_state = 71},
  [248] = {.lex_state = 71},
  [249] = {.lex_state = 71},
  [250] = {.lex_state = 71},
  [251] = {.lex_state = 71},
  [252] = {.lex_state = 71},
  [253] = {.lex_state = 71},
  [254] = {.lex_state = 71},
  [255] = {.lex_state = 71},
  [256] = {.lex_state = 71},
  [257] = {.lex_state = 71},
  [258] = {.lex_state = 71},
  [259] = {.lex_state = 71},
  [260] = {.lex_state = 71},
  [261] = {.lex_state = 71},
  [262] = {.lex_state = 71},
  [263] = {.lex_state = 71},
  [264] = {.lex_state = 71},
  [265] = {.lex_state = 71},
  [266] = {.lex_state = 71},
  [267] = {.lex_state = 71},
  [268] = {.lex_state = 71},
  [269] = {.lex_state = 71},
  [270] = {.lex_state = 3, .external_lex_state = 3},
  [271] = {.lex_state = 71},
  [272] = {.lex_state = 3, .external_lex_state = 3},
  [273] = {.lex_state = 71},
  [274] = {.lex_state = 71},
  [275] = {.lex_state = 71},
  [276] = {.lex_state = 71},
  [277] = {.lex_state = 71},
  [278] = {.lex_state = 71},
  [279] = {.lex_state = 71},
  [280] = {.lex_state = 71},
  [281] = {.lex_state = 71},
  [282] = {.lex_state = 71},
  [283] = {.lex_state = 71},
  [284] = {.lex_state = 71},
  [285] = {.lex_state = 71},
  [286] = {.lex_state = 71},
  [287] = {.lex_state = 71},
  [288] = {.lex_state = 71},
  [289] = {.lex_state = 71},
  [290] = {.lex_state = 71},
  [291] = {.lex_state = 71},
  [292] = {.lex_state = 71},
  [293] = {.lex_state = 71},
  [294] = {.lex_state = 71},
  [295] = {.lex_state = 71},
  [296] = {.lex_state = 71},
  [297] = {.lex_state = 71},
  [298] = {.lex_state = 71},
  [299] = {.lex_state = 71},
  [300] = {.lex_state = 71},
  [301] = {.lex_state = 71},
  [302] = {.lex_state = 71},
  [303] = {.lex_state = 71},
  [304] = {.lex_state = 71},
  [305] = {.lex_state = 71},
  [306] = {.lex_state = 71},
  [307] = {.lex_state = 71},
  [308] = {.lex_state = 71},
  [309] = {.lex_state = 71},
  [310] = {.lex_state = 71},
  [311] = {.lex_state = 71},
  [312] = {.lex_state = 71},
  [313] = {.lex_state = 71},
  [314] = {.lex_state = 71},
  [315] = {.lex_state = 71},
  [316] = {.lex_state = 71},
  [317] = {.lex_state = 71},
  [318] = {.lex_state = 71},
  [319] = {.lex_state = 71},
  [320] = {.lex_state = 71},
  [321] = {.lex_state = 71},
  [322] = {.lex_state = 71},
  [323] = {.lex_state = 71},
  [324] = {.lex_state = 71},
  [325] = {.lex_state = 71},
  [326] = {.lex_state = 71},
  [327] = {.lex_state = 71},
  [328] = {.lex_state = 71},
  [329] = {.lex_state = 71},
  [330] = {.lex_state = 71},
  [331] = {.lex_state = 71},
  [332] = {.lex_state = 71},
  [333] = {.lex_state = 71},
  [334] = {.lex_state = 71},
  [335] = {.lex_state = 71},
  [336] = {.lex_state = 71},
  [337] = {.lex_state = 71},
  [338] = {.lex_state = 71},
  [339] = {.lex_state = 71},
  [340] = {.lex_state = 71},
  [341] = {.lex_state = 71},
  [342] = {.lex_state = 71},
  [343] = {.lex_state = 71},
  [344] = {.lex_state = 71},
  [345] = {.lex_state = 71},
  [346] = {.lex_state = 71},
  [347] = {.lex_state = 71},
  [348] = {.lex_state = 71},
  [349] = {.lex_state = 71},
  [350] = {.lex_state = 71},
  [351] = {.lex_state = 71},
  [352] = {.lex_state = 71},
  [353] = {.lex_state = 71},
  [354] = {.lex_state = 71},
  [355] = {.lex_state = 71},
  [356] = {.lex_state = 71},
  [357] = {.lex_state = 71},
  [358] = {.lex_state = 2, .external_lex_state = 3},
  [359] = {.lex_state = 71},
  [360] = {.lex_state = 71},
  [361] = {.lex_state = 71},
  [362] = {.lex_state = 71},
  [363] = {.lex_state = 71},
  [364] = {.lex_state = 71},
  [365] = {.lex_state = 71},
  [366] = {.lex_state = 71},
  [367] = {.lex_state = 71},
  [368] = {.lex_state = 71},
  [369] = {.lex_state = 71},
  [370] = {.lex_state = 71},
  [371] = {.lex_state = 71},
  [372] = {.lex_state = 71},
  [373] = {.lex_state = 71},
  [374] = {.lex_state = 71},
  [375] = {.lex_state = 71},
  [376] = {.lex_state = 71},
  [377] = {.lex_state = 71},
  [378] = {.lex_state = 71},
  [379] = {.lex_state = 71},
  [380] = {.lex_state = 71},
  [381] = {.lex_state = 71},
  [382] = {.lex_state = 71},
  [383] = {.lex_state = 71},
  [384] = {.lex_state = 71},
  [385] = {.lex_state = 71},
  [386] = {.lex_state = 71},
  [387] = {.lex_state = 71},
  [388] = {.lex_state = 71},
  [389] = {.lex_state = 71},
  [390] = {.lex_state = 71},
  [391] = {.lex_state = 71},
  [392] = {.lex_state = 71},
  [393] = {.lex_state = 71},
  [394] = {.lex_state = 71},
  [395] = {.lex_state = 71},
  [396] = {.lex_state = 71},
  [397] = {.lex_state = 71},
  [398] = {.lex_state = 71},
  [399] = {.lex_state = 71},
  [400] = {.lex_state = 71},
  [401] = {.lex_state = 71},
  [402] = {.lex_state = 71},
  [403] = {.lex_state = 71},
  [404] = {.lex_state = 71},
  [405] = {.lex_state = 71},
  [406] = {.lex_state = 71},
  [407] = {.lex_state = 71},
  [408] = {.lex_state = 71},
  [409] = {.lex_state = 71},
  [410] = {.lex_state = 71},
  [411] = {.lex_state = 71},
  [412] = {.lex_state = 71},
  [413] = {.lex_state = 71},
  [414] = {.lex_state = 71},
  [415] = {.lex_state = 71},
  [416] = {.lex_state = 71},
  [417] = {.lex_state = 71},
  [418] = {.lex_state = 71},
  [419] = {.lex_state = 71},
  [420] = {.lex_state = 71},
  [421] = {.lex_state = 71},
  [422] = {.lex_state = 71},
  [423] = {.lex_state = 71},
  [424] = {.lex_state = 71},
  [425] = {.lex_state = 71},
  [426] = {.lex_state = 71},
  [427] = {.lex_state = 71},
  [428] = {.lex_state = 71},
  [429] = {.lex_state = 71},
  [430] = {.lex_state = 71},
  [431] = {.lex_state = 71},
  [432] = {.lex_state = 71},
  [433] = {.lex_state = 71},
  [434] = {.lex_state = 71},
  [435] = {.lex_state = 2, .external_lex_state = 3},
  [436] = {.lex_state = 71},
  [437] = {.lex_state = 71},
  [438] = {.lex_state = 71},
  [439] = {.lex_state = 71},
  [440] = {.lex_state = 71},
  [441] = {.lex_state = 71},
  [442] = {.lex_state = 71},
  [443] = {.lex_state = 71},
  [444] = {.lex_state = 71},
  [445] = {.lex_state = 71},
  [446] = {.lex_state = 71},
  [447] = {.lex_state = 71},
  [448] = {.lex_state = 71},
  [449] = {.lex_state = 71},
  [450] = {.lex_state = 71},
  [451] = {.lex_state = 71},
  [452] = {.lex_state = 71},
  [453] = {.lex_state = 71},
  [454] = {.lex_state = 71},
  [455] = {.lex_state = 71},
  [456] = {.lex_state = 71},
  [457] = {.lex_state = 71},
  [458] = {.lex_state = 71},
  [459] = {.lex_state = 71},
  [460] = {.lex_state = 71},
  [461] = {.lex_state = 71},
  [462] = {.lex_state = 71},
  [463] = {.lex_state = 71},
  [464] = {.lex_state = 71},
  [465] = {.lex_state = 71},
  [466] = {.lex_state = 71},
  [467] = {.lex_state = 71},
  [468] = {.lex_state = 71},
  [469] = {.lex_state = 71},
  [470] = {.lex_state = 71},
  [471] = {.lex_state = 71},
  [472] = {.lex_state = 71},
  [473] = {.lex_state = 71},
  [474] = {.lex_state = 71},
  [475] = {.lex_state = 71},
  [476] = {.lex_state = 71},
  [477] = {.lex_state = 71},
  [478] = {.lex_state = 71},
  [479] = {.lex_state = 71},
  [480] = {.lex_state = 71},
  [481] = {.lex_state = 71},
  [482] = {.lex_state = 71},
  [483] = {.lex_state = 71},
  [484] = {.lex_state = 71},
  [485] = {.lex_state = 2, .external_lex_state = 3},
  [486] = {.lex_state = 71},
  [487] = {.lex_state = 71},
  [488] = {.lex_state = 71},
  [489] = {.lex_state = 71},
  [490] = {.lex_state = 71},
  [491] = {.lex_state = 71},
  [492] = {.lex_state = 71},
  [493] = {.lex_state = 71},
  [494] = {.lex_state = 71},
  [495] = {.lex_state = 71},
  [496] = {.lex_state = 71},
  [497] = {.lex_state = 71},
  [498] = {.lex_state = 71},
  [499] = {.lex_state = 71},
  [500] = {.lex_state = 71},
  [501] = {.lex_state = 71},
  [502] = {.lex_state = 71},
  [503] = {.lex_state = 71},
  [504] = {.lex_state = 71},
  [505] = {.lex_state = 71},
  [506] = {.lex_state = 71},
  [507] = {.lex_state = 71},
  [508] = {.lex_state = 71},
  [509] = {.lex_state = 71},
  [510] = {.lex_state = 71},
  [511] = {.lex_state = 71},
  [512] = {.lex_state = 71},
  [513] = {.lex_state = 71},
  [514] = {.lex_state = 71},
  [515] = {.lex_state = 71},
  [516] = {.lex_state = 71},
  [517] = {.lex_state = 71},
  [518] = {.lex_state = 71},
  [519] = {.lex_state = 71},
  [520] = {.lex_state = 71},
  [521] = {.lex_state = 71},
  [522] = {.lex_state = 71},
  [523] = {.lex_state = 71},
  [524] = {.lex_state = 71},
  [525] = {.lex_state = 71},
  [526] = {.lex_state = 71},
  [527] = {.lex_state = 2, .external_lex_state = 3},
  [528] = {.lex_state = 2, .external_lex_state = 3},
  [529] = {.lex_state = 2, .external_lex_state = 3},
  [530] = {.lex_state = 2, .external_lex_state = 3},
  [531] = {.lex_state = 2, .external_lex_state = 3},
  [532] = {.lex_state = 2, .external_lex_state = 3},
  [533] = {.lex_state = 2, .external_lex_state = 3},
  [534] = {.lex_state = 2, .external_lex_state = 3},
  [535] = {.lex_state = 2, .external_lex_state = 3},
  [536] = {.lex_state = 2, .external_lex_state = 3},
  [537] = {.lex_state = 2, .external_lex_state = 3},
  [538] = {.lex_state = 2, .external_lex_state = 3},
  [539] = {.lex_state = 2, .external_lex_state = 3},
  [540] = {.lex_state = 71},
  [541] = {.lex_state = 71},
  [542] = {.lex_state = 71},
  [543] = {.lex_state = 71},
  [544] = {.lex_state = 71},
  [545] = {.lex_state = 71},
  [546] = {.lex_state = 71},
  [547] = {.lex_state = 2, .external_lex_state = 3},
  [548] = {.lex_state = 2, .external_lex_state = 3},
  [549] = {.lex_state = 2, .external_lex_state = 3},
  [550] = {.lex_state = 2, .external_lex_state = 3},
  [551] = {.lex_state = 2, .external_lex_state = 3},
  [552] = {.lex_state = 2, .external_lex_state = 3},
  [553] = {.lex_state = 2, .external_lex_state = 2},
  [554] = {.lex_state = 2, .external_lex_state = 2},
  [555] = {.lex_state = 2, .external_lex_state = 2},
  [556] = {.lex_state = 2, .external_lex_state = 2},
  [557] = {.lex_state = 2, .external_lex_state = 2},
  [558] = {.lex_state = 2, .external_lex_state = 2},
  [559] = {.lex_state = 2, .external_lex_state = 3},
  [560] = {.lex_state = 2, .external_lex_state = 3},
  [561] = {.lex_state = 2, .external_lex_state = 3},
  [562] = {.lex_state = 2, .external_lex_state = 3},
  [563] = {.lex_state = 2, .external_lex_state = 3},
  [564] = {.lex_state = 2, .external_lex_state = 3},
  [565] = {.lex_state = 2, .external_lex_state = 3},
  [566] = {.lex_state = 71, .external_lex_state = 4},
  [567] = {.lex_state = 71},
  [568] = {.lex_state = 71, .external_lex_state = 4},
  [569] = {.lex_state = 3, .external_lex_state = 2},
  [570] = {.lex_state = 2, .external_lex_state = 2},
  [571] = {.lex_state = 3, .external_lex_state = 2},
  [572] = {.lex_state = 2, .external_lex_state = 2},
  [573] = {.lex_state = 2, .external_lex_state = 2},
  [574] = {.lex_state = 71},
  [575] = {.lex_state = 71, .external_lex_state = 4},
  [576] = {.lex_state = 2, .external_lex_state = 3},
  [577] = {.lex_state = 2, .external_lex_state = 3},
  [578] = {.lex_state = 71, .external_lex_state = 4},
  [579] = {.lex_state = 71, .external_lex_state = 4},
  [580] = {.lex_state = 71, .external_lex_state = 4},
  [581] = {.lex_state = 71},
  [582] = {.lex_state = 2, .external_lex_state = 2},
  [583] = {.lex_state = 2, .external_lex_state = 3},
  [584] = {.lex_state = 2, .external_lex_state = 3},
  [585] = {.lex_state = 2, .external_lex_state = 2},
  [586] = {.lex_state = 71, .external_lex_state = 4},
  [587] = {.lex_state = 2, .external_lex_state = 2},
  [588] = {.lex_state = 2, .external_lex_state = 3},
  [589] = {.lex_state = 71, .external_lex_state = 4},
  [590] = {.lex_state = 2, .external_lex_state = 2},
  [591] = {.lex_state = 71},
  [592] = {.lex_state = 71},
  [593] = {.lex_state = 2, .external_lex_state = 2},
  [594] = {.lex_state = 2, .external_lex_state = 2},
  [595] = {.lex_state = 2, .external_lex_state = 2},
  [596] = {.lex_state = 71},
  [597] = {.lex_state = 71, .external_lex_state = 4},
  [598] = {.lex_state = 71, .external_lex_state = 4},
  [599] = {.lex_state = 71, .external_lex_state = 4},
  [600] = {.lex_state = 71},
  [601] = {.lex_state = 71, .external_lex_state = 4},
  [602] = {.lex_state = 71, .external_lex_state = 4},
  [603] = {.lex_state = 71},
  [604] = {.lex_state = 71},
  [605] = {.lex_state = 71, .external_lex_state = 4},
  [606] = {.lex_state = 71, .external_lex_state = 4},
  [607] = {.lex_state = 71, .external_lex_state = 4},
  [608] = {.lex_state = 71, .external_lex_state = 4},
  [609] = {.lex_state = 71},
  [610] = {.lex_state = 71},
  [611] = {.lex_state = 2, .external_lex_state = 2},
  [612] = {.lex_state = 71, .external_lex_state = 4},
  [613] = {.lex_state = 71},
  [614] = {.lex_state = 71, .external_lex_state = 4},
  [615] = {.lex_state = 71},
  [616] = {.lex_state = 71, .external_lex_state = 4},
  [617] = {.lex_state = 71},
  [618] = {.lex_state = 71},
  [619] = {.lex_state = 71},
  [620] = {.lex_state = 71},
  [621] = {.lex_state = 71},
  [622] = {.lex_state = 71},
  [623] = {.lex_state = 71},
  [624] = {.lex_state = 71},
  [625] = {.lex_state = 71},
  [626] = {.lex_state = 71},
  [627] = {.lex_state = 71},
  [628] = {.lex_state = 71},
  [629] = {.lex_state = 71},
  [630] = {.lex_state = 71},
  [631] = {.lex_state = 71},
  [632] = {.lex_state = 71},
  [633] = {.lex_state = 71},
  [634] = {.lex_state = 71},
  [635] = {.lex_state = 71},
  [636] = {.lex_state = 71},
  [637] = {.lex_state = 71},
  [638] = {.lex_state = 71},
  [639] = {.lex_state = 71},
  [640] = {.lex_state = 71},
  [641] = {.lex_state = 71},
  [642] = {.lex_state = 71},
  [643] = {.lex_state = 71},
  [644] = {.lex_state = 71},
  [645] = {.lex_state = 71},
  [646] = {.lex_state = 71},
  [647] = {.lex_state = 71},
  [648] = {.lex_state = 71},
  [649] = {.lex_state = 71},
  [650] = {.lex_state = 71},
  [651] = {.lex_state = 71},
  [652] = {.lex_state = 71},
  [653] = {.lex_state = 71},
  [654] = {.lex_state = 71},
  [655] = {.lex_state = 71},
  [656] = {.lex_state = 71},
  [657] = {.lex_state = 71},
  [658] = {.lex_state = 71},
  [659] = {.lex_state = 71},
  [660] = {.lex_state = 71},
  [661] = {.lex_state = 71},
  [662] = {.lex_state = 71},
  [663] = {.lex_state = 71},
  [664] = {.lex_state = 71},
  [665] = {.lex_state = 71},
  [666] = {.lex_state = 71},
  [667] = {.lex_state = 71},
  [668] = {.lex_state = 71},
  [669] = {.lex_state = 71},
  [670] = {.lex_state = 71},
  [671] = {.lex_state = 71},
  [672] = {.lex_state = 71},
  [673] = {.lex_state = 71},
  [674] = {.lex_state = 71},
  [675] = {.lex_state = 71},
  [676] = {.lex_state = 71},
  [677] = {.lex_state = 71},
  [678] = {.lex_state = 71},
  [679] = {.lex_state = 71},
  [680] = {.lex_state = 71},
  [681] = {.lex_state = 71},
  [682] = {.lex_state = 71},
  [683] = {.lex_state = 71},
  [684] = {.lex_state = 71},
  [685] = {.lex_state = 71},
  [686] = {.lex_state = 71},
  [687] = {.lex_state = 71},
  [688] = {.lex_state = 71},
  [689] = {.lex_state = 71},
  [690] = {.lex_state = 71},
  [691] = {.lex_state = 71},
  [692] = {.lex_state = 71},
  [693] = {.lex_state = 71},
  [694] = {.lex_state = 71},
  [695] = {.lex_state = 71},
  [696] = {.lex_state = 71},
  [697] = {.lex_state = 71},
  [698] = {.lex_state = 71},
  [699] = {.lex_state = 71},
  [700] = {.lex_state = 71},
  [701] = {.lex_state = 71},
  [702] = {.lex_state = 71},
  [703] = {.lex_state = 71},
  [704] = {.lex_state = 71},
  [705] = {.lex_state = 71},
  [706] = {.lex_state = 71},
  [707] = {.lex_state = 71},
  [708] = {.lex_state = 71},
  [709] = {.lex_state = 71},
  [710] = {.lex_state = 71},
  [711] = {.lex_state = 71},
  [712] = {.lex_state = 71},
  [713] = {.lex_state = 71},
  [714] = {.lex_state = 71},
  [715] = {.lex_state = 71},
  [716] = {.lex_state = 71},
  [717] = {.lex_state = 71},
  [718] = {.lex_state = 71},
  [719] = {.lex_state = 71},
  [720] = {.lex_state = 71},
  [721] = {.lex_state = 71},
  [722] = {.lex_state = 71},
  [723] = {.lex_state = 71},
  [724] = {.lex_state = 71},
  [725] = {.lex_state = 71},
  [726] = {.lex_state = 71},
  [727] = {.lex_state = 71},
  [728] = {.lex_state = 71},
  [729] = {.lex_state = 71},
  [730] = {.lex_state = 71},
  [731] = {.lex_state = 71},
  [732] = {.lex_state = 71},
  [733] = {.lex_state = 71},
  [734] = {.lex_state = 71},
  [735] = {.lex_state = 71},
  [736] = {.lex_state = 71},
  [737] = {.lex_state = 71},
  [738] = {.lex_state = 71},
  [739] = {.lex_state = 71},
  [740] = {.lex_state = 71},
  [741] = {.lex_state = 71},
  [742] = {.lex_state = 71},
  [743] = {.lex_state = 71},
  [744] = {.lex_state = 71},
  [745] = {.lex_state = 71},
  [746] = {.lex_state = 71},
  [747] = {.lex_state = 71},
  [748] = {.lex_state = 71},
  [749] = {.lex_state = 71},
  [750] = {.lex_state = 71},
  [751] = {.lex_state = 71},
  [752] = {.lex_state = 71},
  [753] = {.lex_state = 71},
  [754] = {.lex_state = 71},
  [755] = {.lex_state = 71},
  [756] = {.lex_state = 71},
  [757] = {.lex_state = 71},
  [758] = {.lex_state = 71},
  [759] = {.lex_state = 71},
  [760] = {.lex_state = 71},
  [761] = {.lex_state = 9},
  [762] = {.lex_state = 9},
  [763] = {.lex_state = 9},
  [764] = {.lex_state = 9},
  [765] = {.lex_state = 9},
  [766] = {.lex_state = 9},
  [767] = {.lex_state = 9},
  [768] = {.lex_state = 9},
  [769] = {.lex_state = 9},
  [770] = {.lex_state = 9},
  [771] = {.lex_state = 9},
  [772] = {.lex_state = 9},
  [773] = {.lex_state = 9},
  [774] = {.lex_state = 9},
  [775] = {.lex_state = 9},
  [776] = {.lex_state = 71},
  [777] = {.lex_state = 71},
  [778] = {.lex_state = 71},
  [779] = {.lex_state = 71},
  [780] = {.lex_state = 71},
  [781] = {.lex_state = 71},
  [782] = {.lex_state = 71},
  [783] = {.lex_state = 71},
  [784] = {.lex_state = 71},
  [785] = {.lex_state = 71},
  [786] = {.lex_state = 9},
  [787] = {.lex_state = 71},
  [788] = {.lex_state = 71},
  [789] = {.lex_state = 71},
  [790] = {.lex_state = 8},
  [791] = {.lex_state = 8},
  [792] = {.lex_state = 8},
  [793] = {.lex_state = 2, .external_lex_state = 3},
  [794] = {.lex_state = 2, .external_lex_state = 3},
  [795] = {.lex_state = 2, .external_lex_state = 3},
  [796] = {.lex_state = 2, .external_lex_state = 3},
  [797] = {.lex_state = 2, .external_lex_state = 3},
  [798] = {.lex_state = 2, .external_lex_state = 3},
  [799] = {.lex_state = 9},
  [800] = {.lex_state = 9},
  [801] = {.lex_state = 9},
  [802] = {.lex_state = 71},
  [803] = {.lex_state = 11},
  [804] = {.lex_state = 11},
  [805] = {.lex_state = 2, .external_lex_state = 2},
  [806] = {.lex_state = 9},
  [807] = {.lex_state = 11},
  [808] = {.lex_state = 2, .external_lex_state = 2},
  [809] = {.lex_state = 11},
  [810] = {.lex_state = 9},
  [811] = {.lex_state = 11},
  [812] = {.lex_state = 11},
  [813] = {.lex_state = 9},
  [814] = {.lex_state = 9},
  [815] = {.lex_state = 11},
  [816] = {.lex_state = 9},
  [817] = {.lex_state = 9},
  [818] = {.lex_state = 2, .external_lex_state = 2},
  [819] = {.lex_state = 9},
  [820] = {.lex_state = 9},
  [821] = {.lex_state = 9},
  [822] = {.lex_state = 9},
  [823] = {.lex_state = 9},
  [824] = {.lex_state = 9},
  [825] = {.lex_state = 9},
  [826] = {.lex_state = 9},
  [827] = {.lex_state = 9},
  [828] = {.lex_state = 9},
  [829] = {.lex_state = 9},
  [830] = {.lex_state = 11},
  [831] = {.lex_state = 9},
  [832] = {.lex_state = 9},
  [833] = {.lex_state = 11},
  [834] = {.lex_state = 11},
  [835] = {.lex_state = 11},
  [836] = {.lex_state = 9},
  [837] = {.lex_state = 9},
  [838] = {.lex_state = 9},
  [839] = {.lex_state = 9},
  [840] = {.lex_state = 9},
  [841] = {.lex_state = 9},
  [842] = {.lex_state = 9},
  [843] = {.lex_state = 9},
  [844] = {.lex_state = 9},
  [845] = {.lex_state = 11},
  [846] = {.lex_state = 9},
  [847] = {.lex_state = 9},
  [848] = {.lex_state = 71},
  [849] = {.lex_state = 71},
  [850] = {.lex_state = 9},
  [851] = {.lex_state = 9},
  [852] = {.lex_state = 9},
  [853] = {.lex_state = 9},
  [854] = {.lex_state = 9},
  [855] = {.lex_state = 9},
  [856] = {.lex_state = 9},
  [857] = {.lex_state = 9},
  [858] = {.lex_state = 9},
  [859] = {.lex_state = 9},
  [860] = {.lex_state = 9},
  [861] = {.lex_state = 9},
  [862] = {.lex_state = 9},
  [863] = {.lex_state = 9},
  [864] = {.lex_state = 9},
  [865] = {.lex_state = 9},
  [866] = {.lex_state = 9},
  [867] = {.lex_state = 9},
  [868] = {.lex_state = 9},
  [869] = {.lex_state = 9},
  [870] = {.lex_state = 9},
  [871] = {.lex_state = 9},
  [872] = {.lex_state = 9},
  [873] = {.lex_state = 9},
  [874] = {.lex_state = 9},
  [875] = {.lex_state = 9},
  [876] = {.lex_state = 9},
  [877] = {.lex_state = 9},
  [878] = {.lex_state = 9},
  [879] = {.lex_state = 9},
  [880] = {.lex_state = 9},
  [881] = {.lex_state = 9},
  [882] = {.lex_state = 9},
  [883] = {.lex_state = 9},
  [884] = {.lex_state = 9},
  [885] = {.lex_state = 9},
  [886] = {.lex_state = 9},
  [887] = {.lex_state = 9},
  [888] = {.lex_state = 9},
  [889] = {.lex_state = 9},
  [890] = {.lex_state = 9},
  [891] = {.lex_state = 9},
  [892] = {.lex_state = 9},
  [893] = {.lex_state = 2, .external_lex_state = 2},
  [894] = {.lex_state = 9},
  [895] = {.lex_state = 9},
  [896] = {.lex_state = 9},
  [897] = {.lex_state = 9},
  [898] = {.lex_state = 9},
  [899] = {.lex_state = 9},
  [900] = {.lex_state = 9},
  [901] = {.lex_state = 9},
  [902] = {.lex_state = 9},
  [903] = {.lex_state = 9},
  [904] = {.lex_state = 9},
  [905] = {.lex_state = 9},
  [906] = {.lex_state = 9},
  [907] = {.lex_state = 9},
  [908] = {.lex_state = 9},
  [909] = {.lex_state = 9},
  [910] = {.lex_state = 9},
  [911] = {.lex_state = 9},
  [912] = {.lex_state = 9},
  [913] = {.lex_state = 9},
  [914] = {.lex_state = 9},
  [915] = {.lex_state = 9},
  [916] = {.lex_state = 9},
  [917] = {.lex_state = 9},
  [918] = {.lex_state = 9},
  [919] = {.lex_state = 9},
  [920] = {.lex_state = 9},
  [921] = {.lex_state = 9},
  [922] = {.lex_state = 9},
  [923] = {.lex_state = 9},
  [924] = {.lex_state = 9},
  [925] = {.lex_state = 9},
  [926] = {.lex_state = 9},
  [927] = {.lex_state = 9},
  [928] = {.lex_state = 9},
  [929] = {.lex_state = 9},
  [930] = {.lex_state = 9},
  [931] = {.lex_state = 9},
  [932] = {.lex_state = 9},
  [933] = {.lex_state = 9},
  [934] = {.lex_state = 9},
  [935] = {.lex_state = 9},
  [936] = {.lex_state = 9},
  [937] = {.lex_state = 9},
  [938] = {.lex_state = 9},
  [939] = {.lex_state = 9},
  [940] = {.lex_state = 9},
  [941] = {.lex_state = 9},
  [942] = {.lex_state = 9},
  [943] = {.lex_state = 9},
  [944] = {.lex_state = 9},
  [945] = {.lex_state = 9},
  [946] = {.lex_state = 9},
  [947] = {.lex_state = 9},
  [948] = {.lex_state = 9},
  [949] = {.lex_state = 9},
  [950] = {.lex_state = 9},
  [951] = {.lex_state = 9},
  [952] = {.lex_state = 9},
  [953] = {.lex_state = 9},
  [954] = {.lex_state = 9},
  [955] = {.lex_state = 9},
  [956] = {.lex_state = 9},
  [957] = {.lex_state = 2, .external_lex_state = 2},
  [958] = {.lex_state = 9},
  [959] = {.lex_state = 9},
  [960] = {.lex_state = 9},
  [961] = {.lex_state = 2, .external_lex_state = 3},
  [962] = {.lex_state = 2, .external_lex_state = 3},
  [963] = {.lex_state = 2, .external_lex_state = 3},
  [964] = {.lex_state = 2, .external_lex_state = 3},
  [965] = {.lex_state = 2, .external_lex_state = 3},
  [966] = {.lex_state = 2, .external_lex_state = 3},
  [967] = {.lex_state = 2, .external_lex_state = 3},
  [968] = {.lex_state = 2, .external_lex_state = 2},
  [969] = {.lex_state = 2, .external_lex_state = 3},
  [970] = {.lex_state = 2, .external_lex_state = 3},
  [971] = {.lex_state = 2, .external_lex_state = 3},
  [972] = {.lex_state = 2, .external_lex_state = 3},
  [973] = {.lex_state = 3, .external_lex_state = 2},
  [974] = {.lex_state = 3, .external_lex_state = 2},
  [975] = {.lex_state = 2, .external_lex_state = 3},
  [976] = {.lex_state = 2, .external_lex_state = 2},
  [977] = {.lex_state = 11},
  [978] = {.lex_state = 3, .external_lex_state = 2},
  [979] = {.lex_state = 2, .external_lex_state = 3},
  [980] = {.lex_state = 2, .external_lex_state = 3},
  [981] = {.lex_state = 3, .external_lex_state = 2},
  [982] = {.lex_state = 2, .external_lex_state = 2},
  [983] = {.lex_state = 11},
  [984] = {.lex_state = 3, .external_lex_state = 2},
  [985] = {.lex_state = 2, .external_lex_state = 2},
  [986] = {.lex_state = 2, .external_lex_state = 3},
  [987] = {.lex_state = 2, .external_lex_state = 3},
  [988] = {.lex_state = 2, .external_lex_state = 2},
  [989] = {.lex_state = 2, .external_lex_state = 3},
  [990] = {.lex_state = 3, .external_lex_state = 2},
  [991] = {.lex_state = 3, .external_lex_state = 2},
  [992] = {.lex_state = 2, .external_lex_state = 3},
  [993] = {.lex_state = 2, .external_lex_state = 3},
  [994] = {.lex_state = 2, .external_lex_state = 3},
  [995] = {.lex_state = 2, .external_lex_state = 2},
  [996] = {.lex_state = 2, .external_lex_state = 3},
  [997] = {.lex_state = 2, .external_lex_state = 3},
  [998] = {.lex_state = 2, .external_lex_state = 3},
  [999] = {.lex_state = 2, .external_lex_state = 2},
  [1000] = {.lex_state = 2, .external_lex_state = 2},
  [1001] = {.lex_state = 3, .external_lex_state = 2},
  [1002] = {.lex_state = 2, .external_lex_state = 2},
  [1003] = {.lex_state = 2, .external_lex_state = 2},
  [1004] = {.lex_state = 2, .external_lex_state = 2},
  [1005] = {.lex_state = 2, .external_lex_state = 2},
  [1006] = {.lex_state = 2, .external_lex_state = 2},
  [1007] = {.lex_state = 2, .external_lex_state = 3},
  [1008] = {.lex_state = 3, .external_lex_state = 2},
  [1009] = {.lex_state = 3, .external_lex_state = 2},
  [1010] = {.lex_state = 2, .external_lex_state = 3},
  [1011] = {.lex_state = 2, .external_lex_state = 2},
  [1012] = {.lex_state = 2, .external_lex_state = 2},
  [1013] = {.lex_state = 2, .external_lex_state = 3},
  [1014] = {.lex_state = 2, .external_lex_state = 2},
  [1015] = {.lex_state = 2, .external_lex_state = 3},
  [1016] = {.lex_state = 2, .external_lex_state = 3},
  [1017] = {.lex_state = 2, .external_lex_state = 2},
  [1018] = {.lex_state = 2, .external_lex_state = 2},
  [1019] = {.lex_state = 2, .external_lex_state = 2},
  [1020] = {.lex_state = 2, .external_lex_state = 3},
  [1021] = {.lex_state = 2, .external_lex_state = 2},
  [1022] = {.lex_state = 2, .external_lex_state = 2},
  [1023] = {.lex_state = 2, .external_lex_state = 2},
  [1024] = {.lex_state = 2, .external_lex_state = 2},
  [1025] = {.lex_state = 2, .external_lex_state = 2},
  [1026] = {.lex_state = 2, .external_lex_state = 2},
  [1027] = {.lex_state = 2, .external_lex_state = 3},
  [1028] = {.lex_state = 2, .external_lex_state = 2},
  [1029] = {.lex_state = 2, .external_lex_state = 2},
  [1030] = {.lex_state = 2, .external_lex_state = 2},
  [1031] = {.lex_state = 2, .external_lex_state = 2},
  [1032] = {.lex_state = 2, .external_lex_state = 2},
  [1033] = {.lex_state = 2, .external_lex_state = 2},
  [1034] = {.lex_state = 2, .external_lex_state = 2},
  [1035] = {.lex_state = 2, .external_lex_state = 2},
  [1036] = {.lex_state = 2, .external_lex_state = 2},
  [1037] = {.lex_state = 2, .external_lex_state = 3},
  [1038] = {.lex_state = 2, .external_lex_state = 3},
  [1039] = {.lex_state = 2, .external_lex_state = 2},
  [1040] = {.lex_state = 2, .external_lex_state = 3},
  [1041] = {.lex_state = 2, .external_lex_state = 2},
  [1042] = {.lex_state = 2, .external_lex_state = 2},
  [1043] = {.lex_state = 3, .external_lex_state = 2},
  [1044] = {.lex_state = 2, .external_lex_state = 3},
  [1045] = {.lex_state = 2, .external_lex_state = 2},
  [1046] = {.lex_state = 2, .external_lex_state = 3},
  [1047] = {.lex_state = 2, .external_lex_state = 2},
  [1048] = {.lex_state = 2, .external_lex_state = 3},
  [1049] = {.lex_state = 3, .external_lex_state = 2},
  [1050] = {.lex_state = 2, .external_lex_state = 2},
  [1051] = {.lex_state = 2, .external_lex_state = 3},
  [1052] = {.lex_state = 2, .external_lex_state = 2},
  [1053] = {.lex_state = 2, .external_lex_state = 3},
  [1054] = {.lex_state = 2, .external_lex_state = 2},
  [1055] = {.lex_state = 2, .external_lex_state = 3},
  [1056] = {.lex_state = 2, .external_lex_state = 3},
  [1057] = {.lex_state = 2, .external_lex_state = 2},
  [1058] = {.lex_state = 2, .external_lex_state = 3},
  [1059] = {.lex_state = 2, .external_lex_state = 3},
  [1060] = {.lex_state = 2, .external_lex_state = 3},
  [1061] = {.lex_state = 2, .external_lex_state = 3},
  [1062] = {.lex_state = 2, .external_lex_state = 2},
  [1063] = {.lex_state = 2, .external_lex_state = 3},
  [1064] = {.lex_state = 2, .external_lex_state = 3},
  [1065] = {.lex_state = 2, .external_lex_state = 2},
  [1066] = {.lex_state = 2, .external_lex_state = 3},
  [1067] = {.lex_state = 2, .external_lex_state = 2},
  [1068] = {.lex_state = 3, .external_lex_state = 2},
  [1069] = {.lex_state = 2, .external_lex_state = 2},
  [1070] = {.lex_state = 2, .external_lex_state = 3},
  [1071] = {.lex_state = 2, .external_lex_state = 3},
  [1072] = {.lex_state = 2, .external_lex_state = 3},
  [1073] = {.lex_state = 2, .external_lex_state = 3},
  [1074] = {.lex_state = 2, .external_lex_state = 2},
  [1075] = {.lex_state = 2, .external_lex_state = 3},
  [1076] = {.lex_state = 2, .external_lex_state = 3},
  [1077] = {.lex_state = 2, .external_lex_state = 3},
  [1078] = {.lex_state = 2, .external_lex_state = 3},
  [1079] = {.lex_state = 2, .external_lex_state = 3},
  [1080] = {.lex_state = 2, .external_lex_state = 3},
  [1081] = {.lex_state = 2, .external_lex_state = 3},
  [1082] = {.lex_state = 2, .external_lex_state = 3},
  [1083] = {.lex_state = 2, .external_lex_state = 2},
  [1084] = {.lex_state = 2, .external_lex_state = 2},
  [1085] = {.lex_state = 2, .external_lex_state = 3},
  [1086] = {.lex_state = 2, .external_lex_state = 2},
  [1087] = {.lex_state = 71},
  [1088] = {.lex_state = 2, .external_lex_state = 2},
  [1089] = {.lex_state = 2, .external_lex_state = 2},
  [1090] = {.lex_state = 2, .external_lex_state = 2},
  [1091] = {.lex_state = 2, .external_lex_state = 2},
  [1092] = {.lex_state = 2, .external_lex_state = 2},
  [1093] = {.lex_state = 2, .external_lex_state = 2},
  [1094] = {.lex_state = 2, .external_lex_state = 3},
  [1095] = {.lex_state = 71},
  [1096] = {.lex_state = 2, .external_lex_state = 3},
  [1097] = {.lex_state = 3, .external_lex_state = 2},
  [1098] = {.lex_state = 2, .external_lex_state = 2},
  [1099] = {.lex_state = 2, .external_lex_state = 3},
  [1100] = {.lex_state = 2, .external_lex_state = 3},
  [1101] = {.lex_state = 3, .external_lex_state = 2},
  [1102] = {.lex_state = 3, .external_lex_state = 2},
  [1103] = {.lex_state = 3, .external_lex_state = 2},
  [1104] = {.lex_state = 2, .external_lex_state = 2},
  [1105] = {.lex_state = 2, .external_lex_state = 2},
  [1106] = {.lex_state = 2, .external_lex_state = 3},
  [1107] = {.lex_state = 2, .external_lex_state = 3},
  [1108] = {.lex_state = 2, .external_lex_state = 2},
  [1109] = {.lex_state = 3, .external_lex_state = 2},
  [1110] = {.lex_state = 2, .external_lex_state = 3},
  [1111] = {.lex_state = 2, .external_lex_state = 2},
  [1112] = {.lex_state = 2, .external_lex_state = 3},
  [1113] = {.lex_state = 2, .external_lex_state = 2},
  [1114] = {.lex_state = 2, .external_lex_state = 2},
  [1115] = {.lex_state = 2, .external_lex_state = 2},
  [1116] = {.lex_state = 71},
  [1117] = {.lex_state = 2, .external_lex_state = 2},
  [1118] = {.lex_state = 71},
  [1119] = {.lex_state = 2, .external_lex_state = 2},
  [1120] = {.lex_state = 2, .external_lex_state = 2},
  [1121] = {.lex_state = 2, .external_lex_state = 2},
  [1122] = {.lex_state = 2, .external_lex_state = 2},
  [1123] = {.lex_state = 2, .external_lex_state = 2},
  [1124] = {.lex_state = 2, .external_lex_state = 2},
  [1125] = {.lex_state = 71},
  [1126] = {.lex_state = 2, .external_lex_state = 2},
  [1127] = {.lex_state = 2, .external_lex_state = 3},
  [1128] = {.lex_state = 2, .external_lex_state = 2},
  [1129] = {.lex_state = 71},
  [1130] = {.lex_state = 2, .external_lex_state = 2},
  [1131] = {.lex_state = 71},
  [1132] = {.lex_state = 2, .external_lex_state = 2},
  [1133] = {.lex_state = 2, .external_lex_state = 2},
  [1134] = {.lex_state = 2, .external_lex_state = 2},
  [1135] = {.lex_state = 2, .external_lex_state = 2},
  [1136] = {.lex_state = 2, .external_lex_state = 2},
  [1137] = {.lex_state = 2, .external_lex_state = 2},
  [1138] = {.lex_state = 2, .external_lex_state = 2},
  [1139] = {.lex_state = 2, .external_lex_state = 2},
  [1140] = {.lex_state = 9},
  [1141] = {.lex_state = 9},
  [1142] = {.lex_state = 9},
  [1143] = {.lex_state = 9},
  [1144] = {.lex_state = 9},
  [1145] = {.lex_state = 9},
  [1146] = {.lex_state = 71, .external_lex_state = 4},
  [1147] = {.lex_state = 71, .external_lex_state = 4},
  [1148] = {.lex_state = 71, .external_lex_state = 4},
  [1149] = {.lex_state = 71, .external_lex_state = 4},
  [1150] = {.lex_state = 71, .external_lex_state = 4},
  [1151] = {.lex_state = 9},
  [1152] = {.lex_state = 9},
  [1153] = {.lex_state = 9},
  [1154] = {.lex_state = 9},
  [1155] = {.lex_state = 9},
  [1156] = {.lex_state = 9},
  [1157] = {.lex_state = 9},
  [1158] = {.lex_state = 9},
  [1159] = {.lex_state = 70, .external_lex_state = 3},
  [1160] = {.lex_state = 9},
  [1161] = {.lex_state = 9},
  [1162] = {.lex_state = 9},
  [1163] = {.lex_state = 9},
  [1164] = {.lex_state = 9},
  [1165] = {.lex_state = 9},
  [1166] = {.lex_state = 9},
  [1167] = {.lex_state = 9},
  [1168] = {.lex_state = 9},
  [1169] = {.lex_state = 9},
  [1170] = {.lex_state = 71, .external_lex_state = 4},
  [1171] = {.lex_state = 71, .external_lex_state = 4},
  [1172] = {.lex_state = 9},
  [1173] = {.lex_state = 70, .external_lex_state = 3},
  [1174] = {.lex_state = 70, .external_lex_state = 3},
  [1175] = {.lex_state = 9},
  [1176] = {.lex_state = 9},
  [1177] = {.lex_state = 9},
  [1178] = {.lex_state = 9},
  [1179] = {.lex_state = 9},
  [1180] = {.lex_state = 9},
  [1181] = {.lex_state = 71},
  [1182] = {.lex_state = 71},
  [1183] = {.lex_state = 71},
  [1184] = {.lex_state = 71},
  [1185] = {.lex_state = 71},
  [1186] = {.lex_state = 71},
  [1187] = {.lex_state = 71},
  [1188] = {.lex_state = 70, .external_lex_state = 2},
  [1189] = {.lex_state = 70, .external_lex_state = 2},
  [1190] = {.lex_state = 70, .external_lex_state = 2},
  [1191] = {.lex_state = 70, .external_lex_state = 2},
  [1192] = {.lex_state = 70, .external_lex_state = 2},
  [1193] = {.lex_state = 70, .external_lex_state = 2},
  [1194] = {.lex_state = 70, .external_lex_state = 3},
  [1195] = {.lex_state = 70, .external_lex_state = 3},
  [1196] = {.lex_state = 70, .external_lex_state = 3},
  [1197] = {.lex_state = 70, .external_lex_state = 2},
  [1198] = {.lex_state = 70, .external_lex_state = 2},
  [1199] = {.lex_state = 70, .external_lex_state = 2},
  [1200] = {.lex_state = 70, .external_lex_state = 2},
  [1201] = {.lex_state = 70, .external_lex_state = 2},
  [1202] = {.lex_state = 70, .external_lex_state = 2},
  [1203] = {.lex_state = 70, .external_lex_state = 2},
  [1204] = {.lex_state = 70, .external_lex_state = 2},
  [1205] = {.lex_state = 70, .external_lex_state = 2},
  [1206] = {.lex_state = 70, .external_lex_state = 2},
  [1207] = {.lex_state = 70, .external_lex_state = 2},
  [1208] = {.lex_state = 70, .external_lex_state = 2},
  [1209] = {.lex_state = 70, .external_lex_state = 2},
  [1210] = {.lex_state = 70, .external_lex_state = 2},
  [1211] = {.lex_state = 70, .external_lex_state = 2},
  [1212] = {.lex_state = 70, .external_lex_state = 2},
  [1213] = {.lex_state = 70, .external_lex_state = 2},
  [1214] = {.lex_state = 70, .external_lex_state = 2},
  [1215] = {.lex_state = 70, .external_lex_state = 2},
  [1216] = {.lex_state = 70, .external_lex_state = 2},
  [1217] = {.lex_state = 70, .external_lex_state = 2},
  [1218] = {.lex_state = 70, .external_lex_state = 2},
  [1219] = {.lex_state = 70, .external_lex_state = 2},
  [1220] = {.lex_state = 70, .external_lex_state = 2},
  [1221] = {.lex_state = 70, .external_lex_state = 2},
  [1222] = {.lex_state = 70, .external_lex_state = 2},
  [1223] = {.lex_state = 70, .external_lex_state = 2},
  [1224] = {.lex_state = 70, .external_lex_state = 2},
  [1225] = {.lex_state = 70, .external_lex_state = 2},
  [1226] = {.lex_state = 70, .external_lex_state = 2},
  [1227] = {.lex_state = 70, .external_lex_state = 3},
  [1228] = {.lex_state = 70, .external_lex_state = 2},
  [1229] = {.lex_state = 70, .external_lex_state = 2},
  [1230] = {.lex_state = 70, .external_lex_state = 2},
  [1231] = {.lex_state = 70, .external_lex_state = 2},
  [1232] = {.lex_state = 70, .external_lex_state = 2},
  [1233] = {.lex_state = 70, .external_lex_state = 2},
  [1234] = {.lex_state = 70, .external_lex_state = 2},
  [1235] = {.lex_state = 70, .external_lex_state = 2},
  [1236] = {.lex_state = 70, .external_lex_state = 2},
  [1237] = {.lex_state = 70, .external_lex_state = 2},
  [1238] = {.lex_state = 70, .external_lex_state = 2},
  [1239] = {.lex_state = 70, .external_lex_state = 2},
  [1240] = {.lex_state = 70, .external_lex_state = 2},
  [1241] = {.lex_state = 70, .external_lex_state = 2},
  [1242] = {.lex_state = 70, .external_lex_state = 2},
  [1243] = {.lex_state = 70, .external_lex_state = 2},
  [1244] = {.lex_state = 70, .external_lex_state = 2},
  [1245] = {.lex_state = 70, .external_lex_state = 3},
  [1246] = {.lex_state = 70, .external_lex_state = 2},
  [1247] = {.lex_state = 70, .external_lex_state = 2},
  [1248] = {.lex_state = 70, .external_lex_state = 2},
  [1249] = {.lex_state = 70, .external_lex_state = 2},
  [1250] = {.lex_state = 70, .external_lex_state = 2},
  [1251] = {.lex_state = 70, .external_lex_state = 2},
  [1252] = {.lex_state = 70, .external_lex_state = 2},
  [1253] = {.lex_state = 70, .external_lex_state = 2},
  [1254] = {.lex_state = 70, .external_lex_state = 2},
  [1255] = {.lex_state = 70, .external_lex_state = 2},
  [1256] = {.lex_state = 70, .external_lex_state = 2},
  [1257] = {.lex_state = 70, .external_lex_state = 2},
  [1258] = {.lex_state = 70, .external_lex_state = 2},
  [1259] = {.lex_state = 70, .external_lex_state = 2},
  [1260] = {.lex_state = 70, .external_lex_state = 2},
  [1261] = {.lex_state = 70, .external_lex_state = 2},
  [1262] = {.lex_state = 70, .external_lex_state = 2},
  [1263] = {.lex_state = 70, .external_lex_state = 2},
  [1264] = {.lex_state = 70, .external_lex_state = 2},
  [1265] = {.lex_state = 70, .external_lex_state = 2},
  [1266] = {.lex_state = 70, .external_lex_state = 2},
  [1267] = {.lex_state = 70, .external_lex_state = 2},
  [1268] = {.lex_state = 70, .external_lex_state = 3},
  [1269] = {.lex_state = 70, .external_lex_state = 2},
  [1270] = {.lex_state = 70, .external_lex_state = 2},
  [1271] = {.lex_state = 70, .external_lex_state = 2},
  [1272] = {.lex_state = 70, .external_lex_state = 2},
  [1273] = {.lex_state = 70, .external_lex_state = 2},
  [1274] = {.lex_state = 70, .external_lex_state = 2},
  [1275] = {.lex_state = 70, .external_lex_state = 2},
  [1276] = {.lex_state = 70, .external_lex_state = 2},
  [1277] = {.lex_state = 70, .external_lex_state = 2},
  [1278] = {.lex_state = 70, .external_lex_state = 2},
  [1279] = {.lex_state = 70, .external_lex_state = 2},
  [1280] = {.lex_state = 70, .external_lex_state = 2},
  [1281] = {.lex_state = 70, .external_lex_state = 2},
  [1282] = {.lex_state = 70, .external_lex_state = 2},
  [1283] = {.lex_state = 70, .external_lex_state = 2},
  [1284] = {.lex_state = 70, .external_lex_state = 2},
  [1285] = {.lex_state = 70, .external_lex_state = 2},
  [1286] = {.lex_state = 70, .external_lex_state = 2},
  [1287] = {.lex_state = 70, .external_lex_state = 2},
  [1288] = {.lex_state = 70, .external_lex_state = 2},
  [1289] = {.lex_state = 70, .external_lex_state = 2},
  [1290] = {.lex_state = 70, .external_lex_state = 2},
  [1291] = {.lex_state = 70, .external_lex_state = 2},
  [1292] = {.lex_state = 70, .external_lex_state = 2},
  [1293] = {.lex_state = 70, .external_lex_state = 2},
  [1294] = {.lex_state = 70, .external_lex_state = 2},
  [1295] = {.lex_state = 70, .external_lex_state = 2},
  [1296] = {.lex_state = 70, .external_lex_state = 2},
  [1297] = {.lex_state = 71},
  [1298] = {.lex_state = 70, .external_lex_state = 2},
  [1299] = {.lex_state = 70, .external_lex_state = 2},
  [1300] = {.lex_state = 70, .external_lex_state = 2},
  [1301] = {.lex_state = 70, .external_lex_state = 2},
  [1302] = {.lex_state = 70, .external_lex_state = 2},
  [1303] = {.lex_state = 70, .external_lex_state = 2},
  [1304] = {.lex_state = 70, .external_lex_state = 2},
  [1305] = {.lex_state = 70, .external_lex_state = 2},
  [1306] = {.lex_state = 70, .external_lex_state = 2},
  [1307] = {.lex_state = 70, .external_lex_state = 2},
  [1308] = {.lex_state = 70, .external_lex_state = 2},
  [1309] = {.lex_state = 70, .external_lex_state = 2},
  [1310] = {.lex_state = 70, .external_lex_state = 2},
  [1311] = {.lex_state = 70, .external_lex_state = 2},
  [1312] = {.lex_state = 70, .external_lex_state = 2},
  [1313] = {.lex_state = 70, .external_lex_state = 2},
  [1314] = {.lex_state = 70, .external_lex_state = 2},
  [1315] = {.lex_state = 70, .external_lex_state = 2},
  [1316] = {.lex_state = 70, .external_lex_state = 2},
  [1317] = {.lex_state = 70, .external_lex_state = 2},
  [1318] = {.lex_state = 70, .external_lex_state = 2},
  [1319] = {.lex_state = 70, .external_lex_state = 2},
  [1320] = {.lex_state = 70, .external_lex_state = 2},
  [1321] = {.lex_state = 70, .external_lex_state = 3},
  [1322] = {.lex_state = 70, .external_lex_state = 3},
  [1323] = {.lex_state = 70, .external_lex_state = 2},
  [1324] = {.lex_state = 70, .external_lex_state = 2},
  [1325] = {.lex_state = 70, .external_lex_state = 2},
  [1326] = {.lex_state = 70, .external_lex_state = 2},
  [1327] = {.lex_state = 70, .external_lex_state = 2},
  [1328] = {.lex_state = 70, .external_lex_state = 2},
  [1329] = {.lex_state = 70, .external_lex_state = 2},
  [1330] = {.lex_state = 70, .external_lex_state = 3},
  [1331] = {.lex_state = 70, .external_lex_state = 3},
  [1332] = {.lex_state = 70, .external_lex_state = 2},
  [1333] = {.lex_state = 70, .external_lex_state = 2},
  [1334] = {.lex_state = 70, .external_lex_state = 2},
  [1335] = {.lex_state = 70, .external_lex_state = 2},
  [1336] = {.lex_state = 70, .external_lex_state = 3},
  [1337] = {.lex_state = 70, .external_lex_state = 2},
  [1338] = {.lex_state = 70, .external_lex_state = 3},
  [1339] = {.lex_state = 70, .external_lex_state = 2},
  [1340] = {.lex_state = 70, .external_lex_state = 2},
  [1341] = {.lex_state = 70, .external_lex_state = 2},
  [1342] = {.lex_state = 70, .external_lex_state = 2},
  [1343] = {.lex_state = 70, .external_lex_state = 2},
  [1344] = {.lex_state = 70, .external_lex_state = 2},
  [1345] = {.lex_state = 70, .external_lex_state = 2},
  [1346] = {.lex_state = 70, .external_lex_state = 2},
  [1347] = {.lex_state = 70, .external_lex_state = 2},
  [1348] = {.lex_state = 70, .external_lex_state = 2},
  [1349] = {.lex_state = 70, .external_lex_state = 2},
  [1350] = {.lex_state = 70, .external_lex_state = 2},
  [1351] = {.lex_state = 70, .external_lex_state = 2},
  [1352] = {.lex_state = 70, .external_lex_state = 2},
  [1353] = {.lex_state = 70, .external_lex_state = 2},
  [1354] = {.lex_state = 70, .external_lex_state = 2},
  [1355] = {.lex_state = 70, .external_lex_state = 2},
  [1356] = {.lex_state = 70, .external_lex_state = 2},
  [1357] = {.lex_state = 70, .external_lex_state = 2},
  [1358] = {.lex_state = 70, .external_lex_state = 2},
  [1359] = {.lex_state = 70, .external_lex_state = 2},
  [1360] = {.lex_state = 70, .external_lex_state = 2},
  [1361] = {.lex_state = 70, .external_lex_state = 2},
  [1362] = {.lex_state = 70, .external_lex_state = 2},
  [1363] = {.lex_state = 70, .external_lex_state = 2},
  [1364] = {.lex_state = 70, .external_lex_state = 2},
  [1365] = {.lex_state = 70, .external_lex_state = 2},
  [1366] = {.lex_state = 70, .external_lex_state = 2},
  [1367] = {.lex_state = 70, .external_lex_state = 3},
  [1368] = {.lex_state = 70, .external_lex_state = 2},
  [1369] = {.lex_state = 70, .external_lex_state = 2},
  [1370] = {.lex_state = 70, .external_lex_state = 2},
  [1371] = {.lex_state = 70, .external_lex_state = 2},
  [1372] = {.lex_state = 70, .external_lex_state = 2},
  [1373] = {.lex_state = 70, .external_lex_state = 2},
  [1374] = {.lex_state = 70, .external_lex_state = 2},
  [1375] = {.lex_state = 70, .external_lex_state = 2},
  [1376] = {.lex_state = 70, .external_lex_state = 2},
  [1377] = {.lex_state = 70, .external_lex_state = 2},
  [1378] = {.lex_state = 70, .external_lex_state = 2},
  [1379] = {.lex_state = 70, .external_lex_state = 2},
  [1380] = {.lex_state = 70, .external_lex_state = 2},
  [1381] = {.lex_state = 70, .external_lex_state = 2},
  [1382] = {.lex_state = 70, .external_lex_state = 2},
  [1383] = {.lex_state = 70, .external_lex_state = 2},
  [1384] = {.lex_state = 70, .external_lex_state = 3},
  [1385] = {.lex_state = 70, .external_lex_state = 2},
  [1386] = {.lex_state = 70, .external_lex_state = 2},
  [1387] = {.lex_state = 70, .external_lex_state = 2},
  [1388] = {.lex_state = 70, .external_lex_state = 2},
  [1389] = {.lex_state = 70, .external_lex_state = 2},
  [1390] = {.lex_state = 70, .external_lex_state = 2},
  [1391] = {.lex_state = 70, .external_lex_state = 2},
  [1392] = {.lex_state = 70, .external_lex_state = 2},
  [1393] = {.lex_state = 70, .external_lex_state = 2},
  [1394] = {.lex_state = 70, .external_lex_state = 2},
  [1395] = {.lex_state = 70, .external_lex_state = 2},
  [1396] = {.lex_state = 70, .external_lex_state = 2},
  [1397] = {.lex_state = 70, .external_lex_state = 2},
  [1398] = {.lex_state = 70, .external_lex_state = 2},
  [1399] = {.lex_state = 70, .external_lex_state = 2},
  [1400] = {.lex_state = 70, .external_lex_state = 2},
  [1401] = {.lex_state = 70, .external_lex_state = 2},
  [1402] = {.lex_state = 70, .external_lex_state = 2},
  [1403] = {.lex_state = 70, .external_lex_state = 3},
  [1404] = {.lex_state = 9},
  [1405] = {.lex_state = 70, .external_lex_state = 2},
  [1406] = {.lex_state = 70, .external_lex_state = 3},
  [1407] = {.lex_state = 71, .external_lex_state = 4},
  [1408] = {.lex_state = 70, .external_lex_state = 3},
  [1409] = {.lex_state = 70, .external_lex_state = 2},
  [1410] = {.lex_state = 70, .external_lex_state = 3},
  [1411] = {.lex_state = 70, .external_lex_state = 3},
  [1412] = {.lex_state = 70, .external_lex_state = 2},
  [1413] = {.lex_state = 70, .external_lex_state = 3},
  [1414] = {.lex_state = 70, .external_lex_state = 3},
  [1415] = {.lex_state = 70, .external_lex_state = 3},
  [1416] = {.lex_state = 70, .external_lex_state = 3},
  [1417] = {.lex_state = 70, .external_lex_state = 3},
  [1418] = {.lex_state = 70, .external_lex_state = 3},
  [1419] = {.lex_state = 70, .external_lex_state = 3},
  [1420] = {.lex_state = 70, .external_lex_state = 3},
  [1421] = {.lex_state = 70, .external_lex_state = 3},
  [1422] = {.lex_state = 70, .external_lex_state = 3},
  [1423] = {.lex_state = 70, .external_lex_state = 3},
  [1424] = {.lex_state = 70, .external_lex_state = 3},
  [1425] = {.lex_state = 70, .external_lex_state = 3},
  [1426] = {.lex_state = 9},
  [1427] = {.lex_state = 70, .external_lex_state = 2},
  [1428] = {.lex_state = 70, .external_lex_state = 3},
  [1429] = {.lex_state = 70, .external_lex_state = 3},
  [1430] = {.lex_state = 70, .external_lex_state = 3},
  [1431] = {.lex_state = 70, .external_lex_state = 3},
  [1432] = {.lex_state = 70, .external_lex_state = 3},
  [1433] = {.lex_state = 70, .external_lex_state = 3},
  [1434] = {.lex_state = 70, .external_lex_state = 3},
  [1435] = {.lex_state = 70, .external_lex_state = 3},
  [1436] = {.lex_state = 70, .external_lex_state = 3},
  [1437] = {.lex_state = 70, .external_lex_state = 3},
  [1438] = {.lex_state = 9},
  [1439] = {.lex_state = 70, .external_lex_state = 3},
  [1440] = {.lex_state = 70, .external_lex_state = 3},
  [1441] = {.lex_state = 70, .external_lex_state = 3},
  [1442] = {.lex_state = 70, .external_lex_state = 3},
  [1443] = {.lex_state = 70, .external_lex_state = 3},
  [1444] = {.lex_state = 70, .external_lex_state = 3},
  [1445] = {.lex_state = 70, .external_lex_state = 3},
  [1446] = {.lex_state = 70, .external_lex_state = 3},
  [1447] = {.lex_state = 70, .external_lex_state = 3},
  [1448] = {.lex_state = 70, .external_lex_state = 3},
  [1449] = {.lex_state = 70, .external_lex_state = 3},
  [1450] = {.lex_state = 70, .external_lex_state = 3},
  [1451] = {.lex_state = 70, .external_lex_state = 3},
  [1452] = {.lex_state = 70, .external_lex_state = 3},
  [1453] = {.lex_state = 70, .external_lex_state = 2},
  [1454] = {.lex_state = 70, .external_lex_state = 3},
  [1455] = {.lex_state = 70, .external_lex_state = 3},
  [1456] = {.lex_state = 70, .external_lex_state = 3},
  [1457] = {.lex_state = 70, .external_lex_state = 3},
  [1458] = {.lex_state = 70, .external_lex_state = 3},
  [1459] = {.lex_state = 70, .external_lex_state = 3},
  [1460] = {.lex_state = 70, .external_lex_state = 2},
  [1461] = {.lex_state = 70, .external_lex_state = 2},
  [1462] = {.lex_state = 70, .external_lex_state = 3},
  [1463] = {.lex_state = 70, .external_lex_state = 3},
  [1464] = {.lex_state = 70, .external_lex_state = 3},
  [1465] = {.lex_state = 70, .external_lex_state = 3},
  [1466] = {.lex_state = 70, .external_lex_state = 3},
  [1467] = {.lex_state = 70, .external_lex_state = 3},
  [1468] = {.lex_state = 70, .external_lex_state = 3},
  [1469] = {.lex_state = 70, .external_lex_state = 3},
  [1470] = {.lex_state = 70, .external_lex_state = 2},
  [1471] = {.lex_state = 70, .external_lex_state = 3},
  [1472] = {.lex_state = 70, .external_lex_state = 3},
  [1473] = {.lex_state = 70, .external_lex_state = 3},
  [1474] = {.lex_state = 70, .external_lex_state = 3},
  [1475] = {.lex_state = 9},
  [1476] = {.lex_state = 70, .external_lex_state = 2},
  [1477] = {.lex_state = 9},
  [1478] = {.lex_state = 70, .external_lex_state = 2},
  [1479] = {.lex_state = 70, .external_lex_state = 2},
  [1480] = {.lex_state = 70, .external_lex_state = 3},
  [1481] = {.lex_state = 70, .external_lex_state = 3},
  [1482] = {.lex_state = 70, .external_lex_state = 3},
  [1483] = {.lex_state = 70, .external_lex_state = 2},
  [1484] = {.lex_state = 70, .external_lex_state = 3},
  [1485] = {.lex_state = 70, .external_lex_state = 3},
  [1486] = {.lex_state = 9},
  [1487] = {.lex_state = 70, .external_lex_state = 3},
  [1488] = {.lex_state = 9},
  [1489] = {.lex_state = 70, .external_lex_state = 3},
  [1490] = {.lex_state = 70, .external_lex_state = 3},
  [1491] = {.lex_state = 70, .external_lex_state = 3},
  [1492] = {.lex_state = 70, .external_lex_state = 3},
  [1493] = {.lex_state = 70, .external_lex_state = 2},
  [1494] = {.lex_state = 71, .external_lex_state = 4},
  [1495] = {.lex_state = 70, .external_lex_state = 3},
  [1496] = {.lex_state = 70, .external_lex_state = 3},
  [1497] = {.lex_state = 9},
  [1498] = {.lex_state = 9},
  [1499] = {.lex_state = 71, .external_lex_state = 4},
  [1500] = {.lex_state = 70, .external_lex_state = 3},
  [1501] = {.lex_state = 70, .external_lex_state = 3},
  [1502] = {.lex_state = 9},
  [1503] = {.lex_state = 70, .external_lex_state = 3},
  [1504] = {.lex_state = 71, .external_lex_state = 4},
  [1505] = {.lex_state = 9},
  [1506] = {.lex_state = 71, .external_lex_state = 4},
  [1507] = {.lex_state = 70, .external_lex_state = 3},
  [1508] = {.lex_state = 70, .external_lex_state = 3},
  [1509] = {.lex_state = 70, .external_lex_state = 3},
  [1510] = {.lex_state = 70, .external_lex_state = 2},
  [1511] = {.lex_state = 70, .external_lex_state = 2},
  [1512] = {.lex_state = 70, .external_lex_state = 3},
  [1513] = {.lex_state = 70, .external_lex_state = 3},
  [1514] = {.lex_state = 70, .external_lex_state = 3},
  [1515] = {.lex_state = 70, .external_lex_state = 3},
  [1516] = {.lex_state = 70, .external_lex_state = 3},
  [1517] = {.lex_state = 70, .external_lex_state = 3},
  [1518] = {.lex_state = 70, .external_lex_state = 3},
  [1519] = {.lex_state = 70, .external_lex_state = 2},
  [1520] = {.lex_state = 70, .external_lex_state = 3},
  [1521] = {.lex_state = 70, .external_lex_state = 3},
  [1522] = {.lex_state = 70, .external_lex_state = 3},
  [1523] = {.lex_state = 70, .external_lex_state = 3},
  [1524] = {.lex_state = 70, .external_lex_state = 3},
  [1525] = {.lex_state = 70, .external_lex_state = 3},
  [1526] = {.lex_state = 70, .external_lex_state = 3},
  [1527] = {.lex_state = 70, .external_lex_state = 3},
  [1528] = {.lex_state = 70, .external_lex_state = 3},
  [1529] = {.lex_state = 70, .external_lex_state = 3},
  [1530] = {.lex_state = 70, .external_lex_state = 3},
  [1531] = {.lex_state = 70, .external_lex_state = 3},
  [1532] = {.lex_state = 70, .external_lex_state = 3},
  [1533] = {.lex_state = 70, .external_lex_state = 3},
  [1534] = {.lex_state = 70, .external_lex_state = 3},
  [1535] = {.lex_state = 70, .external_lex_state = 3},
  [1536] = {.lex_state = 70, .external_lex_state = 3},
  [1537] = {.lex_state = 70, .external_lex_state = 3},
  [1538] = {.lex_state = 70, .external_lex_state = 3},
  [1539] = {.lex_state = 70, .external_lex_state = 3},
  [1540] = {.lex_state = 70, .external_lex_state = 3},
  [1541] = {.lex_state = 71, .external_lex_state = 4},
  [1542] = {.lex_state = 70, .external_lex_state = 3},
  [1543] = {.lex_state = 71, .external_lex_state = 4},
  [1544] = {.lex_state = 70, .external_lex_state = 3},
  [1545] = {.lex_state = 70, .external_lex_state = 3},
  [1546] = {.lex_state = 70, .external_lex_state = 2},
  [1547] = {.lex_state = 70, .external_lex_state = 2},
  [1548] = {.lex_state = 70, .external_lex_state = 2},
  [1549] = {.lex_state = 70, .external_lex_state = 2},
  [1550] = {.lex_state = 71, .external_lex_state = 4},
  [1551] = {.lex_state = 71, .external_lex_state = 4},
  [1552] = {.lex_state = 70, .external_lex_state = 2},
  [1553] = {.lex_state = 70, .external_lex_state = 2},
  [1554] = {.lex_state = 70, .external_lex_state = 3},
  [1555] = {.lex_state = 70, .external_lex_state = 3},
  [1556] = {.lex_state = 70, .external_lex_state = 2},
  [1557] = {.lex_state = 70, .external_lex_state = 3},
  [1558] = {.lex_state = 70, .external_lex_state = 3},
  [1559] = {.lex_state = 70, .external_lex_state = 3},
  [1560] = {.lex_state = 70, .external_lex_state = 3},
  [1561] = {.lex_state = 70, .external_lex_state = 3},
  [1562] = {.lex_state = 70, .external_lex_state = 3},
  [1563] = {.lex_state = 70, .external_lex_state = 3},
  [1564] = {.lex_state = 70, .external_lex_state = 3},
  [1565] = {.lex_state = 70, .external_lex_state = 3},
  [1566] = {.lex_state = 70, .external_lex_state = 3},
  [1567] = {.lex_state = 70, .external_lex_state = 3},
  [1568] = {.lex_state = 70, .external_lex_state = 3},
  [1569] = {.lex_state = 70, .external_lex_state = 3},
  [1570] = {.lex_state = 70, .external_lex_state = 3},
  [1571] = {.lex_state = 70, .external_lex_state = 3},
  [1572] = {.lex_state = 70, .external_lex_state = 3},
  [1573] = {.lex_state = 70, .external_lex_state = 3},
  [1574] = {.lex_state = 70, .external_lex_state = 3},
  [1575] = {.lex_state = 70, .external_lex_state = 3},
  [1576] = {.lex_state = 70, .external_lex_state = 3},
  [1577] = {.lex_state = 70, .external_lex_state = 3},
  [1578] = {.lex_state = 4, .external_lex_state = 2},
  [1579] = {.lex_state = 70, .external_lex_state = 3},
  [1580] = {.lex_state = 70, .external_lex_state = 3},
  [1581] = {.lex_state = 70, .external_lex_state = 3},
  [1582] = {.lex_state = 70, .external_lex_state = 3},
  [1583] = {.lex_state = 70, .external_lex_state = 3},
  [1584] = {.lex_state = 70, .external_lex_state = 3},
  [1585] = {.lex_state = 70, .external_lex_state = 3},
  [1586] = {.lex_state = 70, .external_lex_state = 3},
  [1587] = {.lex_state = 70, .external_lex_state = 3},
  [1588] = {.lex_state = 70, .external_lex_state = 3},
  [1589] = {.lex_state = 70, .external_lex_state = 2},
  [1590] = {.lex_state = 70, .external_lex_state = 3},
  [1591] = {.lex_state = 70, .external_lex_state = 3},
  [1592] = {.lex_state = 70, .external_lex_state = 3},
  [1593] = {.lex_state = 70, .external_lex_state = 3},
  [1594] = {.lex_state = 70, .external_lex_state = 3},
  [1595] = {.lex_state = 70, .external_lex_state = 3},
  [1596] = {.lex_state = 70, .external_lex_state = 3},
  [1597] = {.lex_state = 71, .external_lex_state = 4},
  [1598] = {.lex_state = 70, .external_lex_state = 2},
  [1599] = {.lex_state = 70, .external_lex_state = 2},
  [1600] = {.lex_state = 70, .external_lex_state = 3},
  [1601] = {.lex_state = 70, .external_lex_state = 3},
  [1602] = {.lex_state = 70, .external_lex_state = 3},
  [1603] = {.lex_state = 70, .external_lex_state = 3},
  [1604] = {.lex_state = 70, .external_lex_state = 2},
  [1605] = {.lex_state = 71, .external_lex_state = 4},
  [1606] = {.lex_state = 70, .external_lex_state = 2},
  [1607] = {.lex_state = 70, .external_lex_state = 3},
  [1608] = {.lex_state = 70, .external_lex_state = 3},
  [1609] = {.lex_state = 70, .external_lex_state = 3},
  [1610] = {.lex_state = 70, .external_lex_state = 3},
  [1611] = {.lex_state = 70, .external_lex_state = 3},
  [1612] = {.lex_state = 70, .external_lex_state = 3},
  [1613] = {.lex_state = 70, .external_lex_state = 3},
  [1614] = {.lex_state = 70, .external_lex_state = 3},
  [1615] = {.lex_state = 70, .external_lex_state = 2},
  [1616] = {.lex_state = 70, .external_lex_state = 3},
  [1617] = {.lex_state = 70, .external_lex_state = 3},
  [1618] = {.lex_state = 70, .external_lex_state = 3},
  [1619] = {.lex_state = 70, .external_lex_state = 3},
  [1620] = {.lex_state = 70, .external_lex_state = 2},
  [1621] = {.lex_state = 70, .external_lex_state = 3},
  [1622] = {.lex_state = 70, .external_lex_state = 3},
  [1623] = {.lex_state = 70, .external_lex_state = 2},
  [1624] = {.lex_state = 70, .external_lex_state = 2},
  [1625] = {.lex_state = 70, .external_lex_state = 3},
  [1626] = {.lex_state = 70, .external_lex_state = 2},
  [1627] = {.lex_state = 70, .external_lex_state = 3},
  [1628] = {.lex_state = 70, .external_lex_state = 3},
  [1629] = {.lex_state = 70, .external_lex_state = 3},
  [1630] = {.lex_state = 70, .external_lex_state = 3},
  [1631] = {.lex_state = 70, .external_lex_state = 2},
  [1632] = {.lex_state = 70, .external_lex_state = 2},
  [1633] = {.lex_state = 70, .external_lex_state = 3},
  [1634] = {.lex_state = 70, .external_lex_state = 3},
  [1635] = {.lex_state = 70, .external_lex_state = 2},
  [1636] = {.lex_state = 70, .external_lex_state = 3},
  [1637] = {.lex_state = 70, .external_lex_state = 2},
  [1638] = {.lex_state = 70, .external_lex_state = 2},
  [1639] = {.lex_state = 70, .external_lex_state = 2},
  [1640] = {.lex_state = 70, .external_lex_state = 3},
  [1641] = {.lex_state = 70, .external_lex_state = 2},
  [1642] = {.lex_state = 70, .external_lex_state = 2},
  [1643] = {.lex_state = 70, .external_lex_state = 3},
  [1644] = {.lex_state = 70, .external_lex_state = 2},
  [1645] = {.lex_state = 70, .external_lex_state = 2},
  [1646] = {.lex_state = 70, .external_lex_state = 2},
  [1647] = {.lex_state = 70, .external_lex_state = 3},
  [1648] = {.lex_state = 70, .external_lex_state = 2},
  [1649] = {.lex_state = 70, .external_lex_state = 2},
  [1650] = {.lex_state = 70, .external_lex_state = 3},
  [1651] = {.lex_state = 70, .external_lex_state = 3},
  [1652] = {.lex_state = 70, .external_lex_state = 2},
  [1653] = {.lex_state = 70, .external_lex_state = 2},
  [1654] = {.lex_state = 70, .external_lex_state = 2},
  [1655] = {.lex_state = 70, .external_lex_state = 2},
  [1656] = {.lex_state = 70, .external_lex_state = 2},
  [1657] = {.lex_state = 70, .external_lex_state = 2},
  [1658] = {.lex_state = 71, .external_lex_state = 4},
  [1659] = {.lex_state = 71, .external_lex_state = 4},
  [1660] = {.lex_state = 71, .external_lex_state = 4},
  [1661] = {.lex_state = 70, .external_lex_state = 2},
  [1662] = {.lex_state = 71, .external_lex_state = 4},
  [1663] = {.lex_state = 70, .external_lex_state = 3},
  [1664] = {.lex_state = 70, .external_lex_state = 2},
  [1665] = {.lex_state = 70, .external_lex_state = 3},
  [1666] = {.lex_state = 70, .external_lex_state = 2},
  [1667] = {.lex_state = 70, .external_lex_state = 2},
  [1668] = {.lex_state = 70, .external_lex_state = 2},
  [1669] = {.lex_state = 70, .external_lex_state = 3},
  [1670] = {.lex_state = 70, .external_lex_state = 2},
  [1671] = {.lex_state = 70, .external_lex_state = 2},
  [1672] = {.lex_state = 70, .external_lex_state = 2},
  [1673] = {.lex_state = 70, .external_lex_state = 3},
  [1674] = {.lex_state = 70, .external_lex_state = 2},
  [1675] = {.lex_state = 70, .external_lex_state = 2},
  [1676] = {.lex_state = 70, .external_lex_state = 2},
  [1677] = {.lex_state = 70, .external_lex_state = 2},
  [1678] = {.lex_state = 70, .external_lex_state = 2},
  [1679] = {.lex_state = 70, .external_lex_state = 2},
  [1680] = {.lex_state = 70, .external_lex_state = 2},
  [1681] = {.lex_state = 70, .external_lex_state = 3},
  [1682] = {.lex_state = 70, .external_lex_state = 2},
  [1683] = {.lex_state = 70, .external_lex_state = 2},
  [1684] = {.lex_state = 70, .external_lex_state = 3},
  [1685] = {.lex_state = 70, .external_lex_state = 3},
  [1686] = {.lex_state = 70, .external_lex_state = 3},
  [1687] = {.lex_state = 70, .external_lex_state = 3},
  [1688] = {.lex_state = 70, .external_lex_state = 3},
  [1689] = {.lex_state = 70, .external_lex_state = 2},
  [1690] = {.lex_state = 70, .external_lex_state = 2},
  [1691] = {.lex_state = 70, .external_lex_state = 2},
  [1692] = {.lex_state = 70, .external_lex_state = 2},
  [1693] = {.lex_state = 70, .external_lex_state = 2},
  [1694] = {.lex_state = 70, .external_lex_state = 2},
  [1695] = {.lex_state = 71, .external_lex_state = 4},
  [1696] = {.lex_state = 70, .external_lex_state = 2},
  [1697] = {.lex_state = 70, .external_lex_state = 3},
  [1698] = {.lex_state = 70, .external_lex_state = 3},
  [1699] = {.lex_state = 70, .external_lex_state = 2},
  [1700] = {.lex_state = 70, .external_lex_state = 3},
  [1701] = {.lex_state = 70, .external_lex_state = 3},
  [1702] = {.lex_state = 70, .external_lex_state = 3},
  [1703] = {.lex_state = 70, .external_lex_state = 2},
  [1704] = {.lex_state = 70, .external_lex_state = 3},
  [1705] = {.lex_state = 70, .external_lex_state = 3},
  [1706] = {.lex_state = 70, .external_lex_state = 2},
  [1707] = {.lex_state = 70, .external_lex_state = 3},
  [1708] = {.lex_state = 70, .external_lex_state = 3},
  [1709] = {.lex_state = 70, .external_lex_state = 3},
  [1710] = {.lex_state = 70, .external_lex_state = 3},
  [1711] = {.lex_state = 70, .external_lex_state = 3},
  [1712] = {.lex_state = 71, .external_lex_state = 4},
  [1713] = {.lex_state = 70, .external_lex_state = 3},
  [1714] = {.lex_state = 70, .external_lex_state = 3},
  [1715] = {.lex_state = 70, .external_lex_state = 3},
  [1716] = {.lex_state = 70, .external_lex_state = 3},
  [1717] = {.lex_state = 70, .external_lex_state = 3},
  [1718] = {.lex_state = 70, .external_lex_state = 3},
  [1719] = {.lex_state = 70, .external_lex_state = 3},
  [1720] = {.lex_state = 70, .external_lex_state = 3},
  [1721] = {.lex_state = 70, .external_lex_state = 3},
  [1722] = {.lex_state = 70, .external_lex_state = 3},
  [1723] = {.lex_state = 70, .external_lex_state = 2},
  [1724] = {.lex_state = 70, .external_lex_state = 3},
  [1725] = {.lex_state = 70, .external_lex_state = 3},
  [1726] = {.lex_state = 70, .external_lex_state = 3},
  [1727] = {.lex_state = 70, .external_lex_state = 3},
  [1728] = {.lex_state = 70, .external_lex_state = 3},
  [1729] = {.lex_state = 70, .external_lex_state = 3},
  [1730] = {.lex_state = 70, .external_lex_state = 2},
  [1731] = {.lex_state = 70, .external_lex_state = 3},
  [1732] = {.lex_state = 70, .external_lex_state = 2},
  [1733] = {.lex_state = 70, .external_lex_state = 2},
  [1734] = {.lex_state = 70, .external_lex_state = 3},
  [1735] = {.lex_state = 70, .external_lex_state = 2},
  [1736] = {.lex_state = 70, .external_lex_state = 3},
  [1737] = {.lex_state = 70, .external_lex_state = 2},
  [1738] = {.lex_state = 70, .external_lex_state = 2},
  [1739] = {.lex_state = 70, .external_lex_state = 3},
  [1740] = {.lex_state = 70, .external_lex_state = 2},
  [1741] = {.lex_state = 70, .external_lex_state = 3},
  [1742] = {.lex_state = 70, .external_lex_state = 2},
  [1743] = {.lex_state = 70, .external_lex_state = 3},
  [1744] = {.lex_state = 70, .external_lex_state = 2},
  [1745] = {.lex_state = 70, .external_lex_state = 3},
  [1746] = {.lex_state = 70, .external_lex_state = 3},
  [1747] = {.lex_state = 70, .external_lex_state = 3},
  [1748] = {.lex_state = 70, .external_lex_state = 3},
  [1749] = {.lex_state = 70, .external_lex_state = 3},
  [1750] = {.lex_state = 70, .external_lex_state = 3},
  [1751] = {.lex_state = 70, .external_lex_state = 3},
  [1752] = {.lex_state = 70, .external_lex_state = 3},
  [1753] = {.lex_state = 70, .external_lex_state = 3},
  [1754] = {.lex_state = 4, .external_lex_state = 3},
  [1755] = {.lex_state = 70, .external_lex_state = 2},
  [1756] = {.lex_state = 70, .external_lex_state = 3},
  [1757] = {.lex_state = 71, .external_lex_state = 4},
  [1758] = {.lex_state = 70, .external_lex_state = 2},
  [1759] = {.lex_state = 70, .external_lex_state = 2},
  [1760] = {.lex_state = 70, .external_lex_state = 3},
  [1761] = {.lex_state = 70, .external_lex_state = 2},
  [1762] = {.lex_state = 70, .external_lex_state = 2},
  [1763] = {.lex_state = 70, .external_lex_state = 2},
  [1764] = {.lex_state = 71, .external_lex_state = 4},
  [1765] = {.lex_state = 70, .external_lex_state = 2},
  [1766] = {.lex_state = 70, .external_lex_state = 3},
  [1767] = {.lex_state = 70, .external_lex_state = 3},
  [1768] = {.lex_state = 70, .external_lex_state = 2},
  [1769] = {.lex_state = 70, .external_lex_state = 3},
  [1770] = {.lex_state = 70, .external_lex_state = 3},
  [1771] = {.lex_state = 70, .external_lex_state = 2},
  [1772] = {.lex_state = 70, .external_lex_state = 2},
  [1773] = {.lex_state = 70, .external_lex_state = 3},
  [1774] = {.lex_state = 70, .external_lex_state = 3},
  [1775] = {.lex_state = 70, .external_lex_state = 3},
  [1776] = {.lex_state = 70, .external_lex_state = 3},
  [1777] = {.lex_state = 70, .external_lex_state = 2},
  [1778] = {.lex_state = 70, .external_lex_state = 2},
  [1779] = {.lex_state = 70, .external_lex_state = 3},
  [1780] = {.lex_state = 70, .external_lex_state = 3},
  [1781] = {.lex_state = 70, .external_lex_state = 3},
  [1782] = {.lex_state = 70, .external_lex_state = 2},
  [1783] = {.lex_state = 70, .external_lex_state = 3},
  [1784] = {.lex_state = 70, .external_lex_state = 2},
  [1785] = {.lex_state = 70, .external_lex_state = 2},
  [1786] = {.lex_state = 4, .external_lex_state = 3},
  [1787] = {.lex_state = 70, .external_lex_state = 3},
  [1788] = {.lex_state = 70, .external_lex_state = 2},
  [1789] = {.lex_state = 70, .external_lex_state = 2},
  [1790] = {.lex_state = 70, .external_lex_state = 2},
  [1791] = {.lex_state = 70, .external_lex_state = 3},
  [1792] = {.lex_state = 70, .external_lex_state = 3},
  [1793] = {.lex_state = 70, .external_lex_state = 2},
  [1794] = {.lex_state = 70, .external_lex_state = 2},
  [1795] = {.lex_state = 70, .external_lex_state = 3},
  [1796] = {.lex_state = 70, .external_lex_state = 3},
  [1797] = {.lex_state = 70, .external_lex_state = 3},
  [1798] = {.lex_state = 70, .external_lex_state = 3},
  [1799] = {.lex_state = 70, .external_lex_state = 3},
  [1800] = {.lex_state = 70, .external_lex_state = 2},
  [1801] = {.lex_state = 70, .external_lex_state = 2},
  [1802] = {.lex_state = 70, .external_lex_state = 2},
  [1803] = {.lex_state = 70, .external_lex_state = 3},
  [1804] = {.lex_state = 70, .external_lex_state = 3},
  [1805] = {.lex_state = 70, .external_lex_state = 3},
  [1806] = {.lex_state = 70, .external_lex_state = 2},
  [1807] = {.lex_state = 70, .external_lex_state = 2},
  [1808] = {.lex_state = 70, .external_lex_state = 3},
  [1809] = {.lex_state = 70, .external_lex_state = 3},
  [1810] = {.lex_state = 70, .external_lex_state = 2},
  [1811] = {.lex_state = 70, .external_lex_state = 3},
  [1812] = {.lex_state = 70, .external_lex_state = 2},
  [1813] = {.lex_state = 70, .external_lex_state = 3},
  [1814] = {.lex_state = 70, .external_lex_state = 3},
  [1815] = {.lex_state = 70, .external_lex_state = 3},
  [1816] = {.lex_state = 70, .external_lex_state = 3},
  [1817] = {.lex_state = 70, .external_lex_state = 3},
  [1818] = {.lex_state = 70, .external_lex_state = 3},
  [1819] = {.lex_state = 70, .external_lex_state = 3},
  [1820] = {.lex_state = 70, .external_lex_state = 3},
  [1821] = {.lex_state = 70, .external_lex_state = 3},
  [1822] = {.lex_state = 70, .external_lex_state = 3},
  [1823] = {.lex_state = 70, .external_lex_state = 3},
  [1824] = {.lex_state = 70, .external_lex_state = 2},
  [1825] = {.lex_state = 70, .external_lex_state = 2},
  [1826] = {.lex_state = 70, .external_lex_state = 2},
  [1827] = {.lex_state = 70, .external_lex_state = 3},
  [1828] = {.lex_state = 70, .external_lex_state = 2},
  [1829] = {.lex_state = 70, .external_lex_state = 3},
  [1830] = {.lex_state = 70, .external_lex_state = 2},
  [1831] = {.lex_state = 70, .external_lex_state = 3},
  [1832] = {.lex_state = 70, .external_lex_state = 3},
  [1833] = {.lex_state = 70, .external_lex_state = 2},
  [1834] = {.lex_state = 70, .external_lex_state = 3},
  [1835] = {.lex_state = 70, .external_lex_state = 2},
  [1836] = {.lex_state = 70, .external_lex_state = 3},
  [1837] = {.lex_state = 70, .external_lex_state = 3},
  [1838] = {.lex_state = 70, .external_lex_state = 3},
  [1839] = {.lex_state = 70, .external_lex_state = 3},
  [1840] = {.lex_state = 70, .external_lex_state = 3},
  [1841] = {.lex_state = 70, .external_lex_state = 2},
  [1842] = {.lex_state = 70, .external_lex_state = 2},
  [1843] = {.lex_state = 70, .external_lex_state = 3},
  [1844] = {.lex_state = 70, .external_lex_state = 2},
  [1845] = {.lex_state = 70, .external_lex_state = 2},
  [1846] = {.lex_state = 70, .external_lex_state = 3},
  [1847] = {.lex_state = 70, .external_lex_state = 3},
  [1848] = {.lex_state = 70, .external_lex_state = 3},
  [1849] = {.lex_state = 71, .external_lex_state = 4},
  [1850] = {.lex_state = 70, .external_lex_state = 3},
  [1851] = {.lex_state = 70, .external_lex_state = 3},
  [1852] = {.lex_state = 70, .external_lex_state = 2},
  [1853] = {.lex_state = 70, .external_lex_state = 3},
  [1854] = {.lex_state = 70, .external_lex_state = 2},
  [1855] = {.lex_state = 70, .external_lex_state = 3},
  [1856] = {.lex_state = 70, .external_lex_state = 2},
  [1857] = {.lex_state = 70, .external_lex_state = 2},
  [1858] = {.lex_state = 71, .external_lex_state = 4},
  [1859] = {.lex_state = 70, .external_lex_state = 2},
  [1860] = {.lex_state = 70, .external_lex_state = 2},
  [1861] = {.lex_state = 70, .external_lex_state = 3},
  [1862] = {.lex_state = 70, .external_lex_state = 2},
  [1863] = {.lex_state = 70, .external_lex_state = 3},
  [1864] = {.lex_state = 70, .external_lex_state = 3},
  [1865] = {.lex_state = 70, .external_lex_state = 2},
  [1866] = {.lex_state = 70, .external_lex_state = 3},
  [1867] = {.lex_state = 70, .external_lex_state = 2},
  [1868] = {.lex_state = 70, .external_lex_state = 2},
  [1869] = {.lex_state = 70, .external_lex_state = 3},
  [1870] = {.lex_state = 70, .external_lex_state = 3},
  [1871] = {.lex_state = 70, .external_lex_state = 3},
  [1872] = {.lex_state = 70, .external_lex_state = 3},
  [1873] = {.lex_state = 70, .external_lex_state = 2},
  [1874] = {.lex_state = 71, .external_lex_state = 4},
  [1875] = {.lex_state = 70, .external_lex_state = 2},
  [1876] = {.lex_state = 70, .external_lex_state = 3},
  [1877] = {.lex_state = 70, .external_lex_state = 3},
  [1878] = {.lex_state = 70, .external_lex_state = 3},
  [1879] = {.lex_state = 70, .external_lex_state = 2},
  [1880] = {.lex_state = 70, .external_lex_state = 3},
  [1881] = {.lex_state = 70, .external_lex_state = 3},
  [1882] = {.lex_state = 70, .external_lex_state = 2},
  [1883] = {.lex_state = 70, .external_lex_state = 3},
  [1884] = {.lex_state = 70, .external_lex_state = 2},
  [1885] = {.lex_state = 70, .external_lex_state = 2},
  [1886] = {.lex_state = 70, .external_lex_state = 3},
  [1887] = {.lex_state = 70, .external_lex_state = 3},
  [1888] = {.lex_state = 70, .external_lex_state = 2},
  [1889] = {.lex_state = 70, .external_lex_state = 2},
  [1890] = {.lex_state = 70, .external_lex_state = 2},
  [1891] = {.lex_state = 70, .external_lex_state = 2},
  [1892] = {.lex_state = 70, .external_lex_state = 2},
  [1893] = {.lex_state = 70, .external_lex_state = 2},
  [1894] = {.lex_state = 70, .external_lex_state = 2},
  [1895] = {.lex_state = 70, .external_lex_state = 2},
  [1896] = {.lex_state = 70, .external_lex_state = 2},
  [1897] = {.lex_state = 70, .external_lex_state = 2},
  [1898] = {.lex_state = 70, .external_lex_state = 2},
  [1899] = {.lex_state = 70, .external_lex_state = 2},
  [1900] = {.lex_state = 70, .external_lex_state = 2},
  [1901] = {.lex_state = 70, .external_lex_state = 2},
  [1902] = {.lex_state = 71, .external_lex_state = 4},
  [1903] = {.lex_state = 71, .external_lex_state = 4},
  [1904] = {.lex_state = 70, .external_lex_state = 2},
  [1905] = {.lex_state = 71, .external_lex_state = 4},
  [1906] = {.lex_state = 71},
  [1907] = {.lex_state = 71},
  [1908] = {.lex_state = 71, .external_lex_state = 4},
  [1909] = {.lex_state = 70, .external_lex_state = 2},
  [1910] = {.lex_state = 70, .external_lex_state = 2},
  [1911] = {.lex_state = 70, .external_lex_state = 2},
  [1912] = {.lex_state = 4, .external_lex_state = 2},
  [1913] = {.lex_state = 70, .external_lex_state = 2},
  [1914] = {.lex_state = 70, .external_lex_state = 2},
  [1915] = {.lex_state = 70, .external_lex_state = 2},
  [1916] = {.lex_state = 70, .external_lex_state = 2},
  [1917] = {.lex_state = 70, .external_lex_state = 2},
  [1918] = {.lex_state = 71, .external_lex_state = 4},
  [1919] = {.lex_state = 71, .external_lex_state = 4},
  [1920] = {.lex_state = 70, .external_lex_state = 2},
  [1921] = {.lex_state = 70, .external_lex_state = 2},
  [1922] = {.lex_state = 70, .external_lex_state = 2},
  [1923] = {.lex_state = 70, .external_lex_state = 2},
  [1924] = {.lex_state = 71, .external_lex_state = 4},
  [1925] = {.lex_state = 71},
  [1926] = {.lex_state = 71},
  [1927] = {.lex_state = 71},
  [1928] = {.lex_state = 71},
  [1929] = {.lex_state = 70, .external_lex_state = 2},
  [1930] = {.lex_state = 70, .external_lex_state = 3},
  [1931] = {.lex_state = 71},
  [1932] = {.lex_state = 70, .external_lex_state = 2},
  [1933] = {.lex_state = 70, .external_lex_state = 2},
  [1934] = {.lex_state = 70, .external_lex_state = 3},
  [1935] = {.lex_state = 70, .external_lex_state = 2},
  [1936] = {.lex_state = 70, .external_lex_state = 3},
  [1937] = {.lex_state = 70, .external_lex_state = 2},
  [1938] = {.lex_state = 70, .external_lex_state = 2},
  [1939] = {.lex_state = 70, .external_lex_state = 2},
  [1940] = {.lex_state = 71},
  [1941] = {.lex_state = 70, .external_lex_state = 2},
  [1942] = {.lex_state = 70, .external_lex_state = 2},
  [1943] = {.lex_state = 70, .external_lex_state = 2},
  [1944] = {.lex_state = 70, .external_lex_state = 2},
  [1945] = {.lex_state = 70, .external_lex_state = 2},
  [1946] = {.lex_state = 70, .external_lex_state = 2},
  [1947] = {.lex_state = 70, .external_lex_state = 2},
  [1948] = {.lex_state = 70, .external_lex_state = 2},
  [1949] = {.lex_state = 71, .external_lex_state = 4},
  [1950] = {.lex_state = 71},
  [1951] = {.lex_state = 71, .external_lex_state = 4},
  [1952] = {.lex_state = 70, .external_lex_state = 2},
  [1953] = {.lex_state = 70, .external_lex_state = 2},
  [1954] = {.lex_state = 70, .external_lex_state = 2},
  [1955] = {.lex_state = 70, .external_lex_state = 2},
  [1956] = {.lex_state = 70, .external_lex_state = 2},
  [1957] = {.lex_state = 70, .external_lex_state = 2},
  [1958] = {.lex_state = 71, .external_lex_state = 4},
  [1959] = {.lex_state = 70, .external_lex_state = 2},
  [1960] = {.lex_state = 71, .external_lex_state = 4},
  [1961] = {.lex_state = 71, .external_lex_state = 4},
  [1962] = {.lex_state = 71, .external_lex_state = 4},
  [1963] = {.lex_state = 71},
  [1964] = {.lex_state = 70, .external_lex_state = 2},
  [1965] = {.lex_state = 71, .external_lex_state = 4},
  [1966] = {.lex_state = 71, .external_lex_state = 4},
  [1967] = {.lex_state = 71, .external_lex_state = 4},
  [1968] = {.lex_state = 71},
  [1969] = {.lex_state = 71, .external_lex_state = 4},
  [1970] = {.lex_state = 70, .external_lex_state = 2},
  [1971] = {.lex_state = 71},
  [1972] = {.lex_state = 70, .external_lex_state = 3},
  [1973] = {.lex_state = 70, .external_lex_state = 3},
  [1974] = {.lex_state = 71},
  [1975] = {.lex_state = 71, .external_lex_state = 4},
  [1976] = {.lex_state = 71, .external_lex_state = 4},
  [1977] = {.lex_state = 71, .external_lex_state = 4},
  [1978] = {.lex_state = 71, .external_lex_state = 4},
  [1979] = {.lex_state = 71, .external_lex_state = 4},
  [1980] = {.lex_state = 71},
  [1981] = {.lex_state = 71, .external_lex_state = 4},
  [1982] = {.lex_state = 71, .external_lex_state = 4},
  [1983] = {.lex_state = 71},
  [1984] = {.lex_state = 71, .external_lex_state = 4},
  [1985] = {.lex_state = 70, .external_lex_state = 2},
  [1986] = {.lex_state = 70, .external_lex_state = 2},
  [1987] = {.lex_state = 71, .external_lex_state = 4},
  [1988] = {.lex_state = 71, .external_lex_state = 4},
  [1989] = {.lex_state = 71},
  [1990] = {.lex_state = 70, .external_lex_state = 2},
  [1991] = {.lex_state = 70, .external_lex_state = 2},
  [1992] = {.lex_state = 70, .external_lex_state = 2},
  [1993] = {.lex_state = 70, .external_lex_state = 2},
  [1994] = {.lex_state = 70, .external_lex_state = 2},
  [1995] = {.lex_state = 70, .external_lex_state = 2},
  [1996] = {.lex_state = 70, .external_lex_state = 2},
  [1997] = {.lex_state = 71},
  [1998] = {.lex_state = 71},
  [1999] = {.lex_state = 71, .external_lex_state = 4},
  [2000] = {.lex_state = 71, .external_lex_state = 4},
  [2001] = {.lex_state = 71, .external_lex_state = 4},
  [2002] = {.lex_state = 70, .external_lex_state = 2},
  [2003] = {.lex_state = 70, .external_lex_state = 2},
  [2004] = {.lex_state = 71},
  [2005] = {.lex_state = 71, .external_lex_state = 4},
  [2006] = {.lex_state = 70, .external_lex_state = 2},
  [2007] = {.lex_state = 70, .external_lex_state = 2},
  [2008] = {.lex_state = 70, .external_lex_state = 2},
  [2009] = {.lex_state = 70, .external_lex_state = 2},
  [2010] = {.lex_state = 71, .external_lex_state = 4},
  [2011] = {.lex_state = 71, .external_lex_state = 4},
  [2012] = {.lex_state = 70, .external_lex_state = 2},
  [2013] = {.lex_state = 70, .external_lex_state = 2},
  [2014] = {.lex_state = 71, .external_lex_state = 4},
  [2015] = {.lex_state = 71, .external_lex_state = 4},
  [2016] = {.lex_state = 71, .external_lex_state = 4},
  [2017] = {.lex_state = 71, .external_lex_state = 4},
  [2018] = {.lex_state = 71, .external_lex_state = 4},
  [2019] = {.lex_state = 71, .external_lex_state = 4},
  [2020] = {.lex_state = 71, .external_lex_state = 4},
  [2021] = {.lex_state = 70, .external_lex_state = 2},
  [2022] = {.lex_state = 70, .external_lex_state = 2},
  [2023] = {.lex_state = 71, .external_lex_state = 4},
  [2024] = {.lex_state = 70, .external_lex_state = 2},
  [2025] = {.lex_state = 70, .external_lex_state = 2},
  [2026] = {.lex_state = 70, .external_lex_state = 2},
  [2027] = {.lex_state = 70, .external_lex_state = 2},
  [2028] = {.lex_state = 71, .external_lex_state = 4},
  [2029] = {.lex_state = 71, .external_lex_state = 4},
  [2030] = {.lex_state = 70, .external_lex_state = 2},
  [2031] = {.lex_state = 70, .external_lex_state = 2},
  [2032] = {.lex_state = 70, .external_lex_state = 2},
  [2033] = {.lex_state = 71},
  [2034] = {.lex_state = 70, .external_lex_state = 2},
  [2035] = {.lex_state = 70, .external_lex_state = 2},
  [2036] = {.lex_state = 70, .external_lex_state = 2},
  [2037] = {.lex_state = 70, .external_lex_state = 2},
  [2038] = {.lex_state = 70, .external_lex_state = 2},
  [2039] = {.lex_state = 70, .external_lex_state = 2},
  [2040] = {.lex_state = 70, .external_lex_state = 2},
  [2041] = {.lex_state = 71},
  [2042] = {.lex_state = 70, .external_lex_state = 2},
  [2043] = {.lex_state = 70, .external_lex_state = 2},
  [2044] = {.lex_state = 70, .external_lex_state = 2},
  [2045] = {.lex_state = 71},
  [2046] = {.lex_state = 71},
  [2047] = {.lex_state = 70, .external_lex_state = 2},
  [2048] = {.lex_state = 70, .external_lex_state = 3},
  [2049] = {.lex_state = 70, .external_lex_state = 2},
  [2050] = {.lex_state = 70, .external_lex_state = 2},
  [2051] = {.lex_state = 71, .external_lex_state = 4},
  [2052] = {.lex_state = 70, .external_lex_state = 2},
  [2053] = {.lex_state = 70, .external_lex_state = 2},
  [2054] = {.lex_state = 71, .external_lex_state = 4},
  [2055] = {.lex_state = 71},
  [2056] = {.lex_state = 70, .external_lex_state = 2},
  [2057] = {.lex_state = 70, .external_lex_state = 2},
  [2058] = {.lex_state = 70, .external_lex_state = 2},
  [2059] = {.lex_state = 70, .external_lex_state = 2},
  [2060] = {.lex_state = 70, .external_lex_state = 2},
  [2061] = {.lex_state = 71, .external_lex_state = 4},
  [2062] = {.lex_state = 71, .external_lex_state = 4},
  [2063] = {.lex_state = 71},
  [2064] = {.lex_state = 71, .external_lex_state = 4},
  [2065] = {.lex_state = 71, .external_lex_state = 4},
  [2066] = {.lex_state = 71},
  [2067] = {.lex_state = 71, .external_lex_state = 4},
  [2068] = {.lex_state = 70, .external_lex_state = 2},
  [2069] = {.lex_state = 70, .external_lex_state = 2},
  [2070] = {.lex_state = 71, .external_lex_state = 4},
  [2071] = {.lex_state = 71, .external_lex_state = 4},
  [2072] = {.lex_state = 71},
  [2073] = {.lex_state = 71, .external_lex_state = 4},
  [2074] = {.lex_state = 71, .external_lex_state = 4},
  [2075] = {.lex_state = 70, .external_lex_state = 2},
  [2076] = {.lex_state = 71, .external_lex_state = 4},
  [2077] = {.lex_state = 70, .external_lex_state = 2},
  [2078] = {.lex_state = 71},
  [2079] = {.lex_state = 71, .external_lex_state = 4},
  [2080] = {.lex_state = 71, .external_lex_state = 4},
  [2081] = {.lex_state = 71, .external_lex_state = 4},
  [2082] = {.lex_state = 71, .external_lex_state = 4},
  [2083] = {.lex_state = 71, .external_lex_state = 4},
  [2084] = {.lex_state = 71},
  [2085] = {.lex_state = 71, .external_lex_state = 4},
  [2086] = {.lex_state = 71, .external_lex_state = 4},
  [2087] = {.lex_state = 71, .external_lex_state = 4},
  [2088] = {.lex_state = 71, .external_lex_state = 4},
  [2089] = {.lex_state = 71},
  [2090] = {.lex_state = 71},
  [2091] = {.lex_state = 71},
  [2092] = {.lex_state = 71},
  [2093] = {.lex_state = 70, .external_lex_state = 2},
  [2094] = {.lex_state = 4, .external_lex_state = 2},
  [2095] = {.lex_state = 71, .external_lex_state = 4},
  [2096] = {.lex_state = 71, .external_lex_state = 4},
  [2097] = {.lex_state = 71},
  [2098] = {.lex_state = 71, .external_lex_state = 4},
  [2099] = {.lex_state = 71, .external_lex_state = 4},
  [2100] = {.lex_state = 71, .external_lex_state = 4},
  [2101] = {.lex_state = 71},
  [2102] = {.lex_state = 71},
  [2103] = {.lex_state = 71, .external_lex_state = 4},
  [2104] = {.lex_state = 71},
  [2105] = {.lex_state = 71, .external_lex_state = 4},
  [2106] = {.lex_state = 71},
  [2107] = {.lex_state = 71},
  [2108] = {.lex_state = 71},
  [2109] = {.lex_state = 71},
  [2110] = {.lex_state = 71},
  [2111] = {.lex_state = 71},
  [2112] = {.lex_state = 71},
  [2113] = {.lex_state = 71},
  [2114] = {.lex_state = 71},
  [2115] = {.lex_state = 71},
  [2116] = {.lex_state = 71},
  [2117] = {.lex_state = 71},
  [2118] = {.lex_state = 71},
  [2119] = {.lex_state = 71},
  [2120] = {.lex_state = 71},
  [2121] = {.lex_state = 71},
  [2122] = {.lex_state = 71, .external_lex_state = 4},
  [2123] = {.lex_state = 71},
  [2124] = {.lex_state = 71},
  [2125] = {.lex_state = 71},
  [2126] = {.lex_state = 71},
  [2127] = {.lex_state = 71},
  [2128] = {.lex_state = 71},
  [2129] = {.lex_state = 9},
  [2130] = {.lex_state = 71},
  [2131] = {.lex_state = 71},
  [2132] = {.lex_state = 71},
  [2133] = {.lex_state = 71},
  [2134] = {.lex_state = 71},
  [2135] = {.lex_state = 9, .external_lex_state = 4},
  [2136] = {.lex_state = 9, .external_lex_state = 4},
  [2137] = {.lex_state = 9, .external_lex_state = 4},
  [2138] = {.lex_state = 9, .external_lex_state = 4},
  [2139] = {.lex_state = 9, .external_lex_state = 4},
  [2140] = {.lex_state = 9, .external_lex_state = 4},
  [2141] = {.lex_state = 9, .external_lex_state = 4},
  [2142] = {.lex_state = 71},
  [2143] = {.lex_state = 9, .external_lex_state = 4},
  [2144] = {.lex_state = 9, .external_lex_state = 4},
  [2145] = {.lex_state = 71},
  [2146] = {.lex_state = 9, .external_lex_state = 4},
  [2147] = {.lex_state = 9, .external_lex_state = 4},
  [2148] = {.lex_state = 9, .external_lex_state = 4},
  [2149] = {.lex_state = 9, .external_lex_state = 4},
  [2150] = {.lex_state = 71},
  [2151] = {.lex_state = 71},
  [2152] = {.lex_state = 71},
  [2153] = {.lex_state = 71},
  [2154] = {.lex_state = 9, .external_lex_state = 4},
  [2155] = {.lex_state = 71},
  [2156] = {.lex_state = 9, .external_lex_state = 4},
  [2157] = {.lex_state = 9, .external_lex_state = 4},
  [2158] = {.lex_state = 9, .external_lex_state = 4},
  [2159] = {.lex_state = 9, .external_lex_state = 4},
  [2160] = {.lex_state = 9, .external_lex_state = 4},
  [2161] = {.lex_state = 9, .external_lex_state = 4},
  [2162] = {.lex_state = 9, .external_lex_state = 4},
  [2163] = {.lex_state = 71},
  [2164] = {.lex_state = 9, .external_lex_state = 4},
  [2165] = {.lex_state = 9, .external_lex_state = 4},
  [2166] = {.lex_state = 9},
  [2167] = {.lex_state = 9, .external_lex_state = 4},
  [2168] = {.lex_state = 9, .external_lex_state = 4},
  [2169] = {.lex_state = 9, .external_lex_state = 4},
  [2170] = {.lex_state = 9, .external_lex_state = 4},
  [2171] = {.lex_state = 71},
  [2172] = {.lex_state = 71},
  [2173] = {.lex_state = 71},
  [2174] = {.lex_state = 71},
  [2175] = {.lex_state = 71},
  [2176] = {.lex_state = 71},
  [2177] = {.lex_state = 71},
  [2178] = {.lex_state = 71},
  [2179] = {.lex_state = 71},
  [2180] = {.lex_state = 71},
  [2181] = {.lex_state = 71},
  [2182] = {.lex_state = 71},
  [2183] = {.lex_state = 71},
  [2184] = {.lex_state = 71},
  [2185] = {.lex_state = 71},
  [2186] = {.lex_state = 71},
  [2187] = {.lex_state = 71},
  [2188] = {.lex_state = 71},
  [2189] = {.lex_state = 71},
  [2190] = {.lex_state = 71},
  [2191] = {.lex_state = 71},
  [2192] = {.lex_state = 9},
  [2193] = {.lex_state = 71},
  [2194] = {.lex_state = 71},
  [2195] = {.lex_state = 71},
  [2196] = {.lex_state = 71},
  [2197] = {.lex_state = 71},
  [2198] = {.lex_state = 9},
  [2199] = {.lex_state = 71},
  [2200] = {.lex_state = 71},
  [2201] = {.lex_state = 9},
  [2202] = {.lex_state = 71},
  [2203] = {.lex_state = 9},
  [2204] = {.lex_state = 9},
  [2205] = {.lex_state = 71},
  [2206] = {.lex_state = 71},
  [2207] = {.lex_state = 71},
  [2208] = {.lex_state = 71},
  [2209] = {.lex_state = 71},
  [2210] = {.lex_state = 71},
  [2211] = {.lex_state = 9},
  [2212] = {.lex_state = 71},
  [2213] = {.lex_state = 71},
  [2214] = {.lex_state = 71},
  [2215] = {.lex_state = 71},
  [2216] = {.lex_state = 71},
  [2217] = {.lex_state = 71},
  [2218] = {.lex_state = 71},
  [2219] = {.lex_state = 71},
  [2220] = {.lex_state = 71},
  [2221] = {.lex_state = 71},
  [2222] = {.lex_state = 71},
  [2223] = {.lex_state = 71},
  [2224] = {.lex_state = 71},
  [2225] = {.lex_state = 71},
  [2226] = {.lex_state = 71},
  [2227] = {.lex_state = 71},
  [2228] = {.lex_state = 71},
  [2229] = {.lex_state = 71},
  [2230] = {.lex_state = 71},
  [2231] = {.lex_state = 71},
  [2232] = {.lex_state = 71},
  [2233] = {.lex_state = 71},
  [2234] = {.lex_state = 71},
  [2235] = {.lex_state = 71},
  [2236] = {.lex_state = 71},
  [2237] = {.lex_state = 71},
  [2238] = {.lex_state = 71},
  [2239] = {.lex_state = 71},
  [2240] = {.lex_state = 71},
  [2241] = {.lex_state = 71},
  [2242] = {.lex_state = 71},
  [2243] = {.lex_state = 71},
  [2244] = {.lex_state = 71},
  [2245] = {.lex_state = 71},
  [2246] = {.lex_state = 71},
  [2247] = {.lex_state = 71},
  [2248] = {.lex_state = 71},
  [2249] = {.lex_state = 71},
  [2250] = {.lex_state = 71},
  [2251] = {.lex_state = 71},
  [2252] = {.lex_state = 71},
  [2253] = {.lex_state = 71},
  [2254] = {.lex_state = 71},
  [2255] = {.lex_state = 71},
  [2256] = {.lex_state = 71},
  [2257] = {.lex_state = 71},
  [2258] = {.lex_state = 71},
  [2259] = {.lex_state = 71},
  [2260] = {.lex_state = 71},
  [2261] = {.lex_state = 8},
  [2262] = {.lex_state = 8},
  [2263] = {.lex_state = 8},
  [2264] = {.lex_state = 8},
  [2265] = {.lex_state = 8},
  [2266] = {.lex_state = 8},
  [2267] = {.lex_state = 8},
  [2268] = {.lex_state = 8},
  [2269] = {.lex_state = 8},
  [2270] = {.lex_state = 8},
  [2271] = {.lex_state = 8},
  [2272] = {.lex_state = 8},
  [2273] = {.lex_state = 8},
  [2274] = {.lex_state = 8},
  [2275] = {.lex_state = 8},
  [2276] = {.lex_state = 8},
  [2277] = {.lex_state = 8},
  [2278] = {.lex_state = 8},
  [2279] = {.lex_state = 8},
  [2280] = {.lex_state = 8},
  [2281] = {.lex_state = 8},
  [2282] = {.lex_state = 8},
  [2283] = {.lex_state = 8},
  [2284] = {.lex_state = 8},
  [2285] = {.lex_state = 8},
  [2286] = {.lex_state = 8},
  [2287] = {.lex_state = 8},
  [2288] = {.lex_state = 8},
  [2289] = {.lex_state = 8},
  [2290] = {.lex_state = 8},
  [2291] = {.lex_state = 8},
  [2292] = {.lex_state = 8},
  [2293] = {.lex_state = 8},
  [2294] = {.lex_state = 8},
  [2295] = {.lex_state = 71},
  [2296] = {.lex_state = 8},
  [2297] = {.lex_state = 8},
  [2298] = {.lex_state = 8},
  [2299] = {.lex_state = 8},
  [2300] = {.lex_state = 71},
  [2301] = {.lex_state = 8},
  [2302] = {.lex_state = 8},
  [2303] = {.lex_state = 8},
  [2304] = {.lex_state = 71},
  [2305] = {.lex_state = 71, .external_lex_state = 4},
  [2306] = {.lex_state = 71},
  [2307] = {.lex_state = 71, .external_lex_state = 4},
  [2308] = {.lex_state = 71},
  [2309] = {.lex_state = 71},
  [2310] = {.lex_state = 71},
  [2311] = {.lex_state = 71},
  [2312] = {.lex_state = 71},
  [2313] = {.lex_state = 2},
  [2314] = {.lex_state = 2},
  [2315] = {.lex_state = 71},
  [2316] = {.lex_state = 71},
  [2317] = {.lex_state = 71},
  [2318] = {.lex_state = 71},
  [2319] = {.lex_state = 71},
  [2320] = {.lex_state = 71},
  [2321] = {.lex_state = 71},
  [2322] = {.lex_state = 71},
  [2323] = {.lex_state = 71},
  [2324] = {.lex_state = 8, .external_lex_state = 4},
  [2325] = {.lex_state = 71},
  [2326] = {.lex_state = 71},
  [2327] = {.lex_state = 71},
  [2328] = {.lex_state = 71},
  [2329] = {.lex_state = 2},
  [2330] = {.lex_state = 8, .external_lex_state = 4},
  [2331] = {.lex_state = 71},
  [2332] = {.lex_state = 8, .external_lex_state = 4},
  [2333] = {.lex_state = 71},
  [2334] = {.lex_state = 71},
  [2335] = {.lex_state = 71, .external_lex_state = 4},
  [2336] = {.lex_state = 71},
  [2337] = {.lex_state = 2},
  [2338] = {.lex_state = 71},
  [2339] = {.lex_state = 2},
  [2340] = {.lex_state = 71},
  [2341] = {.lex_state = 71},
  [2342] = {.lex_state = 71},
  [2343] = {.lex_state = 2},
  [2344] = {.lex_state = 2},
  [2345] = {.lex_state = 71},
  [2346] = {.lex_state = 71},
  [2347] = {.lex_state = 2},
  [2348] = {.lex_state = 71},
  [2349] = {.lex_state = 8, .external_lex_state = 4},
  [2350] = {.lex_state = 71},
  [2351] = {.lex_state = 8, .external_lex_state = 4},
  [2352] = {.lex_state = 8, .external_lex_state = 4},
  [2353] = {.lex_state = 8, .external_lex_state = 4},
  [2354] = {.lex_state = 8, .external_lex_state = 4},
  [2355] = {.lex_state = 71},
  [2356] = {.lex_state = 71},
  [2357] = {.lex_state = 71},
  [2358] = {.lex_state = 71},
  [2359] = {.lex_state = 71},
  [2360] = {.lex_state = 8, .external_lex_state = 4},
  [2361] = {.lex_state = 8, .external_lex_state = 4},
  [2362] = {.lex_state = 8, .external_lex_state = 4},
  [2363] = {.lex_state = 8, .external_lex_state = 4},
  [2364] = {.lex_state = 8, .external_lex_state = 4},
  [2365] = {.lex_state = 8, .external_lex_state = 4},
  [2366] = {.lex_state = 8, .external_lex_state = 4},
  [2367] = {.lex_state = 8, .external_lex_state = 4},
  [2368] = {.lex_state = 8, .external_lex_state = 4},
  [2369] = {.lex_state = 8, .external_lex_state = 4},
  [2370] = {.lex_state = 71},
  [2371] = {.lex_state = 71},
  [2372] = {.lex_state = 71, .external_lex_state = 4},
  [2373] = {.lex_state = 71},
  [2374] = {.lex_state = 71},
  [2375] = {.lex_state = 71},
  [2376] = {.lex_state = 71},
  [2377] = {.lex_state = 71},
  [2378] = {.lex_state = 71},
  [2379] = {.lex_state = 71},
  [2380] = {.lex_state = 71},
  [2381] = {.lex_state = 8, .external_lex_state = 4},
  [2382] = {.lex_state = 8, .external_lex_state = 4},
  [2383] = {.lex_state = 8, .external_lex_state = 4},
  [2384] = {.lex_state = 8, .external_lex_state = 4},
  [2385] = {.lex_state = 8, .external_lex_state = 4},
  [2386] = {.lex_state = 8, .external_lex_state = 4},
  [2387] = {.lex_state = 8, .external_lex_state = 4},
  [2388] = {.lex_state = 71},
  [2389] = {.lex_state = 71},
  [2390] = {.lex_state = 71},
  [2391] = {.lex_state = 8, .external_lex_state = 4},
  [2392] = {.lex_state = 8, .external_lex_state = 4},
  [2393] = {.lex_state = 8, .external_lex_state = 4},
  [2394] = {.lex_state = 8, .external_lex_state = 4},
  [2395] = {.lex_state = 8, .external_lex_state = 4},
  [2396] = {.lex_state = 71},
  [2397] = {.lex_state = 8, .external_lex_state = 4},
  [2398] = {.lex_state = 8, .external_lex_state = 4},
  [2399] = {.lex_state = 8, .external_lex_state = 4},
  [2400] = {.lex_state = 8, .external_lex_state = 4},
  [2401] = {.lex_state = 8, .external_lex_state = 4},
  [2402] = {.lex_state = 8, .external_lex_state = 4},
  [2403] = {.lex_state = 71},
  [2404] = {.lex_state = 71},
  [2405] = {.lex_state = 71},
  [2406] = {.lex_state = 71},
  [2407] = {.lex_state = 71, .external_lex_state = 4},
  [2408] = {.lex_state = 71},
  [2409] = {.lex_state = 71},
  [2410] = {.lex_state = 71},
  [2411] = {.lex_state = 71},
  [2412] = {.lex_state = 71},
  [2413] = {.lex_state = 71, .external_lex_state = 4},
  [2414] = {.lex_state = 71},
  [2415] = {.lex_state = 71},
  [2416] = {.lex_state = 71, .external_lex_state = 4},
  [2417] = {.lex_state = 71},
  [2418] = {.lex_state = 71},
  [2419] = {.lex_state = 71},
  [2420] = {.lex_state = 71, .external_lex_state = 4},
  [2421] = {.lex_state = 71},
  [2422] = {.lex_state = 71},
  [2423] = {.lex_state = 71},
  [2424] = {.lex_state = 71},
  [2425] = {.lex_state = 71},
  [2426] = {.lex_state = 71, .external_lex_state = 4},
  [2427] = {.lex_state = 71},
  [2428] = {.lex_state = 71},
  [2429] = {.lex_state = 8, .external_lex_state = 4},
  [2430] = {.lex_state = 71},
  [2431] = {.lex_state = 71},
  [2432] = {.lex_state = 71},
  [2433] = {.lex_state = 71},
  [2434] = {.lex_state = 71},
  [2435] = {.lex_state = 71},
  [2436] = {.lex_state = 71, .external_lex_state = 4},
  [2437] = {.lex_state = 71, .external_lex_state = 4},
  [2438] = {.lex_state = 8, .external_lex_state = 4},
  [2439] = {.lex_state = 71, .external_lex_state = 4},
  [2440] = {.lex_state = 8, .external_lex_state = 5},
  [2441] = {.lex_state = 8, .external_lex_state = 4},
  [2442] = {.lex_state = 8, .external_lex_state = 5},
  [2443] = {.lex_state = 71, .external_lex_state = 5},
  [2444] = {.lex_state = 8, .external_lex_state = 5},
  [2445] = {.lex_state = 71, .external_lex_state = 4},
  [2446] = {.lex_state = 71, .external_lex_state = 4},
  [2447] = {.lex_state = 71, .external_lex_state = 4},
  [2448] = {.lex_state = 71, .external_lex_state = 4},
  [2449] = {.lex_state = 8, .external_lex_state = 4},
  [2450] = {.lex_state = 8, .external_lex_state = 4},
  [2451] = {.lex_state = 71, .external_lex_state = 4},
  [2452] = {.lex_state = 71, .external_lex_state = 4},
  [2453] = {.lex_state = 71, .external_lex_state = 4},
  [2454] = {.lex_state = 71, .external_lex_state = 4},
  [2455] = {.lex_state = 8, .external_lex_state = 4},
  [2456] = {.lex_state = 8, .external_lex_state = 4},
  [2457] = {.lex_state = 71, .external_lex_state = 4},
  [2458] = {.lex_state = 71, .external_lex_state = 4},
  [2459] = {.lex_state = 71},
  [2460] = {.lex_state = 8, .external_lex_state = 4},
  [2461] = {.lex_state = 71, .external_lex_state = 4},
  [2462] = {.lex_state = 71, .external_lex_state = 4},
  [2463] = {.lex_state = 8, .external_lex_state = 5},
  [2464] = {.lex_state = 8, .external_lex_state = 5},
  [2465] = {.lex_state = 8, .external_lex_state = 5},
  [2466] = {.lex_state = 8, .external_lex_state = 5},
  [2467] = {.lex_state = 8, .external_lex_state = 5},
  [2468] = {.lex_state = 8, .external_lex_state = 5},
  [2469] = {.lex_state = 8, .external_lex_state = 5},
  [2470] = {.lex_state = 8, .external_lex_state = 5},
  [2471] = {.lex_state = 8, .external_lex_state = 5},
  [2472] = {.lex_state = 8, .external_lex_state = 5},
  [2473] = {.lex_state = 8, .external_lex_state = 5},
  [2474] = {.lex_state = 8, .external_lex_state = 5},
  [2475] = {.lex_state = 8, .external_lex_state = 5},
  [2476] = {.lex_state = 8, .external_lex_state = 5},
  [2477] = {.lex_state = 71, .external_lex_state = 4},
  [2478] = {.lex_state = 71, .external_lex_state = 4},
  [2479] = {.lex_state = 71, .external_lex_state = 4},
  [2480] = {.lex_state = 71, .external_lex_state = 4},
  [2481] = {.lex_state = 71, .external_lex_state = 4},
  [2482] = {.lex_state = 71, .external_lex_state = 4},
  [2483] = {.lex_state = 71, .external_lex_state = 4},
  [2484] = {.lex_state = 8, .external_lex_state = 5},
  [2485] = {.lex_state = 8, .external_lex_state = 5},
  [2486] = {.lex_state = 8, .external_lex_state = 5},
  [2487] = {.lex_state = 8, .external_lex_state = 5},
  [2488] = {.lex_state = 8, .external_lex_state = 5},
  [2489] = {.lex_state = 8, .external_lex_state = 5},
  [2490] = {.lex_state = 8, .external_lex_state = 5},
  [2491] = {.lex_state = 8, .external_lex_state = 5},
  [2492] = {.lex_state = 71, .external_lex_state = 4},
  [2493] = {.lex_state = 8, .external_lex_state = 5},
  [2494] = {.lex_state = 8, .external_lex_state = 5},
  [2495] = {.lex_state = 8, .external_lex_state = 5},
  [2496] = {.lex_state = 8, .external_lex_state = 5},
  [2497] = {.lex_state = 8, .external_lex_state = 5},
  [2498] = {.lex_state = 71, .external_lex_state = 4},
  [2499] = {.lex_state = 8, .external_lex_state = 5},
  [2500] = {.lex_state = 8, .external_lex_state = 5},
  [2501] = {.lex_state = 8, .external_lex_state = 5},
  [2502] = {.lex_state = 71, .external_lex_state = 4},
  [2503] = {.lex_state = 71, .external_lex_state = 4},
  [2504] = {.lex_state = 8, .external_lex_state = 5},
  [2505] = {.lex_state = 8, .external_lex_state = 5},
  [2506] = {.lex_state = 71},
  [2507] = {.lex_state = 71, .external_lex_state = 4},
  [2508] = {.lex_state = 71, .external_lex_state = 4},
  [2509] = {.lex_state = 8, .external_lex_state = 5},
  [2510] = {.lex_state = 8, .external_lex_state = 5},
  [2511] = {.lex_state = 71, .external_lex_state = 4},
  [2512] = {.lex_state = 71, .external_lex_state = 4},
  [2513] = {.lex_state = 71, .external_lex_state = 4},
  [2514] = {.lex_state = 71, .external_lex_state = 4},
  [2515] = {.lex_state = 71, .external_lex_state = 5},
  [2516] = {.lex_state = 71, .external_lex_state = 4},
  [2517] = {.lex_state = 71, .external_lex_state = 4},
  [2518] = {.lex_state = 71, .external_lex_state = 4},
  [2519] = {.lex_state = 71, .external_lex_state = 4},
  [2520] = {.lex_state = 71, .external_lex_state = 4},
  [2521] = {.lex_state = 8, .external_lex_state = 5},
  [2522] = {.lex_state = 71, .external_lex_state = 4},
  [2523] = {.lex_state = 8, .external_lex_state = 5},
  [2524] = {.lex_state = 71, .external_lex_state = 4},
  [2525] = {.lex_state = 71, .external_lex_state = 4},
  [2526] = {.lex_state = 71, .external_lex_state = 4},
  [2527] = {.lex_state = 71, .external_lex_state = 5},
  [2528] = {.lex_state = 71, .external_lex_state = 4},
  [2529] = {.lex_state = 71, .external_lex_state = 4},
  [2530] = {.lex_state = 71, .external_lex_state = 4},
  [2531] = {.lex_state = 71, .external_lex_state = 5},
  [2532] = {.lex_state = 71, .external_lex_state = 4},
  [2533] = {.lex_state = 71, .external_lex_state = 4},
  [2534] = {.lex_state = 71, .external_lex_state = 4},
  [2535] = {.lex_state = 71, .external_lex_state = 4},
  [2536] = {.lex_state = 71, .external_lex_state = 4},
  [2537] = {.lex_state = 71, .external_lex_state = 4},
  [2538] = {.lex_state = 71, .external_lex_state = 4},
  [2539] = {.lex_state = 71, .external_lex_state = 4},
  [2540] = {.lex_state = 71, .external_lex_state = 4},
  [2541] = {.lex_state = 71, .external_lex_state = 4},
  [2542] = {.lex_state = 71, .external_lex_state = 4},
  [2543] = {.lex_state = 71, .external_lex_state = 4},
  [2544] = {.lex_state = 8, .external_lex_state = 5},
  [2545] = {.lex_state = 71, .external_lex_state = 4},
  [2546] = {.lex_state = 8, .external_lex_state = 5},
  [2547] = {.lex_state = 71, .external_lex_state = 4},
  [2548] = {.lex_state = 71, .external_lex_state = 4},
  [2549] = {.lex_state = 71, .external_lex_state = 4},
  [2550] = {.lex_state = 71, .external_lex_state = 4},
  [2551] = {.lex_state = 8, .external_lex_state = 5},
  [2552] = {.lex_state = 71, .external_lex_state = 4},
  [2553] = {.lex_state = 71, .external_lex_state = 4},
  [2554] = {.lex_state = 71, .external_lex_state = 4},
  [2555] = {.lex_state = 71, .external_lex_state = 4},
  [2556] = {.lex_state = 71, .external_lex_state = 4},
  [2557] = {.lex_state = 71, .external_lex_state = 4},
  [2558] = {.lex_state = 71, .external_lex_state = 4},
  [2559] = {.lex_state = 71, .external_lex_state = 4},
  [2560] = {.lex_state = 8, .external_lex_state = 5},
  [2561] = {.lex_state = 71, .external_lex_state = 4},
  [2562] = {.lex_state = 71, .external_lex_state = 4},
  [2563] = {.lex_state = 71, .external_lex_state = 4},
  [2564] = {.lex_state = 71, .external_lex_state = 4},
  [2565] = {.lex_state = 71, .external_lex_state = 4},
  [2566] = {.lex_state = 71, .external_lex_state = 4},
  [2567] = {.lex_state = 71, .external_lex_state = 4},
  [2568] = {.lex_state = 71, .external_lex_state = 4},
  [2569] = {.lex_state = 71, .external_lex_state = 4},
  [2570] = {.lex_state = 71, .external_lex_state = 4},
  [2571] = {.lex_state = 71, .external_lex_state = 4},
  [2572] = {.lex_state = 8, .external_lex_state = 5},
  [2573] = {.lex_state = 71, .external_lex_state = 4},
  [2574] = {.lex_state = 71, .external_lex_state = 4},
  [2575] = {.lex_state = 71},
  [2576] = {.lex_state = 71},
  [2577] = {.lex_state = 71},
  [2578] = {.lex_state = 71, .external_lex_state = 4},
  [2579] = {.lex_state = 71, .external_lex_state = 5},
  [2580] = {.lex_state = 71},
  [2581] = {.lex_state = 71, .external_lex_state = 4},
  [2582] = {.lex_state = 71, .external_lex_state = 4},
  [2583] = {.lex_state = 71},
  [2584] = {.lex_state = 71},
  [2585] = {.lex_state = 71, .external_lex_state = 4},
  [2586] = {.lex_state = 71},
  [2587] = {.lex_state = 71},
  [2588] = {.lex_state = 71},
  [2589] = {.lex_state = 8},
  [2590] = {.lex_state = 71, .external_lex_state = 4},
  [2591] = {.lex_state = 8},
  [2592] = {.lex_state = 71},
  [2593] = {.lex_state = 71},
  [2594] = {.lex_state = 8},
  [2595] = {.lex_state = 71},
  [2596] = {.lex_state = 71},
  [2597] = {.lex_state = 71, .external_lex_state = 4},
  [2598] = {.lex_state = 71},
  [2599] = {.lex_state = 71, .external_lex_state = 5},
  [2600] = {.lex_state = 71},
  [2601] = {.lex_state = 71},
  [2602] = {.lex_state = 71},
  [2603] = {.lex_state = 71, .external_lex_state = 5},
  [2604] = {.lex_state = 71},
  [2605] = {.lex_state = 71, .external_lex_state = 5},
  [2606] = {.lex_state = 71},
  [2607] = {.lex_state = 71, .external_lex_state = 5},
  [2608] = {.lex_state = 71, .external_lex_state = 5},
  [2609] = {.lex_state = 71, .external_lex_state = 5},
  [2610] = {.lex_state = 71, .external_lex_state = 5},
  [2611] = {.lex_state = 71, .external_lex_state = 5},
  [2612] = {.lex_state = 71, .external_lex_state = 5},
  [2613] = {.lex_state = 71, .external_lex_state = 5},
  [2614] = {.lex_state = 7},
  [2615] = {.lex_state = 71, .external_lex_state = 5},
  [2616] = {.lex_state = 71, .external_lex_state = 5},
  [2617] = {.lex_state = 71, .external_lex_state = 5},
  [2618] = {.lex_state = 71, .external_lex_state = 5},
  [2619] = {.lex_state = 71, .external_lex_state = 5},
  [2620] = {.lex_state = 71, .external_lex_state = 4},
  [2621] = {.lex_state = 71},
  [2622] = {.lex_state = 71, .external_lex_state = 5},
  [2623] = {.lex_state = 71},
  [2624] = {.lex_state = 71},
  [2625] = {.lex_state = 71},
  [2626] = {.lex_state = 71, .external_lex_state = 5},
  [2627] = {.lex_state = 71},
  [2628] = {.lex_state = 71},
  [2629] = {.lex_state = 71, .external_lex_state = 5},
  [2630] = {.lex_state = 71, .external_lex_state = 5},
  [2631] = {.lex_state = 71, .external_lex_state = 5},
  [2632] = {.lex_state = 71},
  [2633] = {.lex_state = 7},
  [2634] = {.lex_state = 71, .external_lex_state = 5},
  [2635] = {.lex_state = 71, .external_lex_state = 5},
  [2636] = {.lex_state = 71, .external_lex_state = 5},
  [2637] = {.lex_state = 71},
  [2638] = {.lex_state = 71, .external_lex_state = 5},
  [2639] = {.lex_state = 71},
  [2640] = {.lex_state = 71},
  [2641] = {.lex_state = 71, .external_lex_state = 4},
  [2642] = {.lex_state = 71, .external_lex_state = 5},
  [2643] = {.lex_state = 71, .external_lex_state = 5},
  [2644] = {.lex_state = 71, .external_lex_state = 5},
  [2645] = {.lex_state = 71, .external_lex_state = 4},
  [2646] = {.lex_state = 71},
  [2647] = {.lex_state = 71},
  [2648] = {.lex_state = 71},
  [2649] = {.lex_state = 71},
  [2650] = {.lex_state = 71, .external_lex_state = 4},
  [2651] = {.lex_state = 71},
  [2652] = {.lex_state = 71, .external_lex_state = 4},
  [2653] = {.lex_state = 71},
  [2654] = {.lex_state = 71, .external_lex_state = 5},
  [2655] = {.lex_state = 71, .external_lex_state = 5},
  [2656] = {.lex_state = 71, .external_lex_state = 5},
  [2657] = {.lex_state = 71, .external_lex_state = 5},
  [2658] = {.lex_state = 71},
  [2659] = {.lex_state = 71},
  [2660] = {.lex_state = 71},
  [2661] = {.lex_state = 7},
  [2662] = {.lex_state = 71, .external_lex_state = 5},
  [2663] = {.lex_state = 71},
  [2664] = {.lex_state = 71, .external_lex_state = 5},
  [2665] = {.lex_state = 71},
  [2666] = {.lex_state = 71},
  [2667] = {.lex_state = 71},
  [2668] = {.lex_state = 71, .external_lex_state = 4},
  [2669] = {.lex_state = 71, .external_lex_state = 5},
  [2670] = {.lex_state = 71},
  [2671] = {.lex_state = 71, .external_lex_state = 5},
  [2672] = {.lex_state = 71, .external_lex_state = 5},
  [2673] = {.lex_state = 71, .external_lex_state = 5},
  [2674] = {.lex_state = 71, .external_lex_state = 5},
  [2675] = {.lex_state = 71, .external_lex_state = 5},
  [2676] = {.lex_state = 71, .external_lex_state = 4},
  [2677] = {.lex_state = 71, .external_lex_state = 5},
  [2678] = {.lex_state = 71, .external_lex_state = 5},
  [2679] = {.lex_state = 71, .external_lex_state = 5},
  [2680] = {.lex_state = 71},
  [2681] = {.lex_state = 71, .external_lex_state = 5},
  [2682] = {.lex_state = 71},
  [2683] = {.lex_state = 71, .external_lex_state = 5},
  [2684] = {.lex_state = 71, .external_lex_state = 5},
  [2685] = {.lex_state = 71, .external_lex_state = 5},
  [2686] = {.lex_state = 71},
  [2687] = {.lex_state = 71, .external_lex_state = 5},
  [2688] = {.lex_state = 71},
  [2689] = {.lex_state = 71},
  [2690] = {.lex_state = 13, .external_lex_state = 6},
  [2691] = {.lex_state = 13, .external_lex_state = 6},
  [2692] = {.lex_state = 71, .external_lex_state = 4},
  [2693] = {.lex_state = 71, .external_lex_state = 5},
  [2694] = {.lex_state = 13, .external_lex_state = 6},
  [2695] = {.lex_state = 71, .external_lex_state = 4},
  [2696] = {.lex_state = 71, .external_lex_state = 4},
  [2697] = {.lex_state = 13, .external_lex_state = 6},
  [2698] = {.lex_state = 13, .external_lex_state = 6},
  [2699] = {.lex_state = 71, .external_lex_state = 4},
  [2700] = {.lex_state = 71},
  [2701] = {.lex_state = 8},
  [2702] = {.lex_state = 13, .external_lex_state = 6},
  [2703] = {.lex_state = 13, .external_lex_state = 6},
  [2704] = {.lex_state = 71},
  [2705] = {.lex_state = 13, .external_lex_state = 6},
  [2706] = {.lex_state = 8},
  [2707] = {.lex_state = 8},
  [2708] = {.lex_state = 0, .external_lex_state = 4},
  [2709] = {.lex_state = 71, .external_lex_state = 4},
  [2710] = {.lex_state = 71},
  [2711] = {.lex_state = 71},
  [2712] = {.lex_state = 71},
  [2713] = {.lex_state = 71, .external_lex_state = 4},
  [2714] = {.lex_state = 71, .external_lex_state = 4},
  [2715] = {.lex_state = 71, .external_lex_state = 4},
  [2716] = {.lex_state = 71},
  [2717] = {.lex_state = 71, .external_lex_state = 4},
  [2718] = {.lex_state = 0, .external_lex_state = 4},
  [2719] = {.lex_state = 71, .external_lex_state = 4},
  [2720] = {.lex_state = 0, .external_lex_state = 4},
  [2721] = {.lex_state = 0, .external_lex_state = 4},
  [2722] = {.lex_state = 71, .external_lex_state = 4},
  [2723] = {.lex_state = 71},
  [2724] = {.lex_state = 71},
  [2725] = {.lex_state = 71},
  [2726] = {.lex_state = 71},
  [2727] = {.lex_state = 71, .external_lex_state = 4},
  [2728] = {.lex_state = 71},
  [2729] = {.lex_state = 71, .external_lex_state = 4},
  [2730] = {.lex_state = 71, .external_lex_state = 4},
  [2731] = {.lex_state = 71},
  [2732] = {.lex_state = 71},
  [2733] = {.lex_state = 71},
  [2734] = {.lex_state = 71, .external_lex_state = 4},
  [2735] = {.lex_state = 71},
  [2736] = {.lex_state = 71, .external_lex_state = 4},
  [2737] = {.lex_state = 71},
  [2738] = {.lex_state = 71, .external_lex_state = 4},
  [2739] = {.lex_state = 71},
  [2740] = {.lex_state = 71},
  [2741] = {.lex_state = 71},
  [2742] = {.lex_state = 71},
  [2743] = {.lex_state = 71, .external_lex_state = 4},
  [2744] = {.lex_state = 71},
  [2745] = {.lex_state = 71},
  [2746] = {.lex_state = 71, .external_lex_state = 4},
  [2747] = {.lex_state = 71},
  [2748] = {.lex_state = 71, .external_lex_state = 4},
  [2749] = {.lex_state = 71},
  [2750] = {.lex_state = 0, .external_lex_state = 4},
  [2751] = {.lex_state = 71},
  [2752] = {.lex_state = 71},
  [2753] = {.lex_state = 71, .external_lex_state = 4},
  [2754] = {.lex_state = 7},
  [2755] = {.lex_state = 71},
  [2756] = {.lex_state = 0, .external_lex_state = 4},
  [2757] = {.lex_state = 71},
  [2758] = {.lex_state = 71, .external_lex_state = 4},
  [2759] = {.lex_state = 71, .external_lex_state = 4},
  [2760] = {.lex_state = 71, .external_lex_state = 4},
  [2761] = {.lex_state = 71, .external_lex_state = 4},
  [2762] = {.lex_state = 71, .external_lex_state = 4},
  [2763] = {.lex_state = 71, .external_lex_state = 4},
  [2764] = {.lex_state = 71, .external_lex_state = 4},
  [2765] = {.lex_state = 71},
  [2766] = {.lex_state = 71},
  [2767] = {.lex_state = 71},
  [2768] = {.lex_state = 71, .external_lex_state = 4},
  [2769] = {.lex_state = 71},
  [2770] = {.lex_state = 71},
  [2771] = {.lex_state = 71, .external_lex_state = 4},
  [2772] = {.lex_state = 71},
  [2773] = {.lex_state = 71, .external_lex_state = 4},
  [2774] = {.lex_state = 71},
  [2775] = {.lex_state = 71},
  [2776] = {.lex_state = 71},
  [2777] = {.lex_state = 71, .external_lex_state = 4},
  [2778] = {.lex_state = 71},
  [2779] = {.lex_state = 71},
  [2780] = {.lex_state = 71},
  [2781] = {.lex_state = 71, .external_lex_state = 4},
  [2782] = {.lex_state = 7},
  [2783] = {.lex_state = 71, .external_lex_state = 4},
  [2784] = {.lex_state = 71},
  [2785] = {.lex_state = 71},
  [2786] = {.lex_state = 71},
  [2787] = {.lex_state = 71},
  [2788] = {.lex_state = 71, .external_lex_state = 4},
  [2789] = {.lex_state = 71, .external_lex_state = 4},
  [2790] = {.lex_state = 71, .external_lex_state = 4},
  [2791] = {.lex_state = 71},
  [2792] = {.lex_state = 71},
  [2793] = {.lex_state = 71},
  [2794] = {.lex_state = 71},
  [2795] = {.lex_state = 71},
  [2796] = {.lex_state = 71, .external_lex_state = 4},
  [2797] = {.lex_state = 7},
  [2798] = {.lex_state = 71},
  [2799] = {.lex_state = 71},
  [2800] = {.lex_state = 71, .external_lex_state = 4},
  [2801] = {.lex_state = 71},
  [2802] = {.lex_state = 0, .external_lex_state = 4},
  [2803] = {.lex_state = 0, .external_lex_state = 4},
  [2804] = {.lex_state = 71, .external_lex_state = 4},
  [2805] = {.lex_state = 71},
  [2806] = {.lex_state = 71},
  [2807] = {.lex_state = 71, .external_lex_state = 4},
  [2808] = {.lex_state = 71},
  [2809] = {.lex_state = 71},
  [2810] = {.lex_state = 71},
  [2811] = {.lex_state = 71},
  [2812] = {.lex_state = 71},
  [2813] = {.lex_state = 0, .external_lex_state = 4},
  [2814] = {.lex_state = 0, .external_lex_state = 4},
  [2815] = {.lex_state = 71},
  [2816] = {.lex_state = 71},
  [2817] = {.lex_state = 13, .external_lex_state = 6},
  [2818] = {.lex_state = 13},
  [2819] = {.lex_state = 71},
  [2820] = {.lex_state = 71},
  [2821] = {.lex_state = 71},
  [2822] = {.lex_state = 0, .external_lex_state = 4},
  [2823] = {.lex_state = 71},
  [2824] = {.lex_state = 71, .external_lex_state = 5},
  [2825] = {.lex_state = 71, .external_lex_state = 5},
  [2826] = {.lex_state = 71},
  [2827] = {.lex_state = 71},
  [2828] = {.lex_state = 71, .external_lex_state = 5},
  [2829] = {.lex_state = 71},
  [2830] = {.lex_state = 71},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 71, .external_lex_state = 5},
  [2833] = {.lex_state = 71},
  [2834] = {.lex_state = 71},
  [2835] = {.lex_state = 71},
  [2836] = {.lex_state = 13, .external_lex_state = 6},
  [2837] = {.lex_state = 71},
  [2838] = {.lex_state = 7},
  [2839] = {.lex_state = 71},
  [2840] = {.lex_state = 71},
  [2841] = {.lex_state = 0, .external_lex_state = 4},
  [2842] = {.lex_state = 71},
  [2843] = {.lex_state = 71, .external_lex_state = 5},
  [2844] = {.lex_state = 13},
  [2845] = {.lex_state = 13},
  [2846] = {.lex_state = 71},
  [2847] = {.lex_state = 71},
  [2848] = {.lex_state = 71},
  [2849] = {.lex_state = 13},
  [2850] = {.lex_state = 71, .external_lex_state = 4},
  [2851] = {.lex_state = 71, .external_lex_state = 4},
  [2852] = {.lex_state = 71},
  [2853] = {.lex_state = 0, .external_lex_state = 4},
  [2854] = {.lex_state = 0, .external_lex_state = 4},
  [2855] = {.lex_state = 71},
  [2856] = {.lex_state = 0, .external_lex_state = 4},
  [2857] = {.lex_state = 71},
  [2858] = {.lex_state = 71},
  [2859] = {.lex_state = 71},
  [2860] = {.lex_state = 13, .external_lex_state = 6},
  [2861] = {.lex_state = 0, .external_lex_state = 4},
  [2862] = {.lex_state = 0, .external_lex_state = 4},
  [2863] = {.lex_state = 71, .external_lex_state = 5},
  [2864] = {.lex_state = 71, .external_lex_state = 4},
  [2865] = {.lex_state = 0, .external_lex_state = 4},
  [2866] = {.lex_state = 71},
  [2867] = {.lex_state = 71, .external_lex_state = 5},
  [2868] = {.lex_state = 71},
  [2869] = {.lex_state = 71, .external_lex_state = 5},
  [2870] = {.lex_state = 71},
  [2871] = {.lex_state = 71, .external_lex_state = 5},
  [2872] = {.lex_state = 71},
  [2873] = {.lex_state = 71},
  [2874] = {.lex_state = 71, .external_lex_state = 5},
  [2875] = {.lex_state = 71},
  [2876] = {.lex_state = 71},
  [2877] = {.lex_state = 71, .external_lex_state = 5},
  [2878] = {.lex_state = 71},
  [2879] = {.lex_state = 71, .external_lex_state = 4},
  [2880] = {.lex_state = 71},
  [2881] = {.lex_state = 71},
  [2882] = {.lex_state = 71},
  [2883] = {.lex_state = 71},
  [2884] = {.lex_state = 0, .external_lex_state = 4},
  [2885] = {.lex_state = 71},
  [2886] = {.lex_state = 71},
  [2887] = {.lex_state = 71},
  [2888] = {.lex_state = 71},
  [2889] = {.lex_state = 71},
  [2890] = {.lex_state = 71},
  [2891] = {.lex_state = 71},
  [2892] = {.lex_state = 71},
  [2893] = {.lex_state = 71},
  [2894] = {.lex_state = 71},
  [2895] = {.lex_state = 71, .external_lex_state = 5},
  [2896] = {.lex_state = 71},
  [2897] = {.lex_state = 71},
  [2898] = {.lex_state = 13},
  [2899] = {.lex_state = 71},
  [2900] = {.lex_state = 13},
  [2901] = {.lex_state = 0, .external_lex_state = 4},
  [2902] = {.lex_state = 71},
  [2903] = {.lex_state = 71},
  [2904] = {.lex_state = 13},
  [2905] = {.lex_state = 71},
  [2906] = {.lex_state = 71},
  [2907] = {.lex_state = 71},
  [2908] = {.lex_state = 71},
  [2909] = {.lex_state = 71},
  [2910] = {.lex_state = 0, .external_lex_state = 4},
  [2911] = {.lex_state = 71, .external_lex_state = 5},
  [2912] = {.lex_state = 0, .external_lex_state = 4},
  [2913] = {.lex_state = 0, .external_lex_state = 4},
  [2914] = {.lex_state = 71, .external_lex_state = 5},
  [2915] = {.lex_state = 71},
  [2916] = {.lex_state = 0, .external_lex_state = 4},
  [2917] = {.lex_state = 71, .external_lex_state = 5},
  [2918] = {.lex_state = 7},
  [2919] = {.lex_state = 13, .external_lex_state = 6},
  [2920] = {.lex_state = 71},
  [2921] = {.lex_state = 71, .external_lex_state = 5},
  [2922] = {.lex_state = 71},
  [2923] = {.lex_state = 71},
  [2924] = {.lex_state = 0, .external_lex_state = 4},
  [2925] = {.lex_state = 13},
  [2926] = {.lex_state = 71},
  [2927] = {.lex_state = 71},
  [2928] = {.lex_state = 71, .external_lex_state = 5},
  [2929] = {.lex_state = 71},
  [2930] = {.lex_state = 13, .external_lex_state = 6},
  [2931] = {.lex_state = 71},
  [2932] = {.lex_state = 13},
  [2933] = {.lex_state = 71},
  [2934] = {.lex_state = 0, .external_lex_state = 4},
  [2935] = {.lex_state = 71},
  [2936] = {.lex_state = 71},
  [2937] = {.lex_state = 71},
  [2938] = {.lex_state = 71, .external_lex_state = 5},
  [2939] = {.lex_state = 71},
  [2940] = {.lex_state = 71},
  [2941] = {.lex_state = 71, .external_lex_state = 5},
  [2942] = {.lex_state = 71},
  [2943] = {.lex_state = 71, .external_lex_state = 5},
  [2944] = {.lex_state = 71},
  [2945] = {.lex_state = 0, .external_lex_state = 4},
  [2946] = {.lex_state = 71, .external_lex_state = 5},
  [2947] = {.lex_state = 0, .external_lex_state = 4},
  [2948] = {.lex_state = 0, .external_lex_state = 4},
  [2949] = {.lex_state = 0, .external_lex_state = 4},
  [2950] = {.lex_state = 71, .external_lex_state = 5},
  [2951] = {.lex_state = 71, .external_lex_state = 5},
  [2952] = {.lex_state = 71, .external_lex_state = 5},
  [2953] = {.lex_state = 71, .external_lex_state = 5},
  [2954] = {.lex_state = 71},
  [2955] = {.lex_state = 0, .external_lex_state = 4},
  [2956] = {.lex_state = 71},
  [2957] = {.lex_state = 71, .external_lex_state = 5},
  [2958] = {.lex_state = 71},
  [2959] = {.lex_state = 71},
  [2960] = {.lex_state = 71},
  [2961] = {.lex_state = 0, .external_lex_state = 4},
  [2962] = {.lex_state = 71},
  [2963] = {.lex_state = 71, .external_lex_state = 5},
  [2964] = {.lex_state = 0, .external_lex_state = 4},
  [2965] = {.lex_state = 71},
  [2966] = {.lex_state = 71},
  [2967] = {.lex_state = 71},
  [2968] = {.lex_state = 71},
  [2969] = {.lex_state = 0, .external_lex_state = 4},
  [2970] = {.lex_state = 71},
  [2971] = {.lex_state = 0, .external_lex_state = 4},
  [2972] = {.lex_state = 71, .external_lex_state = 4},
  [2973] = {.lex_state = 71},
  [2974] = {.lex_state = 71},
  [2975] = {.lex_state = 13, .external_lex_state = 6},
  [2976] = {.lex_state = 0},
  [2977] = {.lex_state = 71},
  [2978] = {.lex_state = 71},
  [2979] = {.lex_state = 71},
  [2980] = {.lex_state = 71, .external_lex_state = 5},
  [2981] = {.lex_state = 0},
  [2982] = {.lex_state = 71},
  [2983] = {.lex_state = 0},
  [2984] = {.lex_state = 0, .external_lex_state = 4},
  [2985] = {.lex_state = 71},
  [2986] = {.lex_state = 71},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 71},
  [2989] = {.lex_state = 71},
  [2990] = {.lex_state = 71},
  [2991] = {.lex_state = 0},
  [2992] = {.lex_state = 71},
  [2993] = {.lex_state = 13, .external_lex_state = 6},
  [2994] = {.lex_state = 71},
  [2995] = {.lex_state = 71},
  [2996] = {.lex_state = 71},
  [2997] = {.lex_state = 71, .external_lex_state = 5},
  [2998] = {.lex_state = 0, .external_lex_state = 4},
  [2999] = {.lex_state = 71, .external_lex_state = 5},
  [3000] = {.lex_state = 0, .external_lex_state = 4},
  [3001] = {.lex_state = 2},
  [3002] = {.lex_state = 71},
  [3003] = {.lex_state = 71, .external_lex_state = 4},
  [3004] = {.lex_state = 71},
  [3005] = {.lex_state = 71},
  [3006] = {.lex_state = 71, .external_lex_state = 5},
  [3007] = {.lex_state = 71, .external_lex_state = 4},
  [3008] = {.lex_state = 71},
  [3009] = {.lex_state = 71},
  [3010] = {.lex_state = 71},
  [3011] = {.lex_state = 71, .external_lex_state = 4},
  [3012] = {.lex_state = 71},
  [3013] = {.lex_state = 71},
  [3014] = {.lex_state = 71},
  [3015] = {.lex_state = 71},
  [3016] = {.lex_state = 71},
  [3017] = {.lex_state = 0, .external_lex_state = 4},
  [3018] = {.lex_state = 0, .external_lex_state = 4},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 71},
  [3022] = {.lex_state = 0},
  [3023] = {.lex_state = 71, .external_lex_state = 5},
  [3024] = {.lex_state = 71},
  [3025] = {.lex_state = 13, .external_lex_state = 6},
  [3026] = {.lex_state = 71},
  [3027] = {.lex_state = 71},
  [3028] = {.lex_state = 71},
  [3029] = {.lex_state = 0, .external_lex_state = 4},
  [3030] = {.lex_state = 71},
  [3031] = {.lex_state = 71},
  [3032] = {.lex_state = 71, .external_lex_state = 5},
  [3033] = {.lex_state = 71},
  [3034] = {.lex_state = 0},
  [3035] = {.lex_state = 71},
  [3036] = {.lex_state = 0},
  [3037] = {.lex_state = 71},
  [3038] = {.lex_state = 71},
  [3039] = {.lex_state = 0, .external_lex_state = 4},
  [3040] = {.lex_state = 0, .external_lex_state = 4},
  [3041] = {.lex_state = 71},
  [3042] = {.lex_state = 71, .external_lex_state = 5},
  [3043] = {.lex_state = 71, .external_lex_state = 4},
  [3044] = {.lex_state = 2},
  [3045] = {.lex_state = 71},
  [3046] = {.lex_state = 71},
  [3047] = {.lex_state = 71},
  [3048] = {.lex_state = 71},
  [3049] = {.lex_state = 71, .external_lex_state = 4},
  [3050] = {.lex_state = 71, .external_lex_state = 4},
  [3051] = {.lex_state = 71},
  [3052] = {.lex_state = 71},
  [3053] = {.lex_state = 71},
  [3054] = {.lex_state = 71},
  [3055] = {.lex_state = 71},
  [3056] = {.lex_state = 0, .external_lex_state = 4},
  [3057] = {.lex_state = 71},
  [3058] = {.lex_state = 0, .external_lex_state = 4},
  [3059] = {.lex_state = 71, .external_lex_state = 4},
  [3060] = {.lex_state = 71, .external_lex_state = 5},
  [3061] = {.lex_state = 0, .external_lex_state = 4},
  [3062] = {.lex_state = 0, .external_lex_state = 4},
  [3063] = {.lex_state = 0, .external_lex_state = 4},
  [3064] = {.lex_state = 0, .external_lex_state = 4},
  [3065] = {.lex_state = 71},
  [3066] = {.lex_state = 0, .external_lex_state = 4},
  [3067] = {.lex_state = 0},
  [3068] = {.lex_state = 71},
  [3069] = {.lex_state = 71},
  [3070] = {.lex_state = 71},
  [3071] = {.lex_state = 71},
  [3072] = {.lex_state = 71},
  [3073] = {.lex_state = 0, .external_lex_state = 4},
  [3074] = {.lex_state = 0, .external_lex_state = 4},
  [3075] = {.lex_state = 0, .external_lex_state = 4},
  [3076] = {.lex_state = 71},
  [3077] = {.lex_state = 13, .external_lex_state = 6},
  [3078] = {.lex_state = 71},
  [3079] = {.lex_state = 71},
  [3080] = {.lex_state = 71},
  [3081] = {.lex_state = 71},
  [3082] = {.lex_state = 0},
  [3083] = {.lex_state = 71},
  [3084] = {.lex_state = 71},
  [3085] = {.lex_state = 0, .external_lex_state = 4},
  [3086] = {.lex_state = 71},
  [3087] = {.lex_state = 0, .external_lex_state = 4},
  [3088] = {.lex_state = 71},
  [3089] = {.lex_state = 0, .external_lex_state = 4},
  [3090] = {.lex_state = 0, .external_lex_state = 4},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 0, .external_lex_state = 4},
  [3093] = {.lex_state = 71},
  [3094] = {.lex_state = 0, .external_lex_state = 4},
  [3095] = {.lex_state = 0, .external_lex_state = 4},
  [3096] = {.lex_state = 71},
  [3097] = {.lex_state = 0, .external_lex_state = 4},
  [3098] = {.lex_state = 71},
  [3099] = {.lex_state = 0, .external_lex_state = 4},
  [3100] = {.lex_state = 71},
  [3101] = {.lex_state = 0, .external_lex_state = 4},
  [3102] = {.lex_state = 71},
  [3103] = {.lex_state = 71},
  [3104] = {.lex_state = 71},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 7},
  [3107] = {.lex_state = 71},
  [3108] = {.lex_state = 71},
  [3109] = {.lex_state = 0, .external_lex_state = 4},
  [3110] = {.lex_state = 71},
  [3111] = {.lex_state = 0, .external_lex_state = 4},
  [3112] = {.lex_state = 0, .external_lex_state = 4},
  [3113] = {.lex_state = 0, .external_lex_state = 4},
  [3114] = {.lex_state = 0, .external_lex_state = 4},
  [3115] = {.lex_state = 0, .external_lex_state = 4},
  [3116] = {.lex_state = 0, .external_lex_state = 4},
  [3117] = {.lex_state = 0, .external_lex_state = 4},
  [3118] = {.lex_state = 71},
  [3119] = {.lex_state = 0, .external_lex_state = 4},
  [3120] = {.lex_state = 71},
  [3121] = {.lex_state = 13, .external_lex_state = 6},
  [3122] = {.lex_state = 71},
  [3123] = {.lex_state = 0, .external_lex_state = 4},
  [3124] = {.lex_state = 0, .external_lex_state = 4},
  [3125] = {.lex_state = 0, .external_lex_state = 4},
  [3126] = {.lex_state = 0, .external_lex_state = 4},
  [3127] = {.lex_state = 71},
  [3128] = {.lex_state = 0, .external_lex_state = 4},
  [3129] = {.lex_state = 0, .external_lex_state = 4},
  [3130] = {.lex_state = 0, .external_lex_state = 4},
  [3131] = {.lex_state = 0, .external_lex_state = 4},
  [3132] = {.lex_state = 0, .external_lex_state = 4},
  [3133] = {.lex_state = 71},
  [3134] = {.lex_state = 0, .external_lex_state = 4},
  [3135] = {.lex_state = 0, .external_lex_state = 4},
  [3136] = {.lex_state = 71},
  [3137] = {.lex_state = 13, .external_lex_state = 6},
  [3138] = {.lex_state = 0, .external_lex_state = 4},
  [3139] = {.lex_state = 71},
  [3140] = {.lex_state = 0, .external_lex_state = 4},
  [3141] = {.lex_state = 0, .external_lex_state = 4},
  [3142] = {.lex_state = 0, .external_lex_state = 4},
  [3143] = {.lex_state = 0, .external_lex_state = 4},
  [3144] = {.lex_state = 0, .external_lex_state = 4},
  [3145] = {.lex_state = 71},
  [3146] = {.lex_state = 0, .external_lex_state = 4},
  [3147] = {.lex_state = 0, .external_lex_state = 4},
  [3148] = {.lex_state = 0, .external_lex_state = 4},
  [3149] = {.lex_state = 0, .external_lex_state = 4},
  [3150] = {.lex_state = 13, .external_lex_state = 6},
  [3151] = {.lex_state = 71},
  [3152] = {.lex_state = 0, .external_lex_state = 4},
  [3153] = {.lex_state = 0, .external_lex_state = 4},
  [3154] = {.lex_state = 71},
  [3155] = {.lex_state = 0, .external_lex_state = 4},
  [3156] = {.lex_state = 7},
  [3157] = {.lex_state = 13, .external_lex_state = 6},
  [3158] = {.lex_state = 0, .external_lex_state = 4},
  [3159] = {.lex_state = 0, .external_lex_state = 4},
  [3160] = {.lex_state = 0, .external_lex_state = 4},
  [3161] = {.lex_state = 0, .external_lex_state = 4},
  [3162] = {.lex_state = 0, .external_lex_state = 4},
  [3163] = {.lex_state = 13, .external_lex_state = 6},
  [3164] = {.lex_state = 0, .external_lex_state = 4},
  [3165] = {.lex_state = 0, .external_lex_state = 4},
  [3166] = {.lex_state = 0, .external_lex_state = 4},
  [3167] = {.lex_state = 0, .external_lex_state = 4},
  [3168] = {.lex_state = 0, .external_lex_state = 4},
  [3169] = {.lex_state = 71},
  [3170] = {.lex_state = 0, .external_lex_state = 4},
  [3171] = {.lex_state = 0, .external_lex_state = 4},
  [3172] = {.lex_state = 0, .external_lex_state = 4},
  [3173] = {.lex_state = 71, .external_lex_state = 5},
  [3174] = {.lex_state = 71, .external_lex_state = 5},
  [3175] = {.lex_state = 71, .external_lex_state = 5},
  [3176] = {.lex_state = 0, .external_lex_state = 4},
  [3177] = {.lex_state = 0, .external_lex_state = 4},
  [3178] = {.lex_state = 0, .external_lex_state = 4},
  [3179] = {.lex_state = 71, .external_lex_state = 5},
  [3180] = {.lex_state = 71, .external_lex_state = 5},
  [3181] = {.lex_state = 0, .external_lex_state = 4},
  [3182] = {.lex_state = 71},
  [3183] = {.lex_state = 0, .external_lex_state = 4},
  [3184] = {.lex_state = 0, .external_lex_state = 4},
  [3185] = {.lex_state = 0, .external_lex_state = 4},
  [3186] = {.lex_state = 0, .external_lex_state = 4},
  [3187] = {.lex_state = 0, .external_lex_state = 4},
  [3188] = {.lex_state = 0, .external_lex_state = 4},
  [3189] = {.lex_state = 0, .external_lex_state = 4},
  [3190] = {.lex_state = 13, .external_lex_state = 6},
  [3191] = {.lex_state = 0, .external_lex_state = 4},
  [3192] = {.lex_state = 71},
  [3193] = {.lex_state = 0, .external_lex_state = 4},
  [3194] = {.lex_state = 0, .external_lex_state = 4},
  [3195] = {.lex_state = 0, .external_lex_state = 4},
  [3196] = {.lex_state = 0, .external_lex_state = 4},
  [3197] = {.lex_state = 0, .external_lex_state = 4},
  [3198] = {.lex_state = 0, .external_lex_state = 4},
  [3199] = {.lex_state = 0, .external_lex_state = 4},
  [3200] = {.lex_state = 0, .external_lex_state = 4},
  [3201] = {.lex_state = 0, .external_lex_state = 4},
  [3202] = {.lex_state = 0, .external_lex_state = 4},
  [3203] = {.lex_state = 71, .external_lex_state = 5},
  [3204] = {.lex_state = 13, .external_lex_state = 6},
  [3205] = {.lex_state = 0, .external_lex_state = 4},
  [3206] = {.lex_state = 0, .external_lex_state = 4},
  [3207] = {.lex_state = 0, .external_lex_state = 4},
  [3208] = {.lex_state = 0, .external_lex_state = 4},
  [3209] = {.lex_state = 0, .external_lex_state = 4},
  [3210] = {.lex_state = 0, .external_lex_state = 4},
  [3211] = {.lex_state = 0, .external_lex_state = 4},
  [3212] = {.lex_state = 0, .external_lex_state = 4},
  [3213] = {.lex_state = 0, .external_lex_state = 4},
  [3214] = {.lex_state = 0, .external_lex_state = 4},
  [3215] = {.lex_state = 0, .external_lex_state = 4},
  [3216] = {.lex_state = 0, .external_lex_state = 4},
  [3217] = {.lex_state = 0, .external_lex_state = 4},
  [3218] = {.lex_state = 0, .external_lex_state = 4},
  [3219] = {.lex_state = 0, .external_lex_state = 4},
  [3220] = {.lex_state = 0, .external_lex_state = 4},
  [3221] = {.lex_state = 0, .external_lex_state = 4},
  [3222] = {.lex_state = 0, .external_lex_state = 4},
  [3223] = {.lex_state = 0, .external_lex_state = 4},
  [3224] = {.lex_state = 0, .external_lex_state = 4},
  [3225] = {.lex_state = 0, .external_lex_state = 4},
  [3226] = {.lex_state = 0, .external_lex_state = 4},
  [3227] = {.lex_state = 0, .external_lex_state = 4},
  [3228] = {.lex_state = 0, .external_lex_state = 4},
  [3229] = {.lex_state = 0, .external_lex_state = 4},
  [3230] = {.lex_state = 0, .external_lex_state = 4},
  [3231] = {.lex_state = 0, .external_lex_state = 4},
  [3232] = {.lex_state = 0, .external_lex_state = 4},
  [3233] = {.lex_state = 0, .external_lex_state = 4},
  [3234] = {.lex_state = 0, .external_lex_state = 4},
  [3235] = {.lex_state = 0, .external_lex_state = 4},
  [3236] = {.lex_state = 0, .external_lex_state = 4},
  [3237] = {.lex_state = 0, .external_lex_state = 4},
  [3238] = {.lex_state = 0, .external_lex_state = 4},
  [3239] = {.lex_state = 0, .external_lex_state = 4},
  [3240] = {.lex_state = 0, .external_lex_state = 4},
  [3241] = {.lex_state = 0, .external_lex_state = 4},
  [3242] = {.lex_state = 12},
  [3243] = {.lex_state = 12},
  [3244] = {.lex_state = 15},
  [3245] = {.lex_state = 71},
  [3246] = {.lex_state = 71},
  [3247] = {.lex_state = 71},
  [3248] = {.lex_state = 71, .external_lex_state = 4},
  [3249] = {.lex_state = 71},
  [3250] = {.lex_state = 71},
  [3251] = {.lex_state = 71},
  [3252] = {.lex_state = 0, .external_lex_state = 4},
  [3253] = {.lex_state = 0},
  [3254] = {.lex_state = 71},
  [3255] = {.lex_state = 12},
  [3256] = {.lex_state = 15},
  [3257] = {.lex_state = 0, .external_lex_state = 4},
  [3258] = {.lex_state = 0},
  [3259] = {.lex_state = 71},
  [3260] = {.lex_state = 71},
  [3261] = {.lex_state = 71},
  [3262] = {.lex_state = 0, .external_lex_state = 4},
  [3263] = {.lex_state = 0, .external_lex_state = 4},
  [3264] = {.lex_state = 12},
  [3265] = {.lex_state = 15},
  [3266] = {.lex_state = 0},
  [3267] = {.lex_state = 71},
  [3268] = {.lex_state = 0},
  [3269] = {.lex_state = 71},
  [3270] = {.lex_state = 71},
  [3271] = {.lex_state = 71},
  [3272] = {.lex_state = 71},
  [3273] = {.lex_state = 71},
  [3274] = {.lex_state = 71},
  [3275] = {.lex_state = 0, .external_lex_state = 5},
  [3276] = {.lex_state = 12},
  [3277] = {.lex_state = 15},
  [3278] = {.lex_state = 71},
  [3279] = {.lex_state = 71},
  [3280] = {.lex_state = 71},
  [3281] = {.lex_state = 12},
  [3282] = {.lex_state = 15},
  [3283] = {.lex_state = 0},
  [3284] = {.lex_state = 0, .external_lex_state = 4},
  [3285] = {.lex_state = 71},
  [3286] = {.lex_state = 0},
  [3287] = {.lex_state = 13, .external_lex_state = 6},
  [3288] = {.lex_state = 71},
  [3289] = {.lex_state = 71},
  [3290] = {.lex_state = 71},
  [3291] = {.lex_state = 71},
  [3292] = {.lex_state = 71},
  [3293] = {.lex_state = 71},
  [3294] = {.lex_state = 13, .external_lex_state = 6},
  [3295] = {.lex_state = 0},
  [3296] = {.lex_state = 71},
  [3297] = {.lex_state = 71},
  [3298] = {.lex_state = 71},
  [3299] = {.lex_state = 71},
  [3300] = {.lex_state = 71},
  [3301] = {.lex_state = 71},
  [3302] = {.lex_state = 71},
  [3303] = {.lex_state = 0},
  [3304] = {.lex_state = 0},
  [3305] = {.lex_state = 0},
  [3306] = {.lex_state = 71},
  [3307] = {.lex_state = 71},
  [3308] = {.lex_state = 71},
  [3309] = {.lex_state = 71},
  [3310] = {.lex_state = 71},
  [3311] = {.lex_state = 0, .external_lex_state = 4},
  [3312] = {.lex_state = 0, .external_lex_state = 4},
  [3313] = {.lex_state = 71},
  [3314] = {.lex_state = 0},
  [3315] = {.lex_state = 15},
  [3316] = {.lex_state = 0},
  [3317] = {.lex_state = 0},
  [3318] = {.lex_state = 12},
  [3319] = {.lex_state = 71},
  [3320] = {.lex_state = 12},
  [3321] = {.lex_state = 0},
  [3322] = {.lex_state = 15},
  [3323] = {.lex_state = 71},
  [3324] = {.lex_state = 71},
  [3325] = {.lex_state = 71},
  [3326] = {.lex_state = 71},
  [3327] = {.lex_state = 71},
  [3328] = {.lex_state = 71},
  [3329] = {.lex_state = 71},
  [3330] = {.lex_state = 0},
  [3331] = {.lex_state = 12},
  [3332] = {.lex_state = 15},
  [3333] = {.lex_state = 12},
  [3334] = {.lex_state = 15},
  [3335] = {.lex_state = 12},
  [3336] = {.lex_state = 0, .external_lex_state = 4},
  [3337] = {.lex_state = 0, .external_lex_state = 4},
  [3338] = {.lex_state = 15},
  [3339] = {.lex_state = 12},
  [3340] = {.lex_state = 71, .external_lex_state = 4},
  [3341] = {.lex_state = 15},
  [3342] = {.lex_state = 12},
  [3343] = {.lex_state = 12},
  [3344] = {.lex_state = 71},
  [3345] = {.lex_state = 15},
  [3346] = {.lex_state = 71},
  [3347] = {.lex_state = 71},
  [3348] = {.lex_state = 15},
  [3349] = {.lex_state = 15},
  [3350] = {.lex_state = 12},
  [3351] = {.lex_state = 71},
  [3352] = {.lex_state = 15},
  [3353] = {.lex_state = 71},
  [3354] = {.lex_state = 71},
  [3355] = {.lex_state = 0},
  [3356] = {.lex_state = 71},
  [3357] = {.lex_state = 71, .external_lex_state = 4},
  [3358] = {.lex_state = 71, .external_lex_state = 4},
  [3359] = {.lex_state = 71},
  [3360] = {.lex_state = 71},
  [3361] = {.lex_state = 71},
  [3362] = {.lex_state = 71},
  [3363] = {.lex_state = 0},
  [3364] = {.lex_state = 71},
  [3365] = {.lex_state = 0, .external_lex_state = 4},
  [3366] = {.lex_state = 0},
  [3367] = {.lex_state = 0},
  [3368] = {.lex_state = 0},
  [3369] = {.lex_state = 0},
  [3370] = {.lex_state = 0},
  [3371] = {.lex_state = 0},
  [3372] = {.lex_state = 0},
  [3373] = {.lex_state = 0},
  [3374] = {.lex_state = 71},
  [3375] = {.lex_state = 71},
  [3376] = {.lex_state = 0},
  [3377] = {.lex_state = 0, .external_lex_state = 4},
  [3378] = {.lex_state = 0},
  [3379] = {.lex_state = 0},
  [3380] = {.lex_state = 0, .external_lex_state = 4},
  [3381] = {.lex_state = 0, .external_lex_state = 4},
  [3382] = {.lex_state = 71},
  [3383] = {.lex_state = 0},
  [3384] = {.lex_state = 2},
  [3385] = {.lex_state = 0},
  [3386] = {.lex_state = 0},
  [3387] = {.lex_state = 0},
  [3388] = {.lex_state = 71},
  [3389] = {.lex_state = 71},
  [3390] = {.lex_state = 71},
  [3391] = {.lex_state = 71},
  [3392] = {.lex_state = 71},
  [3393] = {.lex_state = 71},
  [3394] = {.lex_state = 0},
  [3395] = {.lex_state = 0},
  [3396] = {.lex_state = 71, .external_lex_state = 4},
  [3397] = {.lex_state = 71},
  [3398] = {.lex_state = 0},
  [3399] = {.lex_state = 0},
  [3400] = {.lex_state = 0},
  [3401] = {.lex_state = 0, .external_lex_state = 4},
  [3402] = {.lex_state = 0},
  [3403] = {.lex_state = 0},
  [3404] = {.lex_state = 71},
  [3405] = {.lex_state = 0},
  [3406] = {.lex_state = 71},
  [3407] = {.lex_state = 0},
  [3408] = {.lex_state = 71},
  [3409] = {.lex_state = 71},
  [3410] = {.lex_state = 71},
  [3411] = {.lex_state = 0, .external_lex_state = 4},
  [3412] = {.lex_state = 0},
  [3413] = {.lex_state = 0},
  [3414] = {.lex_state = 0, .external_lex_state = 4},
  [3415] = {.lex_state = 0},
  [3416] = {.lex_state = 0},
  [3417] = {.lex_state = 0, .external_lex_state = 4},
  [3418] = {.lex_state = 0, .external_lex_state = 4},
  [3419] = {.lex_state = 71},
  [3420] = {.lex_state = 0},
  [3421] = {.lex_state = 71},
  [3422] = {.lex_state = 0, .external_lex_state = 4},
  [3423] = {.lex_state = 0, .external_lex_state = 4},
  [3424] = {.lex_state = 71},
  [3425] = {.lex_state = 71},
  [3426] = {.lex_state = 0},
  [3427] = {.lex_state = 0},
  [3428] = {.lex_state = 0},
  [3429] = {.lex_state = 0, .external_lex_state = 4},
  [3430] = {.lex_state = 71},
  [3431] = {.lex_state = 0},
  [3432] = {.lex_state = 0},
  [3433] = {.lex_state = 0},
  [3434] = {.lex_state = 0},
  [3435] = {.lex_state = 0},
  [3436] = {.lex_state = 0},
  [3437] = {.lex_state = 0},
  [3438] = {.lex_state = 71},
  [3439] = {.lex_state = 0},
  [3440] = {.lex_state = 0},
  [3441] = {.lex_state = 71},
  [3442] = {.lex_state = 71},
  [3443] = {.lex_state = 71},
  [3444] = {.lex_state = 71},
  [3445] = {.lex_state = 71},
  [3446] = {.lex_state = 0},
  [3447] = {.lex_state = 71},
  [3448] = {.lex_state = 0},
  [3449] = {.lex_state = 0, .external_lex_state = 4},
  [3450] = {.lex_state = 71},
  [3451] = {.lex_state = 0},
  [3452] = {.lex_state = 0},
  [3453] = {.lex_state = 71},
  [3454] = {.lex_state = 71},
  [3455] = {.lex_state = 71, .external_lex_state = 4},
  [3456] = {.lex_state = 71, .external_lex_state = 4},
  [3457] = {.lex_state = 0},
  [3458] = {.lex_state = 0, .external_lex_state = 4},
  [3459] = {.lex_state = 0, .external_lex_state = 4},
  [3460] = {.lex_state = 0, .external_lex_state = 4},
  [3461] = {.lex_state = 71},
  [3462] = {.lex_state = 0},
  [3463] = {.lex_state = 0},
  [3464] = {.lex_state = 0},
  [3465] = {.lex_state = 0, .external_lex_state = 4},
  [3466] = {.lex_state = 0, .external_lex_state = 4},
  [3467] = {.lex_state = 0, .external_lex_state = 4},
  [3468] = {.lex_state = 0},
  [3469] = {.lex_state = 0},
  [3470] = {.lex_state = 0, .external_lex_state = 4},
  [3471] = {.lex_state = 0, .external_lex_state = 4},
  [3472] = {.lex_state = 0},
  [3473] = {.lex_state = 0},
  [3474] = {.lex_state = 0},
  [3475] = {.lex_state = 0, .external_lex_state = 4},
  [3476] = {.lex_state = 0, .external_lex_state = 4},
  [3477] = {.lex_state = 0, .external_lex_state = 4},
  [3478] = {.lex_state = 0, .external_lex_state = 4},
  [3479] = {.lex_state = 0},
  [3480] = {.lex_state = 0},
  [3481] = {.lex_state = 2},
  [3482] = {.lex_state = 0},
  [3483] = {.lex_state = 71},
  [3484] = {.lex_state = 0},
  [3485] = {.lex_state = 0},
  [3486] = {.lex_state = 0},
  [3487] = {.lex_state = 0},
  [3488] = {.lex_state = 0},
  [3489] = {.lex_state = 71},
  [3490] = {.lex_state = 0},
  [3491] = {.lex_state = 71},
  [3492] = {.lex_state = 0},
  [3493] = {.lex_state = 71},
  [3494] = {.lex_state = 71},
  [3495] = {.lex_state = 0},
  [3496] = {.lex_state = 0},
  [3497] = {.lex_state = 71},
  [3498] = {.lex_state = 0, .external_lex_state = 4},
  [3499] = {.lex_state = 0, .external_lex_state = 4},
  [3500] = {.lex_state = 71},
  [3501] = {.lex_state = 71},
  [3502] = {.lex_state = 0, .external_lex_state = 4},
  [3503] = {.lex_state = 71},
  [3504] = {.lex_state = 0, .external_lex_state = 4},
  [3505] = {.lex_state = 71},
  [3506] = {.lex_state = 71},
  [3507] = {.lex_state = 0, .external_lex_state = 4},
  [3508] = {.lex_state = 0, .external_lex_state = 4},
  [3509] = {.lex_state = 0},
  [3510] = {.lex_state = 71},
  [3511] = {.lex_state = 0, .external_lex_state = 4},
  [3512] = {.lex_state = 0, .external_lex_state = 4},
  [3513] = {.lex_state = 0, .external_lex_state = 4},
  [3514] = {.lex_state = 0},
  [3515] = {.lex_state = 0},
  [3516] = {.lex_state = 0},
  [3517] = {.lex_state = 0, .external_lex_state = 4},
  [3518] = {.lex_state = 71},
  [3519] = {.lex_state = 71},
  [3520] = {.lex_state = 0},
  [3521] = {.lex_state = 0},
  [3522] = {.lex_state = 71},
  [3523] = {.lex_state = 71, .external_lex_state = 4},
  [3524] = {.lex_state = 0},
  [3525] = {.lex_state = 2},
  [3526] = {.lex_state = 71},
  [3527] = {.lex_state = 0},
  [3528] = {.lex_state = 0},
  [3529] = {.lex_state = 0},
  [3530] = {.lex_state = 71, .external_lex_state = 4},
  [3531] = {.lex_state = 0},
  [3532] = {.lex_state = 0},
  [3533] = {.lex_state = 71},
  [3534] = {.lex_state = 0},
  [3535] = {.lex_state = 71},
  [3536] = {.lex_state = 0},
  [3537] = {.lex_state = 0},
  [3538] = {.lex_state = 0},
  [3539] = {.lex_state = 71},
  [3540] = {.lex_state = 13, .external_lex_state = 6},
  [3541] = {.lex_state = 71},
  [3542] = {.lex_state = 71},
  [3543] = {.lex_state = 0, .external_lex_state = 4},
  [3544] = {.lex_state = 0, .external_lex_state = 4},
  [3545] = {.lex_state = 0, .external_lex_state = 4},
  [3546] = {.lex_state = 0, .external_lex_state = 4},
  [3547] = {.lex_state = 0, .external_lex_state = 4},
  [3548] = {.lex_state = 71},
  [3549] = {.lex_state = 0, .external_lex_state = 4},
  [3550] = {.lex_state = 71},
  [3551] = {.lex_state = 71},
  [3552] = {.lex_state = 0, .external_lex_state = 4},
  [3553] = {.lex_state = 71},
  [3554] = {.lex_state = 71},
  [3555] = {.lex_state = 0},
  [3556] = {.lex_state = 71},
  [3557] = {.lex_state = 71},
  [3558] = {.lex_state = 71},
  [3559] = {.lex_state = 0},
  [3560] = {.lex_state = 0},
  [3561] = {.lex_state = 0},
  [3562] = {.lex_state = 0, .external_lex_state = 4},
  [3563] = {.lex_state = 0, .external_lex_state = 4},
  [3564] = {.lex_state = 0, .external_lex_state = 4},
  [3565] = {.lex_state = 0, .external_lex_state = 4},
  [3566] = {.lex_state = 0, .external_lex_state = 4},
  [3567] = {.lex_state = 0, .external_lex_state = 4},
  [3568] = {.lex_state = 71, .external_lex_state = 4},
  [3569] = {.lex_state = 0},
  [3570] = {.lex_state = 0},
  [3571] = {.lex_state = 71},
  [3572] = {.lex_state = 0},
  [3573] = {.lex_state = 0, .external_lex_state = 4},
  [3574] = {.lex_state = 0, .external_lex_state = 4},
  [3575] = {.lex_state = 0, .external_lex_state = 4},
  [3576] = {.lex_state = 71},
  [3577] = {.lex_state = 0, .external_lex_state = 4},
  [3578] = {.lex_state = 0},
  [3579] = {.lex_state = 71},
  [3580] = {.lex_state = 0},
  [3581] = {.lex_state = 0, .external_lex_state = 4},
  [3582] = {.lex_state = 0},
  [3583] = {.lex_state = 71},
  [3584] = {.lex_state = 0},
  [3585] = {.lex_state = 71},
  [3586] = {.lex_state = 0},
  [3587] = {.lex_state = 0},
  [3588] = {.lex_state = 0},
  [3589] = {.lex_state = 71},
  [3590] = {.lex_state = 71},
  [3591] = {.lex_state = 0},
  [3592] = {.lex_state = 0},
  [3593] = {.lex_state = 71},
  [3594] = {.lex_state = 71},
  [3595] = {.lex_state = 0},
  [3596] = {.lex_state = 0, .external_lex_state = 4},
  [3597] = {.lex_state = 0},
  [3598] = {.lex_state = 0, .external_lex_state = 4},
  [3599] = {.lex_state = 0},
  [3600] = {.lex_state = 0, .external_lex_state = 4},
  [3601] = {.lex_state = 0},
  [3602] = {.lex_state = 71},
  [3603] = {.lex_state = 71},
  [3604] = {.lex_state = 0},
  [3605] = {.lex_state = 0, .external_lex_state = 4},
  [3606] = {.lex_state = 71},
  [3607] = {.lex_state = 0, .external_lex_state = 4},
  [3608] = {.lex_state = 71},
  [3609] = {.lex_state = 0, .external_lex_state = 4},
  [3610] = {.lex_state = 71},
  [3611] = {.lex_state = 71},
  [3612] = {.lex_state = 0},
  [3613] = {.lex_state = 0},
  [3614] = {.lex_state = 71},
  [3615] = {.lex_state = 0},
  [3616] = {.lex_state = 0, .external_lex_state = 4},
  [3617] = {.lex_state = 0},
  [3618] = {.lex_state = 71},
  [3619] = {.lex_state = 0, .external_lex_state = 4},
  [3620] = {.lex_state = 71},
  [3621] = {.lex_state = 71},
  [3622] = {.lex_state = 0},
  [3623] = {.lex_state = 0, .external_lex_state = 4},
  [3624] = {.lex_state = 71},
  [3625] = {.lex_state = 0, .external_lex_state = 4},
  [3626] = {.lex_state = 71},
  [3627] = {.lex_state = 0, .external_lex_state = 4},
  [3628] = {.lex_state = 71},
  [3629] = {.lex_state = 0},
  [3630] = {.lex_state = 71},
  [3631] = {.lex_state = 71},
  [3632] = {.lex_state = 0, .external_lex_state = 4},
  [3633] = {.lex_state = 0},
  [3634] = {.lex_state = 0, .external_lex_state = 4},
  [3635] = {.lex_state = 0},
  [3636] = {.lex_state = 71},
  [3637] = {.lex_state = 0},
  [3638] = {.lex_state = 71},
  [3639] = {.lex_state = 0},
  [3640] = {.lex_state = 71},
  [3641] = {.lex_state = 71},
  [3642] = {.lex_state = 71},
  [3643] = {.lex_state = 0},
  [3644] = {.lex_state = 0},
  [3645] = {.lex_state = 71},
  [3646] = {.lex_state = 71},
  [3647] = {.lex_state = 71},
  [3648] = {.lex_state = 71},
  [3649] = {.lex_state = 71},
  [3650] = {.lex_state = 71},
  [3651] = {.lex_state = 71},
  [3652] = {.lex_state = 71},
  [3653] = {.lex_state = 0},
  [3654] = {.lex_state = 71},
  [3655] = {.lex_state = 71},
  [3656] = {.lex_state = 71},
  [3657] = {.lex_state = 71},
  [3658] = {.lex_state = 0},
  [3659] = {.lex_state = 71},
  [3660] = {.lex_state = 71},
  [3661] = {.lex_state = 71},
  [3662] = {.lex_state = 71},
  [3663] = {.lex_state = 71},
  [3664] = {.lex_state = 71},
  [3665] = {.lex_state = 0},
  [3666] = {.lex_state = 71},
  [3667] = {.lex_state = 71},
  [3668] = {.lex_state = 0, .external_lex_state = 4},
  [3669] = {.lex_state = 0},
  [3670] = {.lex_state = 71},
  [3671] = {.lex_state = 0, .external_lex_state = 4},
  [3672] = {.lex_state = 0},
  [3673] = {.lex_state = 0},
  [3674] = {.lex_state = 71},
  [3675] = {.lex_state = 0, .external_lex_state = 4},
  [3676] = {.lex_state = 71},
  [3677] = {.lex_state = 0},
  [3678] = {.lex_state = 0},
  [3679] = {.lex_state = 0},
  [3680] = {.lex_state = 71},
  [3681] = {.lex_state = 71},
  [3682] = {.lex_state = 71},
  [3683] = {.lex_state = 71},
  [3684] = {.lex_state = 0, .external_lex_state = 4},
  [3685] = {.lex_state = 0, .external_lex_state = 4},
  [3686] = {.lex_state = 71},
  [3687] = {.lex_state = 71},
  [3688] = {.lex_state = 0},
  [3689] = {.lex_state = 0},
  [3690] = {.lex_state = 71},
  [3691] = {.lex_state = 71},
  [3692] = {.lex_state = 71},
  [3693] = {.lex_state = 71},
  [3694] = {.lex_state = 71},
  [3695] = {.lex_state = 71},
  [3696] = {.lex_state = 71},
  [3697] = {.lex_state = 71},
  [3698] = {.lex_state = 71},
  [3699] = {.lex_state = 71},
  [3700] = {.lex_state = 0, .external_lex_state = 4},
  [3701] = {.lex_state = 0, .external_lex_state = 4},
  [3702] = {.lex_state = 0, .external_lex_state = 4},
  [3703] = {.lex_state = 71},
  [3704] = {.lex_state = 71},
  [3705] = {.lex_state = 71},
  [3706] = {.lex_state = 0},
  [3707] = {.lex_state = 0},
  [3708] = {.lex_state = 71},
  [3709] = {.lex_state = 71},
  [3710] = {.lex_state = 71},
  [3711] = {.lex_state = 71},
  [3712] = {.lex_state = 71},
  [3713] = {.lex_state = 71},
  [3714] = {.lex_state = 0},
  [3715] = {.lex_state = 0},
  [3716] = {.lex_state = 0},
  [3717] = {.lex_state = 0},
  [3718] = {.lex_state = 0},
  [3719] = {.lex_state = 0},
  [3720] = {.lex_state = 71},
  [3721] = {.lex_state = 0},
  [3722] = {.lex_state = 0},
  [3723] = {.lex_state = 71},
  [3724] = {.lex_state = 0},
  [3725] = {.lex_state = 0},
  [3726] = {.lex_state = 0},
  [3727] = {.lex_state = 0},
  [3728] = {.lex_state = 71},
  [3729] = {.lex_state = 0},
  [3730] = {.lex_state = 71},
  [3731] = {.lex_state = 71},
  [3732] = {.lex_state = 0, .external_lex_state = 4},
  [3733] = {.lex_state = 71},
  [3734] = {.lex_state = 0},
  [3735] = {.lex_state = 71},
  [3736] = {.lex_state = 71},
  [3737] = {.lex_state = 0},
  [3738] = {.lex_state = 71},
  [3739] = {.lex_state = 71},
  [3740] = {.lex_state = 71},
  [3741] = {.lex_state = 0},
  [3742] = {.lex_state = 71},
  [3743] = {.lex_state = 71},
  [3744] = {.lex_state = 71},
  [3745] = {.lex_state = 71},
  [3746] = {.lex_state = 71},
  [3747] = {.lex_state = 71},
  [3748] = {.lex_state = 71},
  [3749] = {.lex_state = 0},
  [3750] = {.lex_state = 71},
  [3751] = {.lex_state = 71},
  [3752] = {.lex_state = 71},
  [3753] = {.lex_state = 71},
  [3754] = {.lex_state = 0},
  [3755] = {.lex_state = 71},
  [3756] = {.lex_state = 71},
  [3757] = {.lex_state = 71},
  [3758] = {.lex_state = 71},
  [3759] = {.lex_state = 71},
  [3760] = {.lex_state = 71},
  [3761] = {.lex_state = 71},
  [3762] = {.lex_state = 71},
  [3763] = {.lex_state = 71},
  [3764] = {.lex_state = 71},
  [3765] = {.lex_state = 0},
  [3766] = {.lex_state = 71},
  [3767] = {.lex_state = 71},
  [3768] = {.lex_state = 71},
  [3769] = {.lex_state = 71},
  [3770] = {.lex_state = 71},
  [3771] = {.lex_state = 71},
  [3772] = {.lex_state = 0},
  [3773] = {.lex_state = 71},
  [3774] = {.lex_state = 0},
  [3775] = {.lex_state = 71},
  [3776] = {.lex_state = 0, .external_lex_state = 4},
  [3777] = {.lex_state = 0},
  [3778] = {.lex_state = 71},
  [3779] = {.lex_state = 0},
  [3780] = {.lex_state = 71},
  [3781] = {.lex_state = 71},
  [3782] = {.lex_state = 0},
  [3783] = {.lex_state = 0},
  [3784] = {.lex_state = 0},
  [3785] = {.lex_state = 71},
  [3786] = {.lex_state = 71},
  [3787] = {.lex_state = 0},
  [3788] = {.lex_state = 0},
  [3789] = {.lex_state = 0},
  [3790] = {.lex_state = 71},
  [3791] = {.lex_state = 71},
  [3792] = {.lex_state = 0, .external_lex_state = 4},
  [3793] = {.lex_state = 0},
  [3794] = {.lex_state = 71},
  [3795] = {.lex_state = 71},
  [3796] = {.lex_state = 0},
  [3797] = {.lex_state = 0},
  [3798] = {.lex_state = 0},
  [3799] = {.lex_state = 0},
  [3800] = {.lex_state = 71},
  [3801] = {.lex_state = 71},
  [3802] = {.lex_state = 71},
  [3803] = {.lex_state = 0},
  [3804] = {.lex_state = 0, .external_lex_state = 4},
  [3805] = {.lex_state = 0, .external_lex_state = 4},
  [3806] = {.lex_state = 0},
  [3807] = {.lex_state = 71},
  [3808] = {.lex_state = 0},
  [3809] = {.lex_state = 71},
  [3810] = {.lex_state = 0},
  [3811] = {.lex_state = 71},
  [3812] = {.lex_state = 71},
  [3813] = {.lex_state = 71},
  [3814] = {.lex_state = 71},
  [3815] = {.lex_state = 71},
  [3816] = {.lex_state = 0},
  [3817] = {.lex_state = 0},
  [3818] = {.lex_state = 71},
  [3819] = {.lex_state = 0, .external_lex_state = 4},
  [3820] = {.lex_state = 0},
  [3821] = {.lex_state = 71},
  [3822] = {.lex_state = 71},
  [3823] = {.lex_state = 71},
  [3824] = {.lex_state = 0},
  [3825] = {.lex_state = 0},
  [3826] = {.lex_state = 0},
  [3827] = {.lex_state = 71},
  [3828] = {.lex_state = 71},
  [3829] = {.lex_state = 71},
  [3830] = {.lex_state = 0},
  [3831] = {.lex_state = 0},
  [3832] = {.lex_state = 71},
  [3833] = {.lex_state = 0},
  [3834] = {.lex_state = 71},
  [3835] = {.lex_state = 71},
  [3836] = {.lex_state = 71},
  [3837] = {.lex_state = 71},
  [3838] = {.lex_state = 71},
  [3839] = {.lex_state = 0},
  [3840] = {.lex_state = 0, .external_lex_state = 4},
  [3841] = {.lex_state = 0},
  [3842] = {.lex_state = 0},
  [3843] = {.lex_state = 0},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 71},
  [3846] = {.lex_state = 0},
  [3847] = {.lex_state = 0},
  [3848] = {.lex_state = 0},
  [3849] = {.lex_state = 71},
  [3850] = {.lex_state = 0},
  [3851] = {.lex_state = 0},
  [3852] = {.lex_state = 0},
  [3853] = {.lex_state = 71},
  [3854] = {.lex_state = 0},
  [3855] = {.lex_state = 0},
  [3856] = {.lex_state = 0},
  [3857] = {.lex_state = 1},
  [3858] = {.lex_state = 0},
  [3859] = {.lex_state = 0},
  [3860] = {.lex_state = 0},
  [3861] = {.lex_state = 0},
  [3862] = {.lex_state = 71},
  [3863] = {.lex_state = 0},
  [3864] = {.lex_state = 0},
  [3865] = {.lex_state = 0},
  [3866] = {.lex_state = 0},
  [3867] = {.lex_state = 0},
  [3868] = {.lex_state = 0},
  [3869] = {.lex_state = 71},
  [3870] = {.lex_state = 0},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 71},
  [3873] = {.lex_state = 0},
  [3874] = {.lex_state = 0},
  [3875] = {.lex_state = 71},
  [3876] = {.lex_state = 0},
  [3877] = {.lex_state = 0},
  [3878] = {.lex_state = 71},
  [3879] = {.lex_state = 0},
  [3880] = {.lex_state = 71},
  [3881] = {.lex_state = 71},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 0},
  [3884] = {.lex_state = 0},
  [3885] = {.lex_state = 0},
  [3886] = {.lex_state = 0},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 0},
  [3889] = {.lex_state = 0},
  [3890] = {.lex_state = 1},
  [3891] = {.lex_state = 1},
  [3892] = {.lex_state = 0},
  [3893] = {.lex_state = 0},
  [3894] = {.lex_state = 0},
  [3895] = {.lex_state = 0},
  [3896] = {.lex_state = 71},
  [3897] = {.lex_state = 0},
  [3898] = {.lex_state = 71},
  [3899] = {.lex_state = 71},
  [3900] = {.lex_state = 0},
  [3901] = {.lex_state = 71},
  [3902] = {.lex_state = 9},
  [3903] = {.lex_state = 71},
  [3904] = {.lex_state = 71},
  [3905] = {.lex_state = 0},
  [3906] = {.lex_state = 9},
  [3907] = {.lex_state = 0},
  [3908] = {.lex_state = 0},
  [3909] = {.lex_state = 0},
  [3910] = {.lex_state = 0},
  [3911] = {.lex_state = 0},
  [3912] = {.lex_state = 0},
  [3913] = {.lex_state = 0},
  [3914] = {.lex_state = 0},
  [3915] = {.lex_state = 71},
  [3916] = {.lex_state = 71},
  [3917] = {.lex_state = 71},
  [3918] = {.lex_state = 0},
  [3919] = {.lex_state = 0},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 9},
  [3922] = {.lex_state = 0},
  [3923] = {.lex_state = 0},
  [3924] = {.lex_state = 0},
  [3925] = {.lex_state = 0},
  [3926] = {.lex_state = 0},
  [3927] = {.lex_state = 71},
  [3928] = {.lex_state = 71},
  [3929] = {.lex_state = 0},
  [3930] = {.lex_state = 0},
  [3931] = {.lex_state = 0},
  [3932] = {.lex_state = 71},
  [3933] = {.lex_state = 0},
  [3934] = {.lex_state = 0},
  [3935] = {.lex_state = 0},
  [3936] = {.lex_state = 1},
  [3937] = {.lex_state = 0},
  [3938] = {.lex_state = 0},
  [3939] = {.lex_state = 71},
  [3940] = {.lex_state = 0},
  [3941] = {.lex_state = 0},
  [3942] = {.lex_state = 0},
  [3943] = {.lex_state = 0},
  [3944] = {.lex_state = 0},
  [3945] = {.lex_state = 0},
  [3946] = {.lex_state = 0},
  [3947] = {.lex_state = 0},
  [3948] = {.lex_state = 0},
  [3949] = {.lex_state = 0},
  [3950] = {.lex_state = 71},
  [3951] = {.lex_state = 71},
  [3952] = {.lex_state = 0},
  [3953] = {.lex_state = 0},
  [3954] = {.lex_state = 0},
  [3955] = {.lex_state = 71},
  [3956] = {.lex_state = 0},
  [3957] = {.lex_state = 71},
  [3958] = {.lex_state = 0},
  [3959] = {.lex_state = 0},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 0},
  [3962] = {.lex_state = 0},
  [3963] = {.lex_state = 0},
  [3964] = {.lex_state = 0},
  [3965] = {.lex_state = 71},
  [3966] = {.lex_state = 0},
  [3967] = {.lex_state = 0},
  [3968] = {.lex_state = 0},
  [3969] = {.lex_state = 0},
  [3970] = {.lex_state = 0},
  [3971] = {.lex_state = 0},
  [3972] = {.lex_state = 0},
  [3973] = {.lex_state = 0},
  [3974] = {.lex_state = 0},
  [3975] = {.lex_state = 0},
  [3976] = {.lex_state = 0},
  [3977] = {.lex_state = 0},
  [3978] = {.lex_state = 0},
  [3979] = {.lex_state = 0},
  [3980] = {.lex_state = 0},
  [3981] = {.lex_state = 0},
  [3982] = {.lex_state = 0},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 0},
  [3985] = {.lex_state = 0},
  [3986] = {.lex_state = 0},
  [3987] = {.lex_state = 0},
  [3988] = {.lex_state = 0},
  [3989] = {.lex_state = 0},
  [3990] = {.lex_state = 0},
  [3991] = {.lex_state = 0},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 0},
  [3994] = {.lex_state = 0},
  [3995] = {.lex_state = 0},
  [3996] = {.lex_state = 71},
  [3997] = {.lex_state = 0},
  [3998] = {.lex_state = 0},
  [3999] = {.lex_state = 0},
  [4000] = {.lex_state = 0},
  [4001] = {.lex_state = 71},
  [4002] = {.lex_state = 0},
  [4003] = {.lex_state = 0},
  [4004] = {.lex_state = 71},
  [4005] = {.lex_state = 0},
  [4006] = {.lex_state = 71},
  [4007] = {.lex_state = 0},
  [4008] = {.lex_state = 0},
  [4009] = {.lex_state = 0},
  [4010] = {.lex_state = 0},
  [4011] = {.lex_state = 0},
  [4012] = {.lex_state = 0},
  [4013] = {.lex_state = 0},
  [4014] = {.lex_state = 0},
  [4015] = {.lex_state = 71},
  [4016] = {.lex_state = 71},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 71},
  [4019] = {.lex_state = 0},
  [4020] = {.lex_state = 0},
  [4021] = {.lex_state = 0},
  [4022] = {.lex_state = 0},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 0},
  [4025] = {.lex_state = 0},
  [4026] = {.lex_state = 0},
  [4027] = {.lex_state = 0},
  [4028] = {.lex_state = 0},
  [4029] = {.lex_state = 71},
  [4030] = {.lex_state = 71},
  [4031] = {.lex_state = 0},
  [4032] = {.lex_state = 71},
  [4033] = {.lex_state = 0},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 71},
  [4036] = {.lex_state = 71},
  [4037] = {.lex_state = 0},
  [4038] = {.lex_state = 0},
  [4039] = {.lex_state = 0},
  [4040] = {.lex_state = 0},
  [4041] = {.lex_state = 71},
  [4042] = {.lex_state = 71},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 0},
  [4045] = {.lex_state = 0},
  [4046] = {.lex_state = 0},
  [4047] = {.lex_state = 0},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 71},
  [4050] = {.lex_state = 0},
  [4051] = {.lex_state = 0},
  [4052] = {.lex_state = 71},
  [4053] = {.lex_state = 0},
  [4054] = {.lex_state = 71},
  [4055] = {.lex_state = 0},
  [4056] = {.lex_state = 0},
  [4057] = {.lex_state = 0},
  [4058] = {.lex_state = 0},
  [4059] = {.lex_state = 71},
  [4060] = {.lex_state = 0},
  [4061] = {.lex_state = 9},
  [4062] = {.lex_state = 71},
  [4063] = {.lex_state = 71},
  [4064] = {.lex_state = 0},
  [4065] = {.lex_state = 0},
  [4066] = {.lex_state = 71},
  [4067] = {.lex_state = 0},
  [4068] = {.lex_state = 0},
  [4069] = {.lex_state = 71},
  [4070] = {.lex_state = 0},
  [4071] = {.lex_state = 0},
  [4072] = {.lex_state = 0},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 0},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 0},
  [4077] = {.lex_state = 71},
  [4078] = {.lex_state = 71},
  [4079] = {.lex_state = 0},
  [4080] = {.lex_state = 71},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 0},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 71},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 71},
  [4087] = {.lex_state = 71},
  [4088] = {.lex_state = 0},
  [4089] = {.lex_state = 0},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 0},
  [4092] = {.lex_state = 0},
  [4093] = {.lex_state = 71},
  [4094] = {.lex_state = 71},
  [4095] = {.lex_state = 0},
  [4096] = {.lex_state = 0},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 71},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 0},
  [4104] = {.lex_state = 0},
  [4105] = {.lex_state = 9},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 0},
  [4109] = {.lex_state = 71},
  [4110] = {.lex_state = 0},
  [4111] = {.lex_state = 0},
  [4112] = {.lex_state = 0},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 71},
  [4116] = {.lex_state = 71},
  [4117] = {.lex_state = 71},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 71},
  [4121] = {.lex_state = 0},
  [4122] = {.lex_state = 0},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 0},
  [4126] = {.lex_state = 0},
  [4127] = {.lex_state = 0},
  [4128] = {.lex_state = 71},
  [4129] = {.lex_state = 71},
  [4130] = {.lex_state = 0},
  [4131] = {.lex_state = 71},
  [4132] = {.lex_state = 71},
  [4133] = {.lex_state = 71},
  [4134] = {.lex_state = 71},
  [4135] = {.lex_state = 71},
  [4136] = {.lex_state = 71},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 71},
  [4139] = {.lex_state = 0},
  [4140] = {.lex_state = 0},
  [4141] = {.lex_state = 1},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 0},
  [4144] = {.lex_state = 0},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 0},
  [4148] = {.lex_state = 0},
  [4149] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(4130),
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [2] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2985),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(182),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(190),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(194),
    [anon_sym_number] = ACTIONS(194),
    [anon_sym_boolean] = ACTIONS(194),
    [anon_sym_string] = ACTIONS(194),
    [anon_sym_symbol] = ACTIONS(194),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [3] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2985),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(182),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(190),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(194),
    [anon_sym_number] = ACTIONS(194),
    [anon_sym_boolean] = ACTIONS(194),
    [anon_sym_string] = ACTIONS(194),
    [anon_sym_symbol] = ACTIONS(194),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [4] = {
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4107),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4107),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4107),
    [sym_spread_element] = STATE(3368),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1774),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3368),
    [sym_pair] = STATE(3368),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2737),
    [sym_computed_property_name] = STATE(2737),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_accessibility_modifier] = STATE(2194),
    [sym_override_modifier] = STATE(2226),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [aux_sym_object_repeat1] = STATE(3369),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(211),
    [anon_sym_export] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(217),
    [anon_sym_namespace] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(235),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_get] = ACTIONS(239),
    [anon_sym_set] = ACTIONS(239),
    [anon_sym_declare] = ACTIONS(241),
    [anon_sym_public] = ACTIONS(243),
    [anon_sym_private] = ACTIONS(243),
    [anon_sym_protected] = ACTIONS(243),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(247),
    [anon_sym_any] = ACTIONS(249),
    [anon_sym_number] = ACTIONS(249),
    [anon_sym_boolean] = ACTIONS(249),
    [anon_sym_string] = ACTIONS(249),
    [anon_sym_symbol] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [5] = {
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4107),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4107),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4107),
    [sym_spread_element] = STATE(3368),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1774),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3368),
    [sym_pair] = STATE(3368),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2737),
    [sym_computed_property_name] = STATE(2737),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_accessibility_modifier] = STATE(2194),
    [sym_override_modifier] = STATE(2226),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [aux_sym_object_repeat1] = STATE(3369),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(211),
    [anon_sym_export] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(217),
    [anon_sym_namespace] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(235),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_get] = ACTIONS(239),
    [anon_sym_set] = ACTIONS(239),
    [anon_sym_declare] = ACTIONS(241),
    [anon_sym_public] = ACTIONS(243),
    [anon_sym_private] = ACTIONS(243),
    [anon_sym_protected] = ACTIONS(243),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(247),
    [anon_sym_any] = ACTIONS(249),
    [anon_sym_number] = ACTIONS(249),
    [anon_sym_boolean] = ACTIONS(249),
    [anon_sym_string] = ACTIONS(249),
    [anon_sym_symbol] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [6] = {
    [sym_export_statement] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4107),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4107),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4107),
    [sym_spread_element] = STATE(3448),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1774),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2737),
    [sym_computed_property_name] = STATE(2737),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_accessibility_modifier] = STATE(2194),
    [sym_override_modifier] = STATE(2226),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(253),
    [anon_sym_export] = ACTIONS(255),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(257),
    [anon_sym_namespace] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(263),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(265),
    [anon_sym_readonly] = ACTIONS(267),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(271),
    [anon_sym_public] = ACTIONS(273),
    [anon_sym_private] = ACTIONS(273),
    [anon_sym_protected] = ACTIONS(273),
    [anon_sym_override] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(279),
    [anon_sym_number] = ACTIONS(279),
    [anon_sym_boolean] = ACTIONS(279),
    [anon_sym_string] = ACTIONS(279),
    [anon_sym_symbol] = ACTIONS(279),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [7] = {
    [sym_export_statement] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4107),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4107),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4107),
    [sym_spread_element] = STATE(3368),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1774),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3368),
    [sym_pair] = STATE(3368),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2737),
    [sym_computed_property_name] = STATE(2737),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_accessibility_modifier] = STATE(2194),
    [sym_override_modifier] = STATE(2226),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(26),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [aux_sym_object_repeat1] = STATE(3369),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(211),
    [anon_sym_export] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(217),
    [anon_sym_namespace] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(235),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_get] = ACTIONS(239),
    [anon_sym_set] = ACTIONS(239),
    [anon_sym_declare] = ACTIONS(241),
    [anon_sym_public] = ACTIONS(243),
    [anon_sym_private] = ACTIONS(243),
    [anon_sym_protected] = ACTIONS(243),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(247),
    [anon_sym_any] = ACTIONS(249),
    [anon_sym_number] = ACTIONS(249),
    [anon_sym_boolean] = ACTIONS(249),
    [anon_sym_string] = ACTIONS(249),
    [anon_sym_symbol] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [8] = {
    [sym_export_statement] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4107),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4107),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4107),
    [sym_spread_element] = STATE(3448),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1774),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2737),
    [sym_computed_property_name] = STATE(2737),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_accessibility_modifier] = STATE(2194),
    [sym_override_modifier] = STATE(2226),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(283),
    [anon_sym_export] = ACTIONS(285),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(291),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(293),
    [anon_sym_readonly] = ACTIONS(295),
    [anon_sym_get] = ACTIONS(297),
    [anon_sym_set] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(301),
    [anon_sym_private] = ACTIONS(301),
    [anon_sym_protected] = ACTIONS(301),
    [anon_sym_override] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_any] = ACTIONS(307),
    [anon_sym_number] = ACTIONS(307),
    [anon_sym_boolean] = ACTIONS(307),
    [anon_sym_string] = ACTIONS(307),
    [anon_sym_symbol] = ACTIONS(307),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [9] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [ts_builtin_sym_end] = ACTIONS(309),
    [sym_identifier] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(314),
    [anon_sym_default] = ACTIONS(317),
    [anon_sym_type] = ACTIONS(319),
    [anon_sym_namespace] = ACTIONS(322),
    [anon_sym_LBRACE] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(309),
    [anon_sym_typeof] = ACTIONS(328),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_var] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_const] = ACTIONS(340),
    [anon_sym_BANG] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(349),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_await] = ACTIONS(358),
    [anon_sym_while] = ACTIONS(361),
    [anon_sym_do] = ACTIONS(364),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_with] = ACTIONS(370),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_continue] = ACTIONS(376),
    [anon_sym_debugger] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_throw] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_yield] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_SLASH] = ACTIONS(400),
    [anon_sym_class] = ACTIONS(403),
    [anon_sym_async] = ACTIONS(406),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_new] = ACTIONS(412),
    [anon_sym_PLUS] = ACTIONS(328),
    [anon_sym_DASH] = ACTIONS(328),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_void] = ACTIONS(328),
    [anon_sym_delete] = ACTIONS(328),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [anon_sym_SQUOTE] = ACTIONS(421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(424),
    [sym_number] = ACTIONS(427),
    [sym_this] = ACTIONS(430),
    [sym_super] = ACTIONS(430),
    [sym_true] = ACTIONS(430),
    [sym_false] = ACTIONS(430),
    [sym_null] = ACTIONS(430),
    [sym_undefined] = ACTIONS(433),
    [anon_sym_AT] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(439),
    [anon_sym_readonly] = ACTIONS(439),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
    [anon_sym_declare] = ACTIONS(442),
    [anon_sym_public] = ACTIONS(439),
    [anon_sym_private] = ACTIONS(439),
    [anon_sym_protected] = ACTIONS(439),
    [anon_sym_override] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(439),
    [anon_sym_number] = ACTIONS(439),
    [anon_sym_boolean] = ACTIONS(439),
    [anon_sym_string] = ACTIONS(439),
    [anon_sym_symbol] = ACTIONS(439),
    [anon_sym_abstract] = ACTIONS(448),
    [anon_sym_interface] = ACTIONS(451),
    [anon_sym_enum] = ACTIONS(454),
  },
  [10] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(457),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [11] = {
    [sym_export_statement] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(461),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(461),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [12] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(465),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(465),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [13] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(469),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(469),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [14] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [15] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [16] = {
    [sym_export_statement] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [17] = {
    [sym_export_statement] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [18] = {
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [ts_builtin_sym_end] = ACTIONS(481),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [19] = {
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [20] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [21] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [22] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [ts_builtin_sym_end] = ACTIONS(481),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [23] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [ts_builtin_sym_end] = ACTIONS(489),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [24] = {
    [sym_export_statement] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [25] = {
    [sym_export_statement] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [26] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [27] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [28] = {
    [sym_export_statement] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_program_repeat1] = STATE(26),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [29] = {
    [sym_export_statement] = STATE(4080),
    [sym_declaration] = STATE(4080),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(4080),
    [sym_expression_statement] = STATE(4080),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(4080),
    [sym_if_statement] = STATE(4080),
    [sym_switch_statement] = STATE(4080),
    [sym_for_statement] = STATE(4080),
    [sym_for_in_statement] = STATE(4080),
    [sym_while_statement] = STATE(4080),
    [sym_do_statement] = STATE(4080),
    [sym_try_statement] = STATE(4080),
    [sym_with_statement] = STATE(4080),
    [sym_break_statement] = STATE(4080),
    [sym_continue_statement] = STATE(4080),
    [sym_debugger_statement] = STATE(4080),
    [sym_return_statement] = STATE(4080),
    [sym_throw_statement] = STATE(4080),
    [sym_empty_statement] = STATE(4080),
    [sym_labeled_statement] = STATE(4080),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [30] = {
    [sym_export_statement] = STATE(693),
    [sym_declaration] = STATE(693),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(693),
    [sym_expression_statement] = STATE(693),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(693),
    [sym_if_statement] = STATE(693),
    [sym_switch_statement] = STATE(693),
    [sym_for_statement] = STATE(693),
    [sym_for_in_statement] = STATE(693),
    [sym_while_statement] = STATE(693),
    [sym_do_statement] = STATE(693),
    [sym_try_statement] = STATE(693),
    [sym_with_statement] = STATE(693),
    [sym_break_statement] = STATE(693),
    [sym_continue_statement] = STATE(693),
    [sym_debugger_statement] = STATE(693),
    [sym_return_statement] = STATE(693),
    [sym_throw_statement] = STATE(693),
    [sym_empty_statement] = STATE(693),
    [sym_labeled_statement] = STATE(693),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [31] = {
    [sym_export_statement] = STATE(627),
    [sym_declaration] = STATE(627),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(627),
    [sym_expression_statement] = STATE(627),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(627),
    [sym_if_statement] = STATE(627),
    [sym_switch_statement] = STATE(627),
    [sym_for_statement] = STATE(627),
    [sym_for_in_statement] = STATE(627),
    [sym_while_statement] = STATE(627),
    [sym_do_statement] = STATE(627),
    [sym_try_statement] = STATE(627),
    [sym_with_statement] = STATE(627),
    [sym_break_statement] = STATE(627),
    [sym_continue_statement] = STATE(627),
    [sym_debugger_statement] = STATE(627),
    [sym_return_statement] = STATE(627),
    [sym_throw_statement] = STATE(627),
    [sym_empty_statement] = STATE(627),
    [sym_labeled_statement] = STATE(627),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [32] = {
    [sym_export_statement] = STATE(660),
    [sym_declaration] = STATE(660),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(660),
    [sym_expression_statement] = STATE(660),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(660),
    [sym_if_statement] = STATE(660),
    [sym_switch_statement] = STATE(660),
    [sym_for_statement] = STATE(660),
    [sym_for_in_statement] = STATE(660),
    [sym_while_statement] = STATE(660),
    [sym_do_statement] = STATE(660),
    [sym_try_statement] = STATE(660),
    [sym_with_statement] = STATE(660),
    [sym_break_statement] = STATE(660),
    [sym_continue_statement] = STATE(660),
    [sym_debugger_statement] = STATE(660),
    [sym_return_statement] = STATE(660),
    [sym_throw_statement] = STATE(660),
    [sym_empty_statement] = STATE(660),
    [sym_labeled_statement] = STATE(660),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [33] = {
    [sym_export_statement] = STATE(742),
    [sym_declaration] = STATE(741),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(740),
    [sym_expression_statement] = STATE(739),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(738),
    [sym_if_statement] = STATE(735),
    [sym_switch_statement] = STATE(618),
    [sym_for_statement] = STATE(733),
    [sym_for_in_statement] = STATE(732),
    [sym_while_statement] = STATE(731),
    [sym_do_statement] = STATE(726),
    [sym_try_statement] = STATE(725),
    [sym_with_statement] = STATE(724),
    [sym_break_statement] = STATE(723),
    [sym_continue_statement] = STATE(666),
    [sym_debugger_statement] = STATE(720),
    [sym_return_statement] = STATE(719),
    [sym_throw_statement] = STATE(718),
    [sym_empty_statement] = STATE(716),
    [sym_labeled_statement] = STATE(713),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [34] = {
    [sym_export_statement] = STATE(691),
    [sym_declaration] = STATE(691),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(691),
    [sym_expression_statement] = STATE(691),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(691),
    [sym_if_statement] = STATE(691),
    [sym_switch_statement] = STATE(691),
    [sym_for_statement] = STATE(691),
    [sym_for_in_statement] = STATE(691),
    [sym_while_statement] = STATE(691),
    [sym_do_statement] = STATE(691),
    [sym_try_statement] = STATE(691),
    [sym_with_statement] = STATE(691),
    [sym_break_statement] = STATE(691),
    [sym_continue_statement] = STATE(691),
    [sym_debugger_statement] = STATE(691),
    [sym_return_statement] = STATE(691),
    [sym_throw_statement] = STATE(691),
    [sym_empty_statement] = STATE(691),
    [sym_labeled_statement] = STATE(691),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [35] = {
    [sym_export_statement] = STATE(693),
    [sym_declaration] = STATE(693),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(693),
    [sym_expression_statement] = STATE(693),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(693),
    [sym_if_statement] = STATE(693),
    [sym_switch_statement] = STATE(693),
    [sym_for_statement] = STATE(693),
    [sym_for_in_statement] = STATE(693),
    [sym_while_statement] = STATE(693),
    [sym_do_statement] = STATE(693),
    [sym_try_statement] = STATE(693),
    [sym_with_statement] = STATE(693),
    [sym_break_statement] = STATE(693),
    [sym_continue_statement] = STATE(693),
    [sym_debugger_statement] = STATE(693),
    [sym_return_statement] = STATE(693),
    [sym_throw_statement] = STATE(693),
    [sym_empty_statement] = STATE(693),
    [sym_labeled_statement] = STATE(693),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [36] = {
    [sym_export_statement] = STATE(660),
    [sym_declaration] = STATE(660),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(660),
    [sym_expression_statement] = STATE(660),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(660),
    [sym_if_statement] = STATE(660),
    [sym_switch_statement] = STATE(660),
    [sym_for_statement] = STATE(660),
    [sym_for_in_statement] = STATE(660),
    [sym_while_statement] = STATE(660),
    [sym_do_statement] = STATE(660),
    [sym_try_statement] = STATE(660),
    [sym_with_statement] = STATE(660),
    [sym_break_statement] = STATE(660),
    [sym_continue_statement] = STATE(660),
    [sym_debugger_statement] = STATE(660),
    [sym_return_statement] = STATE(660),
    [sym_throw_statement] = STATE(660),
    [sym_empty_statement] = STATE(660),
    [sym_labeled_statement] = STATE(660),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [37] = {
    [sym_export_statement] = STATE(742),
    [sym_declaration] = STATE(741),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(740),
    [sym_expression_statement] = STATE(739),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(738),
    [sym_if_statement] = STATE(735),
    [sym_switch_statement] = STATE(618),
    [sym_for_statement] = STATE(733),
    [sym_for_in_statement] = STATE(732),
    [sym_while_statement] = STATE(731),
    [sym_do_statement] = STATE(726),
    [sym_try_statement] = STATE(725),
    [sym_with_statement] = STATE(724),
    [sym_break_statement] = STATE(723),
    [sym_continue_statement] = STATE(666),
    [sym_debugger_statement] = STATE(720),
    [sym_return_statement] = STATE(719),
    [sym_throw_statement] = STATE(718),
    [sym_empty_statement] = STATE(716),
    [sym_labeled_statement] = STATE(713),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [38] = {
    [sym_export_statement] = STATE(3579),
    [sym_declaration] = STATE(3579),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(3579),
    [sym_expression_statement] = STATE(3579),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(3579),
    [sym_if_statement] = STATE(3579),
    [sym_switch_statement] = STATE(3579),
    [sym_for_statement] = STATE(3579),
    [sym_for_in_statement] = STATE(3579),
    [sym_while_statement] = STATE(3579),
    [sym_do_statement] = STATE(3579),
    [sym_try_statement] = STATE(3579),
    [sym_with_statement] = STATE(3579),
    [sym_break_statement] = STATE(3579),
    [sym_continue_statement] = STATE(3579),
    [sym_debugger_statement] = STATE(3579),
    [sym_return_statement] = STATE(3579),
    [sym_throw_statement] = STATE(3579),
    [sym_empty_statement] = STATE(3579),
    [sym_labeled_statement] = STATE(3579),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [39] = {
    [sym_export_statement] = STATE(756),
    [sym_declaration] = STATE(756),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(756),
    [sym_expression_statement] = STATE(756),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(756),
    [sym_if_statement] = STATE(756),
    [sym_switch_statement] = STATE(756),
    [sym_for_statement] = STATE(756),
    [sym_for_in_statement] = STATE(756),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(756),
    [sym_try_statement] = STATE(756),
    [sym_with_statement] = STATE(756),
    [sym_break_statement] = STATE(756),
    [sym_continue_statement] = STATE(756),
    [sym_debugger_statement] = STATE(756),
    [sym_return_statement] = STATE(756),
    [sym_throw_statement] = STATE(756),
    [sym_empty_statement] = STATE(756),
    [sym_labeled_statement] = STATE(756),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [40] = {
    [sym_export_statement] = STATE(737),
    [sym_declaration] = STATE(737),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(737),
    [sym_expression_statement] = STATE(737),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(737),
    [sym_if_statement] = STATE(737),
    [sym_switch_statement] = STATE(737),
    [sym_for_statement] = STATE(737),
    [sym_for_in_statement] = STATE(737),
    [sym_while_statement] = STATE(737),
    [sym_do_statement] = STATE(737),
    [sym_try_statement] = STATE(737),
    [sym_with_statement] = STATE(737),
    [sym_break_statement] = STATE(737),
    [sym_continue_statement] = STATE(737),
    [sym_debugger_statement] = STATE(737),
    [sym_return_statement] = STATE(737),
    [sym_throw_statement] = STATE(737),
    [sym_empty_statement] = STATE(737),
    [sym_labeled_statement] = STATE(737),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [41] = {
    [sym_export_statement] = STATE(756),
    [sym_declaration] = STATE(756),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(756),
    [sym_expression_statement] = STATE(756),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(756),
    [sym_if_statement] = STATE(756),
    [sym_switch_statement] = STATE(756),
    [sym_for_statement] = STATE(756),
    [sym_for_in_statement] = STATE(756),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(756),
    [sym_try_statement] = STATE(756),
    [sym_with_statement] = STATE(756),
    [sym_break_statement] = STATE(756),
    [sym_continue_statement] = STATE(756),
    [sym_debugger_statement] = STATE(756),
    [sym_return_statement] = STATE(756),
    [sym_throw_statement] = STATE(756),
    [sym_empty_statement] = STATE(756),
    [sym_labeled_statement] = STATE(756),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [42] = {
    [sym_export_statement] = STATE(603),
    [sym_declaration] = STATE(603),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(603),
    [sym_expression_statement] = STATE(603),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_switch_statement] = STATE(603),
    [sym_for_statement] = STATE(603),
    [sym_for_in_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_do_statement] = STATE(603),
    [sym_try_statement] = STATE(603),
    [sym_with_statement] = STATE(603),
    [sym_break_statement] = STATE(603),
    [sym_continue_statement] = STATE(603),
    [sym_debugger_statement] = STATE(603),
    [sym_return_statement] = STATE(603),
    [sym_throw_statement] = STATE(603),
    [sym_empty_statement] = STATE(603),
    [sym_labeled_statement] = STATE(603),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [43] = {
    [sym_export_statement] = STATE(627),
    [sym_declaration] = STATE(627),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(627),
    [sym_expression_statement] = STATE(627),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(627),
    [sym_if_statement] = STATE(627),
    [sym_switch_statement] = STATE(627),
    [sym_for_statement] = STATE(627),
    [sym_for_in_statement] = STATE(627),
    [sym_while_statement] = STATE(627),
    [sym_do_statement] = STATE(627),
    [sym_try_statement] = STATE(627),
    [sym_with_statement] = STATE(627),
    [sym_break_statement] = STATE(627),
    [sym_continue_statement] = STATE(627),
    [sym_debugger_statement] = STATE(627),
    [sym_return_statement] = STATE(627),
    [sym_throw_statement] = STATE(627),
    [sym_empty_statement] = STATE(627),
    [sym_labeled_statement] = STATE(627),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [44] = {
    [sym_export_statement] = STATE(670),
    [sym_declaration] = STATE(667),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(664),
    [sym_expression_statement] = STATE(655),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(652),
    [sym_if_statement] = STATE(650),
    [sym_switch_statement] = STATE(649),
    [sym_for_statement] = STATE(644),
    [sym_for_in_statement] = STATE(641),
    [sym_while_statement] = STATE(640),
    [sym_do_statement] = STATE(639),
    [sym_try_statement] = STATE(637),
    [sym_with_statement] = STATE(636),
    [sym_break_statement] = STATE(634),
    [sym_continue_statement] = STATE(633),
    [sym_debugger_statement] = STATE(632),
    [sym_return_statement] = STATE(631),
    [sym_throw_statement] = STATE(630),
    [sym_empty_statement] = STATE(629),
    [sym_labeled_statement] = STATE(628),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2870),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [45] = {
    [sym_export_statement] = STATE(691),
    [sym_declaration] = STATE(691),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(691),
    [sym_expression_statement] = STATE(691),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(691),
    [sym_if_statement] = STATE(691),
    [sym_switch_statement] = STATE(691),
    [sym_for_statement] = STATE(691),
    [sym_for_in_statement] = STATE(691),
    [sym_while_statement] = STATE(691),
    [sym_do_statement] = STATE(691),
    [sym_try_statement] = STATE(691),
    [sym_with_statement] = STATE(691),
    [sym_break_statement] = STATE(691),
    [sym_continue_statement] = STATE(691),
    [sym_debugger_statement] = STATE(691),
    [sym_return_statement] = STATE(691),
    [sym_throw_statement] = STATE(691),
    [sym_empty_statement] = STATE(691),
    [sym_labeled_statement] = STATE(691),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [46] = {
    [sym_export_statement] = STATE(737),
    [sym_declaration] = STATE(737),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(737),
    [sym_expression_statement] = STATE(737),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(737),
    [sym_if_statement] = STATE(737),
    [sym_switch_statement] = STATE(737),
    [sym_for_statement] = STATE(737),
    [sym_for_in_statement] = STATE(737),
    [sym_while_statement] = STATE(737),
    [sym_do_statement] = STATE(737),
    [sym_try_statement] = STATE(737),
    [sym_with_statement] = STATE(737),
    [sym_break_statement] = STATE(737),
    [sym_continue_statement] = STATE(737),
    [sym_debugger_statement] = STATE(737),
    [sym_return_statement] = STATE(737),
    [sym_throw_statement] = STATE(737),
    [sym_empty_statement] = STATE(737),
    [sym_labeled_statement] = STATE(737),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [47] = {
    [sym_export_statement] = STATE(670),
    [sym_declaration] = STATE(667),
    [sym_import] = STATE(1872),
    [sym_import_statement] = STATE(664),
    [sym_expression_statement] = STATE(655),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_statement_block] = STATE(652),
    [sym_if_statement] = STATE(650),
    [sym_switch_statement] = STATE(649),
    [sym_for_statement] = STATE(644),
    [sym_for_in_statement] = STATE(641),
    [sym_while_statement] = STATE(640),
    [sym_do_statement] = STATE(639),
    [sym_try_statement] = STATE(637),
    [sym_with_statement] = STATE(636),
    [sym_break_statement] = STATE(634),
    [sym_continue_statement] = STATE(633),
    [sym_debugger_statement] = STATE(632),
    [sym_return_statement] = STATE(631),
    [sym_throw_statement] = STATE(630),
    [sym_empty_statement] = STATE(629),
    [sym_labeled_statement] = STATE(628),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2903),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [48] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [49] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2985),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(605),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [50] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3013),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(611),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [51] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3363),
    [sym_optional_tuple_parameter] = STATE(3363),
    [sym_optional_type] = STATE(3363),
    [sym_rest_type] = STATE(3363),
    [sym__tuple_type_member] = STATE(3363),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [52] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [53] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3379),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3385),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [54] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [55] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [56] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3051),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(625),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [57] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [58] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [59] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3014),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(631),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [60] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2985),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(605),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [61] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3054),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [62] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3084),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(635),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [63] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(637),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [64] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3052),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(140),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(171),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(639),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [65] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3379),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(3034),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3385),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(583),
    [anon_sym_number] = ACTIONS(583),
    [anon_sym_boolean] = ACTIONS(583),
    [anon_sym_string] = ACTIONS(583),
    [anon_sym_symbol] = ACTIONS(583),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [66] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1461),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(4082),
    [sym_string] = STATE(1768),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3271),
    [sym_constructor_type] = STATE(3271),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3271),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3271),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3271),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [67] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1476),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3847),
    [sym_string] = STATE(1768),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3271),
    [sym_constructor_type] = STATE(3271),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3271),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3271),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3271),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [68] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1476),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3847),
    [sym_string] = STATE(1768),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3353),
    [sym_constructor_type] = STATE(3353),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3353),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3353),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3353),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [69] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3307),
    [sym_constructor_type] = STATE(3307),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3307),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3307),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3307),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(194),
    [anon_sym_number] = ACTIONS(194),
    [anon_sym_boolean] = ACTIONS(194),
    [anon_sym_string] = ACTIONS(194),
    [anon_sym_symbol] = ACTIONS(194),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [70] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3347),
    [sym_constructor_type] = STATE(3347),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3347),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3347),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3347),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(194),
    [anon_sym_number] = ACTIONS(194),
    [anon_sym_boolean] = ACTIONS(194),
    [anon_sym_string] = ACTIONS(194),
    [anon_sym_symbol] = ACTIONS(194),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [71] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3353),
    [sym_constructor_type] = STATE(3353),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3353),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3353),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3353),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(194),
    [anon_sym_number] = ACTIONS(194),
    [anon_sym_boolean] = ACTIONS(194),
    [anon_sym_string] = ACTIONS(194),
    [anon_sym_symbol] = ACTIONS(194),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [72] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3293),
    [sym_constructor_type] = STATE(3293),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3293),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3293),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3293),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(194),
    [anon_sym_number] = ACTIONS(194),
    [anon_sym_boolean] = ACTIONS(194),
    [anon_sym_string] = ACTIONS(194),
    [anon_sym_symbol] = ACTIONS(194),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [73] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym__type] = STATE(3271),
    [sym_constructor_type] = STATE(3271),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3271),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3271),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3271),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(194),
    [anon_sym_number] = ACTIONS(194),
    [anon_sym_boolean] = ACTIONS(194),
    [anon_sym_string] = ACTIONS(194),
    [anon_sym_symbol] = ACTIONS(194),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [74] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1884),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3831),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_nested_identifier] = STATE(3933),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1603),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3082),
    [sym_pattern] = STATE(3472),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2451),
    [sym__type] = STATE(2585),
    [sym_constructor_type] = STATE(2585),
    [sym__primary_type] = STATE(2535),
    [sym_template_literal_type] = STATE(2532),
    [sym_infer_type] = STATE(2585),
    [sym_conditional_type] = STATE(2532),
    [sym_generic_type] = STATE(2532),
    [sym_type_query] = STATE(2532),
    [sym_index_type_query] = STATE(2532),
    [sym_lookup_type] = STATE(2532),
    [sym_literal_type] = STATE(2532),
    [sym__number] = STATE(2522),
    [sym_existential_type] = STATE(2532),
    [sym_flow_maybe_type] = STATE(2532),
    [sym_parenthesized_type] = STATE(2532),
    [sym_predefined_type] = STATE(2532),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2532),
    [sym_type_parameters] = STATE(3597),
    [sym_array_type] = STATE(2532),
    [sym_tuple_type] = STATE(2532),
    [sym_readonly_type] = STATE(2585),
    [sym_union_type] = STATE(2532),
    [sym_intersection_type] = STATE(2532),
    [sym_function_type] = STATE(2585),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(683),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(687),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(703),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(705),
    [sym_number] = ACTIONS(707),
    [sym_this] = ACTIONS(709),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(711),
    [sym_false] = ACTIONS(711),
    [sym_null] = ACTIONS(711),
    [sym_undefined] = ACTIONS(713),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(715),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(719),
    [anon_sym_number] = ACTIONS(719),
    [anon_sym_boolean] = ACTIONS(719),
    [anon_sym_string] = ACTIONS(719),
    [anon_sym_symbol] = ACTIONS(719),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [75] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1824),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3905),
    [sym_string] = STATE(1768),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3354),
    [sym_constructor_type] = STATE(3354),
    [sym__primary_type] = STATE(3024),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3288),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3354),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3354),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(729),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(741),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(743),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [76] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1396),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_typeof] = ACTIONS(753),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [sym_number] = ACTIONS(761),
    [sym_this] = ACTIONS(763),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(769),
    [anon_sym_number] = ACTIONS(769),
    [anon_sym_boolean] = ACTIONS(769),
    [anon_sym_string] = ACTIONS(769),
    [anon_sym_symbol] = ACTIONS(769),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [77] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1414),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1513),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(458),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_typeof] = ACTIONS(779),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(793),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(797),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [sym_number] = ACTIONS(801),
    [sym_this] = ACTIONS(803),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(805),
    [sym_false] = ACTIONS(805),
    [sym_null] = ACTIONS(805),
    [sym_undefined] = ACTIONS(807),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(811),
    [anon_sym_number] = ACTIONS(811),
    [anon_sym_boolean] = ACTIONS(811),
    [anon_sym_string] = ACTIONS(811),
    [anon_sym_symbol] = ACTIONS(811),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [78] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1734),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1936),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(437),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(813),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(821),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(837),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_number] = ACTIONS(845),
    [sym_this] = ACTIONS(847),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(849),
    [sym_false] = ACTIONS(849),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(853),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(855),
    [anon_sym_number] = ACTIONS(855),
    [anon_sym_boolean] = ACTIONS(855),
    [anon_sym_string] = ACTIONS(855),
    [anon_sym_symbol] = ACTIONS(855),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [79] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2801),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2801),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1137),
    [sym_subscript_expression] = STATE(1137),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2801),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(2006),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1137),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(861),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(865),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(869),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(873),
    [sym_number] = ACTIONS(875),
    [sym_this] = ACTIONS(877),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_null] = ACTIONS(879),
    [sym_undefined] = ACTIONS(881),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_readonly] = ACTIONS(883),
    [anon_sym_get] = ACTIONS(859),
    [anon_sym_set] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(859),
    [anon_sym_public] = ACTIONS(859),
    [anon_sym_private] = ACTIONS(859),
    [anon_sym_protected] = ACTIONS(859),
    [anon_sym_override] = ACTIONS(859),
    [anon_sym_module] = ACTIONS(859),
    [anon_sym_any] = ACTIONS(885),
    [anon_sym_number] = ACTIONS(885),
    [anon_sym_boolean] = ACTIONS(885),
    [anon_sym_string] = ACTIONS(885),
    [anon_sym_symbol] = ACTIONS(885),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [80] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1762),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1859),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(416),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(887),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [sym_number] = ACTIONS(919),
    [sym_this] = ACTIONS(921),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(923),
    [sym_false] = ACTIONS(923),
    [sym_null] = ACTIONS(923),
    [sym_undefined] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(927),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [81] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2025),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1859),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(398),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(167),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [sym_number] = ACTIONS(919),
    [sym_this] = ACTIONS(921),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(923),
    [sym_false] = ACTIONS(923),
    [sym_null] = ACTIONS(923),
    [sym_undefined] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(947),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(949),
    [anon_sym_number] = ACTIONS(949),
    [anon_sym_boolean] = ACTIONS(949),
    [anon_sym_string] = ACTIONS(949),
    [anon_sym_symbol] = ACTIONS(949),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [82] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1493),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2981),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2981),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1086),
    [sym_subscript_expression] = STATE(1086),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2981),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1868),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1086),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(349),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(953),
    [anon_sym_namespace] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_typeof] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(178),
    [sym_number] = ACTIONS(180),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(186),
    [sym_false] = ACTIONS(186),
    [sym_null] = ACTIONS(186),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(963),
    [anon_sym_get] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_public] = ACTIONS(953),
    [anon_sym_private] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(953),
    [anon_sym_override] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(953),
    [anon_sym_any] = ACTIONS(965),
    [anon_sym_number] = ACTIONS(965),
    [anon_sym_boolean] = ACTIONS(965),
    [anon_sym_string] = ACTIONS(965),
    [anon_sym_symbol] = ACTIONS(965),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [83] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1657),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(471),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_typeof] = ACTIONS(973),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(989),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [sym_number] = ACTIONS(761),
    [sym_this] = ACTIONS(763),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(997),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(999),
    [anon_sym_number] = ACTIONS(999),
    [anon_sym_boolean] = ACTIONS(999),
    [anon_sym_string] = ACTIONS(999),
    [anon_sym_symbol] = ACTIONS(999),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [84] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1423),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1513),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(360),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_typeof] = ACTIONS(1007),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [sym_number] = ACTIONS(801),
    [sym_this] = ACTIONS(803),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(805),
    [sym_false] = ACTIONS(805),
    [sym_null] = ACTIONS(805),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [85] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1937),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_nested_identifier] = STATE(4065),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1859),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2991),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_type_arguments] = STATE(381),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3725),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1035),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_typeof] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1057),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [sym_number] = ACTIONS(919),
    [sym_this] = ACTIONS(921),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(923),
    [sym_false] = ACTIONS(923),
    [sym_null] = ACTIONS(923),
    [sym_undefined] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1065),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1067),
    [anon_sym_number] = ACTIONS(1067),
    [anon_sym_boolean] = ACTIONS(1067),
    [anon_sym_string] = ACTIONS(1067),
    [anon_sym_symbol] = ACTIONS(1067),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [86] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1335),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [87] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1473),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_of] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [88] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1467),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [89] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_implements] = ACTIONS(1073),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [90] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1751),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [91] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1690),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [92] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1890),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_of] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [93] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2043),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_STAR] = ACTIONS(1141),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(138),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [94] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [95] = {
    [sym_declaration] = STATE(621),
    [sym_import] = STATE(1872),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3104),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(1177),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(1179),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1181),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [96] = {
    [sym_declaration] = STATE(3210),
    [sym_import] = STATE(1872),
    [sym_variable_declaration] = STATE(3159),
    [sym_lexical_declaration] = STATE(3159),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(3159),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(3159),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(3159),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_function_signature] = STATE(3159),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(3159),
    [sym_abstract_class_declaration] = STATE(3159),
    [sym_module] = STATE(3159),
    [sym_internal_module] = STATE(1749),
    [sym_import_alias] = STATE(3159),
    [sym_interface_declaration] = STATE(3159),
    [sym_enum_declaration] = STATE(3159),
    [sym_type_alias_declaration] = STATE(3159),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3037),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(1189),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1193),
    [anon_sym_const] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1199),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(1203),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(1205),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(1207),
    [anon_sym_interface] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1211),
  },
  [97] = {
    [sym_declaration] = STATE(3166),
    [sym_import] = STATE(1872),
    [sym_variable_declaration] = STATE(3159),
    [sym_lexical_declaration] = STATE(3159),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1827),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(3159),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(3159),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(3159),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_function_signature] = STATE(3159),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(3159),
    [sym_abstract_class_declaration] = STATE(3159),
    [sym_module] = STATE(3159),
    [sym_internal_module] = STATE(1749),
    [sym_import_alias] = STATE(3159),
    [sym_interface_declaration] = STATE(3159),
    [sym_enum_declaration] = STATE(3159),
    [sym_type_alias_declaration] = STATE(3159),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3037),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(1189),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1193),
    [anon_sym_const] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1199),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(1203),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(1205),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(1207),
    [anon_sym_interface] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1211),
  },
  [98] = {
    [sym_declaration] = STATE(621),
    [sym_import] = STATE(1872),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2978),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(1177),
    [anon_sym_namespace] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(1179),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [99] = {
    [sym_declaration] = STATE(688),
    [sym_import] = STATE(1872),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1709),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(1714),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3104),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(1177),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(1179),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1181),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [100] = {
    [sym_declaration] = STATE(688),
    [sym_import] = STATE(1872),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1709),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_class_declaration] = STATE(734),
    [sym_function] = STATE(1872),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function] = STATE(1872),
    [sym_generator_function_declaration] = STATE(734),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_function_signature] = STATE(734),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(134),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(2978),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(1177),
    [anon_sym_namespace] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(1179),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [101] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [102] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [103] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [104] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [105] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [106] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [107] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_implements] = ACTIONS(114),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [108] = {
    [sym_nested_identifier] = STATE(3933),
    [sym_string] = STATE(2571),
    [sym_formal_parameters] = STATE(3908),
    [sym_nested_type_identifier] = STATE(2451),
    [sym__type] = STATE(2549),
    [sym_constructor_type] = STATE(2549),
    [sym__primary_type] = STATE(2535),
    [sym_template_literal_type] = STATE(2532),
    [sym_infer_type] = STATE(2549),
    [sym_conditional_type] = STATE(2532),
    [sym_generic_type] = STATE(2532),
    [sym_type_query] = STATE(2532),
    [sym_index_type_query] = STATE(2532),
    [sym_lookup_type] = STATE(2532),
    [sym_literal_type] = STATE(2532),
    [sym__number] = STATE(2522),
    [sym_existential_type] = STATE(2532),
    [sym_flow_maybe_type] = STATE(2532),
    [sym_parenthesized_type] = STATE(2532),
    [sym_predefined_type] = STATE(2532),
    [sym_object_type] = STATE(2532),
    [sym_type_parameters] = STATE(3741),
    [sym_array_type] = STATE(2532),
    [sym_tuple_type] = STATE(2532),
    [sym_readonly_type] = STATE(2549),
    [sym_union_type] = STATE(2532),
    [sym_intersection_type] = STATE(2532),
    [sym_function_type] = STATE(2549),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(1252),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(1266),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(1272),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [109] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [110] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [111] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1282),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [112] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2378),
    [sym_constructor_type] = STATE(2378),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2378),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2378),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2378),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(159),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_EQ] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1288),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_in] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_DOT] = ACTIONS(1288),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(1292),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_AMP_AMP] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [anon_sym_GT_GT_GT] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_CARET] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_STAR] = ACTIONS(1292),
    [anon_sym_LT_EQ] = ACTIONS(1292),
    [anon_sym_EQ_EQ] = ACTIONS(1288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1292),
    [anon_sym_BANG_EQ] = ACTIONS(1288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1292),
    [anon_sym_QMARK_QMARK] = ACTIONS(1292),
    [anon_sym_instanceof] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [sym__automatic_semicolon] = ACTIONS(1294),
    [sym__ternary_qmark] = ACTIONS(1292),
  },
  [114] = {
    [sym_statement_block] = STATE(117),
    [ts_builtin_sym_end] = ACTIONS(1296),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_as] = ACTIONS(1298),
    [anon_sym_namespace] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_COMMA] = ACTIONS(1296),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_typeof] = ACTIONS(1298),
    [anon_sym_import] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_BANG] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_await] = ACTIONS(1298),
    [anon_sym_in] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_debugger] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_throw] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_yield] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1298),
    [anon_sym_GT] = ACTIONS(1298),
    [anon_sym_SLASH] = ACTIONS(1298),
    [anon_sym_DOT] = ACTIONS(1298),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1298),
    [anon_sym_function] = ACTIONS(1298),
    [anon_sym_QMARK_DOT] = ACTIONS(1296),
    [anon_sym_new] = ACTIONS(1298),
    [anon_sym_AMP_AMP] = ACTIONS(1296),
    [anon_sym_PIPE_PIPE] = ACTIONS(1296),
    [anon_sym_GT_GT] = ACTIONS(1298),
    [anon_sym_GT_GT_GT] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1298),
    [anon_sym_CARET] = ACTIONS(1296),
    [anon_sym_PIPE] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_STAR_STAR] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1296),
    [anon_sym_EQ_EQ] = ACTIONS(1298),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1298),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1296),
    [anon_sym_GT_EQ] = ACTIONS(1296),
    [anon_sym_QMARK_QMARK] = ACTIONS(1296),
    [anon_sym_instanceof] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_delete] = ACTIONS(1298),
    [anon_sym_PLUS_PLUS] = ACTIONS(1296),
    [anon_sym_DASH_DASH] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1296),
    [sym_number] = ACTIONS(1296),
    [sym_this] = ACTIONS(1298),
    [sym_super] = ACTIONS(1298),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [sym_null] = ACTIONS(1298),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_get] = ACTIONS(1298),
    [anon_sym_set] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1298),
    [anon_sym_public] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1298),
    [anon_sym_protected] = ACTIONS(1298),
    [anon_sym_override] = ACTIONS(1298),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_abstract] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [sym__automatic_semicolon] = ACTIONS(1296),
    [sym__ternary_qmark] = ACTIONS(1296),
  },
  [115] = {
    [sym_statement_block] = STATE(117),
    [ts_builtin_sym_end] = ACTIONS(1296),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_as] = ACTIONS(1298),
    [anon_sym_namespace] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_COMMA] = ACTIONS(1296),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_typeof] = ACTIONS(1298),
    [anon_sym_import] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_BANG] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_await] = ACTIONS(1298),
    [anon_sym_in] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_debugger] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_throw] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_yield] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1298),
    [anon_sym_GT] = ACTIONS(1298),
    [anon_sym_SLASH] = ACTIONS(1298),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1298),
    [anon_sym_function] = ACTIONS(1298),
    [anon_sym_QMARK_DOT] = ACTIONS(1296),
    [anon_sym_new] = ACTIONS(1298),
    [anon_sym_AMP_AMP] = ACTIONS(1296),
    [anon_sym_PIPE_PIPE] = ACTIONS(1296),
    [anon_sym_GT_GT] = ACTIONS(1298),
    [anon_sym_GT_GT_GT] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1298),
    [anon_sym_CARET] = ACTIONS(1296),
    [anon_sym_PIPE] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_STAR_STAR] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1296),
    [anon_sym_EQ_EQ] = ACTIONS(1298),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1298),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1296),
    [anon_sym_GT_EQ] = ACTIONS(1296),
    [anon_sym_QMARK_QMARK] = ACTIONS(1296),
    [anon_sym_instanceof] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_delete] = ACTIONS(1298),
    [anon_sym_PLUS_PLUS] = ACTIONS(1296),
    [anon_sym_DASH_DASH] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1296),
    [sym_number] = ACTIONS(1296),
    [sym_this] = ACTIONS(1298),
    [sym_super] = ACTIONS(1298),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [sym_null] = ACTIONS(1298),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_get] = ACTIONS(1298),
    [anon_sym_set] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1298),
    [anon_sym_public] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1298),
    [anon_sym_protected] = ACTIONS(1298),
    [anon_sym_override] = ACTIONS(1298),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_abstract] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [sym__automatic_semicolon] = ACTIONS(1296),
    [sym__ternary_qmark] = ACTIONS(1296),
  },
  [116] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1461),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(4082),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1306),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(1310),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1312),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_export] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_namespace] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_COMMA] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [anon_sym_typeof] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(1314),
    [anon_sym_var] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_in] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_try] = ACTIONS(1314),
    [anon_sym_with] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_debugger] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_throw] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_yield] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(1314),
    [anon_sym_GT] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1314),
    [anon_sym_DOT] = ACTIONS(1314),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_function] = ACTIONS(1314),
    [anon_sym_QMARK_DOT] = ACTIONS(1312),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1312),
    [anon_sym_GT_GT] = ACTIONS(1314),
    [anon_sym_GT_GT_GT] = ACTIONS(1312),
    [anon_sym_LT_LT] = ACTIONS(1312),
    [anon_sym_AMP] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_PERCENT] = ACTIONS(1312),
    [anon_sym_STAR_STAR] = ACTIONS(1312),
    [anon_sym_LT_EQ] = ACTIONS(1312),
    [anon_sym_EQ_EQ] = ACTIONS(1314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1312),
    [anon_sym_BANG_EQ] = ACTIONS(1314),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1312),
    [anon_sym_GT_EQ] = ACTIONS(1312),
    [anon_sym_QMARK_QMARK] = ACTIONS(1312),
    [anon_sym_instanceof] = ACTIONS(1314),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_void] = ACTIONS(1314),
    [anon_sym_delete] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1312),
    [sym_number] = ACTIONS(1312),
    [sym_this] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [sym_null] = ACTIONS(1314),
    [sym_undefined] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(1312),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_readonly] = ACTIONS(1314),
    [anon_sym_get] = ACTIONS(1314),
    [anon_sym_set] = ACTIONS(1314),
    [anon_sym_declare] = ACTIONS(1314),
    [anon_sym_public] = ACTIONS(1314),
    [anon_sym_private] = ACTIONS(1314),
    [anon_sym_protected] = ACTIONS(1314),
    [anon_sym_override] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [anon_sym_any] = ACTIONS(1314),
    [anon_sym_number] = ACTIONS(1314),
    [anon_sym_boolean] = ACTIONS(1314),
    [anon_sym_string] = ACTIONS(1314),
    [anon_sym_symbol] = ACTIONS(1314),
    [anon_sym_abstract] = ACTIONS(1314),
    [anon_sym_interface] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [sym__automatic_semicolon] = ACTIONS(1312),
    [sym__ternary_qmark] = ACTIONS(1312),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_default] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_as] = ACTIONS(1318),
    [anon_sym_namespace] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_typeof] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_var] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1318),
    [anon_sym_const] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_switch] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [anon_sym_in] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_do] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_debugger] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_throw] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_function] = ACTIONS(1318),
    [anon_sym_QMARK_DOT] = ACTIONS(1316),
    [anon_sym_new] = ACTIONS(1318),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE_PIPE] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_GT_GT_GT] = ACTIONS(1316),
    [anon_sym_LT_LT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_STAR_STAR] = ACTIONS(1316),
    [anon_sym_LT_EQ] = ACTIONS(1316),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1316),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1316),
    [anon_sym_GT_EQ] = ACTIONS(1316),
    [anon_sym_QMARK_QMARK] = ACTIONS(1316),
    [anon_sym_instanceof] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [sym_number] = ACTIONS(1316),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_null] = ACTIONS(1318),
    [sym_undefined] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1318),
    [anon_sym_readonly] = ACTIONS(1318),
    [anon_sym_get] = ACTIONS(1318),
    [anon_sym_set] = ACTIONS(1318),
    [anon_sym_declare] = ACTIONS(1318),
    [anon_sym_public] = ACTIONS(1318),
    [anon_sym_private] = ACTIONS(1318),
    [anon_sym_protected] = ACTIONS(1318),
    [anon_sym_override] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(1318),
    [anon_sym_number] = ACTIONS(1318),
    [anon_sym_boolean] = ACTIONS(1318),
    [anon_sym_string] = ACTIONS(1318),
    [anon_sym_symbol] = ACTIONS(1318),
    [anon_sym_abstract] = ACTIONS(1318),
    [anon_sym_interface] = ACTIONS(1318),
    [anon_sym_enum] = ACTIONS(1318),
    [sym__automatic_semicolon] = ACTIONS(1320),
    [sym__ternary_qmark] = ACTIONS(1316),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [sym_identifier] = ACTIONS(1324),
    [anon_sym_export] = ACTIONS(1324),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1324),
    [anon_sym_type] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COMMA] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_typeof] = ACTIONS(1324),
    [anon_sym_import] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_const] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1324),
    [anon_sym_switch] = ACTIONS(1324),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_await] = ACTIONS(1324),
    [anon_sym_in] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1324),
    [anon_sym_do] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_with] = ACTIONS(1324),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_debugger] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_throw] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1324),
    [anon_sym_yield] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1324),
    [anon_sym_DOT] = ACTIONS(1326),
    [anon_sym_class] = ACTIONS(1324),
    [anon_sym_async] = ACTIONS(1324),
    [anon_sym_function] = ACTIONS(1324),
    [anon_sym_QMARK_DOT] = ACTIONS(1328),
    [anon_sym_new] = ACTIONS(1324),
    [anon_sym_AMP_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1326),
    [anon_sym_CARET] = ACTIONS(1328),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_STAR_STAR] = ACTIONS(1328),
    [anon_sym_LT_EQ] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1328),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1328),
    [anon_sym_GT_EQ] = ACTIONS(1328),
    [anon_sym_QMARK_QMARK] = ACTIONS(1328),
    [anon_sym_instanceof] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_void] = ACTIONS(1324),
    [anon_sym_delete] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [sym_number] = ACTIONS(1322),
    [sym_this] = ACTIONS(1324),
    [sym_super] = ACTIONS(1324),
    [sym_true] = ACTIONS(1324),
    [sym_false] = ACTIONS(1324),
    [sym_null] = ACTIONS(1324),
    [sym_undefined] = ACTIONS(1324),
    [anon_sym_AT] = ACTIONS(1322),
    [anon_sym_static] = ACTIONS(1324),
    [anon_sym_readonly] = ACTIONS(1324),
    [anon_sym_get] = ACTIONS(1324),
    [anon_sym_set] = ACTIONS(1324),
    [anon_sym_declare] = ACTIONS(1324),
    [anon_sym_public] = ACTIONS(1324),
    [anon_sym_private] = ACTIONS(1324),
    [anon_sym_protected] = ACTIONS(1324),
    [anon_sym_override] = ACTIONS(1324),
    [anon_sym_module] = ACTIONS(1324),
    [anon_sym_any] = ACTIONS(1324),
    [anon_sym_number] = ACTIONS(1324),
    [anon_sym_boolean] = ACTIONS(1324),
    [anon_sym_string] = ACTIONS(1324),
    [anon_sym_symbol] = ACTIONS(1324),
    [anon_sym_abstract] = ACTIONS(1324),
    [anon_sym_interface] = ACTIONS(1324),
    [anon_sym_enum] = ACTIONS(1324),
    [sym__automatic_semicolon] = ACTIONS(1330),
    [sym__ternary_qmark] = ACTIONS(1328),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1332),
    [sym_identifier] = ACTIONS(1334),
    [anon_sym_export] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_type] = ACTIONS(1334),
    [anon_sym_as] = ACTIONS(1334),
    [anon_sym_namespace] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_typeof] = ACTIONS(1334),
    [anon_sym_import] = ACTIONS(1334),
    [anon_sym_var] = ACTIONS(1334),
    [anon_sym_let] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1332),
    [anon_sym_await] = ACTIONS(1334),
    [anon_sym_in] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_with] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_debugger] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_throw] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_yield] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1334),
    [anon_sym_DOT] = ACTIONS(1334),
    [anon_sym_class] = ACTIONS(1334),
    [anon_sym_async] = ACTIONS(1334),
    [anon_sym_function] = ACTIONS(1334),
    [anon_sym_QMARK_DOT] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE_PIPE] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(1334),
    [anon_sym_GT_GT_GT] = ACTIONS(1332),
    [anon_sym_LT_LT] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(1332),
    [anon_sym_STAR_STAR] = ACTIONS(1332),
    [anon_sym_LT_EQ] = ACTIONS(1332),
    [anon_sym_EQ_EQ] = ACTIONS(1334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1332),
    [anon_sym_BANG_EQ] = ACTIONS(1334),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1332),
    [anon_sym_GT_EQ] = ACTIONS(1332),
    [anon_sym_QMARK_QMARK] = ACTIONS(1332),
    [anon_sym_instanceof] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_void] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1332),
    [sym_number] = ACTIONS(1332),
    [sym_this] = ACTIONS(1334),
    [sym_super] = ACTIONS(1334),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_undefined] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_readonly] = ACTIONS(1334),
    [anon_sym_get] = ACTIONS(1334),
    [anon_sym_set] = ACTIONS(1334),
    [anon_sym_declare] = ACTIONS(1334),
    [anon_sym_public] = ACTIONS(1334),
    [anon_sym_private] = ACTIONS(1334),
    [anon_sym_protected] = ACTIONS(1334),
    [anon_sym_override] = ACTIONS(1334),
    [anon_sym_module] = ACTIONS(1334),
    [anon_sym_any] = ACTIONS(1334),
    [anon_sym_number] = ACTIONS(1334),
    [anon_sym_boolean] = ACTIONS(1334),
    [anon_sym_string] = ACTIONS(1334),
    [anon_sym_symbol] = ACTIONS(1334),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_interface] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [sym__automatic_semicolon] = ACTIONS(1332),
    [sym__ternary_qmark] = ACTIONS(1332),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1336),
    [sym_identifier] = ACTIONS(1338),
    [anon_sym_export] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1340),
    [anon_sym_namespace] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_typeof] = ACTIONS(1338),
    [anon_sym_import] = ACTIONS(1338),
    [anon_sym_var] = ACTIONS(1338),
    [anon_sym_let] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_BANG] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_await] = ACTIONS(1338),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_with] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_debugger] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_throw] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_yield] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1338),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(1340),
    [anon_sym_class] = ACTIONS(1338),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_function] = ACTIONS(1338),
    [anon_sym_QMARK_DOT] = ACTIONS(1342),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1342),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1342),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_QMARK_QMARK] = ACTIONS(1342),
    [anon_sym_instanceof] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_void] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [sym_number] = ACTIONS(1336),
    [sym_this] = ACTIONS(1338),
    [sym_super] = ACTIONS(1338),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_undefined] = ACTIONS(1338),
    [anon_sym_AT] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(1338),
    [anon_sym_set] = ACTIONS(1338),
    [anon_sym_declare] = ACTIONS(1338),
    [anon_sym_public] = ACTIONS(1338),
    [anon_sym_private] = ACTIONS(1338),
    [anon_sym_protected] = ACTIONS(1338),
    [anon_sym_override] = ACTIONS(1338),
    [anon_sym_module] = ACTIONS(1338),
    [anon_sym_any] = ACTIONS(1338),
    [anon_sym_number] = ACTIONS(1338),
    [anon_sym_boolean] = ACTIONS(1338),
    [anon_sym_string] = ACTIONS(1338),
    [anon_sym_symbol] = ACTIONS(1338),
    [anon_sym_abstract] = ACTIONS(1338),
    [anon_sym_interface] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [sym__automatic_semicolon] = ACTIONS(1344),
    [sym__ternary_qmark] = ACTIONS(1342),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1348),
    [anon_sym_export] = ACTIONS(1348),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_typeof] = ACTIONS(1348),
    [anon_sym_import] = ACTIONS(1348),
    [anon_sym_var] = ACTIONS(1348),
    [anon_sym_let] = ACTIONS(1348),
    [anon_sym_const] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_else] = ACTIONS(1348),
    [anon_sym_if] = ACTIONS(1348),
    [anon_sym_switch] = ACTIONS(1348),
    [anon_sym_for] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_await] = ACTIONS(1348),
    [anon_sym_in] = ACTIONS(1348),
    [anon_sym_while] = ACTIONS(1348),
    [anon_sym_do] = ACTIONS(1348),
    [anon_sym_try] = ACTIONS(1348),
    [anon_sym_with] = ACTIONS(1348),
    [anon_sym_break] = ACTIONS(1348),
    [anon_sym_continue] = ACTIONS(1348),
    [anon_sym_debugger] = ACTIONS(1348),
    [anon_sym_return] = ACTIONS(1348),
    [anon_sym_throw] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1348),
    [anon_sym_yield] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1348),
    [anon_sym_GT] = ACTIONS(1348),
    [anon_sym_SLASH] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(1348),
    [anon_sym_async] = ACTIONS(1348),
    [anon_sym_function] = ACTIONS(1348),
    [anon_sym_QMARK_DOT] = ACTIONS(1346),
    [anon_sym_new] = ACTIONS(1348),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_GT_GT] = ACTIONS(1348),
    [anon_sym_GT_GT_GT] = ACTIONS(1346),
    [anon_sym_LT_LT] = ACTIONS(1346),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1346),
    [anon_sym_PIPE] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(1346),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1348),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_QMARK_QMARK] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1346),
    [anon_sym_void] = ACTIONS(1348),
    [anon_sym_delete] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [sym_number] = ACTIONS(1346),
    [sym_this] = ACTIONS(1348),
    [sym_super] = ACTIONS(1348),
    [sym_true] = ACTIONS(1348),
    [sym_false] = ACTIONS(1348),
    [sym_null] = ACTIONS(1348),
    [sym_undefined] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1348),
    [anon_sym_readonly] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1348),
    [anon_sym_set] = ACTIONS(1348),
    [anon_sym_declare] = ACTIONS(1348),
    [anon_sym_public] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1348),
    [anon_sym_protected] = ACTIONS(1348),
    [anon_sym_override] = ACTIONS(1348),
    [anon_sym_module] = ACTIONS(1348),
    [anon_sym_any] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1348),
    [anon_sym_abstract] = ACTIONS(1348),
    [anon_sym_interface] = ACTIONS(1348),
    [anon_sym_enum] = ACTIONS(1348),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [sym__ternary_qmark] = ACTIONS(1346),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_identifier] = ACTIONS(1352),
    [anon_sym_export] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_default] = ACTIONS(1352),
    [anon_sym_type] = ACTIONS(1352),
    [anon_sym_as] = ACTIONS(1354),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1356),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_typeof] = ACTIONS(1352),
    [anon_sym_import] = ACTIONS(1352),
    [anon_sym_var] = ACTIONS(1352),
    [anon_sym_let] = ACTIONS(1352),
    [anon_sym_const] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_else] = ACTIONS(1352),
    [anon_sym_if] = ACTIONS(1352),
    [anon_sym_switch] = ACTIONS(1352),
    [anon_sym_for] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_await] = ACTIONS(1352),
    [anon_sym_in] = ACTIONS(1354),
    [anon_sym_while] = ACTIONS(1352),
    [anon_sym_do] = ACTIONS(1352),
    [anon_sym_try] = ACTIONS(1352),
    [anon_sym_with] = ACTIONS(1352),
    [anon_sym_break] = ACTIONS(1352),
    [anon_sym_continue] = ACTIONS(1352),
    [anon_sym_debugger] = ACTIONS(1352),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_throw] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1352),
    [anon_sym_yield] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1354),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_DOT] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(1352),
    [anon_sym_async] = ACTIONS(1352),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_QMARK_DOT] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_AMP_AMP] = ACTIONS(1356),
    [anon_sym_PIPE_PIPE] = ACTIONS(1356),
    [anon_sym_GT_GT] = ACTIONS(1354),
    [anon_sym_GT_GT_GT] = ACTIONS(1356),
    [anon_sym_LT_LT] = ACTIONS(1356),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_PIPE] = ACTIONS(1354),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_PERCENT] = ACTIONS(1356),
    [anon_sym_STAR_STAR] = ACTIONS(1356),
    [anon_sym_LT_EQ] = ACTIONS(1356),
    [anon_sym_EQ_EQ] = ACTIONS(1354),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1356),
    [anon_sym_BANG_EQ] = ACTIONS(1354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1356),
    [anon_sym_GT_EQ] = ACTIONS(1356),
    [anon_sym_QMARK_QMARK] = ACTIONS(1356),
    [anon_sym_instanceof] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_void] = ACTIONS(1352),
    [anon_sym_delete] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [sym_number] = ACTIONS(1350),
    [sym_this] = ACTIONS(1352),
    [sym_super] = ACTIONS(1352),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [sym_null] = ACTIONS(1352),
    [sym_undefined] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1352),
    [anon_sym_readonly] = ACTIONS(1352),
    [anon_sym_get] = ACTIONS(1352),
    [anon_sym_set] = ACTIONS(1352),
    [anon_sym_declare] = ACTIONS(1352),
    [anon_sym_public] = ACTIONS(1352),
    [anon_sym_private] = ACTIONS(1352),
    [anon_sym_protected] = ACTIONS(1352),
    [anon_sym_override] = ACTIONS(1352),
    [anon_sym_module] = ACTIONS(1352),
    [anon_sym_any] = ACTIONS(1352),
    [anon_sym_number] = ACTIONS(1352),
    [anon_sym_boolean] = ACTIONS(1352),
    [anon_sym_string] = ACTIONS(1352),
    [anon_sym_symbol] = ACTIONS(1352),
    [anon_sym_abstract] = ACTIONS(1352),
    [anon_sym_interface] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1352),
    [sym__automatic_semicolon] = ACTIONS(1358),
    [sym__ternary_qmark] = ACTIONS(1356),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1360),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_as] = ACTIONS(1364),
    [anon_sym_namespace] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_COMMA] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1362),
    [anon_sym_import] = ACTIONS(1362),
    [anon_sym_var] = ACTIONS(1362),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1362),
    [anon_sym_else] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1362),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_LPAREN] = ACTIONS(1360),
    [anon_sym_await] = ACTIONS(1362),
    [anon_sym_in] = ACTIONS(1364),
    [anon_sym_while] = ACTIONS(1362),
    [anon_sym_do] = ACTIONS(1362),
    [anon_sym_try] = ACTIONS(1362),
    [anon_sym_with] = ACTIONS(1362),
    [anon_sym_break] = ACTIONS(1362),
    [anon_sym_continue] = ACTIONS(1362),
    [anon_sym_debugger] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1362),
    [anon_sym_throw] = ACTIONS(1362),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym_case] = ACTIONS(1362),
    [anon_sym_yield] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_class] = ACTIONS(1362),
    [anon_sym_async] = ACTIONS(1362),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_QMARK_DOT] = ACTIONS(1366),
    [anon_sym_new] = ACTIONS(1362),
    [anon_sym_AMP_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1366),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_GT_GT_GT] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(1366),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1366),
    [anon_sym_STAR_STAR] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1366),
    [anon_sym_GT_EQ] = ACTIONS(1366),
    [anon_sym_QMARK_QMARK] = ACTIONS(1366),
    [anon_sym_instanceof] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_void] = ACTIONS(1362),
    [anon_sym_delete] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1360),
    [sym_number] = ACTIONS(1360),
    [sym_this] = ACTIONS(1362),
    [sym_super] = ACTIONS(1362),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [sym_null] = ACTIONS(1362),
    [sym_undefined] = ACTIONS(1362),
    [anon_sym_AT] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_abstract] = ACTIONS(1362),
    [anon_sym_interface] = ACTIONS(1362),
    [anon_sym_enum] = ACTIONS(1362),
    [sym__automatic_semicolon] = ACTIONS(1368),
    [sym__ternary_qmark] = ACTIONS(1366),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_export] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_type] = ACTIONS(1372),
    [anon_sym_as] = ACTIONS(1372),
    [anon_sym_namespace] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_typeof] = ACTIONS(1372),
    [anon_sym_import] = ACTIONS(1372),
    [anon_sym_var] = ACTIONS(1372),
    [anon_sym_let] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_else] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_in] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_with] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_debugger] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_throw] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(1372),
    [anon_sym_async] = ACTIONS(1372),
    [anon_sym_function] = ACTIONS(1372),
    [anon_sym_QMARK_DOT] = ACTIONS(1370),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_GT_GT_GT] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1370),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_STAR_STAR] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_EQ_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1372),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_QMARK_QMARK] = ACTIONS(1370),
    [anon_sym_instanceof] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1372),
    [sym_super] = ACTIONS(1372),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_undefined] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_readonly] = ACTIONS(1372),
    [anon_sym_get] = ACTIONS(1372),
    [anon_sym_set] = ACTIONS(1372),
    [anon_sym_declare] = ACTIONS(1372),
    [anon_sym_public] = ACTIONS(1372),
    [anon_sym_private] = ACTIONS(1372),
    [anon_sym_protected] = ACTIONS(1372),
    [anon_sym_override] = ACTIONS(1372),
    [anon_sym_module] = ACTIONS(1372),
    [anon_sym_any] = ACTIONS(1372),
    [anon_sym_number] = ACTIONS(1372),
    [anon_sym_boolean] = ACTIONS(1372),
    [anon_sym_string] = ACTIONS(1372),
    [anon_sym_symbol] = ACTIONS(1372),
    [anon_sym_abstract] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [sym__automatic_semicolon] = ACTIONS(1370),
    [sym__ternary_qmark] = ACTIONS(1370),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_as] = ACTIONS(1378),
    [anon_sym_namespace] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_typeof] = ACTIONS(1376),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_var] = ACTIONS(1376),
    [anon_sym_let] = ACTIONS(1376),
    [anon_sym_const] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_else] = ACTIONS(1376),
    [anon_sym_if] = ACTIONS(1376),
    [anon_sym_switch] = ACTIONS(1376),
    [anon_sym_for] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_await] = ACTIONS(1376),
    [anon_sym_in] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1376),
    [anon_sym_do] = ACTIONS(1376),
    [anon_sym_try] = ACTIONS(1376),
    [anon_sym_with] = ACTIONS(1376),
    [anon_sym_break] = ACTIONS(1376),
    [anon_sym_continue] = ACTIONS(1376),
    [anon_sym_debugger] = ACTIONS(1376),
    [anon_sym_return] = ACTIONS(1376),
    [anon_sym_throw] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1376),
    [anon_sym_yield] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1378),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_DOT] = ACTIONS(1378),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(1376),
    [anon_sym_QMARK_DOT] = ACTIONS(1380),
    [anon_sym_new] = ACTIONS(1376),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1378),
    [anon_sym_CARET] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1380),
    [anon_sym_STAR_STAR] = ACTIONS(1380),
    [anon_sym_LT_EQ] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1378),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1378),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1380),
    [anon_sym_GT_EQ] = ACTIONS(1380),
    [anon_sym_QMARK_QMARK] = ACTIONS(1380),
    [anon_sym_instanceof] = ACTIONS(1378),
    [anon_sym_TILDE] = ACTIONS(1374),
    [anon_sym_void] = ACTIONS(1376),
    [anon_sym_delete] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1374),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_SQUOTE] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1374),
    [sym_number] = ACTIONS(1374),
    [sym_this] = ACTIONS(1376),
    [sym_super] = ACTIONS(1376),
    [sym_true] = ACTIONS(1376),
    [sym_false] = ACTIONS(1376),
    [sym_null] = ACTIONS(1376),
    [sym_undefined] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1374),
    [anon_sym_static] = ACTIONS(1376),
    [anon_sym_readonly] = ACTIONS(1376),
    [anon_sym_get] = ACTIONS(1376),
    [anon_sym_set] = ACTIONS(1376),
    [anon_sym_declare] = ACTIONS(1376),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_override] = ACTIONS(1376),
    [anon_sym_module] = ACTIONS(1376),
    [anon_sym_any] = ACTIONS(1376),
    [anon_sym_number] = ACTIONS(1376),
    [anon_sym_boolean] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_symbol] = ACTIONS(1376),
    [anon_sym_abstract] = ACTIONS(1376),
    [anon_sym_interface] = ACTIONS(1376),
    [anon_sym_enum] = ACTIONS(1376),
    [sym__automatic_semicolon] = ACTIONS(1382),
    [sym__ternary_qmark] = ACTIONS(1380),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_export] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_type] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(1386),
    [anon_sym_namespace] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_typeof] = ACTIONS(1386),
    [anon_sym_import] = ACTIONS(1386),
    [anon_sym_var] = ACTIONS(1386),
    [anon_sym_let] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_await] = ACTIONS(1386),
    [anon_sym_in] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_try] = ACTIONS(1386),
    [anon_sym_with] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_debugger] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_throw] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_yield] = ACTIONS(1386),
    [anon_sym_LBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SLASH] = ACTIONS(1386),
    [anon_sym_DOT] = ACTIONS(1386),
    [anon_sym_class] = ACTIONS(1386),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(1386),
    [anon_sym_QMARK_DOT] = ACTIONS(1384),
    [anon_sym_new] = ACTIONS(1386),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_GT_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
    [anon_sym_CARET] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_STAR_STAR] = ACTIONS(1384),
    [anon_sym_LT_EQ] = ACTIONS(1384),
    [anon_sym_EQ_EQ] = ACTIONS(1386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1384),
    [anon_sym_BANG_EQ] = ACTIONS(1386),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1384),
    [anon_sym_GT_EQ] = ACTIONS(1384),
    [anon_sym_QMARK_QMARK] = ACTIONS(1384),
    [anon_sym_instanceof] = ACTIONS(1386),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_void] = ACTIONS(1386),
    [anon_sym_delete] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [sym_number] = ACTIONS(1384),
    [sym_this] = ACTIONS(1386),
    [sym_super] = ACTIONS(1386),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [sym_null] = ACTIONS(1386),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_readonly] = ACTIONS(1386),
    [anon_sym_get] = ACTIONS(1386),
    [anon_sym_set] = ACTIONS(1386),
    [anon_sym_declare] = ACTIONS(1386),
    [anon_sym_public] = ACTIONS(1386),
    [anon_sym_private] = ACTIONS(1386),
    [anon_sym_protected] = ACTIONS(1386),
    [anon_sym_override] = ACTIONS(1386),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_any] = ACTIONS(1386),
    [anon_sym_number] = ACTIONS(1386),
    [anon_sym_boolean] = ACTIONS(1386),
    [anon_sym_string] = ACTIONS(1386),
    [anon_sym_symbol] = ACTIONS(1386),
    [anon_sym_abstract] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [sym__automatic_semicolon] = ACTIONS(1384),
    [sym__ternary_qmark] = ACTIONS(1384),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1388),
    [sym_identifier] = ACTIONS(1390),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_typeof] = ACTIONS(1390),
    [anon_sym_import] = ACTIONS(1390),
    [anon_sym_var] = ACTIONS(1390),
    [anon_sym_let] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_await] = ACTIONS(1390),
    [anon_sym_in] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_try] = ACTIONS(1390),
    [anon_sym_with] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_debugger] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_throw] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_yield] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1390),
    [anon_sym_async] = ACTIONS(1390),
    [anon_sym_function] = ACTIONS(1390),
    [anon_sym_QMARK_DOT] = ACTIONS(1394),
    [anon_sym_new] = ACTIONS(1390),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_GT_GT_GT] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1394),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1394),
    [anon_sym_PIPE] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_PERCENT] = ACTIONS(1394),
    [anon_sym_STAR_STAR] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1394),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_QMARK_QMARK] = ACTIONS(1394),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_void] = ACTIONS(1390),
    [anon_sym_delete] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1388),
    [sym_number] = ACTIONS(1388),
    [sym_this] = ACTIONS(1390),
    [sym_super] = ACTIONS(1390),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [sym_null] = ACTIONS(1390),
    [sym_undefined] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_readonly] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_override] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [anon_sym_abstract] = ACTIONS(1390),
    [anon_sym_interface] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(1396),
    [sym__ternary_qmark] = ACTIONS(1394),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_as] = ACTIONS(1402),
    [anon_sym_namespace] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(1404),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1400),
    [anon_sym_import] = ACTIONS(1400),
    [anon_sym_var] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_switch] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1400),
    [anon_sym_in] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_do] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [anon_sym_with] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_debugger] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_throw] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1402),
    [anon_sym_class] = ACTIONS(1400),
    [anon_sym_async] = ACTIONS(1400),
    [anon_sym_function] = ACTIONS(1400),
    [anon_sym_QMARK_DOT] = ACTIONS(1404),
    [anon_sym_new] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1404),
    [anon_sym_PIPE_PIPE] = ACTIONS(1404),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_GT_GT_GT] = ACTIONS(1404),
    [anon_sym_LT_LT] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1402),
    [anon_sym_CARET] = ACTIONS(1404),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1404),
    [anon_sym_STAR_STAR] = ACTIONS(1404),
    [anon_sym_LT_EQ] = ACTIONS(1404),
    [anon_sym_EQ_EQ] = ACTIONS(1402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1402),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1404),
    [anon_sym_QMARK_QMARK] = ACTIONS(1404),
    [anon_sym_instanceof] = ACTIONS(1402),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_void] = ACTIONS(1400),
    [anon_sym_delete] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [sym_number] = ACTIONS(1398),
    [sym_this] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_true] = ACTIONS(1400),
    [sym_false] = ACTIONS(1400),
    [sym_null] = ACTIONS(1400),
    [sym_undefined] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_readonly] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_override] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [anon_sym_abstract] = ACTIONS(1400),
    [anon_sym_interface] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [sym__automatic_semicolon] = ACTIONS(1406),
    [sym__ternary_qmark] = ACTIONS(1404),
  },
  [130] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1476),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3847),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1306),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(1310),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [sym_identifier] = ACTIONS(1410),
    [anon_sym_export] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_type] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_namespace] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_typeof] = ACTIONS(1410),
    [anon_sym_import] = ACTIONS(1410),
    [anon_sym_var] = ACTIONS(1410),
    [anon_sym_let] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_BANG] = ACTIONS(1410),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_await] = ACTIONS(1410),
    [anon_sym_in] = ACTIONS(1412),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_try] = ACTIONS(1410),
    [anon_sym_with] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_debugger] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_throw] = ACTIONS(1410),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_yield] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1410),
    [anon_sym_GT] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1410),
    [anon_sym_DOT] = ACTIONS(1412),
    [anon_sym_class] = ACTIONS(1410),
    [anon_sym_async] = ACTIONS(1410),
    [anon_sym_function] = ACTIONS(1410),
    [anon_sym_QMARK_DOT] = ACTIONS(1414),
    [anon_sym_new] = ACTIONS(1410),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_GT_GT] = ACTIONS(1412),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1414),
    [anon_sym_PIPE] = ACTIONS(1412),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_STAR_STAR] = ACTIONS(1414),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_EQ_EQ] = ACTIONS(1412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1412),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1414),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_QMARK_QMARK] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_readonly] = ACTIONS(1410),
    [anon_sym_get] = ACTIONS(1410),
    [anon_sym_set] = ACTIONS(1410),
    [anon_sym_declare] = ACTIONS(1410),
    [anon_sym_public] = ACTIONS(1410),
    [anon_sym_private] = ACTIONS(1410),
    [anon_sym_protected] = ACTIONS(1410),
    [anon_sym_override] = ACTIONS(1410),
    [anon_sym_module] = ACTIONS(1410),
    [anon_sym_any] = ACTIONS(1410),
    [anon_sym_number] = ACTIONS(1410),
    [anon_sym_boolean] = ACTIONS(1410),
    [anon_sym_string] = ACTIONS(1410),
    [anon_sym_symbol] = ACTIONS(1410),
    [anon_sym_abstract] = ACTIONS(1410),
    [anon_sym_interface] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [sym__automatic_semicolon] = ACTIONS(1416),
    [sym__ternary_qmark] = ACTIONS(1414),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_export] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1420),
    [anon_sym_type] = ACTIONS(1420),
    [anon_sym_as] = ACTIONS(1422),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_typeof] = ACTIONS(1420),
    [anon_sym_import] = ACTIONS(1420),
    [anon_sym_var] = ACTIONS(1420),
    [anon_sym_let] = ACTIONS(1420),
    [anon_sym_const] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_else] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(1420),
    [anon_sym_switch] = ACTIONS(1420),
    [anon_sym_for] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_await] = ACTIONS(1420),
    [anon_sym_in] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_try] = ACTIONS(1420),
    [anon_sym_with] = ACTIONS(1420),
    [anon_sym_break] = ACTIONS(1420),
    [anon_sym_continue] = ACTIONS(1420),
    [anon_sym_debugger] = ACTIONS(1420),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_throw] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1420),
    [anon_sym_yield] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1420),
    [anon_sym_GT] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1422),
    [anon_sym_class] = ACTIONS(1420),
    [anon_sym_async] = ACTIONS(1420),
    [anon_sym_function] = ACTIONS(1420),
    [anon_sym_QMARK_DOT] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_GT_GT_GT] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_CARET] = ACTIONS(1424),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_PERCENT] = ACTIONS(1424),
    [anon_sym_STAR_STAR] = ACTIONS(1424),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_EQ_EQ] = ACTIONS(1422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1422),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_QMARK_QMARK] = ACTIONS(1424),
    [anon_sym_instanceof] = ACTIONS(1422),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_void] = ACTIONS(1420),
    [anon_sym_delete] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [sym_number] = ACTIONS(1418),
    [sym_this] = ACTIONS(1420),
    [sym_super] = ACTIONS(1420),
    [sym_true] = ACTIONS(1420),
    [sym_false] = ACTIONS(1420),
    [sym_null] = ACTIONS(1420),
    [sym_undefined] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_readonly] = ACTIONS(1420),
    [anon_sym_get] = ACTIONS(1420),
    [anon_sym_set] = ACTIONS(1420),
    [anon_sym_declare] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1420),
    [anon_sym_private] = ACTIONS(1420),
    [anon_sym_protected] = ACTIONS(1420),
    [anon_sym_override] = ACTIONS(1420),
    [anon_sym_module] = ACTIONS(1420),
    [anon_sym_any] = ACTIONS(1420),
    [anon_sym_number] = ACTIONS(1420),
    [anon_sym_boolean] = ACTIONS(1420),
    [anon_sym_string] = ACTIONS(1420),
    [anon_sym_symbol] = ACTIONS(1420),
    [anon_sym_abstract] = ACTIONS(1420),
    [anon_sym_interface] = ACTIONS(1420),
    [anon_sym_enum] = ACTIONS(1420),
    [sym__automatic_semicolon] = ACTIONS(1426),
    [sym__ternary_qmark] = ACTIONS(1424),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_identifier] = ACTIONS(1430),
    [anon_sym_export] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_default] = ACTIONS(1430),
    [anon_sym_type] = ACTIONS(1430),
    [anon_sym_as] = ACTIONS(1430),
    [anon_sym_namespace] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_typeof] = ACTIONS(1430),
    [anon_sym_import] = ACTIONS(1430),
    [anon_sym_var] = ACTIONS(1430),
    [anon_sym_let] = ACTIONS(1430),
    [anon_sym_const] = ACTIONS(1430),
    [anon_sym_BANG] = ACTIONS(1430),
    [anon_sym_else] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1430),
    [anon_sym_for] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_await] = ACTIONS(1430),
    [anon_sym_in] = ACTIONS(1430),
    [anon_sym_while] = ACTIONS(1430),
    [anon_sym_do] = ACTIONS(1430),
    [anon_sym_try] = ACTIONS(1430),
    [anon_sym_with] = ACTIONS(1430),
    [anon_sym_break] = ACTIONS(1430),
    [anon_sym_continue] = ACTIONS(1430),
    [anon_sym_debugger] = ACTIONS(1430),
    [anon_sym_return] = ACTIONS(1430),
    [anon_sym_throw] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_case] = ACTIONS(1430),
    [anon_sym_yield] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_SLASH] = ACTIONS(1430),
    [anon_sym_DOT] = ACTIONS(1430),
    [anon_sym_class] = ACTIONS(1430),
    [anon_sym_async] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1430),
    [anon_sym_QMARK_DOT] = ACTIONS(1428),
    [anon_sym_new] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_GT_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_STAR_STAR] = ACTIONS(1428),
    [anon_sym_LT_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1428),
    [anon_sym_BANG_EQ] = ACTIONS(1430),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1428),
    [anon_sym_QMARK_QMARK] = ACTIONS(1428),
    [anon_sym_instanceof] = ACTIONS(1430),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_void] = ACTIONS(1430),
    [anon_sym_delete] = ACTIONS(1430),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [sym_number] = ACTIONS(1428),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(1430),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_null] = ACTIONS(1430),
    [sym_undefined] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_get] = ACTIONS(1430),
    [anon_sym_set] = ACTIONS(1430),
    [anon_sym_declare] = ACTIONS(1430),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_override] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1430),
    [anon_sym_any] = ACTIONS(1430),
    [anon_sym_number] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1430),
    [anon_sym_symbol] = ACTIONS(1430),
    [anon_sym_abstract] = ACTIONS(1430),
    [anon_sym_interface] = ACTIONS(1430),
    [anon_sym_enum] = ACTIONS(1430),
    [sym__automatic_semicolon] = ACTIONS(1428),
    [sym__ternary_qmark] = ACTIONS(1428),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_identifier] = ACTIONS(1434),
    [anon_sym_export] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_type] = ACTIONS(1434),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [anon_sym_typeof] = ACTIONS(1434),
    [anon_sym_import] = ACTIONS(1434),
    [anon_sym_var] = ACTIONS(1434),
    [anon_sym_let] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(1434),
    [anon_sym_in] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(1434),
    [anon_sym_with] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_debugger] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_throw] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_yield] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1436),
    [anon_sym_class] = ACTIONS(1434),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(1434),
    [anon_sym_QMARK_DOT] = ACTIONS(1438),
    [anon_sym_new] = ACTIONS(1434),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_GT_GT_GT] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1438),
    [anon_sym_STAR_STAR] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_EQ_EQ] = ACTIONS(1436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_QMARK_QMARK] = ACTIONS(1438),
    [anon_sym_instanceof] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_void] = ACTIONS(1434),
    [anon_sym_delete] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [sym_number] = ACTIONS(1432),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [sym_null] = ACTIONS(1434),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_readonly] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1434),
    [anon_sym_set] = ACTIONS(1434),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_public] = ACTIONS(1434),
    [anon_sym_private] = ACTIONS(1434),
    [anon_sym_protected] = ACTIONS(1434),
    [anon_sym_override] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1434),
    [anon_sym_any] = ACTIONS(1434),
    [anon_sym_number] = ACTIONS(1434),
    [anon_sym_boolean] = ACTIONS(1434),
    [anon_sym_string] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1434),
    [anon_sym_abstract] = ACTIONS(1434),
    [anon_sym_interface] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [sym__automatic_semicolon] = ACTIONS(1438),
    [sym__ternary_qmark] = ACTIONS(1438),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1440),
    [sym_identifier] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_as] = ACTIONS(1444),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_typeof] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_var] = ACTIONS(1442),
    [anon_sym_let] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_else] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [anon_sym_await] = ACTIONS(1442),
    [anon_sym_in] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_try] = ACTIONS(1442),
    [anon_sym_with] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_debugger] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_throw] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_yield] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_function] = ACTIONS(1442),
    [anon_sym_QMARK_DOT] = ACTIONS(1446),
    [anon_sym_new] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_GT_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_PERCENT] = ACTIONS(1446),
    [anon_sym_STAR_STAR] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_EQ_EQ] = ACTIONS(1444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1446),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_QMARK_QMARK] = ACTIONS(1446),
    [anon_sym_instanceof] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_delete] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [sym_number] = ACTIONS(1440),
    [sym_this] = ACTIONS(1442),
    [sym_super] = ACTIONS(1442),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [sym_null] = ACTIONS(1442),
    [sym_undefined] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_readonly] = ACTIONS(1442),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1442),
    [anon_sym_protected] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_abstract] = ACTIONS(1442),
    [anon_sym_interface] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [sym__automatic_semicolon] = ACTIONS(1448),
    [sym__ternary_qmark] = ACTIONS(1446),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_as] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_in] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(1284),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1284),
    [anon_sym_GT_GT] = ACTIONS(1286),
    [anon_sym_GT_GT_GT] = ACTIONS(1284),
    [anon_sym_LT_LT] = ACTIONS(1284),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_CARET] = ACTIONS(1284),
    [anon_sym_PIPE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1284),
    [anon_sym_STAR_STAR] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1284),
    [anon_sym_EQ_EQ] = ACTIONS(1286),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1284),
    [anon_sym_BANG_EQ] = ACTIONS(1286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1284),
    [anon_sym_GT_EQ] = ACTIONS(1284),
    [anon_sym_QMARK_QMARK] = ACTIONS(1284),
    [anon_sym_instanceof] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [sym__automatic_semicolon] = ACTIONS(1450),
    [sym__ternary_qmark] = ACTIONS(1284),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_as] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_COMMA] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_typeof] = ACTIONS(1454),
    [anon_sym_import] = ACTIONS(1454),
    [anon_sym_var] = ACTIONS(1454),
    [anon_sym_let] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_await] = ACTIONS(1454),
    [anon_sym_in] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(1454),
    [anon_sym_with] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_debugger] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_throw] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_yield] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1454),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_SLASH] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1454),
    [anon_sym_class] = ACTIONS(1454),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(1454),
    [anon_sym_QMARK_DOT] = ACTIONS(1452),
    [anon_sym_new] = ACTIONS(1454),
    [anon_sym_AMP_AMP] = ACTIONS(1452),
    [anon_sym_PIPE_PIPE] = ACTIONS(1452),
    [anon_sym_GT_GT] = ACTIONS(1454),
    [anon_sym_GT_GT_GT] = ACTIONS(1452),
    [anon_sym_LT_LT] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_STAR_STAR] = ACTIONS(1452),
    [anon_sym_LT_EQ] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1452),
    [anon_sym_BANG_EQ] = ACTIONS(1454),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1452),
    [anon_sym_QMARK_QMARK] = ACTIONS(1452),
    [anon_sym_instanceof] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1454),
    [anon_sym_delete] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [sym_number] = ACTIONS(1452),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_undefined] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_readonly] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_override] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [anon_sym_abstract] = ACTIONS(1454),
    [anon_sym_interface] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [sym__automatic_semicolon] = ACTIONS(1452),
    [sym__ternary_qmark] = ACTIONS(1452),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1456),
    [sym_identifier] = ACTIONS(1458),
    [anon_sym_export] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(1458),
    [anon_sym_as] = ACTIONS(1460),
    [anon_sym_namespace] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_COMMA] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_typeof] = ACTIONS(1458),
    [anon_sym_import] = ACTIONS(1458),
    [anon_sym_var] = ACTIONS(1458),
    [anon_sym_let] = ACTIONS(1458),
    [anon_sym_const] = ACTIONS(1458),
    [anon_sym_BANG] = ACTIONS(1458),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1458),
    [anon_sym_for] = ACTIONS(1458),
    [anon_sym_LPAREN] = ACTIONS(1456),
    [anon_sym_await] = ACTIONS(1458),
    [anon_sym_in] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1458),
    [anon_sym_do] = ACTIONS(1458),
    [anon_sym_try] = ACTIONS(1458),
    [anon_sym_with] = ACTIONS(1458),
    [anon_sym_break] = ACTIONS(1458),
    [anon_sym_continue] = ACTIONS(1458),
    [anon_sym_debugger] = ACTIONS(1458),
    [anon_sym_return] = ACTIONS(1458),
    [anon_sym_throw] = ACTIONS(1458),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_yield] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(1458),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(1458),
    [anon_sym_DOT] = ACTIONS(1460),
    [anon_sym_class] = ACTIONS(1458),
    [anon_sym_async] = ACTIONS(1458),
    [anon_sym_function] = ACTIONS(1458),
    [anon_sym_QMARK_DOT] = ACTIONS(1462),
    [anon_sym_new] = ACTIONS(1458),
    [anon_sym_AMP_AMP] = ACTIONS(1462),
    [anon_sym_PIPE_PIPE] = ACTIONS(1462),
    [anon_sym_GT_GT] = ACTIONS(1460),
    [anon_sym_GT_GT_GT] = ACTIONS(1462),
    [anon_sym_LT_LT] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_CARET] = ACTIONS(1462),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_PERCENT] = ACTIONS(1462),
    [anon_sym_STAR_STAR] = ACTIONS(1462),
    [anon_sym_LT_EQ] = ACTIONS(1462),
    [anon_sym_EQ_EQ] = ACTIONS(1460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1462),
    [anon_sym_BANG_EQ] = ACTIONS(1460),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1462),
    [anon_sym_GT_EQ] = ACTIONS(1462),
    [anon_sym_QMARK_QMARK] = ACTIONS(1462),
    [anon_sym_instanceof] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_void] = ACTIONS(1458),
    [anon_sym_delete] = ACTIONS(1458),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1456),
    [sym_number] = ACTIONS(1456),
    [sym_this] = ACTIONS(1458),
    [sym_super] = ACTIONS(1458),
    [sym_true] = ACTIONS(1458),
    [sym_false] = ACTIONS(1458),
    [sym_null] = ACTIONS(1458),
    [sym_undefined] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1456),
    [anon_sym_static] = ACTIONS(1458),
    [anon_sym_readonly] = ACTIONS(1458),
    [anon_sym_get] = ACTIONS(1458),
    [anon_sym_set] = ACTIONS(1458),
    [anon_sym_declare] = ACTIONS(1458),
    [anon_sym_public] = ACTIONS(1458),
    [anon_sym_private] = ACTIONS(1458),
    [anon_sym_protected] = ACTIONS(1458),
    [anon_sym_override] = ACTIONS(1458),
    [anon_sym_module] = ACTIONS(1458),
    [anon_sym_any] = ACTIONS(1458),
    [anon_sym_number] = ACTIONS(1458),
    [anon_sym_boolean] = ACTIONS(1458),
    [anon_sym_string] = ACTIONS(1458),
    [anon_sym_symbol] = ACTIONS(1458),
    [anon_sym_abstract] = ACTIONS(1458),
    [anon_sym_interface] = ACTIONS(1458),
    [anon_sym_enum] = ACTIONS(1458),
    [sym__automatic_semicolon] = ACTIONS(1464),
    [sym__ternary_qmark] = ACTIONS(1462),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_export] = ACTIONS(1468),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_type] = ACTIONS(1468),
    [anon_sym_as] = ACTIONS(1470),
    [anon_sym_namespace] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [anon_sym_typeof] = ACTIONS(1468),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1468),
    [anon_sym_let] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_await] = ACTIONS(1468),
    [anon_sym_in] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_try] = ACTIONS(1468),
    [anon_sym_with] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_debugger] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_throw] = ACTIONS(1468),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_yield] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_GT] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1468),
    [anon_sym_DOT] = ACTIONS(1470),
    [anon_sym_class] = ACTIONS(1468),
    [anon_sym_async] = ACTIONS(1468),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_QMARK_DOT] = ACTIONS(1472),
    [anon_sym_new] = ACTIONS(1468),
    [anon_sym_AMP_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1472),
    [anon_sym_GT_GT] = ACTIONS(1470),
    [anon_sym_GT_GT_GT] = ACTIONS(1472),
    [anon_sym_LT_LT] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1472),
    [anon_sym_PIPE] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_PERCENT] = ACTIONS(1472),
    [anon_sym_STAR_STAR] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1472),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1472),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1472),
    [anon_sym_QMARK_QMARK] = ACTIONS(1472),
    [anon_sym_instanceof] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_void] = ACTIONS(1468),
    [anon_sym_delete] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1466),
    [sym_number] = ACTIONS(1466),
    [sym_this] = ACTIONS(1468),
    [sym_super] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_undefined] = ACTIONS(1468),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_readonly] = ACTIONS(1468),
    [anon_sym_get] = ACTIONS(1468),
    [anon_sym_set] = ACTIONS(1468),
    [anon_sym_declare] = ACTIONS(1468),
    [anon_sym_public] = ACTIONS(1468),
    [anon_sym_private] = ACTIONS(1468),
    [anon_sym_protected] = ACTIONS(1468),
    [anon_sym_override] = ACTIONS(1468),
    [anon_sym_module] = ACTIONS(1468),
    [anon_sym_any] = ACTIONS(1468),
    [anon_sym_number] = ACTIONS(1468),
    [anon_sym_boolean] = ACTIONS(1468),
    [anon_sym_string] = ACTIONS(1468),
    [anon_sym_symbol] = ACTIONS(1468),
    [anon_sym_abstract] = ACTIONS(1468),
    [anon_sym_interface] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [sym__automatic_semicolon] = ACTIONS(1474),
    [sym__ternary_qmark] = ACTIONS(1472),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(1476),
    [sym_identifier] = ACTIONS(1478),
    [anon_sym_export] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_as] = ACTIONS(1478),
    [anon_sym_namespace] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_COMMA] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_typeof] = ACTIONS(1478),
    [anon_sym_import] = ACTIONS(1478),
    [anon_sym_var] = ACTIONS(1478),
    [anon_sym_let] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_else] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_await] = ACTIONS(1478),
    [anon_sym_in] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_try] = ACTIONS(1478),
    [anon_sym_with] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_debugger] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_throw] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_yield] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1478),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_DOT] = ACTIONS(1478),
    [anon_sym_class] = ACTIONS(1478),
    [anon_sym_async] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1478),
    [anon_sym_QMARK_DOT] = ACTIONS(1476),
    [anon_sym_new] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1478),
    [anon_sym_GT_GT_GT] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_PERCENT] = ACTIONS(1476),
    [anon_sym_STAR_STAR] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1476),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1476),
    [anon_sym_QMARK_QMARK] = ACTIONS(1476),
    [anon_sym_instanceof] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_void] = ACTIONS(1478),
    [anon_sym_delete] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [sym_number] = ACTIONS(1476),
    [sym_this] = ACTIONS(1478),
    [sym_super] = ACTIONS(1478),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [sym_null] = ACTIONS(1478),
    [sym_undefined] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_readonly] = ACTIONS(1478),
    [anon_sym_get] = ACTIONS(1478),
    [anon_sym_set] = ACTIONS(1478),
    [anon_sym_declare] = ACTIONS(1478),
    [anon_sym_public] = ACTIONS(1478),
    [anon_sym_private] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(1478),
    [anon_sym_override] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(1478),
    [anon_sym_any] = ACTIONS(1478),
    [anon_sym_number] = ACTIONS(1478),
    [anon_sym_boolean] = ACTIONS(1478),
    [anon_sym_string] = ACTIONS(1478),
    [anon_sym_symbol] = ACTIONS(1478),
    [anon_sym_abstract] = ACTIONS(1478),
    [anon_sym_interface] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [sym__automatic_semicolon] = ACTIONS(1476),
    [sym__ternary_qmark] = ACTIONS(1476),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_default] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_as] = ACTIONS(1318),
    [anon_sym_namespace] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_typeof] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_var] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1318),
    [anon_sym_const] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_switch] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [anon_sym_in] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_do] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_debugger] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_throw] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_function] = ACTIONS(1318),
    [anon_sym_QMARK_DOT] = ACTIONS(1316),
    [anon_sym_new] = ACTIONS(1318),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE_PIPE] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_GT_GT_GT] = ACTIONS(1316),
    [anon_sym_LT_LT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_STAR_STAR] = ACTIONS(1316),
    [anon_sym_LT_EQ] = ACTIONS(1316),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1316),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1316),
    [anon_sym_GT_EQ] = ACTIONS(1316),
    [anon_sym_QMARK_QMARK] = ACTIONS(1316),
    [anon_sym_instanceof] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [sym_number] = ACTIONS(1316),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_null] = ACTIONS(1318),
    [sym_undefined] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1318),
    [anon_sym_readonly] = ACTIONS(1318),
    [anon_sym_get] = ACTIONS(1318),
    [anon_sym_set] = ACTIONS(1318),
    [anon_sym_declare] = ACTIONS(1318),
    [anon_sym_public] = ACTIONS(1318),
    [anon_sym_private] = ACTIONS(1318),
    [anon_sym_protected] = ACTIONS(1318),
    [anon_sym_override] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(1318),
    [anon_sym_number] = ACTIONS(1318),
    [anon_sym_boolean] = ACTIONS(1318),
    [anon_sym_string] = ACTIONS(1318),
    [anon_sym_symbol] = ACTIONS(1318),
    [anon_sym_abstract] = ACTIONS(1318),
    [anon_sym_interface] = ACTIONS(1318),
    [anon_sym_enum] = ACTIONS(1318),
    [sym__automatic_semicolon] = ACTIONS(1316),
    [sym__ternary_qmark] = ACTIONS(1316),
  },
  [142] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3830),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3830),
    [sym_optional_parameter] = STATE(3830),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1480),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [143] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3830),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3830),
    [sym_optional_parameter] = STATE(3830),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1488),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [144] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3830),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3830),
    [sym_optional_parameter] = STATE(3830),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [145] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3830),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3830),
    [sym_optional_parameter] = STATE(3830),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [146] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3479),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3479),
    [sym_optional_parameter] = STATE(3479),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [147] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3480),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3480),
    [sym_optional_parameter] = STATE(3480),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1496),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [148] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3830),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3830),
    [sym_optional_parameter] = STATE(3830),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1498),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [149] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3376),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3376),
    [sym_optional_parameter] = STATE(3376),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [150] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3830),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3830),
    [sym_optional_parameter] = STATE(3830),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [151] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3379),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3385),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [152] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [153] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(1508),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [154] = {
    [sym_import] = STATE(1872),
    [sym_expression_statement] = STATE(199),
    [sym_variable_declaration] = STATE(199),
    [sym_lexical_declaration] = STATE(199),
    [sym_empty_statement] = STATE(199),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3424),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3424),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3424),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_export] = ACTIONS(1514),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_namespace] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_var] = ACTIONS(1520),
    [anon_sym_let] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1526),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_readonly] = ACTIONS(1514),
    [anon_sym_get] = ACTIONS(1514),
    [anon_sym_set] = ACTIONS(1514),
    [anon_sym_declare] = ACTIONS(1514),
    [anon_sym_public] = ACTIONS(1514),
    [anon_sym_private] = ACTIONS(1514),
    [anon_sym_protected] = ACTIONS(1514),
    [anon_sym_override] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [anon_sym_any] = ACTIONS(1514),
    [anon_sym_number] = ACTIONS(1514),
    [anon_sym_boolean] = ACTIONS(1514),
    [anon_sym_string] = ACTIONS(1514),
    [anon_sym_symbol] = ACTIONS(1514),
  },
  [155] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1530),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [156] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1655),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3379),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3385),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [157] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym__formal_parameter] = STATE(3830),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2974),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(196),
    [sym_override_modifier] = STATE(206),
    [sym_required_parameter] = STATE(3830),
    [sym_optional_parameter] = STATE(3830),
    [sym__parameter_name] = STATE(2752),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [158] = {
    [sym_import] = STATE(1872),
    [sym_expression_statement] = STATE(198),
    [sym_variable_declaration] = STATE(198),
    [sym_lexical_declaration] = STATE(198),
    [sym_empty_statement] = STATE(198),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3424),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3424),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3424),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_export] = ACTIONS(1514),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_namespace] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_var] = ACTIONS(1520),
    [anon_sym_let] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1526),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_readonly] = ACTIONS(1514),
    [anon_sym_get] = ACTIONS(1514),
    [anon_sym_set] = ACTIONS(1514),
    [anon_sym_declare] = ACTIONS(1514),
    [anon_sym_public] = ACTIONS(1514),
    [anon_sym_private] = ACTIONS(1514),
    [anon_sym_protected] = ACTIONS(1514),
    [anon_sym_override] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [anon_sym_any] = ACTIONS(1514),
    [anon_sym_number] = ACTIONS(1514),
    [anon_sym_boolean] = ACTIONS(1514),
    [anon_sym_string] = ACTIONS(1514),
    [anon_sym_symbol] = ACTIONS(1514),
  },
  [159] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [160] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [161] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3570),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3490),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [162] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3379),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3385),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [163] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3372),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3372),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3372),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_mapped_type_clause] = STATE(3871),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_export] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1542),
    [anon_sym_namespace] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1542),
    [anon_sym_readonly] = ACTIONS(1542),
    [anon_sym_get] = ACTIONS(1542),
    [anon_sym_set] = ACTIONS(1542),
    [anon_sym_declare] = ACTIONS(1542),
    [anon_sym_public] = ACTIONS(1542),
    [anon_sym_private] = ACTIONS(1542),
    [anon_sym_protected] = ACTIONS(1542),
    [anon_sym_override] = ACTIONS(1542),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_any] = ACTIONS(1542),
    [anon_sym_number] = ACTIONS(1542),
    [anon_sym_boolean] = ACTIONS(1542),
    [anon_sym_string] = ACTIONS(1542),
    [anon_sym_symbol] = ACTIONS(1542),
  },
  [164] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [anon_sym_extends] = ACTIONS(1510),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [sym__automatic_semicolon] = ACTIONS(1508),
  },
  [165] = {
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(1558),
    [anon_sym_import] = ACTIONS(1558),
    [anon_sym_BANG] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(1558),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1558),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_function] = ACTIONS(1558),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1558),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1560),
    [anon_sym_void] = ACTIONS(1558),
    [anon_sym_delete] = ACTIONS(1558),
    [anon_sym_PLUS_PLUS] = ACTIONS(1560),
    [anon_sym_DASH_DASH] = ACTIONS(1560),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1560),
    [sym_number] = ACTIONS(1560),
    [sym_this] = ACTIONS(1558),
    [sym_super] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_null] = ACTIONS(1558),
    [sym_undefined] = ACTIONS(1558),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_readonly] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_override] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [166] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_assignment_pattern] = STATE(3482),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3330),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_pattern_repeat1] = STATE(3492),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_RBRACK] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [167] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1632),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3716),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3433),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3434),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [168] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [169] = {
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1571),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1573),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_typeof] = ACTIONS(1571),
    [anon_sym_import] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_await] = ACTIONS(1571),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(1571),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1571),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(1571),
    [anon_sym_function] = ACTIONS(1571),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1571),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1573),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1573),
    [anon_sym_void] = ACTIONS(1571),
    [anon_sym_delete] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1573),
    [sym_number] = ACTIONS(1573),
    [sym_this] = ACTIONS(1571),
    [sym_super] = ACTIONS(1571),
    [sym_true] = ACTIONS(1571),
    [sym_false] = ACTIONS(1571),
    [sym_null] = ACTIONS(1571),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1571),
    [anon_sym_readonly] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(1571),
    [anon_sym_set] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(1571),
    [anon_sym_public] = ACTIONS(1571),
    [anon_sym_private] = ACTIONS(1571),
    [anon_sym_protected] = ACTIONS(1571),
    [anon_sym_override] = ACTIONS(1571),
    [anon_sym_module] = ACTIONS(1571),
    [anon_sym_any] = ACTIONS(1571),
    [anon_sym_number] = ACTIONS(1571),
    [anon_sym_boolean] = ACTIONS(1571),
    [anon_sym_string] = ACTIONS(1571),
    [anon_sym_symbol] = ACTIONS(1571),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [170] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1632),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3716),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3433),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3434),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [171] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1932),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3372),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3372),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3372),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1581),
    [anon_sym_type] = ACTIONS(1581),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_readonly] = ACTIONS(1581),
    [anon_sym_get] = ACTIONS(1581),
    [anon_sym_set] = ACTIONS(1581),
    [anon_sym_declare] = ACTIONS(1581),
    [anon_sym_public] = ACTIONS(1581),
    [anon_sym_private] = ACTIONS(1581),
    [anon_sym_protected] = ACTIONS(1581),
    [anon_sym_override] = ACTIONS(1581),
    [anon_sym_module] = ACTIONS(1581),
    [anon_sym_any] = ACTIONS(1581),
    [anon_sym_number] = ACTIONS(1581),
    [anon_sym_boolean] = ACTIONS(1581),
    [anon_sym_string] = ACTIONS(1581),
    [anon_sym_symbol] = ACTIONS(1581),
  },
  [172] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1632),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3716),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_spread_element] = STATE(3433),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3434),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [173] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_assignment_pattern] = STATE(3378),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3253),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_pattern_repeat1] = STATE(3387),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1571),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1573),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1571),
    [anon_sym_import] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(1571),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(1571),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1571),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(1571),
    [anon_sym_function] = ACTIONS(1571),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1571),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1573),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1573),
    [anon_sym_void] = ACTIONS(1571),
    [anon_sym_delete] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1573),
    [sym_number] = ACTIONS(1573),
    [sym_this] = ACTIONS(1571),
    [sym_super] = ACTIONS(1571),
    [sym_true] = ACTIONS(1571),
    [sym_false] = ACTIONS(1571),
    [sym_null] = ACTIONS(1571),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1571),
    [anon_sym_readonly] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(1571),
    [anon_sym_set] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(1571),
    [anon_sym_public] = ACTIONS(1571),
    [anon_sym_private] = ACTIONS(1571),
    [anon_sym_protected] = ACTIONS(1571),
    [anon_sym_override] = ACTIONS(1571),
    [anon_sym_module] = ACTIONS(1571),
    [anon_sym_any] = ACTIONS(1571),
    [anon_sym_number] = ACTIONS(1571),
    [anon_sym_boolean] = ACTIONS(1571),
    [anon_sym_string] = ACTIONS(1571),
    [anon_sym_symbol] = ACTIONS(1571),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1558),
    [anon_sym_import] = ACTIONS(1558),
    [anon_sym_BANG] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(1558),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1558),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_function] = ACTIONS(1558),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1558),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1560),
    [anon_sym_void] = ACTIONS(1558),
    [anon_sym_delete] = ACTIONS(1558),
    [anon_sym_PLUS_PLUS] = ACTIONS(1560),
    [anon_sym_DASH_DASH] = ACTIONS(1560),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1560),
    [sym_number] = ACTIONS(1560),
    [sym_this] = ACTIONS(1558),
    [sym_super] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_null] = ACTIONS(1558),
    [sym_undefined] = ACTIONS(1558),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_readonly] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_override] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [176] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_assignment_pattern] = STATE(3716),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3434),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_RBRACK] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [177] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1632),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3433),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1589),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1589),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [178] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1805),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [179] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1694),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [180] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1469),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [181] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1623),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3569),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3524),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1595),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [182] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [183] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1546),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3532),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [184] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1615),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3484),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3485),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [185] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1645),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3463),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3464),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [186] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1589),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3452),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3473),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1603),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [187] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2986),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_accessibility_modifier] = STATE(200),
    [sym_override_modifier] = STATE(211),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(1116),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(1605),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1607),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [188] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1410),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [189] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1652),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3432),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3516),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1611),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [190] = {
    [sym_export_clause] = STATE(3248),
    [sym_declaration] = STATE(721),
    [sym_namespace_import_export] = STATE(3603),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1619),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1656),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [191] = {
    [sym_export_clause] = STATE(3248),
    [sym_declaration] = STATE(721),
    [sym_namespace_import_export] = STATE(3603),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1619),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1656),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [192] = {
    [sym_export_clause] = STATE(3248),
    [sym_declaration] = STATE(721),
    [sym_namespace_import_export] = STATE(3603),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1619),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1656),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [193] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1637),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [194] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1620),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_spread_element] = STATE(3398),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [aux_sym_array_repeat1] = STATE(3399),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1668),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [195] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1884),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2776),
    [sym_assignment_pattern] = STATE(3831),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2776),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2776),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3472),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1028),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(557),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_get] = ACTIONS(533),
    [anon_sym_set] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_public] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_override] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_any] = ACTIONS(533),
    [anon_sym_number] = ACTIONS(533),
    [anon_sym_boolean] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [anon_sym_symbol] = ACTIONS(533),
  },
  [196] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2985),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_override_modifier] = STATE(210),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(605),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [197] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_assignment_pattern] = STATE(3831),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3472),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [198] = {
    [sym_import] = STATE(1872),
    [sym_expression_statement] = STATE(221),
    [sym_empty_statement] = STATE(221),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [199] = {
    [sym_import] = STATE(1872),
    [sym_expression_statement] = STATE(220),
    [sym_empty_statement] = STATE(220),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [200] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3015),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_override_modifier] = STATE(217),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1672),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1674),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [201] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [202] = {
    [sym_import] = STATE(2042),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2330),
    [sym__type_query_subscript_expression] = STATE(2324),
    [sym__type_query_call_expression] = STATE(2455),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1678),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [203] = {
    [sym_import] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1805),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [204] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1682),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [205] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1617),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3627),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
    [sym__automatic_semicolon] = ACTIONS(1684),
  },
  [206] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(2985),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(605),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [207] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [208] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3489),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3489),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1138),
    [sym_subscript_expression] = STATE(1138),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3489),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(1690),
    [anon_sym_type] = ACTIONS(1690),
    [anon_sym_namespace] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_var] = ACTIONS(1696),
    [anon_sym_let] = ACTIONS(1698),
    [anon_sym_const] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1700),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1690),
    [anon_sym_readonly] = ACTIONS(1690),
    [anon_sym_get] = ACTIONS(1690),
    [anon_sym_set] = ACTIONS(1690),
    [anon_sym_declare] = ACTIONS(1690),
    [anon_sym_public] = ACTIONS(1690),
    [anon_sym_private] = ACTIONS(1690),
    [anon_sym_protected] = ACTIONS(1690),
    [anon_sym_override] = ACTIONS(1690),
    [anon_sym_module] = ACTIONS(1690),
    [anon_sym_any] = ACTIONS(1690),
    [anon_sym_number] = ACTIONS(1690),
    [anon_sym_boolean] = ACTIONS(1690),
    [anon_sym_string] = ACTIONS(1690),
    [anon_sym_symbol] = ACTIONS(1690),
  },
  [209] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [210] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3013),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(611),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [211] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3016),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1710),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [212] = {
    [sym_import] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1410),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1714),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [213] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [214] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1637),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [215] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [216] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1694),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [217] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2767),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2767),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2767),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_pattern] = STATE(3053),
    [sym_rest_pattern] = STATE(2772),
    [sym_non_null_expression] = STATE(1035),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(585),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1726),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [218] = {
    [sym_import] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1469),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [219] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym__type_query_member_expression] = STATE(2271),
    [sym__type_query_subscript_expression] = STATE(2270),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1730),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [220] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1744),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3986),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [221] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1737),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(4053),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [222] = {
    [sym_declaration] = STATE(712),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1740),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_global] = ACTIONS(1742),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [223] = {
    [sym_declaration] = STATE(712),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1740),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_global] = ACTIONS(1742),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [224] = {
    [sym_declaration] = STATE(712),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1740),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_global] = ACTIONS(1742),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [225] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1871),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1408),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [226] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1455),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [227] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1688),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1452),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [228] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1060),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1444),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1060),
    [sym_subscript_expression] = STATE(1060),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1746),
    [anon_sym_export] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(1748),
    [anon_sym_namespace] = ACTIONS(1750),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1754),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1748),
    [anon_sym_readonly] = ACTIONS(1748),
    [anon_sym_get] = ACTIONS(1748),
    [anon_sym_set] = ACTIONS(1748),
    [anon_sym_declare] = ACTIONS(1748),
    [anon_sym_public] = ACTIONS(1748),
    [anon_sym_private] = ACTIONS(1748),
    [anon_sym_protected] = ACTIONS(1748),
    [anon_sym_override] = ACTIONS(1748),
    [anon_sym_module] = ACTIONS(1748),
    [anon_sym_any] = ACTIONS(1748),
    [anon_sym_number] = ACTIONS(1748),
    [anon_sym_boolean] = ACTIONS(1748),
    [anon_sym_string] = ACTIONS(1748),
    [anon_sym_symbol] = ACTIONS(1748),
  },
  [229] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(1994),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [230] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1762),
    [anon_sym_export] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1770),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_readonly] = ACTIONS(1764),
    [anon_sym_get] = ACTIONS(1764),
    [anon_sym_set] = ACTIONS(1764),
    [anon_sym_declare] = ACTIONS(1764),
    [anon_sym_public] = ACTIONS(1764),
    [anon_sym_private] = ACTIONS(1764),
    [anon_sym_protected] = ACTIONS(1764),
    [anon_sym_override] = ACTIONS(1764),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_any] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1764),
    [anon_sym_boolean] = ACTIONS(1764),
    [anon_sym_string] = ACTIONS(1764),
    [anon_sym_symbol] = ACTIONS(1764),
  },
  [231] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1343),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1790),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [232] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1060),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1444),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1060),
    [sym_subscript_expression] = STATE(1060),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1746),
    [anon_sym_export] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(1748),
    [anon_sym_namespace] = ACTIONS(1750),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1754),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1748),
    [anon_sym_readonly] = ACTIONS(1748),
    [anon_sym_get] = ACTIONS(1748),
    [anon_sym_set] = ACTIONS(1748),
    [anon_sym_declare] = ACTIONS(1748),
    [anon_sym_public] = ACTIONS(1748),
    [anon_sym_private] = ACTIONS(1748),
    [anon_sym_protected] = ACTIONS(1748),
    [anon_sym_override] = ACTIONS(1748),
    [anon_sym_module] = ACTIONS(1748),
    [anon_sym_any] = ACTIONS(1748),
    [anon_sym_number] = ACTIONS(1748),
    [anon_sym_boolean] = ACTIONS(1748),
    [anon_sym_string] = ACTIONS(1748),
    [anon_sym_symbol] = ACTIONS(1748),
  },
  [233] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_mapped_type_clause] = STATE(4007),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1776),
    [anon_sym_namespace] = ACTIONS(1778),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1776),
    [anon_sym_readonly] = ACTIONS(1776),
    [anon_sym_get] = ACTIONS(1776),
    [anon_sym_set] = ACTIONS(1776),
    [anon_sym_declare] = ACTIONS(1776),
    [anon_sym_public] = ACTIONS(1776),
    [anon_sym_private] = ACTIONS(1776),
    [anon_sym_protected] = ACTIONS(1776),
    [anon_sym_override] = ACTIONS(1776),
    [anon_sym_module] = ACTIONS(1776),
    [anon_sym_any] = ACTIONS(1776),
    [anon_sym_number] = ACTIONS(1776),
    [anon_sym_boolean] = ACTIONS(1776),
    [anon_sym_string] = ACTIONS(1776),
    [anon_sym_symbol] = ACTIONS(1776),
  },
  [234] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1362),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1800),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [235] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1370),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1802),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [236] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1376),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [237] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1830),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(4038),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [238] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1828),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(4037),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [239] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1826),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(4031),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [240] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3998),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [241] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1703),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3948),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [242] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1818),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1702),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [243] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1742),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3982),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [244] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1738),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3970),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [245] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1812),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3966),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [246] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1701),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [247] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1803),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [248] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1784),
    [anon_sym_type] = ACTIONS(1784),
    [anon_sym_namespace] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1784),
    [anon_sym_readonly] = ACTIONS(1784),
    [anon_sym_get] = ACTIONS(1784),
    [anon_sym_set] = ACTIONS(1784),
    [anon_sym_declare] = ACTIONS(1784),
    [anon_sym_public] = ACTIONS(1784),
    [anon_sym_private] = ACTIONS(1784),
    [anon_sym_protected] = ACTIONS(1784),
    [anon_sym_override] = ACTIONS(1784),
    [anon_sym_module] = ACTIONS(1784),
    [anon_sym_any] = ACTIONS(1784),
    [anon_sym_number] = ACTIONS(1784),
    [anon_sym_boolean] = ACTIONS(1784),
    [anon_sym_string] = ACTIONS(1784),
    [anon_sym_symbol] = ACTIONS(1784),
  },
  [249] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1790),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1796),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
  },
  [250] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1478),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3844),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [251] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [252] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1935),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [253] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1824),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3905),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [254] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1769),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1715),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [255] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1343),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1947),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [256] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1362),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2037),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [257] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1362),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1945),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [258] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1370),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1944),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [259] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1376),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [260] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1733),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3909),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [261] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1800),
    [anon_sym_type] = ACTIONS(1800),
    [anon_sym_namespace] = ACTIONS(1802),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1804),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1800),
    [anon_sym_readonly] = ACTIONS(1800),
    [anon_sym_get] = ACTIONS(1800),
    [anon_sym_set] = ACTIONS(1800),
    [anon_sym_declare] = ACTIONS(1800),
    [anon_sym_public] = ACTIONS(1800),
    [anon_sym_private] = ACTIONS(1800),
    [anon_sym_protected] = ACTIONS(1800),
    [anon_sym_override] = ACTIONS(1800),
    [anon_sym_module] = ACTIONS(1800),
    [anon_sym_any] = ACTIONS(1800),
    [anon_sym_number] = ACTIONS(1800),
    [anon_sym_boolean] = ACTIONS(1800),
    [anon_sym_string] = ACTIONS(1800),
    [anon_sym_symbol] = ACTIONS(1800),
  },
  [262] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1871),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1745),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [263] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1740),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3914),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [264] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1409),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3960),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [265] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1688),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1686),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [266] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2976),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3639),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1784),
    [anon_sym_type] = ACTIONS(1784),
    [anon_sym_namespace] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1784),
    [anon_sym_readonly] = ACTIONS(1784),
    [anon_sym_get] = ACTIONS(1784),
    [anon_sym_set] = ACTIONS(1784),
    [anon_sym_declare] = ACTIONS(1784),
    [anon_sym_public] = ACTIONS(1784),
    [anon_sym_private] = ACTIONS(1784),
    [anon_sym_protected] = ACTIONS(1784),
    [anon_sym_override] = ACTIONS(1784),
    [anon_sym_module] = ACTIONS(1784),
    [anon_sym_any] = ACTIONS(1784),
    [anon_sym_number] = ACTIONS(1784),
    [anon_sym_boolean] = ACTIONS(1784),
    [anon_sym_string] = ACTIONS(1784),
    [anon_sym_symbol] = ACTIONS(1784),
  },
  [267] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1818),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1454),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [268] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1699),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [269] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1472),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [270] = {
    [sym_export_clause] = STATE(3248),
    [sym_declaration] = STATE(721),
    [sym_namespace_import_export] = STATE(3603),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1806),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1808),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1656),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [271] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1591),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3776),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [272] = {
    [sym_export_clause] = STATE(3248),
    [sym_declaration] = STATE(721),
    [sym_namespace_import_export] = STATE(3603),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_default] = ACTIONS(1810),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1806),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1656),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [273] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1871),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1419),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [274] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1060),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1444),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1060),
    [sym_subscript_expression] = STATE(1060),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1816),
    [anon_sym_type] = ACTIONS(1816),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1820),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1816),
    [anon_sym_readonly] = ACTIONS(1816),
    [anon_sym_get] = ACTIONS(1816),
    [anon_sym_set] = ACTIONS(1816),
    [anon_sym_declare] = ACTIONS(1816),
    [anon_sym_public] = ACTIONS(1816),
    [anon_sym_private] = ACTIONS(1816),
    [anon_sym_protected] = ACTIONS(1816),
    [anon_sym_override] = ACTIONS(1816),
    [anon_sym_module] = ACTIONS(1816),
    [anon_sym_any] = ACTIONS(1816),
    [anon_sym_number] = ACTIONS(1816),
    [anon_sym_boolean] = ACTIONS(1816),
    [anon_sym_string] = ACTIONS(1816),
    [anon_sym_symbol] = ACTIONS(1816),
  },
  [275] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1873),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3892),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [276] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [277] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1307),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [278] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2008),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [279] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1402),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [280] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [281] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1401),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(3321),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [282] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1343),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1342),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [283] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1852),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(4083),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [284] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_mapped_type_clause] = STATE(3871),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1822),
    [anon_sym_export] = ACTIONS(1824),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_namespace] = ACTIONS(1826),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1824),
    [anon_sym_readonly] = ACTIONS(1824),
    [anon_sym_get] = ACTIONS(1824),
    [anon_sym_set] = ACTIONS(1824),
    [anon_sym_declare] = ACTIONS(1824),
    [anon_sym_public] = ACTIONS(1824),
    [anon_sym_private] = ACTIONS(1824),
    [anon_sym_protected] = ACTIONS(1824),
    [anon_sym_override] = ACTIONS(1824),
    [anon_sym_module] = ACTIONS(1824),
    [anon_sym_any] = ACTIONS(1824),
    [anon_sym_number] = ACTIONS(1824),
    [anon_sym_boolean] = ACTIONS(1824),
    [anon_sym_string] = ACTIONS(1824),
    [anon_sym_symbol] = ACTIONS(1824),
  },
  [285] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1343),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2056),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [286] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1060),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1444),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1060),
    [sym_subscript_expression] = STATE(1060),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1830),
    [anon_sym_export] = ACTIONS(1832),
    [anon_sym_type] = ACTIONS(1832),
    [anon_sym_namespace] = ACTIONS(1834),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1836),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1832),
    [anon_sym_readonly] = ACTIONS(1832),
    [anon_sym_get] = ACTIONS(1832),
    [anon_sym_set] = ACTIONS(1832),
    [anon_sym_declare] = ACTIONS(1832),
    [anon_sym_public] = ACTIONS(1832),
    [anon_sym_private] = ACTIONS(1832),
    [anon_sym_protected] = ACTIONS(1832),
    [anon_sym_override] = ACTIONS(1832),
    [anon_sym_module] = ACTIONS(1832),
    [anon_sym_any] = ACTIONS(1832),
    [anon_sym_number] = ACTIONS(1832),
    [anon_sym_boolean] = ACTIONS(1832),
    [anon_sym_string] = ACTIONS(1832),
    [anon_sym_symbol] = ACTIONS(1832),
  },
  [287] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1762),
    [anon_sym_export] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1770),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_readonly] = ACTIONS(1764),
    [anon_sym_get] = ACTIONS(1764),
    [anon_sym_set] = ACTIONS(1764),
    [anon_sym_declare] = ACTIONS(1764),
    [anon_sym_public] = ACTIONS(1764),
    [anon_sym_private] = ACTIONS(1764),
    [anon_sym_protected] = ACTIONS(1764),
    [anon_sym_override] = ACTIONS(1764),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_any] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1764),
    [anon_sym_boolean] = ACTIONS(1764),
    [anon_sym_string] = ACTIONS(1764),
    [anon_sym_symbol] = ACTIONS(1764),
  },
  [288] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1362),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1363),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [289] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1060),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1444),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1060),
    [sym_subscript_expression] = STATE(1060),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1816),
    [anon_sym_type] = ACTIONS(1816),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1820),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1816),
    [anon_sym_readonly] = ACTIONS(1816),
    [anon_sym_get] = ACTIONS(1816),
    [anon_sym_set] = ACTIONS(1816),
    [anon_sym_declare] = ACTIONS(1816),
    [anon_sym_public] = ACTIONS(1816),
    [anon_sym_private] = ACTIONS(1816),
    [anon_sym_protected] = ACTIONS(1816),
    [anon_sym_override] = ACTIONS(1816),
    [anon_sym_module] = ACTIONS(1816),
    [anon_sym_any] = ACTIONS(1816),
    [anon_sym_number] = ACTIONS(1816),
    [anon_sym_boolean] = ACTIONS(1816),
    [anon_sym_string] = ACTIONS(1816),
    [anon_sym_symbol] = ACTIONS(1816),
  },
  [290] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1370),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1375),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [291] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1376),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1379),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [292] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1688),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1496),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [293] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1769),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1436),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [294] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1376),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1635),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [295] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1818),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1503),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [296] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1790),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1796),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
  },
  [297] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [298] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1491),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [299] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1784),
    [anon_sym_type] = ACTIONS(1784),
    [anon_sym_namespace] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1784),
    [anon_sym_readonly] = ACTIONS(1784),
    [anon_sym_get] = ACTIONS(1784),
    [anon_sym_set] = ACTIONS(1784),
    [anon_sym_declare] = ACTIONS(1784),
    [anon_sym_public] = ACTIONS(1784),
    [anon_sym_private] = ACTIONS(1784),
    [anon_sym_protected] = ACTIONS(1784),
    [anon_sym_override] = ACTIONS(1784),
    [anon_sym_module] = ACTIONS(1784),
    [anon_sym_any] = ACTIONS(1784),
    [anon_sym_number] = ACTIONS(1784),
    [anon_sym_boolean] = ACTIONS(1784),
    [anon_sym_string] = ACTIONS(1784),
    [anon_sym_symbol] = ACTIONS(1784),
  },
  [300] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1489),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [301] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1646),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [302] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1376),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2032),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [303] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1654),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [304] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1060),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1444),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1060),
    [sym_subscript_expression] = STATE(1060),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1830),
    [anon_sym_export] = ACTIONS(1832),
    [anon_sym_type] = ACTIONS(1832),
    [anon_sym_namespace] = ACTIONS(1834),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1836),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1832),
    [anon_sym_readonly] = ACTIONS(1832),
    [anon_sym_get] = ACTIONS(1832),
    [anon_sym_set] = ACTIONS(1832),
    [anon_sym_declare] = ACTIONS(1832),
    [anon_sym_public] = ACTIONS(1832),
    [anon_sym_private] = ACTIONS(1832),
    [anon_sym_protected] = ACTIONS(1832),
    [anon_sym_override] = ACTIONS(1832),
    [anon_sym_module] = ACTIONS(1832),
    [anon_sym_any] = ACTIONS(1832),
    [anon_sym_number] = ACTIONS(1832),
    [anon_sym_boolean] = ACTIONS(1832),
    [anon_sym_string] = ACTIONS(1832),
    [anon_sym_symbol] = ACTIONS(1832),
  },
  [305] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(3019),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3803),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1800),
    [anon_sym_type] = ACTIONS(1800),
    [anon_sym_namespace] = ACTIONS(1802),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1804),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1800),
    [anon_sym_readonly] = ACTIONS(1800),
    [anon_sym_get] = ACTIONS(1800),
    [anon_sym_set] = ACTIONS(1800),
    [anon_sym_declare] = ACTIONS(1800),
    [anon_sym_public] = ACTIONS(1800),
    [anon_sym_private] = ACTIONS(1800),
    [anon_sym_protected] = ACTIONS(1800),
    [anon_sym_override] = ACTIONS(1800),
    [anon_sym_module] = ACTIONS(1800),
    [anon_sym_any] = ACTIONS(1800),
    [anon_sym_number] = ACTIONS(1800),
    [anon_sym_boolean] = ACTIONS(1800),
    [anon_sym_string] = ACTIONS(1800),
    [anon_sym_symbol] = ACTIONS(1800),
  },
  [306] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1343),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1679),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [307] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1514),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_sequence_expression] = STATE(3632),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [308] = {
    [sym_import] = STATE(1872),
    [sym_statement_block] = STATE(1769),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1465),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [309] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1198),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [310] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1362),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1682),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [311] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1370),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2035),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [312] = {
    [sym_import] = STATE(1310),
    [sym_statement_block] = STATE(1370),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1683),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [313] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1842),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [314] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1429),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [315] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1442),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [316] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [317] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1952),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [318] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [319] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1349),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [320] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1353),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [321] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1642),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [322] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1356),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [323] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1841),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [324] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1358),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [325] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1359),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [326] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1840),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [327] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1896),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [328] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1361),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [329] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1694),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [330] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [331] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1346),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [332] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1773),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [333] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1413),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [334] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1884),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [335] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1405),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [336] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1449),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [337] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1377),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [338] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1739),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [339] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1734),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [340] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1469),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [341] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1493),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2981),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2981),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1086),
    [sym_subscript_expression] = STATE(1086),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2981),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1086),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_type] = ACTIONS(953),
    [anon_sym_namespace] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1846),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_get] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(953),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_public] = ACTIONS(953),
    [anon_sym_private] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(953),
    [anon_sym_override] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(953),
    [anon_sym_any] = ACTIONS(953),
    [anon_sym_number] = ACTIONS(953),
    [anon_sym_boolean] = ACTIONS(953),
    [anon_sym_string] = ACTIONS(953),
    [anon_sym_symbol] = ACTIONS(953),
  },
  [342] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1793),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [343] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1341),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [344] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1736),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [345] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1789),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [346] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1445),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [347] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1923),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [348] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1788),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [349] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1371),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [350] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1932),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [351] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1366),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [352] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1439),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [353] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1368),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [354] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1785),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [355] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1784),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [356] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1778),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [357] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1410),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [358] = {
    [sym__call_signature] = STATE(4055),
    [sym_string] = STATE(2959),
    [sym_formal_parameters] = STATE(2922),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_export] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1850),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_function] = ACTIONS(1866),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_readonly] = ACTIONS(1850),
    [anon_sym_get] = ACTIONS(1870),
    [anon_sym_set] = ACTIONS(1870),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1850),
    [anon_sym_private] = ACTIONS(1850),
    [anon_sym_protected] = ACTIONS(1850),
    [anon_sym_override] = ACTIONS(1850),
    [anon_sym_module] = ACTIONS(1850),
    [anon_sym_any] = ACTIONS(1850),
    [anon_sym_number] = ACTIONS(1850),
    [anon_sym_boolean] = ACTIONS(1850),
    [anon_sym_string] = ACTIONS(1850),
    [anon_sym_symbol] = ACTIONS(1850),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [359] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1469),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [360] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1458),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [361] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [362] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1953),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [363] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [364] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1872),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [365] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1334),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [366] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1813),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [367] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1694),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1840),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [368] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1805),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [369] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1808),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [370] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1414),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [371] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1929),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [372] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1777),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [373] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1309),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [374] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1420),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [375] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1772),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [376] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1440),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [377] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1771),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [378] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1891),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [379] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1909),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [380] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1765),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [381] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [382] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1763),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [383] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1762),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [384] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1441),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [385] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1706),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [386] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1696),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [387] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1895),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [388] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2039),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [389] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1917),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [390] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [391] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1921),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [392] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1693),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [393] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2044),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [394] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1423),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [395] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1899),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [396] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1840),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [397] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1933),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [398] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(1993),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [399] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1396),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [400] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1829),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [401] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1490),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [402] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1794),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [403] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1482),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [404] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1680),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [405] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1430),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [406] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1431),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [407] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1678),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [408] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1677),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [409] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1676),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [410] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1675),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [411] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1674),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [412] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1672),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [413] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1670),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [414] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1668),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [415] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1666),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [416] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1801),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [417] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1922),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [418] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1664),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [419] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(1996),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [420] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1937),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [421] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1364),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [422] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1493),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [423] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1561),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [424] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1657),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [425] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1424),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [426] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1656),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [427] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [428] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1447),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [429] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1731),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [430] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1653),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [431] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1649),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [432] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1448),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [433] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1684),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [434] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1648),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [435] = {
    [sym__call_signature] = STATE(4055),
    [sym_string] = STATE(2959),
    [sym_formal_parameters] = STATE(2922),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_export] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1850),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_function] = ACTIONS(1866),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_readonly] = ACTIONS(1850),
    [anon_sym_get] = ACTIONS(1870),
    [anon_sym_set] = ACTIONS(1870),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1850),
    [anon_sym_private] = ACTIONS(1850),
    [anon_sym_protected] = ACTIONS(1850),
    [anon_sym_override] = ACTIONS(1850),
    [anon_sym_module] = ACTIONS(1850),
    [anon_sym_any] = ACTIONS(1850),
    [anon_sym_number] = ACTIONS(1850),
    [anon_sym_boolean] = ACTIONS(1850),
    [anon_sym_string] = ACTIONS(1850),
    [anon_sym_symbol] = ACTIONS(1850),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [436] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(2801),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(2801),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1032),
    [sym_subscript_expression] = STATE(1032),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(2801),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1032),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1874),
    [anon_sym_export] = ACTIONS(1876),
    [anon_sym_type] = ACTIONS(1876),
    [anon_sym_namespace] = ACTIONS(1878),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1880),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1882),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1876),
    [anon_sym_readonly] = ACTIONS(1876),
    [anon_sym_get] = ACTIONS(1876),
    [anon_sym_set] = ACTIONS(1876),
    [anon_sym_declare] = ACTIONS(1876),
    [anon_sym_public] = ACTIONS(1876),
    [anon_sym_private] = ACTIONS(1876),
    [anon_sym_protected] = ACTIONS(1876),
    [anon_sym_override] = ACTIONS(1876),
    [anon_sym_module] = ACTIONS(1876),
    [anon_sym_any] = ACTIONS(1876),
    [anon_sym_number] = ACTIONS(1876),
    [anon_sym_boolean] = ACTIONS(1876),
    [anon_sym_string] = ACTIONS(1876),
    [anon_sym_symbol] = ACTIONS(1876),
  },
  [437] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1840),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [438] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2026),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [439] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1729),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [440] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1728),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [441] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1661),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [442] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1450),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [443] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2002),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [444] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1792),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [445] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1884),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [446] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1845),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [447] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2003),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [448] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1840),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [449] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2013),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [450] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1492),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [451] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [452] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1939),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [453] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1727),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [454] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1471),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [455] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1406),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [456] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1671),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [457] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1916),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [458] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1425),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [459] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1957),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [460] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1901),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [461] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1942),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [462] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1943),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [463] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1725),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [464] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1893),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [465] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1898),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [466] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1948),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [467] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1946),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [468] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1637),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1840),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [469] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1954),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [470] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1456),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [471] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1644),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [472] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1724),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [473] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1689),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [474] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1721),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [475] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2025),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [476] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1641),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [477] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2027),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [478] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [479] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1417),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [480] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [481] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2031),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [482] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [483] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_expression] = STATE(1913),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4118),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3885),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1135),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(1059),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_override] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [484] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1437),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [485] = {
    [sym__call_signature] = STATE(4055),
    [sym_string] = STATE(2959),
    [sym_formal_parameters] = STATE(2922),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_export] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1850),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_function] = ACTIONS(1866),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_readonly] = ACTIONS(1850),
    [anon_sym_get] = ACTIONS(1870),
    [anon_sym_set] = ACTIONS(1870),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1850),
    [anon_sym_private] = ACTIONS(1850),
    [anon_sym_protected] = ACTIONS(1850),
    [anon_sym_override] = ACTIONS(1850),
    [anon_sym_module] = ACTIONS(1850),
    [anon_sym_any] = ACTIONS(1850),
    [anon_sym_number] = ACTIONS(1850),
    [anon_sym_boolean] = ACTIONS(1850),
    [anon_sym_string] = ACTIONS(1850),
    [anon_sym_symbol] = ACTIONS(1850),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [486] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2034),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [487] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1457),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [488] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1466),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [489] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1305),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [490] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [491] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1805),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [492] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2009),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [493] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1459),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [494] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [495] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1351),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [496] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1464),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [497] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1884),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [498] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1463),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [499] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1462),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [500] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1422),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [501] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1428),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [502] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4045),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4045),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3865),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2343),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4045),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(416),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_override] = ACTIONS(889),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
  },
  [503] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1495),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [504] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1435),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [505] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [506] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1433),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [507] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2060),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [508] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1418),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [509] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1637),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [510] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1410),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [511] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1553),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [512] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4088),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4088),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4043),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1109),
    [sym_subscript_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2329),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4088),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(991),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
  },
  [513] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1746),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [514] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2059),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [515] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2058),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [516] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2057),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [517] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1720),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [518] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1432),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [519] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1719),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [520] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1713),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [521] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1443),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [522] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(1480),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4097),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4097),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4095),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2347),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4097),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_get] = ACTIONS(1003),
    [anon_sym_set] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_override] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_any] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_boolean] = ACTIONS(1003),
    [anon_sym_string] = ACTIONS(1003),
    [anon_sym_symbol] = ACTIONS(1003),
  },
  [523] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1009),
    [sym_expression] = STATE(2053),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(4039),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(4039),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3958),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1009),
    [sym_subscript_expression] = STATE(1009),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2344),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(4039),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1009),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(398),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(169),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(132),
    [anon_sym_yield] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(169),
    [anon_sym_delete] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_readonly] = ACTIONS(933),
    [anon_sym_get] = ACTIONS(933),
    [anon_sym_set] = ACTIONS(933),
    [anon_sym_declare] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(933),
    [anon_sym_private] = ACTIONS(933),
    [anon_sym_protected] = ACTIONS(933),
    [anon_sym_override] = ACTIONS(933),
    [anon_sym_module] = ACTIONS(933),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
  },
  [524] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1485),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(4126),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(4126),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(4127),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2339),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(4126),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(458),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_readonly] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_override] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
  },
  [525] = {
    [sym_import] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_expression] = STATE(1717),
    [sym_primary_expression] = STATE(1750),
    [sym_yield_expression] = STATE(1766),
    [sym_object] = STATE(1872),
    [sym_object_pattern] = STATE(3931),
    [sym_array] = STATE(1872),
    [sym_array_pattern] = STATE(3931),
    [sym_class] = STATE(1872),
    [sym_function] = STATE(1872),
    [sym_generator_function] = STATE(1872),
    [sym_arrow_function] = STATE(1872),
    [sym__call_signature] = STATE(3929),
    [sym_call_expression] = STATE(1872),
    [sym_new_expression] = STATE(1766),
    [sym_await_expression] = STATE(1766),
    [sym_member_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1766),
    [sym__augmented_assignment_lhs] = STATE(2337),
    [sym_augmented_assignment_expression] = STATE(1766),
    [sym__destructuring_pattern] = STATE(3931),
    [sym_ternary_expression] = STATE(1766),
    [sym_binary_expression] = STATE(1766),
    [sym_unary_expression] = STATE(1766),
    [sym_update_expression] = STATE(1766),
    [sym_string] = STATE(1872),
    [sym_template_string] = STATE(1872),
    [sym_regex] = STATE(1872),
    [sym_meta_property] = STATE(1872),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1766),
    [sym_as_expression] = STATE(1766),
    [sym_internal_module] = STATE(1766),
    [sym_type_arguments] = STATE(437),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_override] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
  },
  [526] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1054),
    [sym_expression] = STATE(1390),
    [sym_primary_expression] = STATE(1313),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1310),
    [sym_object_pattern] = STATE(3952),
    [sym_array] = STATE(1310),
    [sym_array_pattern] = STATE(3952),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(4071),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1314),
    [sym__augmented_assignment_lhs] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym__destructuring_pattern] = STATE(3952),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2922),
    [sym_non_null_expression] = STATE(1054),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(349),
    [sym_type_parameters] = STATE(3601),
    [aux_sym_export_statement_repeat1] = STATE(3323),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(184),
    [sym_super] = ACTIONS(184),
    [sym_true] = ACTIONS(184),
    [sym_false] = ACTIONS(184),
    [sym_null] = ACTIONS(184),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [527] = {
    [sym_declaration] = STATE(712),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1808),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1740),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_global] = ACTIONS(1742),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [528] = {
    [sym_declaration] = STATE(712),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1740),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_global] = ACTIONS(1742),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [529] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [sym_override_modifier] = STATE(2216),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1888),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1892),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1894),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [530] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [sym_override_modifier] = STATE(2216),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1888),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1892),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1894),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [531] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [sym_override_modifier] = STATE(2216),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1888),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1892),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1894),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [532] = {
    [sym_declaration] = STATE(3162),
    [sym_variable_declaration] = STATE(3159),
    [sym_lexical_declaration] = STATE(3159),
    [sym_class_declaration] = STATE(3159),
    [sym_function_declaration] = STATE(3159),
    [sym_generator_function_declaration] = STATE(3159),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(3159),
    [sym_ambient_declaration] = STATE(3159),
    [sym_abstract_class_declaration] = STATE(3159),
    [sym_module] = STATE(3159),
    [sym_internal_module] = STATE(3161),
    [sym_import_alias] = STATE(3159),
    [sym_interface_declaration] = STATE(3159),
    [sym_enum_declaration] = STATE(3159),
    [sym_type_alias_declaration] = STATE(3159),
    [aux_sym_export_statement_repeat1] = STATE(2992),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1896),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1898),
    [anon_sym_import] = ACTIONS(1900),
    [anon_sym_var] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1904),
    [anon_sym_const] = ACTIONS(1906),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1908),
    [anon_sym_async] = ACTIONS(1910),
    [anon_sym_function] = ACTIONS(1912),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1918),
    [anon_sym_global] = ACTIONS(1920),
    [anon_sym_interface] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1924),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [533] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1886),
    [anon_sym_set] = ACTIONS(1886),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [534] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1886),
    [anon_sym_set] = ACTIONS(1886),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [535] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1888),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1892),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [536] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1888),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1892),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [537] = {
    [sym_declaration] = STATE(712),
    [sym_variable_declaration] = STATE(734),
    [sym_lexical_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym_generator_function_declaration] = STATE(734),
    [sym_decorator] = STATE(1129),
    [sym_function_signature] = STATE(734),
    [sym_ambient_declaration] = STATE(734),
    [sym_abstract_class_declaration] = STATE(734),
    [sym_module] = STATE(734),
    [sym_internal_module] = STATE(707),
    [sym_import_alias] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_type_alias_declaration] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(2973),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_import] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(151),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1740),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_global] = ACTIONS(1742),
    [anon_sym_interface] = ACTIONS(1660),
    [anon_sym_enum] = ACTIONS(1662),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [538] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1886),
    [anon_sym_set] = ACTIONS(1886),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [539] = {
    [sym_string] = STATE(2959),
    [sym__property_name] = STATE(2959),
    [sym_computed_property_name] = STATE(2959),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1888),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1868),
    [sym_private_property_identifier] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1892),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1926),
    [sym_identifier] = ACTIONS(1928),
    [anon_sym_export] = ACTIONS(1928),
    [anon_sym_default] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(1928),
    [anon_sym_EQ] = ACTIONS(1928),
    [anon_sym_namespace] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1926),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1928),
    [anon_sym_import] = ACTIONS(1928),
    [anon_sym_var] = ACTIONS(1928),
    [anon_sym_let] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_else] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_LPAREN] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1926),
    [anon_sym_await] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_with] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_debugger] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_COLON] = ACTIONS(1926),
    [anon_sym_case] = ACTIONS(1928),
    [anon_sym_yield] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1926),
    [anon_sym_RBRACK] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_async] = ACTIONS(1928),
    [anon_sym_function] = ACTIONS(1928),
    [anon_sym_EQ_GT] = ACTIONS(1926),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_void] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1926),
    [sym_number] = ACTIONS(1926),
    [sym_this] = ACTIONS(1928),
    [sym_super] = ACTIONS(1928),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [sym_null] = ACTIONS(1928),
    [sym_undefined] = ACTIONS(1928),
    [anon_sym_AT] = ACTIONS(1926),
    [anon_sym_static] = ACTIONS(1928),
    [anon_sym_readonly] = ACTIONS(1928),
    [anon_sym_get] = ACTIONS(1928),
    [anon_sym_set] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1926),
    [anon_sym_declare] = ACTIONS(1928),
    [anon_sym_public] = ACTIONS(1928),
    [anon_sym_private] = ACTIONS(1928),
    [anon_sym_protected] = ACTIONS(1928),
    [anon_sym_override] = ACTIONS(1928),
    [anon_sym_module] = ACTIONS(1928),
    [anon_sym_any] = ACTIONS(1928),
    [anon_sym_number] = ACTIONS(1928),
    [anon_sym_boolean] = ACTIONS(1928),
    [anon_sym_string] = ACTIONS(1928),
    [anon_sym_symbol] = ACTIONS(1928),
    [anon_sym_abstract] = ACTIONS(1928),
    [anon_sym_extends] = ACTIONS(1928),
    [anon_sym_interface] = ACTIONS(1928),
    [anon_sym_enum] = ACTIONS(1928),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_EQ] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_COMMA] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_typeof] = ACTIONS(1454),
    [anon_sym_import] = ACTIONS(1454),
    [anon_sym_var] = ACTIONS(1454),
    [anon_sym_let] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_RPAREN] = ACTIONS(1452),
    [anon_sym_await] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(1454),
    [anon_sym_with] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_debugger] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_throw] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_COLON] = ACTIONS(1452),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_yield] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1452),
    [anon_sym_RBRACK] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1454),
    [anon_sym_class] = ACTIONS(1454),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(1454),
    [anon_sym_EQ_GT] = ACTIONS(1452),
    [anon_sym_new] = ACTIONS(1454),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1454),
    [anon_sym_delete] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [sym_number] = ACTIONS(1452),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_undefined] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_readonly] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1452),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_override] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [anon_sym_abstract] = ACTIONS(1454),
    [anon_sym_extends] = ACTIONS(1454),
    [anon_sym_interface] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1930),
    [sym_identifier] = ACTIONS(1932),
    [anon_sym_export] = ACTIONS(1932),
    [anon_sym_default] = ACTIONS(1932),
    [anon_sym_type] = ACTIONS(1932),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_namespace] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_COMMA] = ACTIONS(1930),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_typeof] = ACTIONS(1932),
    [anon_sym_import] = ACTIONS(1932),
    [anon_sym_var] = ACTIONS(1932),
    [anon_sym_let] = ACTIONS(1932),
    [anon_sym_const] = ACTIONS(1932),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_else] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(1932),
    [anon_sym_switch] = ACTIONS(1932),
    [anon_sym_for] = ACTIONS(1932),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [anon_sym_RPAREN] = ACTIONS(1930),
    [anon_sym_await] = ACTIONS(1932),
    [anon_sym_while] = ACTIONS(1932),
    [anon_sym_do] = ACTIONS(1932),
    [anon_sym_try] = ACTIONS(1932),
    [anon_sym_with] = ACTIONS(1932),
    [anon_sym_break] = ACTIONS(1932),
    [anon_sym_continue] = ACTIONS(1932),
    [anon_sym_debugger] = ACTIONS(1932),
    [anon_sym_return] = ACTIONS(1932),
    [anon_sym_throw] = ACTIONS(1932),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_COLON] = ACTIONS(1930),
    [anon_sym_case] = ACTIONS(1932),
    [anon_sym_yield] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1930),
    [anon_sym_RBRACK] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_SLASH] = ACTIONS(1932),
    [anon_sym_class] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1932),
    [anon_sym_function] = ACTIONS(1932),
    [anon_sym_EQ_GT] = ACTIONS(1930),
    [anon_sym_new] = ACTIONS(1932),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_void] = ACTIONS(1932),
    [anon_sym_delete] = ACTIONS(1932),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1930),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_super] = ACTIONS(1932),
    [sym_true] = ACTIONS(1932),
    [sym_false] = ACTIONS(1932),
    [sym_null] = ACTIONS(1932),
    [sym_undefined] = ACTIONS(1932),
    [anon_sym_AT] = ACTIONS(1930),
    [anon_sym_static] = ACTIONS(1932),
    [anon_sym_readonly] = ACTIONS(1932),
    [anon_sym_get] = ACTIONS(1932),
    [anon_sym_set] = ACTIONS(1932),
    [anon_sym_QMARK] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1932),
    [anon_sym_public] = ACTIONS(1932),
    [anon_sym_private] = ACTIONS(1932),
    [anon_sym_protected] = ACTIONS(1932),
    [anon_sym_override] = ACTIONS(1932),
    [anon_sym_module] = ACTIONS(1932),
    [anon_sym_any] = ACTIONS(1932),
    [anon_sym_number] = ACTIONS(1932),
    [anon_sym_boolean] = ACTIONS(1932),
    [anon_sym_string] = ACTIONS(1932),
    [anon_sym_symbol] = ACTIONS(1932),
    [anon_sym_abstract] = ACTIONS(1932),
    [anon_sym_extends] = ACTIONS(1932),
    [anon_sym_interface] = ACTIONS(1932),
    [anon_sym_enum] = ACTIONS(1932),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1934),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_type] = ACTIONS(1936),
    [anon_sym_EQ] = ACTIONS(1936),
    [anon_sym_namespace] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_typeof] = ACTIONS(1936),
    [anon_sym_import] = ACTIONS(1936),
    [anon_sym_var] = ACTIONS(1936),
    [anon_sym_let] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_LPAREN] = ACTIONS(1934),
    [anon_sym_RPAREN] = ACTIONS(1934),
    [anon_sym_await] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_with] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_debugger] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_COLON] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_yield] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_RBRACK] = ACTIONS(1934),
    [anon_sym_LT] = ACTIONS(1934),
    [anon_sym_GT] = ACTIONS(1934),
    [anon_sym_SLASH] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_async] = ACTIONS(1936),
    [anon_sym_function] = ACTIONS(1936),
    [anon_sym_EQ_GT] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1934),
    [anon_sym_PIPE] = ACTIONS(1934),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_void] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [sym_number] = ACTIONS(1934),
    [sym_this] = ACTIONS(1936),
    [sym_super] = ACTIONS(1936),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [sym_null] = ACTIONS(1936),
    [sym_undefined] = ACTIONS(1936),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_readonly] = ACTIONS(1936),
    [anon_sym_get] = ACTIONS(1936),
    [anon_sym_set] = ACTIONS(1936),
    [anon_sym_QMARK] = ACTIONS(1934),
    [anon_sym_declare] = ACTIONS(1936),
    [anon_sym_public] = ACTIONS(1936),
    [anon_sym_private] = ACTIONS(1936),
    [anon_sym_protected] = ACTIONS(1936),
    [anon_sym_override] = ACTIONS(1936),
    [anon_sym_module] = ACTIONS(1936),
    [anon_sym_any] = ACTIONS(1936),
    [anon_sym_number] = ACTIONS(1936),
    [anon_sym_boolean] = ACTIONS(1936),
    [anon_sym_string] = ACTIONS(1936),
    [anon_sym_symbol] = ACTIONS(1936),
    [anon_sym_abstract] = ACTIONS(1936),
    [anon_sym_extends] = ACTIONS(1936),
    [anon_sym_interface] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_export] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_type] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(1938),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_typeof] = ACTIONS(1940),
    [anon_sym_import] = ACTIONS(1940),
    [anon_sym_var] = ACTIONS(1940),
    [anon_sym_let] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_LPAREN] = ACTIONS(1938),
    [anon_sym_RPAREN] = ACTIONS(1938),
    [anon_sym_await] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_with] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_debugger] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_COLON] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_yield] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_RBRACK] = ACTIONS(1938),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_SLASH] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_function] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1938),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1938),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_void] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [sym_number] = ACTIONS(1938),
    [sym_this] = ACTIONS(1940),
    [sym_super] = ACTIONS(1940),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [sym_null] = ACTIONS(1940),
    [sym_undefined] = ACTIONS(1940),
    [anon_sym_AT] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_readonly] = ACTIONS(1940),
    [anon_sym_get] = ACTIONS(1940),
    [anon_sym_set] = ACTIONS(1940),
    [anon_sym_QMARK] = ACTIONS(1938),
    [anon_sym_declare] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_override] = ACTIONS(1940),
    [anon_sym_module] = ACTIONS(1940),
    [anon_sym_any] = ACTIONS(1940),
    [anon_sym_number] = ACTIONS(1940),
    [anon_sym_boolean] = ACTIONS(1940),
    [anon_sym_string] = ACTIONS(1940),
    [anon_sym_symbol] = ACTIONS(1940),
    [anon_sym_abstract] = ACTIONS(1940),
    [anon_sym_extends] = ACTIONS(1940),
    [anon_sym_interface] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1332),
    [sym_identifier] = ACTIONS(1334),
    [anon_sym_export] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_type] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_namespace] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_typeof] = ACTIONS(1334),
    [anon_sym_import] = ACTIONS(1334),
    [anon_sym_var] = ACTIONS(1334),
    [anon_sym_let] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1332),
    [anon_sym_RPAREN] = ACTIONS(1332),
    [anon_sym_await] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_with] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_debugger] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_throw] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_yield] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_RBRACK] = ACTIONS(1332),
    [anon_sym_LT] = ACTIONS(1332),
    [anon_sym_GT] = ACTIONS(1332),
    [anon_sym_SLASH] = ACTIONS(1334),
    [anon_sym_class] = ACTIONS(1334),
    [anon_sym_async] = ACTIONS(1334),
    [anon_sym_function] = ACTIONS(1334),
    [anon_sym_EQ_GT] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_void] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1332),
    [sym_number] = ACTIONS(1332),
    [sym_this] = ACTIONS(1334),
    [sym_super] = ACTIONS(1334),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_undefined] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_readonly] = ACTIONS(1334),
    [anon_sym_get] = ACTIONS(1334),
    [anon_sym_set] = ACTIONS(1334),
    [anon_sym_QMARK] = ACTIONS(1332),
    [anon_sym_declare] = ACTIONS(1334),
    [anon_sym_public] = ACTIONS(1334),
    [anon_sym_private] = ACTIONS(1334),
    [anon_sym_protected] = ACTIONS(1334),
    [anon_sym_override] = ACTIONS(1334),
    [anon_sym_module] = ACTIONS(1334),
    [anon_sym_any] = ACTIONS(1334),
    [anon_sym_number] = ACTIONS(1334),
    [anon_sym_boolean] = ACTIONS(1334),
    [anon_sym_string] = ACTIONS(1334),
    [anon_sym_symbol] = ACTIONS(1334),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_extends] = ACTIONS(1334),
    [anon_sym_interface] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1942),
    [sym_identifier] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_default] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1944),
    [anon_sym_LBRACE] = ACTIONS(1942),
    [anon_sym_COMMA] = ACTIONS(1942),
    [anon_sym_RBRACE] = ACTIONS(1942),
    [anon_sym_typeof] = ACTIONS(1944),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_var] = ACTIONS(1944),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_const] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1944),
    [anon_sym_if] = ACTIONS(1944),
    [anon_sym_switch] = ACTIONS(1944),
    [anon_sym_for] = ACTIONS(1944),
    [anon_sym_LPAREN] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_await] = ACTIONS(1944),
    [anon_sym_while] = ACTIONS(1944),
    [anon_sym_do] = ACTIONS(1944),
    [anon_sym_try] = ACTIONS(1944),
    [anon_sym_with] = ACTIONS(1944),
    [anon_sym_break] = ACTIONS(1944),
    [anon_sym_continue] = ACTIONS(1944),
    [anon_sym_debugger] = ACTIONS(1944),
    [anon_sym_return] = ACTIONS(1944),
    [anon_sym_throw] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_COLON] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1944),
    [anon_sym_yield] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_RBRACK] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(1944),
    [anon_sym_EQ_GT] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1942),
    [anon_sym_void] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_SQUOTE] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [sym_number] = ACTIONS(1942),
    [sym_this] = ACTIONS(1944),
    [sym_super] = ACTIONS(1944),
    [sym_true] = ACTIONS(1944),
    [sym_false] = ACTIONS(1944),
    [sym_null] = ACTIONS(1944),
    [sym_undefined] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1944),
    [anon_sym_readonly] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_override] = ACTIONS(1944),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_abstract] = ACTIONS(1944),
    [anon_sym_extends] = ACTIONS(1944),
    [anon_sym_interface] = ACTIONS(1944),
    [anon_sym_enum] = ACTIONS(1944),
  },
  [547] = {
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_type] = ACTIONS(1571),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1571),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1571),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1573),
    [sym_private_property_identifier] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1571),
    [anon_sym_readonly] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(1571),
    [anon_sym_set] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1571),
    [anon_sym_public] = ACTIONS(1571),
    [anon_sym_private] = ACTIONS(1571),
    [anon_sym_protected] = ACTIONS(1571),
    [anon_sym_override] = ACTIONS(1571),
    [anon_sym_module] = ACTIONS(1571),
    [anon_sym_any] = ACTIONS(1571),
    [anon_sym_number] = ACTIONS(1571),
    [anon_sym_boolean] = ACTIONS(1571),
    [anon_sym_string] = ACTIONS(1571),
    [anon_sym_symbol] = ACTIONS(1571),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [548] = {
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_type] = ACTIONS(1571),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1571),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1571),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1573),
    [sym_private_property_identifier] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1571),
    [anon_sym_readonly] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(1571),
    [anon_sym_set] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1571),
    [anon_sym_public] = ACTIONS(1571),
    [anon_sym_private] = ACTIONS(1571),
    [anon_sym_protected] = ACTIONS(1571),
    [anon_sym_override] = ACTIONS(1571),
    [anon_sym_module] = ACTIONS(1571),
    [anon_sym_any] = ACTIONS(1571),
    [anon_sym_number] = ACTIONS(1571),
    [anon_sym_boolean] = ACTIONS(1571),
    [anon_sym_string] = ACTIONS(1571),
    [anon_sym_symbol] = ACTIONS(1571),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [549] = {
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1560),
    [sym_private_property_identifier] = ACTIONS(1560),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_readonly] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_override] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [550] = {
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1560),
    [sym_private_property_identifier] = ACTIONS(1560),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_readonly] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_override] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [551] = {
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_type] = ACTIONS(1571),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1571),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1571),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1573),
    [sym_private_property_identifier] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1571),
    [anon_sym_readonly] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(1571),
    [anon_sym_set] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1571),
    [anon_sym_public] = ACTIONS(1571),
    [anon_sym_private] = ACTIONS(1571),
    [anon_sym_protected] = ACTIONS(1571),
    [anon_sym_override] = ACTIONS(1571),
    [anon_sym_module] = ACTIONS(1571),
    [anon_sym_any] = ACTIONS(1571),
    [anon_sym_number] = ACTIONS(1571),
    [anon_sym_boolean] = ACTIONS(1571),
    [anon_sym_string] = ACTIONS(1571),
    [anon_sym_symbol] = ACTIONS(1571),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [552] = {
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym_number] = ACTIONS(1560),
    [sym_private_property_identifier] = ACTIONS(1560),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_readonly] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_override] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [553] = {
    [sym__call_signature] = STATE(3941),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [554] = {
    [sym__call_signature] = STATE(3941),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_QMARK] = ACTIONS(1958),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [555] = {
    [sym__call_signature] = STATE(3926),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1960),
    [anon_sym_export] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_readonly] = ACTIONS(1962),
    [anon_sym_get] = ACTIONS(1962),
    [anon_sym_set] = ACTIONS(1962),
    [anon_sym_QMARK] = ACTIONS(609),
    [anon_sym_declare] = ACTIONS(1962),
    [anon_sym_public] = ACTIONS(1962),
    [anon_sym_private] = ACTIONS(1962),
    [anon_sym_protected] = ACTIONS(1962),
    [anon_sym_override] = ACTIONS(1962),
    [anon_sym_module] = ACTIONS(1962),
    [anon_sym_any] = ACTIONS(1962),
    [anon_sym_number] = ACTIONS(1962),
    [anon_sym_boolean] = ACTIONS(1962),
    [anon_sym_string] = ACTIONS(1962),
    [anon_sym_symbol] = ACTIONS(1962),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [556] = {
    [sym__call_signature] = STATE(3926),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1960),
    [anon_sym_export] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_readonly] = ACTIONS(1962),
    [anon_sym_get] = ACTIONS(1962),
    [anon_sym_set] = ACTIONS(1962),
    [anon_sym_declare] = ACTIONS(1962),
    [anon_sym_public] = ACTIONS(1962),
    [anon_sym_private] = ACTIONS(1962),
    [anon_sym_protected] = ACTIONS(1962),
    [anon_sym_override] = ACTIONS(1962),
    [anon_sym_module] = ACTIONS(1962),
    [anon_sym_any] = ACTIONS(1962),
    [anon_sym_number] = ACTIONS(1962),
    [anon_sym_boolean] = ACTIONS(1962),
    [anon_sym_string] = ACTIONS(1962),
    [anon_sym_symbol] = ACTIONS(1962),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [557] = {
    [sym__call_signature] = STATE(3926),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1960),
    [anon_sym_export] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_readonly] = ACTIONS(1962),
    [anon_sym_get] = ACTIONS(1962),
    [anon_sym_set] = ACTIONS(1962),
    [anon_sym_declare] = ACTIONS(1962),
    [anon_sym_public] = ACTIONS(1962),
    [anon_sym_private] = ACTIONS(1962),
    [anon_sym_protected] = ACTIONS(1962),
    [anon_sym_override] = ACTIONS(1962),
    [anon_sym_module] = ACTIONS(1962),
    [anon_sym_any] = ACTIONS(1962),
    [anon_sym_number] = ACTIONS(1962),
    [anon_sym_boolean] = ACTIONS(1962),
    [anon_sym_string] = ACTIONS(1962),
    [anon_sym_symbol] = ACTIONS(1962),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [558] = {
    [sym__call_signature] = STATE(3926),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1960),
    [anon_sym_export] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_readonly] = ACTIONS(1962),
    [anon_sym_get] = ACTIONS(1962),
    [anon_sym_set] = ACTIONS(1962),
    [anon_sym_declare] = ACTIONS(1962),
    [anon_sym_public] = ACTIONS(1962),
    [anon_sym_private] = ACTIONS(1962),
    [anon_sym_protected] = ACTIONS(1962),
    [anon_sym_override] = ACTIONS(1962),
    [anon_sym_module] = ACTIONS(1962),
    [anon_sym_any] = ACTIONS(1962),
    [anon_sym_number] = ACTIONS(1962),
    [anon_sym_boolean] = ACTIONS(1962),
    [anon_sym_string] = ACTIONS(1962),
    [anon_sym_symbol] = ACTIONS(1962),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [559] = {
    [sym__call_signature] = STATE(4055),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_export] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(1968),
    [anon_sym_of] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1966),
    [anon_sym_readonly] = ACTIONS(1966),
    [anon_sym_get] = ACTIONS(1966),
    [anon_sym_set] = ACTIONS(1966),
    [anon_sym_declare] = ACTIONS(1966),
    [anon_sym_public] = ACTIONS(1966),
    [anon_sym_private] = ACTIONS(1966),
    [anon_sym_protected] = ACTIONS(1966),
    [anon_sym_override] = ACTIONS(1966),
    [anon_sym_module] = ACTIONS(1966),
    [anon_sym_any] = ACTIONS(1966),
    [anon_sym_number] = ACTIONS(1966),
    [anon_sym_boolean] = ACTIONS(1966),
    [anon_sym_string] = ACTIONS(1966),
    [anon_sym_symbol] = ACTIONS(1966),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [560] = {
    [sym__call_signature] = STATE(4055),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_export] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1966),
    [anon_sym_readonly] = ACTIONS(1966),
    [anon_sym_get] = ACTIONS(1966),
    [anon_sym_set] = ACTIONS(1966),
    [anon_sym_declare] = ACTIONS(1966),
    [anon_sym_public] = ACTIONS(1966),
    [anon_sym_private] = ACTIONS(1966),
    [anon_sym_protected] = ACTIONS(1966),
    [anon_sym_override] = ACTIONS(1966),
    [anon_sym_module] = ACTIONS(1966),
    [anon_sym_any] = ACTIONS(1966),
    [anon_sym_number] = ACTIONS(1966),
    [anon_sym_boolean] = ACTIONS(1966),
    [anon_sym_string] = ACTIONS(1966),
    [anon_sym_symbol] = ACTIONS(1966),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [561] = {
    [sym__call_signature] = STATE(4103),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_export] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1977),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1977),
    [anon_sym_get] = ACTIONS(1977),
    [anon_sym_set] = ACTIONS(1977),
    [anon_sym_declare] = ACTIONS(1977),
    [anon_sym_public] = ACTIONS(1977),
    [anon_sym_private] = ACTIONS(1977),
    [anon_sym_protected] = ACTIONS(1977),
    [anon_sym_override] = ACTIONS(1977),
    [anon_sym_module] = ACTIONS(1977),
    [anon_sym_any] = ACTIONS(1977),
    [anon_sym_number] = ACTIONS(1977),
    [anon_sym_boolean] = ACTIONS(1977),
    [anon_sym_string] = ACTIONS(1977),
    [anon_sym_symbol] = ACTIONS(1977),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [562] = {
    [sym__call_signature] = STATE(4055),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_export] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1966),
    [anon_sym_readonly] = ACTIONS(1966),
    [anon_sym_get] = ACTIONS(1966),
    [anon_sym_set] = ACTIONS(1966),
    [anon_sym_declare] = ACTIONS(1966),
    [anon_sym_public] = ACTIONS(1966),
    [anon_sym_private] = ACTIONS(1966),
    [anon_sym_protected] = ACTIONS(1966),
    [anon_sym_override] = ACTIONS(1966),
    [anon_sym_module] = ACTIONS(1966),
    [anon_sym_any] = ACTIONS(1966),
    [anon_sym_number] = ACTIONS(1966),
    [anon_sym_boolean] = ACTIONS(1966),
    [anon_sym_string] = ACTIONS(1966),
    [anon_sym_symbol] = ACTIONS(1966),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [563] = {
    [sym__call_signature] = STATE(4055),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_export] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1808),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_function] = ACTIONS(1866),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1966),
    [anon_sym_readonly] = ACTIONS(1966),
    [anon_sym_get] = ACTIONS(1966),
    [anon_sym_set] = ACTIONS(1966),
    [anon_sym_declare] = ACTIONS(1966),
    [anon_sym_public] = ACTIONS(1966),
    [anon_sym_private] = ACTIONS(1966),
    [anon_sym_protected] = ACTIONS(1966),
    [anon_sym_override] = ACTIONS(1966),
    [anon_sym_module] = ACTIONS(1966),
    [anon_sym_any] = ACTIONS(1966),
    [anon_sym_number] = ACTIONS(1966),
    [anon_sym_boolean] = ACTIONS(1966),
    [anon_sym_string] = ACTIONS(1966),
    [anon_sym_symbol] = ACTIONS(1966),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [564] = {
    [sym__call_signature] = STATE(4055),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_export] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1966),
    [anon_sym_readonly] = ACTIONS(1966),
    [anon_sym_get] = ACTIONS(1966),
    [anon_sym_set] = ACTIONS(1966),
    [anon_sym_declare] = ACTIONS(1966),
    [anon_sym_public] = ACTIONS(1966),
    [anon_sym_private] = ACTIONS(1966),
    [anon_sym_protected] = ACTIONS(1966),
    [anon_sym_override] = ACTIONS(1966),
    [anon_sym_module] = ACTIONS(1966),
    [anon_sym_any] = ACTIONS(1966),
    [anon_sym_number] = ACTIONS(1966),
    [anon_sym_boolean] = ACTIONS(1966),
    [anon_sym_string] = ACTIONS(1966),
    [anon_sym_symbol] = ACTIONS(1966),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [565] = {
    [sym__call_signature] = STATE(4103),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_export] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1977),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1977),
    [anon_sym_get] = ACTIONS(1977),
    [anon_sym_set] = ACTIONS(1977),
    [anon_sym_declare] = ACTIONS(1977),
    [anon_sym_public] = ACTIONS(1977),
    [anon_sym_private] = ACTIONS(1977),
    [anon_sym_protected] = ACTIONS(1977),
    [anon_sym_override] = ACTIONS(1977),
    [anon_sym_module] = ACTIONS(1977),
    [anon_sym_any] = ACTIONS(1977),
    [anon_sym_number] = ACTIONS(1977),
    [anon_sym_boolean] = ACTIONS(1977),
    [anon_sym_string] = ACTIONS(1977),
    [anon_sym_symbol] = ACTIONS(1977),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(1318),
    [anon_sym_default] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_namespace] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_typeof] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_var] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1318),
    [anon_sym_const] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_switch] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_do] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_debugger] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_throw] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1318),
    [anon_sym_catch] = ACTIONS(1318),
    [anon_sym_finally] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_function] = ACTIONS(1318),
    [anon_sym_new] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [sym_number] = ACTIONS(1316),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_null] = ACTIONS(1318),
    [sym_undefined] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1318),
    [anon_sym_readonly] = ACTIONS(1318),
    [anon_sym_get] = ACTIONS(1318),
    [anon_sym_set] = ACTIONS(1318),
    [anon_sym_declare] = ACTIONS(1318),
    [anon_sym_public] = ACTIONS(1318),
    [anon_sym_private] = ACTIONS(1318),
    [anon_sym_protected] = ACTIONS(1318),
    [anon_sym_override] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(1318),
    [anon_sym_number] = ACTIONS(1318),
    [anon_sym_boolean] = ACTIONS(1318),
    [anon_sym_string] = ACTIONS(1318),
    [anon_sym_symbol] = ACTIONS(1318),
    [anon_sym_abstract] = ACTIONS(1318),
    [anon_sym_interface] = ACTIONS(1318),
    [anon_sym_enum] = ACTIONS(1318),
    [sym__automatic_semicolon] = ACTIONS(1981),
  },
  [567] = {
    [sym_catch_clause] = STATE(592),
    [sym_finally_clause] = STATE(692),
    [ts_builtin_sym_end] = ACTIONS(1983),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_export] = ACTIONS(1985),
    [anon_sym_default] = ACTIONS(1985),
    [anon_sym_type] = ACTIONS(1985),
    [anon_sym_namespace] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1983),
    [anon_sym_RBRACE] = ACTIONS(1983),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_import] = ACTIONS(1985),
    [anon_sym_var] = ACTIONS(1985),
    [anon_sym_let] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1985),
    [anon_sym_if] = ACTIONS(1985),
    [anon_sym_switch] = ACTIONS(1985),
    [anon_sym_for] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1983),
    [anon_sym_await] = ACTIONS(1985),
    [anon_sym_while] = ACTIONS(1985),
    [anon_sym_do] = ACTIONS(1985),
    [anon_sym_try] = ACTIONS(1985),
    [anon_sym_with] = ACTIONS(1985),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_continue] = ACTIONS(1985),
    [anon_sym_debugger] = ACTIONS(1985),
    [anon_sym_return] = ACTIONS(1985),
    [anon_sym_throw] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1983),
    [anon_sym_case] = ACTIONS(1985),
    [anon_sym_catch] = ACTIONS(1987),
    [anon_sym_finally] = ACTIONS(1989),
    [anon_sym_yield] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1985),
    [anon_sym_class] = ACTIONS(1985),
    [anon_sym_async] = ACTIONS(1985),
    [anon_sym_function] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1983),
    [anon_sym_void] = ACTIONS(1985),
    [anon_sym_delete] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1983),
    [anon_sym_DQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1983),
    [sym_number] = ACTIONS(1983),
    [sym_this] = ACTIONS(1985),
    [sym_super] = ACTIONS(1985),
    [sym_true] = ACTIONS(1985),
    [sym_false] = ACTIONS(1985),
    [sym_null] = ACTIONS(1985),
    [sym_undefined] = ACTIONS(1985),
    [anon_sym_AT] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1985),
    [anon_sym_readonly] = ACTIONS(1985),
    [anon_sym_get] = ACTIONS(1985),
    [anon_sym_set] = ACTIONS(1985),
    [anon_sym_declare] = ACTIONS(1985),
    [anon_sym_public] = ACTIONS(1985),
    [anon_sym_private] = ACTIONS(1985),
    [anon_sym_protected] = ACTIONS(1985),
    [anon_sym_override] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(1985),
    [anon_sym_any] = ACTIONS(1985),
    [anon_sym_number] = ACTIONS(1985),
    [anon_sym_boolean] = ACTIONS(1985),
    [anon_sym_string] = ACTIONS(1985),
    [anon_sym_symbol] = ACTIONS(1985),
    [anon_sym_abstract] = ACTIONS(1985),
    [anon_sym_interface] = ACTIONS(1985),
    [anon_sym_enum] = ACTIONS(1985),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_catch] = ACTIONS(1286),
    [anon_sym_finally] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1284),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [sym__automatic_semicolon] = ACTIONS(1294),
  },
  [569] = {
    [sym__call_signature] = STATE(4048),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [anon_sym_implements] = ACTIONS(114),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [570] = {
    [sym__call_signature] = STATE(3858),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_readonly] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [571] = {
    [sym__call_signature] = STATE(4048),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [anon_sym_implements] = ACTIONS(114),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [572] = {
    [sym__call_signature] = STATE(3858),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_readonly] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [573] = {
    [sym__call_signature] = STATE(3858),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_readonly] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(1318),
    [anon_sym_default] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_namespace] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_typeof] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_var] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1318),
    [anon_sym_const] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_switch] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_do] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_debugger] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_throw] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1318),
    [anon_sym_catch] = ACTIONS(1318),
    [anon_sym_finally] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_function] = ACTIONS(1318),
    [anon_sym_new] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [sym_number] = ACTIONS(1316),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_null] = ACTIONS(1318),
    [sym_undefined] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1318),
    [anon_sym_readonly] = ACTIONS(1318),
    [anon_sym_get] = ACTIONS(1318),
    [anon_sym_set] = ACTIONS(1318),
    [anon_sym_declare] = ACTIONS(1318),
    [anon_sym_public] = ACTIONS(1318),
    [anon_sym_private] = ACTIONS(1318),
    [anon_sym_protected] = ACTIONS(1318),
    [anon_sym_override] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(1318),
    [anon_sym_number] = ACTIONS(1318),
    [anon_sym_boolean] = ACTIONS(1318),
    [anon_sym_string] = ACTIONS(1318),
    [anon_sym_symbol] = ACTIONS(1318),
    [anon_sym_abstract] = ACTIONS(1318),
    [anon_sym_interface] = ACTIONS(1318),
    [anon_sym_enum] = ACTIONS(1318),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(1318),
    [anon_sym_default] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_namespace] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_typeof] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_var] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1318),
    [anon_sym_const] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_switch] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_do] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_debugger] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_throw] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_function] = ACTIONS(1318),
    [anon_sym_new] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [sym_number] = ACTIONS(1316),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_null] = ACTIONS(1318),
    [sym_undefined] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1318),
    [anon_sym_readonly] = ACTIONS(1318),
    [anon_sym_get] = ACTIONS(1318),
    [anon_sym_set] = ACTIONS(1318),
    [anon_sym_declare] = ACTIONS(1318),
    [anon_sym_public] = ACTIONS(1318),
    [anon_sym_private] = ACTIONS(1318),
    [anon_sym_protected] = ACTIONS(1318),
    [anon_sym_override] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(1318),
    [anon_sym_number] = ACTIONS(1318),
    [anon_sym_boolean] = ACTIONS(1318),
    [anon_sym_string] = ACTIONS(1318),
    [anon_sym_symbol] = ACTIONS(1318),
    [anon_sym_abstract] = ACTIONS(1318),
    [anon_sym_interface] = ACTIONS(1318),
    [anon_sym_enum] = ACTIONS(1318),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1316),
    [sym__automatic_semicolon] = ACTIONS(2006),
  },
  [576] = {
    [sym__call_signature] = STATE(3947),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [577] = {
    [sym__call_signature] = STATE(3947),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1866),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1284),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1284),
    [sym__automatic_semicolon] = ACTIONS(2012),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(1318),
    [anon_sym_default] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_namespace] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_typeof] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_var] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1318),
    [anon_sym_const] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_switch] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_do] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_debugger] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_throw] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_function] = ACTIONS(1318),
    [anon_sym_new] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [sym_number] = ACTIONS(1316),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_null] = ACTIONS(1318),
    [sym_undefined] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1318),
    [anon_sym_readonly] = ACTIONS(1318),
    [anon_sym_get] = ACTIONS(1318),
    [anon_sym_set] = ACTIONS(1318),
    [anon_sym_declare] = ACTIONS(1318),
    [anon_sym_public] = ACTIONS(1318),
    [anon_sym_private] = ACTIONS(1318),
    [anon_sym_protected] = ACTIONS(1318),
    [anon_sym_override] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(1318),
    [anon_sym_number] = ACTIONS(1318),
    [anon_sym_boolean] = ACTIONS(1318),
    [anon_sym_string] = ACTIONS(1318),
    [anon_sym_symbol] = ACTIONS(1318),
    [anon_sym_abstract] = ACTIONS(1318),
    [anon_sym_interface] = ACTIONS(1318),
    [anon_sym_enum] = ACTIONS(1318),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1316),
    [sym__automatic_semicolon] = ACTIONS(1316),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1348),
    [anon_sym_export] = ACTIONS(1348),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_typeof] = ACTIONS(1348),
    [anon_sym_import] = ACTIONS(1348),
    [anon_sym_var] = ACTIONS(1348),
    [anon_sym_let] = ACTIONS(1348),
    [anon_sym_const] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1348),
    [anon_sym_if] = ACTIONS(1348),
    [anon_sym_switch] = ACTIONS(1348),
    [anon_sym_for] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_await] = ACTIONS(1348),
    [anon_sym_while] = ACTIONS(1348),
    [anon_sym_do] = ACTIONS(1348),
    [anon_sym_try] = ACTIONS(1348),
    [anon_sym_with] = ACTIONS(1348),
    [anon_sym_break] = ACTIONS(1348),
    [anon_sym_continue] = ACTIONS(1348),
    [anon_sym_debugger] = ACTIONS(1348),
    [anon_sym_return] = ACTIONS(1348),
    [anon_sym_throw] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1348),
    [anon_sym_yield] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(1348),
    [anon_sym_async] = ACTIONS(1348),
    [anon_sym_function] = ACTIONS(1348),
    [anon_sym_new] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1346),
    [anon_sym_void] = ACTIONS(1348),
    [anon_sym_delete] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [sym_number] = ACTIONS(1346),
    [sym_this] = ACTIONS(1348),
    [sym_super] = ACTIONS(1348),
    [sym_true] = ACTIONS(1348),
    [sym_false] = ACTIONS(1348),
    [sym_null] = ACTIONS(1348),
    [sym_undefined] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1348),
    [anon_sym_readonly] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1348),
    [anon_sym_set] = ACTIONS(1348),
    [anon_sym_declare] = ACTIONS(1348),
    [anon_sym_public] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1348),
    [anon_sym_protected] = ACTIONS(1348),
    [anon_sym_override] = ACTIONS(1348),
    [anon_sym_module] = ACTIONS(1348),
    [anon_sym_any] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1348),
    [anon_sym_abstract] = ACTIONS(1348),
    [anon_sym_interface] = ACTIONS(1348),
    [anon_sym_enum] = ACTIONS(1348),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_export] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_type] = ACTIONS(1372),
    [anon_sym_namespace] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_typeof] = ACTIONS(1372),
    [anon_sym_import] = ACTIONS(1372),
    [anon_sym_var] = ACTIONS(1372),
    [anon_sym_let] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_with] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_debugger] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_throw] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_catch] = ACTIONS(1372),
    [anon_sym_finally] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(1372),
    [anon_sym_async] = ACTIONS(1372),
    [anon_sym_function] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1372),
    [sym_super] = ACTIONS(1372),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_undefined] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_readonly] = ACTIONS(1372),
    [anon_sym_get] = ACTIONS(1372),
    [anon_sym_set] = ACTIONS(1372),
    [anon_sym_declare] = ACTIONS(1372),
    [anon_sym_public] = ACTIONS(1372),
    [anon_sym_private] = ACTIONS(1372),
    [anon_sym_protected] = ACTIONS(1372),
    [anon_sym_override] = ACTIONS(1372),
    [anon_sym_module] = ACTIONS(1372),
    [anon_sym_any] = ACTIONS(1372),
    [anon_sym_number] = ACTIONS(1372),
    [anon_sym_boolean] = ACTIONS(1372),
    [anon_sym_string] = ACTIONS(1372),
    [anon_sym_symbol] = ACTIONS(1372),
    [anon_sym_abstract] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
  },
  [582] = {
    [sym__call_signature] = STATE(3858),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_readonly] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [583] = {
    [sym__call_signature] = STATE(3947),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(2014),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [584] = {
    [sym__call_signature] = STATE(3947),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [585] = {
    [sym__call_signature] = STATE(3858),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_readonly] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_export] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_type] = ACTIONS(1372),
    [anon_sym_namespace] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_typeof] = ACTIONS(1372),
    [anon_sym_import] = ACTIONS(1372),
    [anon_sym_var] = ACTIONS(1372),
    [anon_sym_let] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_with] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_debugger] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_throw] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(1372),
    [anon_sym_async] = ACTIONS(1372),
    [anon_sym_function] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1372),
    [sym_super] = ACTIONS(1372),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_undefined] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_readonly] = ACTIONS(1372),
    [anon_sym_get] = ACTIONS(1372),
    [anon_sym_set] = ACTIONS(1372),
    [anon_sym_declare] = ACTIONS(1372),
    [anon_sym_public] = ACTIONS(1372),
    [anon_sym_private] = ACTIONS(1372),
    [anon_sym_protected] = ACTIONS(1372),
    [anon_sym_override] = ACTIONS(1372),
    [anon_sym_module] = ACTIONS(1372),
    [anon_sym_any] = ACTIONS(1372),
    [anon_sym_number] = ACTIONS(1372),
    [anon_sym_boolean] = ACTIONS(1372),
    [anon_sym_string] = ACTIONS(1372),
    [anon_sym_symbol] = ACTIONS(1372),
    [anon_sym_abstract] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1370),
    [sym__automatic_semicolon] = ACTIONS(1370),
  },
  [587] = {
    [sym__call_signature] = STATE(3858),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_readonly] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [588] = {
    [sym__call_signature] = STATE(3947),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_export] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_type] = ACTIONS(1386),
    [anon_sym_namespace] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_typeof] = ACTIONS(1386),
    [anon_sym_import] = ACTIONS(1386),
    [anon_sym_var] = ACTIONS(1386),
    [anon_sym_let] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_await] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_try] = ACTIONS(1386),
    [anon_sym_with] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_debugger] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_throw] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_yield] = ACTIONS(1386),
    [anon_sym_LBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1386),
    [anon_sym_class] = ACTIONS(1386),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(1386),
    [anon_sym_new] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_void] = ACTIONS(1386),
    [anon_sym_delete] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [sym_number] = ACTIONS(1384),
    [sym_this] = ACTIONS(1386),
    [sym_super] = ACTIONS(1386),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [sym_null] = ACTIONS(1386),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_readonly] = ACTIONS(1386),
    [anon_sym_get] = ACTIONS(1386),
    [anon_sym_set] = ACTIONS(1386),
    [anon_sym_declare] = ACTIONS(1386),
    [anon_sym_public] = ACTIONS(1386),
    [anon_sym_private] = ACTIONS(1386),
    [anon_sym_protected] = ACTIONS(1386),
    [anon_sym_override] = ACTIONS(1386),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_any] = ACTIONS(1386),
    [anon_sym_number] = ACTIONS(1386),
    [anon_sym_boolean] = ACTIONS(1386),
    [anon_sym_string] = ACTIONS(1386),
    [anon_sym_symbol] = ACTIONS(1386),
    [anon_sym_abstract] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1384),
    [sym__automatic_semicolon] = ACTIONS(1384),
  },
  [590] = {
    [sym__call_signature] = STATE(3941),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(1968),
    [anon_sym_of] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [591] = {
    [sym_statement_block] = STATE(749),
    [ts_builtin_sym_end] = ACTIONS(1296),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_namespace] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_typeof] = ACTIONS(1298),
    [anon_sym_import] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_BANG] = ACTIONS(1296),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_await] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_debugger] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_throw] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_yield] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1298),
    [anon_sym_DOT] = ACTIONS(2018),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1298),
    [anon_sym_function] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_delete] = ACTIONS(1298),
    [anon_sym_PLUS_PLUS] = ACTIONS(1296),
    [anon_sym_DASH_DASH] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1296),
    [sym_number] = ACTIONS(1296),
    [sym_this] = ACTIONS(1298),
    [sym_super] = ACTIONS(1298),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [sym_null] = ACTIONS(1298),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_get] = ACTIONS(1298),
    [anon_sym_set] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1298),
    [anon_sym_public] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1298),
    [anon_sym_protected] = ACTIONS(1298),
    [anon_sym_override] = ACTIONS(1298),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_abstract] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
  },
  [592] = {
    [sym_finally_clause] = STATE(715),
    [ts_builtin_sym_end] = ACTIONS(2020),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_export] = ACTIONS(2022),
    [anon_sym_default] = ACTIONS(2022),
    [anon_sym_type] = ACTIONS(2022),
    [anon_sym_namespace] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2020),
    [anon_sym_RBRACE] = ACTIONS(2020),
    [anon_sym_typeof] = ACTIONS(2022),
    [anon_sym_import] = ACTIONS(2022),
    [anon_sym_var] = ACTIONS(2022),
    [anon_sym_let] = ACTIONS(2022),
    [anon_sym_const] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2020),
    [anon_sym_else] = ACTIONS(2022),
    [anon_sym_if] = ACTIONS(2022),
    [anon_sym_switch] = ACTIONS(2022),
    [anon_sym_for] = ACTIONS(2022),
    [anon_sym_LPAREN] = ACTIONS(2020),
    [anon_sym_await] = ACTIONS(2022),
    [anon_sym_while] = ACTIONS(2022),
    [anon_sym_do] = ACTIONS(2022),
    [anon_sym_try] = ACTIONS(2022),
    [anon_sym_with] = ACTIONS(2022),
    [anon_sym_break] = ACTIONS(2022),
    [anon_sym_continue] = ACTIONS(2022),
    [anon_sym_debugger] = ACTIONS(2022),
    [anon_sym_return] = ACTIONS(2022),
    [anon_sym_throw] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_case] = ACTIONS(2022),
    [anon_sym_finally] = ACTIONS(1989),
    [anon_sym_yield] = ACTIONS(2022),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_SLASH] = ACTIONS(2022),
    [anon_sym_class] = ACTIONS(2022),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_function] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(2022),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(2020),
    [anon_sym_void] = ACTIONS(2022),
    [anon_sym_delete] = ACTIONS(2022),
    [anon_sym_PLUS_PLUS] = ACTIONS(2020),
    [anon_sym_DASH_DASH] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_SQUOTE] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [sym_number] = ACTIONS(2020),
    [sym_this] = ACTIONS(2022),
    [sym_super] = ACTIONS(2022),
    [sym_true] = ACTIONS(2022),
    [sym_false] = ACTIONS(2022),
    [sym_null] = ACTIONS(2022),
    [sym_undefined] = ACTIONS(2022),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2022),
    [anon_sym_readonly] = ACTIONS(2022),
    [anon_sym_get] = ACTIONS(2022),
    [anon_sym_set] = ACTIONS(2022),
    [anon_sym_declare] = ACTIONS(2022),
    [anon_sym_public] = ACTIONS(2022),
    [anon_sym_private] = ACTIONS(2022),
    [anon_sym_protected] = ACTIONS(2022),
    [anon_sym_override] = ACTIONS(2022),
    [anon_sym_module] = ACTIONS(2022),
    [anon_sym_any] = ACTIONS(2022),
    [anon_sym_number] = ACTIONS(2022),
    [anon_sym_boolean] = ACTIONS(2022),
    [anon_sym_string] = ACTIONS(2022),
    [anon_sym_symbol] = ACTIONS(2022),
    [anon_sym_abstract] = ACTIONS(2022),
    [anon_sym_interface] = ACTIONS(2022),
    [anon_sym_enum] = ACTIONS(2022),
  },
  [593] = {
    [sym__call_signature] = STATE(3889),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_export] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2026),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(2026),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1282),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_readonly] = ACTIONS(2026),
    [anon_sym_get] = ACTIONS(2026),
    [anon_sym_set] = ACTIONS(2026),
    [anon_sym_declare] = ACTIONS(2026),
    [anon_sym_public] = ACTIONS(2026),
    [anon_sym_private] = ACTIONS(2026),
    [anon_sym_protected] = ACTIONS(2026),
    [anon_sym_override] = ACTIONS(2026),
    [anon_sym_module] = ACTIONS(2026),
    [anon_sym_any] = ACTIONS(2026),
    [anon_sym_number] = ACTIONS(2026),
    [anon_sym_boolean] = ACTIONS(2026),
    [anon_sym_string] = ACTIONS(2026),
    [anon_sym_symbol] = ACTIONS(2026),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [594] = {
    [sym__call_signature] = STATE(3889),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_export] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2026),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(2026),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(1282),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_readonly] = ACTIONS(2026),
    [anon_sym_get] = ACTIONS(2026),
    [anon_sym_set] = ACTIONS(2026),
    [anon_sym_declare] = ACTIONS(2026),
    [anon_sym_public] = ACTIONS(2026),
    [anon_sym_private] = ACTIONS(2026),
    [anon_sym_protected] = ACTIONS(2026),
    [anon_sym_override] = ACTIONS(2026),
    [anon_sym_module] = ACTIONS(2026),
    [anon_sym_any] = ACTIONS(2026),
    [anon_sym_number] = ACTIONS(2026),
    [anon_sym_boolean] = ACTIONS(2026),
    [anon_sym_string] = ACTIONS(2026),
    [anon_sym_symbol] = ACTIONS(2026),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [595] = {
    [sym__call_signature] = STATE(3941),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [596] = {
    [sym_statement_block] = STATE(749),
    [ts_builtin_sym_end] = ACTIONS(1296),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_namespace] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_typeof] = ACTIONS(1298),
    [anon_sym_import] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_BANG] = ACTIONS(1296),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_await] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_debugger] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_throw] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_yield] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1298),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1298),
    [anon_sym_function] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_delete] = ACTIONS(1298),
    [anon_sym_PLUS_PLUS] = ACTIONS(1296),
    [anon_sym_DASH_DASH] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1296),
    [sym_number] = ACTIONS(1296),
    [sym_this] = ACTIONS(1298),
    [sym_super] = ACTIONS(1298),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [sym_null] = ACTIONS(1298),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_get] = ACTIONS(1298),
    [anon_sym_set] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1298),
    [anon_sym_public] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1298),
    [anon_sym_protected] = ACTIONS(1298),
    [anon_sym_override] = ACTIONS(1298),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_abstract] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_identifier] = ACTIONS(1352),
    [anon_sym_export] = ACTIONS(1352),
    [anon_sym_default] = ACTIONS(1352),
    [anon_sym_type] = ACTIONS(1352),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_typeof] = ACTIONS(1352),
    [anon_sym_import] = ACTIONS(1352),
    [anon_sym_var] = ACTIONS(1352),
    [anon_sym_let] = ACTIONS(1352),
    [anon_sym_const] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1352),
    [anon_sym_if] = ACTIONS(1352),
    [anon_sym_switch] = ACTIONS(1352),
    [anon_sym_for] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_await] = ACTIONS(1352),
    [anon_sym_while] = ACTIONS(1352),
    [anon_sym_do] = ACTIONS(1352),
    [anon_sym_try] = ACTIONS(1352),
    [anon_sym_with] = ACTIONS(1352),
    [anon_sym_break] = ACTIONS(1352),
    [anon_sym_continue] = ACTIONS(1352),
    [anon_sym_debugger] = ACTIONS(1352),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_throw] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1352),
    [anon_sym_yield] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_class] = ACTIONS(1352),
    [anon_sym_async] = ACTIONS(1352),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_void] = ACTIONS(1352),
    [anon_sym_delete] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [sym_number] = ACTIONS(1350),
    [sym_this] = ACTIONS(1352),
    [sym_super] = ACTIONS(1352),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [sym_null] = ACTIONS(1352),
    [sym_undefined] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1352),
    [anon_sym_readonly] = ACTIONS(1352),
    [anon_sym_get] = ACTIONS(1352),
    [anon_sym_set] = ACTIONS(1352),
    [anon_sym_declare] = ACTIONS(1352),
    [anon_sym_public] = ACTIONS(1352),
    [anon_sym_private] = ACTIONS(1352),
    [anon_sym_protected] = ACTIONS(1352),
    [anon_sym_override] = ACTIONS(1352),
    [anon_sym_module] = ACTIONS(1352),
    [anon_sym_any] = ACTIONS(1352),
    [anon_sym_number] = ACTIONS(1352),
    [anon_sym_boolean] = ACTIONS(1352),
    [anon_sym_string] = ACTIONS(1352),
    [anon_sym_symbol] = ACTIONS(1352),
    [anon_sym_abstract] = ACTIONS(1352),
    [anon_sym_interface] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1352),
    [sym__automatic_semicolon] = ACTIONS(1358),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(1336),
    [sym_identifier] = ACTIONS(1338),
    [anon_sym_export] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(1338),
    [anon_sym_namespace] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_typeof] = ACTIONS(1338),
    [anon_sym_import] = ACTIONS(1338),
    [anon_sym_var] = ACTIONS(1338),
    [anon_sym_let] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_await] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_with] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_debugger] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_throw] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_yield] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1336),
    [anon_sym_SLASH] = ACTIONS(1338),
    [anon_sym_class] = ACTIONS(1338),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_function] = ACTIONS(1338),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_void] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [sym_number] = ACTIONS(1336),
    [sym_this] = ACTIONS(1338),
    [sym_super] = ACTIONS(1338),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_undefined] = ACTIONS(1338),
    [anon_sym_AT] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(1338),
    [anon_sym_set] = ACTIONS(1338),
    [anon_sym_declare] = ACTIONS(1338),
    [anon_sym_public] = ACTIONS(1338),
    [anon_sym_private] = ACTIONS(1338),
    [anon_sym_protected] = ACTIONS(1338),
    [anon_sym_override] = ACTIONS(1338),
    [anon_sym_module] = ACTIONS(1338),
    [anon_sym_any] = ACTIONS(1338),
    [anon_sym_number] = ACTIONS(1338),
    [anon_sym_boolean] = ACTIONS(1338),
    [anon_sym_string] = ACTIONS(1338),
    [anon_sym_symbol] = ACTIONS(1338),
    [anon_sym_abstract] = ACTIONS(1338),
    [anon_sym_interface] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [sym__automatic_semicolon] = ACTIONS(1344),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(1456),
    [sym_identifier] = ACTIONS(1458),
    [anon_sym_export] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_type] = ACTIONS(1458),
    [anon_sym_namespace] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_typeof] = ACTIONS(1458),
    [anon_sym_import] = ACTIONS(1458),
    [anon_sym_var] = ACTIONS(1458),
    [anon_sym_let] = ACTIONS(1458),
    [anon_sym_const] = ACTIONS(1458),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1458),
    [anon_sym_for] = ACTIONS(1458),
    [anon_sym_LPAREN] = ACTIONS(1456),
    [anon_sym_await] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(1458),
    [anon_sym_do] = ACTIONS(1458),
    [anon_sym_try] = ACTIONS(1458),
    [anon_sym_with] = ACTIONS(1458),
    [anon_sym_break] = ACTIONS(1458),
    [anon_sym_continue] = ACTIONS(1458),
    [anon_sym_debugger] = ACTIONS(1458),
    [anon_sym_return] = ACTIONS(1458),
    [anon_sym_throw] = ACTIONS(1458),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_yield] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(1456),
    [anon_sym_SLASH] = ACTIONS(1458),
    [anon_sym_class] = ACTIONS(1458),
    [anon_sym_async] = ACTIONS(1458),
    [anon_sym_function] = ACTIONS(1458),
    [anon_sym_new] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_void] = ACTIONS(1458),
    [anon_sym_delete] = ACTIONS(1458),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1456),
    [sym_number] = ACTIONS(1456),
    [sym_this] = ACTIONS(1458),
    [sym_super] = ACTIONS(1458),
    [sym_true] = ACTIONS(1458),
    [sym_false] = ACTIONS(1458),
    [sym_null] = ACTIONS(1458),
    [sym_undefined] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1456),
    [anon_sym_static] = ACTIONS(1458),
    [anon_sym_readonly] = ACTIONS(1458),
    [anon_sym_get] = ACTIONS(1458),
    [anon_sym_set] = ACTIONS(1458),
    [anon_sym_declare] = ACTIONS(1458),
    [anon_sym_public] = ACTIONS(1458),
    [anon_sym_private] = ACTIONS(1458),
    [anon_sym_protected] = ACTIONS(1458),
    [anon_sym_override] = ACTIONS(1458),
    [anon_sym_module] = ACTIONS(1458),
    [anon_sym_any] = ACTIONS(1458),
    [anon_sym_number] = ACTIONS(1458),
    [anon_sym_boolean] = ACTIONS(1458),
    [anon_sym_string] = ACTIONS(1458),
    [anon_sym_symbol] = ACTIONS(1458),
    [anon_sym_abstract] = ACTIONS(1458),
    [anon_sym_interface] = ACTIONS(1458),
    [anon_sym_enum] = ACTIONS(1458),
    [sym__automatic_semicolon] = ACTIONS(1464),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2028),
    [sym_identifier] = ACTIONS(2030),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_default] = ACTIONS(2030),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_LBRACE] = ACTIONS(2028),
    [anon_sym_RBRACE] = ACTIONS(2028),
    [anon_sym_typeof] = ACTIONS(2030),
    [anon_sym_import] = ACTIONS(2030),
    [anon_sym_var] = ACTIONS(2030),
    [anon_sym_let] = ACTIONS(2030),
    [anon_sym_const] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_else] = ACTIONS(2030),
    [anon_sym_if] = ACTIONS(2030),
    [anon_sym_switch] = ACTIONS(2030),
    [anon_sym_for] = ACTIONS(2030),
    [anon_sym_LPAREN] = ACTIONS(2028),
    [anon_sym_await] = ACTIONS(2030),
    [anon_sym_while] = ACTIONS(2030),
    [anon_sym_do] = ACTIONS(2030),
    [anon_sym_try] = ACTIONS(2030),
    [anon_sym_with] = ACTIONS(2030),
    [anon_sym_break] = ACTIONS(2030),
    [anon_sym_continue] = ACTIONS(2030),
    [anon_sym_debugger] = ACTIONS(2030),
    [anon_sym_return] = ACTIONS(2030),
    [anon_sym_throw] = ACTIONS(2030),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_case] = ACTIONS(2030),
    [anon_sym_finally] = ACTIONS(2030),
    [anon_sym_yield] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2030),
    [anon_sym_class] = ACTIONS(2030),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2030),
    [anon_sym_new] = ACTIONS(2030),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2028),
    [anon_sym_void] = ACTIONS(2030),
    [anon_sym_delete] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2028),
    [anon_sym_DASH_DASH] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_SQUOTE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_super] = ACTIONS(2030),
    [sym_true] = ACTIONS(2030),
    [sym_false] = ACTIONS(2030),
    [sym_null] = ACTIONS(2030),
    [sym_undefined] = ACTIONS(2030),
    [anon_sym_AT] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_abstract] = ACTIONS(2030),
    [anon_sym_interface] = ACTIONS(2030),
    [anon_sym_enum] = ACTIONS(2030),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_export] = ACTIONS(1468),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_type] = ACTIONS(1468),
    [anon_sym_namespace] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [anon_sym_typeof] = ACTIONS(1468),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1468),
    [anon_sym_let] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_await] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_try] = ACTIONS(1468),
    [anon_sym_with] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_debugger] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_throw] = ACTIONS(1468),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_yield] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_LT] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(1468),
    [anon_sym_class] = ACTIONS(1468),
    [anon_sym_async] = ACTIONS(1468),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_new] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_void] = ACTIONS(1468),
    [anon_sym_delete] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1466),
    [sym_number] = ACTIONS(1466),
    [sym_this] = ACTIONS(1468),
    [sym_super] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_undefined] = ACTIONS(1468),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_readonly] = ACTIONS(1468),
    [anon_sym_get] = ACTIONS(1468),
    [anon_sym_set] = ACTIONS(1468),
    [anon_sym_declare] = ACTIONS(1468),
    [anon_sym_public] = ACTIONS(1468),
    [anon_sym_private] = ACTIONS(1468),
    [anon_sym_protected] = ACTIONS(1468),
    [anon_sym_override] = ACTIONS(1468),
    [anon_sym_module] = ACTIONS(1468),
    [anon_sym_any] = ACTIONS(1468),
    [anon_sym_number] = ACTIONS(1468),
    [anon_sym_boolean] = ACTIONS(1468),
    [anon_sym_string] = ACTIONS(1468),
    [anon_sym_symbol] = ACTIONS(1468),
    [anon_sym_abstract] = ACTIONS(1468),
    [anon_sym_interface] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [sym__automatic_semicolon] = ACTIONS(1474),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [sym_identifier] = ACTIONS(1324),
    [anon_sym_export] = ACTIONS(1324),
    [anon_sym_default] = ACTIONS(1324),
    [anon_sym_type] = ACTIONS(1324),
    [anon_sym_namespace] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_typeof] = ACTIONS(1324),
    [anon_sym_import] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_const] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_else] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1324),
    [anon_sym_switch] = ACTIONS(1324),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_await] = ACTIONS(1324),
    [anon_sym_while] = ACTIONS(1324),
    [anon_sym_do] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_with] = ACTIONS(1324),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_debugger] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_throw] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1324),
    [anon_sym_yield] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1324),
    [anon_sym_class] = ACTIONS(1324),
    [anon_sym_async] = ACTIONS(1324),
    [anon_sym_function] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_void] = ACTIONS(1324),
    [anon_sym_delete] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [sym_number] = ACTIONS(1322),
    [sym_this] = ACTIONS(1324),
    [sym_super] = ACTIONS(1324),
    [sym_true] = ACTIONS(1324),
    [sym_false] = ACTIONS(1324),
    [sym_null] = ACTIONS(1324),
    [sym_undefined] = ACTIONS(1324),
    [anon_sym_AT] = ACTIONS(1322),
    [anon_sym_static] = ACTIONS(1324),
    [anon_sym_readonly] = ACTIONS(1324),
    [anon_sym_get] = ACTIONS(1324),
    [anon_sym_set] = ACTIONS(1324),
    [anon_sym_declare] = ACTIONS(1324),
    [anon_sym_public] = ACTIONS(1324),
    [anon_sym_private] = ACTIONS(1324),
    [anon_sym_protected] = ACTIONS(1324),
    [anon_sym_override] = ACTIONS(1324),
    [anon_sym_module] = ACTIONS(1324),
    [anon_sym_any] = ACTIONS(1324),
    [anon_sym_number] = ACTIONS(1324),
    [anon_sym_boolean] = ACTIONS(1324),
    [anon_sym_string] = ACTIONS(1324),
    [anon_sym_symbol] = ACTIONS(1324),
    [anon_sym_abstract] = ACTIONS(1324),
    [anon_sym_interface] = ACTIONS(1324),
    [anon_sym_enum] = ACTIONS(1324),
    [sym__automatic_semicolon] = ACTIONS(1330),
  },
  [603] = {
    [sym_else_clause] = STATE(683),
    [ts_builtin_sym_end] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(2034),
    [anon_sym_export] = ACTIONS(2034),
    [anon_sym_default] = ACTIONS(2034),
    [anon_sym_type] = ACTIONS(2034),
    [anon_sym_namespace] = ACTIONS(2034),
    [anon_sym_LBRACE] = ACTIONS(2032),
    [anon_sym_RBRACE] = ACTIONS(2032),
    [anon_sym_typeof] = ACTIONS(2034),
    [anon_sym_import] = ACTIONS(2034),
    [anon_sym_var] = ACTIONS(2034),
    [anon_sym_let] = ACTIONS(2034),
    [anon_sym_const] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2034),
    [anon_sym_switch] = ACTIONS(2034),
    [anon_sym_for] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(2032),
    [anon_sym_await] = ACTIONS(2034),
    [anon_sym_while] = ACTIONS(2034),
    [anon_sym_do] = ACTIONS(2034),
    [anon_sym_try] = ACTIONS(2034),
    [anon_sym_with] = ACTIONS(2034),
    [anon_sym_break] = ACTIONS(2034),
    [anon_sym_continue] = ACTIONS(2034),
    [anon_sym_debugger] = ACTIONS(2034),
    [anon_sym_return] = ACTIONS(2034),
    [anon_sym_throw] = ACTIONS(2034),
    [anon_sym_SEMI] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2034),
    [anon_sym_yield] = ACTIONS(2034),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2032),
    [anon_sym_SLASH] = ACTIONS(2034),
    [anon_sym_class] = ACTIONS(2034),
    [anon_sym_async] = ACTIONS(2034),
    [anon_sym_function] = ACTIONS(2034),
    [anon_sym_new] = ACTIONS(2034),
    [anon_sym_PLUS] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2032),
    [anon_sym_void] = ACTIONS(2034),
    [anon_sym_delete] = ACTIONS(2034),
    [anon_sym_PLUS_PLUS] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(2032),
    [anon_sym_SQUOTE] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2032),
    [sym_number] = ACTIONS(2032),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(2034),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2034),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_get] = ACTIONS(2034),
    [anon_sym_set] = ACTIONS(2034),
    [anon_sym_declare] = ACTIONS(2034),
    [anon_sym_public] = ACTIONS(2034),
    [anon_sym_private] = ACTIONS(2034),
    [anon_sym_protected] = ACTIONS(2034),
    [anon_sym_override] = ACTIONS(2034),
    [anon_sym_module] = ACTIONS(2034),
    [anon_sym_any] = ACTIONS(2034),
    [anon_sym_number] = ACTIONS(2034),
    [anon_sym_boolean] = ACTIONS(2034),
    [anon_sym_string] = ACTIONS(2034),
    [anon_sym_symbol] = ACTIONS(2034),
    [anon_sym_abstract] = ACTIONS(2034),
    [anon_sym_interface] = ACTIONS(2034),
    [anon_sym_enum] = ACTIONS(2034),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(1476),
    [sym_identifier] = ACTIONS(1478),
    [anon_sym_export] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_namespace] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_typeof] = ACTIONS(1478),
    [anon_sym_import] = ACTIONS(1478),
    [anon_sym_var] = ACTIONS(1478),
    [anon_sym_let] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_await] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_try] = ACTIONS(1478),
    [anon_sym_with] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_debugger] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_throw] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_yield] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_DOT] = ACTIONS(1478),
    [anon_sym_class] = ACTIONS(1478),
    [anon_sym_async] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1478),
    [anon_sym_new] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_void] = ACTIONS(1478),
    [anon_sym_delete] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [sym_number] = ACTIONS(1476),
    [sym_this] = ACTIONS(1478),
    [sym_super] = ACTIONS(1478),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [sym_null] = ACTIONS(1478),
    [sym_undefined] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_readonly] = ACTIONS(1478),
    [anon_sym_get] = ACTIONS(1478),
    [anon_sym_set] = ACTIONS(1478),
    [anon_sym_declare] = ACTIONS(1478),
    [anon_sym_public] = ACTIONS(1478),
    [anon_sym_private] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(1478),
    [anon_sym_override] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(1478),
    [anon_sym_any] = ACTIONS(1478),
    [anon_sym_number] = ACTIONS(1478),
    [anon_sym_boolean] = ACTIONS(1478),
    [anon_sym_string] = ACTIONS(1478),
    [anon_sym_symbol] = ACTIONS(1478),
    [anon_sym_abstract] = ACTIONS(1478),
    [anon_sym_interface] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(1360),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_default] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1362),
    [anon_sym_import] = ACTIONS(1362),
    [anon_sym_var] = ACTIONS(1362),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_else] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1362),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_LPAREN] = ACTIONS(1360),
    [anon_sym_await] = ACTIONS(1362),
    [anon_sym_while] = ACTIONS(1362),
    [anon_sym_do] = ACTIONS(1362),
    [anon_sym_try] = ACTIONS(1362),
    [anon_sym_with] = ACTIONS(1362),
    [anon_sym_break] = ACTIONS(1362),
    [anon_sym_continue] = ACTIONS(1362),
    [anon_sym_debugger] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1362),
    [anon_sym_throw] = ACTIONS(1362),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym_case] = ACTIONS(1362),
    [anon_sym_yield] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1360),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_class] = ACTIONS(1362),
    [anon_sym_async] = ACTIONS(1362),
    [anon_sym_function] = ACTIONS(1362),
    [anon_sym_new] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_void] = ACTIONS(1362),
    [anon_sym_delete] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1360),
    [sym_number] = ACTIONS(1360),
    [sym_this] = ACTIONS(1362),
    [sym_super] = ACTIONS(1362),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [sym_null] = ACTIONS(1362),
    [sym_undefined] = ACTIONS(1362),
    [anon_sym_AT] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_abstract] = ACTIONS(1362),
    [anon_sym_interface] = ACTIONS(1362),
    [anon_sym_enum] = ACTIONS(1362),
    [sym__automatic_semicolon] = ACTIONS(1368),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(1376),
    [anon_sym_default] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_namespace] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_typeof] = ACTIONS(1376),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_var] = ACTIONS(1376),
    [anon_sym_let] = ACTIONS(1376),
    [anon_sym_const] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1374),
    [anon_sym_else] = ACTIONS(1376),
    [anon_sym_if] = ACTIONS(1376),
    [anon_sym_switch] = ACTIONS(1376),
    [anon_sym_for] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_await] = ACTIONS(1376),
    [anon_sym_while] = ACTIONS(1376),
    [anon_sym_do] = ACTIONS(1376),
    [anon_sym_try] = ACTIONS(1376),
    [anon_sym_with] = ACTIONS(1376),
    [anon_sym_break] = ACTIONS(1376),
    [anon_sym_continue] = ACTIONS(1376),
    [anon_sym_debugger] = ACTIONS(1376),
    [anon_sym_return] = ACTIONS(1376),
    [anon_sym_throw] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1376),
    [anon_sym_yield] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1374),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1374),
    [anon_sym_void] = ACTIONS(1376),
    [anon_sym_delete] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1374),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_SQUOTE] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1374),
    [sym_number] = ACTIONS(1374),
    [sym_this] = ACTIONS(1376),
    [sym_super] = ACTIONS(1376),
    [sym_true] = ACTIONS(1376),
    [sym_false] = ACTIONS(1376),
    [sym_null] = ACTIONS(1376),
    [sym_undefined] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1374),
    [anon_sym_static] = ACTIONS(1376),
    [anon_sym_readonly] = ACTIONS(1376),
    [anon_sym_get] = ACTIONS(1376),
    [anon_sym_set] = ACTIONS(1376),
    [anon_sym_declare] = ACTIONS(1376),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_override] = ACTIONS(1376),
    [anon_sym_module] = ACTIONS(1376),
    [anon_sym_any] = ACTIONS(1376),
    [anon_sym_number] = ACTIONS(1376),
    [anon_sym_boolean] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_symbol] = ACTIONS(1376),
    [anon_sym_abstract] = ACTIONS(1376),
    [anon_sym_interface] = ACTIONS(1376),
    [anon_sym_enum] = ACTIONS(1376),
    [sym__automatic_semicolon] = ACTIONS(1382),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_export] = ACTIONS(1420),
    [anon_sym_default] = ACTIONS(1420),
    [anon_sym_type] = ACTIONS(1420),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_typeof] = ACTIONS(1420),
    [anon_sym_import] = ACTIONS(1420),
    [anon_sym_var] = ACTIONS(1420),
    [anon_sym_let] = ACTIONS(1420),
    [anon_sym_const] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(1420),
    [anon_sym_switch] = ACTIONS(1420),
    [anon_sym_for] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_await] = ACTIONS(1420),
    [anon_sym_while] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_try] = ACTIONS(1420),
    [anon_sym_with] = ACTIONS(1420),
    [anon_sym_break] = ACTIONS(1420),
    [anon_sym_continue] = ACTIONS(1420),
    [anon_sym_debugger] = ACTIONS(1420),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_throw] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1420),
    [anon_sym_yield] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1420),
    [anon_sym_class] = ACTIONS(1420),
    [anon_sym_async] = ACTIONS(1420),
    [anon_sym_function] = ACTIONS(1420),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_void] = ACTIONS(1420),
    [anon_sym_delete] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [sym_number] = ACTIONS(1418),
    [sym_this] = ACTIONS(1420),
    [sym_super] = ACTIONS(1420),
    [sym_true] = ACTIONS(1420),
    [sym_false] = ACTIONS(1420),
    [sym_null] = ACTIONS(1420),
    [sym_undefined] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_readonly] = ACTIONS(1420),
    [anon_sym_get] = ACTIONS(1420),
    [anon_sym_set] = ACTIONS(1420),
    [anon_sym_declare] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1420),
    [anon_sym_private] = ACTIONS(1420),
    [anon_sym_protected] = ACTIONS(1420),
    [anon_sym_override] = ACTIONS(1420),
    [anon_sym_module] = ACTIONS(1420),
    [anon_sym_any] = ACTIONS(1420),
    [anon_sym_number] = ACTIONS(1420),
    [anon_sym_boolean] = ACTIONS(1420),
    [anon_sym_string] = ACTIONS(1420),
    [anon_sym_symbol] = ACTIONS(1420),
    [anon_sym_abstract] = ACTIONS(1420),
    [anon_sym_interface] = ACTIONS(1420),
    [anon_sym_enum] = ACTIONS(1420),
    [sym__automatic_semicolon] = ACTIONS(1426),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [sym_identifier] = ACTIONS(1410),
    [anon_sym_export] = ACTIONS(1410),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_type] = ACTIONS(1410),
    [anon_sym_namespace] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_typeof] = ACTIONS(1410),
    [anon_sym_import] = ACTIONS(1410),
    [anon_sym_var] = ACTIONS(1410),
    [anon_sym_let] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_await] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_try] = ACTIONS(1410),
    [anon_sym_with] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_debugger] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_throw] = ACTIONS(1410),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_yield] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1410),
    [anon_sym_class] = ACTIONS(1410),
    [anon_sym_async] = ACTIONS(1410),
    [anon_sym_function] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_readonly] = ACTIONS(1410),
    [anon_sym_get] = ACTIONS(1410),
    [anon_sym_set] = ACTIONS(1410),
    [anon_sym_declare] = ACTIONS(1410),
    [anon_sym_public] = ACTIONS(1410),
    [anon_sym_private] = ACTIONS(1410),
    [anon_sym_protected] = ACTIONS(1410),
    [anon_sym_override] = ACTIONS(1410),
    [anon_sym_module] = ACTIONS(1410),
    [anon_sym_any] = ACTIONS(1410),
    [anon_sym_number] = ACTIONS(1410),
    [anon_sym_boolean] = ACTIONS(1410),
    [anon_sym_string] = ACTIONS(1410),
    [anon_sym_symbol] = ACTIONS(1410),
    [anon_sym_abstract] = ACTIONS(1410),
    [anon_sym_interface] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [sym__automatic_semicolon] = ACTIONS(1416),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(2038),
    [sym_identifier] = ACTIONS(2040),
    [anon_sym_export] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_type] = ACTIONS(2040),
    [anon_sym_namespace] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [anon_sym_typeof] = ACTIONS(2040),
    [anon_sym_import] = ACTIONS(2040),
    [anon_sym_var] = ACTIONS(2040),
    [anon_sym_let] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_switch] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_LPAREN] = ACTIONS(2038),
    [anon_sym_RPAREN] = ACTIONS(2038),
    [anon_sym_await] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_do] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [anon_sym_with] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_debugger] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_throw] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_case] = ACTIONS(2040),
    [anon_sym_yield] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2038),
    [anon_sym_SLASH] = ACTIONS(2040),
    [anon_sym_class] = ACTIONS(2040),
    [anon_sym_async] = ACTIONS(2040),
    [anon_sym_function] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_void] = ACTIONS(2040),
    [anon_sym_delete] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2038),
    [sym_number] = ACTIONS(2038),
    [sym_this] = ACTIONS(2040),
    [sym_super] = ACTIONS(2040),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [sym_null] = ACTIONS(2040),
    [sym_undefined] = ACTIONS(2040),
    [anon_sym_AT] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_readonly] = ACTIONS(2040),
    [anon_sym_get] = ACTIONS(2040),
    [anon_sym_set] = ACTIONS(2040),
    [anon_sym_declare] = ACTIONS(2040),
    [anon_sym_public] = ACTIONS(2040),
    [anon_sym_private] = ACTIONS(2040),
    [anon_sym_protected] = ACTIONS(2040),
    [anon_sym_override] = ACTIONS(2040),
    [anon_sym_module] = ACTIONS(2040),
    [anon_sym_any] = ACTIONS(2040),
    [anon_sym_number] = ACTIONS(2040),
    [anon_sym_boolean] = ACTIONS(2040),
    [anon_sym_string] = ACTIONS(2040),
    [anon_sym_symbol] = ACTIONS(2040),
    [anon_sym_abstract] = ACTIONS(2040),
    [anon_sym_interface] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(2042),
    [sym_identifier] = ACTIONS(2044),
    [anon_sym_export] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_typeof] = ACTIONS(2044),
    [anon_sym_import] = ACTIONS(2044),
    [anon_sym_var] = ACTIONS(2044),
    [anon_sym_let] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_RPAREN] = ACTIONS(2042),
    [anon_sym_await] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_do] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [anon_sym_with] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_debugger] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_throw] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_yield] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2042),
    [anon_sym_SLASH] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_async] = ACTIONS(2044),
    [anon_sym_function] = ACTIONS(2044),
    [anon_sym_new] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_TILDE] = ACTIONS(2042),
    [anon_sym_void] = ACTIONS(2044),
    [anon_sym_delete] = ACTIONS(2044),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2042),
    [sym_number] = ACTIONS(2042),
    [sym_this] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [sym_null] = ACTIONS(2044),
    [sym_undefined] = ACTIONS(2044),
    [anon_sym_AT] = ACTIONS(2042),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_readonly] = ACTIONS(2044),
    [anon_sym_get] = ACTIONS(2044),
    [anon_sym_set] = ACTIONS(2044),
    [anon_sym_declare] = ACTIONS(2044),
    [anon_sym_public] = ACTIONS(2044),
    [anon_sym_private] = ACTIONS(2044),
    [anon_sym_protected] = ACTIONS(2044),
    [anon_sym_override] = ACTIONS(2044),
    [anon_sym_module] = ACTIONS(2044),
    [anon_sym_any] = ACTIONS(2044),
    [anon_sym_number] = ACTIONS(2044),
    [anon_sym_boolean] = ACTIONS(2044),
    [anon_sym_string] = ACTIONS(2044),
    [anon_sym_symbol] = ACTIONS(2044),
    [anon_sym_abstract] = ACTIONS(2044),
    [anon_sym_interface] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
  },
  [611] = {
    [sym__call_signature] = STATE(3941),
    [sym_formal_parameters] = STATE(2922),
    [sym_type_parameters] = STATE(3601),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1400),
    [anon_sym_import] = ACTIONS(1400),
    [anon_sym_var] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_switch] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_do] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [anon_sym_with] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_debugger] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_throw] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1398),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_class] = ACTIONS(1400),
    [anon_sym_async] = ACTIONS(1400),
    [anon_sym_function] = ACTIONS(1400),
    [anon_sym_new] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_void] = ACTIONS(1400),
    [anon_sym_delete] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [sym_number] = ACTIONS(1398),
    [sym_this] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_true] = ACTIONS(1400),
    [sym_false] = ACTIONS(1400),
    [sym_null] = ACTIONS(1400),
    [sym_undefined] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_readonly] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_override] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [anon_sym_abstract] = ACTIONS(1400),
    [anon_sym_interface] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [sym__automatic_semicolon] = ACTIONS(1406),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(2046),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_type] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_typeof] = ACTIONS(2048),
    [anon_sym_import] = ACTIONS(2048),
    [anon_sym_var] = ACTIONS(2048),
    [anon_sym_let] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_LPAREN] = ACTIONS(2046),
    [anon_sym_await] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_with] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_debugger] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_finally] = ACTIONS(2048),
    [anon_sym_yield] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2046),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_SLASH] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_async] = ACTIONS(2048),
    [anon_sym_function] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_void] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2046),
    [sym_number] = ACTIONS(2046),
    [sym_this] = ACTIONS(2048),
    [sym_super] = ACTIONS(2048),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [sym_null] = ACTIONS(2048),
    [sym_undefined] = ACTIONS(2048),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_readonly] = ACTIONS(2048),
    [anon_sym_get] = ACTIONS(2048),
    [anon_sym_set] = ACTIONS(2048),
    [anon_sym_declare] = ACTIONS(2048),
    [anon_sym_public] = ACTIONS(2048),
    [anon_sym_private] = ACTIONS(2048),
    [anon_sym_protected] = ACTIONS(2048),
    [anon_sym_override] = ACTIONS(2048),
    [anon_sym_module] = ACTIONS(2048),
    [anon_sym_any] = ACTIONS(2048),
    [anon_sym_number] = ACTIONS(2048),
    [anon_sym_boolean] = ACTIONS(2048),
    [anon_sym_string] = ACTIONS(2048),
    [anon_sym_symbol] = ACTIONS(2048),
    [anon_sym_abstract] = ACTIONS(2048),
    [anon_sym_interface] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(1388),
    [sym_identifier] = ACTIONS(1390),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_namespace] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_typeof] = ACTIONS(1390),
    [anon_sym_import] = ACTIONS(1390),
    [anon_sym_var] = ACTIONS(1390),
    [anon_sym_let] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_await] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_try] = ACTIONS(1390),
    [anon_sym_with] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_debugger] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_throw] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_yield] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_LT] = ACTIONS(1388),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_class] = ACTIONS(1390),
    [anon_sym_async] = ACTIONS(1390),
    [anon_sym_function] = ACTIONS(1390),
    [anon_sym_new] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_void] = ACTIONS(1390),
    [anon_sym_delete] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1388),
    [sym_number] = ACTIONS(1388),
    [sym_this] = ACTIONS(1390),
    [sym_super] = ACTIONS(1390),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [sym_null] = ACTIONS(1390),
    [sym_undefined] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_readonly] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_override] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [anon_sym_abstract] = ACTIONS(1390),
    [anon_sym_interface] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(1396),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(2050),
    [sym_identifier] = ACTIONS(2052),
    [anon_sym_export] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_type] = ACTIONS(2052),
    [anon_sym_namespace] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [anon_sym_typeof] = ACTIONS(2052),
    [anon_sym_import] = ACTIONS(2052),
    [anon_sym_var] = ACTIONS(2052),
    [anon_sym_let] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_await] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_with] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_debugger] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_finally] = ACTIONS(2052),
    [anon_sym_yield] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_async] = ACTIONS(2052),
    [anon_sym_function] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_void] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [sym_number] = ACTIONS(2050),
    [sym_this] = ACTIONS(2052),
    [sym_super] = ACTIONS(2052),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [sym_null] = ACTIONS(2052),
    [sym_undefined] = ACTIONS(2052),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_readonly] = ACTIONS(2052),
    [anon_sym_get] = ACTIONS(2052),
    [anon_sym_set] = ACTIONS(2052),
    [anon_sym_declare] = ACTIONS(2052),
    [anon_sym_public] = ACTIONS(2052),
    [anon_sym_private] = ACTIONS(2052),
    [anon_sym_protected] = ACTIONS(2052),
    [anon_sym_override] = ACTIONS(2052),
    [anon_sym_module] = ACTIONS(2052),
    [anon_sym_any] = ACTIONS(2052),
    [anon_sym_number] = ACTIONS(2052),
    [anon_sym_boolean] = ACTIONS(2052),
    [anon_sym_string] = ACTIONS(2052),
    [anon_sym_symbol] = ACTIONS(2052),
    [anon_sym_abstract] = ACTIONS(2052),
    [anon_sym_interface] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(1440),
    [sym_identifier] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_typeof] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_var] = ACTIONS(1442),
    [anon_sym_let] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [anon_sym_await] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_try] = ACTIONS(1442),
    [anon_sym_with] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_debugger] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_throw] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_yield] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1442),
    [anon_sym_class] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_function] = ACTIONS(1442),
    [anon_sym_new] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_delete] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [sym_number] = ACTIONS(1440),
    [sym_this] = ACTIONS(1442),
    [sym_super] = ACTIONS(1442),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [sym_null] = ACTIONS(1442),
    [sym_undefined] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_readonly] = ACTIONS(1442),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1442),
    [anon_sym_protected] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_abstract] = ACTIONS(1442),
    [anon_sym_interface] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [sym__automatic_semicolon] = ACTIONS(1448),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_typeof] = ACTIONS(2056),
    [anon_sym_import] = ACTIONS(2056),
    [anon_sym_var] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_debugger] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_SLASH] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_function] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_void] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [sym_undefined] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_readonly] = ACTIONS(2056),
    [anon_sym_get] = ACTIONS(2056),
    [anon_sym_set] = ACTIONS(2056),
    [anon_sym_declare] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_override] = ACTIONS(2056),
    [anon_sym_module] = ACTIONS(2056),
    [anon_sym_any] = ACTIONS(2056),
    [anon_sym_number] = ACTIONS(2056),
    [anon_sym_boolean] = ACTIONS(2056),
    [anon_sym_string] = ACTIONS(2056),
    [anon_sym_symbol] = ACTIONS(2056),
    [anon_sym_abstract] = ACTIONS(2056),
    [anon_sym_interface] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2062),
    [sym_identifier] = ACTIONS(2064),
    [anon_sym_export] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_type] = ACTIONS(2064),
    [anon_sym_namespace] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_typeof] = ACTIONS(2064),
    [anon_sym_import] = ACTIONS(2064),
    [anon_sym_var] = ACTIONS(2064),
    [anon_sym_let] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_LPAREN] = ACTIONS(2062),
    [anon_sym_await] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_with] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_debugger] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym_case] = ACTIONS(2064),
    [anon_sym_yield] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2062),
    [anon_sym_SLASH] = ACTIONS(2064),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_async] = ACTIONS(2064),
    [anon_sym_function] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_void] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_number] = ACTIONS(2062),
    [sym_this] = ACTIONS(2064),
    [sym_super] = ACTIONS(2064),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [sym_null] = ACTIONS(2064),
    [sym_undefined] = ACTIONS(2064),
    [anon_sym_AT] = ACTIONS(2062),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_readonly] = ACTIONS(2064),
    [anon_sym_get] = ACTIONS(2064),
    [anon_sym_set] = ACTIONS(2064),
    [anon_sym_declare] = ACTIONS(2064),
    [anon_sym_public] = ACTIONS(2064),
    [anon_sym_private] = ACTIONS(2064),
    [anon_sym_protected] = ACTIONS(2064),
    [anon_sym_override] = ACTIONS(2064),
    [anon_sym_module] = ACTIONS(2064),
    [anon_sym_any] = ACTIONS(2064),
    [anon_sym_number] = ACTIONS(2064),
    [anon_sym_boolean] = ACTIONS(2064),
    [anon_sym_string] = ACTIONS(2064),
    [anon_sym_symbol] = ACTIONS(2064),
    [anon_sym_abstract] = ACTIONS(2064),
    [anon_sym_interface] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2068),
    [anon_sym_export] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_type] = ACTIONS(2068),
    [anon_sym_namespace] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_RBRACE] = ACTIONS(2066),
    [anon_sym_typeof] = ACTIONS(2068),
    [anon_sym_import] = ACTIONS(2068),
    [anon_sym_var] = ACTIONS(2068),
    [anon_sym_let] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_LPAREN] = ACTIONS(2066),
    [anon_sym_await] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_with] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_debugger] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_case] = ACTIONS(2068),
    [anon_sym_yield] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_SLASH] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_async] = ACTIONS(2068),
    [anon_sym_function] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_void] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2066),
    [sym_number] = ACTIONS(2066),
    [sym_this] = ACTIONS(2068),
    [sym_super] = ACTIONS(2068),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [sym_null] = ACTIONS(2068),
    [sym_undefined] = ACTIONS(2068),
    [anon_sym_AT] = ACTIONS(2066),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_readonly] = ACTIONS(2068),
    [anon_sym_get] = ACTIONS(2068),
    [anon_sym_set] = ACTIONS(2068),
    [anon_sym_declare] = ACTIONS(2068),
    [anon_sym_public] = ACTIONS(2068),
    [anon_sym_private] = ACTIONS(2068),
    [anon_sym_protected] = ACTIONS(2068),
    [anon_sym_override] = ACTIONS(2068),
    [anon_sym_module] = ACTIONS(2068),
    [anon_sym_any] = ACTIONS(2068),
    [anon_sym_number] = ACTIONS(2068),
    [anon_sym_boolean] = ACTIONS(2068),
    [anon_sym_string] = ACTIONS(2068),
    [anon_sym_symbol] = ACTIONS(2068),
    [anon_sym_abstract] = ACTIONS(2068),
    [anon_sym_interface] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_export] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_type] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_RBRACE] = ACTIONS(2070),
    [anon_sym_typeof] = ACTIONS(2072),
    [anon_sym_import] = ACTIONS(2072),
    [anon_sym_var] = ACTIONS(2072),
    [anon_sym_let] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_LPAREN] = ACTIONS(2070),
    [anon_sym_await] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_with] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_debugger] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_case] = ACTIONS(2072),
    [anon_sym_yield] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_SLASH] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_async] = ACTIONS(2072),
    [anon_sym_function] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_void] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2070),
    [sym_number] = ACTIONS(2070),
    [sym_this] = ACTIONS(2072),
    [sym_super] = ACTIONS(2072),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [sym_null] = ACTIONS(2072),
    [sym_undefined] = ACTIONS(2072),
    [anon_sym_AT] = ACTIONS(2070),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_readonly] = ACTIONS(2072),
    [anon_sym_get] = ACTIONS(2072),
    [anon_sym_set] = ACTIONS(2072),
    [anon_sym_declare] = ACTIONS(2072),
    [anon_sym_public] = ACTIONS(2072),
    [anon_sym_private] = ACTIONS(2072),
    [anon_sym_protected] = ACTIONS(2072),
    [anon_sym_override] = ACTIONS(2072),
    [anon_sym_module] = ACTIONS(2072),
    [anon_sym_any] = ACTIONS(2072),
    [anon_sym_number] = ACTIONS(2072),
    [anon_sym_boolean] = ACTIONS(2072),
    [anon_sym_string] = ACTIONS(2072),
    [anon_sym_symbol] = ACTIONS(2072),
    [anon_sym_abstract] = ACTIONS(2072),
    [anon_sym_interface] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_export] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_type] = ACTIONS(2076),
    [anon_sym_namespace] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_typeof] = ACTIONS(2076),
    [anon_sym_import] = ACTIONS(2076),
    [anon_sym_var] = ACTIONS(2076),
    [anon_sym_let] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_await] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_with] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_debugger] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_case] = ACTIONS(2076),
    [anon_sym_yield] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_SLASH] = ACTIONS(2076),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_async] = ACTIONS(2076),
    [anon_sym_function] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_void] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [sym_number] = ACTIONS(2074),
    [sym_this] = ACTIONS(2076),
    [sym_super] = ACTIONS(2076),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [sym_null] = ACTIONS(2076),
    [sym_undefined] = ACTIONS(2076),
    [anon_sym_AT] = ACTIONS(2074),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_readonly] = ACTIONS(2076),
    [anon_sym_get] = ACTIONS(2076),
    [anon_sym_set] = ACTIONS(2076),
    [anon_sym_declare] = ACTIONS(2076),
    [anon_sym_public] = ACTIONS(2076),
    [anon_sym_private] = ACTIONS(2076),
    [anon_sym_protected] = ACTIONS(2076),
    [anon_sym_override] = ACTIONS(2076),
    [anon_sym_module] = ACTIONS(2076),
    [anon_sym_any] = ACTIONS(2076),
    [anon_sym_number] = ACTIONS(2076),
    [anon_sym_boolean] = ACTIONS(2076),
    [anon_sym_string] = ACTIONS(2076),
    [anon_sym_symbol] = ACTIONS(2076),
    [anon_sym_abstract] = ACTIONS(2076),
    [anon_sym_interface] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2080),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_RBRACE] = ACTIONS(2078),
    [anon_sym_typeof] = ACTIONS(2080),
    [anon_sym_import] = ACTIONS(2080),
    [anon_sym_var] = ACTIONS(2080),
    [anon_sym_let] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_else] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_switch] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_await] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [anon_sym_with] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_debugger] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_throw] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_case] = ACTIONS(2080),
    [anon_sym_yield] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_SLASH] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2080),
    [anon_sym_new] = ACTIONS(2080),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_void] = ACTIONS(2080),
    [anon_sym_delete] = ACTIONS(2080),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2078),
    [sym_number] = ACTIONS(2078),
    [sym_this] = ACTIONS(2080),
    [sym_super] = ACTIONS(2080),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [sym_null] = ACTIONS(2080),
    [sym_undefined] = ACTIONS(2080),
    [anon_sym_AT] = ACTIONS(2078),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_abstract] = ACTIONS(2080),
    [anon_sym_interface] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2088),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_default] = ACTIONS(2088),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_typeof] = ACTIONS(2088),
    [anon_sym_import] = ACTIONS(2088),
    [anon_sym_var] = ACTIONS(2088),
    [anon_sym_let] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_else] = ACTIONS(2088),
    [anon_sym_if] = ACTIONS(2088),
    [anon_sym_switch] = ACTIONS(2088),
    [anon_sym_for] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(2086),
    [anon_sym_await] = ACTIONS(2088),
    [anon_sym_while] = ACTIONS(2088),
    [anon_sym_do] = ACTIONS(2088),
    [anon_sym_try] = ACTIONS(2088),
    [anon_sym_with] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2088),
    [anon_sym_continue] = ACTIONS(2088),
    [anon_sym_debugger] = ACTIONS(2088),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_throw] = ACTIONS(2088),
    [anon_sym_SEMI] = ACTIONS(2086),
    [anon_sym_case] = ACTIONS(2088),
    [anon_sym_yield] = ACTIONS(2088),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_LT] = ACTIONS(2086),
    [anon_sym_SLASH] = ACTIONS(2088),
    [anon_sym_class] = ACTIONS(2088),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(2088),
    [anon_sym_new] = ACTIONS(2088),
    [anon_sym_PLUS] = ACTIONS(2088),
    [anon_sym_DASH] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2086),
    [anon_sym_void] = ACTIONS(2088),
    [anon_sym_delete] = ACTIONS(2088),
    [anon_sym_PLUS_PLUS] = ACTIONS(2086),
    [anon_sym_DASH_DASH] = ACTIONS(2086),
    [anon_sym_DQUOTE] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2086),
    [sym_number] = ACTIONS(2086),
    [sym_this] = ACTIONS(2088),
    [sym_super] = ACTIONS(2088),
    [sym_true] = ACTIONS(2088),
    [sym_false] = ACTIONS(2088),
    [sym_null] = ACTIONS(2088),
    [sym_undefined] = ACTIONS(2088),
    [anon_sym_AT] = ACTIONS(2086),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_override] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [anon_sym_abstract] = ACTIONS(2088),
    [anon_sym_interface] = ACTIONS(2088),
    [anon_sym_enum] = ACTIONS(2088),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_export] = ACTIONS(2092),
    [anon_sym_default] = ACTIONS(2092),
    [anon_sym_type] = ACTIONS(2092),
    [anon_sym_namespace] = ACTIONS(2092),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_typeof] = ACTIONS(2092),
    [anon_sym_import] = ACTIONS(2092),
    [anon_sym_var] = ACTIONS(2092),
    [anon_sym_let] = ACTIONS(2092),
    [anon_sym_const] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_else] = ACTIONS(2092),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(2092),
    [anon_sym_for] = ACTIONS(2092),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_await] = ACTIONS(2092),
    [anon_sym_while] = ACTIONS(2092),
    [anon_sym_do] = ACTIONS(2092),
    [anon_sym_try] = ACTIONS(2092),
    [anon_sym_with] = ACTIONS(2092),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2092),
    [anon_sym_debugger] = ACTIONS(2092),
    [anon_sym_return] = ACTIONS(2092),
    [anon_sym_throw] = ACTIONS(2092),
    [anon_sym_SEMI] = ACTIONS(2090),
    [anon_sym_case] = ACTIONS(2092),
    [anon_sym_yield] = ACTIONS(2092),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_LT] = ACTIONS(2090),
    [anon_sym_SLASH] = ACTIONS(2092),
    [anon_sym_class] = ACTIONS(2092),
    [anon_sym_async] = ACTIONS(2092),
    [anon_sym_function] = ACTIONS(2092),
    [anon_sym_new] = ACTIONS(2092),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2090),
    [anon_sym_void] = ACTIONS(2092),
    [anon_sym_delete] = ACTIONS(2092),
    [anon_sym_PLUS_PLUS] = ACTIONS(2090),
    [anon_sym_DASH_DASH] = ACTIONS(2090),
    [anon_sym_DQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2090),
    [sym_number] = ACTIONS(2090),
    [sym_this] = ACTIONS(2092),
    [sym_super] = ACTIONS(2092),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [sym_null] = ACTIONS(2092),
    [sym_undefined] = ACTIONS(2092),
    [anon_sym_AT] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2092),
    [anon_sym_readonly] = ACTIONS(2092),
    [anon_sym_get] = ACTIONS(2092),
    [anon_sym_set] = ACTIONS(2092),
    [anon_sym_declare] = ACTIONS(2092),
    [anon_sym_public] = ACTIONS(2092),
    [anon_sym_private] = ACTIONS(2092),
    [anon_sym_protected] = ACTIONS(2092),
    [anon_sym_override] = ACTIONS(2092),
    [anon_sym_module] = ACTIONS(2092),
    [anon_sym_any] = ACTIONS(2092),
    [anon_sym_number] = ACTIONS(2092),
    [anon_sym_boolean] = ACTIONS(2092),
    [anon_sym_string] = ACTIONS(2092),
    [anon_sym_symbol] = ACTIONS(2092),
    [anon_sym_abstract] = ACTIONS(2092),
    [anon_sym_interface] = ACTIONS(2092),
    [anon_sym_enum] = ACTIONS(2092),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(2096),
    [anon_sym_export] = ACTIONS(2096),
    [anon_sym_default] = ACTIONS(2096),
    [anon_sym_type] = ACTIONS(2096),
    [anon_sym_namespace] = ACTIONS(2096),
    [anon_sym_LBRACE] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_typeof] = ACTIONS(2096),
    [anon_sym_import] = ACTIONS(2096),
    [anon_sym_var] = ACTIONS(2096),
    [anon_sym_let] = ACTIONS(2096),
    [anon_sym_const] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_else] = ACTIONS(2096),
    [anon_sym_if] = ACTIONS(2096),
    [anon_sym_switch] = ACTIONS(2096),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_LPAREN] = ACTIONS(2094),
    [anon_sym_await] = ACTIONS(2096),
    [anon_sym_while] = ACTIONS(2096),
    [anon_sym_do] = ACTIONS(2096),
    [anon_sym_try] = ACTIONS(2096),
    [anon_sym_with] = ACTIONS(2096),
    [anon_sym_break] = ACTIONS(2096),
    [anon_sym_continue] = ACTIONS(2096),
    [anon_sym_debugger] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_throw] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2094),
    [anon_sym_case] = ACTIONS(2096),
    [anon_sym_yield] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_LT] = ACTIONS(2094),
    [anon_sym_SLASH] = ACTIONS(2096),
    [anon_sym_class] = ACTIONS(2096),
    [anon_sym_async] = ACTIONS(2096),
    [anon_sym_function] = ACTIONS(2096),
    [anon_sym_new] = ACTIONS(2096),
    [anon_sym_PLUS] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2094),
    [anon_sym_void] = ACTIONS(2096),
    [anon_sym_delete] = ACTIONS(2096),
    [anon_sym_PLUS_PLUS] = ACTIONS(2094),
    [anon_sym_DASH_DASH] = ACTIONS(2094),
    [anon_sym_DQUOTE] = ACTIONS(2094),
    [anon_sym_SQUOTE] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2094),
    [sym_number] = ACTIONS(2094),
    [sym_this] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_null] = ACTIONS(2096),
    [sym_undefined] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2096),
    [anon_sym_readonly] = ACTIONS(2096),
    [anon_sym_get] = ACTIONS(2096),
    [anon_sym_set] = ACTIONS(2096),
    [anon_sym_declare] = ACTIONS(2096),
    [anon_sym_public] = ACTIONS(2096),
    [anon_sym_private] = ACTIONS(2096),
    [anon_sym_protected] = ACTIONS(2096),
    [anon_sym_override] = ACTIONS(2096),
    [anon_sym_module] = ACTIONS(2096),
    [anon_sym_any] = ACTIONS(2096),
    [anon_sym_number] = ACTIONS(2096),
    [anon_sym_boolean] = ACTIONS(2096),
    [anon_sym_string] = ACTIONS(2096),
    [anon_sym_symbol] = ACTIONS(2096),
    [anon_sym_abstract] = ACTIONS(2096),
    [anon_sym_interface] = ACTIONS(2096),
    [anon_sym_enum] = ACTIONS(2096),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_export] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_type] = ACTIONS(1386),
    [anon_sym_namespace] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_typeof] = ACTIONS(1386),
    [anon_sym_import] = ACTIONS(1386),
    [anon_sym_var] = ACTIONS(1386),
    [anon_sym_let] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_await] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_try] = ACTIONS(1386),
    [anon_sym_with] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_debugger] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_throw] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_yield] = ACTIONS(1386),
    [anon_sym_LBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1386),
    [anon_sym_class] = ACTIONS(1386),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(1386),
    [anon_sym_new] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_void] = ACTIONS(1386),
    [anon_sym_delete] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [sym_number] = ACTIONS(1384),
    [sym_this] = ACTIONS(1386),
    [sym_super] = ACTIONS(1386),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [sym_null] = ACTIONS(1386),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_readonly] = ACTIONS(1386),
    [anon_sym_get] = ACTIONS(1386),
    [anon_sym_set] = ACTIONS(1386),
    [anon_sym_declare] = ACTIONS(1386),
    [anon_sym_public] = ACTIONS(1386),
    [anon_sym_private] = ACTIONS(1386),
    [anon_sym_protected] = ACTIONS(1386),
    [anon_sym_override] = ACTIONS(1386),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_any] = ACTIONS(1386),
    [anon_sym_number] = ACTIONS(1386),
    [anon_sym_boolean] = ACTIONS(1386),
    [anon_sym_string] = ACTIONS(1386),
    [anon_sym_symbol] = ACTIONS(1386),
    [anon_sym_abstract] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2104),
    [anon_sym_export] = ACTIONS(2104),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_type] = ACTIONS(2104),
    [anon_sym_namespace] = ACTIONS(2104),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_typeof] = ACTIONS(2104),
    [anon_sym_import] = ACTIONS(2104),
    [anon_sym_var] = ACTIONS(2104),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_const] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_else] = ACTIONS(2104),
    [anon_sym_if] = ACTIONS(2104),
    [anon_sym_switch] = ACTIONS(2104),
    [anon_sym_for] = ACTIONS(2104),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_await] = ACTIONS(2104),
    [anon_sym_while] = ACTIONS(2104),
    [anon_sym_do] = ACTIONS(2104),
    [anon_sym_try] = ACTIONS(2104),
    [anon_sym_with] = ACTIONS(2104),
    [anon_sym_break] = ACTIONS(2104),
    [anon_sym_continue] = ACTIONS(2104),
    [anon_sym_debugger] = ACTIONS(2104),
    [anon_sym_return] = ACTIONS(2104),
    [anon_sym_throw] = ACTIONS(2104),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_case] = ACTIONS(2104),
    [anon_sym_yield] = ACTIONS(2104),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_SLASH] = ACTIONS(2104),
    [anon_sym_class] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2104),
    [anon_sym_function] = ACTIONS(2104),
    [anon_sym_new] = ACTIONS(2104),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2104),
    [anon_sym_TILDE] = ACTIONS(2102),
    [anon_sym_void] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2104),
    [anon_sym_PLUS_PLUS] = ACTIONS(2102),
    [anon_sym_DASH_DASH] = ACTIONS(2102),
    [anon_sym_DQUOTE] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2102),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(2104),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_undefined] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2104),
    [anon_sym_readonly] = ACTIONS(2104),
    [anon_sym_get] = ACTIONS(2104),
    [anon_sym_set] = ACTIONS(2104),
    [anon_sym_declare] = ACTIONS(2104),
    [anon_sym_public] = ACTIONS(2104),
    [anon_sym_private] = ACTIONS(2104),
    [anon_sym_protected] = ACTIONS(2104),
    [anon_sym_override] = ACTIONS(2104),
    [anon_sym_module] = ACTIONS(2104),
    [anon_sym_any] = ACTIONS(2104),
    [anon_sym_number] = ACTIONS(2104),
    [anon_sym_boolean] = ACTIONS(2104),
    [anon_sym_string] = ACTIONS(2104),
    [anon_sym_symbol] = ACTIONS(2104),
    [anon_sym_abstract] = ACTIONS(2104),
    [anon_sym_interface] = ACTIONS(2104),
    [anon_sym_enum] = ACTIONS(2104),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2112),
    [anon_sym_export] = ACTIONS(2112),
    [anon_sym_default] = ACTIONS(2112),
    [anon_sym_type] = ACTIONS(2112),
    [anon_sym_namespace] = ACTIONS(2112),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_typeof] = ACTIONS(2112),
    [anon_sym_import] = ACTIONS(2112),
    [anon_sym_var] = ACTIONS(2112),
    [anon_sym_let] = ACTIONS(2112),
    [anon_sym_const] = ACTIONS(2112),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_else] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(2112),
    [anon_sym_switch] = ACTIONS(2112),
    [anon_sym_for] = ACTIONS(2112),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_await] = ACTIONS(2112),
    [anon_sym_while] = ACTIONS(2112),
    [anon_sym_do] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2112),
    [anon_sym_with] = ACTIONS(2112),
    [anon_sym_break] = ACTIONS(2112),
    [anon_sym_continue] = ACTIONS(2112),
    [anon_sym_debugger] = ACTIONS(2112),
    [anon_sym_return] = ACTIONS(2112),
    [anon_sym_throw] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_yield] = ACTIONS(2112),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_LT] = ACTIONS(2110),
    [anon_sym_SLASH] = ACTIONS(2112),
    [anon_sym_class] = ACTIONS(2112),
    [anon_sym_async] = ACTIONS(2112),
    [anon_sym_function] = ACTIONS(2112),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_PLUS] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2110),
    [anon_sym_void] = ACTIONS(2112),
    [anon_sym_delete] = ACTIONS(2112),
    [anon_sym_PLUS_PLUS] = ACTIONS(2110),
    [anon_sym_DASH_DASH] = ACTIONS(2110),
    [anon_sym_DQUOTE] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2110),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(2112),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(2110),
    [anon_sym_static] = ACTIONS(2112),
    [anon_sym_readonly] = ACTIONS(2112),
    [anon_sym_get] = ACTIONS(2112),
    [anon_sym_set] = ACTIONS(2112),
    [anon_sym_declare] = ACTIONS(2112),
    [anon_sym_public] = ACTIONS(2112),
    [anon_sym_private] = ACTIONS(2112),
    [anon_sym_protected] = ACTIONS(2112),
    [anon_sym_override] = ACTIONS(2112),
    [anon_sym_module] = ACTIONS(2112),
    [anon_sym_any] = ACTIONS(2112),
    [anon_sym_number] = ACTIONS(2112),
    [anon_sym_boolean] = ACTIONS(2112),
    [anon_sym_string] = ACTIONS(2112),
    [anon_sym_symbol] = ACTIONS(2112),
    [anon_sym_abstract] = ACTIONS(2112),
    [anon_sym_interface] = ACTIONS(2112),
    [anon_sym_enum] = ACTIONS(2112),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [anon_sym_export] = ACTIONS(2116),
    [anon_sym_default] = ACTIONS(2116),
    [anon_sym_type] = ACTIONS(2116),
    [anon_sym_namespace] = ACTIONS(2116),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_typeof] = ACTIONS(2116),
    [anon_sym_import] = ACTIONS(2116),
    [anon_sym_var] = ACTIONS(2116),
    [anon_sym_let] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_else] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(2116),
    [anon_sym_switch] = ACTIONS(2116),
    [anon_sym_for] = ACTIONS(2116),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_await] = ACTIONS(2116),
    [anon_sym_while] = ACTIONS(2116),
    [anon_sym_do] = ACTIONS(2116),
    [anon_sym_try] = ACTIONS(2116),
    [anon_sym_with] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2116),
    [anon_sym_continue] = ACTIONS(2116),
    [anon_sym_debugger] = ACTIONS(2116),
    [anon_sym_return] = ACTIONS(2116),
    [anon_sym_throw] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_case] = ACTIONS(2116),
    [anon_sym_yield] = ACTIONS(2116),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(2114),
    [anon_sym_SLASH] = ACTIONS(2116),
    [anon_sym_class] = ACTIONS(2116),
    [anon_sym_async] = ACTIONS(2116),
    [anon_sym_function] = ACTIONS(2116),
    [anon_sym_new] = ACTIONS(2116),
    [anon_sym_PLUS] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2114),
    [anon_sym_void] = ACTIONS(2116),
    [anon_sym_delete] = ACTIONS(2116),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2114),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(2116),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_undefined] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(2114),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_readonly] = ACTIONS(2116),
    [anon_sym_get] = ACTIONS(2116),
    [anon_sym_set] = ACTIONS(2116),
    [anon_sym_declare] = ACTIONS(2116),
    [anon_sym_public] = ACTIONS(2116),
    [anon_sym_private] = ACTIONS(2116),
    [anon_sym_protected] = ACTIONS(2116),
    [anon_sym_override] = ACTIONS(2116),
    [anon_sym_module] = ACTIONS(2116),
    [anon_sym_any] = ACTIONS(2116),
    [anon_sym_number] = ACTIONS(2116),
    [anon_sym_boolean] = ACTIONS(2116),
    [anon_sym_string] = ACTIONS(2116),
    [anon_sym_symbol] = ACTIONS(2116),
    [anon_sym_abstract] = ACTIONS(2116),
    [anon_sym_interface] = ACTIONS(2116),
    [anon_sym_enum] = ACTIONS(2116),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_export] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_namespace] = ACTIONS(2120),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_typeof] = ACTIONS(2120),
    [anon_sym_import] = ACTIONS(2120),
    [anon_sym_var] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_else] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_switch] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_await] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_do] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [anon_sym_with] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_debugger] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_throw] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_case] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_SLASH] = ACTIONS(2120),
    [anon_sym_class] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_function] = ACTIONS(2120),
    [anon_sym_new] = ACTIONS(2120),
    [anon_sym_PLUS] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2120),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_void] = ACTIONS(2120),
    [anon_sym_delete] = ACTIONS(2120),
    [anon_sym_PLUS_PLUS] = ACTIONS(2118),
    [anon_sym_DASH_DASH] = ACTIONS(2118),
    [anon_sym_DQUOTE] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2118),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_undefined] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_readonly] = ACTIONS(2120),
    [anon_sym_get] = ACTIONS(2120),
    [anon_sym_set] = ACTIONS(2120),
    [anon_sym_declare] = ACTIONS(2120),
    [anon_sym_public] = ACTIONS(2120),
    [anon_sym_private] = ACTIONS(2120),
    [anon_sym_protected] = ACTIONS(2120),
    [anon_sym_override] = ACTIONS(2120),
    [anon_sym_module] = ACTIONS(2120),
    [anon_sym_any] = ACTIONS(2120),
    [anon_sym_number] = ACTIONS(2120),
    [anon_sym_boolean] = ACTIONS(2120),
    [anon_sym_string] = ACTIONS(2120),
    [anon_sym_symbol] = ACTIONS(2120),
    [anon_sym_abstract] = ACTIONS(2120),
    [anon_sym_interface] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(2124),
    [anon_sym_export] = ACTIONS(2124),
    [anon_sym_default] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2124),
    [anon_sym_namespace] = ACTIONS(2124),
    [anon_sym_LBRACE] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_typeof] = ACTIONS(2124),
    [anon_sym_import] = ACTIONS(2124),
    [anon_sym_var] = ACTIONS(2124),
    [anon_sym_let] = ACTIONS(2124),
    [anon_sym_const] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2122),
    [anon_sym_else] = ACTIONS(2124),
    [anon_sym_if] = ACTIONS(2124),
    [anon_sym_switch] = ACTIONS(2124),
    [anon_sym_for] = ACTIONS(2124),
    [anon_sym_LPAREN] = ACTIONS(2122),
    [anon_sym_await] = ACTIONS(2124),
    [anon_sym_while] = ACTIONS(2124),
    [anon_sym_do] = ACTIONS(2124),
    [anon_sym_try] = ACTIONS(2124),
    [anon_sym_with] = ACTIONS(2124),
    [anon_sym_break] = ACTIONS(2124),
    [anon_sym_continue] = ACTIONS(2124),
    [anon_sym_debugger] = ACTIONS(2124),
    [anon_sym_return] = ACTIONS(2124),
    [anon_sym_throw] = ACTIONS(2124),
    [anon_sym_SEMI] = ACTIONS(2122),
    [anon_sym_case] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2122),
    [anon_sym_SLASH] = ACTIONS(2124),
    [anon_sym_class] = ACTIONS(2124),
    [anon_sym_async] = ACTIONS(2124),
    [anon_sym_function] = ACTIONS(2124),
    [anon_sym_new] = ACTIONS(2124),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2122),
    [anon_sym_void] = ACTIONS(2124),
    [anon_sym_delete] = ACTIONS(2124),
    [anon_sym_PLUS_PLUS] = ACTIONS(2122),
    [anon_sym_DASH_DASH] = ACTIONS(2122),
    [anon_sym_DQUOTE] = ACTIONS(2122),
    [anon_sym_SQUOTE] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2122),
    [sym_number] = ACTIONS(2122),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(2124),
    [sym_true] = ACTIONS(2124),
    [sym_false] = ACTIONS(2124),
    [sym_null] = ACTIONS(2124),
    [sym_undefined] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2124),
    [anon_sym_readonly] = ACTIONS(2124),
    [anon_sym_get] = ACTIONS(2124),
    [anon_sym_set] = ACTIONS(2124),
    [anon_sym_declare] = ACTIONS(2124),
    [anon_sym_public] = ACTIONS(2124),
    [anon_sym_private] = ACTIONS(2124),
    [anon_sym_protected] = ACTIONS(2124),
    [anon_sym_override] = ACTIONS(2124),
    [anon_sym_module] = ACTIONS(2124),
    [anon_sym_any] = ACTIONS(2124),
    [anon_sym_number] = ACTIONS(2124),
    [anon_sym_boolean] = ACTIONS(2124),
    [anon_sym_string] = ACTIONS(2124),
    [anon_sym_symbol] = ACTIONS(2124),
    [anon_sym_abstract] = ACTIONS(2124),
    [anon_sym_interface] = ACTIONS(2124),
    [anon_sym_enum] = ACTIONS(2124),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_export] = ACTIONS(2128),
    [anon_sym_default] = ACTIONS(2128),
    [anon_sym_type] = ACTIONS(2128),
    [anon_sym_namespace] = ACTIONS(2128),
    [anon_sym_LBRACE] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2128),
    [anon_sym_import] = ACTIONS(2128),
    [anon_sym_var] = ACTIONS(2128),
    [anon_sym_let] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_switch] = ACTIONS(2128),
    [anon_sym_for] = ACTIONS(2128),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2128),
    [anon_sym_while] = ACTIONS(2128),
    [anon_sym_do] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2128),
    [anon_sym_with] = ACTIONS(2128),
    [anon_sym_break] = ACTIONS(2128),
    [anon_sym_continue] = ACTIONS(2128),
    [anon_sym_debugger] = ACTIONS(2128),
    [anon_sym_return] = ACTIONS(2128),
    [anon_sym_throw] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_class] = ACTIONS(2128),
    [anon_sym_async] = ACTIONS(2128),
    [anon_sym_function] = ACTIONS(2128),
    [anon_sym_new] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2128),
    [anon_sym_delete] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2128),
    [sym_super] = ACTIONS(2128),
    [sym_true] = ACTIONS(2128),
    [sym_false] = ACTIONS(2128),
    [sym_null] = ACTIONS(2128),
    [sym_undefined] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_readonly] = ACTIONS(2128),
    [anon_sym_get] = ACTIONS(2128),
    [anon_sym_set] = ACTIONS(2128),
    [anon_sym_declare] = ACTIONS(2128),
    [anon_sym_public] = ACTIONS(2128),
    [anon_sym_private] = ACTIONS(2128),
    [anon_sym_protected] = ACTIONS(2128),
    [anon_sym_override] = ACTIONS(2128),
    [anon_sym_module] = ACTIONS(2128),
    [anon_sym_any] = ACTIONS(2128),
    [anon_sym_number] = ACTIONS(2128),
    [anon_sym_boolean] = ACTIONS(2128),
    [anon_sym_string] = ACTIONS(2128),
    [anon_sym_symbol] = ACTIONS(2128),
    [anon_sym_abstract] = ACTIONS(2128),
    [anon_sym_interface] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [650] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2132),
    [anon_sym_export] = ACTIONS(2132),
    [anon_sym_default] = ACTIONS(2132),
    [anon_sym_type] = ACTIONS(2132),
    [anon_sym_namespace] = ACTIONS(2132),
    [anon_sym_LBRACE] = ACTIONS(2130),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_typeof] = ACTIONS(2132),
    [anon_sym_import] = ACTIONS(2132),
    [anon_sym_var] = ACTIONS(2132),
    [anon_sym_let] = ACTIONS(2132),
    [anon_sym_const] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_else] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(2132),
    [anon_sym_switch] = ACTIONS(2132),
    [anon_sym_for] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_await] = ACTIONS(2132),
    [anon_sym_while] = ACTIONS(2132),
    [anon_sym_do] = ACTIONS(2132),
    [anon_sym_try] = ACTIONS(2132),
    [anon_sym_with] = ACTIONS(2132),
    [anon_sym_break] = ACTIONS(2132),
    [anon_sym_continue] = ACTIONS(2132),
    [anon_sym_debugger] = ACTIONS(2132),
    [anon_sym_return] = ACTIONS(2132),
    [anon_sym_throw] = ACTIONS(2132),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym_case] = ACTIONS(2132),
    [anon_sym_yield] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2130),
    [anon_sym_SLASH] = ACTIONS(2132),
    [anon_sym_class] = ACTIONS(2132),
    [anon_sym_async] = ACTIONS(2132),
    [anon_sym_function] = ACTIONS(2132),
    [anon_sym_new] = ACTIONS(2132),
    [anon_sym_PLUS] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2130),
    [anon_sym_void] = ACTIONS(2132),
    [anon_sym_delete] = ACTIONS(2132),
    [anon_sym_PLUS_PLUS] = ACTIONS(2130),
    [anon_sym_DASH_DASH] = ACTIONS(2130),
    [anon_sym_DQUOTE] = ACTIONS(2130),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2130),
    [sym_number] = ACTIONS(2130),
    [sym_this] = ACTIONS(2132),
    [sym_super] = ACTIONS(2132),
    [sym_true] = ACTIONS(2132),
    [sym_false] = ACTIONS(2132),
    [sym_null] = ACTIONS(2132),
    [sym_undefined] = ACTIONS(2132),
    [anon_sym_AT] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(2132),
    [anon_sym_readonly] = ACTIONS(2132),
    [anon_sym_get] = ACTIONS(2132),
    [anon_sym_set] = ACTIONS(2132),
    [anon_sym_declare] = ACTIONS(2132),
    [anon_sym_public] = ACTIONS(2132),
    [anon_sym_private] = ACTIONS(2132),
    [anon_sym_protected] = ACTIONS(2132),
    [anon_sym_override] = ACTIONS(2132),
    [anon_sym_module] = ACTIONS(2132),
    [anon_sym_any] = ACTIONS(2132),
    [anon_sym_number] = ACTIONS(2132),
    [anon_sym_boolean] = ACTIONS(2132),
    [anon_sym_string] = ACTIONS(2132),
    [anon_sym_symbol] = ACTIONS(2132),
    [anon_sym_abstract] = ACTIONS(2132),
    [anon_sym_interface] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2132),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1348),
    [anon_sym_export] = ACTIONS(1348),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_typeof] = ACTIONS(1348),
    [anon_sym_import] = ACTIONS(1348),
    [anon_sym_var] = ACTIONS(1348),
    [anon_sym_let] = ACTIONS(1348),
    [anon_sym_const] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1348),
    [anon_sym_if] = ACTIONS(1348),
    [anon_sym_switch] = ACTIONS(1348),
    [anon_sym_for] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_await] = ACTIONS(1348),
    [anon_sym_while] = ACTIONS(1348),
    [anon_sym_do] = ACTIONS(1348),
    [anon_sym_try] = ACTIONS(1348),
    [anon_sym_with] = ACTIONS(1348),
    [anon_sym_break] = ACTIONS(1348),
    [anon_sym_continue] = ACTIONS(1348),
    [anon_sym_debugger] = ACTIONS(1348),
    [anon_sym_return] = ACTIONS(1348),
    [anon_sym_throw] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1348),
    [anon_sym_yield] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(1348),
    [anon_sym_async] = ACTIONS(1348),
    [anon_sym_function] = ACTIONS(1348),
    [anon_sym_new] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1346),
    [anon_sym_void] = ACTIONS(1348),
    [anon_sym_delete] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [sym_number] = ACTIONS(1346),
    [sym_this] = ACTIONS(1348),
    [sym_super] = ACTIONS(1348),
    [sym_true] = ACTIONS(1348),
    [sym_false] = ACTIONS(1348),
    [sym_null] = ACTIONS(1348),
    [sym_undefined] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1348),
    [anon_sym_readonly] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1348),
    [anon_sym_set] = ACTIONS(1348),
    [anon_sym_declare] = ACTIONS(1348),
    [anon_sym_public] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1348),
    [anon_sym_protected] = ACTIONS(1348),
    [anon_sym_override] = ACTIONS(1348),
    [anon_sym_module] = ACTIONS(1348),
    [anon_sym_any] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1348),
    [anon_sym_abstract] = ACTIONS(1348),
    [anon_sym_interface] = ACTIONS(1348),
    [anon_sym_enum] = ACTIONS(1348),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2136),
    [anon_sym_export] = ACTIONS(2136),
    [anon_sym_default] = ACTIONS(2136),
    [anon_sym_type] = ACTIONS(2136),
    [anon_sym_namespace] = ACTIONS(2136),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_typeof] = ACTIONS(2136),
    [anon_sym_import] = ACTIONS(2136),
    [anon_sym_var] = ACTIONS(2136),
    [anon_sym_let] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_else] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_switch] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_await] = ACTIONS(2136),
    [anon_sym_while] = ACTIONS(2136),
    [anon_sym_do] = ACTIONS(2136),
    [anon_sym_try] = ACTIONS(2136),
    [anon_sym_with] = ACTIONS(2136),
    [anon_sym_break] = ACTIONS(2136),
    [anon_sym_continue] = ACTIONS(2136),
    [anon_sym_debugger] = ACTIONS(2136),
    [anon_sym_return] = ACTIONS(2136),
    [anon_sym_throw] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2134),
    [anon_sym_case] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2136),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_function] = ACTIONS(2136),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2134),
    [anon_sym_void] = ACTIONS(2136),
    [anon_sym_delete] = ACTIONS(2136),
    [anon_sym_PLUS_PLUS] = ACTIONS(2134),
    [anon_sym_DASH_DASH] = ACTIONS(2134),
    [anon_sym_DQUOTE] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2134),
    [sym_number] = ACTIONS(2134),
    [sym_this] = ACTIONS(2136),
    [sym_super] = ACTIONS(2136),
    [sym_true] = ACTIONS(2136),
    [sym_false] = ACTIONS(2136),
    [sym_null] = ACTIONS(2136),
    [sym_undefined] = ACTIONS(2136),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_static] = ACTIONS(2136),
    [anon_sym_readonly] = ACTIONS(2136),
    [anon_sym_get] = ACTIONS(2136),
    [anon_sym_set] = ACTIONS(2136),
    [anon_sym_declare] = ACTIONS(2136),
    [anon_sym_public] = ACTIONS(2136),
    [anon_sym_private] = ACTIONS(2136),
    [anon_sym_protected] = ACTIONS(2136),
    [anon_sym_override] = ACTIONS(2136),
    [anon_sym_module] = ACTIONS(2136),
    [anon_sym_any] = ACTIONS(2136),
    [anon_sym_number] = ACTIONS(2136),
    [anon_sym_boolean] = ACTIONS(2136),
    [anon_sym_string] = ACTIONS(2136),
    [anon_sym_symbol] = ACTIONS(2136),
    [anon_sym_abstract] = ACTIONS(2136),
    [anon_sym_interface] = ACTIONS(2136),
    [anon_sym_enum] = ACTIONS(2136),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2140),
    [anon_sym_export] = ACTIONS(2140),
    [anon_sym_default] = ACTIONS(2140),
    [anon_sym_type] = ACTIONS(2140),
    [anon_sym_namespace] = ACTIONS(2140),
    [anon_sym_LBRACE] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_typeof] = ACTIONS(2140),
    [anon_sym_import] = ACTIONS(2140),
    [anon_sym_var] = ACTIONS(2140),
    [anon_sym_let] = ACTIONS(2140),
    [anon_sym_const] = ACTIONS(2140),
    [anon_sym_BANG] = ACTIONS(2138),
    [anon_sym_else] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_switch] = ACTIONS(2140),
    [anon_sym_for] = ACTIONS(2140),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_await] = ACTIONS(2140),
    [anon_sym_while] = ACTIONS(2140),
    [anon_sym_do] = ACTIONS(2140),
    [anon_sym_try] = ACTIONS(2140),
    [anon_sym_with] = ACTIONS(2140),
    [anon_sym_break] = ACTIONS(2140),
    [anon_sym_continue] = ACTIONS(2140),
    [anon_sym_debugger] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(2140),
    [anon_sym_throw] = ACTIONS(2140),
    [anon_sym_SEMI] = ACTIONS(2138),
    [anon_sym_case] = ACTIONS(2140),
    [anon_sym_yield] = ACTIONS(2140),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_SLASH] = ACTIONS(2140),
    [anon_sym_class] = ACTIONS(2140),
    [anon_sym_async] = ACTIONS(2140),
    [anon_sym_function] = ACTIONS(2140),
    [anon_sym_new] = ACTIONS(2140),
    [anon_sym_PLUS] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2140),
    [anon_sym_TILDE] = ACTIONS(2138),
    [anon_sym_void] = ACTIONS(2140),
    [anon_sym_delete] = ACTIONS(2140),
    [anon_sym_PLUS_PLUS] = ACTIONS(2138),
    [anon_sym_DASH_DASH] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [anon_sym_SQUOTE] = ACTIONS(2138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2138),
    [sym_number] = ACTIONS(2138),
    [sym_this] = ACTIONS(2140),
    [sym_super] = ACTIONS(2140),
    [sym_true] = ACTIONS(2140),
    [sym_false] = ACTIONS(2140),
    [sym_null] = ACTIONS(2140),
    [sym_undefined] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(2138),
    [anon_sym_static] = ACTIONS(2140),
    [anon_sym_readonly] = ACTIONS(2140),
    [anon_sym_get] = ACTIONS(2140),
    [anon_sym_set] = ACTIONS(2140),
    [anon_sym_declare] = ACTIONS(2140),
    [anon_sym_public] = ACTIONS(2140),
    [anon_sym_private] = ACTIONS(2140),
    [anon_sym_protected] = ACTIONS(2140),
    [anon_sym_override] = ACTIONS(2140),
    [anon_sym_module] = ACTIONS(2140),
    [anon_sym_any] = ACTIONS(2140),
    [anon_sym_number] = ACTIONS(2140),
    [anon_sym_boolean] = ACTIONS(2140),
    [anon_sym_string] = ACTIONS(2140),
    [anon_sym_symbol] = ACTIONS(2140),
    [anon_sym_abstract] = ACTIONS(2140),
    [anon_sym_interface] = ACTIONS(2140),
    [anon_sym_enum] = ACTIONS(2140),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_export] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2144),
    [anon_sym_namespace] = ACTIONS(2144),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2144),
    [anon_sym_import] = ACTIONS(2144),
    [anon_sym_var] = ACTIONS(2144),
    [anon_sym_let] = ACTIONS(2144),
    [anon_sym_const] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(2144),
    [anon_sym_switch] = ACTIONS(2144),
    [anon_sym_for] = ACTIONS(2144),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_try] = ACTIONS(2144),
    [anon_sym_with] = ACTIONS(2144),
    [anon_sym_break] = ACTIONS(2144),
    [anon_sym_continue] = ACTIONS(2144),
    [anon_sym_debugger] = ACTIONS(2144),
    [anon_sym_return] = ACTIONS(2144),
    [anon_sym_throw] = ACTIONS(2144),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2144),
    [anon_sym_yield] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2144),
    [anon_sym_class] = ACTIONS(2144),
    [anon_sym_async] = ACTIONS(2144),
    [anon_sym_function] = ACTIONS(2144),
    [anon_sym_new] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2144),
    [anon_sym_delete] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_this] = ACTIONS(2144),
    [sym_super] = ACTIONS(2144),
    [sym_true] = ACTIONS(2144),
    [sym_false] = ACTIONS(2144),
    [sym_null] = ACTIONS(2144),
    [sym_undefined] = ACTIONS(2144),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2144),
    [anon_sym_readonly] = ACTIONS(2144),
    [anon_sym_get] = ACTIONS(2144),
    [anon_sym_set] = ACTIONS(2144),
    [anon_sym_declare] = ACTIONS(2144),
    [anon_sym_public] = ACTIONS(2144),
    [anon_sym_private] = ACTIONS(2144),
    [anon_sym_protected] = ACTIONS(2144),
    [anon_sym_override] = ACTIONS(2144),
    [anon_sym_module] = ACTIONS(2144),
    [anon_sym_any] = ACTIONS(2144),
    [anon_sym_number] = ACTIONS(2144),
    [anon_sym_boolean] = ACTIONS(2144),
    [anon_sym_string] = ACTIONS(2144),
    [anon_sym_symbol] = ACTIONS(2144),
    [anon_sym_abstract] = ACTIONS(2144),
    [anon_sym_interface] = ACTIONS(2144),
    [anon_sym_enum] = ACTIONS(2144),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2148),
    [anon_sym_export] = ACTIONS(2148),
    [anon_sym_default] = ACTIONS(2148),
    [anon_sym_type] = ACTIONS(2148),
    [anon_sym_namespace] = ACTIONS(2148),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [anon_sym_typeof] = ACTIONS(2148),
    [anon_sym_import] = ACTIONS(2148),
    [anon_sym_var] = ACTIONS(2148),
    [anon_sym_let] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_switch] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_await] = ACTIONS(2148),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(2148),
    [anon_sym_try] = ACTIONS(2148),
    [anon_sym_with] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2148),
    [anon_sym_continue] = ACTIONS(2148),
    [anon_sym_debugger] = ACTIONS(2148),
    [anon_sym_return] = ACTIONS(2148),
    [anon_sym_throw] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2148),
    [anon_sym_yield] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2148),
    [anon_sym_class] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_function] = ACTIONS(2148),
    [anon_sym_new] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2148),
    [anon_sym_TILDE] = ACTIONS(2146),
    [anon_sym_void] = ACTIONS(2148),
    [anon_sym_delete] = ACTIONS(2148),
    [anon_sym_PLUS_PLUS] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2146),
    [anon_sym_DQUOTE] = ACTIONS(2146),
    [anon_sym_SQUOTE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2146),
    [sym_number] = ACTIONS(2146),
    [sym_this] = ACTIONS(2148),
    [sym_super] = ACTIONS(2148),
    [sym_true] = ACTIONS(2148),
    [sym_false] = ACTIONS(2148),
    [sym_null] = ACTIONS(2148),
    [sym_undefined] = ACTIONS(2148),
    [anon_sym_AT] = ACTIONS(2146),
    [anon_sym_static] = ACTIONS(2148),
    [anon_sym_readonly] = ACTIONS(2148),
    [anon_sym_get] = ACTIONS(2148),
    [anon_sym_set] = ACTIONS(2148),
    [anon_sym_declare] = ACTIONS(2148),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_override] = ACTIONS(2148),
    [anon_sym_module] = ACTIONS(2148),
    [anon_sym_any] = ACTIONS(2148),
    [anon_sym_number] = ACTIONS(2148),
    [anon_sym_boolean] = ACTIONS(2148),
    [anon_sym_string] = ACTIONS(2148),
    [anon_sym_symbol] = ACTIONS(2148),
    [anon_sym_abstract] = ACTIONS(2148),
    [anon_sym_interface] = ACTIONS(2148),
    [anon_sym_enum] = ACTIONS(2148),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(2150),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2150),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_else] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_case] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2150),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2150),
    [anon_sym_DASH_DASH] = ACTIONS(2150),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_SQUOTE] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2150),
    [sym_number] = ACTIONS(2150),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(2154),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_export] = ACTIONS(2156),
    [anon_sym_default] = ACTIONS(2156),
    [anon_sym_type] = ACTIONS(2156),
    [anon_sym_namespace] = ACTIONS(2156),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(2156),
    [anon_sym_import] = ACTIONS(2156),
    [anon_sym_var] = ACTIONS(2156),
    [anon_sym_let] = ACTIONS(2156),
    [anon_sym_const] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_else] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(2156),
    [anon_sym_switch] = ACTIONS(2156),
    [anon_sym_for] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_await] = ACTIONS(2156),
    [anon_sym_while] = ACTIONS(2156),
    [anon_sym_do] = ACTIONS(2156),
    [anon_sym_try] = ACTIONS(2156),
    [anon_sym_with] = ACTIONS(2156),
    [anon_sym_break] = ACTIONS(2156),
    [anon_sym_continue] = ACTIONS(2156),
    [anon_sym_debugger] = ACTIONS(2156),
    [anon_sym_return] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_case] = ACTIONS(2156),
    [anon_sym_yield] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2154),
    [anon_sym_SLASH] = ACTIONS(2156),
    [anon_sym_class] = ACTIONS(2156),
    [anon_sym_async] = ACTIONS(2156),
    [anon_sym_function] = ACTIONS(2156),
    [anon_sym_new] = ACTIONS(2156),
    [anon_sym_PLUS] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_void] = ACTIONS(2156),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_PLUS_PLUS] = ACTIONS(2154),
    [anon_sym_DASH_DASH] = ACTIONS(2154),
    [anon_sym_DQUOTE] = ACTIONS(2154),
    [anon_sym_SQUOTE] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2154),
    [sym_number] = ACTIONS(2154),
    [sym_this] = ACTIONS(2156),
    [sym_super] = ACTIONS(2156),
    [sym_true] = ACTIONS(2156),
    [sym_false] = ACTIONS(2156),
    [sym_null] = ACTIONS(2156),
    [sym_undefined] = ACTIONS(2156),
    [anon_sym_AT] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2156),
    [anon_sym_readonly] = ACTIONS(2156),
    [anon_sym_get] = ACTIONS(2156),
    [anon_sym_set] = ACTIONS(2156),
    [anon_sym_declare] = ACTIONS(2156),
    [anon_sym_public] = ACTIONS(2156),
    [anon_sym_private] = ACTIONS(2156),
    [anon_sym_protected] = ACTIONS(2156),
    [anon_sym_override] = ACTIONS(2156),
    [anon_sym_module] = ACTIONS(2156),
    [anon_sym_any] = ACTIONS(2156),
    [anon_sym_number] = ACTIONS(2156),
    [anon_sym_boolean] = ACTIONS(2156),
    [anon_sym_string] = ACTIONS(2156),
    [anon_sym_symbol] = ACTIONS(2156),
    [anon_sym_abstract] = ACTIONS(2156),
    [anon_sym_interface] = ACTIONS(2156),
    [anon_sym_enum] = ACTIONS(2156),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(2158),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LT] = ACTIONS(2158),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2158),
    [anon_sym_DASH_DASH] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_SQUOTE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2158),
    [sym_number] = ACTIONS(2158),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_export] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_namespace] = ACTIONS(2164),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_typeof] = ACTIONS(2164),
    [anon_sym_import] = ACTIONS(2164),
    [anon_sym_var] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_else] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_do] = ACTIONS(2164),
    [anon_sym_try] = ACTIONS(2164),
    [anon_sym_with] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_debugger] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_throw] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2162),
    [anon_sym_case] = ACTIONS(2164),
    [anon_sym_yield] = ACTIONS(2164),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2162),
    [anon_sym_SLASH] = ACTIONS(2164),
    [anon_sym_class] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_function] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2164),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_void] = ACTIONS(2164),
    [anon_sym_delete] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [sym_number] = ACTIONS(2162),
    [sym_this] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_undefined] = ACTIONS(2164),
    [anon_sym_AT] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_readonly] = ACTIONS(2164),
    [anon_sym_get] = ACTIONS(2164),
    [anon_sym_set] = ACTIONS(2164),
    [anon_sym_declare] = ACTIONS(2164),
    [anon_sym_public] = ACTIONS(2164),
    [anon_sym_private] = ACTIONS(2164),
    [anon_sym_protected] = ACTIONS(2164),
    [anon_sym_override] = ACTIONS(2164),
    [anon_sym_module] = ACTIONS(2164),
    [anon_sym_any] = ACTIONS(2164),
    [anon_sym_number] = ACTIONS(2164),
    [anon_sym_boolean] = ACTIONS(2164),
    [anon_sym_string] = ACTIONS(2164),
    [anon_sym_symbol] = ACTIONS(2164),
    [anon_sym_abstract] = ACTIONS(2164),
    [anon_sym_interface] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2168),
    [anon_sym_import] = ACTIONS(2168),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_with] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_debugger] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_function] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_abstract] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(2170),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2170),
    [anon_sym_else] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2170),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2170),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_DQUOTE] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(2170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2170),
    [sym_number] = ACTIONS(2170),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2170),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2176),
    [anon_sym_export] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_type] = ACTIONS(2176),
    [anon_sym_namespace] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_typeof] = ACTIONS(2176),
    [anon_sym_import] = ACTIONS(2176),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_else] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_switch] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_await] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_do] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [anon_sym_with] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_debugger] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_throw] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym_case] = ACTIONS(2176),
    [anon_sym_yield] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_async] = ACTIONS(2176),
    [anon_sym_function] = ACTIONS(2176),
    [anon_sym_new] = ACTIONS(2176),
    [anon_sym_PLUS] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_void] = ACTIONS(2176),
    [anon_sym_delete] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2174),
    [anon_sym_DASH_DASH] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2174),
    [sym_number] = ACTIONS(2174),
    [sym_this] = ACTIONS(2176),
    [sym_super] = ACTIONS(2176),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_undefined] = ACTIONS(2176),
    [anon_sym_AT] = ACTIONS(2174),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_readonly] = ACTIONS(2176),
    [anon_sym_get] = ACTIONS(2176),
    [anon_sym_set] = ACTIONS(2176),
    [anon_sym_declare] = ACTIONS(2176),
    [anon_sym_public] = ACTIONS(2176),
    [anon_sym_private] = ACTIONS(2176),
    [anon_sym_protected] = ACTIONS(2176),
    [anon_sym_override] = ACTIONS(2176),
    [anon_sym_module] = ACTIONS(2176),
    [anon_sym_any] = ACTIONS(2176),
    [anon_sym_number] = ACTIONS(2176),
    [anon_sym_boolean] = ACTIONS(2176),
    [anon_sym_string] = ACTIONS(2176),
    [anon_sym_symbol] = ACTIONS(2176),
    [anon_sym_abstract] = ACTIONS(2176),
    [anon_sym_interface] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_export] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_type] = ACTIONS(2180),
    [anon_sym_namespace] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2180),
    [anon_sym_import] = ACTIONS(2180),
    [anon_sym_var] = ACTIONS(2180),
    [anon_sym_let] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_else] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_switch] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_do] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [anon_sym_with] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_debugger] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_throw] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_case] = ACTIONS(2180),
    [anon_sym_yield] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_async] = ACTIONS(2180),
    [anon_sym_function] = ACTIONS(2180),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2180),
    [anon_sym_delete] = ACTIONS(2180),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_this] = ACTIONS(2180),
    [sym_super] = ACTIONS(2180),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_undefined] = ACTIONS(2180),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_readonly] = ACTIONS(2180),
    [anon_sym_get] = ACTIONS(2180),
    [anon_sym_set] = ACTIONS(2180),
    [anon_sym_declare] = ACTIONS(2180),
    [anon_sym_public] = ACTIONS(2180),
    [anon_sym_private] = ACTIONS(2180),
    [anon_sym_protected] = ACTIONS(2180),
    [anon_sym_override] = ACTIONS(2180),
    [anon_sym_module] = ACTIONS(2180),
    [anon_sym_any] = ACTIONS(2180),
    [anon_sym_number] = ACTIONS(2180),
    [anon_sym_boolean] = ACTIONS(2180),
    [anon_sym_string] = ACTIONS(2180),
    [anon_sym_symbol] = ACTIONS(2180),
    [anon_sym_abstract] = ACTIONS(2180),
    [anon_sym_interface] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(2182),
    [sym_identifier] = ACTIONS(2184),
    [anon_sym_export] = ACTIONS(2184),
    [anon_sym_default] = ACTIONS(2184),
    [anon_sym_type] = ACTIONS(2184),
    [anon_sym_namespace] = ACTIONS(2184),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2184),
    [anon_sym_import] = ACTIONS(2184),
    [anon_sym_var] = ACTIONS(2184),
    [anon_sym_let] = ACTIONS(2184),
    [anon_sym_const] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2184),
    [anon_sym_if] = ACTIONS(2184),
    [anon_sym_switch] = ACTIONS(2184),
    [anon_sym_for] = ACTIONS(2184),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2184),
    [anon_sym_do] = ACTIONS(2184),
    [anon_sym_try] = ACTIONS(2184),
    [anon_sym_with] = ACTIONS(2184),
    [anon_sym_break] = ACTIONS(2184),
    [anon_sym_continue] = ACTIONS(2184),
    [anon_sym_debugger] = ACTIONS(2184),
    [anon_sym_return] = ACTIONS(2184),
    [anon_sym_throw] = ACTIONS(2184),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2184),
    [anon_sym_yield] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2184),
    [anon_sym_class] = ACTIONS(2184),
    [anon_sym_async] = ACTIONS(2184),
    [anon_sym_function] = ACTIONS(2184),
    [anon_sym_new] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_DASH] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2184),
    [anon_sym_delete] = ACTIONS(2184),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_this] = ACTIONS(2184),
    [sym_super] = ACTIONS(2184),
    [sym_true] = ACTIONS(2184),
    [sym_false] = ACTIONS(2184),
    [sym_null] = ACTIONS(2184),
    [sym_undefined] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2184),
    [anon_sym_readonly] = ACTIONS(2184),
    [anon_sym_get] = ACTIONS(2184),
    [anon_sym_set] = ACTIONS(2184),
    [anon_sym_declare] = ACTIONS(2184),
    [anon_sym_public] = ACTIONS(2184),
    [anon_sym_private] = ACTIONS(2184),
    [anon_sym_protected] = ACTIONS(2184),
    [anon_sym_override] = ACTIONS(2184),
    [anon_sym_module] = ACTIONS(2184),
    [anon_sym_any] = ACTIONS(2184),
    [anon_sym_number] = ACTIONS(2184),
    [anon_sym_boolean] = ACTIONS(2184),
    [anon_sym_string] = ACTIONS(2184),
    [anon_sym_symbol] = ACTIONS(2184),
    [anon_sym_abstract] = ACTIONS(2184),
    [anon_sym_interface] = ACTIONS(2184),
    [anon_sym_enum] = ACTIONS(2184),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2186),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2186),
    [anon_sym_DQUOTE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [sym_number] = ACTIONS(2186),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_export] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_namespace] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_typeof] = ACTIONS(2192),
    [anon_sym_import] = ACTIONS(2192),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_await] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_do] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [anon_sym_with] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_debugger] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_throw] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_class] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_function] = ACTIONS(2192),
    [anon_sym_new] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2190),
    [anon_sym_void] = ACTIONS(2192),
    [anon_sym_delete] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2190),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_readonly] = ACTIONS(2192),
    [anon_sym_get] = ACTIONS(2192),
    [anon_sym_set] = ACTIONS(2192),
    [anon_sym_declare] = ACTIONS(2192),
    [anon_sym_public] = ACTIONS(2192),
    [anon_sym_private] = ACTIONS(2192),
    [anon_sym_protected] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_module] = ACTIONS(2192),
    [anon_sym_any] = ACTIONS(2192),
    [anon_sym_number] = ACTIONS(2192),
    [anon_sym_boolean] = ACTIONS(2192),
    [anon_sym_string] = ACTIONS(2192),
    [anon_sym_symbol] = ACTIONS(2192),
    [anon_sym_abstract] = ACTIONS(2192),
    [anon_sym_interface] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(2194),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2194),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2194),
    [anon_sym_DQUOTE] = ACTIONS(2194),
    [anon_sym_SQUOTE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2194),
    [sym_number] = ACTIONS(2194),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_export] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_namespace] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [anon_sym_typeof] = ACTIONS(2200),
    [anon_sym_import] = ACTIONS(2200),
    [anon_sym_var] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_switch] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_await] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [anon_sym_do] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2200),
    [anon_sym_with] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_debugger] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_throw] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2200),
    [anon_sym_class] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_function] = ACTIONS(2200),
    [anon_sym_new] = ACTIONS(2200),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2200),
    [anon_sym_delete] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2198),
    [anon_sym_DQUOTE] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2198),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_readonly] = ACTIONS(2200),
    [anon_sym_get] = ACTIONS(2200),
    [anon_sym_set] = ACTIONS(2200),
    [anon_sym_declare] = ACTIONS(2200),
    [anon_sym_public] = ACTIONS(2200),
    [anon_sym_private] = ACTIONS(2200),
    [anon_sym_protected] = ACTIONS(2200),
    [anon_sym_override] = ACTIONS(2200),
    [anon_sym_module] = ACTIONS(2200),
    [anon_sym_any] = ACTIONS(2200),
    [anon_sym_number] = ACTIONS(2200),
    [anon_sym_boolean] = ACTIONS(2200),
    [anon_sym_string] = ACTIONS(2200),
    [anon_sym_symbol] = ACTIONS(2200),
    [anon_sym_abstract] = ACTIONS(2200),
    [anon_sym_interface] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(2202),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2202),
    [anon_sym_RBRACE] = ACTIONS(2202),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2202),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2202),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_SQUOTE] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2202),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2208),
    [anon_sym_export] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_namespace] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_typeof] = ACTIONS(2208),
    [anon_sym_import] = ACTIONS(2208),
    [anon_sym_var] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_switch] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_do] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(2208),
    [anon_sym_with] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_debugger] = ACTIONS(2208),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_throw] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2208),
    [anon_sym_class] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_function] = ACTIONS(2208),
    [anon_sym_new] = ACTIONS(2208),
    [anon_sym_PLUS] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_void] = ACTIONS(2208),
    [anon_sym_delete] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2206),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2206),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(2208),
    [sym_super] = ACTIONS(2208),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_undefined] = ACTIONS(2208),
    [anon_sym_AT] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_readonly] = ACTIONS(2208),
    [anon_sym_get] = ACTIONS(2208),
    [anon_sym_set] = ACTIONS(2208),
    [anon_sym_declare] = ACTIONS(2208),
    [anon_sym_public] = ACTIONS(2208),
    [anon_sym_private] = ACTIONS(2208),
    [anon_sym_protected] = ACTIONS(2208),
    [anon_sym_override] = ACTIONS(2208),
    [anon_sym_module] = ACTIONS(2208),
    [anon_sym_any] = ACTIONS(2208),
    [anon_sym_number] = ACTIONS(2208),
    [anon_sym_boolean] = ACTIONS(2208),
    [anon_sym_string] = ACTIONS(2208),
    [anon_sym_symbol] = ACTIONS(2208),
    [anon_sym_abstract] = ACTIONS(2208),
    [anon_sym_interface] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(2210),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2210),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2210),
    [anon_sym_DQUOTE] = ACTIONS(2210),
    [anon_sym_SQUOTE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2210),
    [sym_number] = ACTIONS(2210),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_export] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2216),
    [anon_sym_namespace] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_typeof] = ACTIONS(2216),
    [anon_sym_import] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_switch] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_await] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_do] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [anon_sym_with] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_debugger] = ACTIONS(2216),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_throw] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_class] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_function] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_void] = ACTIONS(2216),
    [anon_sym_delete] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2214),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(2216),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_declare] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(2216),
    [anon_sym_any] = ACTIONS(2216),
    [anon_sym_number] = ACTIONS(2216),
    [anon_sym_boolean] = ACTIONS(2216),
    [anon_sym_string] = ACTIONS(2216),
    [anon_sym_symbol] = ACTIONS(2216),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_interface] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_export] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2216),
    [anon_sym_namespace] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_typeof] = ACTIONS(2216),
    [anon_sym_import] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_switch] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_await] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_do] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [anon_sym_with] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_debugger] = ACTIONS(2216),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_throw] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_class] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_function] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_void] = ACTIONS(2216),
    [anon_sym_delete] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2214),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(2216),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_declare] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(2216),
    [anon_sym_any] = ACTIONS(2216),
    [anon_sym_number] = ACTIONS(2216),
    [anon_sym_boolean] = ACTIONS(2216),
    [anon_sym_string] = ACTIONS(2216),
    [anon_sym_symbol] = ACTIONS(2216),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_interface] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2220),
    [anon_sym_export] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2220),
    [anon_sym_namespace] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2218),
    [anon_sym_typeof] = ACTIONS(2220),
    [anon_sym_import] = ACTIONS(2220),
    [anon_sym_var] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_await] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_do] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [anon_sym_with] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_debugger] = ACTIONS(2220),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_throw] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_case] = ACTIONS(2220),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(2218),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_class] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_function] = ACTIONS(2220),
    [anon_sym_new] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_void] = ACTIONS(2220),
    [anon_sym_delete] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2218),
    [anon_sym_DQUOTE] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2218),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(2220),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_readonly] = ACTIONS(2220),
    [anon_sym_get] = ACTIONS(2220),
    [anon_sym_set] = ACTIONS(2220),
    [anon_sym_declare] = ACTIONS(2220),
    [anon_sym_public] = ACTIONS(2220),
    [anon_sym_private] = ACTIONS(2220),
    [anon_sym_protected] = ACTIONS(2220),
    [anon_sym_override] = ACTIONS(2220),
    [anon_sym_module] = ACTIONS(2220),
    [anon_sym_any] = ACTIONS(2220),
    [anon_sym_number] = ACTIONS(2220),
    [anon_sym_boolean] = ACTIONS(2220),
    [anon_sym_string] = ACTIONS(2220),
    [anon_sym_symbol] = ACTIONS(2220),
    [anon_sym_abstract] = ACTIONS(2220),
    [anon_sym_interface] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_export] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2216),
    [anon_sym_namespace] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_typeof] = ACTIONS(2216),
    [anon_sym_import] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_switch] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_await] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_do] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [anon_sym_with] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_debugger] = ACTIONS(2216),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_throw] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_class] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_function] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_void] = ACTIONS(2216),
    [anon_sym_delete] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2214),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(2216),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_declare] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(2216),
    [anon_sym_any] = ACTIONS(2216),
    [anon_sym_number] = ACTIONS(2216),
    [anon_sym_boolean] = ACTIONS(2216),
    [anon_sym_string] = ACTIONS(2216),
    [anon_sym_symbol] = ACTIONS(2216),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_interface] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_export] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_typeof] = ACTIONS(2224),
    [anon_sym_import] = ACTIONS(2224),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_await] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_with] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_debugger] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_function] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_void] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2222),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_readonly] = ACTIONS(2224),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_declare] = ACTIONS(2224),
    [anon_sym_public] = ACTIONS(2224),
    [anon_sym_private] = ACTIONS(2224),
    [anon_sym_protected] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_module] = ACTIONS(2224),
    [anon_sym_any] = ACTIONS(2224),
    [anon_sym_number] = ACTIONS(2224),
    [anon_sym_boolean] = ACTIONS(2224),
    [anon_sym_string] = ACTIONS(2224),
    [anon_sym_symbol] = ACTIONS(2224),
    [anon_sym_abstract] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_export] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2228),
    [anon_sym_import] = ACTIONS(2228),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_with] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_debugger] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(2228),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_readonly] = ACTIONS(2228),
    [anon_sym_get] = ACTIONS(2228),
    [anon_sym_set] = ACTIONS(2228),
    [anon_sym_declare] = ACTIONS(2228),
    [anon_sym_public] = ACTIONS(2228),
    [anon_sym_private] = ACTIONS(2228),
    [anon_sym_protected] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [anon_sym_module] = ACTIONS(2228),
    [anon_sym_any] = ACTIONS(2228),
    [anon_sym_number] = ACTIONS(2228),
    [anon_sym_boolean] = ACTIONS(2228),
    [anon_sym_string] = ACTIONS(2228),
    [anon_sym_symbol] = ACTIONS(2228),
    [anon_sym_abstract] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_export] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_type] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_typeof] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(2232),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_await] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_with] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_debugger] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_yield] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LT] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_async] = ACTIONS(2232),
    [anon_sym_function] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_void] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2230),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(2232),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_readonly] = ACTIONS(2232),
    [anon_sym_get] = ACTIONS(2232),
    [anon_sym_set] = ACTIONS(2232),
    [anon_sym_declare] = ACTIONS(2232),
    [anon_sym_public] = ACTIONS(2232),
    [anon_sym_private] = ACTIONS(2232),
    [anon_sym_protected] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [anon_sym_module] = ACTIONS(2232),
    [anon_sym_any] = ACTIONS(2232),
    [anon_sym_number] = ACTIONS(2232),
    [anon_sym_boolean] = ACTIONS(2232),
    [anon_sym_string] = ACTIONS(2232),
    [anon_sym_symbol] = ACTIONS(2232),
    [anon_sym_abstract] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_export] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2236),
    [anon_sym_import] = ACTIONS(2236),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_with] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_debugger] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_yield] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2236),
    [anon_sym_function] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(2236),
    [sym_super] = ACTIONS(2236),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [sym_null] = ACTIONS(2236),
    [sym_undefined] = ACTIONS(2236),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_readonly] = ACTIONS(2236),
    [anon_sym_get] = ACTIONS(2236),
    [anon_sym_set] = ACTIONS(2236),
    [anon_sym_declare] = ACTIONS(2236),
    [anon_sym_public] = ACTIONS(2236),
    [anon_sym_private] = ACTIONS(2236),
    [anon_sym_protected] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [anon_sym_module] = ACTIONS(2236),
    [anon_sym_any] = ACTIONS(2236),
    [anon_sym_number] = ACTIONS(2236),
    [anon_sym_boolean] = ACTIONS(2236),
    [anon_sym_string] = ACTIONS(2236),
    [anon_sym_symbol] = ACTIONS(2236),
    [anon_sym_abstract] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_export] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_type] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_typeof] = ACTIONS(2240),
    [anon_sym_import] = ACTIONS(2240),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [anon_sym_await] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_with] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_debugger] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_void] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2238),
    [sym_number] = ACTIONS(2238),
    [sym_this] = ACTIONS(2240),
    [sym_super] = ACTIONS(2240),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [sym_null] = ACTIONS(2240),
    [sym_undefined] = ACTIONS(2240),
    [anon_sym_AT] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_readonly] = ACTIONS(2240),
    [anon_sym_get] = ACTIONS(2240),
    [anon_sym_set] = ACTIONS(2240),
    [anon_sym_declare] = ACTIONS(2240),
    [anon_sym_public] = ACTIONS(2240),
    [anon_sym_private] = ACTIONS(2240),
    [anon_sym_protected] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [anon_sym_module] = ACTIONS(2240),
    [anon_sym_any] = ACTIONS(2240),
    [anon_sym_number] = ACTIONS(2240),
    [anon_sym_boolean] = ACTIONS(2240),
    [anon_sym_string] = ACTIONS(2240),
    [anon_sym_symbol] = ACTIONS(2240),
    [anon_sym_abstract] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_export] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2244),
    [anon_sym_import] = ACTIONS(2244),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_with] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_debugger] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_async] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_this] = ACTIONS(2244),
    [sym_super] = ACTIONS(2244),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [sym_null] = ACTIONS(2244),
    [sym_undefined] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_readonly] = ACTIONS(2244),
    [anon_sym_get] = ACTIONS(2244),
    [anon_sym_set] = ACTIONS(2244),
    [anon_sym_declare] = ACTIONS(2244),
    [anon_sym_public] = ACTIONS(2244),
    [anon_sym_private] = ACTIONS(2244),
    [anon_sym_protected] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [anon_sym_module] = ACTIONS(2244),
    [anon_sym_any] = ACTIONS(2244),
    [anon_sym_number] = ACTIONS(2244),
    [anon_sym_boolean] = ACTIONS(2244),
    [anon_sym_string] = ACTIONS(2244),
    [anon_sym_symbol] = ACTIONS(2244),
    [anon_sym_abstract] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_typeof] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_await] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_with] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_debugger] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_void] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2246),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_readonly] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_export] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_debugger] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_readonly] = ACTIONS(2252),
    [anon_sym_get] = ACTIONS(2252),
    [anon_sym_set] = ACTIONS(2252),
    [anon_sym_declare] = ACTIONS(2252),
    [anon_sym_public] = ACTIONS(2252),
    [anon_sym_private] = ACTIONS(2252),
    [anon_sym_protected] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_module] = ACTIONS(2252),
    [anon_sym_any] = ACTIONS(2252),
    [anon_sym_number] = ACTIONS(2252),
    [anon_sym_boolean] = ACTIONS(2252),
    [anon_sym_string] = ACTIONS(2252),
    [anon_sym_symbol] = ACTIONS(2252),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_with] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_debugger] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_function] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_void] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_declare] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_module] = ACTIONS(2256),
    [anon_sym_any] = ACTIONS(2256),
    [anon_sym_number] = ACTIONS(2256),
    [anon_sym_boolean] = ACTIONS(2256),
    [anon_sym_string] = ACTIONS(2256),
    [anon_sym_symbol] = ACTIONS(2256),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2258),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [sym_number] = ACTIONS(2262),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_export] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_type] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_typeof] = ACTIONS(2268),
    [anon_sym_import] = ACTIONS(2268),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_await] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_with] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_debugger] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_function] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_void] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2266),
    [sym_number] = ACTIONS(2266),
    [sym_this] = ACTIONS(2268),
    [sym_super] = ACTIONS(2268),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [sym_null] = ACTIONS(2268),
    [sym_undefined] = ACTIONS(2268),
    [anon_sym_AT] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_readonly] = ACTIONS(2268),
    [anon_sym_get] = ACTIONS(2268),
    [anon_sym_set] = ACTIONS(2268),
    [anon_sym_declare] = ACTIONS(2268),
    [anon_sym_public] = ACTIONS(2268),
    [anon_sym_private] = ACTIONS(2268),
    [anon_sym_protected] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_module] = ACTIONS(2268),
    [anon_sym_any] = ACTIONS(2268),
    [anon_sym_number] = ACTIONS(2268),
    [anon_sym_boolean] = ACTIONS(2268),
    [anon_sym_string] = ACTIONS(2268),
    [anon_sym_symbol] = ACTIONS(2268),
    [anon_sym_abstract] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2270),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_export] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_type] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_typeof] = ACTIONS(2276),
    [anon_sym_import] = ACTIONS(2276),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_await] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_with] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_debugger] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_function] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_void] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2274),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(2276),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_readonly] = ACTIONS(2276),
    [anon_sym_get] = ACTIONS(2276),
    [anon_sym_set] = ACTIONS(2276),
    [anon_sym_declare] = ACTIONS(2276),
    [anon_sym_public] = ACTIONS(2276),
    [anon_sym_private] = ACTIONS(2276),
    [anon_sym_protected] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_module] = ACTIONS(2276),
    [anon_sym_any] = ACTIONS(2276),
    [anon_sym_number] = ACTIONS(2276),
    [anon_sym_boolean] = ACTIONS(2276),
    [anon_sym_string] = ACTIONS(2276),
    [anon_sym_symbol] = ACTIONS(2276),
    [anon_sym_abstract] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_export] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_type] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_typeof] = ACTIONS(2284),
    [anon_sym_import] = ACTIONS(2284),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_await] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_with] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_debugger] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_function] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_void] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2282),
    [sym_number] = ACTIONS(2282),
    [sym_this] = ACTIONS(2284),
    [sym_super] = ACTIONS(2284),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [sym_null] = ACTIONS(2284),
    [sym_undefined] = ACTIONS(2284),
    [anon_sym_AT] = ACTIONS(2282),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_readonly] = ACTIONS(2284),
    [anon_sym_get] = ACTIONS(2284),
    [anon_sym_set] = ACTIONS(2284),
    [anon_sym_declare] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_module] = ACTIONS(2284),
    [anon_sym_any] = ACTIONS(2284),
    [anon_sym_number] = ACTIONS(2284),
    [anon_sym_boolean] = ACTIONS(2284),
    [anon_sym_string] = ACTIONS(2284),
    [anon_sym_symbol] = ACTIONS(2284),
    [anon_sym_abstract] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2286),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [sym_number] = ACTIONS(2290),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2290),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
  },
  [701] = {
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_export] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_type] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_typeof] = ACTIONS(2296),
    [anon_sym_import] = ACTIONS(2296),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_await] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_with] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_debugger] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_function] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_void] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2294),
    [sym_number] = ACTIONS(2294),
    [sym_this] = ACTIONS(2296),
    [sym_super] = ACTIONS(2296),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [sym_null] = ACTIONS(2296),
    [sym_undefined] = ACTIONS(2296),
    [anon_sym_AT] = ACTIONS(2294),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_readonly] = ACTIONS(2296),
    [anon_sym_get] = ACTIONS(2296),
    [anon_sym_set] = ACTIONS(2296),
    [anon_sym_declare] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_module] = ACTIONS(2296),
    [anon_sym_any] = ACTIONS(2296),
    [anon_sym_number] = ACTIONS(2296),
    [anon_sym_boolean] = ACTIONS(2296),
    [anon_sym_string] = ACTIONS(2296),
    [anon_sym_symbol] = ACTIONS(2296),
    [anon_sym_abstract] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_LT] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2298),
    [sym_number] = ACTIONS(2298),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_LT] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2302),
    [sym_number] = ACTIONS(2302),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
  },
  [704] = {
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [sym_number] = ACTIONS(2306),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_typeof] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_await] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_debugger] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_void] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2310),
    [sym_number] = ACTIONS(2310),
    [sym_this] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [sym_null] = ACTIONS(2312),
    [sym_undefined] = ACTIONS(2312),
    [anon_sym_AT] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2312),
    [anon_sym_set] = ACTIONS(2312),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_export] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_type] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_typeof] = ACTIONS(2316),
    [anon_sym_import] = ACTIONS(2316),
    [anon_sym_var] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_await] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_with] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_debugger] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_function] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_void] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2314),
    [sym_number] = ACTIONS(2314),
    [sym_this] = ACTIONS(2316),
    [sym_super] = ACTIONS(2316),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [sym_null] = ACTIONS(2316),
    [sym_undefined] = ACTIONS(2316),
    [anon_sym_AT] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_readonly] = ACTIONS(2316),
    [anon_sym_get] = ACTIONS(2316),
    [anon_sym_set] = ACTIONS(2316),
    [anon_sym_declare] = ACTIONS(2316),
    [anon_sym_public] = ACTIONS(2316),
    [anon_sym_private] = ACTIONS(2316),
    [anon_sym_protected] = ACTIONS(2316),
    [anon_sym_override] = ACTIONS(2316),
    [anon_sym_module] = ACTIONS(2316),
    [anon_sym_any] = ACTIONS(2316),
    [anon_sym_number] = ACTIONS(2316),
    [anon_sym_boolean] = ACTIONS(2316),
    [anon_sym_string] = ACTIONS(2316),
    [anon_sym_symbol] = ACTIONS(2316),
    [anon_sym_abstract] = ACTIONS(2316),
    [anon_sym_interface] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_identifier] = ACTIONS(1434),
    [anon_sym_export] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_type] = ACTIONS(1434),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [anon_sym_typeof] = ACTIONS(1434),
    [anon_sym_import] = ACTIONS(1434),
    [anon_sym_var] = ACTIONS(1434),
    [anon_sym_let] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(1434),
    [anon_sym_with] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_debugger] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_throw] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_yield] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_class] = ACTIONS(1434),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(1434),
    [anon_sym_new] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_void] = ACTIONS(1434),
    [anon_sym_delete] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [sym_number] = ACTIONS(1432),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [sym_null] = ACTIONS(1434),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_readonly] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1434),
    [anon_sym_set] = ACTIONS(1434),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_public] = ACTIONS(1434),
    [anon_sym_private] = ACTIONS(1434),
    [anon_sym_protected] = ACTIONS(1434),
    [anon_sym_override] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1434),
    [anon_sym_any] = ACTIONS(1434),
    [anon_sym_number] = ACTIONS(1434),
    [anon_sym_boolean] = ACTIONS(1434),
    [anon_sym_string] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1434),
    [anon_sym_abstract] = ACTIONS(1434),
    [anon_sym_interface] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_export] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_import] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_with] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_debugger] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_function] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_void] = ACTIONS(2320),
    [anon_sym_delete] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_undefined] = ACTIONS(2320),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_declare] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_module] = ACTIONS(2320),
    [anon_sym_any] = ACTIONS(2320),
    [anon_sym_number] = ACTIONS(2320),
    [anon_sym_boolean] = ACTIONS(2320),
    [anon_sym_string] = ACTIONS(2320),
    [anon_sym_symbol] = ACTIONS(2320),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_export] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_import] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_with] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_debugger] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_function] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_void] = ACTIONS(2320),
    [anon_sym_delete] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_undefined] = ACTIONS(2320),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_declare] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_module] = ACTIONS(2320),
    [anon_sym_any] = ACTIONS(2320),
    [anon_sym_number] = ACTIONS(2320),
    [anon_sym_boolean] = ACTIONS(2320),
    [anon_sym_string] = ACTIONS(2320),
    [anon_sym_symbol] = ACTIONS(2320),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2324),
    [anon_sym_export] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_type] = ACTIONS(2324),
    [anon_sym_namespace] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_typeof] = ACTIONS(2324),
    [anon_sym_import] = ACTIONS(2324),
    [anon_sym_var] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_await] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [anon_sym_with] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_debugger] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_throw] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_LT] = ACTIONS(2322),
    [anon_sym_SLASH] = ACTIONS(2324),
    [anon_sym_class] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_new] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_void] = ACTIONS(2324),
    [anon_sym_delete] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2322),
    [sym_number] = ACTIONS(2322),
    [sym_this] = ACTIONS(2324),
    [sym_super] = ACTIONS(2324),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_undefined] = ACTIONS(2324),
    [anon_sym_AT] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_readonly] = ACTIONS(2324),
    [anon_sym_get] = ACTIONS(2324),
    [anon_sym_set] = ACTIONS(2324),
    [anon_sym_declare] = ACTIONS(2324),
    [anon_sym_public] = ACTIONS(2324),
    [anon_sym_private] = ACTIONS(2324),
    [anon_sym_protected] = ACTIONS(2324),
    [anon_sym_override] = ACTIONS(2324),
    [anon_sym_module] = ACTIONS(2324),
    [anon_sym_any] = ACTIONS(2324),
    [anon_sym_number] = ACTIONS(2324),
    [anon_sym_boolean] = ACTIONS(2324),
    [anon_sym_string] = ACTIONS(2324),
    [anon_sym_symbol] = ACTIONS(2324),
    [anon_sym_abstract] = ACTIONS(2324),
    [anon_sym_interface] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(2326),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_export] = ACTIONS(2328),
    [anon_sym_default] = ACTIONS(2328),
    [anon_sym_type] = ACTIONS(2328),
    [anon_sym_namespace] = ACTIONS(2328),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(2328),
    [anon_sym_import] = ACTIONS(2328),
    [anon_sym_var] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_switch] = ACTIONS(2328),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2326),
    [anon_sym_await] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_with] = ACTIONS(2328),
    [anon_sym_break] = ACTIONS(2328),
    [anon_sym_continue] = ACTIONS(2328),
    [anon_sym_debugger] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_throw] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2328),
    [anon_sym_class] = ACTIONS(2328),
    [anon_sym_async] = ACTIONS(2328),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2326),
    [anon_sym_void] = ACTIONS(2328),
    [anon_sym_delete] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2326),
    [anon_sym_DQUOTE] = ACTIONS(2326),
    [anon_sym_SQUOTE] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2326),
    [sym_number] = ACTIONS(2326),
    [sym_this] = ACTIONS(2328),
    [sym_super] = ACTIONS(2328),
    [sym_true] = ACTIONS(2328),
    [sym_false] = ACTIONS(2328),
    [sym_null] = ACTIONS(2328),
    [sym_undefined] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_readonly] = ACTIONS(2328),
    [anon_sym_get] = ACTIONS(2328),
    [anon_sym_set] = ACTIONS(2328),
    [anon_sym_declare] = ACTIONS(2328),
    [anon_sym_public] = ACTIONS(2328),
    [anon_sym_private] = ACTIONS(2328),
    [anon_sym_protected] = ACTIONS(2328),
    [anon_sym_override] = ACTIONS(2328),
    [anon_sym_module] = ACTIONS(2328),
    [anon_sym_any] = ACTIONS(2328),
    [anon_sym_number] = ACTIONS(2328),
    [anon_sym_boolean] = ACTIONS(2328),
    [anon_sym_string] = ACTIONS(2328),
    [anon_sym_symbol] = ACTIONS(2328),
    [anon_sym_abstract] = ACTIONS(2328),
    [anon_sym_interface] = ACTIONS(2328),
    [anon_sym_enum] = ACTIONS(2328),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_export] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_type] = ACTIONS(2332),
    [anon_sym_namespace] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_typeof] = ACTIONS(2332),
    [anon_sym_import] = ACTIONS(2332),
    [anon_sym_var] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_switch] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_await] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_with] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_debugger] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_throw] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_SLASH] = ACTIONS(2332),
    [anon_sym_class] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2330),
    [anon_sym_void] = ACTIONS(2332),
    [anon_sym_delete] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(2330),
    [anon_sym_SQUOTE] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2330),
    [sym_number] = ACTIONS(2330),
    [sym_this] = ACTIONS(2332),
    [sym_super] = ACTIONS(2332),
    [sym_true] = ACTIONS(2332),
    [sym_false] = ACTIONS(2332),
    [sym_null] = ACTIONS(2332),
    [sym_undefined] = ACTIONS(2332),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_readonly] = ACTIONS(2332),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_declare] = ACTIONS(2332),
    [anon_sym_public] = ACTIONS(2332),
    [anon_sym_private] = ACTIONS(2332),
    [anon_sym_protected] = ACTIONS(2332),
    [anon_sym_override] = ACTIONS(2332),
    [anon_sym_module] = ACTIONS(2332),
    [anon_sym_any] = ACTIONS(2332),
    [anon_sym_number] = ACTIONS(2332),
    [anon_sym_boolean] = ACTIONS(2332),
    [anon_sym_string] = ACTIONS(2332),
    [anon_sym_symbol] = ACTIONS(2332),
    [anon_sym_abstract] = ACTIONS(2332),
    [anon_sym_interface] = ACTIONS(2332),
    [anon_sym_enum] = ACTIONS(2332),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_typeof] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_await] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_debugger] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_void] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2310),
    [sym_number] = ACTIONS(2310),
    [sym_this] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [sym_null] = ACTIONS(2312),
    [sym_undefined] = ACTIONS(2312),
    [anon_sym_AT] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2312),
    [anon_sym_set] = ACTIONS(2312),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_export] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_type] = ACTIONS(2336),
    [anon_sym_namespace] = ACTIONS(2336),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_typeof] = ACTIONS(2336),
    [anon_sym_import] = ACTIONS(2336),
    [anon_sym_var] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_switch] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_await] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_do] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_with] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_debugger] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_throw] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_SLASH] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_function] = ACTIONS(2336),
    [anon_sym_new] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_void] = ACTIONS(2336),
    [anon_sym_delete] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2334),
    [anon_sym_DQUOTE] = ACTIONS(2334),
    [anon_sym_SQUOTE] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2334),
    [sym_number] = ACTIONS(2334),
    [sym_this] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_undefined] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_readonly] = ACTIONS(2336),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_declare] = ACTIONS(2336),
    [anon_sym_public] = ACTIONS(2336),
    [anon_sym_private] = ACTIONS(2336),
    [anon_sym_protected] = ACTIONS(2336),
    [anon_sym_override] = ACTIONS(2336),
    [anon_sym_module] = ACTIONS(2336),
    [anon_sym_any] = ACTIONS(2336),
    [anon_sym_number] = ACTIONS(2336),
    [anon_sym_boolean] = ACTIONS(2336),
    [anon_sym_string] = ACTIONS(2336),
    [anon_sym_symbol] = ACTIONS(2336),
    [anon_sym_abstract] = ACTIONS(2336),
    [anon_sym_interface] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_typeof] = ACTIONS(2056),
    [anon_sym_import] = ACTIONS(2056),
    [anon_sym_var] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_debugger] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_SLASH] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_function] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_void] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [sym_undefined] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_readonly] = ACTIONS(2056),
    [anon_sym_get] = ACTIONS(2056),
    [anon_sym_set] = ACTIONS(2056),
    [anon_sym_declare] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_override] = ACTIONS(2056),
    [anon_sym_module] = ACTIONS(2056),
    [anon_sym_any] = ACTIONS(2056),
    [anon_sym_number] = ACTIONS(2056),
    [anon_sym_boolean] = ACTIONS(2056),
    [anon_sym_string] = ACTIONS(2056),
    [anon_sym_symbol] = ACTIONS(2056),
    [anon_sym_abstract] = ACTIONS(2056),
    [anon_sym_interface] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_export] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_namespace] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_typeof] = ACTIONS(2340),
    [anon_sym_import] = ACTIONS(2340),
    [anon_sym_var] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_await] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_debugger] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_throw] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_class] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2338),
    [anon_sym_void] = ACTIONS(2340),
    [anon_sym_delete] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [anon_sym_DQUOTE] = ACTIONS(2338),
    [anon_sym_SQUOTE] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2338),
    [sym_number] = ACTIONS(2338),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_readonly] = ACTIONS(2340),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_declare] = ACTIONS(2340),
    [anon_sym_public] = ACTIONS(2340),
    [anon_sym_private] = ACTIONS(2340),
    [anon_sym_protected] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [anon_sym_module] = ACTIONS(2340),
    [anon_sym_any] = ACTIONS(2340),
    [anon_sym_number] = ACTIONS(2340),
    [anon_sym_boolean] = ACTIONS(2340),
    [anon_sym_string] = ACTIONS(2340),
    [anon_sym_symbol] = ACTIONS(2340),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_interface] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_typeof] = ACTIONS(2056),
    [anon_sym_import] = ACTIONS(2056),
    [anon_sym_var] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_debugger] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_SLASH] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_function] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_void] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [sym_undefined] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_readonly] = ACTIONS(2056),
    [anon_sym_get] = ACTIONS(2056),
    [anon_sym_set] = ACTIONS(2056),
    [anon_sym_declare] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_override] = ACTIONS(2056),
    [anon_sym_module] = ACTIONS(2056),
    [anon_sym_any] = ACTIONS(2056),
    [anon_sym_number] = ACTIONS(2056),
    [anon_sym_boolean] = ACTIONS(2056),
    [anon_sym_string] = ACTIONS(2056),
    [anon_sym_symbol] = ACTIONS(2056),
    [anon_sym_abstract] = ACTIONS(2056),
    [anon_sym_interface] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [726] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_export] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_import] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_with] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_debugger] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_function] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_void] = ACTIONS(2320),
    [anon_sym_delete] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_undefined] = ACTIONS(2320),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_declare] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_module] = ACTIONS(2320),
    [anon_sym_any] = ACTIONS(2320),
    [anon_sym_number] = ACTIONS(2320),
    [anon_sym_boolean] = ACTIONS(2320),
    [anon_sym_string] = ACTIONS(2320),
    [anon_sym_symbol] = ACTIONS(2320),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_export] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_import] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_with] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_debugger] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_function] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_void] = ACTIONS(2320),
    [anon_sym_delete] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_undefined] = ACTIONS(2320),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_declare] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_module] = ACTIONS(2320),
    [anon_sym_any] = ACTIONS(2320),
    [anon_sym_number] = ACTIONS(2320),
    [anon_sym_boolean] = ACTIONS(2320),
    [anon_sym_string] = ACTIONS(2320),
    [anon_sym_symbol] = ACTIONS(2320),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_export] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_import] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_with] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_debugger] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_class] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_function] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2344),
    [anon_sym_delete] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_declare] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_override] = ACTIONS(2344),
    [anon_sym_module] = ACTIONS(2344),
    [anon_sym_any] = ACTIONS(2344),
    [anon_sym_number] = ACTIONS(2344),
    [anon_sym_boolean] = ACTIONS(2344),
    [anon_sym_string] = ACTIONS(2344),
    [anon_sym_symbol] = ACTIONS(2344),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_export] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_import] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_with] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_debugger] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_class] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_function] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2344),
    [anon_sym_delete] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_declare] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_override] = ACTIONS(2344),
    [anon_sym_module] = ACTIONS(2344),
    [anon_sym_any] = ACTIONS(2344),
    [anon_sym_number] = ACTIONS(2344),
    [anon_sym_boolean] = ACTIONS(2344),
    [anon_sym_string] = ACTIONS(2344),
    [anon_sym_symbol] = ACTIONS(2344),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_identifier] = ACTIONS(1434),
    [anon_sym_export] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_type] = ACTIONS(1434),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [anon_sym_typeof] = ACTIONS(1434),
    [anon_sym_import] = ACTIONS(1434),
    [anon_sym_var] = ACTIONS(1434),
    [anon_sym_let] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(1434),
    [anon_sym_with] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_debugger] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_throw] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_yield] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_class] = ACTIONS(1434),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(1434),
    [anon_sym_new] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_void] = ACTIONS(1434),
    [anon_sym_delete] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [sym_number] = ACTIONS(1432),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [sym_null] = ACTIONS(1434),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_readonly] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1434),
    [anon_sym_set] = ACTIONS(1434),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_public] = ACTIONS(1434),
    [anon_sym_private] = ACTIONS(1434),
    [anon_sym_protected] = ACTIONS(1434),
    [anon_sym_override] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1434),
    [anon_sym_any] = ACTIONS(1434),
    [anon_sym_number] = ACTIONS(1434),
    [anon_sym_boolean] = ACTIONS(1434),
    [anon_sym_string] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1434),
    [anon_sym_abstract] = ACTIONS(1434),
    [anon_sym_interface] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2346),
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_export] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_typeof] = ACTIONS(2348),
    [anon_sym_import] = ACTIONS(2348),
    [anon_sym_var] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_await] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_with] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_debugger] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_function] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2346),
    [anon_sym_void] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2346),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2346),
    [sym_number] = ACTIONS(2346),
    [sym_this] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_readonly] = ACTIONS(2348),
    [anon_sym_get] = ACTIONS(2348),
    [anon_sym_set] = ACTIONS(2348),
    [anon_sym_declare] = ACTIONS(2348),
    [anon_sym_public] = ACTIONS(2348),
    [anon_sym_private] = ACTIONS(2348),
    [anon_sym_protected] = ACTIONS(2348),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2348),
    [anon_sym_any] = ACTIONS(2348),
    [anon_sym_number] = ACTIONS(2348),
    [anon_sym_boolean] = ACTIONS(2348),
    [anon_sym_string] = ACTIONS(2348),
    [anon_sym_symbol] = ACTIONS(2348),
    [anon_sym_abstract] = ACTIONS(2348),
    [anon_sym_interface] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_export] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_typeof] = ACTIONS(2352),
    [anon_sym_import] = ACTIONS(2352),
    [anon_sym_var] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_await] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_debugger] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_function] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_void] = ACTIONS(2352),
    [anon_sym_delete] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2350),
    [sym_number] = ACTIONS(2350),
    [sym_this] = ACTIONS(2352),
    [sym_super] = ACTIONS(2352),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [sym_null] = ACTIONS(2352),
    [sym_undefined] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_readonly] = ACTIONS(2352),
    [anon_sym_get] = ACTIONS(2352),
    [anon_sym_set] = ACTIONS(2352),
    [anon_sym_declare] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_override] = ACTIONS(2352),
    [anon_sym_module] = ACTIONS(2352),
    [anon_sym_any] = ACTIONS(2352),
    [anon_sym_number] = ACTIONS(2352),
    [anon_sym_boolean] = ACTIONS(2352),
    [anon_sym_string] = ACTIONS(2352),
    [anon_sym_symbol] = ACTIONS(2352),
    [anon_sym_abstract] = ACTIONS(2352),
    [anon_sym_interface] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [741] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2356),
    [anon_sym_export] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_typeof] = ACTIONS(2356),
    [anon_sym_import] = ACTIONS(2356),
    [anon_sym_var] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_await] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_with] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_debugger] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_function] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_void] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [sym_number] = ACTIONS(2354),
    [sym_this] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_null] = ACTIONS(2356),
    [sym_undefined] = ACTIONS(2356),
    [anon_sym_AT] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_readonly] = ACTIONS(2356),
    [anon_sym_get] = ACTIONS(2356),
    [anon_sym_set] = ACTIONS(2356),
    [anon_sym_declare] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_override] = ACTIONS(2356),
    [anon_sym_module] = ACTIONS(2356),
    [anon_sym_any] = ACTIONS(2356),
    [anon_sym_number] = ACTIONS(2356),
    [anon_sym_boolean] = ACTIONS(2356),
    [anon_sym_string] = ACTIONS(2356),
    [anon_sym_symbol] = ACTIONS(2356),
    [anon_sym_abstract] = ACTIONS(2356),
    [anon_sym_interface] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2356),
    [anon_sym_export] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_typeof] = ACTIONS(2356),
    [anon_sym_import] = ACTIONS(2356),
    [anon_sym_var] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_await] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_with] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_debugger] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_function] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_void] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [sym_number] = ACTIONS(2354),
    [sym_this] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_null] = ACTIONS(2356),
    [sym_undefined] = ACTIONS(2356),
    [anon_sym_AT] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_readonly] = ACTIONS(2356),
    [anon_sym_get] = ACTIONS(2356),
    [anon_sym_set] = ACTIONS(2356),
    [anon_sym_declare] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_override] = ACTIONS(2356),
    [anon_sym_module] = ACTIONS(2356),
    [anon_sym_any] = ACTIONS(2356),
    [anon_sym_number] = ACTIONS(2356),
    [anon_sym_boolean] = ACTIONS(2356),
    [anon_sym_string] = ACTIONS(2356),
    [anon_sym_symbol] = ACTIONS(2356),
    [anon_sym_abstract] = ACTIONS(2356),
    [anon_sym_interface] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2360),
    [anon_sym_export] = ACTIONS(2360),
    [anon_sym_default] = ACTIONS(2360),
    [anon_sym_type] = ACTIONS(2360),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_typeof] = ACTIONS(2360),
    [anon_sym_import] = ACTIONS(2360),
    [anon_sym_var] = ACTIONS(2360),
    [anon_sym_let] = ACTIONS(2360),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_switch] = ACTIONS(2360),
    [anon_sym_for] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2358),
    [anon_sym_await] = ACTIONS(2360),
    [anon_sym_while] = ACTIONS(2360),
    [anon_sym_do] = ACTIONS(2360),
    [anon_sym_try] = ACTIONS(2360),
    [anon_sym_with] = ACTIONS(2360),
    [anon_sym_break] = ACTIONS(2360),
    [anon_sym_continue] = ACTIONS(2360),
    [anon_sym_debugger] = ACTIONS(2360),
    [anon_sym_return] = ACTIONS(2360),
    [anon_sym_throw] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2360),
    [anon_sym_yield] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_LT] = ACTIONS(2358),
    [anon_sym_SLASH] = ACTIONS(2360),
    [anon_sym_class] = ACTIONS(2360),
    [anon_sym_async] = ACTIONS(2360),
    [anon_sym_function] = ACTIONS(2360),
    [anon_sym_new] = ACTIONS(2360),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_void] = ACTIONS(2360),
    [anon_sym_delete] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2358),
    [sym_number] = ACTIONS(2358),
    [sym_this] = ACTIONS(2360),
    [sym_super] = ACTIONS(2360),
    [sym_true] = ACTIONS(2360),
    [sym_false] = ACTIONS(2360),
    [sym_null] = ACTIONS(2360),
    [sym_undefined] = ACTIONS(2360),
    [anon_sym_AT] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2360),
    [anon_sym_readonly] = ACTIONS(2360),
    [anon_sym_get] = ACTIONS(2360),
    [anon_sym_set] = ACTIONS(2360),
    [anon_sym_declare] = ACTIONS(2360),
    [anon_sym_public] = ACTIONS(2360),
    [anon_sym_private] = ACTIONS(2360),
    [anon_sym_protected] = ACTIONS(2360),
    [anon_sym_override] = ACTIONS(2360),
    [anon_sym_module] = ACTIONS(2360),
    [anon_sym_any] = ACTIONS(2360),
    [anon_sym_number] = ACTIONS(2360),
    [anon_sym_boolean] = ACTIONS(2360),
    [anon_sym_string] = ACTIONS(2360),
    [anon_sym_symbol] = ACTIONS(2360),
    [anon_sym_abstract] = ACTIONS(2360),
    [anon_sym_interface] = ACTIONS(2360),
    [anon_sym_enum] = ACTIONS(2360),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2364),
    [anon_sym_export] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(2364),
    [anon_sym_type] = ACTIONS(2364),
    [anon_sym_namespace] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_typeof] = ACTIONS(2364),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2364),
    [anon_sym_switch] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_await] = ACTIONS(2364),
    [anon_sym_while] = ACTIONS(2364),
    [anon_sym_do] = ACTIONS(2364),
    [anon_sym_try] = ACTIONS(2364),
    [anon_sym_with] = ACTIONS(2364),
    [anon_sym_break] = ACTIONS(2364),
    [anon_sym_continue] = ACTIONS(2364),
    [anon_sym_debugger] = ACTIONS(2364),
    [anon_sym_return] = ACTIONS(2364),
    [anon_sym_throw] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2364),
    [anon_sym_yield] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2362),
    [anon_sym_SLASH] = ACTIONS(2364),
    [anon_sym_class] = ACTIONS(2364),
    [anon_sym_async] = ACTIONS(2364),
    [anon_sym_function] = ACTIONS(2364),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_void] = ACTIONS(2364),
    [anon_sym_delete] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [sym_number] = ACTIONS(2362),
    [sym_this] = ACTIONS(2364),
    [sym_super] = ACTIONS(2364),
    [sym_true] = ACTIONS(2364),
    [sym_false] = ACTIONS(2364),
    [sym_null] = ACTIONS(2364),
    [sym_undefined] = ACTIONS(2364),
    [anon_sym_AT] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_readonly] = ACTIONS(2364),
    [anon_sym_get] = ACTIONS(2364),
    [anon_sym_set] = ACTIONS(2364),
    [anon_sym_declare] = ACTIONS(2364),
    [anon_sym_public] = ACTIONS(2364),
    [anon_sym_private] = ACTIONS(2364),
    [anon_sym_protected] = ACTIONS(2364),
    [anon_sym_override] = ACTIONS(2364),
    [anon_sym_module] = ACTIONS(2364),
    [anon_sym_any] = ACTIONS(2364),
    [anon_sym_number] = ACTIONS(2364),
    [anon_sym_boolean] = ACTIONS(2364),
    [anon_sym_string] = ACTIONS(2364),
    [anon_sym_symbol] = ACTIONS(2364),
    [anon_sym_abstract] = ACTIONS(2364),
    [anon_sym_interface] = ACTIONS(2364),
    [anon_sym_enum] = ACTIONS(2364),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2368),
    [anon_sym_export] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_type] = ACTIONS(2368),
    [anon_sym_namespace] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_typeof] = ACTIONS(2368),
    [anon_sym_import] = ACTIONS(2368),
    [anon_sym_var] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_switch] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_await] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_do] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_with] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_debugger] = ACTIONS(2368),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_throw] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2368),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_SLASH] = ACTIONS(2368),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_new] = ACTIONS(2368),
    [anon_sym_PLUS] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2366),
    [anon_sym_void] = ACTIONS(2368),
    [anon_sym_delete] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2366),
    [anon_sym_DQUOTE] = ACTIONS(2366),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2366),
    [sym_number] = ACTIONS(2366),
    [sym_this] = ACTIONS(2368),
    [sym_super] = ACTIONS(2368),
    [sym_true] = ACTIONS(2368),
    [sym_false] = ACTIONS(2368),
    [sym_null] = ACTIONS(2368),
    [sym_undefined] = ACTIONS(2368),
    [anon_sym_AT] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_readonly] = ACTIONS(2368),
    [anon_sym_get] = ACTIONS(2368),
    [anon_sym_set] = ACTIONS(2368),
    [anon_sym_declare] = ACTIONS(2368),
    [anon_sym_public] = ACTIONS(2368),
    [anon_sym_private] = ACTIONS(2368),
    [anon_sym_protected] = ACTIONS(2368),
    [anon_sym_override] = ACTIONS(2368),
    [anon_sym_module] = ACTIONS(2368),
    [anon_sym_any] = ACTIONS(2368),
    [anon_sym_number] = ACTIONS(2368),
    [anon_sym_boolean] = ACTIONS(2368),
    [anon_sym_string] = ACTIONS(2368),
    [anon_sym_symbol] = ACTIONS(2368),
    [anon_sym_abstract] = ACTIONS(2368),
    [anon_sym_interface] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2368),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_export] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_type] = ACTIONS(2372),
    [anon_sym_namespace] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_typeof] = ACTIONS(2372),
    [anon_sym_import] = ACTIONS(2372),
    [anon_sym_var] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_switch] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_await] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_do] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [anon_sym_with] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_debugger] = ACTIONS(2372),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_throw] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2372),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2370),
    [anon_sym_SLASH] = ACTIONS(2372),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_function] = ACTIONS(2372),
    [anon_sym_new] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2370),
    [anon_sym_void] = ACTIONS(2372),
    [anon_sym_delete] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2370),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2370),
    [sym_number] = ACTIONS(2370),
    [sym_this] = ACTIONS(2372),
    [sym_super] = ACTIONS(2372),
    [sym_true] = ACTIONS(2372),
    [sym_false] = ACTIONS(2372),
    [sym_null] = ACTIONS(2372),
    [sym_undefined] = ACTIONS(2372),
    [anon_sym_AT] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_readonly] = ACTIONS(2372),
    [anon_sym_get] = ACTIONS(2372),
    [anon_sym_set] = ACTIONS(2372),
    [anon_sym_declare] = ACTIONS(2372),
    [anon_sym_public] = ACTIONS(2372),
    [anon_sym_private] = ACTIONS(2372),
    [anon_sym_protected] = ACTIONS(2372),
    [anon_sym_override] = ACTIONS(2372),
    [anon_sym_module] = ACTIONS(2372),
    [anon_sym_any] = ACTIONS(2372),
    [anon_sym_number] = ACTIONS(2372),
    [anon_sym_boolean] = ACTIONS(2372),
    [anon_sym_string] = ACTIONS(2372),
    [anon_sym_symbol] = ACTIONS(2372),
    [anon_sym_abstract] = ACTIONS(2372),
    [anon_sym_interface] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(1312),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_export] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_namespace] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [anon_sym_typeof] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(1314),
    [anon_sym_var] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_try] = ACTIONS(1314),
    [anon_sym_with] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_debugger] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_throw] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_yield] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(1312),
    [anon_sym_SLASH] = ACTIONS(1314),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_function] = ACTIONS(1314),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_void] = ACTIONS(1314),
    [anon_sym_delete] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1312),
    [sym_number] = ACTIONS(1312),
    [sym_this] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [sym_null] = ACTIONS(1314),
    [sym_undefined] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(1312),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_readonly] = ACTIONS(1314),
    [anon_sym_get] = ACTIONS(1314),
    [anon_sym_set] = ACTIONS(1314),
    [anon_sym_declare] = ACTIONS(1314),
    [anon_sym_public] = ACTIONS(1314),
    [anon_sym_private] = ACTIONS(1314),
    [anon_sym_protected] = ACTIONS(1314),
    [anon_sym_override] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [anon_sym_any] = ACTIONS(1314),
    [anon_sym_number] = ACTIONS(1314),
    [anon_sym_boolean] = ACTIONS(1314),
    [anon_sym_string] = ACTIONS(1314),
    [anon_sym_symbol] = ACTIONS(1314),
    [anon_sym_abstract] = ACTIONS(1314),
    [anon_sym_interface] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2376),
    [anon_sym_export] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_RBRACE] = ACTIONS(2374),
    [anon_sym_typeof] = ACTIONS(2376),
    [anon_sym_import] = ACTIONS(2376),
    [anon_sym_var] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_await] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_with] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_debugger] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_LT] = ACTIONS(2374),
    [anon_sym_SLASH] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2374),
    [anon_sym_void] = ACTIONS(2376),
    [anon_sym_delete] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2374),
    [anon_sym_DQUOTE] = ACTIONS(2374),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2374),
    [sym_number] = ACTIONS(2374),
    [sym_this] = ACTIONS(2376),
    [sym_super] = ACTIONS(2376),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [sym_null] = ACTIONS(2376),
    [sym_undefined] = ACTIONS(2376),
    [anon_sym_AT] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_readonly] = ACTIONS(2376),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_declare] = ACTIONS(2376),
    [anon_sym_public] = ACTIONS(2376),
    [anon_sym_private] = ACTIONS(2376),
    [anon_sym_protected] = ACTIONS(2376),
    [anon_sym_override] = ACTIONS(2376),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_any] = ACTIONS(2376),
    [anon_sym_number] = ACTIONS(2376),
    [anon_sym_boolean] = ACTIONS(2376),
    [anon_sym_string] = ACTIONS(2376),
    [anon_sym_symbol] = ACTIONS(2376),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_interface] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2380),
    [anon_sym_export] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_type] = ACTIONS(2380),
    [anon_sym_namespace] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_typeof] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2380),
    [anon_sym_var] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_await] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [anon_sym_with] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_debugger] = ACTIONS(2380),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2380),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2378),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_class] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2380),
    [anon_sym_new] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_void] = ACTIONS(2380),
    [anon_sym_delete] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [sym_number] = ACTIONS(2378),
    [sym_this] = ACTIONS(2380),
    [sym_super] = ACTIONS(2380),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [sym_null] = ACTIONS(2380),
    [sym_undefined] = ACTIONS(2380),
    [anon_sym_AT] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_readonly] = ACTIONS(2380),
    [anon_sym_get] = ACTIONS(2380),
    [anon_sym_set] = ACTIONS(2380),
    [anon_sym_declare] = ACTIONS(2380),
    [anon_sym_public] = ACTIONS(2380),
    [anon_sym_private] = ACTIONS(2380),
    [anon_sym_protected] = ACTIONS(2380),
    [anon_sym_override] = ACTIONS(2380),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_any] = ACTIONS(2380),
    [anon_sym_number] = ACTIONS(2380),
    [anon_sym_boolean] = ACTIONS(2380),
    [anon_sym_string] = ACTIONS(2380),
    [anon_sym_symbol] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2380),
    [anon_sym_interface] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(2382),
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_export] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_typeof] = ACTIONS(2384),
    [anon_sym_import] = ACTIONS(2384),
    [anon_sym_var] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_await] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_with] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_debugger] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_function] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2382),
    [anon_sym_void] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [anon_sym_DQUOTE] = ACTIONS(2382),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [sym_number] = ACTIONS(2382),
    [sym_this] = ACTIONS(2384),
    [sym_super] = ACTIONS(2384),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [sym_null] = ACTIONS(2384),
    [sym_undefined] = ACTIONS(2384),
    [anon_sym_AT] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_readonly] = ACTIONS(2384),
    [anon_sym_get] = ACTIONS(2384),
    [anon_sym_set] = ACTIONS(2384),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_override] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2384),
    [anon_sym_any] = ACTIONS(2384),
    [anon_sym_number] = ACTIONS(2384),
    [anon_sym_boolean] = ACTIONS(2384),
    [anon_sym_string] = ACTIONS(2384),
    [anon_sym_symbol] = ACTIONS(2384),
    [anon_sym_abstract] = ACTIONS(2384),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_export] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_typeof] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2388),
    [anon_sym_var] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_await] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_with] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_debugger] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_SLASH] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_function] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_void] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [sym_number] = ACTIONS(2386),
    [sym_this] = ACTIONS(2388),
    [sym_super] = ACTIONS(2388),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [sym_null] = ACTIONS(2388),
    [sym_undefined] = ACTIONS(2388),
    [anon_sym_AT] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_readonly] = ACTIONS(2388),
    [anon_sym_get] = ACTIONS(2388),
    [anon_sym_set] = ACTIONS(2388),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_override] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(2388),
    [anon_sym_any] = ACTIONS(2388),
    [anon_sym_number] = ACTIONS(2388),
    [anon_sym_boolean] = ACTIONS(2388),
    [anon_sym_string] = ACTIONS(2388),
    [anon_sym_symbol] = ACTIONS(2388),
    [anon_sym_abstract] = ACTIONS(2388),
    [anon_sym_interface] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_identifier] = ACTIONS(1430),
    [anon_sym_export] = ACTIONS(1430),
    [anon_sym_default] = ACTIONS(1430),
    [anon_sym_type] = ACTIONS(1430),
    [anon_sym_namespace] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_typeof] = ACTIONS(1430),
    [anon_sym_import] = ACTIONS(1430),
    [anon_sym_var] = ACTIONS(1430),
    [anon_sym_let] = ACTIONS(1430),
    [anon_sym_const] = ACTIONS(1430),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_else] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1430),
    [anon_sym_for] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_await] = ACTIONS(1430),
    [anon_sym_while] = ACTIONS(1430),
    [anon_sym_do] = ACTIONS(1430),
    [anon_sym_try] = ACTIONS(1430),
    [anon_sym_with] = ACTIONS(1430),
    [anon_sym_break] = ACTIONS(1430),
    [anon_sym_continue] = ACTIONS(1430),
    [anon_sym_debugger] = ACTIONS(1430),
    [anon_sym_return] = ACTIONS(1430),
    [anon_sym_throw] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_case] = ACTIONS(1430),
    [anon_sym_yield] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1430),
    [anon_sym_class] = ACTIONS(1430),
    [anon_sym_async] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1430),
    [anon_sym_new] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_void] = ACTIONS(1430),
    [anon_sym_delete] = ACTIONS(1430),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [sym_number] = ACTIONS(1428),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(1430),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_null] = ACTIONS(1430),
    [sym_undefined] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_get] = ACTIONS(1430),
    [anon_sym_set] = ACTIONS(1430),
    [anon_sym_declare] = ACTIONS(1430),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_override] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1430),
    [anon_sym_any] = ACTIONS(1430),
    [anon_sym_number] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1430),
    [anon_sym_symbol] = ACTIONS(1430),
    [anon_sym_abstract] = ACTIONS(1430),
    [anon_sym_interface] = ACTIONS(1430),
    [anon_sym_enum] = ACTIONS(1430),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2392),
    [anon_sym_export] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_typeof] = ACTIONS(2392),
    [anon_sym_import] = ACTIONS(2392),
    [anon_sym_var] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_with] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_debugger] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_function] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_void] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2390),
    [sym_number] = ACTIONS(2390),
    [sym_this] = ACTIONS(2392),
    [sym_super] = ACTIONS(2392),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [sym_null] = ACTIONS(2392),
    [sym_undefined] = ACTIONS(2392),
    [anon_sym_AT] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_readonly] = ACTIONS(2392),
    [anon_sym_get] = ACTIONS(2392),
    [anon_sym_set] = ACTIONS(2392),
    [anon_sym_declare] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_override] = ACTIONS(2392),
    [anon_sym_module] = ACTIONS(2392),
    [anon_sym_any] = ACTIONS(2392),
    [anon_sym_number] = ACTIONS(2392),
    [anon_sym_boolean] = ACTIONS(2392),
    [anon_sym_string] = ACTIONS(2392),
    [anon_sym_symbol] = ACTIONS(2392),
    [anon_sym_abstract] = ACTIONS(2392),
    [anon_sym_interface] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_export] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_import] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_with] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_debugger] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_function] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_void] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [sym_number] = ACTIONS(2394),
    [sym_this] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [sym_null] = ACTIONS(2396),
    [sym_undefined] = ACTIONS(2396),
    [anon_sym_AT] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_readonly] = ACTIONS(2396),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_declare] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_override] = ACTIONS(2396),
    [anon_sym_module] = ACTIONS(2396),
    [anon_sym_any] = ACTIONS(2396),
    [anon_sym_number] = ACTIONS(2396),
    [anon_sym_boolean] = ACTIONS(2396),
    [anon_sym_string] = ACTIONS(2396),
    [anon_sym_symbol] = ACTIONS(2396),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_export] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_typeof] = ACTIONS(2400),
    [anon_sym_import] = ACTIONS(2400),
    [anon_sym_var] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_with] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_debugger] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_void] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym_number] = ACTIONS(2398),
    [sym_this] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [sym_null] = ACTIONS(2400),
    [sym_undefined] = ACTIONS(2400),
    [anon_sym_AT] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_readonly] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2400),
    [anon_sym_set] = ACTIONS(2400),
    [anon_sym_declare] = ACTIONS(2400),
    [anon_sym_public] = ACTIONS(2400),
    [anon_sym_private] = ACTIONS(2400),
    [anon_sym_protected] = ACTIONS(2400),
    [anon_sym_override] = ACTIONS(2400),
    [anon_sym_module] = ACTIONS(2400),
    [anon_sym_any] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2400),
    [anon_sym_string] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_await] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_with] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_debugger] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_yield] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [sym_number] = ACTIONS(2402),
    [sym_this] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [sym_null] = ACTIONS(2404),
    [sym_undefined] = ACTIONS(2404),
    [anon_sym_AT] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_readonly] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2404),
    [anon_sym_set] = ACTIONS(2404),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_override] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_export] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_namespace] = ACTIONS(2120),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_typeof] = ACTIONS(2120),
    [anon_sym_import] = ACTIONS(2120),
    [anon_sym_var] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_else] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_switch] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_await] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_do] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [anon_sym_with] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_debugger] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_throw] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_case] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_SLASH] = ACTIONS(2120),
    [anon_sym_class] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_function] = ACTIONS(2120),
    [anon_sym_new] = ACTIONS(2120),
    [anon_sym_PLUS] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2120),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_void] = ACTIONS(2120),
    [anon_sym_delete] = ACTIONS(2120),
    [anon_sym_PLUS_PLUS] = ACTIONS(2118),
    [anon_sym_DASH_DASH] = ACTIONS(2118),
    [anon_sym_DQUOTE] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2118),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_undefined] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_readonly] = ACTIONS(2120),
    [anon_sym_get] = ACTIONS(2120),
    [anon_sym_set] = ACTIONS(2120),
    [anon_sym_declare] = ACTIONS(2120),
    [anon_sym_public] = ACTIONS(2120),
    [anon_sym_private] = ACTIONS(2120),
    [anon_sym_protected] = ACTIONS(2120),
    [anon_sym_override] = ACTIONS(2120),
    [anon_sym_module] = ACTIONS(2120),
    [anon_sym_any] = ACTIONS(2120),
    [anon_sym_number] = ACTIONS(2120),
    [anon_sym_boolean] = ACTIONS(2120),
    [anon_sym_string] = ACTIONS(2120),
    [anon_sym_symbol] = ACTIONS(2120),
    [anon_sym_abstract] = ACTIONS(2120),
    [anon_sym_interface] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2408),
    [anon_sym_export] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2408),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_namespace] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2408),
    [anon_sym_import] = ACTIONS(2408),
    [anon_sym_var] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_const] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_switch] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_await] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_do] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [anon_sym_with] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_debugger] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_throw] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_case] = ACTIONS(2408),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2408),
    [anon_sym_class] = ACTIONS(2408),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_function] = ACTIONS(2408),
    [anon_sym_new] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_void] = ACTIONS(2408),
    [anon_sym_delete] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [sym_number] = ACTIONS(2406),
    [sym_this] = ACTIONS(2408),
    [sym_super] = ACTIONS(2408),
    [sym_true] = ACTIONS(2408),
    [sym_false] = ACTIONS(2408),
    [sym_null] = ACTIONS(2408),
    [sym_undefined] = ACTIONS(2408),
    [anon_sym_AT] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2408),
    [anon_sym_readonly] = ACTIONS(2408),
    [anon_sym_get] = ACTIONS(2408),
    [anon_sym_set] = ACTIONS(2408),
    [anon_sym_declare] = ACTIONS(2408),
    [anon_sym_public] = ACTIONS(2408),
    [anon_sym_private] = ACTIONS(2408),
    [anon_sym_protected] = ACTIONS(2408),
    [anon_sym_override] = ACTIONS(2408),
    [anon_sym_module] = ACTIONS(2408),
    [anon_sym_any] = ACTIONS(2408),
    [anon_sym_number] = ACTIONS(2408),
    [anon_sym_boolean] = ACTIONS(2408),
    [anon_sym_string] = ACTIONS(2408),
    [anon_sym_symbol] = ACTIONS(2408),
    [anon_sym_abstract] = ACTIONS(2408),
    [anon_sym_interface] = ACTIONS(2408),
    [anon_sym_enum] = ACTIONS(2408),
  },
  [761] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3440),
    [sym_optional_tuple_parameter] = STATE(3440),
    [sym_optional_type] = STATE(3440),
    [sym_rest_type] = STATE(3440),
    [sym__tuple_type_member] = STATE(3440),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [762] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3572),
    [sym_optional_tuple_parameter] = STATE(3572),
    [sym_optional_type] = STATE(3572),
    [sym_rest_type] = STATE(3572),
    [sym__tuple_type_member] = STATE(3572),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [763] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3514),
    [sym_optional_tuple_parameter] = STATE(3514),
    [sym_optional_type] = STATE(3514),
    [sym_rest_type] = STATE(3514),
    [sym__tuple_type_member] = STATE(3514),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [764] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3386),
    [sym_optional_tuple_parameter] = STATE(3386),
    [sym_optional_type] = STATE(3386),
    [sym_rest_type] = STATE(3386),
    [sym__tuple_type_member] = STATE(3386),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [765] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3363),
    [sym_optional_tuple_parameter] = STATE(3363),
    [sym_optional_type] = STATE(3363),
    [sym_rest_type] = STATE(3363),
    [sym__tuple_type_member] = STATE(3363),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [766] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [767] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [768] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [769] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [770] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [771] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [772] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [773] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [774] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [775] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [776] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [778] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [779] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [780] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [781] = {
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_export] = ACTIONS(2462),
    [anon_sym_type] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_typeof] = ACTIONS(2462),
    [anon_sym_import] = ACTIONS(2462),
    [anon_sym_var] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_await] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_debugger] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_void] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym_number] = ACTIONS(2464),
    [sym_this] = ACTIONS(2462),
    [sym_super] = ACTIONS(2462),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [sym_null] = ACTIONS(2462),
    [sym_undefined] = ACTIONS(2462),
    [anon_sym_AT] = ACTIONS(2464),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_readonly] = ACTIONS(2462),
    [anon_sym_get] = ACTIONS(2462),
    [anon_sym_set] = ACTIONS(2462),
    [anon_sym_declare] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_override] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(2462),
    [anon_sym_any] = ACTIONS(2462),
    [anon_sym_number] = ACTIONS(2462),
    [anon_sym_boolean] = ACTIONS(2462),
    [anon_sym_string] = ACTIONS(2462),
    [anon_sym_symbol] = ACTIONS(2462),
    [anon_sym_abstract] = ACTIONS(2462),
    [anon_sym_interface] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
  },
  [782] = {
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_export] = ACTIONS(2466),
    [anon_sym_type] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_typeof] = ACTIONS(2466),
    [anon_sym_import] = ACTIONS(2466),
    [anon_sym_var] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_await] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_debugger] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_void] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [sym_number] = ACTIONS(2468),
    [sym_this] = ACTIONS(2466),
    [sym_super] = ACTIONS(2466),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [sym_null] = ACTIONS(2466),
    [sym_undefined] = ACTIONS(2466),
    [anon_sym_AT] = ACTIONS(2468),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_readonly] = ACTIONS(2466),
    [anon_sym_get] = ACTIONS(2466),
    [anon_sym_set] = ACTIONS(2466),
    [anon_sym_declare] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_override] = ACTIONS(2466),
    [anon_sym_module] = ACTIONS(2466),
    [anon_sym_any] = ACTIONS(2466),
    [anon_sym_number] = ACTIONS(2466),
    [anon_sym_boolean] = ACTIONS(2466),
    [anon_sym_string] = ACTIONS(2466),
    [anon_sym_symbol] = ACTIONS(2466),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_interface] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
  },
  [783] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_export] = ACTIONS(2470),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_import] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_debugger] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_void] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [sym_number] = ACTIONS(2472),
    [sym_this] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [sym_null] = ACTIONS(2470),
    [sym_undefined] = ACTIONS(2470),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_readonly] = ACTIONS(2470),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_override] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2470),
    [anon_sym_any] = ACTIONS(2470),
    [anon_sym_number] = ACTIONS(2470),
    [anon_sym_boolean] = ACTIONS(2470),
    [anon_sym_string] = ACTIONS(2470),
    [anon_sym_symbol] = ACTIONS(2470),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_interface] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_export] = ACTIONS(2474),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_import] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_debugger] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym_number] = ACTIONS(2476),
    [sym_this] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [sym_null] = ACTIONS(2474),
    [sym_undefined] = ACTIONS(2474),
    [anon_sym_AT] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_readonly] = ACTIONS(2474),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_declare] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_override] = ACTIONS(2474),
    [anon_sym_module] = ACTIONS(2474),
    [anon_sym_any] = ACTIONS(2474),
    [anon_sym_number] = ACTIONS(2474),
    [anon_sym_boolean] = ACTIONS(2474),
    [anon_sym_string] = ACTIONS(2474),
    [anon_sym_symbol] = ACTIONS(2474),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_interface] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
  },
  [786] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_rest_pattern] = STATE(3727),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2848),
    [sym_tuple_parameter] = STATE(3678),
    [sym_optional_tuple_parameter] = STATE(3678),
    [sym_optional_type] = STATE(3678),
    [sym_rest_type] = STATE(3678),
    [sym__tuple_type_member] = STATE(3678),
    [sym_constructor_type] = STATE(2848),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2848),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2848),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2848),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_export] = ACTIONS(2478),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_import] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_with] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_debugger] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_function] = ACTIONS(2478),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_void] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym_number] = ACTIONS(2480),
    [sym_this] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_true] = ACTIONS(2478),
    [sym_false] = ACTIONS(2478),
    [sym_null] = ACTIONS(2478),
    [sym_undefined] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_readonly] = ACTIONS(2478),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_declare] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_override] = ACTIONS(2478),
    [anon_sym_module] = ACTIONS(2478),
    [anon_sym_any] = ACTIONS(2478),
    [anon_sym_number] = ACTIONS(2478),
    [anon_sym_boolean] = ACTIONS(2478),
    [anon_sym_string] = ACTIONS(2478),
    [anon_sym_symbol] = ACTIONS(2478),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
  },
  [788] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_COLON] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_EQ_GT] = ACTIONS(2484),
    [anon_sym_QMARK_DOT] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_extends] = ACTIONS(2482),
  },
  [791] = {
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2486),
    [anon_sym_EQ] = ACTIONS(2486),
    [anon_sym_namespace] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_typeof] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_await] = ACTIONS(2486),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_class] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_EQ_GT] = ACTIONS(2488),
    [anon_sym_QMARK_DOT] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2486),
    [anon_sym_delete] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2488),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2488),
    [sym_number] = ACTIONS(2488),
    [sym_this] = ACTIONS(2486),
    [sym_super] = ACTIONS(2486),
    [sym_true] = ACTIONS(2486),
    [sym_false] = ACTIONS(2486),
    [sym_null] = ACTIONS(2486),
    [sym_undefined] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_readonly] = ACTIONS(2486),
    [anon_sym_get] = ACTIONS(2486),
    [anon_sym_set] = ACTIONS(2486),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_declare] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2486),
    [anon_sym_private] = ACTIONS(2486),
    [anon_sym_protected] = ACTIONS(2486),
    [anon_sym_override] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_any] = ACTIONS(2486),
    [anon_sym_number] = ACTIONS(2486),
    [anon_sym_boolean] = ACTIONS(2486),
    [anon_sym_string] = ACTIONS(2486),
    [anon_sym_symbol] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_extends] = ACTIONS(2486),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_typeof] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_await] = ACTIONS(2490),
    [anon_sym_COLON] = ACTIONS(2492),
    [anon_sym_yield] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_GT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2490),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(2492),
    [anon_sym_QMARK_DOT] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [sym_number] = ACTIONS(2492),
    [sym_this] = ACTIONS(2490),
    [sym_super] = ACTIONS(2490),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [sym_null] = ACTIONS(2490),
    [sym_undefined] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_readonly] = ACTIONS(2490),
    [anon_sym_get] = ACTIONS(2490),
    [anon_sym_set] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_declare] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_override] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_any] = ACTIONS(2490),
    [anon_sym_number] = ACTIONS(2490),
    [anon_sym_boolean] = ACTIONS(2490),
    [anon_sym_string] = ACTIONS(2490),
    [anon_sym_symbol] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_extends] = ACTIONS(2490),
  },
  [793] = {
    [sym_nested_identifier] = STATE(591),
    [sym_string] = STATE(596),
    [sym__module] = STATE(699),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [794] = {
    [sym_nested_identifier] = STATE(591),
    [sym_string] = STATE(596),
    [sym__module] = STATE(699),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [795] = {
    [sym_nested_identifier] = STATE(115),
    [sym_string] = STATE(114),
    [sym__module] = STATE(133),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [796] = {
    [sym_nested_identifier] = STATE(591),
    [sym_string] = STATE(596),
    [sym__module] = STATE(699),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [797] = {
    [sym_nested_identifier] = STATE(115),
    [sym_string] = STATE(114),
    [sym__module] = STATE(133),
    [aux_sym_object_repeat1] = STATE(3402),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [798] = {
    [sym_nested_identifier] = STATE(115),
    [sym_string] = STATE(114),
    [sym__module] = STATE(133),
    [aux_sym_object_repeat1] = STATE(3584),
    [aux_sym_object_pattern_repeat1] = STATE(3403),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(151),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [799] = {
    [sym_nested_identifier] = STATE(3912),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4106),
    [sym_nested_type_identifier] = STATE(2531),
    [sym__type] = STATE(2693),
    [sym_constructor_type] = STATE(2693),
    [sym__primary_type] = STATE(2618),
    [sym_template_literal_type] = STATE(2626),
    [sym_infer_type] = STATE(2693),
    [sym_conditional_type] = STATE(2626),
    [sym_generic_type] = STATE(2626),
    [sym_type_predicate] = STATE(3179),
    [sym_type_query] = STATE(2626),
    [sym_index_type_query] = STATE(2626),
    [sym_lookup_type] = STATE(2626),
    [sym_literal_type] = STATE(2626),
    [sym__number] = STATE(2629),
    [sym_existential_type] = STATE(2626),
    [sym_flow_maybe_type] = STATE(2626),
    [sym_parenthesized_type] = STATE(2626),
    [sym_predefined_type] = STATE(2626),
    [sym_object_type] = STATE(2626),
    [sym_type_parameters] = STATE(3779),
    [sym_array_type] = STATE(2626),
    [sym_tuple_type] = STATE(2626),
    [sym_readonly_type] = STATE(2693),
    [sym_union_type] = STATE(2626),
    [sym_intersection_type] = STATE(2626),
    [sym_function_type] = STATE(2693),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_typeof] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2528),
    [sym_number] = ACTIONS(2530),
    [sym_this] = ACTIONS(2532),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_readonly] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_asserts] = ACTIONS(2540),
    [anon_sym_infer] = ACTIONS(2542),
    [anon_sym_keyof] = ACTIONS(2544),
    [anon_sym_unknown] = ACTIONS(2522),
    [anon_sym_never] = ACTIONS(2522),
    [anon_sym_object] = ACTIONS(2522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2546),
  },
  [800] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2601),
    [sym_constructor_type] = STATE(2601),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2601),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_predicate] = STATE(3795),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2601),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2601),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(2550),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_asserts] = ACTIONS(2552),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [801] = {
    [sym_nested_identifier] = STATE(3933),
    [sym_string] = STATE(2571),
    [sym_formal_parameters] = STATE(3908),
    [sym_nested_type_identifier] = STATE(2451),
    [sym__type] = STATE(2585),
    [sym_constructor_type] = STATE(2585),
    [sym__primary_type] = STATE(2535),
    [sym_template_literal_type] = STATE(2532),
    [sym_infer_type] = STATE(2585),
    [sym_conditional_type] = STATE(2532),
    [sym_generic_type] = STATE(2532),
    [sym_type_predicate] = STATE(2850),
    [sym_type_query] = STATE(2532),
    [sym_index_type_query] = STATE(2532),
    [sym_lookup_type] = STATE(2532),
    [sym_literal_type] = STATE(2532),
    [sym__number] = STATE(2522),
    [sym_existential_type] = STATE(2532),
    [sym_flow_maybe_type] = STATE(2532),
    [sym_parenthesized_type] = STATE(2532),
    [sym_predefined_type] = STATE(2532),
    [sym_object_type] = STATE(2532),
    [sym_type_parameters] = STATE(3741),
    [sym_array_type] = STATE(2532),
    [sym_tuple_type] = STATE(2532),
    [sym_readonly_type] = STATE(2585),
    [sym_union_type] = STATE(2532),
    [sym_intersection_type] = STATE(2532),
    [sym_function_type] = STATE(2585),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(2558),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_asserts] = ACTIONS(2560),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [802] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_type] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_namespace] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_typeof] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_await] = ACTIONS(2562),
    [anon_sym_COLON] = ACTIONS(2564),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_RBRACK] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_GT] = ACTIONS(2564),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2564),
    [anon_sym_void] = ACTIONS(2562),
    [anon_sym_delete] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [sym_number] = ACTIONS(2564),
    [sym_this] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_null] = ACTIONS(2562),
    [sym_undefined] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2562),
    [anon_sym_readonly] = ACTIONS(2562),
    [anon_sym_get] = ACTIONS(2562),
    [anon_sym_set] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2564),
    [anon_sym_declare] = ACTIONS(2562),
    [anon_sym_public] = ACTIONS(2562),
    [anon_sym_private] = ACTIONS(2562),
    [anon_sym_protected] = ACTIONS(2562),
    [anon_sym_override] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_any] = ACTIONS(2562),
    [anon_sym_number] = ACTIONS(2562),
    [anon_sym_boolean] = ACTIONS(2562),
    [anon_sym_string] = ACTIONS(2562),
    [anon_sym_symbol] = ACTIONS(2562),
    [anon_sym_extends] = ACTIONS(2562),
    [anon_sym_implements] = ACTIONS(2562),
  },
  [803] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_readonly] = ACTIONS(2594),
    [anon_sym_get] = ACTIONS(2596),
    [anon_sym_set] = ACTIONS(2596),
    [anon_sym_declare] = ACTIONS(2566),
    [anon_sym_public] = ACTIONS(2598),
    [anon_sym_private] = ACTIONS(2598),
    [anon_sym_protected] = ACTIONS(2598),
    [anon_sym_override] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_any] = ACTIONS(2566),
    [anon_sym_number] = ACTIONS(2566),
    [anon_sym_boolean] = ACTIONS(2566),
    [anon_sym_string] = ACTIONS(2566),
    [anon_sym_symbol] = ACTIONS(2566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [804] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2610),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_readonly] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2616),
    [anon_sym_set] = ACTIONS(2616),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_override] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [805] = {
    [sym_nested_identifier] = STATE(1232),
    [sym_string] = STATE(1231),
    [sym__module] = STATE(1328),
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(204),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(609),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [806] = {
    [sym_nested_identifier] = STATE(4026),
    [sym_string] = STATE(1600),
    [sym_formal_parameters] = STATE(3897),
    [sym_nested_type_identifier] = STATE(1415),
    [sym__type] = STATE(1629),
    [sym_constructor_type] = STATE(1629),
    [sym__primary_type] = STATE(1584),
    [sym_template_literal_type] = STATE(1583),
    [sym_infer_type] = STATE(1629),
    [sym_conditional_type] = STATE(1583),
    [sym_generic_type] = STATE(1583),
    [sym_type_predicate] = STATE(1628),
    [sym_type_query] = STATE(1583),
    [sym_index_type_query] = STATE(1583),
    [sym_lookup_type] = STATE(1583),
    [sym_literal_type] = STATE(1583),
    [sym__number] = STATE(1582),
    [sym_existential_type] = STATE(1583),
    [sym_flow_maybe_type] = STATE(1583),
    [sym_parenthesized_type] = STATE(1583),
    [sym_predefined_type] = STATE(1583),
    [sym_object_type] = STATE(1583),
    [sym_type_parameters] = STATE(3673),
    [sym_array_type] = STATE(1583),
    [sym_tuple_type] = STATE(1583),
    [sym_readonly_type] = STATE(1629),
    [sym_union_type] = STATE(1583),
    [sym_intersection_type] = STATE(1583),
    [sym_function_type] = STATE(1629),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_LBRACE] = ACTIONS(2628),
    [anon_sym_typeof] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_void] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2650),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [sym_null] = ACTIONS(2652),
    [sym_undefined] = ACTIONS(2652),
    [anon_sym_readonly] = ACTIONS(2654),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_any] = ACTIONS(2644),
    [anon_sym_number] = ACTIONS(2644),
    [anon_sym_boolean] = ACTIONS(2644),
    [anon_sym_string] = ACTIONS(2644),
    [anon_sym_symbol] = ACTIONS(2644),
    [anon_sym_infer] = ACTIONS(2658),
    [anon_sym_keyof] = ACTIONS(2660),
    [anon_sym_unknown] = ACTIONS(2644),
    [anon_sym_never] = ACTIONS(2644),
    [anon_sym_object] = ACTIONS(2644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2662),
  },
  [807] = {
    [sym_export_statement] = STATE(2861),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2861),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2861),
    [sym_property_signature] = STATE(2861),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2861),
    [sym_index_signature] = STATE(2861),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2668),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_override] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2686),
  },
  [808] = {
    [sym_nested_identifier] = STATE(1232),
    [sym_string] = STATE(1231),
    [sym__module] = STATE(1328),
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(1958),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [809] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2610),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_readonly] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2616),
    [anon_sym_set] = ACTIONS(2616),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_override] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [810] = {
    [sym_nested_identifier] = STATE(3854),
    [sym_string] = STATE(1221),
    [sym_formal_parameters] = STATE(3907),
    [sym_nested_type_identifier] = STATE(1197),
    [sym__type] = STATE(1223),
    [sym_constructor_type] = STATE(1223),
    [sym__primary_type] = STATE(1204),
    [sym_template_literal_type] = STATE(1207),
    [sym_infer_type] = STATE(1223),
    [sym_conditional_type] = STATE(1207),
    [sym_generic_type] = STATE(1207),
    [sym_type_predicate] = STATE(1224),
    [sym_type_query] = STATE(1207),
    [sym_index_type_query] = STATE(1207),
    [sym_lookup_type] = STATE(1207),
    [sym_literal_type] = STATE(1207),
    [sym__number] = STATE(1208),
    [sym_existential_type] = STATE(1207),
    [sym_flow_maybe_type] = STATE(1207),
    [sym_parenthesized_type] = STATE(1207),
    [sym_predefined_type] = STATE(1207),
    [sym_object_type] = STATE(1207),
    [sym_type_parameters] = STATE(3839),
    [sym_array_type] = STATE(1207),
    [sym_tuple_type] = STATE(1207),
    [sym_readonly_type] = STATE(1223),
    [sym_union_type] = STATE(1207),
    [sym_intersection_type] = STATE(1207),
    [sym_function_type] = STATE(1223),
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_STAR] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_typeof] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE] = ACTIONS(2706),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_void] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [sym_number] = ACTIONS(2714),
    [sym_this] = ACTIONS(2716),
    [sym_true] = ACTIONS(2718),
    [sym_false] = ACTIONS(2718),
    [sym_null] = ACTIONS(2718),
    [sym_undefined] = ACTIONS(2718),
    [anon_sym_readonly] = ACTIONS(2720),
    [anon_sym_QMARK] = ACTIONS(2722),
    [anon_sym_any] = ACTIONS(2710),
    [anon_sym_number] = ACTIONS(2710),
    [anon_sym_boolean] = ACTIONS(2710),
    [anon_sym_string] = ACTIONS(2710),
    [anon_sym_symbol] = ACTIONS(2710),
    [anon_sym_infer] = ACTIONS(2724),
    [anon_sym_keyof] = ACTIONS(2726),
    [anon_sym_unknown] = ACTIONS(2710),
    [anon_sym_never] = ACTIONS(2710),
    [anon_sym_object] = ACTIONS(2710),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2728),
  },
  [811] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_override] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [812] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3368),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3368),
    [sym_pair] = STATE(3368),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3369),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2730),
    [anon_sym_namespace] = ACTIONS(2730),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2738),
    [anon_sym_readonly] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
    [anon_sym_declare] = ACTIONS(2730),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_override] = ACTIONS(2746),
    [anon_sym_module] = ACTIONS(2730),
    [anon_sym_any] = ACTIONS(2730),
    [anon_sym_number] = ACTIONS(2730),
    [anon_sym_boolean] = ACTIONS(2730),
    [anon_sym_string] = ACTIONS(2730),
    [anon_sym_symbol] = ACTIONS(2730),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [813] = {
    [sym_nested_identifier] = STATE(3854),
    [sym_string] = STATE(1221),
    [sym_formal_parameters] = STATE(3907),
    [sym_nested_type_identifier] = STATE(1197),
    [sym__type] = STATE(1280),
    [sym_constructor_type] = STATE(1280),
    [sym__primary_type] = STATE(1204),
    [sym_template_literal_type] = STATE(1207),
    [sym_infer_type] = STATE(1280),
    [sym_conditional_type] = STATE(1207),
    [sym_generic_type] = STATE(1207),
    [sym_type_predicate] = STATE(1274),
    [sym_type_query] = STATE(1207),
    [sym_index_type_query] = STATE(1207),
    [sym_lookup_type] = STATE(1207),
    [sym_literal_type] = STATE(1207),
    [sym__number] = STATE(1208),
    [sym_existential_type] = STATE(1207),
    [sym_flow_maybe_type] = STATE(1207),
    [sym_parenthesized_type] = STATE(1207),
    [sym_predefined_type] = STATE(1207),
    [sym_object_type] = STATE(1207),
    [sym_type_parameters] = STATE(3839),
    [sym_array_type] = STATE(1207),
    [sym_tuple_type] = STATE(1207),
    [sym_readonly_type] = STATE(1280),
    [sym_union_type] = STATE(1207),
    [sym_intersection_type] = STATE(1207),
    [sym_function_type] = STATE(1280),
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_STAR] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_typeof] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PIPE] = ACTIONS(2706),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_void] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [sym_number] = ACTIONS(2714),
    [sym_this] = ACTIONS(2716),
    [sym_true] = ACTIONS(2718),
    [sym_false] = ACTIONS(2718),
    [sym_null] = ACTIONS(2718),
    [sym_undefined] = ACTIONS(2718),
    [anon_sym_readonly] = ACTIONS(2720),
    [anon_sym_QMARK] = ACTIONS(2722),
    [anon_sym_any] = ACTIONS(2710),
    [anon_sym_number] = ACTIONS(2710),
    [anon_sym_boolean] = ACTIONS(2710),
    [anon_sym_string] = ACTIONS(2710),
    [anon_sym_symbol] = ACTIONS(2710),
    [anon_sym_infer] = ACTIONS(2724),
    [anon_sym_keyof] = ACTIONS(2726),
    [anon_sym_unknown] = ACTIONS(2710),
    [anon_sym_never] = ACTIONS(2710),
    [anon_sym_object] = ACTIONS(2710),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2728),
  },
  [814] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [815] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_override] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [816] = {
    [sym_nested_identifier] = STATE(3933),
    [sym_string] = STATE(2571),
    [sym_formal_parameters] = STATE(3908),
    [sym_nested_type_identifier] = STATE(2451),
    [sym__type] = STATE(2557),
    [sym_constructor_type] = STATE(2557),
    [sym__primary_type] = STATE(2535),
    [sym_template_literal_type] = STATE(2532),
    [sym_infer_type] = STATE(2557),
    [sym_conditional_type] = STATE(2532),
    [sym_generic_type] = STATE(2532),
    [sym_type_predicate] = STATE(2556),
    [sym_type_query] = STATE(2532),
    [sym_index_type_query] = STATE(2532),
    [sym_lookup_type] = STATE(2532),
    [sym_literal_type] = STATE(2532),
    [sym__number] = STATE(2522),
    [sym_existential_type] = STATE(2532),
    [sym_flow_maybe_type] = STATE(2532),
    [sym_parenthesized_type] = STATE(2532),
    [sym_predefined_type] = STATE(2532),
    [sym_object_type] = STATE(2532),
    [sym_type_parameters] = STATE(3741),
    [sym_array_type] = STATE(2532),
    [sym_tuple_type] = STATE(2532),
    [sym_readonly_type] = STATE(2557),
    [sym_union_type] = STATE(2532),
    [sym_intersection_type] = STATE(2532),
    [sym_function_type] = STATE(2557),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(2558),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [817] = {
    [sym_nested_identifier] = STATE(3912),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4106),
    [sym_nested_type_identifier] = STATE(2531),
    [sym__type] = STATE(2612),
    [sym_constructor_type] = STATE(2612),
    [sym__primary_type] = STATE(2618),
    [sym_template_literal_type] = STATE(2626),
    [sym_infer_type] = STATE(2612),
    [sym_conditional_type] = STATE(2626),
    [sym_generic_type] = STATE(2626),
    [sym_type_predicate] = STATE(2613),
    [sym_type_query] = STATE(2626),
    [sym_index_type_query] = STATE(2626),
    [sym_lookup_type] = STATE(2626),
    [sym_literal_type] = STATE(2626),
    [sym__number] = STATE(2629),
    [sym_existential_type] = STATE(2626),
    [sym_flow_maybe_type] = STATE(2626),
    [sym_parenthesized_type] = STATE(2626),
    [sym_predefined_type] = STATE(2626),
    [sym_object_type] = STATE(2626),
    [sym_type_parameters] = STATE(3779),
    [sym_array_type] = STATE(2626),
    [sym_tuple_type] = STATE(2626),
    [sym_readonly_type] = STATE(2612),
    [sym_union_type] = STATE(2626),
    [sym_intersection_type] = STATE(2626),
    [sym_function_type] = STATE(2612),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_typeof] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2528),
    [sym_number] = ACTIONS(2530),
    [sym_this] = ACTIONS(2532),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_readonly] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_infer] = ACTIONS(2542),
    [anon_sym_keyof] = ACTIONS(2544),
    [anon_sym_unknown] = ACTIONS(2522),
    [anon_sym_never] = ACTIONS(2522),
    [anon_sym_object] = ACTIONS(2522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2546),
  },
  [818] = {
    [sym_nested_identifier] = STATE(1232),
    [sym_string] = STATE(1231),
    [sym__module] = STATE(1328),
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(149),
    [anon_sym_QMARK_DOT] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(155),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(155),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_DASH_DASH] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_SQUOTE] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(609),
    [sym__ternary_qmark] = ACTIONS(151),
  },
  [819] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3280),
    [sym_constructor_type] = STATE(3280),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3280),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3280),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3280),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [820] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2377),
    [sym_constructor_type] = STATE(2377),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2377),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_predicate] = STATE(2342),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2377),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2377),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(2550),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [821] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [822] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4027),
    [sym_nested_type_identifier] = STATE(2700),
    [sym__type] = STATE(2929),
    [sym_constructor_type] = STATE(2929),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2929),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_predicate] = STATE(2318),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2929),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2929),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2762),
    [anon_sym_AMP] = ACTIONS(2764),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(2772),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(2778),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2780),
  },
  [823] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3291),
    [sym_constructor_type] = STATE(3291),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3291),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3291),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3291),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [824] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [825] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2958),
    [sym_constructor_type] = STATE(2958),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2958),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_type_parameter] = STATE(3389),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2958),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2958),
    [sym_identifier] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [826] = {
    [sym_nested_identifier] = STATE(3933),
    [sym_string] = STATE(2571),
    [sym_formal_parameters] = STATE(3908),
    [sym_nested_type_identifier] = STATE(2451),
    [sym__type] = STATE(2541),
    [sym_constructor_type] = STATE(2541),
    [sym__primary_type] = STATE(2535),
    [sym_template_literal_type] = STATE(2532),
    [sym_infer_type] = STATE(2541),
    [sym_conditional_type] = STATE(2532),
    [sym_generic_type] = STATE(2532),
    [sym_type_predicate] = STATE(2543),
    [sym_type_query] = STATE(2532),
    [sym_index_type_query] = STATE(2532),
    [sym_lookup_type] = STATE(2532),
    [sym_literal_type] = STATE(2532),
    [sym__number] = STATE(2522),
    [sym_existential_type] = STATE(2532),
    [sym_flow_maybe_type] = STATE(2532),
    [sym_parenthesized_type] = STATE(2532),
    [sym_predefined_type] = STATE(2532),
    [sym_object_type] = STATE(2532),
    [sym_type_parameters] = STATE(3741),
    [sym_array_type] = STATE(2532),
    [sym_tuple_type] = STATE(2532),
    [sym_readonly_type] = STATE(2541),
    [sym_union_type] = STATE(2532),
    [sym_intersection_type] = STATE(2532),
    [sym_function_type] = STATE(2541),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(2558),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [827] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3329),
    [sym_constructor_type] = STATE(3329),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3329),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3329),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3329),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2788),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [828] = {
    [sym_nested_identifier] = STATE(3912),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4106),
    [sym_nested_type_identifier] = STATE(2531),
    [sym__type] = STATE(2635),
    [sym_constructor_type] = STATE(2635),
    [sym__primary_type] = STATE(2618),
    [sym_template_literal_type] = STATE(2626),
    [sym_infer_type] = STATE(2635),
    [sym_conditional_type] = STATE(2626),
    [sym_generic_type] = STATE(2626),
    [sym_type_predicate] = STATE(2636),
    [sym_type_query] = STATE(2626),
    [sym_index_type_query] = STATE(2626),
    [sym_lookup_type] = STATE(2626),
    [sym_literal_type] = STATE(2626),
    [sym__number] = STATE(2629),
    [sym_existential_type] = STATE(2626),
    [sym_flow_maybe_type] = STATE(2626),
    [sym_parenthesized_type] = STATE(2626),
    [sym_predefined_type] = STATE(2626),
    [sym_object_type] = STATE(2626),
    [sym_type_parameters] = STATE(3779),
    [sym_array_type] = STATE(2626),
    [sym_tuple_type] = STATE(2626),
    [sym_readonly_type] = STATE(2635),
    [sym_union_type] = STATE(2626),
    [sym_intersection_type] = STATE(2626),
    [sym_function_type] = STATE(2635),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_typeof] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2528),
    [sym_number] = ACTIONS(2530),
    [sym_this] = ACTIONS(2532),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_readonly] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_infer] = ACTIONS(2542),
    [anon_sym_keyof] = ACTIONS(2544),
    [anon_sym_unknown] = ACTIONS(2522),
    [anon_sym_never] = ACTIONS(2522),
    [anon_sym_object] = ACTIONS(2522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2546),
  },
  [829] = {
    [sym_nested_identifier] = STATE(4026),
    [sym_string] = STATE(1600),
    [sym_formal_parameters] = STATE(3897),
    [sym_nested_type_identifier] = STATE(1415),
    [sym__type] = STATE(1509),
    [sym_constructor_type] = STATE(1509),
    [sym__primary_type] = STATE(1584),
    [sym_template_literal_type] = STATE(1583),
    [sym_infer_type] = STATE(1509),
    [sym_conditional_type] = STATE(1583),
    [sym_generic_type] = STATE(1583),
    [sym_type_predicate] = STATE(1512),
    [sym_type_query] = STATE(1583),
    [sym_index_type_query] = STATE(1583),
    [sym_lookup_type] = STATE(1583),
    [sym_literal_type] = STATE(1583),
    [sym__number] = STATE(1582),
    [sym_existential_type] = STATE(1583),
    [sym_flow_maybe_type] = STATE(1583),
    [sym_parenthesized_type] = STATE(1583),
    [sym_predefined_type] = STATE(1583),
    [sym_object_type] = STATE(1583),
    [sym_type_parameters] = STATE(3673),
    [sym_array_type] = STATE(1583),
    [sym_tuple_type] = STATE(1583),
    [sym_readonly_type] = STATE(1509),
    [sym_union_type] = STATE(1583),
    [sym_intersection_type] = STATE(1583),
    [sym_function_type] = STATE(1509),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_LBRACE] = ACTIONS(2628),
    [anon_sym_typeof] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_void] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2650),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [sym_null] = ACTIONS(2652),
    [sym_undefined] = ACTIONS(2652),
    [anon_sym_readonly] = ACTIONS(2654),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_any] = ACTIONS(2644),
    [anon_sym_number] = ACTIONS(2644),
    [anon_sym_boolean] = ACTIONS(2644),
    [anon_sym_string] = ACTIONS(2644),
    [anon_sym_symbol] = ACTIONS(2644),
    [anon_sym_infer] = ACTIONS(2658),
    [anon_sym_keyof] = ACTIONS(2660),
    [anon_sym_unknown] = ACTIONS(2644),
    [anon_sym_never] = ACTIONS(2644),
    [anon_sym_object] = ACTIONS(2644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2662),
  },
  [830] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_readonly] = ACTIONS(2594),
    [anon_sym_get] = ACTIONS(2596),
    [anon_sym_set] = ACTIONS(2596),
    [anon_sym_declare] = ACTIONS(2566),
    [anon_sym_public] = ACTIONS(2598),
    [anon_sym_private] = ACTIONS(2598),
    [anon_sym_protected] = ACTIONS(2598),
    [anon_sym_override] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_any] = ACTIONS(2566),
    [anon_sym_number] = ACTIONS(2566),
    [anon_sym_boolean] = ACTIONS(2566),
    [anon_sym_string] = ACTIONS(2566),
    [anon_sym_symbol] = ACTIONS(2566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [831] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3249),
    [sym_constructor_type] = STATE(3249),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3249),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3249),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3249),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2792),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [832] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [833] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_readonly] = ACTIONS(2594),
    [anon_sym_get] = ACTIONS(2596),
    [anon_sym_set] = ACTIONS(2596),
    [anon_sym_declare] = ACTIONS(2566),
    [anon_sym_public] = ACTIONS(2598),
    [anon_sym_private] = ACTIONS(2598),
    [anon_sym_protected] = ACTIONS(2598),
    [anon_sym_override] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_any] = ACTIONS(2566),
    [anon_sym_number] = ACTIONS(2566),
    [anon_sym_boolean] = ACTIONS(2566),
    [anon_sym_string] = ACTIONS(2566),
    [anon_sym_symbol] = ACTIONS(2566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [834] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3368),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3368),
    [sym_pair] = STATE(3368),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3369),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2730),
    [anon_sym_namespace] = ACTIONS(2730),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2738),
    [anon_sym_readonly] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
    [anon_sym_declare] = ACTIONS(2730),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_override] = ACTIONS(2746),
    [anon_sym_module] = ACTIONS(2730),
    [anon_sym_any] = ACTIONS(2730),
    [anon_sym_number] = ACTIONS(2730),
    [anon_sym_boolean] = ACTIONS(2730),
    [anon_sym_string] = ACTIONS(2730),
    [anon_sym_symbol] = ACTIONS(2730),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [835] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2802),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2806),
    [anon_sym_readonly] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2810),
    [anon_sym_set] = ACTIONS(2810),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_override] = ACTIONS(2814),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [836] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [837] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4027),
    [sym_nested_type_identifier] = STATE(2700),
    [sym__type] = STATE(2966),
    [sym_constructor_type] = STATE(2966),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2966),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_predicate] = STATE(2342),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2966),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2966),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2762),
    [anon_sym_AMP] = ACTIONS(2764),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(2772),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(2778),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2780),
  },
  [838] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2818),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [839] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2820),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [840] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2822),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [841] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2427),
    [sym_constructor_type] = STATE(2427),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2427),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_predicate] = STATE(2318),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2427),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2427),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(2550),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [842] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(3346),
    [sym_constructor_type] = STATE(3346),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(3346),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(3346),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(3346),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [843] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [844] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2828),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [845] = {
    [sym_export_statement] = STATE(2822),
    [sym_object_pattern] = STATE(4012),
    [sym_object_assignment_pattern] = STATE(3366),
    [sym_array_pattern] = STATE(4012),
    [sym__call_signature] = STATE(2998),
    [sym__destructuring_pattern] = STATE(4012),
    [sym_spread_element] = STATE(3448),
    [sym_string] = STATE(2454),
    [sym_decorator] = STATE(1129),
    [sym_formal_parameters] = STATE(2590),
    [sym_rest_pattern] = STATE(3366),
    [sym_method_definition] = STATE(3448),
    [sym_pair] = STATE(3448),
    [sym_pair_pattern] = STATE(3366),
    [sym__property_name] = STATE(2454),
    [sym_computed_property_name] = STATE(2454),
    [sym_method_signature] = STATE(2822),
    [sym_accessibility_modifier] = STATE(2206),
    [sym_override_modifier] = STATE(2215),
    [sym_call_signature] = STATE(2822),
    [sym_property_signature] = STATE(2822),
    [sym_type_parameters] = STATE(3777),
    [sym_construct_signature] = STATE(2822),
    [sym_index_signature] = STATE(2822),
    [aux_sym_export_statement_repeat1] = STATE(3270),
    [aux_sym_object_repeat1] = STATE(3462),
    [aux_sym_object_pattern_repeat1] = STATE(3371),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2590),
    [sym_private_property_identifier] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_override] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
  },
  [846] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [847] = {
    [sym_nested_identifier] = STATE(4065),
    [sym_string] = STATE(2312),
    [sym_formal_parameters] = STATE(4064),
    [sym_nested_type_identifier] = STATE(2306),
    [sym__type] = STATE(2968),
    [sym_constructor_type] = STATE(2968),
    [sym__primary_type] = STATE(2323),
    [sym_template_literal_type] = STATE(2322),
    [sym_infer_type] = STATE(2968),
    [sym_conditional_type] = STATE(2322),
    [sym_generic_type] = STATE(2322),
    [sym_type_query] = STATE(2322),
    [sym_index_type_query] = STATE(2322),
    [sym_lookup_type] = STATE(2322),
    [sym_literal_type] = STATE(2322),
    [sym__number] = STATE(2346),
    [sym_existential_type] = STATE(2322),
    [sym_flow_maybe_type] = STATE(2322),
    [sym_parenthesized_type] = STATE(2322),
    [sym_predefined_type] = STATE(2322),
    [sym_object_type] = STATE(2322),
    [sym_type_parameters] = STATE(3643),
    [sym_array_type] = STATE(2322),
    [sym_tuple_type] = STATE(2322),
    [sym_readonly_type] = STATE(2968),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2968),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2834),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(200),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [sym_this] = ACTIONS(1171),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_any] = ACTIONS(200),
    [anon_sym_number] = ACTIONS(200),
    [anon_sym_boolean] = ACTIONS(200),
    [anon_sym_string] = ACTIONS(200),
    [anon_sym_symbol] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(196),
    [anon_sym_keyof] = ACTIONS(198),
    [anon_sym_unknown] = ACTIONS(200),
    [anon_sym_never] = ACTIONS(200),
    [anon_sym_object] = ACTIONS(200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(202),
  },
  [848] = {
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_EQ] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_COMMA] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_typeof] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_LPAREN] = ACTIONS(2838),
    [anon_sym_RPAREN] = ACTIONS(2838),
    [anon_sym_await] = ACTIONS(2836),
    [anon_sym_COLON] = ACTIONS(2838),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_RBRACK] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_GT] = ACTIONS(2838),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_function] = ACTIONS(2836),
    [anon_sym_EQ_GT] = ACTIONS(2838),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_PIPE] = ACTIONS(2838),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2838),
    [sym_number] = ACTIONS(2838),
    [sym_this] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_undefined] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_readonly] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_QMARK] = ACTIONS(2838),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_override] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_extends] = ACTIONS(2836),
    [anon_sym_implements] = ACTIONS(2836),
  },
  [849] = {
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_export] = ACTIONS(2840),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_EQ] = ACTIONS(2840),
    [anon_sym_namespace] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_COMMA] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_typeof] = ACTIONS(2840),
    [anon_sym_import] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [anon_sym_RPAREN] = ACTIONS(2842),
    [anon_sym_await] = ACTIONS(2840),
    [anon_sym_COLON] = ACTIONS(2842),
    [anon_sym_yield] = ACTIONS(2840),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_RBRACK] = ACTIONS(2842),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_GT] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2840),
    [anon_sym_class] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_function] = ACTIONS(2840),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_PIPE] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_void] = ACTIONS(2840),
    [anon_sym_delete] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2842),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_SQUOTE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2842),
    [sym_number] = ACTIONS(2842),
    [sym_this] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [sym_true] = ACTIONS(2840),
    [sym_false] = ACTIONS(2840),
    [sym_null] = ACTIONS(2840),
    [sym_undefined] = ACTIONS(2840),
    [anon_sym_AT] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_readonly] = ACTIONS(2840),
    [anon_sym_get] = ACTIONS(2840),
    [anon_sym_set] = ACTIONS(2840),
    [anon_sym_QMARK] = ACTIONS(2842),
    [anon_sym_declare] = ACTIONS(2840),
    [anon_sym_public] = ACTIONS(2840),
    [anon_sym_private] = ACTIONS(2840),
    [anon_sym_protected] = ACTIONS(2840),
    [anon_sym_override] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2840),
    [anon_sym_any] = ACTIONS(2840),
    [anon_sym_number] = ACTIONS(2840),
    [anon_sym_boolean] = ACTIONS(2840),
    [anon_sym_string] = ACTIONS(2840),
    [anon_sym_symbol] = ACTIONS(2840),
    [anon_sym_extends] = ACTIONS(2840),
    [anon_sym_implements] = ACTIONS(2840),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2396), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [131] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2958), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [262] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1592), 1,
      sym_template_literal_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1593), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 15,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [395] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2956), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [526] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3298), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [657] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3344), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [788] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2320), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [919] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1213), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1050] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2599), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1181] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1542), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1312] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2972), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1443] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2643), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1574] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2631), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1705] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2616), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1836] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1567), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1967] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2615), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2098] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1568), 1,
      sym__primary_type,
    STATE(1582), 1,
      sym__number,
    STATE(1600), 1,
      sym_string,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3554), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2229] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1554), 1,
      sym__primary_type,
    STATE(1582), 1,
      sym__number,
    STATE(1600), 1,
      sym_string,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3554), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2360] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2334), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2491] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2629), 1,
      sym__number,
    STATE(2662), 1,
      sym__primary_type,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3391), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2622] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2629), 1,
      sym__number,
    STATE(2687), 1,
      sym__primary_type,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3391), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2753] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2683), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2884] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2675), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3015] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2908), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3146] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2673), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3277] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1261), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3408] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1270), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3539] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3059), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3670] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2847), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3801] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2876), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3932] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3289), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4063] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2936), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4194] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2373), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4325] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1293), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4456] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1559), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4587] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2348), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4718] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2341), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4849] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2872), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4980] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1563), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5111] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3003), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5242] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2890), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5373] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2967), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5504] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2341), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5635] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [5724] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2829), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5855] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2545), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5986] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2540), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6117] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2378), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6248] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2965), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6379] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3007), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6510] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3245), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6641] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2549), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6772] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2355), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6903] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3246), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7034] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3313), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7165] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3247), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7296] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2348), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7427] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2696), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7558] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3250), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7689] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2564), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3360), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7820] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3027), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7951] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2571), 1,
      sym_string,
    STATE(2573), 1,
      sym__primary_type,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3360), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8082] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2601), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8213] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2695), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8344] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3043), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8475] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2346), 1,
      sym__number,
    STATE(3024), 1,
      sym__primary_type,
    STATE(3288), 1,
      sym_infer_type,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3354), 4,
      sym__type,
      sym_constructor_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8608] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3267), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8739] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2968), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8870] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1560), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9001] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2585), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9132] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2331), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3354), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9263] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2376), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9394] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3326), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9525] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2570), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9656] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2555), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9787] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2553), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9918] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2334), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10049] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2820), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10180] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      anon_sym_typeof,
    ACTIONS(2510), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_LBRACK,
    ACTIONS(2514), 1,
      anon_sym_new,
    ACTIONS(2516), 1,
      anon_sym_AMP,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_SQUOTE,
    ACTIONS(2528), 1,
      anon_sym_BQUOTE,
    ACTIONS(2530), 1,
      sym_number,
    ACTIONS(2536), 1,
      anon_sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_infer,
    ACTIONS(2544), 1,
      anon_sym_keyof,
    ACTIONS(2546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2854), 1,
      sym_identifier,
    ACTIONS(2856), 1,
      sym_this,
    STATE(2531), 1,
      sym_nested_type_identifier,
    STATE(2607), 1,
      sym_string,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2629), 1,
      sym__number,
    STATE(3779), 1,
      sym_type_parameters,
    STATE(3912), 1,
      sym_nested_identifier,
    STATE(4106), 1,
      sym_formal_parameters,
    ACTIONS(2520), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2534), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2656), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2522), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2626), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10311] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3309), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10442] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3086), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10573] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3310), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10704] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1217), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10835] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2528), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10966] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3324), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11097] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3351), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11228] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3325), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11359] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2762), 1,
      anon_sym_new,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2774), 1,
      anon_sym_readonly,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3724), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2819), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11490] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(1269), 1,
      sym__primary_type,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3551), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11621] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(1265), 1,
      sym__primary_type,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3551), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11752] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1562), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11883] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1210), 1,
      sym_template_literal_type,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1205), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 15,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12016] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3327), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12147] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1264), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12278] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1276), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12409] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2524), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12540] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3274), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12671] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2320), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12802] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2325), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3354), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12933] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3011), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13064] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2331), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3585), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13195] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1252), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13326] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_STAR,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_new,
    ACTIONS(2704), 1,
      anon_sym_AMP,
    ACTIONS(2706), 1,
      anon_sym_PIPE,
    ACTIONS(2712), 1,
      anon_sym_BQUOTE,
    ACTIONS(2714), 1,
      sym_number,
    ACTIONS(2720), 1,
      anon_sym_readonly,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_infer,
    ACTIONS(2726), 1,
      anon_sym_keyof,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2850), 1,
      sym_identifier,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1197), 1,
      sym_nested_type_identifier,
    STATE(1204), 1,
      sym__primary_type,
    STATE(1208), 1,
      sym__number,
    STATE(1221), 1,
      sym_string,
    STATE(3839), 1,
      sym_type_parameters,
    STATE(3854), 1,
      sym_nested_identifier,
    STATE(3907), 1,
      sym_formal_parameters,
    ACTIONS(2708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2718), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1251), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2710), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1207), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13457] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1622), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13588] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1531), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13719] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_STAR,
    ACTIONS(2628), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_typeof,
    ACTIONS(2632), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2636), 1,
      anon_sym_new,
    ACTIONS(2638), 1,
      anon_sym_AMP,
    ACTIONS(2640), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 1,
      anon_sym_BQUOTE,
    ACTIONS(2648), 1,
      sym_number,
    ACTIONS(2654), 1,
      anon_sym_readonly,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_infer,
    ACTIONS(2660), 1,
      anon_sym_keyof,
    ACTIONS(2662), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      sym_this,
    STATE(1415), 1,
      sym_nested_type_identifier,
    STATE(1582), 1,
      sym__number,
    STATE(1584), 1,
      sym__primary_type,
    STATE(1600), 1,
      sym_string,
    STATE(3673), 1,
      sym_type_parameters,
    STATE(3897), 1,
      sym_formal_parameters,
    STATE(4026), 1,
      sym_nested_identifier,
    ACTIONS(2642), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2652), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1625), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2644), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1583), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13850] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2758), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 1,
      anon_sym_DQUOTE,
    ACTIONS(2770), 1,
      anon_sym_SQUOTE,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(2778), 1,
      anon_sym_keyof,
    ACTIONS(2780), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2848), 1,
      sym_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2325), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(2700), 1,
      sym_nested_type_identifier,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3585), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13981] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1147), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14070] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2451), 1,
      sym_nested_type_identifier,
    STATE(2522), 1,
      sym__number,
    STATE(2535), 1,
      sym__primary_type,
    STATE(2571), 1,
      sym_string,
    STATE(3741), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym_formal_parameters,
    STATE(3933), 1,
      sym_nested_identifier,
    ACTIONS(2556), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2537), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2532), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14201] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3299), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14332] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(196), 1,
      anon_sym_infer,
    ACTIONS(198), 1,
      anon_sym_keyof,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(535), 1,
      anon_sym_STAR,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(581), 1,
      anon_sym_QMARK,
    ACTIONS(1145), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(1151), 1,
      anon_sym_typeof,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_new,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1169), 1,
      sym_number,
    ACTIONS(1171), 1,
      sym_this,
    ACTIONS(1175), 1,
      anon_sym_readonly,
    ACTIONS(2416), 1,
      anon_sym_LT,
    STATE(2306), 1,
      sym_nested_type_identifier,
    STATE(2312), 1,
      sym_string,
    STATE(2323), 1,
      sym__primary_type,
    STATE(2346), 1,
      sym__number,
    STATE(3643), 1,
      sym_type_parameters,
    STATE(4064), 1,
      sym_formal_parameters,
    STATE(4065), 1,
      sym_nested_identifier,
    ACTIONS(2420), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1173), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3328), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(200), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2322), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14463] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1812), 1,
      anon_sym_COLON,
    ACTIONS(2494), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(596), 1,
      sym_string,
    STATE(699), 1,
      sym__module,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14553] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1812), 1,
      anon_sym_COLON,
    ACTIONS(2858), 1,
      sym_identifier,
    STATE(1194), 1,
      sym_nested_identifier,
    STATE(1196), 1,
      sym_string,
    STATE(1403), 1,
      sym__module,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14643] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(2858), 1,
      sym_identifier,
    STATE(1194), 1,
      sym_nested_identifier,
    STATE(1196), 1,
      sym_string,
    STATE(1403), 1,
      sym__module,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14731] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1808), 1,
      anon_sym_COLON,
    ACTIONS(2496), 1,
      sym_identifier,
    ACTIONS(2498), 1,
      anon_sym_DQUOTE,
    ACTIONS(2500), 1,
      anon_sym_SQUOTE,
    STATE(114), 1,
      sym_string,
    STATE(115), 1,
      sym_nested_identifier,
    STATE(133), 1,
      sym__module,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14821] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(2858), 1,
      sym_identifier,
    STATE(1194), 1,
      sym_nested_identifier,
    STATE(1196), 1,
      sym_string,
    STATE(1403), 1,
      sym__module,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14909] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14997] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1808), 1,
      anon_sym_COLON,
    ACTIONS(2494), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(596), 1,
      sym_string,
    STATE(699), 1,
      sym__module,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15087] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1147), 1,
      anon_sym_EQ,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(1225), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15179] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1968), 1,
      anon_sym_in,
    ACTIONS(1971), 1,
      anon_sym_of,
    ACTIONS(2858), 1,
      sym_identifier,
    STATE(1194), 1,
      sym_nested_identifier,
    STATE(1196), 1,
      sym_string,
    STATE(1403), 1,
      sym__module,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15271] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15359] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1637), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1643), 1,
      anon_sym_LT,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(1738), 1,
      anon_sym_EQ,
    ACTIONS(2860), 1,
      sym_identifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15450] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(1637), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1643), 1,
      anon_sym_LT,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1738), 1,
      anon_sym_EQ,
    ACTIONS(2860), 1,
      sym_identifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15541] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [15628] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [15715] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1637), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1643), 1,
      anon_sym_LT,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1738), 1,
      anon_sym_EQ,
    ACTIONS(2860), 1,
      sym_identifier,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15806] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_RBRACK,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(207), 1,
      anon_sym_COMMA,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1999), 1,
      anon_sym_EQ,
    ACTIONS(2002), 1,
      anon_sym_COLON,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15899] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2570), 1,
      anon_sym_STAR,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2582), 1,
      anon_sym_LBRACK,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(2864), 1,
      anon_sym_export,
    ACTIONS(2869), 1,
      anon_sym_async,
    ACTIONS(2871), 1,
      anon_sym_static,
    ACTIONS(2873), 1,
      anon_sym_readonly,
    ACTIONS(2879), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2206), 1,
      sym_accessibility_modifier,
    STATE(2215), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(2590), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2875), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2877), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2454), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3688), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3689), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(2913), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2862), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2883), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16097] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(2887), 1,
      anon_sym_EQ,
    ACTIONS(2891), 1,
      anon_sym_LPAREN,
    ACTIONS(2894), 1,
      anon_sym_LT,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16185] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2494), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(596), 1,
      sym_string,
    STATE(699), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2903), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16339] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16425] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2570), 1,
      anon_sym_STAR,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2582), 1,
      anon_sym_LBRACK,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(2864), 1,
      anon_sym_export,
    ACTIONS(2869), 1,
      anon_sym_async,
    ACTIONS(2871), 1,
      anon_sym_static,
    ACTIONS(2873), 1,
      anon_sym_readonly,
    ACTIONS(2879), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2206), 1,
      sym_accessibility_modifier,
    STATE(2215), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(2590), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2875), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2877), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2454), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3688), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3689), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(2948), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2862), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2907), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16623] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_RBRACK,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(207), 1,
      anon_sym_COMMA,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1999), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16713] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16799] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(2887), 1,
      anon_sym_EQ,
    ACTIONS(2891), 1,
      anon_sym_LPAREN,
    ACTIONS(2894), 1,
      anon_sym_LT,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16887] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16973] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(2887), 1,
      anon_sym_EQ,
    ACTIONS(2891), 1,
      anon_sym_LPAREN,
    ACTIONS(2894), 1,
      anon_sym_LT,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2911), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [17129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2915), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [17197] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2496), 1,
      sym_identifier,
    ACTIONS(2498), 1,
      anon_sym_DQUOTE,
    ACTIONS(2500), 1,
      anon_sym_SQUOTE,
    STATE(114), 1,
      sym_string,
    STATE(115), 1,
      sym_nested_identifier,
    STATE(133), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17283] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2917), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_nested_identifier,
    STATE(2746), 1,
      sym_string,
    STATE(3165), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17369] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2858), 1,
      sym_identifier,
    STATE(1194), 1,
      sym_nested_identifier,
    STATE(1196), 1,
      sym_string,
    STATE(1403), 1,
      sym__module,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17455] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(2004), 1,
      anon_sym_COLON,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17543] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1637), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1643), 1,
      anon_sym_LT,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(1738), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17631] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1637), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1643), 1,
      anon_sym_LT,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1738), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17719] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(1637), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1643), 1,
      anon_sym_LT,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1738), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17807] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(2002), 1,
      anon_sym_COLON,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2472), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18049] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1280), 1,
      anon_sym_EQ,
    ACTIONS(1282), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18134] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1282), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18219] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18306] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1968), 1,
      anon_sym_in,
    ACTIONS(1971), 1,
      anon_sym_of,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18395] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2956), 1,
      anon_sym_QMARK,
    ACTIONS(2959), 1,
      anon_sym_extends,
    STATE(2308), 1,
      sym_type_arguments,
    STATE(3798), 1,
      sym_type_annotation,
    ACTIONS(2938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2953), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18488] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2961), 1,
      anon_sym_LT,
    ACTIONS(2964), 1,
      anon_sym_DOT,
    STATE(2534), 1,
      sym_type_arguments,
    ACTIONS(2938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2953), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2959), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2480), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18642] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18713] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2969), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_LBRACK,
    ACTIONS(2973), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    STATE(2449), 1,
      sym_arguments,
    ACTIONS(2927), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2921), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2889), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18800] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2944), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18885] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2927), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2921), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18971] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2944), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    ACTIONS(2983), 1,
      anon_sym_QMARK,
    ACTIONS(2979), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19131] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19217] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    ACTIONS(2985), 1,
      anon_sym_EQ,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2944), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19301] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(2989), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19377] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(176), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_string,
    STATE(1232), 1,
      sym_nested_identifier,
    STATE(1328), 1,
      sym__module,
    ACTIONS(151), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [19461] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1147), 1,
      anon_sym_EQ,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(2994), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19539] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2985), 1,
      anon_sym_EQ,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1958), 1,
      anon_sym_QMARK,
    ACTIONS(1228), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19701] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(3000), 1,
      anon_sym_EQ,
    ACTIONS(3005), 1,
      anon_sym_RPAREN,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2953), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3003), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19791] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(609), 1,
      anon_sym_QMARK,
    ACTIONS(120), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19867] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(2938), 1,
      anon_sym_RPAREN,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2953), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2989), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19957] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(204), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(609), 1,
      anon_sym_QMARK,
    ACTIONS(207), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20033] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(3000), 1,
      anon_sym_EQ,
    ACTIONS(3003), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20109] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(2997), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1508), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(2989), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20260] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(2889), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20345] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2953), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(609), 1,
      anon_sym_QMARK,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(120), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1508), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2997), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20511] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2983), 1,
      anon_sym_QMARK,
    ACTIONS(2979), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20584] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20669] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(3000), 1,
      anon_sym_EQ,
    ACTIONS(3003), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20813] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20896] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(2994), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20973] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1812), 1,
      anon_sym_COLON,
    ACTIONS(2860), 1,
      sym_identifier,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [21048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21119] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1808), 1,
      anon_sym_COLON,
    ACTIONS(2860), 1,
      sym_identifier,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [21194] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2953), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3012), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21352] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    ACTIONS(3016), 1,
      anon_sym_EQ,
    ACTIONS(3018), 1,
      anon_sym_EQ_GT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2944), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21435] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_EQ,
    ACTIONS(3022), 1,
      anon_sym_EQ_GT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21518] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1147), 1,
      anon_sym_EQ,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21589] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(2994), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21666] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(204), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(609), 1,
      anon_sym_QMARK,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(207), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1508), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2997), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21747] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3020), 1,
      anon_sym_EQ,
    ACTIONS(3022), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21832] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3016), 1,
      anon_sym_EQ,
    ACTIONS(3018), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21917] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      anon_sym_extends,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2944), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2953), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21999] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 1,
      anon_sym_EQ,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22069] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1510), 1,
      anon_sym_QMARK,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(2997), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1508), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2915), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1812), 1,
      anon_sym_COLON,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 1,
      anon_sym_COLON,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22423] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(3024), 1,
      anon_sym_EQ,
    ACTIONS(3026), 1,
      anon_sym_EQ_GT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2903), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2883), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22701] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22771] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3024), 1,
      anon_sym_EQ,
    ACTIONS(3026), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22855] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_COLON,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23003] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1147), 1,
      anon_sym_EQ,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(2997), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3028), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2911), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23147] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23223] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(2994), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1147), 1,
      anon_sym_EQ,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1225), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23373] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2480), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2472), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23571] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23641] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2927), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2921), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2889), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23725] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1808), 1,
      anon_sym_COLON,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1968), 1,
      anon_sym_in,
    ACTIONS(3032), 1,
      anon_sym_of,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_in,
    ACTIONS(3037), 1,
      anon_sym_of,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2907), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_EQ_GT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24289] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(2997), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1508), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24367] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1147), 1,
      anon_sym_EQ,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(2994), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2997), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24442] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2860), 1,
      sym_identifier,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [24513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    ACTIONS(3039), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_AT,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
    ACTIONS(3044), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3042), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [24653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(3039), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24724] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_RBRACK,
    ACTIONS(207), 1,
      anon_sym_COMMA,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1999), 1,
      anon_sym_EQ,
    ACTIONS(2002), 1,
      anon_sym_COLON,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24799] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_RBRACK,
    ACTIONS(3003), 1,
      anon_sym_COMMA,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3049), 1,
      anon_sym_EQ,
    ACTIONS(3052), 1,
      anon_sym_in,
    ACTIONS(3054), 1,
      anon_sym_COLON,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24876] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2927), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24959] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1280), 1,
      anon_sym_EQ,
    ACTIONS(1282), 1,
      anon_sym_EQ_GT,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_in,
    ACTIONS(3037), 1,
      anon_sym_of,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_DOT,
    STATE(1125), 1,
      sym_arguments,
    ACTIONS(3058), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3056), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [25257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25324] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_EQ,
    ACTIONS(3018), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25393] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACK,
    ACTIONS(2947), 1,
      anon_sym_LT,
    ACTIONS(2950), 1,
      anon_sym_DOT,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2889), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25474] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(3062), 1,
      sym_identifier,
    ACTIONS(151), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [25545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(3018), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25887] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3052), 1,
      anon_sym_in,
    ACTIONS(3054), 1,
      anon_sym_COLON,
    ACTIONS(2889), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(3022), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26297] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3052), 1,
      anon_sym_in,
    ACTIONS(3064), 1,
      anon_sym_COLON,
    ACTIONS(2889), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26369] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym_EQ,
    ACTIONS(3022), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_RBRACK,
    ACTIONS(207), 1,
      anon_sym_COMMA,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1999), 1,
      anon_sym_EQ,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(151), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26577] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_RBRACK,
    ACTIONS(3003), 1,
      anon_sym_COMMA,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3049), 1,
      anon_sym_EQ,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26649] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_AT,
    ACTIONS(3066), 1,
      anon_sym_class,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
    ACTIONS(3044), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3042), 37,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(2002), 1,
      anon_sym_COLON,
    ACTIONS(151), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3069), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [26851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26919] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(2994), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2997), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(151), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26993] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(2004), 1,
      anon_sym_COLON,
    ACTIONS(151), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27063] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    ACTIONS(3034), 1,
      anon_sym_in,
    ACTIONS(3037), 1,
      anon_sym_of,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_EQ,
    ACTIONS(3026), 1,
      anon_sym_EQ_GT,
    ACTIONS(2889), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3073), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [27327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym_EQ,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2889), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1280), 1,
      anon_sym_EQ,
    ACTIONS(1282), 1,
      anon_sym_EQ_GT,
    ACTIONS(151), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3077), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [27589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_RBRACK,
    ACTIONS(3003), 1,
      anon_sym_COMMA,
    ACTIONS(3049), 1,
      anon_sym_EQ,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3056), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [27719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1282), 1,
      anon_sym_EQ_GT,
    ACTIONS(151), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(3026), 1,
      anon_sym_EQ_GT,
    ACTIONS(2889), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27853] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1968), 1,
      anon_sym_in,
    ACTIONS(3032), 1,
      anon_sym_of,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_EQ,
    ACTIONS(2889), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27988] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(151), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28120] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_in,
    ACTIONS(3037), 1,
      anon_sym_of,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    ACTIONS(2889), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2885), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28254] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(2672), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2686), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2861), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28367] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3103), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3105), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2961), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28480] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(2580), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2602), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2822), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28593] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3107), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3109), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2865), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28706] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3111), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3113), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2862), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28819] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3115), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2924), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28932] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3119), 1,
      anon_sym_STAR,
    ACTIONS(3121), 1,
      anon_sym_default,
    ACTIONS(3123), 1,
      anon_sym_type,
    ACTIONS(3125), 1,
      anon_sym_EQ,
    ACTIONS(3127), 1,
      anon_sym_as,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(3137), 1,
      anon_sym_module,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3160), 1,
      sym_declaration,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3340), 1,
      sym_export_clause,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    STATE(3762), 1,
      sym_namespace_import_export,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29050] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3119), 1,
      anon_sym_STAR,
    ACTIONS(3121), 1,
      anon_sym_default,
    ACTIONS(3123), 1,
      anon_sym_type,
    ACTIONS(3125), 1,
      anon_sym_EQ,
    ACTIONS(3127), 1,
      anon_sym_as,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_module,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3160), 1,
      sym_declaration,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3340), 1,
      sym_export_clause,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    STATE(3762), 1,
      sym_namespace_import_export,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29168] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3119), 1,
      anon_sym_STAR,
    ACTIONS(3121), 1,
      anon_sym_default,
    ACTIONS(3123), 1,
      anon_sym_type,
    ACTIONS(3125), 1,
      anon_sym_EQ,
    ACTIONS(3127), 1,
      anon_sym_as,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_module,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3160), 1,
      sym_declaration,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3340), 1,
      sym_export_clause,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    STATE(3762), 1,
      sym_namespace_import_export,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29286] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3119), 1,
      anon_sym_STAR,
    ACTIONS(3121), 1,
      anon_sym_default,
    ACTIONS(3123), 1,
      anon_sym_type,
    ACTIONS(3125), 1,
      anon_sym_EQ,
    ACTIONS(3127), 1,
      anon_sym_as,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_module,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3160), 1,
      sym_declaration,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3340), 1,
      sym_export_clause,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3762), 1,
      sym_namespace_import_export,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29404] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3119), 1,
      anon_sym_STAR,
    ACTIONS(3121), 1,
      anon_sym_default,
    ACTIONS(3123), 1,
      anon_sym_type,
    ACTIONS(3125), 1,
      anon_sym_EQ,
    ACTIONS(3127), 1,
      anon_sym_as,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_module,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3160), 1,
      sym_declaration,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3340), 1,
      sym_export_clause,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    STATE(3762), 1,
      sym_namespace_import_export,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29522] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3151), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29631] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29740] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3155), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29849] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3157), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29958] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3159), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30067] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3161), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30176] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30285] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3165), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30394] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    STATE(3606), 1,
      sym_import_clause,
    STATE(3607), 1,
      sym_string,
    STATE(3609), 1,
      sym_import_require_clause,
    ACTIONS(3171), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4093), 2,
      sym_namespace_import_export,
      sym_named_imports,
    ACTIONS(3173), 14,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3177), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30471] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3179), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30580] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3181), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30689] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3183), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30798] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30907] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3187), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31016] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3189), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31125] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3191), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31234] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3193), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31343] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3195), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31452] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3197), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31561] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3119), 1,
      anon_sym_STAR,
    ACTIONS(3121), 1,
      anon_sym_default,
    ACTIONS(3123), 1,
      anon_sym_type,
    ACTIONS(3127), 1,
      anon_sym_as,
    ACTIONS(3137), 1,
      anon_sym_module,
    ACTIONS(3199), 1,
      anon_sym_EQ,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3160), 1,
      sym_declaration,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3340), 1,
      sym_export_clause,
    STATE(3762), 1,
      sym_namespace_import_export,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [31669] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3119), 1,
      anon_sym_STAR,
    ACTIONS(3121), 1,
      anon_sym_default,
    ACTIONS(3123), 1,
      anon_sym_type,
    ACTIONS(3125), 1,
      anon_sym_EQ,
    ACTIONS(3127), 1,
      anon_sym_as,
    ACTIONS(3137), 1,
      anon_sym_module,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3160), 1,
      sym_declaration,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3340), 1,
      sym_export_clause,
    STATE(3762), 1,
      sym_namespace_import_export,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [31779] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2969), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1332), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [31939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1452), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [31994] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2945), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32099] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2913), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32204] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3062), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32309] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2948), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32414] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2856), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32519] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      anon_sym_new,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3083), 1,
      anon_sym_export,
    ACTIONS(3085), 1,
      anon_sym_STAR,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_async,
    ACTIONS(3093), 1,
      anon_sym_static,
    ACTIONS(3095), 1,
      anon_sym_readonly,
    ACTIONS(3101), 1,
      anon_sym_override,
    STATE(1129), 1,
      sym_decorator,
    STATE(2205), 1,
      sym_accessibility_modifier,
    STATE(2219), 1,
      sym_override_modifier,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3270), 1,
      aux_sym_export_statement_repeat1,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(3091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2854), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32624] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3207), 1,
      anon_sym_RBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3211), 1,
      anon_sym_async,
    ACTIONS(3213), 1,
      anon_sym_static,
    ACTIONS(3215), 1,
      anon_sym_readonly,
    ACTIONS(3221), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3462), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3217), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3219), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3448), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3205), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32722] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3225), 1,
      anon_sym_RBRACE,
    ACTIONS(3227), 1,
      anon_sym_async,
    ACTIONS(3229), 1,
      anon_sym_static,
    ACTIONS(3231), 1,
      anon_sym_readonly,
    ACTIONS(3237), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(3369), 1,
      aux_sym_object_repeat1,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3233), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3235), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3368), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3223), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32820] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(3243), 1,
      anon_sym_async,
    ACTIONS(3245), 1,
      anon_sym_static,
    ACTIONS(3247), 1,
      anon_sym_readonly,
    ACTIONS(3253), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(3369), 1,
      aux_sym_object_repeat1,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3249), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3251), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3368), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3239), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32918] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3257), 1,
      anon_sym_RBRACE,
    ACTIONS(3259), 1,
      anon_sym_async,
    ACTIONS(3261), 1,
      anon_sym_static,
    ACTIONS(3263), 1,
      anon_sym_readonly,
    ACTIONS(3269), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3462), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3265), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3267), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3448), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3255), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33016] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_RBRACE,
    ACTIONS(3275), 1,
      anon_sym_async,
    ACTIONS(3277), 1,
      anon_sym_static,
    ACTIONS(3279), 1,
      anon_sym_readonly,
    ACTIONS(3285), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3462), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3281), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3283), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3448), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3271), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33114] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3289), 1,
      anon_sym_RBRACE,
    ACTIONS(3291), 1,
      anon_sym_async,
    ACTIONS(3293), 1,
      anon_sym_static,
    ACTIONS(3295), 1,
      anon_sym_readonly,
    ACTIONS(3301), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3462), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3297), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3299), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3448), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3287), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33212] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3305), 1,
      anon_sym_RBRACE,
    ACTIONS(3307), 1,
      anon_sym_async,
    ACTIONS(3309), 1,
      anon_sym_static,
    ACTIONS(3311), 1,
      anon_sym_readonly,
    ACTIONS(3317), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3462), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3313), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3315), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3448), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3303), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33310] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_LT,
    ACTIONS(3323), 1,
      anon_sym_DOT,
    ACTIONS(3325), 1,
      anon_sym_is,
    STATE(1263), 1,
      sym_type_arguments,
    ACTIONS(3319), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2959), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33372] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3333), 1,
      anon_sym_LBRACK,
    ACTIONS(3335), 1,
      anon_sym_DOT,
    ACTIONS(3337), 1,
      anon_sym_QMARK_DOT,
    STATE(1240), 1,
      sym_arguments,
    ACTIONS(3327), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3329), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33435] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3343), 1,
      anon_sym_LBRACK,
    ACTIONS(3345), 1,
      anon_sym_DOT,
    ACTIONS(3347), 1,
      anon_sym_QMARK_DOT,
    STATE(1298), 1,
      sym_arguments,
    ACTIONS(3339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3341), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33498] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3349), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_DOT,
    ACTIONS(3353), 1,
      anon_sym_QMARK_DOT,
    STATE(1299), 1,
      sym_arguments,
    ACTIONS(2927), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2921), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33561] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_LT,
    ACTIONS(3323), 1,
      anon_sym_DOT,
    STATE(1263), 1,
      sym_type_arguments,
    ACTIONS(3319), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2959), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_is,
    ACTIONS(3355), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3357), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    ACTIONS(3361), 1,
      anon_sym_DOT,
    STATE(1367), 1,
      sym_statement_block,
    ACTIONS(1298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1296), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [33734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(3363), 1,
      sym__automatic_semicolon,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1367), 1,
      sym_statement_block,
    ACTIONS(1298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1296), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [33848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_LT,
    STATE(1275), 1,
      sym_type_arguments,
    ACTIONS(3365), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3367), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33905] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_LT,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3377), 1,
      anon_sym_QMARK_DOT,
    STATE(1215), 1,
      sym_type_arguments,
    STATE(1387), 1,
      sym_arguments,
    ACTIONS(3369), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3371), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1452), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1332), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1508), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3381), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3389), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3399), 1,
      anon_sym_PIPE,
    ACTIONS(3401), 1,
      anon_sym_extends,
    ACTIONS(3393), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3395), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2488), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3367), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_extends,
    ACTIONS(3393), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3395), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3413), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3413), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    STATE(1382), 1,
      sym_arguments,
    ACTIONS(3419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3421), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3425), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34924] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3399), 1,
      anon_sym_PIPE,
    ACTIONS(3401), 1,
      anon_sym_extends,
    ACTIONS(3427), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3429), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3433), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2484), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3357), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3437), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35246] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3399), 1,
      anon_sym_PIPE,
    ACTIONS(3401), 1,
      anon_sym_extends,
    ACTIONS(3439), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3445), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 1,
      sym__automatic_semicolon,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1942), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3433), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3449), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1311), 1,
      sym_statement_block,
    ACTIONS(1298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1296), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    ACTIONS(3453), 1,
      anon_sym_DOT,
    STATE(1311), 1,
      sym_statement_block,
    ACTIONS(1298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1296), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3457), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1926), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3461), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3457), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3469), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2838), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACK,
    ACTIONS(3481), 1,
      anon_sym_DOT,
    ACTIONS(3483), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3477), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 1,
      sym__automatic_semicolon,
    ACTIONS(1318), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1316), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3461), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3493), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3497), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3505), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3507), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3509), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2842), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1934), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3513), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3517), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37100] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_extends,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3528), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3515), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3533), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3535), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3537), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2492), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3541), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37422] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3399), 1,
      anon_sym_PIPE,
    ACTIONS(3401), 1,
      anon_sym_extends,
    ACTIONS(3543), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3545), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_extends,
    ACTIONS(3391), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3547), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3549), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3553), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(1926), 1,
      anon_sym_extends,
    ACTIONS(3555), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3558), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1288), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [37702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_LBRACK,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3567), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2564), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3571), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3575), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3579), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3583), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1938), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3399), 1,
      anon_sym_PIPE,
    ACTIONS(3401), 1,
      anon_sym_extends,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3575), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_DOT,
    ACTIONS(3593), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3595), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3602), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3606), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3602), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3602), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3425), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3610), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3614), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3614), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3614), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_AMP,
    ACTIONS(3399), 1,
      anon_sym_PIPE,
    ACTIONS(3616), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1930), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39172] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(3626), 1,
      anon_sym_async,
    ACTIONS(3628), 1,
      anon_sym_static,
    ACTIONS(3630), 1,
      anon_sym_readonly,
    ACTIONS(3636), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3632), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3634), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3688), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3689), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3624), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3644), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3648), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1340), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1342), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(1288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1316), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39623] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3658), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [39728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3702), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39779] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3652), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [39884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_EQ,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39937] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3710), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1314), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1312), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3714), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40195] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3377), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3718), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3720), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3722), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3724), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1472), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1404), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1462), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1316), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [40664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1372), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1370), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [40715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3729), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3733), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3173), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3177), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40921] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3739), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_extends,
    ACTIONS(3746), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3749), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3742), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41098] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LT,
    ACTIONS(3754), 1,
      anon_sym_DOT,
    ACTIONS(3756), 1,
      anon_sym_is,
    STATE(1566), 1,
      sym_type_arguments,
    ACTIONS(3319), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2959), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [41157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1384), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [41208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41316] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3772), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41389] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3775), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      sym__automatic_semicolon,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [41547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3779), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3782), 1,
      sym__automatic_semicolon,
    ACTIONS(1318), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1316), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [41655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1380), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1366), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41757] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41862] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3786), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3788), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3786), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3792), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3796), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42120] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [42219] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [42304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1354), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1356), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42355] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3802), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3805), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42479] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3802), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1328), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42601] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3802), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3808), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3810), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1384), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42778] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [42871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3814), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42922] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [43013] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3798), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [43102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43153] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3802), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3822), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43281] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3822), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43386] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3824), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3828), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43542] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [43639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1314), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1312), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [43690] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [43785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3832), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3836), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43887] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3664), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [43948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1372), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1370), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3742), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44101] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3836), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3844), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44257] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3850), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [44324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1346), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44375] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3844), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3853), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3859), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3863), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3865), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3867), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1346), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [44735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3871), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3873), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3875), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3879), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3883), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3887), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44990] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3889), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_extends,
    ACTIONS(3891), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3894), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3901), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3903), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3907), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45356] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1424), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3911), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45641] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3915), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45748] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3911), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [45904] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3919), 1,
      anon_sym_RBRACE,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1477), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [45998] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3941), 1,
      anon_sym_COMMA,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(2704), 1,
      sym_type_arguments,
    STATE(3292), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3939), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46106] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3889), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [46210] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    STATE(2222), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46292] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3911), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [46396] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4041), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3852), 1,
      sym_type_annotation,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46506] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4043), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(3555), 1,
      anon_sym_LBRACK,
    ACTIONS(3558), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4046), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1926), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1288), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46692] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4050), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46762] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LT,
    STATE(1573), 1,
      sym_type_arguments,
    ACTIONS(3365), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3367), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [46896] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_LBRACK,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4053), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3493), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46956] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [47050] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3889), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47154] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3911), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47258] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47328] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [47424] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4050), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47500] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47580] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4096), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4098), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47686] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3989), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [47746] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4100), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1475), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(2989), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47896] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [47984] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [48074] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48168] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48260] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4050), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48334] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48402] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [48486] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [48584] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3786), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [48688] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [48792] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4102), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1502), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [48886] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4096), 1,
      anon_sym_RBRACE,
    ACTIONS(4104), 1,
      anon_sym_COMMA,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3710), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48994] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4096), 1,
      anon_sym_RBRACE,
    ACTIONS(4107), 1,
      anon_sym_COMMA,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3889), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49102] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4110), 1,
      anon_sym_COMMA,
    ACTIONS(4113), 1,
      anon_sym_RBRACE,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3889), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49210] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3658), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [49314] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4115), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [49380] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LT,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(4118), 1,
      anon_sym_QMARK_DOT,
    STATE(1601), 1,
      sym_type_arguments,
    STATE(1821), 1,
      sym_arguments,
    ACTIONS(3369), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3371), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49444] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4096), 1,
      anon_sym_RBRACE,
    ACTIONS(4104), 1,
      anon_sym_COMMA,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4120), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LT,
    ACTIONS(3754), 1,
      anon_sym_DOT,
    STATE(1566), 1,
      sym_type_arguments,
    ACTIONS(3319), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2959), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [49608] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [49704] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49780] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3710), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [49884] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [49972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      anon_sym_is,
    ACTIONS(3355), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3357), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [50024] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3652), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [50128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4122), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50182] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3844), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [50286] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3836), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [50390] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [50480] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [50572] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4061), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [50632] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4124), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50760] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4126), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3979), 1,
      sym_type_annotation,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50870] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50938] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [51022] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [51120] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3786), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51224] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51328] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3775), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [51432] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4128), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_DOT,
    ACTIONS(4132), 1,
      anon_sym_QMARK_DOT,
    STATE(1669), 1,
      sym_arguments,
    ACTIONS(3339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3341), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4134), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4137), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51614] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4139), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51686] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3822), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [51790] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3775), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51894] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4142), 1,
      anon_sym_LBRACK,
    ACTIONS(4144), 1,
      anon_sym_DOT,
    ACTIONS(4146), 1,
      anon_sym_QMARK_DOT,
    STATE(1673), 1,
      sym_arguments,
    ACTIONS(3327), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3329), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51954] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4148), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1477), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52048] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(4067), 1,
      sym_type_annotation,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52158] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_STAR,
    ACTIONS(4158), 1,
      anon_sym_RBRACE,
    ACTIONS(4160), 1,
      anon_sym_LBRACK,
    ACTIONS(4163), 1,
      anon_sym_async,
    ACTIONS(4166), 1,
      anon_sym_DASH,
    ACTIONS(4169), 1,
      anon_sym_DQUOTE,
    ACTIONS(4172), 1,
      anon_sym_SQUOTE,
    ACTIONS(4178), 1,
      anon_sym_AT,
    ACTIONS(4181), 1,
      anon_sym_static,
    ACTIONS(4184), 1,
      anon_sym_readonly,
    ACTIONS(4190), 1,
      anon_sym_declare,
    ACTIONS(4196), 1,
      anon_sym_override,
    ACTIONS(4199), 1,
      anon_sym_abstract,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(4175), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4187), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1477), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4193), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4152), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52252] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4202), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(4090), 1,
      sym_type_annotation,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2983), 1,
      anon_sym_QMARK,
    ACTIONS(2979), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52418] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4204), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [52484] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4207), 1,
      anon_sym_LBRACK,
    ACTIONS(4209), 1,
      anon_sym_DOT,
    ACTIONS(4211), 1,
      anon_sym_QMARK_DOT,
    STATE(1681), 1,
      sym_arguments,
    ACTIONS(2927), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2921), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [52544] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4059), 1,
      anon_sym_GT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    ACTIONS(4215), 1,
      anon_sym_in,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4213), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [52650] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(3000), 1,
      anon_sym_EQ,
    ACTIONS(3003), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52706] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3437), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52764] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3658), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [52868] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4218), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1488), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52962] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_extends,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3528), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53020] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4220), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1477), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53114] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3822), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [53218] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4222), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53290] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3836), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [53394] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3824), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [53498] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4225), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [53602] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    STATE(2222), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53684] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3710), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53788] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3652), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53892] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4227), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1498), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53986] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4229), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1477), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54080] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    STATE(2222), 1,
      sym_override_modifier,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54162] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(1926), 1,
      anon_sym_extends,
    ACTIONS(3555), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3558), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1288), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54220] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3824), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54324] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4231), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1477), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54418] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4061), 1,
      anon_sym_LT,
    ACTIONS(4063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4065), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4067), 1,
      anon_sym_GT_GT,
    ACTIONS(4071), 1,
      anon_sym_AMP,
    ACTIONS(4073), 1,
      anon_sym_CARET,
    ACTIONS(4075), 1,
      anon_sym_PIPE,
    ACTIONS(4079), 1,
      anon_sym_PERCENT,
    ACTIONS(4081), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4089), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4091), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4057), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4059), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4069), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4085), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4087), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4083), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3844), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [54522] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    STATE(2222), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54604] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2588), 1,
      anon_sym_DASH,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3917), 1,
      anon_sym_STAR,
    ACTIONS(3921), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_AT,
    ACTIONS(3927), 1,
      anon_sym_static,
    ACTIONS(3929), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_declare,
    ACTIONS(3935), 1,
      anon_sym_abstract,
    ACTIONS(4233), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_method_definition,
    STATE(2184), 1,
      sym_accessibility_modifier,
    STATE(2214), 1,
      sym_override_modifier,
    STATE(3275), 1,
      sym_method_signature,
    ACTIONS(3923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1404), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2420), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3449), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3081), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54698] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    STATE(2222), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_extends,
    ACTIONS(3439), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54933] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(2989), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3437), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54994] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_extends,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(4246), 1,
      anon_sym_RPAREN,
    ACTIONS(3894), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4241), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4243), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55104] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55159] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4250), 1,
      anon_sym_COMMA,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4252), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55264] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4254), 1,
      anon_sym_LBRACK,
    ACTIONS(4256), 1,
      anon_sym_DOT,
    ACTIONS(4258), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3477), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1942), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3449), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55468] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4260), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3435), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1926), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3571), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3583), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1938), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3602), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3602), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3602), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3614), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3614), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56604] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_PIPE,
    ACTIONS(3616), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56732] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4268), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(3777), 1,
      sym__automatic_semicolon,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2484), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56907] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4270), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3439), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57014] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_extends,
    ACTIONS(3525), 1,
      anon_sym_LBRACK,
    ACTIONS(4053), 1,
      anon_sym_RPAREN,
    ACTIONS(3521), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3779), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57075] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_extends,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(4276), 1,
      anon_sym_RPAREN,
    ACTIONS(3894), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4272), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4274), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57136] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_extends,
    ACTIONS(3525), 1,
      anon_sym_LBRACK,
    ACTIONS(4279), 1,
      anon_sym_RPAREN,
    ACTIONS(3521), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4122), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57197] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57272] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4268), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57345] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_extends,
    ACTIONS(3555), 1,
      anon_sym_LBRACK,
    ACTIONS(4282), 1,
      anon_sym_RPAREN,
    ACTIONS(1290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3558), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1288), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57406] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4285), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [57509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4287), 1,
      anon_sym_LBRACK,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3493), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57609] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_extends,
    ACTIONS(3555), 1,
      anon_sym_LBRACK,
    ACTIONS(4046), 1,
      anon_sym_RPAREN,
    ACTIONS(1290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3558), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3805), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1288), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3515), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2838), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3505), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57870] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4213), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [57973] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_extends,
    ACTIONS(3427), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3429), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(3507), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3509), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3515), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3533), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3541), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_extends,
    ACTIONS(3543), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3545), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_extends,
    ACTIONS(4287), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3547), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3549), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3553), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1930), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3381), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3579), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2564), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3413), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3614), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3413), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym_regex_flags,
    ACTIONS(4289), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4291), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3425), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3433), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3425), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3405), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3367), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4287), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3389), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3433), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59173] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59230] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_extends,
    ACTIONS(3891), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3894), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3457), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59334] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3521), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2488), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59490] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4250), 1,
      anon_sym_COMMA,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3915), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_extends,
    ACTIONS(3393), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3395), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_extends,
    ACTIONS(3393), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3395), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3461), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3457), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3357), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59848] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59923] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(1926), 1,
      anon_sym_extends,
    ACTIONS(1928), 1,
      anon_sym_QMARK,
    ACTIONS(3555), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_COLON,
    ACTIONS(3558), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4046), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1288), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59986] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_QMARK,
    ACTIONS(3493), 1,
      anon_sym_extends,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_LBRACK,
    ACTIONS(4122), 1,
      anon_sym_COLON,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4053), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3437), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    STATE(1781), 1,
      sym_arguments,
    ACTIONS(3419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3421), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60151] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4250), 1,
      anon_sym_COMMA,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4297), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3762), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3437), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(3555), 1,
      anon_sym_LBRACK,
    ACTIONS(1926), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3558), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1288), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60368] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4268), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_LBRACK,
    ACTIONS(3493), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3528), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3461), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3746), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3533), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3742), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3891), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3357), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3497), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1508), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1934), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60902] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3486), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61060] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    ACTIONS(4250), 1,
      anon_sym_COMMA,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4301), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3445), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61271] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4303), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3416), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3513), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(3535), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3537), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61478] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3488), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61585] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(3000), 1,
      anon_sym_EQ,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3437), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3567), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_extends,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(4309), 1,
      anon_sym_RPAREN,
    ACTIONS(3894), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4241), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4307), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2842), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3575), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_AMP,
    ACTIONS(4237), 1,
      anon_sym_PIPE,
    ACTIONS(4239), 1,
      anon_sym_extends,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3575), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_DOT,
    ACTIONS(3593), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3595), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61960] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4312), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3580), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62067] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4314), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [62170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3606), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62268] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3844), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3610), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62420] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4316), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [62487] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4319), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [62558] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3775), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62661] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_extends,
    ACTIONS(3746), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3749), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3742), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62716] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4322), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [62781] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3824), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(1288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3945), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [62994] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4325), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3469), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63101] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3652), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(1294), 1,
      sym__automatic_semicolon,
    ACTIONS(1284), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63259] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3710), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63362] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3658), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3517), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63571] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4327), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3431), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63678] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3889), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63781] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3911), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63884] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(4329), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(3435), 1,
      aux_sym_array_repeat1,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63991] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4331), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [64060] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [64139] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4268), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64212] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64287] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4268), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64360] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(2744), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4334), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [64463] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_EQ,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64589] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [64682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2492), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64731] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [64826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64877] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4331), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [64952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65001] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [65088] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4213), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [65191] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [65280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3469), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65329] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [65420] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4331), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [65493] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4331), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [65560] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [65643] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [65740] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65843] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3784), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3644), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65995] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3822), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66098] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3951), 1,
      anon_sym_GT_GT,
    ACTIONS(3955), 1,
      anon_sym_AMP,
    ACTIONS(3957), 1,
      anon_sym_CARET,
    ACTIONS(3959), 1,
      anon_sym_PIPE,
    ACTIONS(3963), 1,
      anon_sym_PERCENT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3973), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3975), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3937), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3943), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3953), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3961), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3971), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3836), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3967), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66201] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3710), 1,
      anon_sym_COMMA,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_LT,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3999), 1,
      anon_sym_GT_GT,
    ACTIONS(4003), 1,
      anon_sym_AMP,
    ACTIONS(4005), 1,
      anon_sym_CARET,
    ACTIONS(4007), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 1,
      anon_sym_PERCENT,
    ACTIONS(4013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4021), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4025), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3977), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3985), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4001), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4120), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4015), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66356] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3652), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66458] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4372), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66608] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4374), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [66672] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3775), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66774] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4413), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 16,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66844] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [66900] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3658), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67002] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4416), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67068] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67136] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3889), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3796), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1470), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1472), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67336] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3911), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 1,
      sym__automatic_semicolon,
    ACTIONS(1456), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1460), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1462), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67490] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3836), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67592] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3844), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67694] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4421), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 1,
      sym__automatic_semicolon,
    ACTIONS(1456), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1460), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1462), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67850] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    ACTIONS(4423), 1,
      anon_sym_SEMI,
    ACTIONS(4425), 1,
      sym__automatic_semicolon,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67954] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4427), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [68022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1378), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1380), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1364), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1366), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68122] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    ACTIONS(4430), 1,
      anon_sym_SEMI,
    ACTIONS(4432), 1,
      sym__automatic_semicolon,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3808), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3810), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 1,
      sym__automatic_semicolon,
    ACTIONS(1350), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1354), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1356), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68326] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4438), 1,
      anon_sym_static,
    ACTIONS(4440), 1,
      anon_sym_readonly,
    ACTIONS(4442), 1,
      anon_sym_abstract,
    STATE(2193), 1,
      sym_accessibility_modifier,
    STATE(2245), 1,
      sym_override_modifier,
    ACTIONS(4436), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2668), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68398] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3784), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68550] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3786), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4444), 1,
      sym__automatic_semicolon,
    ACTIONS(1336), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1340), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1342), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68704] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 5,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [68800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3173), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3177), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68848] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [68930] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4446), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [68996] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4446), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [69068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1328), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3437), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69176] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [69266] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [69354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69402] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [69488] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4446), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [69562] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [69656] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_QMARK,
    ACTIONS(3533), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3749), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3746), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3742), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69712] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [69804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3515), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69856] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69960] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4241), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4307), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70090] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3824), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70192] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4451), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70296] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4453), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70400] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4446), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70468] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4455), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3814), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70620] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4457), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3901), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3903), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70772] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70876] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3911), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70978] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3889), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_EQ,
    ACTIONS(4124), 1,
      anon_sym_of,
    ACTIONS(4461), 1,
      anon_sym_in,
    ACTIONS(3704), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(4118), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71288] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3775), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4464), 1,
      sym__automatic_semicolon,
    ACTIONS(1418), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1422), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1424), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      sym_regex_flags,
    ACTIONS(4289), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4291), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4468), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4470), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71642] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71710] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4474), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4474), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3792), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4474), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71914] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71992] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [72084] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72152] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [72246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(4137), 1,
      anon_sym_of,
    ACTIONS(4476), 1,
      anon_sym_in,
    ACTIONS(1288), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72348] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3762), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3788), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3786), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(4122), 1,
      anon_sym_of,
    ACTIONS(4479), 1,
      anon_sym_in,
    ACTIONS(3519), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72504] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4427), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [72578] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [72664] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4098), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72766] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_LPAREN,
    ACTIONS(4485), 1,
      anon_sym_COLON,
    ACTIONS(4487), 1,
      anon_sym_LT,
    ACTIONS(4490), 1,
      anon_sym_QMARK,
    ACTIONS(2885), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 1,
      sym__automatic_semicolon,
    ACTIONS(1374), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1378), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1380), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1368), 1,
      sym__automatic_semicolon,
    ACTIONS(1360), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1364), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1366), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72926] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [73014] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3648), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3871), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3863), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73248] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3652), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3853), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73398] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4427), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [73470] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4427), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [73536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      sym_regex_flags,
    ACTIONS(4289), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4291), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3733), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73634] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [73716] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [73812] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3786), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym_EQ,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73970] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3658), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74072] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3784), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74174] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3710), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      sym__automatic_semicolon,
    ACTIONS(1350), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1354), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1356), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3714), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3883), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1344), 1,
      sym__automatic_semicolon,
    ACTIONS(1336), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1340), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1342), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74526] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3822), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(4381), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [74686] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3836), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74788] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3822), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      sym__automatic_semicolon,
    ACTIONS(1322), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1328), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74942] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4492), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [75008] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(3555), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_COLON,
    ACTIONS(3558), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1926), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1288), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75066] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_LBRACK,
    ACTIONS(4122), 1,
      anon_sym_COLON,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3493), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75124] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4495), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [75194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_in,
    ACTIONS(3037), 1,
      anon_sym_of,
    ACTIONS(2885), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75248] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3844), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 1,
      sym__automatic_semicolon,
    ACTIONS(1466), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1470), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1472), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75402] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75506] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3710), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1424), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75704] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 1,
      anon_sym_LPAREN,
    ACTIONS(4503), 1,
      anon_sym_COLON,
    ACTIONS(4505), 1,
      anon_sym_LT,
    ACTIONS(4508), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3722), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3873), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3875), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3844), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3879), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3836), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3828), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76096] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76200] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4512), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76304] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4514), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76408] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3979), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4346), 1,
      anon_sym_GT_GT,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_CARET,
    ACTIONS(4354), 1,
      anon_sym_PIPE,
    ACTIONS(4358), 1,
      anon_sym_PERCENT,
    ACTIONS(4360), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4368), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4370), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(4023), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4338), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4348), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4364), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4366), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4516), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4362), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76510] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4518), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76614] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4520), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [76678] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4523), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3832), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1472), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 1,
      anon_sym_LBRACK,
    ACTIONS(3533), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3749), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3742), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1462), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76980] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4525), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1328), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3907), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1340), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1342), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3887), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77232] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4340), 1,
      anon_sym_LT,
    STATE(3258), 1,
      sym_type_arguments,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [77290] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3824), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77392] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4113), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1354), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1356), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4531), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77594] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4096), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 1,
      sym__automatic_semicolon,
    ACTIONS(1440), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1366), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3865), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3867), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77844] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    STATE(2222), 1,
      sym_override_modifier,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1380), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78016] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4533), 1,
      anon_sym_RPAREN,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1402), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1404), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4531), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3859), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4274), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78378] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78446] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4535), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4537), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3718), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4539), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4541), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3702), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3720), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3722), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4241), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4243), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      sym__automatic_semicolon,
    ACTIONS(1388), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4531), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78904] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_QMARK,
    ACTIONS(3437), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3762), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 1,
      sym__automatic_semicolon,
    ACTIONS(1408), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_LBRACK,
    ACTIONS(3493), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3528), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3911), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79164] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    ACTIONS(4543), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79268] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_extends,
    ACTIONS(3749), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3746), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3742), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      sym__automatic_semicolon,
    ACTIONS(1418), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1422), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1424), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 1,
      sym__automatic_semicolon,
    ACTIONS(1398), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1402), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1404), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(3555), 1,
      anon_sym_LBRACK,
    ACTIONS(1926), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3558), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1288), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4547), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3822), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3729), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(3357), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3894), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79800] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3664), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 1,
      anon_sym_GT_GT,
    ACTIONS(3676), 1,
      anon_sym_AMP,
    ACTIONS(3678), 1,
      anon_sym_CARET,
    ACTIONS(3680), 1,
      anon_sym_PIPE,
    ACTIONS(3684), 1,
      anon_sym_PERCENT,
    ACTIONS(3686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3698), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3654), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3662), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3674), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3682), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3690), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3692), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4549), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3688), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79902] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    ACTIONS(3435), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3437), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1404), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3742), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3515), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80107] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4551), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80208] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3775), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80309] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4589), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80410] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(4557), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [80467] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4591), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [80532] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3652), 1,
      anon_sym_of,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80633] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3710), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80734] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4594), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80835] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80890] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [80971] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4213), 1,
      anon_sym_of,
    ACTIONS(4555), 1,
      anon_sym_GT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    ACTIONS(4596), 1,
      anon_sym_in,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [81123] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [81210] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4599), 1,
      anon_sym_STAR,
    ACTIONS(4601), 1,
      anon_sym_async,
    ACTIONS(4605), 1,
      anon_sym_readonly,
    STATE(2218), 1,
      sym_override_modifier,
    ACTIONS(4603), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4607), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81279] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_STAR,
    ACTIONS(4611), 1,
      anon_sym_async,
    ACTIONS(4615), 1,
      anon_sym_readonly,
    STATE(2227), 1,
      sym_override_modifier,
    ACTIONS(4613), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4617), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2461), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81348] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_EQ,
    ACTIONS(4124), 1,
      anon_sym_COLON,
    ACTIONS(3724), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81401] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4619), 1,
      anon_sym_STAR,
    ACTIONS(4621), 1,
      anon_sym_async,
    ACTIONS(4627), 1,
      anon_sym_abstract,
    ACTIONS(4623), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4625), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2426), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81466] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(2216), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81545] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(4637), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4639), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3366), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81614] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4619), 1,
      anon_sym_STAR,
    ACTIONS(4621), 1,
      anon_sym_async,
    ACTIONS(4641), 1,
      anon_sym_readonly,
    STATE(2223), 1,
      sym_override_modifier,
    ACTIONS(4623), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4625), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2426), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81683] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4643), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81784] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_EQ,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81839] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(1926), 1,
      anon_sym_extends,
    ACTIONS(3555), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3558), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1288), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym_regex_flags,
    ACTIONS(4289), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
    ACTIONS(4291), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81943] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4645), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_extends,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3525), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82067] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4648), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82132] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4591), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82205] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3658), 1,
      anon_sym_of,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82306] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82373] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4268), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82438] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_QMARK,
    ACTIONS(3357), 1,
      anon_sym_extends,
    ACTIONS(3894), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3891), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82493] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3889), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82594] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4651), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [82657] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4654), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82758] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4658), 1,
      anon_sym_async,
    ACTIONS(4662), 1,
      anon_sym_readonly,
    STATE(2224), 1,
      sym_override_modifier,
    ACTIONS(4660), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4664), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2446), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82827] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    STATE(2216), 1,
      sym_override_modifier,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82906] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(4670), 1,
      anon_sym_RBRACE,
    STATE(3468), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4639), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3446), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4668), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82975] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    STATE(2216), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83054] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(2216), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83133] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4674), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 1,
      anon_sym_LBRACK,
    ACTIONS(3533), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3749), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3742), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83287] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    STATE(2216), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83366] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4678), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83467] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4591), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83534] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(3357), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3894), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83587] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3911), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83741] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83818] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [83909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [84002] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(2216), 1,
      sym_override_modifier,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84081] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3844), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84182] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [84271] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4591), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [84342] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3836), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84443] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3822), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84544] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3784), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84645] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3786), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84746] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
  [84841] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4680), 1,
      anon_sym_STAR,
    ACTIONS(4682), 1,
      anon_sym_async,
    ACTIONS(4686), 1,
      anon_sym_readonly,
    STATE(2212), 1,
      sym_override_modifier,
    ACTIONS(4684), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4688), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2407), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84910] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(2216), 1,
      sym_override_modifier,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84989] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    ACTIONS(4680), 1,
      anon_sym_STAR,
    ACTIONS(4682), 1,
      anon_sym_async,
    ACTIONS(4690), 1,
      anon_sym_abstract,
    ACTIONS(4684), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4688), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2407), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85054] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85155] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4694), 1,
      anon_sym_COLON,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85256] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3824), 1,
      anon_sym_of,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4559), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4561), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4567), 1,
      anon_sym_AMP,
    ACTIONS(4569), 1,
      anon_sym_CARET,
    ACTIONS(4571), 1,
      anon_sym_PIPE,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4585), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4587), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_EQ,
    ACTIONS(3039), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85408] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4381), 1,
      anon_sym_LT,
    ACTIONS(4383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4385), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4387), 1,
      anon_sym_GT_GT,
    ACTIONS(4391), 1,
      anon_sym_AMP,
    ACTIONS(4393), 1,
      anon_sym_CARET,
    ACTIONS(4395), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 1,
      anon_sym_PERCENT,
    ACTIONS(4401), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4409), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4411), 1,
      sym__ternary_qmark,
    ACTIONS(4696), 1,
      anon_sym_RBRACK,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4379), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4389), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4397), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4403), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85509] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4557), 1,
      anon_sym_LT,
    ACTIONS(4563), 1,
      anon_sym_GT_GT,
    ACTIONS(4575), 1,
      anon_sym_PERCENT,
    ACTIONS(4577), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4555), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4565), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4583), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4579), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [85594] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4698), 1,
      anon_sym_STAR,
    ACTIONS(4700), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4702), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2899), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85702] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85760] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85818] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85876] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4707), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85994] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4599), 1,
      anon_sym_STAR,
    ACTIONS(4710), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4712), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2927), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86054] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4714), 1,
      anon_sym_STAR,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4718), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86114] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86172] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4680), 1,
      anon_sym_STAR,
    ACTIONS(4720), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4722), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2926), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_RBRACK,
    ACTIONS(3003), 1,
      anon_sym_COMMA,
    ACTIONS(3049), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86356] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 1,
      sym_identifier,
    ACTIONS(3173), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3177), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86522] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86594] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4726), 1,
      anon_sym_STAR,
    ACTIONS(4728), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4730), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2892), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86654] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86712] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86770] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86828] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86886] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86958] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4619), 1,
      anon_sym_STAR,
    ACTIONS(4732), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4734), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2868), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87018] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4619), 1,
      anon_sym_STAR,
    ACTIONS(4621), 1,
      anon_sym_async,
    ACTIONS(4623), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4625), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2426), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87080] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(3209), 1,
      anon_sym_LBRACK,
    ACTIONS(4639), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4738), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3688), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4012), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4736), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87144] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4740), 1,
      anon_sym_STAR,
    ACTIONS(4742), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4744), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2915), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4746), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4749), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3903), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4755), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87300] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4758), 1,
      anon_sym_STAR,
    ACTIONS(4760), 1,
      anon_sym_async,
    ACTIONS(4762), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4764), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2372), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87362] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4766), 1,
      anon_sym_STAR,
    ACTIONS(4768), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4770), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87422] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4772), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4775), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4778), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4781), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4784), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4787), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(4790), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [87692] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87790] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 1,
      anon_sym_LBRACK,
    ACTIONS(3749), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3533), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3742), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3744), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87842] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87940] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88012] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88082] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4758), 1,
      anon_sym_STAR,
    ACTIONS(4826), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88142] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4830), 1,
      anon_sym_STAR,
    ACTIONS(4832), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4834), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2855), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4830), 1,
      anon_sym_STAR,
    ACTIONS(4836), 1,
      anon_sym_async,
    ACTIONS(4838), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4840), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88264] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88362] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88460] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88532] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4726), 1,
      anon_sym_STAR,
    ACTIONS(4842), 1,
      anon_sym_async,
    ACTIONS(4844), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4846), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2445), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3437), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88646] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3981), 1,
      anon_sym_BANG,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    ACTIONS(3993), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3258), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1861), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88744] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88842] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [88930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1571), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88978] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4714), 1,
      anon_sym_STAR,
    ACTIONS(4848), 1,
      anon_sym_async,
    ACTIONS(4850), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4852), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2448), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4854), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89088] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4860), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [89154] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4658), 1,
      anon_sym_async,
    ACTIONS(4660), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4664), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2446), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89216] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4262), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_STAR,
    ACTIONS(4611), 1,
      anon_sym_async,
    ACTIONS(4613), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4617), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2461), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89278] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_STAR,
    ACTIONS(4863), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4865), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2944), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89338] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4867), 1,
      anon_sym_STAR,
    ACTIONS(4869), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4871), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2873), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89398] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4599), 1,
      anon_sym_STAR,
    ACTIONS(4601), 1,
      anon_sym_async,
    ACTIONS(4603), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4607), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89460] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89520] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4873), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4875), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89580] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_extends,
    ACTIONS(3891), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3894), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89730] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4867), 1,
      anon_sym_STAR,
    ACTIONS(4877), 1,
      anon_sym_async,
    ACTIONS(4879), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4881), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2437), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(3894), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3357), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2885), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89844] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [89920] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90018] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [90108] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90166] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90224] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [90316] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4860), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [90388] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90486] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90558] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [90642] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2885), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90794] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90892] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4883), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3737), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [90956] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4886), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3770), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [91024] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3800), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3798), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [91110] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LPAREN,
    STATE(2449), 1,
      sym_arguments,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91230] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91328] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4889), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3848), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [91390] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91462] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4895), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4898), 1,
      sym_identifier,
    ACTIONS(3173), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3177), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91628] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(3779), 1,
      anon_sym_RBRACK,
    ACTIONS(4122), 1,
      anon_sym_COMMA,
    ACTIONS(3519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_EQ,
    ACTIONS(3724), 1,
      anon_sym_RBRACK,
    ACTIONS(4124), 1,
      anon_sym_COMMA,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91732] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4900), 1,
      anon_sym_STAR,
    ACTIONS(4902), 1,
      anon_sym_async,
    ACTIONS(4904), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2453), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91794] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(1288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91846] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91944] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4900), 1,
      anon_sym_STAR,
    ACTIONS(4908), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4910), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2816), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92004] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92074] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3656), 1,
      anon_sym_as,
    ACTIONS(3660), 1,
      anon_sym_BANG,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4822), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4824), 1,
      sym__ternary_qmark,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92172] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3800), 1,
      anon_sym_BANG,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4804), 1,
      anon_sym_AMP,
    ACTIONS(4806), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_PIPE,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4820), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3798), 3,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92266] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4790), 1,
      anon_sym_LT,
    ACTIONS(4800), 1,
      anon_sym_GT_GT,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4794), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4802), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4810), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4816), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3800), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [92346] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4860), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [92410] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3373), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_DOT,
    ACTIONS(3666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4812), 1,
      anon_sym_PERCENT,
    ACTIONS(4814), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4860), 1,
      anon_sym_LT,
    STATE(3314), 1,
      sym_type_arguments,
    ACTIONS(3696), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4792), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1315), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3800), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3798), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [92480] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4710), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2927), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92535] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4869), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2873), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92590] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92655] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4700), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2899), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92757] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92822] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4826), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_EQ,
    ACTIONS(4122), 1,
      anon_sym_of,
    ACTIONS(4479), 1,
      anon_sym_in,
    ACTIONS(3519), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_EQ,
    ACTIONS(4137), 1,
      anon_sym_of,
    ACTIONS(4476), 1,
      anon_sym_in,
    ACTIONS(1288), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92979] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4908), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2816), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93034] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4873), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93089] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1591), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4916), 1,
      anon_sym_async,
    ACTIONS(4920), 1,
      anon_sym_static,
    ACTIONS(4922), 1,
      anon_sym_readonly,
    ACTIONS(4928), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    ACTIONS(4914), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4918), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4924), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4926), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2794), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3689), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4912), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93166] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4930), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2652), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93221] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4720), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2926), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_in,
    ACTIONS(3037), 1,
      anon_sym_of,
    ACTIONS(2885), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93327] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4742), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2915), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_EQ,
    ACTIONS(2885), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2889), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93429] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93549] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4728), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2892), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93604] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93659] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4768), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93714] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4934), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2676), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93769] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(2216), 1,
      sym_override_modifier,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93840] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4832), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2855), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4863), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2944), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93950] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4732), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2868), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94005] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4939), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2835), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94060] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94125] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94190] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94255] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_EQ,
    ACTIONS(4124), 1,
      anon_sym_of,
    ACTIONS(4461), 1,
      anon_sym_in,
    ACTIONS(3704), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3708), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym_regex_flags,
    ACTIONS(4289), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4291), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94418] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      anon_sym_readonly,
    STATE(2247), 1,
      sym_override_modifier,
    ACTIONS(4934), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2676), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3081), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94478] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4943), 1,
      anon_sym_abstract,
    ACTIONS(4930), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2652), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94534] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94598] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4627), 1,
      anon_sym_abstract,
    ACTIONS(4934), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2676), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94654] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94754] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    STATE(2216), 1,
      sym_override_modifier,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94822] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94884] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4947), 1,
      anon_sym_readonly,
    STATE(2253), 1,
      sym_override_modifier,
    ACTIONS(4930), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2652), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3081), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94944] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4949), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2620), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95107] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95162] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95272] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95327] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95382] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95437] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95553] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95612] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95667] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95722] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95834] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95889] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95944] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4951), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2650), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95997] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96051] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1623), 1,
      anon_sym_namespace,
    ACTIONS(1629), 1,
      anon_sym_import,
    ACTIONS(1631), 1,
      anon_sym_var,
    ACTIONS(1633), 1,
      anon_sym_let,
    ACTIONS(1635), 1,
      anon_sym_const,
    ACTIONS(1646), 1,
      anon_sym_class,
    ACTIONS(1648), 1,
      anon_sym_async,
    ACTIONS(1650), 1,
      anon_sym_function,
    ACTIONS(1654), 1,
      anon_sym_declare,
    ACTIONS(1656), 1,
      anon_sym_module,
    ACTIONS(1658), 1,
      anon_sym_abstract,
    ACTIONS(1660), 1,
      anon_sym_interface,
    ACTIONS(1662), 1,
      anon_sym_enum,
    ACTIONS(1736), 1,
      anon_sym_type,
    ACTIONS(4953), 1,
      anon_sym_default,
    STATE(700), 1,
      sym_declaration,
    STATE(707), 1,
      sym_internal_module,
    STATE(1129), 1,
      sym_decorator,
    STATE(2973), 1,
      aux_sym_export_statement_repeat1,
    STATE(734), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96130] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1896), 1,
      anon_sym_type,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(3137), 1,
      anon_sym_module,
    ACTIONS(4955), 1,
      anon_sym_default,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3178), 1,
      sym_declaration,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96209] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96303] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4957), 1,
      anon_sym_STAR,
    ACTIONS(4959), 1,
      anon_sym_async,
    ACTIONS(4963), 1,
      anon_sym_readonly,
    STATE(2220), 1,
      sym_override_modifier,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4965), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2920), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 1,
      anon_sym_LPAREN,
    ACTIONS(4969), 1,
      anon_sym_DOT,
    STATE(2204), 1,
      sym_arguments,
    ACTIONS(3058), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3056), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96413] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1623), 1,
      anon_sym_namespace,
    ACTIONS(1629), 1,
      anon_sym_import,
    ACTIONS(1631), 1,
      anon_sym_var,
    ACTIONS(1633), 1,
      anon_sym_let,
    ACTIONS(1635), 1,
      anon_sym_const,
    ACTIONS(1646), 1,
      anon_sym_class,
    ACTIONS(1648), 1,
      anon_sym_async,
    ACTIONS(1650), 1,
      anon_sym_function,
    ACTIONS(1654), 1,
      anon_sym_declare,
    ACTIONS(1658), 1,
      anon_sym_abstract,
    ACTIONS(1660), 1,
      anon_sym_interface,
    ACTIONS(1662), 1,
      anon_sym_enum,
    ACTIONS(1736), 1,
      anon_sym_type,
    ACTIONS(1740), 1,
      anon_sym_module,
    ACTIONS(1742), 1,
      anon_sym_global,
    STATE(707), 1,
      sym_internal_module,
    STATE(712), 1,
      sym_declaration,
    STATE(1129), 1,
      sym_decorator,
    STATE(2973), 1,
      aux_sym_export_statement_repeat1,
    STATE(734), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96492] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1623), 1,
      anon_sym_namespace,
    ACTIONS(1629), 1,
      anon_sym_import,
    ACTIONS(1631), 1,
      anon_sym_var,
    ACTIONS(1633), 1,
      anon_sym_let,
    ACTIONS(1635), 1,
      anon_sym_const,
    ACTIONS(1646), 1,
      anon_sym_class,
    ACTIONS(1648), 1,
      anon_sym_async,
    ACTIONS(1650), 1,
      anon_sym_function,
    ACTIONS(1654), 1,
      anon_sym_declare,
    ACTIONS(1656), 1,
      anon_sym_module,
    ACTIONS(1658), 1,
      anon_sym_abstract,
    ACTIONS(1660), 1,
      anon_sym_interface,
    ACTIONS(1662), 1,
      anon_sym_enum,
    ACTIONS(1736), 1,
      anon_sym_type,
    ACTIONS(4971), 1,
      anon_sym_default,
    STATE(700), 1,
      sym_declaration,
    STATE(707), 1,
      sym_internal_module,
    STATE(1129), 1,
      sym_decorator,
    STATE(2973), 1,
      aux_sym_export_statement_repeat1,
    STATE(734), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96571] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1896), 1,
      anon_sym_type,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1900), 1,
      anon_sym_import,
    ACTIONS(1902), 1,
      anon_sym_var,
    ACTIONS(1904), 1,
      anon_sym_let,
    ACTIONS(1906), 1,
      anon_sym_const,
    ACTIONS(1908), 1,
      anon_sym_class,
    ACTIONS(1910), 1,
      anon_sym_async,
    ACTIONS(1912), 1,
      anon_sym_function,
    ACTIONS(1914), 1,
      anon_sym_declare,
    ACTIONS(1916), 1,
      anon_sym_module,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1920), 1,
      anon_sym_global,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    STATE(1129), 1,
      sym_decorator,
    STATE(2992), 1,
      aux_sym_export_statement_repeat1,
    STATE(3161), 1,
      sym_internal_module,
    STATE(3162), 1,
      sym_declaration,
    STATE(3159), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96694] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4973), 1,
      anon_sym_STAR,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4977), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2839), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4979), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4983), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4987), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4991), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4995), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4995), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1318), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1573), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1571), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4999), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4987), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97152] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5003), 1,
      anon_sym_STAR,
    ACTIONS(5005), 1,
      anon_sym_async,
    ACTIONS(5007), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5009), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2909), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5011), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5015), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5019), 1,
      sym__automatic_semicolon,
    ACTIONS(1284), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1286), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4979), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5021), 1,
      anon_sym_EQ_GT,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2920), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97422] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    ACTIONS(5025), 1,
      anon_sym_async,
    ACTIONS(5027), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5029), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2837), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97478] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    ACTIONS(5027), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5029), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2837), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97532] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5003), 1,
      anon_sym_STAR,
    ACTIONS(5007), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5009), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2909), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1372), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97626] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4957), 1,
      anon_sym_STAR,
    ACTIONS(4959), 1,
      anon_sym_async,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4965), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2920), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5031), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5037), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5035), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4991), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5041), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5045), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5049), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4983), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97964] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4957), 1,
      anon_sym_STAR,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4965), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2920), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5053), 1,
      sym__automatic_semicolon,
    ACTIONS(1316), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1318), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5057), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5055), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3069), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_DOT,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5011), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4999), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5061), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5059), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5015), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98300] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5027), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2837), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98349] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4832), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2855), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98398] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4710), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2927), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5063), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98496] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2839), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98545] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4742), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2915), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4908), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2816), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98643] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98692] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4826), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4732), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2868), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5007), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2909), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4700), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2899), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98888] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2920), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98937] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4680), 1,
      anon_sym_STAR,
    ACTIONS(4682), 1,
      anon_sym_async,
    ACTIONS(5065), 1,
      anon_sym_static,
    ACTIONS(5067), 1,
      anon_sym_readonly,
    ACTIONS(5069), 1,
      anon_sym_abstract,
    STATE(2212), 1,
      sym_override_modifier,
    ACTIONS(4684), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4688), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2407), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99000] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4768), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5071), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99098] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4728), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2892), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99147] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5073), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2894), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99245] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4873), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99294] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4869), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2873), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2490), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99381] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(5077), 1,
      anon_sym_static,
    ACTIONS(5079), 1,
      anon_sym_readonly,
    ACTIONS(5081), 1,
      anon_sym_abstract,
    STATE(2247), 1,
      sym_override_modifier,
    ACTIONS(4934), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2676), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99437] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(1894), 1,
      anon_sym_override,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(5083), 1,
      anon_sym_static,
    STATE(2216), 1,
      sym_override_modifier,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99497] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5085), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99597] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2482), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99685] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99735] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5095), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3056), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99823] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5097), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4158), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5099), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3073), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99949] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_STAR,
    ACTIONS(4611), 1,
      anon_sym_async,
    ACTIONS(4615), 1,
      anon_sym_readonly,
    ACTIONS(5101), 1,
      anon_sym_static,
    STATE(2227), 1,
      sym_override_modifier,
    ACTIONS(4613), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4617), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2461), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100009] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3101), 1,
      anon_sym_override,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    ACTIONS(5103), 1,
      anon_sym_static,
    STATE(2222), 1,
      sym_override_modifier,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5105), 1,
      anon_sym_RBRACE,
    STATE(3428), 1,
      sym_enum_assignment,
    ACTIONS(5107), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100119] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5109), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5111), 1,
      anon_sym_RBRACE,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100219] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5113), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      sym_enum_assignment,
    ACTIONS(5115), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2486), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [100307] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4619), 1,
      anon_sym_STAR,
    ACTIONS(4621), 1,
      anon_sym_async,
    ACTIONS(4641), 1,
      anon_sym_readonly,
    ACTIONS(4623), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4625), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2426), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100360] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      anon_sym_readonly,
    ACTIONS(5117), 1,
      anon_sym_STAR,
    ACTIONS(5119), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5121), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2413), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100411] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4680), 1,
      anon_sym_STAR,
    ACTIONS(4682), 1,
      anon_sym_async,
    ACTIONS(4686), 1,
      anon_sym_readonly,
    ACTIONS(4684), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4688), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2407), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100464] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4027), 1,
      anon_sym_STAR,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 1,
      anon_sym_async,
    ACTIONS(4037), 1,
      anon_sym_readonly,
    ACTIONS(4035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2439), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100517] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4957), 1,
      anon_sym_STAR,
    ACTIONS(4959), 1,
      anon_sym_async,
    ACTIONS(4963), 1,
      anon_sym_readonly,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4965), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2920), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    STATE(3658), 1,
      sym_enum_assignment,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100617] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4714), 1,
      anon_sym_STAR,
    ACTIONS(4848), 1,
      anon_sym_async,
    ACTIONS(5123), 1,
      anon_sym_readonly,
    ACTIONS(4850), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4852), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2448), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100670] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_STAR,
    ACTIONS(4611), 1,
      anon_sym_async,
    ACTIONS(4615), 1,
      anon_sym_readonly,
    ACTIONS(4613), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4617), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2461), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5003), 1,
      anon_sym_STAR,
    ACTIONS(5005), 1,
      anon_sym_async,
    ACTIONS(5125), 1,
      anon_sym_readonly,
    ACTIONS(5007), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5009), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2909), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1560), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1558), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100815] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4599), 1,
      anon_sym_STAR,
    ACTIONS(4601), 1,
      anon_sym_async,
    ACTIONS(4605), 1,
      anon_sym_readonly,
    ACTIONS(4603), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4607), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100868] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4758), 1,
      anon_sym_STAR,
    ACTIONS(4760), 1,
      anon_sym_async,
    ACTIONS(5127), 1,
      anon_sym_readonly,
    ACTIONS(4762), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4764), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2372), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100921] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4900), 1,
      anon_sym_STAR,
    ACTIONS(4902), 1,
      anon_sym_async,
    ACTIONS(5129), 1,
      anon_sym_readonly,
    ACTIONS(4904), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2453), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100974] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 1,
      anon_sym_STAR,
    ACTIONS(5135), 1,
      anon_sym_readonly,
    ACTIONS(5133), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5137), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2436), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101025] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(1888), 1,
      anon_sym_async,
    ACTIONS(1890), 1,
      anon_sym_readonly,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101078] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4658), 1,
      anon_sym_async,
    ACTIONS(4662), 1,
      anon_sym_readonly,
    ACTIONS(4660), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4664), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2446), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101131] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4934), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2676), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5027), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2837), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101219] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5071), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4832), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2855), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2897), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4266), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101439] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2920), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101483] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4710), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2927), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4873), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101571] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4728), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2892), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4869), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2873), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101659] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4768), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2889), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101703] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5073), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2894), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101747] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4732), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2868), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4700), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2899), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101835] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4939), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2835), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      anon_sym_readonly,
    ACTIONS(4934), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2676), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101925] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4951), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2650), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101969] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4947), 1,
      anon_sym_readonly,
    ACTIONS(4930), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2652), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102015] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5007), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2909), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102103] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(5063), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102147] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4863), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2944), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102191] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4826), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(5139), 1,
      anon_sym_readonly,
    ACTIONS(4951), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2650), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102281] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4742), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2915), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102325] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(1868), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102369] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2839), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    ACTIONS(4930), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2652), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3081), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4908), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2816), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(4264), 1,
      anon_sym_LBRACK,
    ACTIONS(4720), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2926), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1886), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 1,
      sym_identifier,
    STATE(4092), 1,
      sym_mapped_type_clause,
    ACTIONS(5143), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3409), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3614), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3473), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3473), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3413), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102784] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2927), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2921), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102820] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_DOT,
    ACTIONS(5149), 1,
      anon_sym_QMARK_DOT,
    STATE(2301), 1,
      sym_arguments,
    ACTIONS(3339), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3341), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102856] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5153), 1,
      anon_sym_DOT,
    ACTIONS(5155), 1,
      anon_sym_QMARK_DOT,
    STATE(2299), 1,
      sym_arguments,
    ACTIONS(3327), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3329), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3473), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3497), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3489), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3461), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3457), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3465), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3465), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3461), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3587), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3591), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3591), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3591), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3409), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3465), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3602), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3602), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3413), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3449), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3602), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3457), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3614), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3433), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3614), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_EQ,
    ACTIONS(5157), 1,
      anon_sym_LT,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    ACTIONS(5161), 1,
      anon_sym_is,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3425), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3425), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3433), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3467), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3469), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_EQ,
    ACTIONS(5157), 1,
      anon_sym_LT,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3640), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3644), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LBRACK,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3475), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3477), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 1,
      anon_sym_DOT,
    ACTIONS(3593), 1,
      anon_sym_EQ,
    ACTIONS(3595), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 1,
      anon_sym_PIPE,
    ACTIONS(1452), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 1,
      anon_sym_EQ,
    ACTIONS(5157), 1,
      anon_sym_LT,
    STATE(2315), 1,
      sym_type_arguments,
    ACTIONS(3367), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 1,
      anon_sym_PIPE,
    ACTIONS(1332), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 1,
      anon_sym_EQ,
    ACTIONS(3541), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_EQ,
    ACTIONS(3357), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_EQ,
    ACTIONS(5161), 1,
      anon_sym_is,
    ACTIONS(3357), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_EQ,
    ACTIONS(3571), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5169), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_EQ,
    ACTIONS(3579), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 1,
      anon_sym_EQ,
    ACTIONS(1508), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_EQ,
    ACTIONS(3515), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_EQ,
    ACTIONS(3441), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_EQ,
    ACTIONS(3385), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 1,
      anon_sym_EQ,
    ACTIONS(3417), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 1,
      anon_sym_EQ,
    ACTIONS(3381), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 1,
      anon_sym_EQ,
    ACTIONS(3367), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(5173), 1,
      anon_sym_LBRACK,
    ACTIONS(3389), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104210] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LPAREN,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(5175), 1,
      anon_sym_LBRACK,
    ACTIONS(5177), 1,
      anon_sym_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK_DOT,
    STATE(2460), 1,
      sym_arguments,
    ACTIONS(3341), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_EQ,
    ACTIONS(5173), 1,
      anon_sym_LBRACK,
    ACTIONS(3563), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3608), 1,
      anon_sym_EQ,
    ACTIONS(3610), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      anon_sym_EQ,
    ACTIONS(3622), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_EQ,
    ACTIONS(3553), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104358] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LPAREN,
    ACTIONS(3327), 1,
      anon_sym_PIPE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5185), 1,
      anon_sym_DOT,
    ACTIONS(5187), 1,
      anon_sym_QMARK_DOT,
    STATE(2450), 1,
      sym_arguments,
    ACTIONS(3329), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_EQ,
    ACTIONS(5173), 1,
      anon_sym_LBRACK,
    ACTIONS(3389), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3549), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [104418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_PIPE,
    ACTIONS(2969), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_LBRACK,
    ACTIONS(2973), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    STATE(2449), 1,
      sym_arguments,
    ACTIONS(2921), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3533), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_EQ,
    ACTIONS(3505), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PIPE,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_DOT,
    ACTIONS(5193), 1,
      anon_sym_is,
    STATE(2534), 1,
      sym_type_arguments,
    ACTIONS(2959), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_EQ,
    ACTIONS(3445), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_EQ,
    ACTIONS(3493), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5197), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 1,
      anon_sym_EQ,
    ACTIONS(3513), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_EQ,
    ACTIONS(3567), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_EQ,
    ACTIONS(3575), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5199), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 1,
      anon_sym_EQ,
    ACTIONS(3606), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_EQ,
    ACTIONS(3405), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_EQ,
    ACTIONS(3583), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3413), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104839] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5207), 1,
      sym_number,
    STATE(3864), 1,
      sym_string,
    STATE(3918), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [104869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 1,
      anon_sym_PIPE,
    ACTIONS(3473), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(3618), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [104983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5213), 1,
      sym_number,
    STATE(3971), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105011] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5215), 1,
      sym_number,
    STATE(4002), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5217), 1,
      sym_number,
    STATE(3993), 1,
      sym_predefined_type,
    STATE(4023), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5219), 1,
      sym_number,
    STATE(3981), 1,
      sym_predefined_type,
    STATE(3984), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_PIPE,
    ACTIONS(3587), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 1,
      anon_sym_PIPE,
    ACTIONS(3602), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 1,
      anon_sym_PIPE,
    ACTIONS(3602), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 1,
      anon_sym_PIPE,
    ACTIONS(3602), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 1,
      anon_sym_PIPE,
    ACTIONS(3614), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 1,
      anon_sym_PIPE,
    ACTIONS(3614), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 1,
      anon_sym_PIPE,
    ACTIONS(3614), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5221), 1,
      sym_number,
    STATE(3974), 1,
      sym_predefined_type,
    STATE(3977), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105349] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5223), 1,
      sym_number,
    STATE(3969), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105377] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5229), 1,
      anon_sym_BANG,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5235), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2877), 1,
      sym__call_signature,
    STATE(3119), 1,
      sym_type_annotation,
    STATE(3417), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5227), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3535), 1,
      anon_sym_EQ,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(3537), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [105443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5237), 1,
      sym_number,
    STATE(3964), 1,
      sym_predefined_type,
    STATE(3967), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      sym_number,
    STATE(3983), 1,
      sym_string,
    STATE(3985), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      anon_sym_EQ,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(3509), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [105527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_EQ,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(3575), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [105555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3543), 1,
      anon_sym_EQ,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(3545), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [105583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5243), 1,
      sym_number,
    STATE(3850), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5245), 1,
      sym_number,
    STATE(3867), 1,
      sym_string,
    STATE(3868), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      anon_sym_PIPE,
    ACTIONS(3449), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_PIPE,
    ACTIONS(3465), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_PIPE,
    ACTIONS(3465), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_PIPE,
    ACTIONS(3465), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 1,
      anon_sym_PIPE,
    ACTIONS(3473), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 1,
      anon_sym_PIPE,
    ACTIONS(3409), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 1,
      anon_sym_PIPE,
    ACTIONS(3409), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105795] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5247), 1,
      sym_number,
    STATE(3874), 1,
      sym_string,
    STATE(3876), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5249), 1,
      sym_number,
    STATE(3882), 1,
      sym_string,
    STATE(3883), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105855] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5251), 1,
      sym_number,
    STATE(4147), 1,
      sym_string,
    STATE(4149), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3413), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 1,
      anon_sym_PIPE,
    ACTIONS(3425), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_PIPE,
    ACTIONS(3433), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3423), 1,
      anon_sym_PIPE,
    ACTIONS(3425), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_PIPE,
    ACTIONS(3433), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(3429), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [106023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3457), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 1,
      anon_sym_PIPE,
    ACTIONS(3461), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3457), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 1,
      anon_sym_PIPE,
    ACTIONS(3461), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_PIPE,
    ACTIONS(3489), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 1,
      anon_sym_PIPE,
    ACTIONS(3497), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5253), 1,
      sym_number,
    STATE(4009), 1,
      sym_string,
    STATE(4010), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5255), 1,
      sym_number,
    STATE(3934), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106213] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5257), 1,
      sym_number,
    STATE(4040), 1,
      sym_string,
    STATE(4050), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106243] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5259), 1,
      sym_number,
    STATE(3949), 1,
      sym_string,
    STATE(3976), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106273] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5263), 1,
      anon_sym_BANG,
    ACTIONS(5265), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2867), 1,
      sym__call_signature,
    STATE(3073), 1,
      sym_type_annotation,
    STATE(3543), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5261), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5267), 1,
      sym_number,
    STATE(3994), 1,
      sym_predefined_type,
    STATE(4022), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106345] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5269), 1,
      sym_number,
    STATE(3988), 1,
      sym_string,
    STATE(3990), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106375] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5271), 1,
      sym_number,
    STATE(4019), 1,
      sym_string,
    STATE(4020), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106405] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5273), 1,
      sym_number,
    STATE(3997), 1,
      sym_string,
    STATE(3999), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5275), 1,
      sym_number,
    STATE(4089), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106463] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5279), 1,
      anon_sym_BANG,
    ACTIONS(5281), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3099), 1,
      sym_type_annotation,
    STATE(3562), 1,
      sym__initializer,
    STATE(3563), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5277), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106505] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5283), 1,
      sym_number,
    STATE(4013), 1,
      sym_string,
    STATE(4014), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106535] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5285), 1,
      sym_number,
    STATE(4108), 1,
      sym_string,
    STATE(4111), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_PIPE,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_DOT,
    STATE(2534), 1,
      sym_type_arguments,
    ACTIONS(2959), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106593] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5287), 1,
      sym_number,
    STATE(4008), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106621] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5289), 1,
      sym_number,
    STATE(3961), 1,
      sym_predefined_type,
    STATE(3962), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5291), 1,
      sym_number,
    STATE(4144), 1,
      sym_predefined_type,
    STATE(4148), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106681] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5295), 1,
      anon_sym_BANG,
    ACTIONS(5297), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2941), 1,
      sym__call_signature,
    STATE(3029), 1,
      sym_type_annotation,
    STATE(3504), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5293), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5299), 1,
      sym_number,
    STATE(4044), 1,
      sym_predefined_type,
    STATE(4099), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5301), 1,
      sym_number,
    STATE(4003), 1,
      sym_string,
    STATE(4074), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5303), 1,
      sym_number,
    STATE(3938), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106811] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5305), 1,
      sym_number,
    STATE(3923), 1,
      sym_string,
    STATE(3930), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5307), 1,
      sym_number,
    STATE(3848), 1,
      sym_string,
    STATE(3851), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106871] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5279), 1,
      anon_sym_BANG,
    ACTIONS(5309), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2828), 1,
      sym__call_signature,
    STATE(3099), 1,
      sym_type_annotation,
    STATE(3581), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5277), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_EQ,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(3441), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [106941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5311), 1,
      sym_number,
    STATE(4058), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 1,
      anon_sym_PIPE,
    ACTIONS(3473), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106991] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5313), 1,
      sym_number,
    STATE(3942), 1,
      sym_predefined_type,
    STATE(3953), 1,
      sym_string,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107021] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5315), 1,
      sym_number,
    STATE(4119), 1,
      sym_string,
    STATE(4123), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5317), 1,
      sym_number,
    STATE(4139), 1,
      sym_string,
    STATE(4140), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      sym_number,
    STATE(4104), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107109] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5321), 1,
      sym_number,
    STATE(4124), 1,
      sym_string,
    STATE(4125), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5323), 1,
      sym_number,
    STATE(4145), 1,
      sym_string,
    STATE(4146), 1,
      sym_predefined_type,
    ACTIONS(5205), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107169] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5263), 1,
      anon_sym_BANG,
    ACTIONS(5325), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3073), 1,
      sym_type_annotation,
    STATE(3545), 1,
      sym__call_signature,
    STATE(3546), 1,
      sym__initializer,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5261), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107211] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5329), 1,
      anon_sym_BANG,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2921), 1,
      sym__call_signature,
    STATE(3135), 1,
      sym_type_annotation,
    STATE(3460), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5327), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5335), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2729), 1,
      sym__call_signature,
    STATE(3061), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5333), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5337), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_LBRACK,
    ACTIONS(5341), 1,
      anon_sym_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK_DOT,
    STATE(2546), 1,
      sym_arguments,
    ACTIONS(2921), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_PIPE,
    ACTIONS(2488), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107359] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5337), 1,
      anon_sym_LPAREN,
    ACTIONS(5345), 1,
      anon_sym_LBRACK,
    ACTIONS(5347), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_QMARK_DOT,
    STATE(2521), 1,
      sym_arguments,
    ACTIONS(3329), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107388] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5353), 1,
      anon_sym_DOT,
    ACTIONS(5355), 1,
      anon_sym_is,
    STATE(2679), 1,
      sym_type_arguments,
    ACTIONS(2959), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5337), 1,
      anon_sym_LPAREN,
    ACTIONS(5357), 1,
      anon_sym_LBRACK,
    ACTIONS(5359), 1,
      anon_sym_DOT,
    ACTIONS(5361), 1,
      anon_sym_QMARK_DOT,
    STATE(2544), 1,
      sym_arguments,
    ACTIONS(3341), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107444] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5365), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2783), 1,
      sym__call_signature,
    STATE(3132), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107479] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3092), 1,
      sym__call_signature,
    STATE(3094), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5367), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107514] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5371), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2759), 1,
      sym__call_signature,
    STATE(3094), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5367), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107549] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2800), 1,
      sym__call_signature,
    STATE(3115), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5373), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 1,
      anon_sym_PIPE,
    ACTIONS(3644), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    ACTIONS(3469), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 1,
      anon_sym_PIPE,
    ACTIONS(5189), 1,
      anon_sym_LT,
    STATE(2569), 1,
      sym_type_arguments,
    ACTIONS(3367), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5379), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3017), 1,
      sym__call_signature,
    STATE(3018), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5377), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107686] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5381), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3114), 1,
      sym__call_signature,
    STATE(3115), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5373), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(5385), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2719), 1,
      sym__call_signature,
    STATE(3018), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5377), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107756] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_PIPE,
    ACTIONS(5387), 1,
      anon_sym_LBRACK,
    ACTIONS(5389), 1,
      anon_sym_DOT,
    ACTIONS(5391), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3477), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 1,
      anon_sym_PIPE,
    ACTIONS(2492), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107804] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5393), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3131), 1,
      sym__call_signature,
    STATE(3132), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 1,
      anon_sym_DOT,
    ACTIONS(3593), 1,
      anon_sym_PIPE,
    ACTIONS(3595), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107862] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 1,
      anon_sym_LT,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    ACTIONS(5395), 1,
      anon_sym_EQ,
    ACTIONS(5400), 1,
      anon_sym_COLON,
    ACTIONS(5402), 1,
      anon_sym_extends,
    STATE(2308), 1,
      sym_type_arguments,
    STATE(3273), 1,
      sym_constraint,
    STATE(3750), 1,
      sym_default_type,
    ACTIONS(5397), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(2959), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [107899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_PIPE,
    ACTIONS(3640), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107920] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5405), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3058), 1,
      sym__call_signature,
    STATE(3061), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5333), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107955] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2796), 1,
      sym__call_signature,
    STATE(3113), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5407), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3449), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108239] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2832), 1,
      sym__call_signature,
    STATE(3101), 1,
      sym_type_annotation,
    STATE(3575), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5409), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108275] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2917), 1,
      sym__call_signature,
    STATE(3134), 1,
      sym_type_annotation,
    STATE(3467), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5411), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [108339] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym_type_annotation,
    STATE(3565), 1,
      sym__initializer,
    STATE(3566), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5409), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108375] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3064), 1,
      sym__call_signature,
    STATE(3066), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5413), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [108435] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2730), 1,
      sym__call_signature,
    STATE(3066), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5413), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [108639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108729] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3129), 1,
      sym__call_signature,
    STATE(3130), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5415), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_PIPE,
    ACTIONS(5193), 1,
      anon_sym_is,
    ACTIONS(3357), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108837] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2843), 1,
      sym__call_signature,
    STATE(3152), 1,
      sym_type_annotation,
    STATE(3401), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5417), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3497), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108909] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(5157), 1,
      anon_sym_LT,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    STATE(2308), 1,
      sym_type_arguments,
    STATE(3798), 1,
      sym_type_annotation,
    ACTIONS(2959), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108939] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3112), 1,
      sym__call_signature,
    STATE(3113), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5407), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108971] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2738), 1,
      sym__call_signature,
    STATE(3130), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5415), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [109067] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3143), 1,
      sym__call_signature,
    STATE(3144), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109099] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2762), 1,
      sym__call_signature,
    STATE(3097), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5424), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109131] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3117), 1,
      sym_type_annotation,
    STATE(3498), 1,
      sym__initializer,
    STATE(3499), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5353), 1,
      anon_sym_DOT,
    STATE(2679), 1,
      sym_type_arguments,
    ACTIONS(2959), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109191] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2758), 1,
      sym__call_signature,
    STATE(3144), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109223] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3095), 1,
      sym__call_signature,
    STATE(3097), 1,
      sym_type_annotation,
    STATE(3777), 1,
      sym_type_parameters,
    ACTIONS(5424), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109255] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2863), 1,
      sym__call_signature,
    STATE(3074), 1,
      sym_type_annotation,
    STATE(3549), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109291] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [109319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2874), 1,
      sym__call_signature,
    STATE(3117), 1,
      sym_type_annotation,
    STATE(3513), 1,
      sym__initializer,
    STATE(3749), 1,
      sym_type_parameters,
    ACTIONS(5426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_PIPE,
    ACTIONS(3405), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_PIPE,
    ACTIONS(3583), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 1,
      anon_sym_PIPE,
    ACTIONS(1508), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1928), 1,
      anon_sym_PIPE,
    ACTIONS(1926), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 1,
      anon_sym_DOT,
    ACTIONS(3595), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 1,
      anon_sym_PIPE,
    ACTIONS(3417), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_PIPE,
    ACTIONS(3445), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 1,
      anon_sym_PIPE,
    ACTIONS(3381), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_type_arguments,
    ACTIONS(3367), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 1,
      anon_sym_PIPE,
    ACTIONS(3367), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_PIPE,
    ACTIONS(1938), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 1,
      anon_sym_PIPE,
    ACTIONS(3541), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_PIPE,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(3389), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_PIPE,
    ACTIONS(3533), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(3618), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_PIPE,
    ACTIONS(3515), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_PIPE,
    ACTIONS(3385), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(3509), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(3441), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [109762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_PIPE,
    ACTIONS(2842), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PIPE,
    ACTIONS(3441), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3644), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_PIPE,
    ACTIONS(1942), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [109889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(3545), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [109912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_PIPE,
    ACTIONS(1934), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5438), 1,
      anon_sym_LBRACK,
    ACTIONS(5440), 1,
      anon_sym_DOT,
    ACTIONS(5442), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3477), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 1,
      anon_sym_PIPE,
    ACTIONS(3513), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3535), 1,
      anon_sym_PIPE,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(3537), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_PIPE,
    ACTIONS(3357), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    ACTIONS(3567), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(3575), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [110074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 1,
      anon_sym_PIPE,
    ACTIONS(3606), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      anon_sym_PIPE,
    ACTIONS(3622), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3608), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_PIPE,
    ACTIONS(2564), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1932), 1,
      anon_sym_PIPE,
    ACTIONS(1930), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_PIPE,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(3389), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(3549), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4503), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [110226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 1,
      anon_sym_PIPE,
    ACTIONS(2838), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3493), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_PIPE,
    ACTIONS(3571), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_PIPE,
    ACTIONS(3579), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(3429), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [110325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_PIPE,
    ACTIONS(3437), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_PIPE,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(3563), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110401] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5444), 1,
      sym_identifier,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    STATE(1798), 1,
      sym_class_body,
    STATE(2723), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3645), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110435] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5452), 1,
      sym_identifier,
    STATE(1798), 1,
      sym_class_body,
    STATE(2723), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3645), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110469] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(5454), 1,
      sym_identifier,
    ACTIONS(5456), 1,
      anon_sym_STAR,
    STATE(3699), 1,
      sym_import_clause,
    STATE(3700), 1,
      sym_string,
    STATE(3701), 1,
      sym_import_require_clause,
    STATE(4093), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [110501] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5460), 1,
      anon_sym_BANG,
    STATE(2984), 1,
      sym_type_annotation,
    STATE(3422), 1,
      sym__initializer,
    ACTIONS(5462), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_is,
    ACTIONS(3357), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110547] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5464), 1,
      sym_identifier,
    STATE(1798), 1,
      sym_class_body,
    STATE(2723), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3645), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 1,
      anon_sym_COLON,
    STATE(2851), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5466), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [110621] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5470), 1,
      sym_identifier,
    STATE(1779), 1,
      sym_class_body,
    STATE(2747), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3801), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110655] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5472), 1,
      sym_identifier,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1300), 1,
      sym_class_body,
    STATE(2751), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3791), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(5476), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110711] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5478), 1,
      sym_identifier,
    STATE(1388), 1,
      sym_class_body,
    STATE(2812), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3759), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110745] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5480), 1,
      sym_identifier,
    STATE(1779), 1,
      sym_class_body,
    STATE(2747), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3801), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110779] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5482), 1,
      sym_identifier,
    STATE(1779), 1,
      sym_class_body,
    STATE(2747), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3801), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110813] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 1,
      anon_sym_DOT,
    ACTIONS(5149), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5484), 1,
      anon_sym_LPAREN,
    STATE(2301), 1,
      sym_arguments,
    ACTIONS(3341), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 1,
      anon_sym_COLON,
    STATE(2864), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5486), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110859] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5153), 1,
      anon_sym_DOT,
    ACTIONS(5155), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5484), 1,
      anon_sym_LPAREN,
    STATE(2299), 1,
      sym_arguments,
    ACTIONS(3329), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110885] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5488), 1,
      sym_identifier,
    STATE(1798), 1,
      sym_class_body,
    STATE(2723), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3645), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [110919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_LT,
    ACTIONS(5492), 1,
      anon_sym_is,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5484), 1,
      anon_sym_LPAREN,
    STATE(2302), 1,
      sym_arguments,
    ACTIONS(2921), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110969] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5494), 1,
      sym_identifier,
    STATE(1779), 1,
      sym_class_body,
    STATE(2747), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3801), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111003] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5448), 1,
      anon_sym_extends,
    ACTIONS(5450), 1,
      anon_sym_implements,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5496), 1,
      sym_identifier,
    STATE(2012), 1,
      sym_class_body,
    STATE(2792), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3823), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111037] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5460), 1,
      anon_sym_BANG,
    ACTIONS(5498), 1,
      anon_sym_EQ,
    STATE(2984), 1,
      sym_type_annotation,
    STATE(3049), 1,
      sym__initializer,
    ACTIONS(5462), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111065] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(2745), 1,
      sym_type_parameters,
    STATE(3205), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3711), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(3618), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [111115] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(616), 1,
      sym_class_body,
    STATE(2810), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3744), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5510), 1,
      anon_sym_EQ,
    ACTIONS(5476), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [111169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [111184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111199] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1877), 1,
      sym_class_body,
    STATE(2731), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3680), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [111260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3622), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3606), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(5516), 1,
      anon_sym_extends,
    ACTIONS(3575), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [111356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_LBRACE,
    ACTIONS(2842), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(3537), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [111420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3513), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 1,
      anon_sym_LBRACK,
    ACTIONS(3389), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111467] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3146), 1,
      sym_type_annotation,
    STATE(3411), 1,
      sym__initializer,
    ACTIONS(5522), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5520), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111492] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1748), 1,
      sym_class_body,
    STATE(2799), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3723), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_COLON,
    STATE(3175), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5466), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5526), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [111557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [111582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [111607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3367), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111622] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(706), 1,
      sym_class_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3769), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111653] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1846), 1,
      sym_class_body,
    STATE(2735), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3753), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3405), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3381), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111729] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(612), 1,
      sym_class_body,
    STATE(2780), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3589), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 1,
      anon_sym_LBRACE,
    ACTIONS(2838), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(5516), 1,
      anon_sym_extends,
    ACTIONS(3441), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [111813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111828] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1886), 1,
      sym_class_body,
    STATE(2793), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3835), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1942), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111874] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1814), 1,
      sym_class_body,
    STATE(2779), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3728), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [111905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_LT,
    STATE(2308), 1,
      sym_type_arguments,
    ACTIONS(2959), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5498), 1,
      anon_sym_EQ,
    STATE(2984), 1,
      sym_type_annotation,
    STATE(3050), 1,
      sym__initializer,
    ACTIONS(5462), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111996] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2984), 1,
      sym_type_annotation,
    STATE(3423), 1,
      sym__initializer,
    ACTIONS(5462), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112021] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(2787), 1,
      sym_type_parameters,
    STATE(3186), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3794), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112052] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(2710), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3778), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112083] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(135), 1,
      sym_class_body,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3757), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3135), 1,
      sym_type_annotation,
    STATE(3465), 1,
      sym__initializer,
    ACTIONS(5329), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5327), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112164] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    STATE(3402), 1,
      aux_sym_object_repeat1,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3119), 1,
      sym_type_annotation,
    STATE(3508), 1,
      sym__initializer,
    ACTIONS(5229), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5227), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [112229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112259] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(5516), 1,
      anon_sym_extends,
    ACTIONS(3429), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [112280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_COLON,
    STATE(3180), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5486), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112324] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1399), 1,
      sym_class_body,
    STATE(2725), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3828), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112355] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1985), 1,
      sym_class_body,
    STATE(2742), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3705), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [112403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 1,
      anon_sym_LBRACK,
    ACTIONS(3563), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112420] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1319), 1,
      sym_class_body,
    STATE(2784), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3837), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112466] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1853), 1,
      sym_class_body,
    STATE(2716), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3742), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112522] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3584), 1,
      aux_sym_object_repeat1,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3073), 1,
      sym_type_annotation,
    STATE(3544), 1,
      sym__initializer,
    ACTIONS(5263), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5261), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112587] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(746), 1,
      sym_class_body,
    STATE(2739), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3646), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3505), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(3509), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [112695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3099), 1,
      sym_type_annotation,
    STATE(3573), 1,
      sym__initializer,
    ACTIONS(5279), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5277), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112765] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(2769), 1,
      sym_type_parameters,
    STATE(3229), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3761), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112811] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_class_body,
    STATE(2711), 1,
      sym_type_parameters,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3755), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [112842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(5516), 1,
      anon_sym_extends,
    ACTIONS(3545), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [112863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [112908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 1,
      anon_sym_LBRACK,
    ACTIONS(3389), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3549), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 1,
      sym_identifier,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5542), 1,
      anon_sym_enum,
    STATE(3336), 1,
      sym_variable_declarator,
    STATE(2813), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [112951] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 1,
      sym_identifier,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5544), 1,
      anon_sym_enum,
    STATE(3252), 1,
      sym_variable_declarator,
    STATE(2813), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [112975] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      sym_escape_sequence,
    ACTIONS(5548), 1,
      anon_sym_BQUOTE,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3163), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112999] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    ACTIONS(5554), 1,
      sym_escape_sequence,
    ACTIONS(5556), 1,
      anon_sym_BQUOTE,
    STATE(2930), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    ACTIONS(5560), 1,
      anon_sym_DOT,
    STATE(3164), 1,
      sym_statement_block,
    ACTIONS(1296), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(5516), 1,
      anon_sym_extends,
    ACTIONS(5476), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      sym_escape_sequence,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    ACTIONS(5562), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(5564), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(5566), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      sym_escape_sequence,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    ACTIONS(5568), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113151] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      sym_escape_sequence,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    ACTIONS(5570), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5460), 1,
      anon_sym_BANG,
    STATE(2984), 1,
      sym_type_annotation,
    STATE(3422), 1,
      sym__initializer,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_LT,
    STATE(2315), 1,
      sym_type_arguments,
    ACTIONS(3367), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      sym_escape_sequence,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    ACTIONS(5572), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113255] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    ACTIONS(5554), 1,
      sym_escape_sequence,
    ACTIONS(5574), 1,
      anon_sym_BQUOTE,
    STATE(2930), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_COMMA,
    STATE(3300), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5576), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(1345), 2,
      sym_template_string,
      sym_arguments,
  [113303] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      sym_escape_sequence,
    ACTIONS(5550), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5552), 1,
      sym__template_chars,
    ACTIONS(5578), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113355] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3134), 1,
      sym_type_annotation,
    STATE(3470), 1,
      sym__initializer,
    ACTIONS(5411), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [113389] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(3232), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3747), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113414] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(131), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3780), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      sym_identifier,
    ACTIONS(5582), 1,
      anon_sym_STAR,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3766), 1,
      sym__call_signature,
  [113464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3810), 1,
      sym_statement_block,
    ACTIONS(5586), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [113494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5193), 1,
      anon_sym_is,
    ACTIONS(5588), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113509] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1753), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3770), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5590), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [113547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3101), 1,
      sym_type_annotation,
    STATE(3577), 1,
      sym__initializer,
    ACTIONS(5409), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3833), 1,
      sym_statement_block,
    ACTIONS(5592), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3075), 1,
      sym_type_annotation,
    ACTIONS(5594), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3074), 1,
      sym_type_annotation,
    STATE(3547), 1,
      sym__initializer,
    ACTIONS(5428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3816), 1,
      sym_statement_block,
    ACTIONS(5596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113640] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1848), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3760), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5598), 1,
      sym_identifier,
    ACTIONS(5600), 1,
      anon_sym_DOT,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(596), 1,
      sym_string,
    STATE(699), 1,
      sym__module,
  [113690] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1339), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3743), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5602), 1,
      sym_identifier,
    STATE(3336), 1,
      sym_variable_declarator,
    STATE(2813), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [113736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3737), 1,
      sym_statement_block,
    ACTIONS(5604), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113753] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5602), 1,
      sym_identifier,
    STATE(3337), 1,
      sym_variable_declarator,
    STATE(2813), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [113774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3669), 1,
      sym_statement_block,
    ACTIONS(5604), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3734), 1,
      sym_statement_block,
    ACTIONS(5606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113808] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1869), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3650), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4503), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [113846] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5608), 1,
      sym_identifier,
    ACTIONS(5610), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3652), 1,
      sym__call_signature,
  [113871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [113884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1775), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3764), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5612), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [113922] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5614), 1,
      anon_sym_COLON,
    ACTIONS(5616), 1,
      anon_sym_QMARK,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3698), 1,
      sym__call_signature,
  [113947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3788), 1,
      sym_statement_block,
    ACTIONS(5618), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113964] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(626), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3660), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [113989] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5620), 1,
      sym_identifier,
    ACTIONS(5622), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3766), 1,
      sym__call_signature,
  [114014] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5624), 1,
      sym_identifier,
    ACTIONS(5626), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3710), 1,
      sym__call_signature,
  [114039] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1991), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3620), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5526), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    STATE(1345), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5628), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [114096] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(3181), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3781), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    STATE(3164), 1,
      sym_statement_block,
    ACTIONS(1296), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114138] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1837), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3756), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3637), 1,
      sym_statement_block,
    ACTIONS(5630), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [114197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3152), 1,
      sym_type_annotation,
    STATE(3418), 1,
      sym__initializer,
    ACTIONS(5417), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114218] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1394), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3767), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114243] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    STATE(3266), 1,
      sym_type_annotation,
    STATE(3714), 1,
      sym__initializer,
    ACTIONS(5634), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [114266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3635), 1,
      sym_statement_block,
    ACTIONS(5638), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_LT,
    ACTIONS(5642), 1,
      anon_sym_extends,
    STATE(651), 1,
      sym_object_type,
    STATE(3001), 1,
      sym_type_parameters,
    STATE(3451), 1,
      sym_extends_type_clause,
  [114308] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5644), 1,
      sym_identifier,
    ACTIONS(5646), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3652), 1,
      sym__call_signature,
  [114333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3153), 1,
      sym_type_annotation,
    STATE(3380), 1,
      sym__initializer,
    ACTIONS(5648), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114354] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5650), 1,
      sym_identifier,
    ACTIONS(5652), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3652), 1,
      sym__call_signature,
  [114379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3613), 1,
      sym_statement_block,
    ACTIONS(5596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3719), 1,
      sym_statement_block,
    ACTIONS(5638), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4137), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3677), 1,
      sym_statement_block,
    ACTIONS(5654), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3721), 1,
      sym_statement_block,
    ACTIONS(5630), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3672), 1,
      sym_statement_block,
    ACTIONS(5656), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3604), 1,
      sym_statement_block,
    ACTIONS(5658), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_EQ,
    STATE(3273), 1,
      sym_constraint,
    STATE(3750), 1,
      sym_default_type,
    ACTIONS(5400), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5660), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [114515] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5602), 1,
      sym_identifier,
    STATE(3252), 1,
      sym_variable_declarator,
    STATE(2813), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [114536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5662), 1,
      anon_sym_EQ,
    ACTIONS(3003), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [114551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114564] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(3223), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3693), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_is,
    ACTIONS(3357), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3808), 1,
      sym_statement_block,
    ACTIONS(5665), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [114634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114647] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5667), 1,
      sym_identifier,
    ACTIONS(5669), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3766), 1,
      sym__call_signature,
  [114672] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5671), 1,
      sym_identifier,
    ACTIONS(5673), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3766), 1,
      sym__call_signature,
  [114697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 1,
      anon_sym_EQ,
    ACTIONS(3003), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [114712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3796), 1,
      sym_statement_block,
    ACTIONS(5618), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114729] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(126), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3647), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1850), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3626), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114779] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(608), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3748), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3588), 1,
      sym_statement_block,
    ACTIONS(5678), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_LT,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    ACTIONS(5684), 1,
      anon_sym_DOT,
    ACTIONS(5686), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3303), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3370), 1,
      sym_type_arguments,
  [114846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3615), 1,
      sym_statement_block,
    ACTIONS(5665), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114863] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1397), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3821), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5602), 1,
      sym_identifier,
    STATE(3257), 1,
      sym_variable_declarator,
    STATE(2813), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [114909] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5690), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3652), 1,
      sym__call_signature,
  [114934] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(3213), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3771), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [114959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4124), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [114985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3665), 1,
      sym_statement_block,
    ACTIONS(5694), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115002] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5698), 1,
      anon_sym_DOT,
    STATE(2692), 1,
      sym_nested_identifier,
    STATE(2746), 1,
      sym_string,
    STATE(3165), 1,
      sym__module,
  [115027] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1992), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3704), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [115052] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1819), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3733), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [115077] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5616), 1,
      anon_sym_QMARK,
    ACTIONS(5700), 1,
      anon_sym_COLON,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3698), 1,
      sym__call_signature,
  [115102] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(623), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3638), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [115127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3793), 1,
      sym_statement_block,
    ACTIONS(5678), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115144] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_LT,
    ACTIONS(5642), 1,
      anon_sym_extends,
    STATE(3044), 1,
      sym_type_parameters,
    STATE(3176), 1,
      sym_object_type,
    STATE(3529), 1,
      sym_extends_type_clause,
  [115169] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5602), 1,
      sym_identifier,
    STATE(3478), 1,
      sym_variable_declarator,
    STATE(2813), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [115190] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1707), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3642), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [115215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3789), 1,
      sym_statement_block,
    ACTIONS(5694), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_EQ,
    ACTIONS(2979), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [115247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3117), 1,
      sym_type_annotation,
    STATE(3517), 1,
      sym__initializer,
    ACTIONS(5426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3090), 1,
      sym_type_annotation,
    ACTIONS(5704), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4122), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [115298] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5706), 1,
      sym_identifier,
    STATE(3252), 1,
      sym_variable_declarator,
    STATE(2645), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [115319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      sym_identifier,
    STATE(3257), 1,
      sym_variable_declarator,
    STATE(2641), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [115340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [115353] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(5157), 1,
      anon_sym_LT,
    ACTIONS(5712), 1,
      sym_identifier,
    ACTIONS(5714), 1,
      anon_sym_LBRACK,
    ACTIONS(5716), 1,
      sym_private_property_identifier,
    STATE(1760), 1,
      sym_arguments,
    STATE(3782), 1,
      sym_type_arguments,
  [115378] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5718), 1,
      sym_identifier,
    ACTIONS(5720), 1,
      anon_sym_STAR,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3692), 1,
      sym__call_signature,
  [115403] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(606), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3593), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [115428] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    ACTIONS(5157), 1,
      anon_sym_LT,
    ACTIONS(5722), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      anon_sym_LBRACK,
    ACTIONS(5726), 1,
      sym_private_property_identifier,
    STATE(1344), 1,
      sym_arguments,
    STATE(3774), 1,
      sym_type_arguments,
  [115453] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    ACTIONS(5502), 1,
      anon_sym_extends,
    ACTIONS(5504), 1,
      anon_sym_implements,
    STATE(1383), 1,
      sym_class_body,
    STATE(3390), 1,
      sym_extends_clause,
    STATE(3691), 1,
      sym_class_heritage,
    STATE(3996), 1,
      sym_implements_clause,
  [115478] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(2984), 1,
      sym_type_annotation,
    STATE(3423), 1,
      sym__initializer,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3155), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5728), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115515] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 1,
      sym_identifier,
    ACTIONS(5732), 1,
      anon_sym_import,
    STATE(2303), 1,
      sym__type_query_call_expression,
    STATE(2589), 1,
      sym__type_query_subscript_expression,
    STATE(2591), 1,
      sym__type_query_member_expression,
    STATE(3820), 1,
      sym_import,
  [115537] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5734), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3111), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [115559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_BQUOTE,
    ACTIONS(5738), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5554), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2930), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [115577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3116), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [115595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_extends,
    ACTIONS(3545), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [115613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(3509), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [115627] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5750), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3768), 1,
      sym__call_signature,
  [115649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2949), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5754), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115665] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_import,
    ACTIONS(5756), 1,
      sym_identifier,
    STATE(1468), 1,
      sym__type_query_subscript_expression,
    STATE(1474), 1,
      sym__type_query_member_expression,
    STATE(1515), 1,
      sym__type_query_call_expression,
    STATE(3629), 1,
      sym_import,
  [115687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2135), 1,
      sym_statement_block,
    ACTIONS(5630), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2137), 1,
      sym_statement_block,
    ACTIONS(5638), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5760), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2871), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [115741] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3775), 1,
      sym__call_signature,
  [115763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2144), 1,
      sym_statement_block,
    ACTIONS(5638), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115779] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5764), 1,
      anon_sym_COMMA,
    ACTIONS(5766), 1,
      anon_sym_GT,
    STATE(3548), 1,
      aux_sym_implements_clause_repeat1,
  [115801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3695), 1,
      sym__call_signature,
  [115823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    STATE(3286), 1,
      sym_type_annotation,
    STATE(3826), 1,
      sym__initializer,
    ACTIONS(5770), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [115843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2149), 1,
      sym_statement_block,
    ACTIONS(5630), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(5466), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3800), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [115875] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    ACTIONS(5778), 1,
      anon_sym_COMMA,
    ACTIONS(5780), 1,
      anon_sym_RBRACE,
    STATE(3420), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [115895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5782), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3502), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [115917] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5786), 1,
      anon_sym_BQUOTE,
    ACTIONS(5784), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2919), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [115935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5788), 1,
      anon_sym_QMARK,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3666), 1,
      sym__call_signature,
  [115957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_LT,
    ACTIONS(5684), 1,
      anon_sym_DOT,
    ACTIONS(5790), 1,
      anon_sym_LBRACE,
    STATE(3370), 1,
      sym_type_arguments,
    ACTIONS(5792), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [115977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5794), 1,
      anon_sym_QMARK,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3812), 1,
      sym__call_signature,
  [115999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      anon_sym_default,
    ACTIONS(5798), 1,
      anon_sym_RBRACE,
    ACTIONS(5800), 1,
      anon_sym_case,
    STATE(2933), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [116017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3153), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5802), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5804), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3683), 1,
      sym__call_signature,
  [116055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2147), 1,
      sym_statement_block,
    ACTIONS(5596), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3123), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [116089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3124), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [116107] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_import,
    ACTIONS(5806), 1,
      sym_identifier,
    STATE(2324), 1,
      sym__type_query_subscript_expression,
    STATE(2330), 1,
      sym__type_query_member_expression,
    STATE(2455), 1,
      sym__type_query_call_expression,
    STATE(3633), 1,
      sym_import,
  [116129] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5808), 1,
      anon_sym_COMMA,
    ACTIONS(5810), 1,
      anon_sym_GT,
    STATE(3442), 1,
      aux_sym_implements_clause_repeat1,
  [116151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5814), 1,
      anon_sym_QMARK,
    ACTIONS(5812), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3125), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [116189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5816), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116213] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5598), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(596), 1,
      sym_string,
    STATE(699), 1,
      sym__module,
  [116235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3183), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5820), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2841), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3183), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5820), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116267] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5822), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3128), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [116289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2912), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3157), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5824), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116305] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(5696), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_nested_identifier,
    STATE(2746), 1,
      sym_string,
    STATE(3165), 1,
      sym__module,
  [116327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5826), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3768), 1,
      sym__call_signature,
  [116349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(5696), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_nested_identifier,
    STATE(2746), 1,
      sym_string,
    STATE(3158), 1,
      sym__module,
  [116371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5828), 1,
      anon_sym_BQUOTE,
    ACTIONS(5546), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [116389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2910), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5832), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5830), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2853), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5836), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5834), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2160), 1,
      sym_statement_block,
    ACTIONS(5606), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5838), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2947), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5842), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5840), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116465] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5844), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3567), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [116487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2136), 1,
      sym_statement_block,
    ACTIONS(5604), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116503] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5846), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2825), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [116525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2138), 1,
      sym_statement_block,
    ACTIONS(5678), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5848), 1,
      anon_sym_export,
    ACTIONS(5850), 1,
      anon_sym_class,
    ACTIONS(5852), 1,
      anon_sym_abstract,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [116563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2139), 1,
      sym_statement_block,
    ACTIONS(5694), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116579] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5854), 1,
      anon_sym_COMMA,
    ACTIONS(5856), 1,
      anon_sym_GT,
    STATE(3553), 1,
      aux_sym_implements_clause_repeat1,
  [116601] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5858), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2914), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [116623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2158), 1,
      sym_statement_block,
    ACTIONS(5678), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116639] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_import,
    ACTIONS(5860), 1,
      sym_identifier,
    STATE(1189), 1,
      sym__type_query_member_expression,
    STATE(1190), 1,
      sym__type_query_subscript_expression,
    STATE(1244), 1,
      sym__type_query_call_expression,
    STATE(3825), 1,
      sym_import,
  [116661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5862), 1,
      anon_sym_LBRACE,
    ACTIONS(5864), 1,
      anon_sym_COMMA,
    STATE(3505), 1,
      aux_sym_implements_clause_repeat1,
  [116683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2140), 1,
      sym_statement_block,
    ACTIONS(5694), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5866), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3768), 1,
      sym__call_signature,
  [116721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116745] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    ACTIONS(5868), 1,
      anon_sym_COMMA,
    ACTIONS(5870), 1,
      anon_sym_RBRACE,
    STATE(3400), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [116765] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    ACTIONS(5598), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(596), 1,
      sym_string,
    STATE(754), 1,
      sym__module,
  [116787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5872), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3089), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [116809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5877), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1942), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116861] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5879), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2763), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [116883] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5881), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2713), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [116905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(3618), 4,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [116921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116933] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5883), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2771), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [116955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5885), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3775), 1,
      sym__call_signature,
  [116977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3834), 1,
      sym__call_signature,
  [116999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2162), 1,
      sym_statement_block,
    ACTIONS(5604), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117027] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2790), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [117049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3087), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5891), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3140), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [117089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3141), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3163), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5893), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5852), 1,
      anon_sym_abstract,
    ACTIONS(5895), 1,
      anon_sym_export,
    ACTIONS(5897), 1,
      anon_sym_class,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [117157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3142), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_default,
    ACTIONS(5902), 1,
      anon_sym_RBRACE,
    ACTIONS(5904), 1,
      anon_sym_case,
    STATE(2905), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [117193] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_import,
    ACTIONS(5907), 1,
      sym_identifier,
    STATE(2270), 1,
      sym__type_query_subscript_expression,
    STATE(2271), 1,
      sym__type_query_member_expression,
    STATE(2303), 1,
      sym__type_query_call_expression,
    STATE(3722), 1,
      sym_import,
  [117215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3135), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [117229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_extends,
    ACTIONS(3429), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [117247] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5909), 1,
      anon_sym_QMARK,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3631), 1,
      sym__call_signature,
  [117269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3159), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5911), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2167), 1,
      sym_statement_block,
    ACTIONS(5618), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3187), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5913), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2814), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3159), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5911), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2168), 1,
      sym_statement_block,
    ACTIONS(5665), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5915), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2950), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [117371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3157), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5824), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2146), 1,
      sym_statement_block,
    ACTIONS(5618), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117403] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_LT,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    ACTIONS(5917), 1,
      anon_sym_LBRACE,
    ACTIONS(5919), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3304), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3367), 1,
      sym_type_arguments,
  [117425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5924), 1,
      anon_sym_BQUOTE,
    ACTIONS(5926), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5921), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2919), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [117443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5929), 1,
      anon_sym_QMARK,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3735), 1,
      sym__call_signature,
  [117465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2143), 1,
      sym_statement_block,
    ACTIONS(5665), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(5486), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [117497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5931), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3775), 1,
      sym__call_signature,
  [117519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2916), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5935), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3147), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117553] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2895), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [117575] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5939), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2753), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [117597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_extends,
    ACTIONS(3441), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [117627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5941), 1,
      anon_sym_BQUOTE,
    ACTIONS(5784), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2919), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [117645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5943), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3775), 1,
      sym__call_signature,
  [117667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    ACTIONS(5740), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5742), 1,
      anon_sym_QMARK_COLON,
    STATE(3148), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      anon_sym_default,
    ACTIONS(5800), 1,
      anon_sym_case,
    ACTIONS(5945), 1,
      anon_sym_RBRACE,
    STATE(2905), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [117703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3151), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5949), 1,
      sym_identifier,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3768), 1,
      sym__call_signature,
  [117741] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5951), 1,
      anon_sym_COMMA,
    ACTIONS(5953), 1,
      anon_sym_GT,
    STATE(3461), 1,
      aux_sym_implements_clause_repeat1,
  [117763] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5955), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3168), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [117785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(5957), 1,
      sym_identifier,
    ACTIONS(5959), 1,
      anon_sym_LBRACK,
    STATE(3709), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(5959), 1,
      anon_sym_LBRACK,
    ACTIONS(5961), 1,
      sym_identifier,
    STATE(3297), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2156), 1,
      sym_statement_block,
    ACTIONS(5592), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    ACTIONS(5959), 1,
      anon_sym_LBRACK,
    ACTIONS(5963), 1,
      sym_identifier,
    STATE(3536), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5612), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3056), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [117901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2934), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3185), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5967), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2170), 1,
      sym_statement_block,
    ACTIONS(5596), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3185), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5967), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2901), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3161), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3161), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2169), 1,
      sym_statement_block,
    ACTIONS(5586), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_is,
    ACTIONS(5588), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_statement_block,
    ACTIONS(5658), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5590), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [118039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_import,
    ACTIONS(5971), 1,
      sym_identifier,
    STATE(2442), 1,
      sym__type_query_member_expression,
    STATE(2444), 1,
      sym__type_query_subscript_expression,
    STATE(2551), 1,
      sym__type_query_call_expression,
    STATE(3622), 1,
      sym_import,
  [118061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3191), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5973), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118077] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5975), 1,
      anon_sym_COMMA,
    ACTIONS(5977), 1,
      anon_sym_GT,
    STATE(3393), 1,
      aux_sym_implements_clause_repeat1,
  [118099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2161), 1,
      sym_statement_block,
    ACTIONS(5656), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118115] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5979), 1,
      anon_sym_COMMA,
    ACTIONS(5981), 1,
      anon_sym_GT,
    STATE(3444), 1,
      aux_sym_implements_clause_repeat1,
  [118137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    ACTIONS(5983), 1,
      anon_sym_QMARK,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3829), 1,
      sym__call_signature,
  [118159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [118171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2964), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5987), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    ACTIONS(5989), 1,
      anon_sym_QMARK,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2957), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [118209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    STATE(2165), 1,
      sym_statement_block,
    ACTIONS(5654), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3189), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5993), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [118259] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_extends,
    ACTIONS(3575), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [118277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(3537), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [118291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(5995), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [118309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2955), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3189), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118325] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2727), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [118347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(6001), 1,
      anon_sym_PIPE,
    ACTIONS(5999), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118375] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5852), 1,
      anon_sym_abstract,
    ACTIONS(6003), 1,
      anon_sym_class,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [118394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4307), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [118405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6005), 1,
      anon_sym_BQUOTE,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6009), 1,
      sym__template_chars,
    STATE(2993), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [118422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6011), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2997), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [118456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5852), 1,
      anon_sym_abstract,
    ACTIONS(5897), 1,
      anon_sym_class,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [118475] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(3006), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [118494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    ACTIONS(6014), 1,
      anon_sym_SEMI,
    ACTIONS(6016), 1,
      sym__automatic_semicolon,
    ACTIONS(6018), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1799), 1,
      sym_statement_block,
  [118513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 1,
      anon_sym_EQ,
    ACTIONS(2979), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [118526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3832), 1,
      sym__call_signature,
  [118545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 1,
      anon_sym_COLON,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6022), 1,
      anon_sym_RBRACE,
    STATE(3586), 1,
      aux_sym_object_pattern_repeat1,
  [118564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3477), 1,
      sym__initializer,
    ACTIONS(6024), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4274), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [118590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4537), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [118601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    ACTIONS(6026), 1,
      anon_sym_COMMA,
    ACTIONS(6028), 1,
      anon_sym_RBRACE,
    STATE(3509), 1,
      aux_sym_enum_body_repeat1,
    STATE(3653), 1,
      sym__initializer,
  [118620] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3663), 1,
      sym__call_signature,
  [118639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3649), 1,
      sym__call_signature,
  [118658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3838), 1,
      sym__call_signature,
  [118677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6030), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118692] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6033), 1,
      anon_sym_class,
    ACTIONS(6035), 1,
      anon_sym_abstract,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [118711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6037), 1,
      anon_sym_BQUOTE,
    ACTIONS(6039), 1,
      sym__template_chars,
    STATE(3025), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [118728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [118739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(3032), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [118758] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3773), 1,
      sym__call_signature,
  [118777] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_SEMI,
    ACTIONS(6045), 1,
      sym__automatic_semicolon,
    ACTIONS(6047), 1,
      sym__function_signature_automatic_semicolon,
    STATE(132), 1,
      sym_statement_block,
  [118796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    ACTIONS(6051), 1,
      anon_sym_SEMI,
    ACTIONS(6053), 1,
      sym__automatic_semicolon,
    ACTIONS(6055), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3039), 1,
      sym_statement_block,
  [118826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4464), 1,
      sym__automatic_semicolon,
    ACTIONS(1418), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    ACTIONS(5642), 1,
      anon_sym_extends,
    STATE(701), 1,
      sym_object_type,
    STATE(3537), 1,
      sym_extends_type_clause,
  [118858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    ACTIONS(6057), 1,
      anon_sym_RBRACE,
    STATE(3806), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [118875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(6001), 1,
      anon_sym_PIPE,
    ACTIONS(6059), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(3042), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [118911] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3745), 1,
      sym__call_signature,
  [118930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_SEMI,
    ACTIONS(6045), 1,
      sym__automatic_semicolon,
    ACTIONS(6047), 1,
      sym__function_signature_automatic_semicolon,
    STATE(607), 1,
      sym_statement_block,
  [118949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(6001), 1,
      anon_sym_PIPE,
    ACTIONS(6061), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3738), 1,
      sym__call_signature,
  [118985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3731), 1,
      sym__call_signature,
  [119004] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3730), 1,
      sym__call_signature,
  [119023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(6001), 1,
      anon_sym_PIPE,
    ACTIONS(6063), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    ACTIONS(6065), 1,
      anon_sym_RBRACE,
    STATE(3726), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [119057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4547), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6067), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6069), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [119138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6072), 1,
      anon_sym_EQ_GT,
    STATE(3800), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [119153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6075), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [119170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6077), 1,
      anon_sym_EQ_GT,
    STATE(3800), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [119185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    ACTIONS(6080), 1,
      anon_sym_SEMI,
    ACTIONS(6082), 1,
      sym__automatic_semicolon,
    ACTIONS(6084), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3000), 1,
      sym_statement_block,
  [119204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5173), 1,
      anon_sym_LBRACK,
    ACTIONS(6086), 1,
      anon_sym_RBRACE,
    ACTIONS(3389), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_BQUOTE,
    ACTIONS(6090), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6093), 1,
      sym__template_chars,
    STATE(3025), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [119236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2748), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [119255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6096), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [119272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6098), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [119283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3552), 1,
      sym__initializer,
    ACTIONS(6100), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119298] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3659), 1,
      sym__call_signature,
  [119317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3656), 1,
      sym__call_signature,
  [119336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 1,
      anon_sym_LBRACE,
    ACTIONS(6014), 1,
      anon_sym_SEMI,
    ACTIONS(6016), 1,
      sym__automatic_semicolon,
    ACTIONS(6018), 1,
      sym__function_signature_automatic_semicolon,
    STATE(121), 1,
      sym_statement_block,
  [119355] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3752), 1,
      sym__call_signature,
  [119374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    STATE(3798), 1,
      sym_type_annotation,
    ACTIONS(3003), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [119389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(3203), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [119408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    ACTIONS(6102), 1,
      anon_sym_COMMA,
    ACTIONS(6104), 1,
      anon_sym_RBRACE,
    STATE(3560), 1,
      aux_sym_enum_body_repeat1,
    STATE(3653), 1,
      sym__initializer,
  [119427] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6035), 1,
      anon_sym_abstract,
    ACTIONS(6106), 1,
      anon_sym_class,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [119446] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    ACTIONS(6108), 1,
      anon_sym_RBRACE,
    STATE(3806), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [119463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4444), 1,
      sym__automatic_semicolon,
    ACTIONS(1336), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 1,
      sym__automatic_semicolon,
    ACTIONS(1350), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3641), 1,
      sym__call_signature,
  [119508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    ACTIONS(6014), 1,
      anon_sym_SEMI,
    ACTIONS(6016), 1,
      sym__automatic_semicolon,
    ACTIONS(6018), 1,
      sym__function_signature_automatic_semicolon,
    STATE(598), 1,
      sym_statement_block,
  [119527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(6001), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(5642), 1,
      anon_sym_extends,
    STATE(3208), 1,
      sym_object_type,
    STATE(3427), 1,
      sym_extends_type_clause,
  [119563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(3174), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [119582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3636), 1,
      sym__call_signature,
  [119601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3630), 1,
      sym__call_signature,
  [119620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    ACTIONS(6112), 1,
      anon_sym_RBRACE,
    STATE(3726), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [119637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 1,
      anon_sym_in,
    ACTIONS(6118), 1,
      anon_sym_of,
    ACTIONS(6114), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 1,
      anon_sym_in,
    ACTIONS(6122), 1,
      anon_sym_of,
    ACTIONS(6114), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4470), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [119711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3085), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [119730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5604), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2781), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [119760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5604), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(6001), 1,
      anon_sym_PIPE,
    ACTIONS(6124), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119788] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_SEMI,
    ACTIONS(6045), 1,
      sym__automatic_semicolon,
    ACTIONS(6047), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1876), 1,
      sym_statement_block,
  [119807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6126), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 1,
      sym__automatic_semicolon,
    ACTIONS(1456), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2777), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [119872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ_GT,
    STATE(3800), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [119898] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2722), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [119917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [119928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2761), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [119947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2824), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [119966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(2764), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [119985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3574), 1,
      sym__initializer,
    ACTIONS(6135), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3564), 1,
      sym__initializer,
    ACTIONS(6137), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3746), 1,
      sym__call_signature,
  [120045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6039), 1,
      sym__template_chars,
    ACTIONS(6141), 1,
      anon_sym_BQUOTE,
    STATE(3025), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120062] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3786), 1,
      sym__call_signature,
  [120081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3664), 1,
      sym__call_signature,
  [120100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3827), 1,
      sym__call_signature,
  [120119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3822), 1,
      sym__call_signature,
  [120138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6143), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [120153] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2999), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [120172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4541), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [120183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_extends,
    ACTIONS(6146), 1,
      anon_sym_as,
    ACTIONS(6148), 1,
      anon_sym_RBRACK,
  [120213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3109), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [120243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 1,
      anon_sym_COLON,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6154), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_object_pattern_repeat1,
  [120284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3703), 1,
      sym__call_signature,
  [120314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2980), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [120355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [120385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3512), 1,
      sym__initializer,
    ACTIONS(6160), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3836), 1,
      sym__call_signature,
  [120419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3511), 1,
      sym__initializer,
    ACTIONS(6162), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120434] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3507), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [120453] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(3023), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [120472] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5850), 1,
      anon_sym_class,
    ACTIONS(5852), 1,
      anon_sym_abstract,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [120491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_COLON,
    ACTIONS(6164), 1,
      anon_sym_EQ_GT,
    STATE(3800), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [120506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_LT,
    ACTIONS(6167), 1,
      anon_sym_LBRACE,
    STATE(3367), 1,
      sym_type_arguments,
    ACTIONS(6169), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [120523] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3802), 1,
      sym__call_signature,
  [120542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(3060), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [120561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120572] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3126), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [120591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6171), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3471), 1,
      sym__initializer,
    ACTIONS(6177), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2911), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [120691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3466), 1,
      sym__initializer,
    ACTIONS(6179), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [120725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6181), 1,
      anon_sym_BQUOTE,
    ACTIONS(6183), 1,
      sym__template_chars,
    STATE(3077), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3814), 1,
      sym__call_signature,
  [120761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6187), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6189), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3138), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [120824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6191), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6193), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2946), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [120898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3429), 1,
      sym__initializer,
    ACTIONS(6195), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3414), 1,
      sym__initializer,
    ACTIONS(6197), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2922), 1,
      sym_formal_parameters,
    STATE(3601), 1,
      sym_type_parameters,
    STATE(3676), 1,
      sym__call_signature,
  [120947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6199), 1,
      anon_sym_BQUOTE,
    ACTIONS(6201), 1,
      sym__template_chars,
    STATE(3163), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3149), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [120994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5586), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6205), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2963), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [121068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3377), 1,
      sym__initializer,
    ACTIONS(6209), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6213), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6039), 1,
      sym__template_chars,
    ACTIONS(6215), 1,
      anon_sym_BQUOTE,
    STATE(3025), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_formal_parameters,
    STATE(3155), 1,
      sym__call_signature,
    STATE(3777), 1,
      sym_type_parameters,
  [121152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3381), 1,
      sym__initializer,
    ACTIONS(6217), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_EQ,
    STATE(3365), 1,
      sym__initializer,
    ACTIONS(6219), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121182] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2657), 1,
      sym_formal_parameters,
    STATE(2952), 1,
      sym__call_signature,
    STATE(3749), 1,
      sym_type_parameters,
  [121201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 1,
      anon_sym_DOT,
    ACTIONS(3593), 1,
      anon_sym_LBRACE,
    ACTIONS(3595), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [121227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6221), 1,
      anon_sym_BQUOTE,
    ACTIONS(6223), 1,
      sym__template_chars,
    STATE(3150), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1428), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2338), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6039), 1,
      sym__template_chars,
    ACTIONS(6225), 1,
      anon_sym_BQUOTE,
    STATE(3025), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4122), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [121382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2378), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2122), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    ACTIONS(6080), 1,
      anon_sym_SEMI,
    ACTIONS(6082), 1,
      sym__automatic_semicolon,
    ACTIONS(6084), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1752), 1,
      sym_statement_block,
  [121445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2134), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5816), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5838), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4137), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [121533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6039), 1,
      sym__template_chars,
    ACTIONS(6227), 1,
      anon_sym_BQUOTE,
    STATE(3025), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4124), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [121649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2110), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    ACTIONS(6051), 1,
      anon_sym_SEMI,
    ACTIONS(6053), 1,
      sym__automatic_semicolon,
    ACTIONS(6055), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1716), 1,
      sym_statement_block,
  [121778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6229), 1,
      anon_sym_BQUOTE,
    ACTIONS(6231), 1,
      sym__template_chars,
    STATE(3190), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2102), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2086), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2090), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2370), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2170), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2178), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122202] = 4,
    ACTIONS(6233), 1,
      anon_sym_DQUOTE,
    ACTIONS(6237), 1,
      sym_comment,
    STATE(3350), 1,
      aux_sym_string_repeat1,
    ACTIONS(6235), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122216] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6239), 1,
      anon_sym_DQUOTE,
    STATE(3255), 1,
      aux_sym_string_repeat1,
    ACTIONS(6241), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122230] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6239), 1,
      anon_sym_SQUOTE,
    STATE(3256), 1,
      aux_sym_string_repeat2,
    ACTIONS(6243), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6245), 1,
      anon_sym_QMARK,
  [122260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6247), 1,
      anon_sym_QMARK,
  [122276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6249), 1,
      anon_sym_QMARK,
  [122292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    STATE(3684), 1,
      sym__from_clause,
    ACTIONS(6253), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6255), 1,
      anon_sym_RBRACK,
  [122322] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6257), 1,
      anon_sym_QMARK,
  [122338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6259), 1,
      anon_sym_class,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [122354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3263), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6263), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6265), 1,
      anon_sym_EQ,
    ACTIONS(6267), 1,
      anon_sym_RBRACK,
    STATE(3436), 1,
      aux_sym_array_pattern_repeat1,
  [122384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3729), 1,
      sym_type_parameters,
    STATE(3937), 1,
      sym_formal_parameters,
  [122400] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6269), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6271), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122414] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6269), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3262), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6275), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    STATE(1697), 2,
      sym_template_string,
      sym_arguments,
  [122456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5021), 1,
      anon_sym_EQ_GT,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [122468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_EQ_GT,
    ACTIONS(3135), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [122480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(5456), 1,
      anon_sym_STAR,
    STATE(3845), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [122494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3284), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6279), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3284), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6281), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122522] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6283), 1,
      anon_sym_DQUOTE,
    STATE(3281), 1,
      aux_sym_string_repeat1,
    ACTIONS(6285), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122536] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6283), 1,
      anon_sym_SQUOTE,
    STATE(3282), 1,
      aux_sym_string_repeat2,
    ACTIONS(6287), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    STATE(3824), 1,
      sym__initializer,
    ACTIONS(6289), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [122564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6291), 1,
      anon_sym_QMARK,
  [122580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_COMMA,
    STATE(3268), 1,
      aux_sym_array_repeat1,
    ACTIONS(4314), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [122594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2720), 1,
      sym_formal_parameters,
    STATE(3817), 1,
      sym_type_parameters,
  [122610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6296), 1,
      anon_sym_export,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [122626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6298), 1,
      anon_sym_RPAREN,
  [122642] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3718), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_formal_parameters,
  [122658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_EQ,
    STATE(3790), 1,
      sym_default_type,
    ACTIONS(6300), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [122672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6302), 1,
      anon_sym_COLON,
  [122688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122698] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6304), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6306), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122712] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6311), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      sym_identifier,
    STATE(2918), 1,
      sym_nested_type_identifier,
    STATE(3295), 1,
      sym_generic_type,
    STATE(3894), 1,
      sym_nested_identifier,
  [122742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3772), 1,
      sym_type_parameters,
    STATE(4072), 1,
      sym_formal_parameters,
  [122758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6316), 1,
      anon_sym_RBRACK,
  [122774] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6318), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6271), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122788] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6318), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 1,
      anon_sym_COLON,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(6320), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 1,
      anon_sym_COMMA,
    STATE(3284), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6325), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4076), 1,
      sym_formal_parameters,
  [122846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    STATE(3706), 1,
      sym__initializer,
    ACTIONS(6327), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [122860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 1,
      sym_escape_sequence,
    ACTIONS(6331), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [122872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6086), 1,
      anon_sym_RBRACE,
    ACTIONS(3389), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6334), 1,
      anon_sym_QMARK,
  [122900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_COMMA,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(5995), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [122914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6339), 1,
      anon_sym_RBRACK,
  [122930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 1,
      anon_sym_COMMA,
    STATE(3301), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6341), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [122944] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6343), 1,
      anon_sym_RPAREN,
  [122960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [122970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    ACTIONS(5917), 1,
      anon_sym_LBRACE,
    ACTIONS(5919), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3305), 1,
      aux_sym_extends_type_clause_repeat1,
  [122986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_type_parameters,
    STATE(4122), 1,
      sym_formal_parameters,
  [123002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_EQ,
    STATE(3621), 1,
      sym__initializer,
    ACTIONS(5462), 2,
      anon_sym_in,
      anon_sym_of,
  [123016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6349), 1,
      anon_sym_COLON,
  [123032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6351), 1,
      anon_sym_COLON,
  [123048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 1,
      anon_sym_COMMA,
    STATE(3301), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6353), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [123062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6357), 1,
      anon_sym_COMMA,
    STATE(3301), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6355), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [123076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6360), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_nested_type_identifier,
    STATE(3559), 1,
      sym_generic_type,
    STATE(3894), 1,
      sym_nested_identifier,
  [123092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6364), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3316), 1,
      aux_sym_extends_type_clause_repeat1,
  [123108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    ACTIONS(6366), 1,
      anon_sym_LBRACE,
    ACTIONS(6368), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3316), 1,
      aux_sym_extends_type_clause_repeat1,
  [123124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    ACTIONS(6366), 1,
      anon_sym_LBRACE,
    ACTIONS(6368), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3316), 1,
      aux_sym_extends_type_clause_repeat1,
  [123140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    STATE(3806), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [123154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6370), 1,
      anon_sym_RPAREN,
  [123170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
    STATE(3726), 1,
      sym__import_export_specifier,
    ACTIONS(5776), 2,
      anon_sym_type,
      anon_sym_typeof,
  [123184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6372), 1,
      anon_sym_RBRACK,
  [123200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6374), 1,
      anon_sym_RBRACK,
  [123216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3284), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6376), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3284), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6378), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6380), 1,
      anon_sym_COLON,
  [123260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    STATE(1345), 2,
      sym_template_string,
      sym_arguments,
  [123274] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 1,
      anon_sym_LBRACE,
    ACTIONS(6386), 1,
      anon_sym_COMMA,
    ACTIONS(6389), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3316), 1,
      aux_sym_extends_type_clause_repeat1,
  [123304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    STATE(3653), 1,
      sym__initializer,
    ACTIONS(6391), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [123318] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6271), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3599), 1,
      sym_type_parameters,
    STATE(4060), 1,
      sym_formal_parameters,
  [123348] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6393), 1,
      anon_sym_DQUOTE,
    STATE(3343), 1,
      aux_sym_string_repeat1,
    ACTIONS(6395), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [123372] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6393), 1,
      anon_sym_SQUOTE,
    STATE(3345), 1,
      aux_sym_string_repeat2,
    ACTIONS(6397), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123386] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6399), 1,
      anon_sym_class,
    STATE(1087), 1,
      aux_sym_export_statement_repeat1,
    STATE(1129), 1,
      sym_decorator,
  [123402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6401), 1,
      anon_sym_RBRACK,
  [123418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6403), 1,
      anon_sym_RBRACK,
  [123434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6405), 1,
      anon_sym_RBRACK,
  [123450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6407), 1,
      anon_sym_RBRACK,
  [123466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6409), 1,
      anon_sym_RBRACK,
  [123482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6411), 1,
      anon_sym_RBRACK,
  [123498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6265), 1,
      anon_sym_EQ,
    ACTIONS(6413), 1,
      anon_sym_RBRACK,
    STATE(3578), 1,
      aux_sym_array_pattern_repeat1,
  [123514] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_DQUOTE,
    STATE(3318), 1,
      aux_sym_string_repeat1,
    ACTIONS(6417), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123528] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6419), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123542] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6419), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6271), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123556] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6421), 1,
      anon_sym_SQUOTE,
    STATE(3332), 1,
      aux_sym_string_repeat2,
    ACTIONS(6423), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123570] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6421), 1,
      anon_sym_DQUOTE,
    STATE(3333), 1,
      aux_sym_string_repeat1,
    ACTIONS(6425), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3311), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6427), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    STATE(3312), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6429), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123612] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6431), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123626] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6431), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6271), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    STATE(3616), 1,
      sym__from_clause,
    ACTIONS(6433), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123654] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6435), 1,
      anon_sym_SQUOTE,
    STATE(3338), 1,
      aux_sym_string_repeat2,
    ACTIONS(6437), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123668] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6435), 1,
      anon_sym_DQUOTE,
    STATE(3339), 1,
      aux_sym_string_repeat1,
    ACTIONS(6439), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123682] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6441), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6271), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6443), 1,
      anon_sym_COLON,
  [123712] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6441), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6445), 1,
      anon_sym_RBRACK,
  [123742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6447), 1,
      anon_sym_RPAREN,
  [123758] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_SQUOTE,
    STATE(3315), 1,
      aux_sym_string_repeat2,
    ACTIONS(6449), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123772] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6451), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123786] = 4,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(6451), 1,
      anon_sym_DQUOTE,
    STATE(3276), 1,
      aux_sym_string_repeat1,
    ACTIONS(6271), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6453), 1,
      anon_sym_COLON,
  [123816] = 4,
    ACTIONS(6233), 1,
      anon_sym_SQUOTE,
    ACTIONS(6237), 1,
      sym_comment,
    STATE(3349), 1,
      aux_sym_string_repeat2,
    ACTIONS(6455), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
    ACTIONS(6457), 1,
      anon_sym_RPAREN,
  [123846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_AMP,
    ACTIONS(5211), 1,
      anon_sym_PIPE,
    ACTIONS(5241), 1,
      anon_sym_extends,
  [123859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6461), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      aux_sym_object_repeat1,
  [123872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LPAREN,
    ACTIONS(6465), 1,
      anon_sym_await,
    STATE(33), 1,
      sym__for_header,
  [123885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6467), 1,
      sym_identifier,
    ACTIONS(6469), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6471), 1,
      sym_identifier,
    ACTIONS(6473), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      sym_identifier,
    STATE(1095), 1,
      sym_decorator_member_expression,
    STATE(1131), 1,
      sym_decorator_call_expression,
  [123920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_AMP,
    ACTIONS(5436), 1,
      anon_sym_extends,
    ACTIONS(6001), 1,
      anon_sym_PIPE,
  [123933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    ACTIONS(6477), 1,
      anon_sym_as,
    STATE(3671), 1,
      sym__from_clause,
  [123946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(6479), 1,
      sym_identifier,
    STATE(3675), 1,
      sym_export_clause,
  [123959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 1,
      anon_sym_COMMA,
    ACTIONS(6483), 1,
      anon_sym_RBRACK,
    STATE(3495), 1,
      aux_sym_tuple_type_repeat1,
  [123972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(6485), 1,
      anon_sym_EQ,
    STATE(4017), 1,
      sym_type_parameters,
  [123985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6489), 1,
      anon_sym_RBRACE,
    STATE(3405), 1,
      aux_sym_object_pattern_repeat1,
  [124007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_LBRACE,
    ACTIONS(3579), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [124018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6491), 1,
      anon_sym_RBRACE,
    STATE(3407), 1,
      aux_sym_object_repeat1,
  [124031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6491), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      aux_sym_object_repeat1,
  [124044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 1,
      anon_sym_LBRACE,
    ACTIONS(3541), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [124055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6489), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      aux_sym_object_pattern_repeat1,
  [124068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_EQ,
    ACTIONS(3003), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [124079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_RBRACK,
    ACTIONS(6496), 1,
      anon_sym_COMMA,
    STATE(3538), 1,
      aux_sym_tuple_type_repeat1,
  [124092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6498), 1,
      anon_sym_EQ,
    ACTIONS(6500), 1,
      anon_sym_COMMA,
    ACTIONS(6502), 1,
      anon_sym_from,
  [124105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [124114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 1,
      anon_sym_COMMA,
    ACTIONS(6506), 1,
      anon_sym_RPAREN,
    STATE(3426), 1,
      aux_sym_formal_parameters_repeat1,
  [124127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6508), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6267), 1,
      anon_sym_RBRACK,
    STATE(3436), 1,
      aux_sym_array_pattern_repeat1,
  [124149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4260), 1,
      anon_sym_RBRACK,
    STATE(3435), 1,
      aux_sym_array_repeat1,
  [124162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6512), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      sym_identifier,
    STATE(2129), 1,
      sym_decorator_member_expression,
    STATE(2201), 1,
      sym_decorator_call_expression,
  [124193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_RPAREN,
    ACTIONS(6516), 1,
      anon_sym_COMMA,
    STATE(3487), 1,
      aux_sym_formal_parameters_repeat1,
  [124206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6518), 1,
      anon_sym_LBRACE,
    ACTIONS(6133), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [124217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4260), 1,
      anon_sym_RBRACK,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [124230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_COMMA,
    ACTIONS(6522), 1,
      anon_sym_RBRACK,
    STATE(3412), 1,
      aux_sym_tuple_type_repeat1,
  [124243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6267), 1,
      anon_sym_RBRACK,
    STATE(3437), 1,
      aux_sym_array_pattern_repeat1,
  [124256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    ACTIONS(6526), 1,
      anon_sym_GT,
    STATE(3785), 1,
      sym_type_parameter,
  [124269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 1,
      anon_sym_COMMA,
    ACTIONS(6530), 1,
      anon_sym_GT,
    STATE(3447), 1,
      aux_sym_type_parameters_repeat1,
  [124282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5504), 1,
      anon_sym_implements,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(3915), 1,
      sym_implements_clause,
  [124295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_AMP,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(5516), 1,
      anon_sym_extends,
  [124308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 1,
      sym_identifier,
    ACTIONS(5714), 1,
      anon_sym_LBRACK,
    ACTIONS(5716), 1,
      sym_private_property_identifier,
  [124321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_GT,
    ACTIONS(6534), 1,
      anon_sym_COMMA,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
  [124334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    STATE(3804), 1,
      sym_string,
  [124347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      anon_sym_RBRACK,
    ACTIONS(6536), 1,
      anon_sym_COMMA,
    STATE(3538), 1,
      aux_sym_tuple_type_repeat1,
  [124360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [124369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_as,
    ACTIONS(6542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [124380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4303), 1,
      anon_sym_RPAREN,
    STATE(3416), 1,
      aux_sym_array_repeat1,
  [124393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4303), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [124406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 1,
      anon_sym_COMMA,
    ACTIONS(6546), 1,
      anon_sym_RBRACE,
    STATE(3457), 1,
      aux_sym_export_clause_repeat1,
  [124419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6550), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      aux_sym_object_repeat1,
  [124441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6552), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      aux_sym_object_pattern_repeat1,
  [124454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 1,
      sym_identifier,
    ACTIONS(6556), 1,
      anon_sym_LBRACK,
    ACTIONS(6558), 1,
      sym_private_property_identifier,
  [124467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6560), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      aux_sym_object_pattern_repeat1,
  [124480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 1,
      sym_identifier,
    ACTIONS(6564), 1,
      anon_sym_LBRACK,
    ACTIONS(6566), 1,
      sym_private_property_identifier,
  [124493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6568), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      aux_sym_object_repeat1,
  [124506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      sym_identifier,
    ACTIONS(6572), 1,
      anon_sym_LBRACK,
    ACTIONS(6574), 1,
      sym_private_property_identifier,
  [124519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      sym_identifier,
    ACTIONS(6578), 1,
      anon_sym_LBRACK,
    ACTIONS(6580), 1,
      sym_private_property_identifier,
  [124532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 1,
      sym_identifier,
    ACTIONS(6584), 1,
      anon_sym_LBRACK,
    ACTIONS(6586), 1,
      sym_private_property_identifier,
  [124545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_RBRACK,
    ACTIONS(6590), 1,
      anon_sym_COMMA,
    STATE(3538), 1,
      aux_sym_tuple_type_repeat1,
  [124567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_COMMA,
    ACTIONS(6595), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      aux_sym_object_repeat1,
  [124580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_COMMA,
    ACTIONS(6602), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      aux_sym_object_pattern_repeat1,
  [124602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6604), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [124615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 1,
      anon_sym_COMMA,
    ACTIONS(6502), 1,
      anon_sym_from,
    ACTIONS(6608), 1,
      anon_sym_EQ,
  [124646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 1,
      anon_sym_COMMA,
    ACTIONS(6612), 1,
      anon_sym_RBRACE,
    STATE(3474), 1,
      aux_sym_named_imports_repeat1,
  [124659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 1,
      sym_identifier,
    ACTIONS(6616), 1,
      anon_sym_require,
    STATE(3475), 1,
      sym_nested_identifier,
  [124672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6114), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6114), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    ACTIONS(3037), 2,
      anon_sym_in,
      anon_sym_of,
  [124701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [124710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 1,
      anon_sym_RPAREN,
    ACTIONS(6620), 1,
      anon_sym_COMMA,
    STATE(3487), 1,
      aux_sym_formal_parameters_repeat1,
  [124723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(3224), 1,
      sym_object_type,
  [124736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 1,
      anon_sym_COMMA,
    ACTIONS(6624), 1,
      anon_sym_RBRACE,
    STATE(3515), 1,
      aux_sym_enum_body_repeat1,
  [124749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6626), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    ACTIONS(6628), 1,
      anon_sym_LPAREN,
    STATE(615), 1,
      sym_statement_block,
  [124771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6630), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [124784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4327), 1,
      anon_sym_RPAREN,
    STATE(3431), 1,
      aux_sym_array_repeat1,
  [124797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4314), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [124806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      anon_sym_EQ,
    ACTIONS(6632), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [124817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6634), 1,
      anon_sym_RBRACK,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [124830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6636), 1,
      anon_sym_RBRACK,
    STATE(3437), 1,
      aux_sym_array_pattern_repeat1,
  [124843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 1,
      anon_sym_RBRACK,
    ACTIONS(6638), 1,
      anon_sym_COMMA,
    STATE(3437), 1,
      aux_sym_array_pattern_repeat1,
  [124856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6641), 1,
      sym_identifier,
    ACTIONS(6643), 1,
      anon_sym_LBRACK,
    ACTIONS(6645), 1,
      sym_private_property_identifier,
  [124869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6647), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [124882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_COMMA,
    ACTIONS(6651), 1,
      anon_sym_RBRACK,
    STATE(3496), 1,
      aux_sym_tuple_type_repeat1,
  [124895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_LT,
    ACTIONS(6653), 1,
      anon_sym_EQ,
    STATE(3956), 1,
      sym_type_parameters,
  [124908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      anon_sym_GT,
    ACTIONS(6655), 1,
      anon_sym_COMMA,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
  [124921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 1,
      sym_identifier,
    ACTIONS(6659), 1,
      anon_sym_LBRACK,
    ACTIONS(6661), 1,
      sym_private_property_identifier,
  [124934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 1,
      anon_sym_GT,
    ACTIONS(6663), 1,
      anon_sym_COMMA,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
  [124947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    ACTIONS(6665), 1,
      anon_sym_GT,
    STATE(3785), 1,
      sym_type_parameter,
  [124960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6667), 1,
      anon_sym_RBRACE,
    STATE(3587), 1,
      aux_sym_object_pattern_repeat1,
  [124973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6665), 1,
      anon_sym_GT,
    ACTIONS(6669), 1,
      anon_sym_COMMA,
    STATE(3503), 1,
      aux_sym_type_parameters_repeat1,
  [124986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6671), 1,
      anon_sym_RBRACE,
    STATE(3355), 1,
      aux_sym_object_repeat1,
  [124999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      sym_identifier,
    ACTIONS(6675), 1,
      anon_sym_LBRACK,
    ACTIONS(6677), 1,
      sym_private_property_identifier,
  [125021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    STATE(703), 1,
      sym_object_type,
  [125034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    STATE(3521), 1,
      aux_sym_array_repeat1,
  [125047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3758), 1,
      sym_type_predicate,
    ACTIONS(6679), 2,
      sym_identifier,
      sym_this,
  [125058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 1,
      anon_sym_as,
    ACTIONS(6683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6685), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [125078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [125087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 1,
      anon_sym_COMMA,
    ACTIONS(6691), 1,
      anon_sym_RBRACE,
    STATE(3528), 1,
      aux_sym_export_clause_repeat1,
  [125100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6693), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_DOT,
    ACTIONS(6695), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [125120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6697), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 1,
      anon_sym_GT,
    ACTIONS(6699), 1,
      anon_sym_COMMA,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
  [125142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6671), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      aux_sym_object_repeat1,
  [125155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      anon_sym_RPAREN,
    STATE(3469), 1,
      aux_sym_array_repeat1,
  [125168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6697), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6667), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      aux_sym_object_pattern_repeat1,
  [125221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6705), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      anon_sym_EQ,
    ACTIONS(6709), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 1,
      anon_sym_COMMA,
    ACTIONS(6713), 1,
      anon_sym_RBRACE,
    STATE(3527), 1,
      aux_sym_named_imports_repeat1,
  [125289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_DOT,
    ACTIONS(6715), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [125300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6717), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6721), 1,
      anon_sym_COMMA,
    ACTIONS(6723), 1,
      anon_sym_RPAREN,
    STATE(3383), 1,
      aux_sym_formal_parameters_repeat1,
  [125340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6725), 1,
      anon_sym_COMMA,
    ACTIONS(6727), 1,
      anon_sym_RPAREN,
    STATE(3582), 1,
      aux_sym_formal_parameters_repeat1,
  [125353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(6098), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [125364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6413), 1,
      anon_sym_RBRACK,
    STATE(3578), 1,
      aux_sym_array_pattern_repeat1,
  [125377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5612), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [125386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
    STATE(3486), 1,
      aux_sym_array_repeat1,
  [125399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6731), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6733), 1,
      anon_sym_COMMA,
    ACTIONS(6736), 1,
      anon_sym_RPAREN,
    STATE(3487), 1,
      aux_sym_formal_parameters_repeat1,
  [125438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6738), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_EQ,
    ACTIONS(3037), 2,
      anon_sym_in,
      anon_sym_of,
  [125462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4312), 1,
      anon_sym_RBRACK,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      sym_identifier,
    ACTIONS(6742), 1,
      anon_sym_LBRACK,
    ACTIONS(6744), 1,
      sym_private_property_identifier,
  [125488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6413), 1,
      anon_sym_RBRACK,
    STATE(3437), 1,
      aux_sym_array_pattern_repeat1,
  [125501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6746), 1,
      sym_identifier,
    ACTIONS(6748), 1,
      anon_sym_LBRACK,
    ACTIONS(6750), 1,
      sym_private_property_identifier,
  [125514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 1,
      sym_identifier,
    ACTIONS(6754), 1,
      anon_sym_LBRACK,
    ACTIONS(6756), 1,
      sym_private_property_identifier,
  [125527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 1,
      anon_sym_RBRACK,
    ACTIONS(6758), 1,
      anon_sym_COMMA,
    STATE(3538), 1,
      aux_sym_tuple_type_repeat1,
  [125540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      anon_sym_RBRACK,
    ACTIONS(6760), 1,
      anon_sym_COMMA,
    STATE(3538), 1,
      aux_sym_tuple_type_repeat1,
  [125553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      sym_identifier,
    ACTIONS(6764), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      sym_private_property_identifier,
  [125566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    ACTIONS(6772), 1,
      anon_sym_GT,
    STATE(3785), 1,
      sym_type_parameter,
  [125597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_LPAREN,
    ACTIONS(6776), 1,
      anon_sym_await,
    STATE(37), 1,
      sym__for_header,
  [125610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6778), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6780), 1,
      anon_sym_COMMA,
    ACTIONS(6783), 1,
      anon_sym_GT,
    STATE(3503), 1,
      aux_sym_type_parameters_repeat1,
  [125632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6785), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5864), 1,
      anon_sym_COMMA,
    ACTIONS(6787), 1,
      anon_sym_LBRACE,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
  [125654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2879), 1,
      sym_type_predicate,
    ACTIONS(6789), 2,
      sym_identifier,
      sym_this,
  [125665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6791), 1,
      anon_sym_COMMA,
    ACTIONS(6793), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_enum_body_repeat1,
  [125696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 1,
      anon_sym_COMMA,
    ACTIONS(6797), 1,
      anon_sym_GT,
    STATE(3541), 1,
      aux_sym_type_parameters_repeat1,
  [125709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6799), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_COMMA,
    ACTIONS(6805), 1,
      anon_sym_RBRACK,
    STATE(3373), 1,
      aux_sym_tuple_type_repeat1,
  [125749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_COMMA,
    ACTIONS(6809), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_enum_body_repeat1,
  [125762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4327), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    ACTIONS(6477), 1,
      anon_sym_as,
    STATE(3634), 1,
      sym__from_clause,
  [125797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_LBRACE,
    ACTIONS(6811), 1,
      sym_identifier,
    STATE(3619), 1,
      sym_export_clause,
  [125810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_COMMA,
    ACTIONS(6815), 1,
      anon_sym_RBRACE,
    STATE(3561), 1,
      aux_sym_enum_body_repeat1,
  [125823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6817), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5161), 1,
      anon_sym_is,
    ACTIONS(5588), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [125847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6819), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [125856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6821), 1,
      anon_sym_LBRACE,
    ACTIONS(6041), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [125880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6823), 1,
      sym_identifier,
    ACTIONS(6825), 1,
      anon_sym_LBRACK,
    ACTIONS(6827), 1,
      sym_private_property_identifier,
  [125893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6829), 1,
      anon_sym_COMMA,
    ACTIONS(6832), 1,
      anon_sym_RBRACE,
    STATE(3527), 1,
      aux_sym_named_imports_repeat1,
  [125906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6834), 1,
      anon_sym_COMMA,
    ACTIONS(6837), 1,
      anon_sym_RBRACE,
    STATE(3528), 1,
      aux_sym_export_clause_repeat1,
  [125919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(3206), 1,
      sym_object_type,
  [125932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6819), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [125941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 1,
      anon_sym_SQUOTE,
    STATE(4079), 1,
      sym_string,
  [125954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4270), 1,
      anon_sym_RPAREN,
    STATE(3439), 1,
      aux_sym_array_repeat1,
  [125967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 1,
      sym_identifier,
    ACTIONS(6841), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      sym_private_property_identifier,
  [125980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4270), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [125993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5590), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [126002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    ACTIONS(6845), 1,
      anon_sym_RPAREN,
    STATE(4085), 1,
      sym_type_annotation,
  [126015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1149), 1,
      anon_sym_LBRACE,
    STATE(620), 1,
      sym_object_type,
  [126028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 1,
      anon_sym_COMMA,
    ACTIONS(6850), 1,
      anon_sym_RBRACK,
    STATE(3538), 1,
      aux_sym_tuple_type_repeat1,
  [126041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3173), 1,
      sym_type_predicate,
    ACTIONS(6852), 2,
      sym_identifier,
      sym_this,
  [126052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6854), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [126061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6856), 1,
      anon_sym_COMMA,
    ACTIONS(6858), 1,
      anon_sym_GT,
    STATE(3503), 1,
      aux_sym_type_parameters_repeat1,
  [126074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    ACTIONS(6858), 1,
      anon_sym_GT,
    STATE(3785), 1,
      sym_type_parameter,
  [126087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6862), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 1,
      anon_sym_GT,
    ACTIONS(6866), 1,
      anon_sym_COMMA,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
  [126145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6868), 1,
      sym_identifier,
    ACTIONS(6870), 1,
      anon_sym_LBRACK,
    ACTIONS(6872), 1,
      sym_private_property_identifier,
  [126167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_extends,
    ACTIONS(6874), 1,
      anon_sym_AMP,
    ACTIONS(6876), 1,
      anon_sym_PIPE,
  [126180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_GT,
    ACTIONS(6880), 1,
      anon_sym_COMMA,
    STATE(3290), 1,
      aux_sym_implements_clause_repeat1,
  [126202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4239), 1,
      anon_sym_extends,
    ACTIONS(6882), 1,
      anon_sym_AMP,
    ACTIONS(6884), 1,
      anon_sym_PIPE,
  [126215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6886), 1,
      anon_sym_COMMA,
    ACTIONS(6889), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_enum_body_repeat1,
  [126228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      sym_identifier,
    ACTIONS(6893), 1,
      anon_sym_LBRACK,
    ACTIONS(6895), 1,
      sym_private_property_identifier,
  [126241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6897), 1,
      sym_identifier,
    ACTIONS(6899), 1,
      anon_sym_LBRACK,
    ACTIONS(6901), 1,
      sym_private_property_identifier,
  [126254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      sym_identifier,
    ACTIONS(6905), 1,
      anon_sym_LBRACK,
    ACTIONS(6907), 1,
      sym_private_property_identifier,
  [126267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      anon_sym_LBRACE,
    ACTIONS(6169), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [126278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6909), 1,
      anon_sym_COMMA,
    ACTIONS(6911), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_enum_body_repeat1,
  [126291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6913), 1,
      anon_sym_COMMA,
    ACTIONS(6915), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_enum_body_repeat1,
  [126304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6925), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6927), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [126367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    STATE(3488), 1,
      aux_sym_array_repeat1,
  [126380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(4312), 1,
      anon_sym_RBRACK,
    STATE(3580), 1,
      aux_sym_array_repeat1,
  [126393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 1,
      sym_identifier,
    ACTIONS(5724), 1,
      anon_sym_LBRACK,
    ACTIONS(5726), 1,
      sym_private_property_identifier,
  [126406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_COMMA,
    ACTIONS(6931), 1,
      anon_sym_RBRACK,
    STATE(3395), 1,
      aux_sym_tuple_type_repeat1,
  [126419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      sym_identifier,
    ACTIONS(6937), 1,
      anon_sym_LBRACK,
    ACTIONS(6939), 1,
      sym_private_property_identifier,
  [126459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6941), 1,
      anon_sym_RBRACK,
    STATE(3437), 1,
      aux_sym_array_pattern_repeat1,
  [126481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2032), 1,
      anon_sym_while,
    ACTIONS(6943), 1,
      anon_sym_else,
    STATE(683), 1,
      sym_else_clause,
  [126494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(6945), 1,
      anon_sym_RBRACK,
    STATE(3268), 1,
      aux_sym_array_repeat1,
  [126507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 1,
      anon_sym_RPAREN,
    ACTIONS(6947), 1,
      anon_sym_COMMA,
    STATE(3487), 1,
      aux_sym_formal_parameters_repeat1,
  [126529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      sym_identifier,
    ACTIONS(6951), 1,
      anon_sym_LBRACK,
    ACTIONS(6953), 1,
      sym_private_property_identifier,
  [126542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_COMMA,
    ACTIONS(6955), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      aux_sym_object_repeat1,
  [126555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_extends,
  [126568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6957), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      aux_sym_object_pattern_repeat1,
  [126581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COMMA,
    ACTIONS(6959), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      aux_sym_object_pattern_repeat1,
  [126594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(614), 1,
      sym_class_body,
  [126612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      sym_identifier,
    ACTIONS(6963), 1,
      sym_private_property_identifier,
  [126622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_LPAREN,
    STATE(3614), 1,
      sym_parenthesized_expression,
  [126632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parenthesized_expression,
  [126642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_class_body,
  [126652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_statement_block,
  [126662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [126672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3105), 1,
      sym_formal_parameters,
  [126690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6967), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(4081), 1,
      sym_formal_parameters,
  [126708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4297), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(2833), 1,
      sym_formal_parameters,
  [126726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6969), 1,
      sym_identifier,
    ACTIONS(6971), 1,
      anon_sym_STAR,
  [126736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    STATE(3685), 1,
      sym__from_clause,
  [126746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6973), 1,
      anon_sym_SEMI,
    ACTIONS(6975), 1,
      sym__automatic_semicolon,
  [126764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    STATE(3702), 1,
      sym__from_clause,
  [126774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_in,
    ACTIONS(6981), 1,
      anon_sym_COLON,
  [126792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6983), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      sym_identifier,
    ACTIONS(6953), 1,
      sym_private_property_identifier,
  [126810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6985), 1,
      anon_sym_LBRACE,
    STATE(3198), 1,
      sym_enum_body,
  [126820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym_parenthesized_expression,
  [126830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6987), 1,
      anon_sym_LBRACE,
    STATE(747), 1,
      sym_switch_body,
  [126848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6989), 1,
      anon_sym_SEMI,
    ACTIONS(6991), 1,
      sym__automatic_semicolon,
  [126866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6993), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym__for_header,
  [126876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_statement_block,
  [126886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4098), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(2047), 1,
      sym_class_body,
  [126904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 1,
      anon_sym_in,
    ACTIONS(6118), 1,
      anon_sym_of,
  [126914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5337), 1,
      anon_sym_LPAREN,
    STATE(2546), 1,
      sym_arguments,
  [126924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6897), 1,
      sym_identifier,
    ACTIONS(6901), 1,
      sym_private_property_identifier,
  [126942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6997), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1832), 1,
      sym_class_body,
  [126960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4301), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 1,
      sym_identifier,
    STATE(3459), 1,
      sym_nested_identifier,
  [126978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    STATE(1681), 1,
      sym_arguments,
  [126988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1834), 1,
      sym_statement_block,
  [126998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3665), 1,
      sym_statement_block,
  [127008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4252), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LPAREN,
    STATE(2449), 1,
      sym_arguments,
  [127026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_SEMI,
    ACTIONS(7003), 1,
      sym__automatic_semicolon,
  [127036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3588), 1,
      sym_statement_block,
  [127054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(673), 1,
      sym_class_body,
  [127072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3022), 1,
      sym_formal_parameters,
  [127082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    STATE(3389), 1,
      sym_type_parameter,
  [127092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    STATE(599), 1,
      sym_statement_block,
  [127102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1698), 1,
      sym_class_body,
  [127112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3922), 1,
      sym_formal_parameters,
  [127122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7005), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1855), 1,
      sym_class_body,
  [127140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_class_body,
  [127150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(139), 1,
      sym_class_body,
  [127160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6985), 1,
      anon_sym_LBRACE,
    STATE(3177), 1,
      sym_enum_body,
  [127170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    STATE(3040), 1,
      sym_statement_block,
  [127180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1804), 1,
      sym_class_body,
  [127190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    STATE(3172), 1,
      sym_statement_block,
  [127200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1780), 1,
      sym_statement_block,
  [127210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7007), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7011), 1,
      sym_private_property_identifier,
  [127228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7013), 1,
      sym_identifier,
    ACTIONS(7015), 1,
      sym_private_property_identifier,
  [127238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1700), 1,
      sym_statement_block,
  [127248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7017), 1,
      sym_identifier,
    ACTIONS(7019), 1,
      sym_private_property_identifier,
  [127258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 1,
      anon_sym_LBRACE,
    STATE(138), 1,
      sym_statement_block,
  [127276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(643), 1,
      sym_class_body,
  [127286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 1,
      sym_identifier,
    ACTIONS(7025), 1,
      sym_private_property_identifier,
  [127296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(647), 1,
      sym_statement_block,
  [127306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    STATE(3063), 1,
      sym_statement_block,
  [127316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3796), 1,
      sym_statement_block,
  [127326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3808), 1,
      sym_statement_block,
  [127344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      anon_sym_LBRACE,
    STATE(654), 1,
      sym_enum_body,
  [127354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5838), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [127378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 1,
      anon_sym_SEMI,
    ACTIONS(7033), 1,
      sym__automatic_semicolon,
  [127388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(4033), 1,
      sym_formal_parameters,
  [127406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    STATE(3785), 1,
      sym_type_parameter,
  [127416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4120), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3604), 1,
      sym_statement_block,
  [127434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5057), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6850), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [127450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [127458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1866), 1,
      sym_class_body,
  [127468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      sym_identifier,
    ACTIONS(7039), 1,
      anon_sym_STAR,
  [127478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 1,
      sym_identifier,
    ACTIONS(5716), 1,
      sym_private_property_identifier,
  [127488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1365), 1,
      sym_statement_block,
  [127498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym_SEMI,
    ACTIONS(7043), 1,
      sym__automatic_semicolon,
  [127508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      anon_sym_SEMI,
    ACTIONS(7047), 1,
      sym__automatic_semicolon,
  [127518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 1,
      sym_identifier,
    ACTIONS(6558), 1,
      sym_private_property_identifier,
  [127528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      sym_identifier,
    ACTIONS(7051), 1,
      sym_private_property_identifier,
  [127538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6602), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      sym_identifier,
    ACTIONS(6677), 1,
      sym_private_property_identifier,
  [127564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1360), 1,
      sym_class_body,
  [127574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_statement_block,
  [127584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3195), 1,
      sym_class_body,
  [127594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7053), 1,
      sym_identifier,
    ACTIONS(7055), 1,
      sym_private_property_identifier,
  [127604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1380), 1,
      sym_statement_block,
  [127614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7057), 1,
      sym_identifier,
    ACTIONS(7059), 1,
      sym_private_property_identifier,
  [127624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_identifier,
    STATE(3510), 1,
      sym_type_parameter,
  [127634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3833), 1,
      sym_statement_block,
  [127644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    STATE(3840), 1,
      sym__from_clause,
  [127654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7063), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym_SEMI,
    ACTIONS(7067), 1,
      sym__automatic_semicolon,
  [127680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1796), 1,
      sym_statement_block,
  [127690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1964), 1,
      sym_class_body,
  [127700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1990), 1,
      sym_class_body,
  [127710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7069), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_COLON,
    STATE(3476), 1,
      sym_type_annotation,
  [127728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(600), 1,
      sym_statement_block,
  [127738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 2,
      anon_sym_in,
      anon_sym_of,
  [127746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1385), 1,
      sym_statement_block,
  [127756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3222), 1,
      sym_class_body,
  [127766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      anon_sym_LBRACE,
    STATE(694), 1,
      sym_enum_body,
  [127776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7071), 1,
      sym_identifier,
    ACTIONS(7073), 1,
      sym_private_property_identifier,
  [127786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7075), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7077), 1,
      anon_sym_LPAREN,
    STATE(3819), 1,
      sym_parenthesized_expression,
  [127804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [127812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6993), 1,
      anon_sym_LPAREN,
    STATE(44), 1,
      sym__for_header,
  [127822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(4070), 1,
      sym_formal_parameters,
  [127832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(7081), 1,
      anon_sym_STAR,
  [127850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    STATE(2302), 1,
      sym_arguments,
  [127868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1708), 1,
      sym_class_body,
  [127878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(4112), 1,
      sym_formal_parameters,
  [127888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3020), 1,
      sym_formal_parameters,
  [127898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    STATE(3798), 1,
      sym_type_annotation,
  [127916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1847), 1,
      sym_class_body,
  [127926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3884), 1,
      sym_formal_parameters,
  [127936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1843), 1,
      sym_statement_block,
  [127946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1838), 1,
      sym_statement_block,
  [127956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1836), 1,
      sym_class_body,
  [127974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3635), 1,
      sym_statement_block,
  [127992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7085), 1,
      sym_identifier,
    ACTIONS(7087), 1,
      sym_private_property_identifier,
  [128002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3637), 1,
      sym_statement_block,
  [128020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7089), 1,
      sym_identifier,
    ACTIONS(7091), 1,
      sym_private_property_identifier,
  [128030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7093), 1,
      sym_identifier,
    ACTIONS(7095), 1,
      anon_sym_STAR,
  [128040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3855), 1,
      sym_formal_parameters,
  [128050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1685), 1,
      sym_class_body,
  [128060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1318), 1,
      sym_class_body,
  [128070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(605), 1,
      sym_class_body,
  [128080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LBRACE,
    STATE(597), 1,
      sym_statement_block,
  [128090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1320), 1,
      sym_statement_block,
  [128100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3220), 1,
      sym_class_body,
  [128110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym_class_body,
  [128120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_LPAREN,
    STATE(2622), 1,
      sym_formal_parameters,
  [128130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7097), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [128138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(619), 1,
      sym_statement_block,
  [128148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1711), 1,
      sym_statement_block,
  [128158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1776), 1,
      sym_class_body,
  [128168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7099), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(128), 1,
      sym_class_body,
  [128186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1741), 1,
      sym_class_body,
  [128196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(124), 1,
      sym_class_body,
  [128206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [128214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1381), 1,
      sym_class_body,
  [128224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1883), 1,
      sym_class_body,
  [128234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3235), 1,
      sym_class_body,
  [128244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_from,
    STATE(3605), 1,
      sym__from_clause,
  [128254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7101), 1,
      sym_identifier,
    ACTIONS(7103), 1,
      sym_private_property_identifier,
  [128264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_class_body,
  [128274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3911), 1,
      sym_formal_parameters,
  [128284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1831), 1,
      sym_statement_block,
  [128294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1357), 1,
      sym_class_body,
  [128304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1783), 1,
      sym_statement_block,
  [128314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_LBRACE,
    STATE(625), 1,
      sym_class_body,
  [128324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym_class_body,
  [128334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3230), 1,
      sym_class_body,
  [128344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(4005), 1,
      sym_formal_parameters,
  [128354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 1,
      anon_sym_LBRACE,
    STATE(123), 1,
      sym_statement_block,
  [128364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    STATE(1392), 1,
      sym_arguments,
  [128374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1823), 1,
      sym_statement_block,
  [128384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2581), 1,
      sym_formal_parameters,
  [128402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3231), 1,
      sym_class_body,
  [128412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(4034), 1,
      sym_formal_parameters,
  [128422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(119), 1,
      sym_class_body,
  [128432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3240), 1,
      sym_class_body,
  [128442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    STATE(1726), 1,
      sym_arguments,
  [128452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym_parenthesized_expression,
  [128462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
  [128472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [128480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1704), 1,
      sym_statement_block,
  [128490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_parenthesized_expression,
  [128500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7105), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [128524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1393), 1,
      sym_class_body,
  [128534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_LBRACE,
    STATE(3212), 1,
      sym_class_body,
  [128560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5816), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [128568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7109), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [128584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7111), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [128592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_COLON,
    STATE(3679), 1,
      sym_type_annotation,
  [128602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [128610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1743), 1,
      sym_class_body,
  [128620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3816), 1,
      sym_statement_block,
  [128630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3067), 1,
      sym_formal_parameters,
  [128640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7113), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7117), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7119), 1,
      sym_identifier,
    ACTIONS(7121), 1,
      sym_private_property_identifier,
  [128674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7123), 1,
      sym_identifier,
    ACTIONS(7125), 1,
      sym_private_property_identifier,
  [128692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5061), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7127), 1,
      sym_identifier,
    ACTIONS(7129), 1,
      sym_private_property_identifier,
  [128710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3810), 1,
      sym_statement_block,
  [128720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      sym_identifier,
    ACTIONS(6744), 1,
      sym_private_property_identifier,
  [128730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3677), 1,
      sym_statement_block,
  [128740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 1,
      sym_identifier,
    ACTIONS(5726), 1,
      sym_private_property_identifier,
  [128750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    STATE(2803), 1,
      sym_formal_parameters,
  [128768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7131), 1,
      sym_identifier,
    STATE(3475), 1,
      sym_nested_identifier,
  [128778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7133), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 1,
      anon_sym_LPAREN,
    STATE(2302), 1,
      sym_arguments,
  [128796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1352), 1,
      sym_class_body,
  [128806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1301), 1,
      sym_statement_block,
  [128816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1986), 1,
      sym_class_body,
  [128826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7135), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [128834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_LPAREN,
    STATE(1299), 1,
      sym_arguments,
  [128844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7137), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [128852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1348), 1,
      sym_statement_block,
  [128862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1340), 1,
      sym_class_body,
  [128872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3737), 1,
      sym_statement_block,
  [128882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6736), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [128890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6709), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3734), 1,
      sym_statement_block,
  [128908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      anon_sym_LBRACE,
    STATE(3672), 1,
      sym_statement_block,
  [128926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1820), 1,
      sym_class_body,
  [128936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(1398), 1,
      sym_statement_block,
  [128946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_LBRACE,
    STATE(1395), 1,
      sym_class_body,
  [128956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    STATE(1815), 1,
      sym_statement_block,
  [128966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(4051), 1,
      sym_formal_parameters,
  [128976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7139), 1,
      anon_sym_SEMI,
    ACTIONS(7141), 1,
      sym__automatic_semicolon,
  [128986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LPAREN,
    STATE(3863), 1,
      sym_formal_parameters,
  [128996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7143), 1,
      anon_sym_RBRACE,
  [129003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_RBRACK,
  [129010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4202), 1,
      anon_sym_RPAREN,
  [129017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7147), 1,
      anon_sym_from,
  [129024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_LPAREN,
  [129031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
  [129038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7151), 1,
      anon_sym_RBRACK,
  [129045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7153), 1,
      anon_sym_from,
  [129052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7155), 1,
      anon_sym_RBRACK,
  [129059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7157), 1,
      anon_sym_RBRACK,
  [129066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7159), 1,
      anon_sym_RPAREN,
  [129073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7161), 1,
      anon_sym_require,
  [129080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_DOT,
  [129087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 1,
      anon_sym_EQ_GT,
  [129094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7165), 1,
      anon_sym_COLON,
  [129101] = 2,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(7167), 1,
      sym_regex_pattern,
  [129108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7169), 1,
      anon_sym_EQ_GT,
  [129115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7171), 1,
      anon_sym_EQ_GT,
  [129122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7173), 1,
      anon_sym_RBRACK,
  [129129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_EQ_GT,
  [129136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7177), 1,
      sym_identifier,
  [129143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_EQ_GT,
  [129150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7181), 1,
      anon_sym_RBRACK,
  [129157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7183), 1,
      anon_sym_EQ_GT,
  [129164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7185), 1,
      anon_sym_RBRACK,
  [129171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_RBRACK,
  [129178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7189), 1,
      anon_sym_RBRACK,
  [129185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      sym_identifier,
  [129192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7193), 1,
      anon_sym_RBRACK,
  [129199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_RBRACK,
  [129206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      sym_identifier,
  [129213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7199), 1,
      anon_sym_LBRACK,
  [129220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7201), 1,
      anon_sym_RBRACK,
  [129227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7203), 1,
      sym_identifier,
  [129234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7205), 1,
      anon_sym_RBRACK,
  [129241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7207), 1,
      sym_number,
  [129248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_from,
  [129255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7211), 1,
      anon_sym_RBRACK,
  [129262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7213), 1,
      anon_sym_from,
  [129269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      sym_identifier,
  [129276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7217), 1,
      anon_sym_RBRACK,
  [129283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7219), 1,
      anon_sym_RBRACK,
  [129290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7221), 1,
      anon_sym_EQ_GT,
  [129297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7223), 1,
      anon_sym_EQ_GT,
  [129304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7225), 1,
      sym_number,
  [129311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7227), 1,
      anon_sym_EQ_GT,
  [129318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7229), 1,
      anon_sym_EQ_GT,
  [129325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_EQ_GT,
  [129332] = 2,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(7233), 1,
      sym_regex_pattern,
  [129339] = 2,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(7235), 1,
      sym_regex_pattern,
  [129346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_RBRACK,
  [129353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7237), 1,
      anon_sym_RBRACK,
  [129360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      anon_sym_DOT,
  [129367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6805), 1,
      anon_sym_RBRACK,
  [129374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      sym_identifier,
  [129381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7241), 1,
      anon_sym_EQ_GT,
  [129388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7243), 1,
      sym_identifier,
  [129395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 1,
      sym_identifier,
  [129402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7247), 1,
      anon_sym_COLON,
  [129409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7249), 1,
      sym_identifier,
  [129416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7251), 1,
      anon_sym_SLASH2,
  [129423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7253), 1,
      sym_identifier,
  [129430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      sym_identifier,
  [129437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
  [129444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7257), 1,
      anon_sym_SLASH2,
  [129451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7259), 1,
      anon_sym_EQ_GT,
  [129458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7261), 1,
      anon_sym_EQ_GT,
  [129465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_RBRACK,
  [129472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 1,
      anon_sym_LPAREN,
  [129479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7263), 1,
      anon_sym_EQ_GT,
  [129486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5353), 1,
      anon_sym_DOT,
  [129493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7265), 1,
      anon_sym_RBRACK,
  [129500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_RBRACK,
  [129507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_LBRACE,
  [129514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7269), 1,
      sym_identifier,
  [129521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7271), 1,
      sym_identifier,
  [129528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_RBRACK,
  [129535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7275), 1,
      anon_sym_RBRACK,
  [129542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7277), 1,
      anon_sym_EQ_GT,
  [129549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7279), 1,
      anon_sym_SLASH2,
  [129556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7281), 1,
      anon_sym_EQ_GT,
  [129563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7283), 1,
      anon_sym_RBRACK,
  [129570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym_EQ_GT,
  [129577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7287), 1,
      sym_number,
  [129584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7289), 1,
      anon_sym_EQ_GT,
  [129591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7291), 1,
      anon_sym_class,
  [129598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7293), 1,
      sym_identifier,
  [129605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_EQ_GT,
  [129612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7297), 1,
      anon_sym_RBRACK,
  [129619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7299), 1,
      anon_sym_EQ,
  [129626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_namespace,
  [129633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_DOT,
  [129640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7303), 1,
      anon_sym_RBRACK,
  [129647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7305), 1,
      anon_sym_RBRACK,
  [129654] = 2,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(7307), 1,
      sym_regex_pattern,
  [129661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7309), 1,
      anon_sym_EQ_GT,
  [129668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 1,
      anon_sym_RBRACK,
  [129675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_from,
  [129682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 1,
      anon_sym_RBRACK,
  [129689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 1,
      anon_sym_EQ_GT,
  [129696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_RBRACK,
  [129703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7319), 1,
      anon_sym_EQ_GT,
  [129710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7321), 1,
      anon_sym_EQ_GT,
  [129717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7323), 1,
      anon_sym_EQ_GT,
  [129724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7325), 1,
      anon_sym_EQ_GT,
  [129731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7327), 1,
      anon_sym_EQ_GT,
  [129738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_RBRACK,
  [129745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_RBRACK,
  [129752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      sym_identifier,
  [129759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_class,
  [129766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 1,
      anon_sym_EQ,
  [129773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_RBRACK,
  [129780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7335), 1,
      anon_sym_EQ,
  [129787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_from,
  [129794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_EQ,
  [129801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7339), 1,
      anon_sym_readonly,
  [129808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_EQ_GT,
  [129815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_RBRACK,
  [129822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4041), 1,
      anon_sym_RPAREN,
  [129829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7345), 1,
      anon_sym_RBRACK,
  [129836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym_RBRACK,
  [129843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_RBRACK,
  [129850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_RBRACK,
  [129857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7353), 1,
      sym_identifier,
  [129864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_COLON,
  [129871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7355), 1,
      anon_sym_RBRACK,
  [129878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7357), 1,
      anon_sym_RBRACK,
  [129885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7359), 1,
      anon_sym_RBRACK,
  [129892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_RPAREN,
  [129899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7361), 1,
      anon_sym_RBRACK,
  [129906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7363), 1,
      anon_sym_COLON,
  [129913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7365), 1,
      anon_sym_RBRACK,
  [129920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_RBRACK,
  [129927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_RBRACK,
  [129934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7371), 1,
      anon_sym_RBRACK,
  [129941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7373), 1,
      anon_sym_RBRACK,
  [129948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_RBRACK,
  [129955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_RPAREN,
  [129962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7379), 1,
      anon_sym_RBRACK,
  [129969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7381), 1,
      anon_sym_RBRACK,
  [129976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_RPAREN,
  [129983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7383), 1,
      anon_sym_RBRACK,
  [129990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7385), 1,
      anon_sym_RBRACK,
  [129997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7387), 1,
      anon_sym_RBRACK,
  [130004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_RPAREN,
  [130011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7389), 1,
      anon_sym_RBRACK,
  [130018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7391), 1,
      anon_sym_RBRACK,
  [130025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7393), 1,
      anon_sym_COLON,
  [130032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_RBRACK,
  [130039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7397), 1,
      anon_sym_RBRACK,
  [130046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_RBRACK,
  [130053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7401), 1,
      anon_sym_RBRACK,
  [130060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7403), 1,
      anon_sym_RBRACK,
  [130067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 1,
      anon_sym_RBRACK,
  [130074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
  [130081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7407), 1,
      anon_sym_RBRACK,
  [130088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7409), 1,
      anon_sym_RPAREN,
  [130095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 1,
      anon_sym_RBRACK,
  [130102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7413), 1,
      anon_sym_RBRACK,
  [130109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7415), 1,
      sym_identifier,
  [130116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      anon_sym_RBRACK,
  [130123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7419), 1,
      anon_sym_RBRACK,
  [130130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7421), 1,
      sym_identifier,
  [130137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_EQ_GT,
  [130144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7425), 1,
      sym_identifier,
  [130151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_RBRACK,
  [130158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7429), 1,
      anon_sym_RBRACK,
  [130165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_RBRACK,
  [130172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_RBRACK,
  [130179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7435), 1,
      anon_sym_RBRACK,
  [130186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_EQ,
  [130193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7439), 1,
      anon_sym_RBRACK,
  [130200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7441), 1,
      anon_sym_RBRACK,
  [130207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7443), 1,
      anon_sym_from,
  [130214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7445), 1,
      sym_identifier,
  [130221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 1,
      anon_sym_EQ,
  [130228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7449), 1,
      sym_identifier,
  [130235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7451), 1,
      anon_sym_RBRACK,
  [130242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_RBRACK,
  [130249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7455), 1,
      anon_sym_RBRACK,
  [130256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_RBRACK,
  [130263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7459), 1,
      anon_sym_RBRACK,
  [130270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7461), 1,
      anon_sym_EQ,
  [130277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7463), 1,
      anon_sym_RBRACK,
  [130284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      anon_sym_DOT,
  [130291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      anon_sym_EQ_GT,
  [130298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7467), 1,
      anon_sym_RBRACE,
  [130305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      sym_identifier,
  [130312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      sym_identifier,
  [130319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7473), 1,
      anon_sym_RPAREN,
  [130326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7475), 1,
      anon_sym_target,
  [130333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 1,
      anon_sym_EQ_GT,
  [130340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7479), 1,
      anon_sym_EQ_GT,
  [130347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      sym_identifier,
  [130354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7483), 1,
      anon_sym_class,
  [130361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_RPAREN,
  [130368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      anon_sym_RPAREN,
  [130375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_EQ,
  [130382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      anon_sym_RBRACK,
  [130389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7491), 1,
      sym_identifier,
  [130396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7493), 1,
      sym_identifier,
  [130403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7495), 1,
      anon_sym_EQ_GT,
  [130410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7497), 1,
      anon_sym_RBRACK,
  [130417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7499), 1,
      anon_sym_EQ,
  [130424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_EQ_GT,
  [130431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7503), 1,
      anon_sym_EQ_GT,
  [130438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7505), 1,
      anon_sym_EQ_GT,
  [130445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      sym_identifier,
  [130452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7507), 1,
      anon_sym_RBRACK,
  [130459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7509), 1,
      anon_sym_EQ_GT,
  [130466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7511), 1,
      anon_sym_target,
  [130473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_RPAREN,
  [130480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7513), 1,
      sym_identifier,
  [130487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7515), 1,
      anon_sym_EQ_GT,
  [130494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_EQ_GT,
  [130501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5021), 1,
      anon_sym_EQ_GT,
  [130508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7517), 1,
      anon_sym_RBRACK,
  [130515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7519), 1,
      sym_identifier,
  [130522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_EQ_GT,
  [130529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_SLASH2,
  [130536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7525), 1,
      sym_identifier,
  [130543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      sym_identifier,
  [130550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_EQ_GT,
  [130557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5159), 1,
      anon_sym_DOT,
  [130564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 1,
      sym_identifier,
  [130571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7533), 1,
      anon_sym_RPAREN,
  [130578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7535), 1,
      sym_number,
  [130585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7537), 1,
      sym_identifier,
  [130592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7539), 1,
      anon_sym_EQ_GT,
  [130599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7541), 1,
      anon_sym_EQ_GT,
  [130606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7543), 1,
      anon_sym_EQ_GT,
  [130613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6522), 1,
      anon_sym_RBRACK,
  [130620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_RBRACK,
  [130627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 1,
      anon_sym_RBRACK,
  [130634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_EQ_GT,
  [130641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      sym_identifier,
  [130648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_from,
  [130655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7553), 1,
      anon_sym_RPAREN,
  [130662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7555), 1,
      anon_sym_while,
  [130669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      anon_sym_EQ_GT,
  [130676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4126), 1,
      anon_sym_RPAREN,
  [130683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4533), 1,
      anon_sym_RPAREN,
  [130690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7559), 1,
      sym_identifier,
  [130697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      anon_sym_RPAREN,
  [130704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7563), 1,
      sym_identifier,
  [130711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7565), 1,
      sym_identifier,
  [130718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7567), 1,
      anon_sym_EQ,
  [130725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7569), 1,
      anon_sym_RBRACK,
  [130732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7571), 1,
      anon_sym_RPAREN,
  [130739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7573), 1,
      anon_sym_COLON,
  [130746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7575), 1,
      anon_sym_RBRACK,
  [130753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6502), 1,
      anon_sym_from,
  [130760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7577), 1,
      sym_identifier,
  [130767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7579), 1,
      anon_sym_EQ_GT,
  [130774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7581), 1,
      anon_sym_RBRACK,
  [130781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_EQ,
  [130788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_as,
  [130795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 1,
      anon_sym_RBRACK,
  [130802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7587), 1,
      anon_sym_EQ_GT,
  [130809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7589), 1,
      anon_sym_RBRACK,
  [130816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7591), 1,
      anon_sym_EQ_GT,
  [130823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7593), 1,
      anon_sym_EQ_GT,
  [130830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7595), 1,
      anon_sym_RBRACK,
  [130837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7597), 1,
      anon_sym_SLASH2,
  [130844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7599), 1,
      anon_sym_EQ_GT,
  [130851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7601), 1,
      anon_sym_EQ,
  [130858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7603), 1,
      anon_sym_RBRACK,
  [130865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7605), 1,
      sym_identifier,
  [130872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7607), 1,
      sym_number,
  [130879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7609), 1,
      anon_sym_RBRACK,
  [130886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7611), 1,
      anon_sym_EQ_GT,
  [130893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7613), 1,
      anon_sym_RBRACK,
  [130900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7615), 1,
      anon_sym_RBRACK,
  [130907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7617), 1,
      anon_sym_function,
  [130914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7619), 1,
      sym_identifier,
  [130921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7621), 1,
      sym_identifier,
  [130928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7623), 1,
      anon_sym_EQ,
  [130935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7625), 1,
      anon_sym_RBRACK,
  [130942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7627), 1,
      anon_sym_namespace,
  [130949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_RBRACK,
  [130956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7629), 1,
      anon_sym_EQ_GT,
  [130963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7631), 1,
      anon_sym_RBRACK,
  [130970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7633), 1,
      anon_sym_RBRACK,
  [130977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7635), 1,
      anon_sym_RBRACK,
  [130984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
  [130991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_EQ_GT,
  [130998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7639), 1,
      sym_identifier,
  [131005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 1,
      anon_sym_function,
  [131012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      ts_builtin_sym_end,
  [131019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7645), 1,
      sym_identifier,
  [131026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7647), 1,
      sym_identifier,
  [131033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      sym_identifier,
  [131040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_class,
  [131047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      sym_identifier,
  [131054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 1,
      sym_identifier,
  [131061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7657), 1,
      anon_sym_RBRACK,
  [131068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7659), 1,
      sym_identifier,
  [131075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7661), 1,
      anon_sym_RBRACK,
  [131082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_RBRACK,
  [131089] = 2,
    ACTIONS(6237), 1,
      sym_comment,
    ACTIONS(7665), 1,
      sym_regex_pattern,
  [131096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_EQ_GT,
  [131103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym_RBRACK,
  [131110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7671), 1,
      anon_sym_RBRACK,
  [131117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7673), 1,
      anon_sym_RBRACK,
  [131124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_RBRACK,
  [131131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7677), 1,
      anon_sym_RBRACK,
  [131138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 1,
      anon_sym_RBRACK,
  [131145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7681), 1,
      anon_sym_RBRACK,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(850)] = 0,
  [SMALL_STATE(851)] = 131,
  [SMALL_STATE(852)] = 262,
  [SMALL_STATE(853)] = 395,
  [SMALL_STATE(854)] = 526,
  [SMALL_STATE(855)] = 657,
  [SMALL_STATE(856)] = 788,
  [SMALL_STATE(857)] = 919,
  [SMALL_STATE(858)] = 1050,
  [SMALL_STATE(859)] = 1181,
  [SMALL_STATE(860)] = 1312,
  [SMALL_STATE(861)] = 1443,
  [SMALL_STATE(862)] = 1574,
  [SMALL_STATE(863)] = 1705,
  [SMALL_STATE(864)] = 1836,
  [SMALL_STATE(865)] = 1967,
  [SMALL_STATE(866)] = 2098,
  [SMALL_STATE(867)] = 2229,
  [SMALL_STATE(868)] = 2360,
  [SMALL_STATE(869)] = 2491,
  [SMALL_STATE(870)] = 2622,
  [SMALL_STATE(871)] = 2753,
  [SMALL_STATE(872)] = 2884,
  [SMALL_STATE(873)] = 3015,
  [SMALL_STATE(874)] = 3146,
  [SMALL_STATE(875)] = 3277,
  [SMALL_STATE(876)] = 3408,
  [SMALL_STATE(877)] = 3539,
  [SMALL_STATE(878)] = 3670,
  [SMALL_STATE(879)] = 3801,
  [SMALL_STATE(880)] = 3932,
  [SMALL_STATE(881)] = 4063,
  [SMALL_STATE(882)] = 4194,
  [SMALL_STATE(883)] = 4325,
  [SMALL_STATE(884)] = 4456,
  [SMALL_STATE(885)] = 4587,
  [SMALL_STATE(886)] = 4718,
  [SMALL_STATE(887)] = 4849,
  [SMALL_STATE(888)] = 4980,
  [SMALL_STATE(889)] = 5111,
  [SMALL_STATE(890)] = 5242,
  [SMALL_STATE(891)] = 5373,
  [SMALL_STATE(892)] = 5504,
  [SMALL_STATE(893)] = 5635,
  [SMALL_STATE(894)] = 5724,
  [SMALL_STATE(895)] = 5855,
  [SMALL_STATE(896)] = 5986,
  [SMALL_STATE(897)] = 6117,
  [SMALL_STATE(898)] = 6248,
  [SMALL_STATE(899)] = 6379,
  [SMALL_STATE(900)] = 6510,
  [SMALL_STATE(901)] = 6641,
  [SMALL_STATE(902)] = 6772,
  [SMALL_STATE(903)] = 6903,
  [SMALL_STATE(904)] = 7034,
  [SMALL_STATE(905)] = 7165,
  [SMALL_STATE(906)] = 7296,
  [SMALL_STATE(907)] = 7427,
  [SMALL_STATE(908)] = 7558,
  [SMALL_STATE(909)] = 7689,
  [SMALL_STATE(910)] = 7820,
  [SMALL_STATE(911)] = 7951,
  [SMALL_STATE(912)] = 8082,
  [SMALL_STATE(913)] = 8213,
  [SMALL_STATE(914)] = 8344,
  [SMALL_STATE(915)] = 8475,
  [SMALL_STATE(916)] = 8608,
  [SMALL_STATE(917)] = 8739,
  [SMALL_STATE(918)] = 8870,
  [SMALL_STATE(919)] = 9001,
  [SMALL_STATE(920)] = 9132,
  [SMALL_STATE(921)] = 9263,
  [SMALL_STATE(922)] = 9394,
  [SMALL_STATE(923)] = 9525,
  [SMALL_STATE(924)] = 9656,
  [SMALL_STATE(925)] = 9787,
  [SMALL_STATE(926)] = 9918,
  [SMALL_STATE(927)] = 10049,
  [SMALL_STATE(928)] = 10180,
  [SMALL_STATE(929)] = 10311,
  [SMALL_STATE(930)] = 10442,
  [SMALL_STATE(931)] = 10573,
  [SMALL_STATE(932)] = 10704,
  [SMALL_STATE(933)] = 10835,
  [SMALL_STATE(934)] = 10966,
  [SMALL_STATE(935)] = 11097,
  [SMALL_STATE(936)] = 11228,
  [SMALL_STATE(937)] = 11359,
  [SMALL_STATE(938)] = 11490,
  [SMALL_STATE(939)] = 11621,
  [SMALL_STATE(940)] = 11752,
  [SMALL_STATE(941)] = 11883,
  [SMALL_STATE(942)] = 12016,
  [SMALL_STATE(943)] = 12147,
  [SMALL_STATE(944)] = 12278,
  [SMALL_STATE(945)] = 12409,
  [SMALL_STATE(946)] = 12540,
  [SMALL_STATE(947)] = 12671,
  [SMALL_STATE(948)] = 12802,
  [SMALL_STATE(949)] = 12933,
  [SMALL_STATE(950)] = 13064,
  [SMALL_STATE(951)] = 13195,
  [SMALL_STATE(952)] = 13326,
  [SMALL_STATE(953)] = 13457,
  [SMALL_STATE(954)] = 13588,
  [SMALL_STATE(955)] = 13719,
  [SMALL_STATE(956)] = 13850,
  [SMALL_STATE(957)] = 13981,
  [SMALL_STATE(958)] = 14070,
  [SMALL_STATE(959)] = 14201,
  [SMALL_STATE(960)] = 14332,
  [SMALL_STATE(961)] = 14463,
  [SMALL_STATE(962)] = 14553,
  [SMALL_STATE(963)] = 14643,
  [SMALL_STATE(964)] = 14731,
  [SMALL_STATE(965)] = 14821,
  [SMALL_STATE(966)] = 14909,
  [SMALL_STATE(967)] = 14997,
  [SMALL_STATE(968)] = 15087,
  [SMALL_STATE(969)] = 15179,
  [SMALL_STATE(970)] = 15271,
  [SMALL_STATE(971)] = 15359,
  [SMALL_STATE(972)] = 15450,
  [SMALL_STATE(973)] = 15541,
  [SMALL_STATE(974)] = 15628,
  [SMALL_STATE(975)] = 15715,
  [SMALL_STATE(976)] = 15806,
  [SMALL_STATE(977)] = 15899,
  [SMALL_STATE(978)] = 16029,
  [SMALL_STATE(979)] = 16097,
  [SMALL_STATE(980)] = 16185,
  [SMALL_STATE(981)] = 16271,
  [SMALL_STATE(982)] = 16339,
  [SMALL_STATE(983)] = 16425,
  [SMALL_STATE(984)] = 16555,
  [SMALL_STATE(985)] = 16623,
  [SMALL_STATE(986)] = 16713,
  [SMALL_STATE(987)] = 16799,
  [SMALL_STATE(988)] = 16887,
  [SMALL_STATE(989)] = 16973,
  [SMALL_STATE(990)] = 17061,
  [SMALL_STATE(991)] = 17129,
  [SMALL_STATE(992)] = 17197,
  [SMALL_STATE(993)] = 17283,
  [SMALL_STATE(994)] = 17369,
  [SMALL_STATE(995)] = 17455,
  [SMALL_STATE(996)] = 17543,
  [SMALL_STATE(997)] = 17631,
  [SMALL_STATE(998)] = 17719,
  [SMALL_STATE(999)] = 17807,
  [SMALL_STATE(1000)] = 17895,
  [SMALL_STATE(1001)] = 17982,
  [SMALL_STATE(1002)] = 18049,
  [SMALL_STATE(1003)] = 18134,
  [SMALL_STATE(1004)] = 18219,
  [SMALL_STATE(1005)] = 18306,
  [SMALL_STATE(1006)] = 18395,
  [SMALL_STATE(1007)] = 18488,
  [SMALL_STATE(1008)] = 18575,
  [SMALL_STATE(1009)] = 18642,
  [SMALL_STATE(1010)] = 18713,
  [SMALL_STATE(1011)] = 18800,
  [SMALL_STATE(1012)] = 18885,
  [SMALL_STATE(1013)] = 18971,
  [SMALL_STATE(1014)] = 19055,
  [SMALL_STATE(1015)] = 19131,
  [SMALL_STATE(1016)] = 19217,
  [SMALL_STATE(1017)] = 19301,
  [SMALL_STATE(1018)] = 19377,
  [SMALL_STATE(1019)] = 19461,
  [SMALL_STATE(1020)] = 19539,
  [SMALL_STATE(1021)] = 19625,
  [SMALL_STATE(1022)] = 19701,
  [SMALL_STATE(1023)] = 19791,
  [SMALL_STATE(1024)] = 19867,
  [SMALL_STATE(1025)] = 19957,
  [SMALL_STATE(1026)] = 20033,
  [SMALL_STATE(1027)] = 20109,
  [SMALL_STATE(1028)] = 20187,
  [SMALL_STATE(1029)] = 20260,
  [SMALL_STATE(1030)] = 20345,
  [SMALL_STATE(1031)] = 20430,
  [SMALL_STATE(1032)] = 20511,
  [SMALL_STATE(1033)] = 20584,
  [SMALL_STATE(1034)] = 20669,
  [SMALL_STATE(1035)] = 20740,
  [SMALL_STATE(1036)] = 20813,
  [SMALL_STATE(1037)] = 20896,
  [SMALL_STATE(1038)] = 20973,
  [SMALL_STATE(1039)] = 21048,
  [SMALL_STATE(1040)] = 21119,
  [SMALL_STATE(1041)] = 21194,
  [SMALL_STATE(1042)] = 21281,
  [SMALL_STATE(1043)] = 21352,
  [SMALL_STATE(1044)] = 21435,
  [SMALL_STATE(1045)] = 21518,
  [SMALL_STATE(1046)] = 21589,
  [SMALL_STATE(1047)] = 21666,
  [SMALL_STATE(1048)] = 21747,
  [SMALL_STATE(1049)] = 21832,
  [SMALL_STATE(1050)] = 21917,
  [SMALL_STATE(1051)] = 21999,
  [SMALL_STATE(1052)] = 22069,
  [SMALL_STATE(1053)] = 22147,
  [SMALL_STATE(1054)] = 22211,
  [SMALL_STATE(1055)] = 22279,
  [SMALL_STATE(1056)] = 22351,
  [SMALL_STATE(1057)] = 22423,
  [SMALL_STATE(1058)] = 22505,
  [SMALL_STATE(1059)] = 22569,
  [SMALL_STATE(1060)] = 22633,
  [SMALL_STATE(1061)] = 22701,
  [SMALL_STATE(1062)] = 22771,
  [SMALL_STATE(1063)] = 22855,
  [SMALL_STATE(1064)] = 22931,
  [SMALL_STATE(1065)] = 23003,
  [SMALL_STATE(1066)] = 23083,
  [SMALL_STATE(1067)] = 23147,
  [SMALL_STATE(1068)] = 23223,
  [SMALL_STATE(1069)] = 23299,
  [SMALL_STATE(1070)] = 23373,
  [SMALL_STATE(1071)] = 23443,
  [SMALL_STATE(1072)] = 23507,
  [SMALL_STATE(1073)] = 23571,
  [SMALL_STATE(1074)] = 23641,
  [SMALL_STATE(1075)] = 23725,
  [SMALL_STATE(1076)] = 23797,
  [SMALL_STATE(1077)] = 23871,
  [SMALL_STATE(1078)] = 23945,
  [SMALL_STATE(1079)] = 24015,
  [SMALL_STATE(1080)] = 24079,
  [SMALL_STATE(1081)] = 24149,
  [SMALL_STATE(1082)] = 24219,
  [SMALL_STATE(1083)] = 24289,
  [SMALL_STATE(1084)] = 24367,
  [SMALL_STATE(1085)] = 24442,
  [SMALL_STATE(1086)] = 24513,
  [SMALL_STATE(1087)] = 24584,
  [SMALL_STATE(1088)] = 24653,
  [SMALL_STATE(1089)] = 24724,
  [SMALL_STATE(1090)] = 24799,
  [SMALL_STATE(1091)] = 24876,
  [SMALL_STATE(1092)] = 24959,
  [SMALL_STATE(1093)] = 25042,
  [SMALL_STATE(1094)] = 25117,
  [SMALL_STATE(1095)] = 25188,
  [SMALL_STATE(1096)] = 25257,
  [SMALL_STATE(1097)] = 25324,
  [SMALL_STATE(1098)] = 25393,
  [SMALL_STATE(1099)] = 25474,
  [SMALL_STATE(1100)] = 25545,
  [SMALL_STATE(1101)] = 25612,
  [SMALL_STATE(1102)] = 25681,
  [SMALL_STATE(1103)] = 25750,
  [SMALL_STATE(1104)] = 25819,
  [SMALL_STATE(1105)] = 25887,
  [SMALL_STATE(1106)] = 25959,
  [SMALL_STATE(1107)] = 26027,
  [SMALL_STATE(1108)] = 26095,
  [SMALL_STATE(1109)] = 26163,
  [SMALL_STATE(1110)] = 26229,
  [SMALL_STATE(1111)] = 26297,
  [SMALL_STATE(1112)] = 26369,
  [SMALL_STATE(1113)] = 26437,
  [SMALL_STATE(1114)] = 26509,
  [SMALL_STATE(1115)] = 26577,
  [SMALL_STATE(1116)] = 26649,
  [SMALL_STATE(1117)] = 26719,
  [SMALL_STATE(1118)] = 26789,
  [SMALL_STATE(1119)] = 26851,
  [SMALL_STATE(1120)] = 26919,
  [SMALL_STATE(1121)] = 26993,
  [SMALL_STATE(1122)] = 27063,
  [SMALL_STATE(1123)] = 27134,
  [SMALL_STATE(1124)] = 27201,
  [SMALL_STATE(1125)] = 27266,
  [SMALL_STATE(1126)] = 27327,
  [SMALL_STATE(1127)] = 27396,
  [SMALL_STATE(1128)] = 27461,
  [SMALL_STATE(1129)] = 27528,
  [SMALL_STATE(1130)] = 27589,
  [SMALL_STATE(1131)] = 27658,
  [SMALL_STATE(1132)] = 27719,
  [SMALL_STATE(1133)] = 27786,
  [SMALL_STATE(1134)] = 27853,
  [SMALL_STATE(1135)] = 27924,
  [SMALL_STATE(1136)] = 27988,
  [SMALL_STATE(1137)] = 28054,
  [SMALL_STATE(1138)] = 28120,
  [SMALL_STATE(1139)] = 28188,
  [SMALL_STATE(1140)] = 28254,
  [SMALL_STATE(1141)] = 28367,
  [SMALL_STATE(1142)] = 28480,
  [SMALL_STATE(1143)] = 28593,
  [SMALL_STATE(1144)] = 28706,
  [SMALL_STATE(1145)] = 28819,
  [SMALL_STATE(1146)] = 28932,
  [SMALL_STATE(1147)] = 29050,
  [SMALL_STATE(1148)] = 29168,
  [SMALL_STATE(1149)] = 29286,
  [SMALL_STATE(1150)] = 29404,
  [SMALL_STATE(1151)] = 29522,
  [SMALL_STATE(1152)] = 29631,
  [SMALL_STATE(1153)] = 29740,
  [SMALL_STATE(1154)] = 29849,
  [SMALL_STATE(1155)] = 29958,
  [SMALL_STATE(1156)] = 30067,
  [SMALL_STATE(1157)] = 30176,
  [SMALL_STATE(1158)] = 30285,
  [SMALL_STATE(1159)] = 30394,
  [SMALL_STATE(1160)] = 30471,
  [SMALL_STATE(1161)] = 30580,
  [SMALL_STATE(1162)] = 30689,
  [SMALL_STATE(1163)] = 30798,
  [SMALL_STATE(1164)] = 30907,
  [SMALL_STATE(1165)] = 31016,
  [SMALL_STATE(1166)] = 31125,
  [SMALL_STATE(1167)] = 31234,
  [SMALL_STATE(1168)] = 31343,
  [SMALL_STATE(1169)] = 31452,
  [SMALL_STATE(1170)] = 31561,
  [SMALL_STATE(1171)] = 31669,
  [SMALL_STATE(1172)] = 31779,
  [SMALL_STATE(1173)] = 31884,
  [SMALL_STATE(1174)] = 31939,
  [SMALL_STATE(1175)] = 31994,
  [SMALL_STATE(1176)] = 32099,
  [SMALL_STATE(1177)] = 32204,
  [SMALL_STATE(1178)] = 32309,
  [SMALL_STATE(1179)] = 32414,
  [SMALL_STATE(1180)] = 32519,
  [SMALL_STATE(1181)] = 32624,
  [SMALL_STATE(1182)] = 32722,
  [SMALL_STATE(1183)] = 32820,
  [SMALL_STATE(1184)] = 32918,
  [SMALL_STATE(1185)] = 33016,
  [SMALL_STATE(1186)] = 33114,
  [SMALL_STATE(1187)] = 33212,
  [SMALL_STATE(1188)] = 33310,
  [SMALL_STATE(1189)] = 33372,
  [SMALL_STATE(1190)] = 33435,
  [SMALL_STATE(1191)] = 33498,
  [SMALL_STATE(1192)] = 33561,
  [SMALL_STATE(1193)] = 33620,
  [SMALL_STATE(1194)] = 33675,
  [SMALL_STATE(1195)] = 33734,
  [SMALL_STATE(1196)] = 33791,
  [SMALL_STATE(1197)] = 33848,
  [SMALL_STATE(1198)] = 33905,
  [SMALL_STATE(1199)] = 33972,
  [SMALL_STATE(1200)] = 34025,
  [SMALL_STATE(1201)] = 34078,
  [SMALL_STATE(1202)] = 34130,
  [SMALL_STATE(1203)] = 34182,
  [SMALL_STATE(1204)] = 34234,
  [SMALL_STATE(1205)] = 34288,
  [SMALL_STATE(1206)] = 34346,
  [SMALL_STATE(1207)] = 34398,
  [SMALL_STATE(1208)] = 34450,
  [SMALL_STATE(1209)] = 34502,
  [SMALL_STATE(1210)] = 34554,
  [SMALL_STATE(1211)] = 34608,
  [SMALL_STATE(1212)] = 34660,
  [SMALL_STATE(1213)] = 34712,
  [SMALL_STATE(1214)] = 34764,
  [SMALL_STATE(1215)] = 34816,
  [SMALL_STATE(1216)] = 34872,
  [SMALL_STATE(1217)] = 34924,
  [SMALL_STATE(1218)] = 34982,
  [SMALL_STATE(1219)] = 35034,
  [SMALL_STATE(1220)] = 35086,
  [SMALL_STATE(1221)] = 35138,
  [SMALL_STATE(1222)] = 35190,
  [SMALL_STATE(1223)] = 35246,
  [SMALL_STATE(1224)] = 35304,
  [SMALL_STATE(1225)] = 35356,
  [SMALL_STATE(1226)] = 35410,
  [SMALL_STATE(1227)] = 35462,
  [SMALL_STATE(1228)] = 35516,
  [SMALL_STATE(1229)] = 35568,
  [SMALL_STATE(1230)] = 35620,
  [SMALL_STATE(1231)] = 35672,
  [SMALL_STATE(1232)] = 35728,
  [SMALL_STATE(1233)] = 35786,
  [SMALL_STATE(1234)] = 35838,
  [SMALL_STATE(1235)] = 35890,
  [SMALL_STATE(1236)] = 35942,
  [SMALL_STATE(1237)] = 35994,
  [SMALL_STATE(1238)] = 36046,
  [SMALL_STATE(1239)] = 36098,
  [SMALL_STATE(1240)] = 36150,
  [SMALL_STATE(1241)] = 36202,
  [SMALL_STATE(1242)] = 36254,
  [SMALL_STATE(1243)] = 36306,
  [SMALL_STATE(1244)] = 36358,
  [SMALL_STATE(1245)] = 36416,
  [SMALL_STATE(1246)] = 36470,
  [SMALL_STATE(1247)] = 36522,
  [SMALL_STATE(1248)] = 36574,
  [SMALL_STATE(1249)] = 36626,
  [SMALL_STATE(1250)] = 36678,
  [SMALL_STATE(1251)] = 36730,
  [SMALL_STATE(1252)] = 36782,
  [SMALL_STATE(1253)] = 36836,
  [SMALL_STATE(1254)] = 36888,
  [SMALL_STATE(1255)] = 36940,
  [SMALL_STATE(1256)] = 36992,
  [SMALL_STATE(1257)] = 37044,
  [SMALL_STATE(1258)] = 37100,
  [SMALL_STATE(1259)] = 37160,
  [SMALL_STATE(1260)] = 37212,
  [SMALL_STATE(1261)] = 37264,
  [SMALL_STATE(1262)] = 37318,
  [SMALL_STATE(1263)] = 37370,
  [SMALL_STATE(1264)] = 37422,
  [SMALL_STATE(1265)] = 37480,
  [SMALL_STATE(1266)] = 37538,
  [SMALL_STATE(1267)] = 37590,
  [SMALL_STATE(1268)] = 37650,
  [SMALL_STATE(1269)] = 37702,
  [SMALL_STATE(1270)] = 37756,
  [SMALL_STATE(1271)] = 37808,
  [SMALL_STATE(1272)] = 37860,
  [SMALL_STATE(1273)] = 37912,
  [SMALL_STATE(1274)] = 37964,
  [SMALL_STATE(1275)] = 38016,
  [SMALL_STATE(1276)] = 38068,
  [SMALL_STATE(1277)] = 38120,
  [SMALL_STATE(1278)] = 38172,
  [SMALL_STATE(1279)] = 38224,
  [SMALL_STATE(1280)] = 38276,
  [SMALL_STATE(1281)] = 38334,
  [SMALL_STATE(1282)] = 38386,
  [SMALL_STATE(1283)] = 38440,
  [SMALL_STATE(1284)] = 38492,
  [SMALL_STATE(1285)] = 38544,
  [SMALL_STATE(1286)] = 38596,
  [SMALL_STATE(1287)] = 38648,
  [SMALL_STATE(1288)] = 38700,
  [SMALL_STATE(1289)] = 38752,
  [SMALL_STATE(1290)] = 38804,
  [SMALL_STATE(1291)] = 38856,
  [SMALL_STATE(1292)] = 38908,
  [SMALL_STATE(1293)] = 38960,
  [SMALL_STATE(1294)] = 39016,
  [SMALL_STATE(1295)] = 39068,
  [SMALL_STATE(1296)] = 39120,
  [SMALL_STATE(1297)] = 39172,
  [SMALL_STATE(1298)] = 39262,
  [SMALL_STATE(1299)] = 39314,
  [SMALL_STATE(1300)] = 39366,
  [SMALL_STATE(1301)] = 39417,
  [SMALL_STATE(1302)] = 39468,
  [SMALL_STATE(1303)] = 39521,
  [SMALL_STATE(1304)] = 39572,
  [SMALL_STATE(1305)] = 39623,
  [SMALL_STATE(1306)] = 39728,
  [SMALL_STATE(1307)] = 39779,
  [SMALL_STATE(1308)] = 39884,
  [SMALL_STATE(1309)] = 39937,
  [SMALL_STATE(1310)] = 40042,
  [SMALL_STATE(1311)] = 40093,
  [SMALL_STATE(1312)] = 40144,
  [SMALL_STATE(1313)] = 40195,
  [SMALL_STATE(1314)] = 40252,
  [SMALL_STATE(1315)] = 40303,
  [SMALL_STATE(1316)] = 40354,
  [SMALL_STATE(1317)] = 40405,
  [SMALL_STATE(1318)] = 40460,
  [SMALL_STATE(1319)] = 40511,
  [SMALL_STATE(1320)] = 40562,
  [SMALL_STATE(1321)] = 40613,
  [SMALL_STATE(1322)] = 40664,
  [SMALL_STATE(1323)] = 40715,
  [SMALL_STATE(1324)] = 40766,
  [SMALL_STATE(1325)] = 40817,
  [SMALL_STATE(1326)] = 40870,
  [SMALL_STATE(1327)] = 40921,
  [SMALL_STATE(1328)] = 40990,
  [SMALL_STATE(1329)] = 41041,
  [SMALL_STATE(1330)] = 41098,
  [SMALL_STATE(1331)] = 41157,
  [SMALL_STATE(1332)] = 41208,
  [SMALL_STATE(1333)] = 41259,
  [SMALL_STATE(1334)] = 41316,
  [SMALL_STATE(1335)] = 41389,
  [SMALL_STATE(1336)] = 41494,
  [SMALL_STATE(1337)] = 41547,
  [SMALL_STATE(1338)] = 41602,
  [SMALL_STATE(1339)] = 41655,
  [SMALL_STATE(1340)] = 41706,
  [SMALL_STATE(1341)] = 41757,
  [SMALL_STATE(1342)] = 41862,
  [SMALL_STATE(1343)] = 41967,
  [SMALL_STATE(1344)] = 42018,
  [SMALL_STATE(1345)] = 42069,
  [SMALL_STATE(1346)] = 42120,
  [SMALL_STATE(1347)] = 42219,
  [SMALL_STATE(1348)] = 42304,
  [SMALL_STATE(1349)] = 42355,
  [SMALL_STATE(1350)] = 42424,
  [SMALL_STATE(1351)] = 42479,
  [SMALL_STATE(1352)] = 42550,
  [SMALL_STATE(1353)] = 42601,
  [SMALL_STATE(1354)] = 42676,
  [SMALL_STATE(1355)] = 42727,
  [SMALL_STATE(1356)] = 42778,
  [SMALL_STATE(1357)] = 42871,
  [SMALL_STATE(1358)] = 42922,
  [SMALL_STATE(1359)] = 43013,
  [SMALL_STATE(1360)] = 43102,
  [SMALL_STATE(1361)] = 43153,
  [SMALL_STATE(1362)] = 43230,
  [SMALL_STATE(1363)] = 43281,
  [SMALL_STATE(1364)] = 43386,
  [SMALL_STATE(1365)] = 43491,
  [SMALL_STATE(1366)] = 43542,
  [SMALL_STATE(1367)] = 43639,
  [SMALL_STATE(1368)] = 43690,
  [SMALL_STATE(1369)] = 43785,
  [SMALL_STATE(1370)] = 43836,
  [SMALL_STATE(1371)] = 43887,
  [SMALL_STATE(1372)] = 43948,
  [SMALL_STATE(1373)] = 43999,
  [SMALL_STATE(1374)] = 44050,
  [SMALL_STATE(1375)] = 44101,
  [SMALL_STATE(1376)] = 44206,
  [SMALL_STATE(1377)] = 44257,
  [SMALL_STATE(1378)] = 44324,
  [SMALL_STATE(1379)] = 44375,
  [SMALL_STATE(1380)] = 44480,
  [SMALL_STATE(1381)] = 44531,
  [SMALL_STATE(1382)] = 44582,
  [SMALL_STATE(1383)] = 44633,
  [SMALL_STATE(1384)] = 44684,
  [SMALL_STATE(1385)] = 44735,
  [SMALL_STATE(1386)] = 44786,
  [SMALL_STATE(1387)] = 44837,
  [SMALL_STATE(1388)] = 44888,
  [SMALL_STATE(1389)] = 44939,
  [SMALL_STATE(1390)] = 44990,
  [SMALL_STATE(1391)] = 45095,
  [SMALL_STATE(1392)] = 45152,
  [SMALL_STATE(1393)] = 45203,
  [SMALL_STATE(1394)] = 45254,
  [SMALL_STATE(1395)] = 45305,
  [SMALL_STATE(1396)] = 45356,
  [SMALL_STATE(1397)] = 45437,
  [SMALL_STATE(1398)] = 45488,
  [SMALL_STATE(1399)] = 45539,
  [SMALL_STATE(1400)] = 45590,
  [SMALL_STATE(1401)] = 45641,
  [SMALL_STATE(1402)] = 45748,
  [SMALL_STATE(1403)] = 45853,
  [SMALL_STATE(1404)] = 45904,
  [SMALL_STATE(1405)] = 45998,
  [SMALL_STATE(1406)] = 46106,
  [SMALL_STATE(1407)] = 46210,
  [SMALL_STATE(1408)] = 46292,
  [SMALL_STATE(1409)] = 46396,
  [SMALL_STATE(1410)] = 46506,
  [SMALL_STATE(1411)] = 46574,
  [SMALL_STATE(1412)] = 46634,
  [SMALL_STATE(1413)] = 46692,
  [SMALL_STATE(1414)] = 46762,
  [SMALL_STATE(1415)] = 46842,
  [SMALL_STATE(1416)] = 46896,
  [SMALL_STATE(1417)] = 46956,
  [SMALL_STATE(1418)] = 47050,
  [SMALL_STATE(1419)] = 47154,
  [SMALL_STATE(1420)] = 47258,
  [SMALL_STATE(1421)] = 47328,
  [SMALL_STATE(1422)] = 47424,
  [SMALL_STATE(1423)] = 47500,
  [SMALL_STATE(1424)] = 47580,
  [SMALL_STATE(1425)] = 47686,
  [SMALL_STATE(1426)] = 47746,
  [SMALL_STATE(1427)] = 47840,
  [SMALL_STATE(1428)] = 47896,
  [SMALL_STATE(1429)] = 47984,
  [SMALL_STATE(1430)] = 48074,
  [SMALL_STATE(1431)] = 48168,
  [SMALL_STATE(1432)] = 48260,
  [SMALL_STATE(1433)] = 48334,
  [SMALL_STATE(1434)] = 48402,
  [SMALL_STATE(1435)] = 48486,
  [SMALL_STATE(1436)] = 48584,
  [SMALL_STATE(1437)] = 48688,
  [SMALL_STATE(1438)] = 48792,
  [SMALL_STATE(1439)] = 48886,
  [SMALL_STATE(1440)] = 48994,
  [SMALL_STATE(1441)] = 49102,
  [SMALL_STATE(1442)] = 49210,
  [SMALL_STATE(1443)] = 49314,
  [SMALL_STATE(1444)] = 49380,
  [SMALL_STATE(1445)] = 49444,
  [SMALL_STATE(1446)] = 49552,
  [SMALL_STATE(1447)] = 49608,
  [SMALL_STATE(1448)] = 49704,
  [SMALL_STATE(1449)] = 49780,
  [SMALL_STATE(1450)] = 49884,
  [SMALL_STATE(1451)] = 49972,
  [SMALL_STATE(1452)] = 50024,
  [SMALL_STATE(1453)] = 50128,
  [SMALL_STATE(1454)] = 50182,
  [SMALL_STATE(1455)] = 50286,
  [SMALL_STATE(1456)] = 50390,
  [SMALL_STATE(1457)] = 50480,
  [SMALL_STATE(1458)] = 50572,
  [SMALL_STATE(1459)] = 50632,
  [SMALL_STATE(1460)] = 50706,
  [SMALL_STATE(1461)] = 50760,
  [SMALL_STATE(1462)] = 50870,
  [SMALL_STATE(1463)] = 50938,
  [SMALL_STATE(1464)] = 51022,
  [SMALL_STATE(1465)] = 51120,
  [SMALL_STATE(1466)] = 51224,
  [SMALL_STATE(1467)] = 51328,
  [SMALL_STATE(1468)] = 51432,
  [SMALL_STATE(1469)] = 51492,
  [SMALL_STATE(1470)] = 51560,
  [SMALL_STATE(1471)] = 51614,
  [SMALL_STATE(1472)] = 51686,
  [SMALL_STATE(1473)] = 51790,
  [SMALL_STATE(1474)] = 51894,
  [SMALL_STATE(1475)] = 51954,
  [SMALL_STATE(1476)] = 52048,
  [SMALL_STATE(1477)] = 52158,
  [SMALL_STATE(1478)] = 52252,
  [SMALL_STATE(1479)] = 52362,
  [SMALL_STATE(1480)] = 52418,
  [SMALL_STATE(1481)] = 52484,
  [SMALL_STATE(1482)] = 52544,
  [SMALL_STATE(1483)] = 52650,
  [SMALL_STATE(1484)] = 52706,
  [SMALL_STATE(1485)] = 52764,
  [SMALL_STATE(1486)] = 52868,
  [SMALL_STATE(1487)] = 52962,
  [SMALL_STATE(1488)] = 53020,
  [SMALL_STATE(1489)] = 53114,
  [SMALL_STATE(1490)] = 53218,
  [SMALL_STATE(1491)] = 53290,
  [SMALL_STATE(1492)] = 53394,
  [SMALL_STATE(1493)] = 53498,
  [SMALL_STATE(1494)] = 53602,
  [SMALL_STATE(1495)] = 53684,
  [SMALL_STATE(1496)] = 53788,
  [SMALL_STATE(1497)] = 53892,
  [SMALL_STATE(1498)] = 53986,
  [SMALL_STATE(1499)] = 54080,
  [SMALL_STATE(1500)] = 54162,
  [SMALL_STATE(1501)] = 54220,
  [SMALL_STATE(1502)] = 54324,
  [SMALL_STATE(1503)] = 54418,
  [SMALL_STATE(1504)] = 54522,
  [SMALL_STATE(1505)] = 54604,
  [SMALL_STATE(1506)] = 54698,
  [SMALL_STATE(1507)] = 54780,
  [SMALL_STATE(1508)] = 54829,
  [SMALL_STATE(1509)] = 54878,
  [SMALL_STATE(1510)] = 54933,
  [SMALL_STATE(1511)] = 54994,
  [SMALL_STATE(1512)] = 55055,
  [SMALL_STATE(1513)] = 55104,
  [SMALL_STATE(1514)] = 55159,
  [SMALL_STATE(1515)] = 55264,
  [SMALL_STATE(1516)] = 55319,
  [SMALL_STATE(1517)] = 55368,
  [SMALL_STATE(1518)] = 55417,
  [SMALL_STATE(1519)] = 55468,
  [SMALL_STATE(1520)] = 55575,
  [SMALL_STATE(1521)] = 55624,
  [SMALL_STATE(1522)] = 55673,
  [SMALL_STATE(1523)] = 55722,
  [SMALL_STATE(1524)] = 55771,
  [SMALL_STATE(1525)] = 55820,
  [SMALL_STATE(1526)] = 55869,
  [SMALL_STATE(1527)] = 55918,
  [SMALL_STATE(1528)] = 55967,
  [SMALL_STATE(1529)] = 56016,
  [SMALL_STATE(1530)] = 56065,
  [SMALL_STATE(1531)] = 56114,
  [SMALL_STATE(1532)] = 56163,
  [SMALL_STATE(1533)] = 56212,
  [SMALL_STATE(1534)] = 56261,
  [SMALL_STATE(1535)] = 56310,
  [SMALL_STATE(1536)] = 56359,
  [SMALL_STATE(1537)] = 56408,
  [SMALL_STATE(1538)] = 56457,
  [SMALL_STATE(1539)] = 56506,
  [SMALL_STATE(1540)] = 56555,
  [SMALL_STATE(1541)] = 56604,
  [SMALL_STATE(1542)] = 56679,
  [SMALL_STATE(1543)] = 56732,
  [SMALL_STATE(1544)] = 56805,
  [SMALL_STATE(1545)] = 56858,
  [SMALL_STATE(1546)] = 56907,
  [SMALL_STATE(1547)] = 57014,
  [SMALL_STATE(1548)] = 57075,
  [SMALL_STATE(1549)] = 57136,
  [SMALL_STATE(1550)] = 57197,
  [SMALL_STATE(1551)] = 57272,
  [SMALL_STATE(1552)] = 57345,
  [SMALL_STATE(1553)] = 57406,
  [SMALL_STATE(1554)] = 57509,
  [SMALL_STATE(1555)] = 57560,
  [SMALL_STATE(1556)] = 57609,
  [SMALL_STATE(1557)] = 57670,
  [SMALL_STATE(1558)] = 57723,
  [SMALL_STATE(1559)] = 57772,
  [SMALL_STATE(1560)] = 57821,
  [SMALL_STATE(1561)] = 57870,
  [SMALL_STATE(1562)] = 57973,
  [SMALL_STATE(1563)] = 58028,
  [SMALL_STATE(1564)] = 58079,
  [SMALL_STATE(1565)] = 58128,
  [SMALL_STATE(1566)] = 58177,
  [SMALL_STATE(1567)] = 58226,
  [SMALL_STATE(1568)] = 58281,
  [SMALL_STATE(1569)] = 58336,
  [SMALL_STATE(1570)] = 58385,
  [SMALL_STATE(1571)] = 58434,
  [SMALL_STATE(1572)] = 58483,
  [SMALL_STATE(1573)] = 58532,
  [SMALL_STATE(1574)] = 58581,
  [SMALL_STATE(1575)] = 58630,
  [SMALL_STATE(1576)] = 58679,
  [SMALL_STATE(1577)] = 58728,
  [SMALL_STATE(1578)] = 58777,
  [SMALL_STATE(1579)] = 58828,
  [SMALL_STATE(1580)] = 58877,
  [SMALL_STATE(1581)] = 58926,
  [SMALL_STATE(1582)] = 58975,
  [SMALL_STATE(1583)] = 59024,
  [SMALL_STATE(1584)] = 59073,
  [SMALL_STATE(1585)] = 59124,
  [SMALL_STATE(1586)] = 59173,
  [SMALL_STATE(1587)] = 59230,
  [SMALL_STATE(1588)] = 59285,
  [SMALL_STATE(1589)] = 59334,
  [SMALL_STATE(1590)] = 59441,
  [SMALL_STATE(1591)] = 59490,
  [SMALL_STATE(1592)] = 59595,
  [SMALL_STATE(1593)] = 59646,
  [SMALL_STATE(1594)] = 59701,
  [SMALL_STATE(1595)] = 59750,
  [SMALL_STATE(1596)] = 59799,
  [SMALL_STATE(1597)] = 59848,
  [SMALL_STATE(1598)] = 59923,
  [SMALL_STATE(1599)] = 59986,
  [SMALL_STATE(1600)] = 60049,
  [SMALL_STATE(1601)] = 60098,
  [SMALL_STATE(1602)] = 60151,
  [SMALL_STATE(1603)] = 60256,
  [SMALL_STATE(1604)] = 60311,
  [SMALL_STATE(1605)] = 60368,
  [SMALL_STATE(1606)] = 60441,
  [SMALL_STATE(1607)] = 60498,
  [SMALL_STATE(1608)] = 60547,
  [SMALL_STATE(1609)] = 60602,
  [SMALL_STATE(1610)] = 60657,
  [SMALL_STATE(1611)] = 60706,
  [SMALL_STATE(1612)] = 60755,
  [SMALL_STATE(1613)] = 60804,
  [SMALL_STATE(1614)] = 60853,
  [SMALL_STATE(1615)] = 60902,
  [SMALL_STATE(1616)] = 61009,
  [SMALL_STATE(1617)] = 61060,
  [SMALL_STATE(1618)] = 61165,
  [SMALL_STATE(1619)] = 61222,
  [SMALL_STATE(1620)] = 61271,
  [SMALL_STATE(1621)] = 61378,
  [SMALL_STATE(1622)] = 61427,
  [SMALL_STATE(1623)] = 61478,
  [SMALL_STATE(1624)] = 61585,
  [SMALL_STATE(1625)] = 61646,
  [SMALL_STATE(1626)] = 61695,
  [SMALL_STATE(1627)] = 61756,
  [SMALL_STATE(1628)] = 61805,
  [SMALL_STATE(1629)] = 61854,
  [SMALL_STATE(1630)] = 61909,
  [SMALL_STATE(1631)] = 61960,
  [SMALL_STATE(1632)] = 62067,
  [SMALL_STATE(1633)] = 62170,
  [SMALL_STATE(1634)] = 62219,
  [SMALL_STATE(1635)] = 62268,
  [SMALL_STATE(1636)] = 62371,
  [SMALL_STATE(1637)] = 62420,
  [SMALL_STATE(1638)] = 62487,
  [SMALL_STATE(1639)] = 62558,
  [SMALL_STATE(1640)] = 62661,
  [SMALL_STATE(1641)] = 62716,
  [SMALL_STATE(1642)] = 62781,
  [SMALL_STATE(1643)] = 62884,
  [SMALL_STATE(1644)] = 62935,
  [SMALL_STATE(1645)] = 62994,
  [SMALL_STATE(1646)] = 63101,
  [SMALL_STATE(1647)] = 63204,
  [SMALL_STATE(1648)] = 63259,
  [SMALL_STATE(1649)] = 63362,
  [SMALL_STATE(1650)] = 63465,
  [SMALL_STATE(1651)] = 63518,
  [SMALL_STATE(1652)] = 63571,
  [SMALL_STATE(1653)] = 63678,
  [SMALL_STATE(1654)] = 63781,
  [SMALL_STATE(1655)] = 63884,
  [SMALL_STATE(1656)] = 63991,
  [SMALL_STATE(1657)] = 64060,
  [SMALL_STATE(1658)] = 64139,
  [SMALL_STATE(1659)] = 64212,
  [SMALL_STATE(1660)] = 64287,
  [SMALL_STATE(1661)] = 64360,
  [SMALL_STATE(1662)] = 64463,
  [SMALL_STATE(1663)] = 64538,
  [SMALL_STATE(1664)] = 64589,
  [SMALL_STATE(1665)] = 64682,
  [SMALL_STATE(1666)] = 64731,
  [SMALL_STATE(1667)] = 64826,
  [SMALL_STATE(1668)] = 64877,
  [SMALL_STATE(1669)] = 64952,
  [SMALL_STATE(1670)] = 65001,
  [SMALL_STATE(1671)] = 65088,
  [SMALL_STATE(1672)] = 65191,
  [SMALL_STATE(1673)] = 65280,
  [SMALL_STATE(1674)] = 65329,
  [SMALL_STATE(1675)] = 65420,
  [SMALL_STATE(1676)] = 65493,
  [SMALL_STATE(1677)] = 65560,
  [SMALL_STATE(1678)] = 65643,
  [SMALL_STATE(1679)] = 65740,
  [SMALL_STATE(1680)] = 65843,
  [SMALL_STATE(1681)] = 65946,
  [SMALL_STATE(1682)] = 65995,
  [SMALL_STATE(1683)] = 66098,
  [SMALL_STATE(1684)] = 66201,
  [SMALL_STATE(1685)] = 66306,
  [SMALL_STATE(1686)] = 66356,
  [SMALL_STATE(1687)] = 66458,
  [SMALL_STATE(1688)] = 66560,
  [SMALL_STATE(1689)] = 66608,
  [SMALL_STATE(1690)] = 66672,
  [SMALL_STATE(1691)] = 66774,
  [SMALL_STATE(1692)] = 66844,
  [SMALL_STATE(1693)] = 66900,
  [SMALL_STATE(1694)] = 67002,
  [SMALL_STATE(1695)] = 67068,
  [SMALL_STATE(1696)] = 67136,
  [SMALL_STATE(1697)] = 67238,
  [SMALL_STATE(1698)] = 67286,
  [SMALL_STATE(1699)] = 67336,
  [SMALL_STATE(1700)] = 67438,
  [SMALL_STATE(1701)] = 67490,
  [SMALL_STATE(1702)] = 67592,
  [SMALL_STATE(1703)] = 67694,
  [SMALL_STATE(1704)] = 67798,
  [SMALL_STATE(1705)] = 67850,
  [SMALL_STATE(1706)] = 67954,
  [SMALL_STATE(1707)] = 68022,
  [SMALL_STATE(1708)] = 68072,
  [SMALL_STATE(1709)] = 68122,
  [SMALL_STATE(1710)] = 68226,
  [SMALL_STATE(1711)] = 68274,
  [SMALL_STATE(1712)] = 68326,
  [SMALL_STATE(1713)] = 68398,
  [SMALL_STATE(1714)] = 68500,
  [SMALL_STATE(1715)] = 68550,
  [SMALL_STATE(1716)] = 68652,
  [SMALL_STATE(1717)] = 68704,
  [SMALL_STATE(1718)] = 68800,
  [SMALL_STATE(1719)] = 68848,
  [SMALL_STATE(1720)] = 68930,
  [SMALL_STATE(1721)] = 68996,
  [SMALL_STATE(1722)] = 69068,
  [SMALL_STATE(1723)] = 69118,
  [SMALL_STATE(1724)] = 69176,
  [SMALL_STATE(1725)] = 69266,
  [SMALL_STATE(1726)] = 69354,
  [SMALL_STATE(1727)] = 69402,
  [SMALL_STATE(1728)] = 69488,
  [SMALL_STATE(1729)] = 69562,
  [SMALL_STATE(1730)] = 69656,
  [SMALL_STATE(1731)] = 69712,
  [SMALL_STATE(1732)] = 69804,
  [SMALL_STATE(1733)] = 69856,
  [SMALL_STATE(1734)] = 69960,
  [SMALL_STATE(1735)] = 70038,
  [SMALL_STATE(1736)] = 70090,
  [SMALL_STATE(1737)] = 70192,
  [SMALL_STATE(1738)] = 70296,
  [SMALL_STATE(1739)] = 70400,
  [SMALL_STATE(1740)] = 70468,
  [SMALL_STATE(1741)] = 70572,
  [SMALL_STATE(1742)] = 70620,
  [SMALL_STATE(1743)] = 70724,
  [SMALL_STATE(1744)] = 70772,
  [SMALL_STATE(1745)] = 70876,
  [SMALL_STATE(1746)] = 70978,
  [SMALL_STATE(1747)] = 71080,
  [SMALL_STATE(1748)] = 71134,
  [SMALL_STATE(1749)] = 71184,
  [SMALL_STATE(1750)] = 71234,
  [SMALL_STATE(1751)] = 71288,
  [SMALL_STATE(1752)] = 71390,
  [SMALL_STATE(1753)] = 71442,
  [SMALL_STATE(1754)] = 71492,
  [SMALL_STATE(1755)] = 71542,
  [SMALL_STATE(1756)] = 71594,
  [SMALL_STATE(1757)] = 71642,
  [SMALL_STATE(1758)] = 71710,
  [SMALL_STATE(1759)] = 71762,
  [SMALL_STATE(1760)] = 71814,
  [SMALL_STATE(1761)] = 71862,
  [SMALL_STATE(1762)] = 71914,
  [SMALL_STATE(1763)] = 71992,
  [SMALL_STATE(1764)] = 72084,
  [SMALL_STATE(1765)] = 72152,
  [SMALL_STATE(1766)] = 72246,
  [SMALL_STATE(1767)] = 72294,
  [SMALL_STATE(1768)] = 72348,
  [SMALL_STATE(1769)] = 72402,
  [SMALL_STATE(1770)] = 72450,
  [SMALL_STATE(1771)] = 72504,
  [SMALL_STATE(1772)] = 72578,
  [SMALL_STATE(1773)] = 72664,
  [SMALL_STATE(1774)] = 72766,
  [SMALL_STATE(1775)] = 72822,
  [SMALL_STATE(1776)] = 72874,
  [SMALL_STATE(1777)] = 72926,
  [SMALL_STATE(1778)] = 73014,
  [SMALL_STATE(1779)] = 73104,
  [SMALL_STATE(1780)] = 73152,
  [SMALL_STATE(1781)] = 73200,
  [SMALL_STATE(1782)] = 73248,
  [SMALL_STATE(1783)] = 73350,
  [SMALL_STATE(1784)] = 73398,
  [SMALL_STATE(1785)] = 73470,
  [SMALL_STATE(1786)] = 73536,
  [SMALL_STATE(1787)] = 73586,
  [SMALL_STATE(1788)] = 73634,
  [SMALL_STATE(1789)] = 73716,
  [SMALL_STATE(1790)] = 73812,
  [SMALL_STATE(1791)] = 73914,
  [SMALL_STATE(1792)] = 73970,
  [SMALL_STATE(1793)] = 74072,
  [SMALL_STATE(1794)] = 74174,
  [SMALL_STATE(1795)] = 74276,
  [SMALL_STATE(1796)] = 74326,
  [SMALL_STATE(1797)] = 74378,
  [SMALL_STATE(1798)] = 74426,
  [SMALL_STATE(1799)] = 74474,
  [SMALL_STATE(1800)] = 74526,
  [SMALL_STATE(1801)] = 74628,
  [SMALL_STATE(1802)] = 74686,
  [SMALL_STATE(1803)] = 74788,
  [SMALL_STATE(1804)] = 74890,
  [SMALL_STATE(1805)] = 74942,
  [SMALL_STATE(1806)] = 75008,
  [SMALL_STATE(1807)] = 75066,
  [SMALL_STATE(1808)] = 75124,
  [SMALL_STATE(1809)] = 75194,
  [SMALL_STATE(1810)] = 75248,
  [SMALL_STATE(1811)] = 75350,
  [SMALL_STATE(1812)] = 75402,
  [SMALL_STATE(1813)] = 75506,
  [SMALL_STATE(1814)] = 75608,
  [SMALL_STATE(1815)] = 75656,
  [SMALL_STATE(1816)] = 75704,
  [SMALL_STATE(1817)] = 75760,
  [SMALL_STATE(1818)] = 75808,
  [SMALL_STATE(1819)] = 75856,
  [SMALL_STATE(1820)] = 75904,
  [SMALL_STATE(1821)] = 75952,
  [SMALL_STATE(1822)] = 76000,
  [SMALL_STATE(1823)] = 76048,
  [SMALL_STATE(1824)] = 76096,
  [SMALL_STATE(1825)] = 76200,
  [SMALL_STATE(1826)] = 76304,
  [SMALL_STATE(1827)] = 76408,
  [SMALL_STATE(1828)] = 76510,
  [SMALL_STATE(1829)] = 76614,
  [SMALL_STATE(1830)] = 76678,
  [SMALL_STATE(1831)] = 76782,
  [SMALL_STATE(1832)] = 76830,
  [SMALL_STATE(1833)] = 76878,
  [SMALL_STATE(1834)] = 76932,
  [SMALL_STATE(1835)] = 76980,
  [SMALL_STATE(1836)] = 77040,
  [SMALL_STATE(1837)] = 77088,
  [SMALL_STATE(1838)] = 77136,
  [SMALL_STATE(1839)] = 77184,
  [SMALL_STATE(1840)] = 77232,
  [SMALL_STATE(1841)] = 77290,
  [SMALL_STATE(1842)] = 77392,
  [SMALL_STATE(1843)] = 77494,
  [SMALL_STATE(1844)] = 77542,
  [SMALL_STATE(1845)] = 77594,
  [SMALL_STATE(1846)] = 77696,
  [SMALL_STATE(1847)] = 77748,
  [SMALL_STATE(1848)] = 77796,
  [SMALL_STATE(1849)] = 77844,
  [SMALL_STATE(1850)] = 77918,
  [SMALL_STATE(1851)] = 77966,
  [SMALL_STATE(1852)] = 78016,
  [SMALL_STATE(1853)] = 78120,
  [SMALL_STATE(1854)] = 78170,
  [SMALL_STATE(1855)] = 78222,
  [SMALL_STATE(1856)] = 78270,
  [SMALL_STATE(1857)] = 78322,
  [SMALL_STATE(1858)] = 78378,
  [SMALL_STATE(1859)] = 78446,
  [SMALL_STATE(1860)] = 78500,
  [SMALL_STATE(1861)] = 78552,
  [SMALL_STATE(1862)] = 78600,
  [SMALL_STATE(1863)] = 78652,
  [SMALL_STATE(1864)] = 78700,
  [SMALL_STATE(1865)] = 78748,
  [SMALL_STATE(1866)] = 78800,
  [SMALL_STATE(1867)] = 78852,
  [SMALL_STATE(1868)] = 78904,
  [SMALL_STATE(1869)] = 78960,
  [SMALL_STATE(1870)] = 79012,
  [SMALL_STATE(1871)] = 79068,
  [SMALL_STATE(1872)] = 79116,
  [SMALL_STATE(1873)] = 79164,
  [SMALL_STATE(1874)] = 79268,
  [SMALL_STATE(1875)] = 79336,
  [SMALL_STATE(1876)] = 79390,
  [SMALL_STATE(1877)] = 79442,
  [SMALL_STATE(1878)] = 79494,
  [SMALL_STATE(1879)] = 79550,
  [SMALL_STATE(1880)] = 79602,
  [SMALL_STATE(1881)] = 79650,
  [SMALL_STATE(1882)] = 79698,
  [SMALL_STATE(1883)] = 79752,
  [SMALL_STATE(1884)] = 79800,
  [SMALL_STATE(1885)] = 79902,
  [SMALL_STATE(1886)] = 79960,
  [SMALL_STATE(1887)] = 80008,
  [SMALL_STATE(1888)] = 80056,
  [SMALL_STATE(1889)] = 80107,
  [SMALL_STATE(1890)] = 80208,
  [SMALL_STATE(1891)] = 80309,
  [SMALL_STATE(1892)] = 80410,
  [SMALL_STATE(1893)] = 80467,
  [SMALL_STATE(1894)] = 80532,
  [SMALL_STATE(1895)] = 80633,
  [SMALL_STATE(1896)] = 80734,
  [SMALL_STATE(1897)] = 80835,
  [SMALL_STATE(1898)] = 80890,
  [SMALL_STATE(1899)] = 80971,
  [SMALL_STATE(1900)] = 81074,
  [SMALL_STATE(1901)] = 81123,
  [SMALL_STATE(1902)] = 81210,
  [SMALL_STATE(1903)] = 81279,
  [SMALL_STATE(1904)] = 81348,
  [SMALL_STATE(1905)] = 81401,
  [SMALL_STATE(1906)] = 81466,
  [SMALL_STATE(1907)] = 81545,
  [SMALL_STATE(1908)] = 81614,
  [SMALL_STATE(1909)] = 81683,
  [SMALL_STATE(1910)] = 81784,
  [SMALL_STATE(1911)] = 81839,
  [SMALL_STATE(1912)] = 81894,
  [SMALL_STATE(1913)] = 81943,
  [SMALL_STATE(1914)] = 82012,
  [SMALL_STATE(1915)] = 82067,
  [SMALL_STATE(1916)] = 82132,
  [SMALL_STATE(1917)] = 82205,
  [SMALL_STATE(1918)] = 82306,
  [SMALL_STATE(1919)] = 82373,
  [SMALL_STATE(1920)] = 82438,
  [SMALL_STATE(1921)] = 82493,
  [SMALL_STATE(1922)] = 82594,
  [SMALL_STATE(1923)] = 82657,
  [SMALL_STATE(1924)] = 82758,
  [SMALL_STATE(1925)] = 82827,
  [SMALL_STATE(1926)] = 82906,
  [SMALL_STATE(1927)] = 82975,
  [SMALL_STATE(1928)] = 83054,
  [SMALL_STATE(1929)] = 83133,
  [SMALL_STATE(1930)] = 83234,
  [SMALL_STATE(1931)] = 83287,
  [SMALL_STATE(1932)] = 83366,
  [SMALL_STATE(1933)] = 83467,
  [SMALL_STATE(1934)] = 83534,
  [SMALL_STATE(1935)] = 83587,
  [SMALL_STATE(1936)] = 83688,
  [SMALL_STATE(1937)] = 83741,
  [SMALL_STATE(1938)] = 83818,
  [SMALL_STATE(1939)] = 83909,
  [SMALL_STATE(1940)] = 84002,
  [SMALL_STATE(1941)] = 84081,
  [SMALL_STATE(1942)] = 84182,
  [SMALL_STATE(1943)] = 84271,
  [SMALL_STATE(1944)] = 84342,
  [SMALL_STATE(1945)] = 84443,
  [SMALL_STATE(1946)] = 84544,
  [SMALL_STATE(1947)] = 84645,
  [SMALL_STATE(1948)] = 84746,
  [SMALL_STATE(1949)] = 84841,
  [SMALL_STATE(1950)] = 84910,
  [SMALL_STATE(1951)] = 84989,
  [SMALL_STATE(1952)] = 85054,
  [SMALL_STATE(1953)] = 85155,
  [SMALL_STATE(1954)] = 85256,
  [SMALL_STATE(1955)] = 85357,
  [SMALL_STATE(1956)] = 85408,
  [SMALL_STATE(1957)] = 85509,
  [SMALL_STATE(1958)] = 85594,
  [SMALL_STATE(1959)] = 85654,
  [SMALL_STATE(1960)] = 85702,
  [SMALL_STATE(1961)] = 85760,
  [SMALL_STATE(1962)] = 85818,
  [SMALL_STATE(1963)] = 85876,
  [SMALL_STATE(1964)] = 85946,
  [SMALL_STATE(1965)] = 85994,
  [SMALL_STATE(1966)] = 86054,
  [SMALL_STATE(1967)] = 86114,
  [SMALL_STATE(1968)] = 86172,
  [SMALL_STATE(1969)] = 86244,
  [SMALL_STATE(1970)] = 86304,
  [SMALL_STATE(1971)] = 86356,
  [SMALL_STATE(1972)] = 86426,
  [SMALL_STATE(1973)] = 86474,
  [SMALL_STATE(1974)] = 86522,
  [SMALL_STATE(1975)] = 86594,
  [SMALL_STATE(1976)] = 86654,
  [SMALL_STATE(1977)] = 86712,
  [SMALL_STATE(1978)] = 86770,
  [SMALL_STATE(1979)] = 86828,
  [SMALL_STATE(1980)] = 86886,
  [SMALL_STATE(1981)] = 86958,
  [SMALL_STATE(1982)] = 87018,
  [SMALL_STATE(1983)] = 87080,
  [SMALL_STATE(1984)] = 87144,
  [SMALL_STATE(1985)] = 87204,
  [SMALL_STATE(1986)] = 87252,
  [SMALL_STATE(1987)] = 87300,
  [SMALL_STATE(1988)] = 87362,
  [SMALL_STATE(1989)] = 87422,
  [SMALL_STATE(1990)] = 87492,
  [SMALL_STATE(1991)] = 87540,
  [SMALL_STATE(1992)] = 87588,
  [SMALL_STATE(1993)] = 87636,
  [SMALL_STATE(1994)] = 87692,
  [SMALL_STATE(1995)] = 87790,
  [SMALL_STATE(1996)] = 87842,
  [SMALL_STATE(1997)] = 87940,
  [SMALL_STATE(1998)] = 88012,
  [SMALL_STATE(1999)] = 88082,
  [SMALL_STATE(2000)] = 88142,
  [SMALL_STATE(2001)] = 88202,
  [SMALL_STATE(2002)] = 88264,
  [SMALL_STATE(2003)] = 88362,
  [SMALL_STATE(2004)] = 88460,
  [SMALL_STATE(2005)] = 88532,
  [SMALL_STATE(2006)] = 88594,
  [SMALL_STATE(2007)] = 88646,
  [SMALL_STATE(2008)] = 88744,
  [SMALL_STATE(2009)] = 88842,
  [SMALL_STATE(2010)] = 88930,
  [SMALL_STATE(2011)] = 88978,
  [SMALL_STATE(2012)] = 89040,
  [SMALL_STATE(2013)] = 89088,
  [SMALL_STATE(2014)] = 89154,
  [SMALL_STATE(2015)] = 89216,
  [SMALL_STATE(2016)] = 89278,
  [SMALL_STATE(2017)] = 89338,
  [SMALL_STATE(2018)] = 89398,
  [SMALL_STATE(2019)] = 89460,
  [SMALL_STATE(2020)] = 89520,
  [SMALL_STATE(2021)] = 89580,
  [SMALL_STATE(2022)] = 89678,
  [SMALL_STATE(2023)] = 89730,
  [SMALL_STATE(2024)] = 89792,
  [SMALL_STATE(2025)] = 89844,
  [SMALL_STATE(2026)] = 89920,
  [SMALL_STATE(2027)] = 90018,
  [SMALL_STATE(2028)] = 90108,
  [SMALL_STATE(2029)] = 90166,
  [SMALL_STATE(2030)] = 90224,
  [SMALL_STATE(2031)] = 90316,
  [SMALL_STATE(2032)] = 90388,
  [SMALL_STATE(2033)] = 90486,
  [SMALL_STATE(2034)] = 90558,
  [SMALL_STATE(2035)] = 90642,
  [SMALL_STATE(2036)] = 90740,
  [SMALL_STATE(2037)] = 90794,
  [SMALL_STATE(2038)] = 90892,
  [SMALL_STATE(2039)] = 90956,
  [SMALL_STATE(2040)] = 91024,
  [SMALL_STATE(2041)] = 91110,
  [SMALL_STATE(2042)] = 91180,
  [SMALL_STATE(2043)] = 91230,
  [SMALL_STATE(2044)] = 91328,
  [SMALL_STATE(2045)] = 91390,
  [SMALL_STATE(2046)] = 91462,
  [SMALL_STATE(2047)] = 91532,
  [SMALL_STATE(2048)] = 91580,
  [SMALL_STATE(2049)] = 91628,
  [SMALL_STATE(2050)] = 91680,
  [SMALL_STATE(2051)] = 91732,
  [SMALL_STATE(2052)] = 91794,
  [SMALL_STATE(2053)] = 91846,
  [SMALL_STATE(2054)] = 91944,
  [SMALL_STATE(2055)] = 92004,
  [SMALL_STATE(2056)] = 92074,
  [SMALL_STATE(2057)] = 92172,
  [SMALL_STATE(2058)] = 92266,
  [SMALL_STATE(2059)] = 92346,
  [SMALL_STATE(2060)] = 92410,
  [SMALL_STATE(2061)] = 92480,
  [SMALL_STATE(2062)] = 92535,
  [SMALL_STATE(2063)] = 92590,
  [SMALL_STATE(2064)] = 92655,
  [SMALL_STATE(2065)] = 92710,
  [SMALL_STATE(2066)] = 92757,
  [SMALL_STATE(2067)] = 92822,
  [SMALL_STATE(2068)] = 92877,
  [SMALL_STATE(2069)] = 92928,
  [SMALL_STATE(2070)] = 92979,
  [SMALL_STATE(2071)] = 93034,
  [SMALL_STATE(2072)] = 93089,
  [SMALL_STATE(2073)] = 93166,
  [SMALL_STATE(2074)] = 93221,
  [SMALL_STATE(2075)] = 93276,
  [SMALL_STATE(2076)] = 93327,
  [SMALL_STATE(2077)] = 93382,
  [SMALL_STATE(2078)] = 93429,
  [SMALL_STATE(2079)] = 93494,
  [SMALL_STATE(2080)] = 93549,
  [SMALL_STATE(2081)] = 93604,
  [SMALL_STATE(2082)] = 93659,
  [SMALL_STATE(2083)] = 93714,
  [SMALL_STATE(2084)] = 93769,
  [SMALL_STATE(2085)] = 93840,
  [SMALL_STATE(2086)] = 93895,
  [SMALL_STATE(2087)] = 93950,
  [SMALL_STATE(2088)] = 94005,
  [SMALL_STATE(2089)] = 94060,
  [SMALL_STATE(2090)] = 94125,
  [SMALL_STATE(2091)] = 94190,
  [SMALL_STATE(2092)] = 94255,
  [SMALL_STATE(2093)] = 94320,
  [SMALL_STATE(2094)] = 94371,
  [SMALL_STATE(2095)] = 94418,
  [SMALL_STATE(2096)] = 94478,
  [SMALL_STATE(2097)] = 94534,
  [SMALL_STATE(2098)] = 94598,
  [SMALL_STATE(2099)] = 94654,
  [SMALL_STATE(2100)] = 94704,
  [SMALL_STATE(2101)] = 94754,
  [SMALL_STATE(2102)] = 94822,
  [SMALL_STATE(2103)] = 94884,
  [SMALL_STATE(2104)] = 94944,
  [SMALL_STATE(2105)] = 94999,
  [SMALL_STATE(2106)] = 95052,
  [SMALL_STATE(2107)] = 95107,
  [SMALL_STATE(2108)] = 95162,
  [SMALL_STATE(2109)] = 95217,
  [SMALL_STATE(2110)] = 95272,
  [SMALL_STATE(2111)] = 95327,
  [SMALL_STATE(2112)] = 95382,
  [SMALL_STATE(2113)] = 95437,
  [SMALL_STATE(2114)] = 95492,
  [SMALL_STATE(2115)] = 95553,
  [SMALL_STATE(2116)] = 95612,
  [SMALL_STATE(2117)] = 95667,
  [SMALL_STATE(2118)] = 95722,
  [SMALL_STATE(2119)] = 95777,
  [SMALL_STATE(2120)] = 95834,
  [SMALL_STATE(2121)] = 95889,
  [SMALL_STATE(2122)] = 95944,
  [SMALL_STATE(2123)] = 95997,
  [SMALL_STATE(2124)] = 96051,
  [SMALL_STATE(2125)] = 96130,
  [SMALL_STATE(2126)] = 96209,
  [SMALL_STATE(2127)] = 96256,
  [SMALL_STATE(2128)] = 96303,
  [SMALL_STATE(2129)] = 96366,
  [SMALL_STATE(2130)] = 96413,
  [SMALL_STATE(2131)] = 96492,
  [SMALL_STATE(2132)] = 96571,
  [SMALL_STATE(2133)] = 96650,
  [SMALL_STATE(2134)] = 96694,
  [SMALL_STATE(2135)] = 96748,
  [SMALL_STATE(2136)] = 96788,
  [SMALL_STATE(2137)] = 96828,
  [SMALL_STATE(2138)] = 96868,
  [SMALL_STATE(2139)] = 96908,
  [SMALL_STATE(2140)] = 96948,
  [SMALL_STATE(2141)] = 96988,
  [SMALL_STATE(2142)] = 97028,
  [SMALL_STATE(2143)] = 97072,
  [SMALL_STATE(2144)] = 97112,
  [SMALL_STATE(2145)] = 97152,
  [SMALL_STATE(2146)] = 97208,
  [SMALL_STATE(2147)] = 97248,
  [SMALL_STATE(2148)] = 97288,
  [SMALL_STATE(2149)] = 97330,
  [SMALL_STATE(2150)] = 97370,
  [SMALL_STATE(2151)] = 97422,
  [SMALL_STATE(2152)] = 97478,
  [SMALL_STATE(2153)] = 97532,
  [SMALL_STATE(2154)] = 97586,
  [SMALL_STATE(2155)] = 97626,
  [SMALL_STATE(2156)] = 97682,
  [SMALL_STATE(2157)] = 97722,
  [SMALL_STATE(2158)] = 97764,
  [SMALL_STATE(2159)] = 97804,
  [SMALL_STATE(2160)] = 97844,
  [SMALL_STATE(2161)] = 97884,
  [SMALL_STATE(2162)] = 97924,
  [SMALL_STATE(2163)] = 97964,
  [SMALL_STATE(2164)] = 98018,
  [SMALL_STATE(2165)] = 98060,
  [SMALL_STATE(2166)] = 98100,
  [SMALL_STATE(2167)] = 98140,
  [SMALL_STATE(2168)] = 98180,
  [SMALL_STATE(2169)] = 98220,
  [SMALL_STATE(2170)] = 98260,
  [SMALL_STATE(2171)] = 98300,
  [SMALL_STATE(2172)] = 98349,
  [SMALL_STATE(2173)] = 98398,
  [SMALL_STATE(2174)] = 98447,
  [SMALL_STATE(2175)] = 98496,
  [SMALL_STATE(2176)] = 98545,
  [SMALL_STATE(2177)] = 98594,
  [SMALL_STATE(2178)] = 98643,
  [SMALL_STATE(2179)] = 98692,
  [SMALL_STATE(2180)] = 98741,
  [SMALL_STATE(2181)] = 98790,
  [SMALL_STATE(2182)] = 98839,
  [SMALL_STATE(2183)] = 98888,
  [SMALL_STATE(2184)] = 98937,
  [SMALL_STATE(2185)] = 99000,
  [SMALL_STATE(2186)] = 99049,
  [SMALL_STATE(2187)] = 99098,
  [SMALL_STATE(2188)] = 99147,
  [SMALL_STATE(2189)] = 99196,
  [SMALL_STATE(2190)] = 99245,
  [SMALL_STATE(2191)] = 99294,
  [SMALL_STATE(2192)] = 99343,
  [SMALL_STATE(2193)] = 99381,
  [SMALL_STATE(2194)] = 99437,
  [SMALL_STATE(2195)] = 99497,
  [SMALL_STATE(2196)] = 99547,
  [SMALL_STATE(2197)] = 99597,
  [SMALL_STATE(2198)] = 99647,
  [SMALL_STATE(2199)] = 99685,
  [SMALL_STATE(2200)] = 99735,
  [SMALL_STATE(2201)] = 99785,
  [SMALL_STATE(2202)] = 99823,
  [SMALL_STATE(2203)] = 99873,
  [SMALL_STATE(2204)] = 99911,
  [SMALL_STATE(2205)] = 99949,
  [SMALL_STATE(2206)] = 100009,
  [SMALL_STATE(2207)] = 100069,
  [SMALL_STATE(2208)] = 100119,
  [SMALL_STATE(2209)] = 100169,
  [SMALL_STATE(2210)] = 100219,
  [SMALL_STATE(2211)] = 100269,
  [SMALL_STATE(2212)] = 100307,
  [SMALL_STATE(2213)] = 100360,
  [SMALL_STATE(2214)] = 100411,
  [SMALL_STATE(2215)] = 100464,
  [SMALL_STATE(2216)] = 100517,
  [SMALL_STATE(2217)] = 100570,
  [SMALL_STATE(2218)] = 100617,
  [SMALL_STATE(2219)] = 100670,
  [SMALL_STATE(2220)] = 100723,
  [SMALL_STATE(2221)] = 100776,
  [SMALL_STATE(2222)] = 100815,
  [SMALL_STATE(2223)] = 100868,
  [SMALL_STATE(2224)] = 100921,
  [SMALL_STATE(2225)] = 100974,
  [SMALL_STATE(2226)] = 101025,
  [SMALL_STATE(2227)] = 101078,
  [SMALL_STATE(2228)] = 101131,
  [SMALL_STATE(2229)] = 101175,
  [SMALL_STATE(2230)] = 101219,
  [SMALL_STATE(2231)] = 101263,
  [SMALL_STATE(2232)] = 101307,
  [SMALL_STATE(2233)] = 101351,
  [SMALL_STATE(2234)] = 101395,
  [SMALL_STATE(2235)] = 101439,
  [SMALL_STATE(2236)] = 101483,
  [SMALL_STATE(2237)] = 101527,
  [SMALL_STATE(2238)] = 101571,
  [SMALL_STATE(2239)] = 101615,
  [SMALL_STATE(2240)] = 101659,
  [SMALL_STATE(2241)] = 101703,
  [SMALL_STATE(2242)] = 101747,
  [SMALL_STATE(2243)] = 101791,
  [SMALL_STATE(2244)] = 101835,
  [SMALL_STATE(2245)] = 101879,
  [SMALL_STATE(2246)] = 101925,
  [SMALL_STATE(2247)] = 101969,
  [SMALL_STATE(2248)] = 102015,
  [SMALL_STATE(2249)] = 102059,
  [SMALL_STATE(2250)] = 102103,
  [SMALL_STATE(2251)] = 102147,
  [SMALL_STATE(2252)] = 102191,
  [SMALL_STATE(2253)] = 102235,
  [SMALL_STATE(2254)] = 102281,
  [SMALL_STATE(2255)] = 102325,
  [SMALL_STATE(2256)] = 102369,
  [SMALL_STATE(2257)] = 102413,
  [SMALL_STATE(2258)] = 102457,
  [SMALL_STATE(2259)] = 102501,
  [SMALL_STATE(2260)] = 102545,
  [SMALL_STATE(2261)] = 102576,
  [SMALL_STATE(2262)] = 102602,
  [SMALL_STATE(2263)] = 102628,
  [SMALL_STATE(2264)] = 102654,
  [SMALL_STATE(2265)] = 102680,
  [SMALL_STATE(2266)] = 102706,
  [SMALL_STATE(2267)] = 102732,
  [SMALL_STATE(2268)] = 102758,
  [SMALL_STATE(2269)] = 102784,
  [SMALL_STATE(2270)] = 102820,
  [SMALL_STATE(2271)] = 102856,
  [SMALL_STATE(2272)] = 102892,
  [SMALL_STATE(2273)] = 102918,
  [SMALL_STATE(2274)] = 102944,
  [SMALL_STATE(2275)] = 102970,
  [SMALL_STATE(2276)] = 102996,
  [SMALL_STATE(2277)] = 103022,
  [SMALL_STATE(2278)] = 103048,
  [SMALL_STATE(2279)] = 103074,
  [SMALL_STATE(2280)] = 103100,
  [SMALL_STATE(2281)] = 103126,
  [SMALL_STATE(2282)] = 103152,
  [SMALL_STATE(2283)] = 103178,
  [SMALL_STATE(2284)] = 103204,
  [SMALL_STATE(2285)] = 103230,
  [SMALL_STATE(2286)] = 103256,
  [SMALL_STATE(2287)] = 103282,
  [SMALL_STATE(2288)] = 103308,
  [SMALL_STATE(2289)] = 103334,
  [SMALL_STATE(2290)] = 103360,
  [SMALL_STATE(2291)] = 103386,
  [SMALL_STATE(2292)] = 103412,
  [SMALL_STATE(2293)] = 103438,
  [SMALL_STATE(2294)] = 103464,
  [SMALL_STATE(2295)] = 103490,
  [SMALL_STATE(2296)] = 103524,
  [SMALL_STATE(2297)] = 103550,
  [SMALL_STATE(2298)] = 103576,
  [SMALL_STATE(2299)] = 103602,
  [SMALL_STATE(2300)] = 103627,
  [SMALL_STATE(2301)] = 103658,
  [SMALL_STATE(2302)] = 103683,
  [SMALL_STATE(2303)] = 103708,
  [SMALL_STATE(2304)] = 103739,
  [SMALL_STATE(2305)] = 103766,
  [SMALL_STATE(2306)] = 103790,
  [SMALL_STATE(2307)] = 103818,
  [SMALL_STATE(2308)] = 103842,
  [SMALL_STATE(2309)] = 103865,
  [SMALL_STATE(2310)] = 103888,
  [SMALL_STATE(2311)] = 103913,
  [SMALL_STATE(2312)] = 103936,
  [SMALL_STATE(2313)] = 103959,
  [SMALL_STATE(2314)] = 103980,
  [SMALL_STATE(2315)] = 104001,
  [SMALL_STATE(2316)] = 104024,
  [SMALL_STATE(2317)] = 104047,
  [SMALL_STATE(2318)] = 104070,
  [SMALL_STATE(2319)] = 104093,
  [SMALL_STATE(2320)] = 104116,
  [SMALL_STATE(2321)] = 104139,
  [SMALL_STATE(2322)] = 104162,
  [SMALL_STATE(2323)] = 104185,
  [SMALL_STATE(2324)] = 104210,
  [SMALL_STATE(2325)] = 104243,
  [SMALL_STATE(2326)] = 104268,
  [SMALL_STATE(2327)] = 104291,
  [SMALL_STATE(2328)] = 104314,
  [SMALL_STATE(2329)] = 104337,
  [SMALL_STATE(2330)] = 104358,
  [SMALL_STATE(2331)] = 104391,
  [SMALL_STATE(2332)] = 104418,
  [SMALL_STATE(2333)] = 104451,
  [SMALL_STATE(2334)] = 104474,
  [SMALL_STATE(2335)] = 104497,
  [SMALL_STATE(2336)] = 104528,
  [SMALL_STATE(2337)] = 104551,
  [SMALL_STATE(2338)] = 104572,
  [SMALL_STATE(2339)] = 104595,
  [SMALL_STATE(2340)] = 104616,
  [SMALL_STATE(2341)] = 104639,
  [SMALL_STATE(2342)] = 104662,
  [SMALL_STATE(2343)] = 104685,
  [SMALL_STATE(2344)] = 104706,
  [SMALL_STATE(2345)] = 104727,
  [SMALL_STATE(2346)] = 104750,
  [SMALL_STATE(2347)] = 104773,
  [SMALL_STATE(2348)] = 104794,
  [SMALL_STATE(2349)] = 104817,
  [SMALL_STATE(2350)] = 104839,
  [SMALL_STATE(2351)] = 104869,
  [SMALL_STATE(2352)] = 104891,
  [SMALL_STATE(2353)] = 104913,
  [SMALL_STATE(2354)] = 104935,
  [SMALL_STATE(2355)] = 104957,
  [SMALL_STATE(2356)] = 104983,
  [SMALL_STATE(2357)] = 105011,
  [SMALL_STATE(2358)] = 105039,
  [SMALL_STATE(2359)] = 105069,
  [SMALL_STATE(2360)] = 105099,
  [SMALL_STATE(2361)] = 105121,
  [SMALL_STATE(2362)] = 105143,
  [SMALL_STATE(2363)] = 105165,
  [SMALL_STATE(2364)] = 105187,
  [SMALL_STATE(2365)] = 105209,
  [SMALL_STATE(2366)] = 105231,
  [SMALL_STATE(2367)] = 105253,
  [SMALL_STATE(2368)] = 105275,
  [SMALL_STATE(2369)] = 105297,
  [SMALL_STATE(2370)] = 105319,
  [SMALL_STATE(2371)] = 105349,
  [SMALL_STATE(2372)] = 105377,
  [SMALL_STATE(2373)] = 105419,
  [SMALL_STATE(2374)] = 105443,
  [SMALL_STATE(2375)] = 105473,
  [SMALL_STATE(2376)] = 105503,
  [SMALL_STATE(2377)] = 105527,
  [SMALL_STATE(2378)] = 105555,
  [SMALL_STATE(2379)] = 105583,
  [SMALL_STATE(2380)] = 105611,
  [SMALL_STATE(2381)] = 105641,
  [SMALL_STATE(2382)] = 105663,
  [SMALL_STATE(2383)] = 105685,
  [SMALL_STATE(2384)] = 105707,
  [SMALL_STATE(2385)] = 105729,
  [SMALL_STATE(2386)] = 105751,
  [SMALL_STATE(2387)] = 105773,
  [SMALL_STATE(2388)] = 105795,
  [SMALL_STATE(2389)] = 105825,
  [SMALL_STATE(2390)] = 105855,
  [SMALL_STATE(2391)] = 105885,
  [SMALL_STATE(2392)] = 105907,
  [SMALL_STATE(2393)] = 105929,
  [SMALL_STATE(2394)] = 105951,
  [SMALL_STATE(2395)] = 105973,
  [SMALL_STATE(2396)] = 105995,
  [SMALL_STATE(2397)] = 106023,
  [SMALL_STATE(2398)] = 106045,
  [SMALL_STATE(2399)] = 106067,
  [SMALL_STATE(2400)] = 106089,
  [SMALL_STATE(2401)] = 106111,
  [SMALL_STATE(2402)] = 106133,
  [SMALL_STATE(2403)] = 106155,
  [SMALL_STATE(2404)] = 106185,
  [SMALL_STATE(2405)] = 106213,
  [SMALL_STATE(2406)] = 106243,
  [SMALL_STATE(2407)] = 106273,
  [SMALL_STATE(2408)] = 106315,
  [SMALL_STATE(2409)] = 106345,
  [SMALL_STATE(2410)] = 106375,
  [SMALL_STATE(2411)] = 106405,
  [SMALL_STATE(2412)] = 106435,
  [SMALL_STATE(2413)] = 106463,
  [SMALL_STATE(2414)] = 106505,
  [SMALL_STATE(2415)] = 106535,
  [SMALL_STATE(2416)] = 106565,
  [SMALL_STATE(2417)] = 106593,
  [SMALL_STATE(2418)] = 106621,
  [SMALL_STATE(2419)] = 106651,
  [SMALL_STATE(2420)] = 106681,
  [SMALL_STATE(2421)] = 106723,
  [SMALL_STATE(2422)] = 106753,
  [SMALL_STATE(2423)] = 106783,
  [SMALL_STATE(2424)] = 106811,
  [SMALL_STATE(2425)] = 106841,
  [SMALL_STATE(2426)] = 106871,
  [SMALL_STATE(2427)] = 106913,
  [SMALL_STATE(2428)] = 106941,
  [SMALL_STATE(2429)] = 106969,
  [SMALL_STATE(2430)] = 106991,
  [SMALL_STATE(2431)] = 107021,
  [SMALL_STATE(2432)] = 107051,
  [SMALL_STATE(2433)] = 107081,
  [SMALL_STATE(2434)] = 107109,
  [SMALL_STATE(2435)] = 107139,
  [SMALL_STATE(2436)] = 107169,
  [SMALL_STATE(2437)] = 107211,
  [SMALL_STATE(2438)] = 107253,
  [SMALL_STATE(2439)] = 107274,
  [SMALL_STATE(2440)] = 107309,
  [SMALL_STATE(2441)] = 107338,
  [SMALL_STATE(2442)] = 107359,
  [SMALL_STATE(2443)] = 107388,
  [SMALL_STATE(2444)] = 107415,
  [SMALL_STATE(2445)] = 107444,
  [SMALL_STATE(2446)] = 107479,
  [SMALL_STATE(2447)] = 107514,
  [SMALL_STATE(2448)] = 107549,
  [SMALL_STATE(2449)] = 107584,
  [SMALL_STATE(2450)] = 107605,
  [SMALL_STATE(2451)] = 107626,
  [SMALL_STATE(2452)] = 107651,
  [SMALL_STATE(2453)] = 107686,
  [SMALL_STATE(2454)] = 107721,
  [SMALL_STATE(2455)] = 107756,
  [SMALL_STATE(2456)] = 107783,
  [SMALL_STATE(2457)] = 107804,
  [SMALL_STATE(2458)] = 107839,
  [SMALL_STATE(2459)] = 107862,
  [SMALL_STATE(2460)] = 107899,
  [SMALL_STATE(2461)] = 107920,
  [SMALL_STATE(2462)] = 107955,
  [SMALL_STATE(2463)] = 107987,
  [SMALL_STATE(2464)] = 108005,
  [SMALL_STATE(2465)] = 108023,
  [SMALL_STATE(2466)] = 108041,
  [SMALL_STATE(2467)] = 108059,
  [SMALL_STATE(2468)] = 108077,
  [SMALL_STATE(2469)] = 108095,
  [SMALL_STATE(2470)] = 108113,
  [SMALL_STATE(2471)] = 108131,
  [SMALL_STATE(2472)] = 108149,
  [SMALL_STATE(2473)] = 108167,
  [SMALL_STATE(2474)] = 108185,
  [SMALL_STATE(2475)] = 108203,
  [SMALL_STATE(2476)] = 108221,
  [SMALL_STATE(2477)] = 108239,
  [SMALL_STATE(2478)] = 108275,
  [SMALL_STATE(2479)] = 108311,
  [SMALL_STATE(2480)] = 108339,
  [SMALL_STATE(2481)] = 108375,
  [SMALL_STATE(2482)] = 108407,
  [SMALL_STATE(2483)] = 108435,
  [SMALL_STATE(2484)] = 108467,
  [SMALL_STATE(2485)] = 108485,
  [SMALL_STATE(2486)] = 108503,
  [SMALL_STATE(2487)] = 108521,
  [SMALL_STATE(2488)] = 108539,
  [SMALL_STATE(2489)] = 108557,
  [SMALL_STATE(2490)] = 108575,
  [SMALL_STATE(2491)] = 108593,
  [SMALL_STATE(2492)] = 108611,
  [SMALL_STATE(2493)] = 108639,
  [SMALL_STATE(2494)] = 108657,
  [SMALL_STATE(2495)] = 108675,
  [SMALL_STATE(2496)] = 108693,
  [SMALL_STATE(2497)] = 108711,
  [SMALL_STATE(2498)] = 108729,
  [SMALL_STATE(2499)] = 108761,
  [SMALL_STATE(2500)] = 108779,
  [SMALL_STATE(2501)] = 108797,
  [SMALL_STATE(2502)] = 108815,
  [SMALL_STATE(2503)] = 108837,
  [SMALL_STATE(2504)] = 108873,
  [SMALL_STATE(2505)] = 108891,
  [SMALL_STATE(2506)] = 108909,
  [SMALL_STATE(2507)] = 108939,
  [SMALL_STATE(2508)] = 108971,
  [SMALL_STATE(2509)] = 109003,
  [SMALL_STATE(2510)] = 109021,
  [SMALL_STATE(2511)] = 109039,
  [SMALL_STATE(2512)] = 109067,
  [SMALL_STATE(2513)] = 109099,
  [SMALL_STATE(2514)] = 109131,
  [SMALL_STATE(2515)] = 109167,
  [SMALL_STATE(2516)] = 109191,
  [SMALL_STATE(2517)] = 109223,
  [SMALL_STATE(2518)] = 109255,
  [SMALL_STATE(2519)] = 109291,
  [SMALL_STATE(2520)] = 109319,
  [SMALL_STATE(2521)] = 109355,
  [SMALL_STATE(2522)] = 109372,
  [SMALL_STATE(2523)] = 109391,
  [SMALL_STATE(2524)] = 109408,
  [SMALL_STATE(2525)] = 109427,
  [SMALL_STATE(2526)] = 109446,
  [SMALL_STATE(2527)] = 109465,
  [SMALL_STATE(2528)] = 109484,
  [SMALL_STATE(2529)] = 109503,
  [SMALL_STATE(2530)] = 109522,
  [SMALL_STATE(2531)] = 109541,
  [SMALL_STATE(2532)] = 109562,
  [SMALL_STATE(2533)] = 109581,
  [SMALL_STATE(2534)] = 109600,
  [SMALL_STATE(2535)] = 109619,
  [SMALL_STATE(2536)] = 109640,
  [SMALL_STATE(2537)] = 109659,
  [SMALL_STATE(2538)] = 109680,
  [SMALL_STATE(2539)] = 109699,
  [SMALL_STATE(2540)] = 109718,
  [SMALL_STATE(2541)] = 109739,
  [SMALL_STATE(2542)] = 109762,
  [SMALL_STATE(2543)] = 109781,
  [SMALL_STATE(2544)] = 109800,
  [SMALL_STATE(2545)] = 109817,
  [SMALL_STATE(2546)] = 109836,
  [SMALL_STATE(2547)] = 109853,
  [SMALL_STATE(2548)] = 109872,
  [SMALL_STATE(2549)] = 109889,
  [SMALL_STATE(2550)] = 109912,
  [SMALL_STATE(2551)] = 109931,
  [SMALL_STATE(2552)] = 109954,
  [SMALL_STATE(2553)] = 109973,
  [SMALL_STATE(2554)] = 109994,
  [SMALL_STATE(2555)] = 110013,
  [SMALL_STATE(2556)] = 110032,
  [SMALL_STATE(2557)] = 110051,
  [SMALL_STATE(2558)] = 110074,
  [SMALL_STATE(2559)] = 110093,
  [SMALL_STATE(2560)] = 110112,
  [SMALL_STATE(2561)] = 110129,
  [SMALL_STATE(2562)] = 110148,
  [SMALL_STATE(2563)] = 110167,
  [SMALL_STATE(2564)] = 110186,
  [SMALL_STATE(2565)] = 110209,
  [SMALL_STATE(2566)] = 110226,
  [SMALL_STATE(2567)] = 110245,
  [SMALL_STATE(2568)] = 110264,
  [SMALL_STATE(2569)] = 110283,
  [SMALL_STATE(2570)] = 110302,
  [SMALL_STATE(2571)] = 110325,
  [SMALL_STATE(2572)] = 110344,
  [SMALL_STATE(2573)] = 110361,
  [SMALL_STATE(2574)] = 110382,
  [SMALL_STATE(2575)] = 110401,
  [SMALL_STATE(2576)] = 110435,
  [SMALL_STATE(2577)] = 110469,
  [SMALL_STATE(2578)] = 110501,
  [SMALL_STATE(2579)] = 110529,
  [SMALL_STATE(2580)] = 110547,
  [SMALL_STATE(2581)] = 110581,
  [SMALL_STATE(2582)] = 110601,
  [SMALL_STATE(2583)] = 110621,
  [SMALL_STATE(2584)] = 110655,
  [SMALL_STATE(2585)] = 110689,
  [SMALL_STATE(2586)] = 110711,
  [SMALL_STATE(2587)] = 110745,
  [SMALL_STATE(2588)] = 110779,
  [SMALL_STATE(2589)] = 110813,
  [SMALL_STATE(2590)] = 110839,
  [SMALL_STATE(2591)] = 110859,
  [SMALL_STATE(2592)] = 110885,
  [SMALL_STATE(2593)] = 110919,
  [SMALL_STATE(2594)] = 110943,
  [SMALL_STATE(2595)] = 110969,
  [SMALL_STATE(2596)] = 111003,
  [SMALL_STATE(2597)] = 111037,
  [SMALL_STATE(2598)] = 111065,
  [SMALL_STATE(2599)] = 111096,
  [SMALL_STATE(2600)] = 111115,
  [SMALL_STATE(2601)] = 111146,
  [SMALL_STATE(2602)] = 111169,
  [SMALL_STATE(2603)] = 111184,
  [SMALL_STATE(2604)] = 111199,
  [SMALL_STATE(2605)] = 111230,
  [SMALL_STATE(2606)] = 111245,
  [SMALL_STATE(2607)] = 111260,
  [SMALL_STATE(2608)] = 111275,
  [SMALL_STATE(2609)] = 111290,
  [SMALL_STATE(2610)] = 111305,
  [SMALL_STATE(2611)] = 111320,
  [SMALL_STATE(2612)] = 111335,
  [SMALL_STATE(2613)] = 111356,
  [SMALL_STATE(2614)] = 111371,
  [SMALL_STATE(2615)] = 111388,
  [SMALL_STATE(2616)] = 111403,
  [SMALL_STATE(2617)] = 111420,
  [SMALL_STATE(2618)] = 111435,
  [SMALL_STATE(2619)] = 111452,
  [SMALL_STATE(2620)] = 111467,
  [SMALL_STATE(2621)] = 111492,
  [SMALL_STATE(2622)] = 111523,
  [SMALL_STATE(2623)] = 111542,
  [SMALL_STATE(2624)] = 111557,
  [SMALL_STATE(2625)] = 111582,
  [SMALL_STATE(2626)] = 111607,
  [SMALL_STATE(2627)] = 111622,
  [SMALL_STATE(2628)] = 111653,
  [SMALL_STATE(2629)] = 111684,
  [SMALL_STATE(2630)] = 111699,
  [SMALL_STATE(2631)] = 111714,
  [SMALL_STATE(2632)] = 111729,
  [SMALL_STATE(2633)] = 111760,
  [SMALL_STATE(2634)] = 111777,
  [SMALL_STATE(2635)] = 111792,
  [SMALL_STATE(2636)] = 111813,
  [SMALL_STATE(2637)] = 111828,
  [SMALL_STATE(2638)] = 111859,
  [SMALL_STATE(2639)] = 111874,
  [SMALL_STATE(2640)] = 111905,
  [SMALL_STATE(2641)] = 111926,
  [SMALL_STATE(2642)] = 111951,
  [SMALL_STATE(2643)] = 111966,
  [SMALL_STATE(2644)] = 111981,
  [SMALL_STATE(2645)] = 111996,
  [SMALL_STATE(2646)] = 112021,
  [SMALL_STATE(2647)] = 112052,
  [SMALL_STATE(2648)] = 112083,
  [SMALL_STATE(2649)] = 112114,
  [SMALL_STATE(2650)] = 112139,
  [SMALL_STATE(2651)] = 112164,
  [SMALL_STATE(2652)] = 112189,
  [SMALL_STATE(2653)] = 112214,
  [SMALL_STATE(2654)] = 112229,
  [SMALL_STATE(2655)] = 112244,
  [SMALL_STATE(2656)] = 112259,
  [SMALL_STATE(2657)] = 112280,
  [SMALL_STATE(2658)] = 112299,
  [SMALL_STATE(2659)] = 112324,
  [SMALL_STATE(2660)] = 112355,
  [SMALL_STATE(2661)] = 112386,
  [SMALL_STATE(2662)] = 112403,
  [SMALL_STATE(2663)] = 112420,
  [SMALL_STATE(2664)] = 112451,
  [SMALL_STATE(2665)] = 112466,
  [SMALL_STATE(2666)] = 112497,
  [SMALL_STATE(2667)] = 112522,
  [SMALL_STATE(2668)] = 112547,
  [SMALL_STATE(2669)] = 112572,
  [SMALL_STATE(2670)] = 112587,
  [SMALL_STATE(2671)] = 112618,
  [SMALL_STATE(2672)] = 112633,
  [SMALL_STATE(2673)] = 112648,
  [SMALL_STATE(2674)] = 112663,
  [SMALL_STATE(2675)] = 112678,
  [SMALL_STATE(2676)] = 112695,
  [SMALL_STATE(2677)] = 112720,
  [SMALL_STATE(2678)] = 112735,
  [SMALL_STATE(2679)] = 112750,
  [SMALL_STATE(2680)] = 112765,
  [SMALL_STATE(2681)] = 112796,
  [SMALL_STATE(2682)] = 112811,
  [SMALL_STATE(2683)] = 112842,
  [SMALL_STATE(2684)] = 112863,
  [SMALL_STATE(2685)] = 112878,
  [SMALL_STATE(2686)] = 112893,
  [SMALL_STATE(2687)] = 112908,
  [SMALL_STATE(2688)] = 112927,
  [SMALL_STATE(2689)] = 112951,
  [SMALL_STATE(2690)] = 112975,
  [SMALL_STATE(2691)] = 112999,
  [SMALL_STATE(2692)] = 113023,
  [SMALL_STATE(2693)] = 113043,
  [SMALL_STATE(2694)] = 113063,
  [SMALL_STATE(2695)] = 113087,
  [SMALL_STATE(2696)] = 113107,
  [SMALL_STATE(2697)] = 113127,
  [SMALL_STATE(2698)] = 113151,
  [SMALL_STATE(2699)] = 113175,
  [SMALL_STATE(2700)] = 113199,
  [SMALL_STATE(2701)] = 113217,
  [SMALL_STATE(2702)] = 113231,
  [SMALL_STATE(2703)] = 113255,
  [SMALL_STATE(2704)] = 113279,
  [SMALL_STATE(2705)] = 113303,
  [SMALL_STATE(2706)] = 113327,
  [SMALL_STATE(2707)] = 113341,
  [SMALL_STATE(2708)] = 113355,
  [SMALL_STATE(2709)] = 113376,
  [SMALL_STATE(2710)] = 113389,
  [SMALL_STATE(2711)] = 113414,
  [SMALL_STATE(2712)] = 113439,
  [SMALL_STATE(2713)] = 113464,
  [SMALL_STATE(2714)] = 113481,
  [SMALL_STATE(2715)] = 113494,
  [SMALL_STATE(2716)] = 113509,
  [SMALL_STATE(2717)] = 113534,
  [SMALL_STATE(2718)] = 113547,
  [SMALL_STATE(2719)] = 113568,
  [SMALL_STATE(2720)] = 113585,
  [SMALL_STATE(2721)] = 113602,
  [SMALL_STATE(2722)] = 113623,
  [SMALL_STATE(2723)] = 113640,
  [SMALL_STATE(2724)] = 113665,
  [SMALL_STATE(2725)] = 113690,
  [SMALL_STATE(2726)] = 113715,
  [SMALL_STATE(2727)] = 113736,
  [SMALL_STATE(2728)] = 113753,
  [SMALL_STATE(2729)] = 113774,
  [SMALL_STATE(2730)] = 113791,
  [SMALL_STATE(2731)] = 113808,
  [SMALL_STATE(2732)] = 113833,
  [SMALL_STATE(2733)] = 113846,
  [SMALL_STATE(2734)] = 113871,
  [SMALL_STATE(2735)] = 113884,
  [SMALL_STATE(2736)] = 113909,
  [SMALL_STATE(2737)] = 113922,
  [SMALL_STATE(2738)] = 113947,
  [SMALL_STATE(2739)] = 113964,
  [SMALL_STATE(2740)] = 113989,
  [SMALL_STATE(2741)] = 114014,
  [SMALL_STATE(2742)] = 114039,
  [SMALL_STATE(2743)] = 114064,
  [SMALL_STATE(2744)] = 114077,
  [SMALL_STATE(2745)] = 114096,
  [SMALL_STATE(2746)] = 114121,
  [SMALL_STATE(2747)] = 114138,
  [SMALL_STATE(2748)] = 114163,
  [SMALL_STATE(2749)] = 114180,
  [SMALL_STATE(2750)] = 114197,
  [SMALL_STATE(2751)] = 114218,
  [SMALL_STATE(2752)] = 114243,
  [SMALL_STATE(2753)] = 114266,
  [SMALL_STATE(2754)] = 114283,
  [SMALL_STATE(2755)] = 114308,
  [SMALL_STATE(2756)] = 114333,
  [SMALL_STATE(2757)] = 114354,
  [SMALL_STATE(2758)] = 114379,
  [SMALL_STATE(2759)] = 114396,
  [SMALL_STATE(2760)] = 114413,
  [SMALL_STATE(2761)] = 114426,
  [SMALL_STATE(2762)] = 114443,
  [SMALL_STATE(2763)] = 114460,
  [SMALL_STATE(2764)] = 114477,
  [SMALL_STATE(2765)] = 114494,
  [SMALL_STATE(2766)] = 114515,
  [SMALL_STATE(2767)] = 114536,
  [SMALL_STATE(2768)] = 114551,
  [SMALL_STATE(2769)] = 114564,
  [SMALL_STATE(2770)] = 114589,
  [SMALL_STATE(2771)] = 114604,
  [SMALL_STATE(2772)] = 114621,
  [SMALL_STATE(2773)] = 114634,
  [SMALL_STATE(2774)] = 114647,
  [SMALL_STATE(2775)] = 114672,
  [SMALL_STATE(2776)] = 114697,
  [SMALL_STATE(2777)] = 114712,
  [SMALL_STATE(2778)] = 114729,
  [SMALL_STATE(2779)] = 114754,
  [SMALL_STATE(2780)] = 114779,
  [SMALL_STATE(2781)] = 114804,
  [SMALL_STATE(2782)] = 114821,
  [SMALL_STATE(2783)] = 114846,
  [SMALL_STATE(2784)] = 114863,
  [SMALL_STATE(2785)] = 114888,
  [SMALL_STATE(2786)] = 114909,
  [SMALL_STATE(2787)] = 114934,
  [SMALL_STATE(2788)] = 114959,
  [SMALL_STATE(2789)] = 114972,
  [SMALL_STATE(2790)] = 114985,
  [SMALL_STATE(2791)] = 115002,
  [SMALL_STATE(2792)] = 115027,
  [SMALL_STATE(2793)] = 115052,
  [SMALL_STATE(2794)] = 115077,
  [SMALL_STATE(2795)] = 115102,
  [SMALL_STATE(2796)] = 115127,
  [SMALL_STATE(2797)] = 115144,
  [SMALL_STATE(2798)] = 115169,
  [SMALL_STATE(2799)] = 115190,
  [SMALL_STATE(2800)] = 115215,
  [SMALL_STATE(2801)] = 115232,
  [SMALL_STATE(2802)] = 115247,
  [SMALL_STATE(2803)] = 115268,
  [SMALL_STATE(2804)] = 115285,
  [SMALL_STATE(2805)] = 115298,
  [SMALL_STATE(2806)] = 115319,
  [SMALL_STATE(2807)] = 115340,
  [SMALL_STATE(2808)] = 115353,
  [SMALL_STATE(2809)] = 115378,
  [SMALL_STATE(2810)] = 115403,
  [SMALL_STATE(2811)] = 115428,
  [SMALL_STATE(2812)] = 115453,
  [SMALL_STATE(2813)] = 115478,
  [SMALL_STATE(2814)] = 115499,
  [SMALL_STATE(2815)] = 115515,
  [SMALL_STATE(2816)] = 115537,
  [SMALL_STATE(2817)] = 115559,
  [SMALL_STATE(2818)] = 115577,
  [SMALL_STATE(2819)] = 115595,
  [SMALL_STATE(2820)] = 115613,
  [SMALL_STATE(2821)] = 115627,
  [SMALL_STATE(2822)] = 115649,
  [SMALL_STATE(2823)] = 115665,
  [SMALL_STATE(2824)] = 115687,
  [SMALL_STATE(2825)] = 115703,
  [SMALL_STATE(2826)] = 115719,
  [SMALL_STATE(2827)] = 115741,
  [SMALL_STATE(2828)] = 115763,
  [SMALL_STATE(2829)] = 115779,
  [SMALL_STATE(2830)] = 115801,
  [SMALL_STATE(2831)] = 115823,
  [SMALL_STATE(2832)] = 115843,
  [SMALL_STATE(2833)] = 115859,
  [SMALL_STATE(2834)] = 115875,
  [SMALL_STATE(2835)] = 115895,
  [SMALL_STATE(2836)] = 115917,
  [SMALL_STATE(2837)] = 115935,
  [SMALL_STATE(2838)] = 115957,
  [SMALL_STATE(2839)] = 115977,
  [SMALL_STATE(2840)] = 115999,
  [SMALL_STATE(2841)] = 116017,
  [SMALL_STATE(2842)] = 116033,
  [SMALL_STATE(2843)] = 116055,
  [SMALL_STATE(2844)] = 116071,
  [SMALL_STATE(2845)] = 116089,
  [SMALL_STATE(2846)] = 116107,
  [SMALL_STATE(2847)] = 116129,
  [SMALL_STATE(2848)] = 116151,
  [SMALL_STATE(2849)] = 116171,
  [SMALL_STATE(2850)] = 116189,
  [SMALL_STATE(2851)] = 116201,
  [SMALL_STATE(2852)] = 116213,
  [SMALL_STATE(2853)] = 116235,
  [SMALL_STATE(2854)] = 116251,
  [SMALL_STATE(2855)] = 116267,
  [SMALL_STATE(2856)] = 116289,
  [SMALL_STATE(2857)] = 116305,
  [SMALL_STATE(2858)] = 116327,
  [SMALL_STATE(2859)] = 116349,
  [SMALL_STATE(2860)] = 116371,
  [SMALL_STATE(2861)] = 116389,
  [SMALL_STATE(2862)] = 116405,
  [SMALL_STATE(2863)] = 116421,
  [SMALL_STATE(2864)] = 116437,
  [SMALL_STATE(2865)] = 116449,
  [SMALL_STATE(2866)] = 116465,
  [SMALL_STATE(2867)] = 116487,
  [SMALL_STATE(2868)] = 116503,
  [SMALL_STATE(2869)] = 116525,
  [SMALL_STATE(2870)] = 116541,
  [SMALL_STATE(2871)] = 116563,
  [SMALL_STATE(2872)] = 116579,
  [SMALL_STATE(2873)] = 116601,
  [SMALL_STATE(2874)] = 116623,
  [SMALL_STATE(2875)] = 116639,
  [SMALL_STATE(2876)] = 116661,
  [SMALL_STATE(2877)] = 116683,
  [SMALL_STATE(2878)] = 116699,
  [SMALL_STATE(2879)] = 116721,
  [SMALL_STATE(2880)] = 116733,
  [SMALL_STATE(2881)] = 116745,
  [SMALL_STATE(2882)] = 116765,
  [SMALL_STATE(2883)] = 116787,
  [SMALL_STATE(2884)] = 116809,
  [SMALL_STATE(2885)] = 116825,
  [SMALL_STATE(2886)] = 116837,
  [SMALL_STATE(2887)] = 116849,
  [SMALL_STATE(2888)] = 116861,
  [SMALL_STATE(2889)] = 116883,
  [SMALL_STATE(2890)] = 116905,
  [SMALL_STATE(2891)] = 116921,
  [SMALL_STATE(2892)] = 116933,
  [SMALL_STATE(2893)] = 116955,
  [SMALL_STATE(2894)] = 116977,
  [SMALL_STATE(2895)] = 116999,
  [SMALL_STATE(2896)] = 117015,
  [SMALL_STATE(2897)] = 117027,
  [SMALL_STATE(2898)] = 117049,
  [SMALL_STATE(2899)] = 117067,
  [SMALL_STATE(2900)] = 117089,
  [SMALL_STATE(2901)] = 117107,
  [SMALL_STATE(2902)] = 117123,
  [SMALL_STATE(2903)] = 117135,
  [SMALL_STATE(2904)] = 117157,
  [SMALL_STATE(2905)] = 117175,
  [SMALL_STATE(2906)] = 117193,
  [SMALL_STATE(2907)] = 117215,
  [SMALL_STATE(2908)] = 117229,
  [SMALL_STATE(2909)] = 117247,
  [SMALL_STATE(2910)] = 117269,
  [SMALL_STATE(2911)] = 117285,
  [SMALL_STATE(2912)] = 117301,
  [SMALL_STATE(2913)] = 117317,
  [SMALL_STATE(2914)] = 117333,
  [SMALL_STATE(2915)] = 117349,
  [SMALL_STATE(2916)] = 117371,
  [SMALL_STATE(2917)] = 117387,
  [SMALL_STATE(2918)] = 117403,
  [SMALL_STATE(2919)] = 117425,
  [SMALL_STATE(2920)] = 117443,
  [SMALL_STATE(2921)] = 117465,
  [SMALL_STATE(2922)] = 117481,
  [SMALL_STATE(2923)] = 117497,
  [SMALL_STATE(2924)] = 117519,
  [SMALL_STATE(2925)] = 117535,
  [SMALL_STATE(2926)] = 117553,
  [SMALL_STATE(2927)] = 117575,
  [SMALL_STATE(2928)] = 117597,
  [SMALL_STATE(2929)] = 117609,
  [SMALL_STATE(2930)] = 117627,
  [SMALL_STATE(2931)] = 117645,
  [SMALL_STATE(2932)] = 117667,
  [SMALL_STATE(2933)] = 117685,
  [SMALL_STATE(2934)] = 117703,
  [SMALL_STATE(2935)] = 117719,
  [SMALL_STATE(2936)] = 117741,
  [SMALL_STATE(2937)] = 117763,
  [SMALL_STATE(2938)] = 117785,
  [SMALL_STATE(2939)] = 117797,
  [SMALL_STATE(2940)] = 117815,
  [SMALL_STATE(2941)] = 117833,
  [SMALL_STATE(2942)] = 117849,
  [SMALL_STATE(2943)] = 117867,
  [SMALL_STATE(2944)] = 117879,
  [SMALL_STATE(2945)] = 117901,
  [SMALL_STATE(2946)] = 117917,
  [SMALL_STATE(2947)] = 117933,
  [SMALL_STATE(2948)] = 117949,
  [SMALL_STATE(2949)] = 117965,
  [SMALL_STATE(2950)] = 117981,
  [SMALL_STATE(2951)] = 117997,
  [SMALL_STATE(2952)] = 118011,
  [SMALL_STATE(2953)] = 118027,
  [SMALL_STATE(2954)] = 118039,
  [SMALL_STATE(2955)] = 118061,
  [SMALL_STATE(2956)] = 118077,
  [SMALL_STATE(2957)] = 118099,
  [SMALL_STATE(2958)] = 118115,
  [SMALL_STATE(2959)] = 118137,
  [SMALL_STATE(2960)] = 118159,
  [SMALL_STATE(2961)] = 118171,
  [SMALL_STATE(2962)] = 118187,
  [SMALL_STATE(2963)] = 118209,
  [SMALL_STATE(2964)] = 118225,
  [SMALL_STATE(2965)] = 118241,
  [SMALL_STATE(2966)] = 118259,
  [SMALL_STATE(2967)] = 118277,
  [SMALL_STATE(2968)] = 118291,
  [SMALL_STATE(2969)] = 118309,
  [SMALL_STATE(2970)] = 118325,
  [SMALL_STATE(2971)] = 118347,
  [SMALL_STATE(2972)] = 118358,
  [SMALL_STATE(2973)] = 118375,
  [SMALL_STATE(2974)] = 118394,
  [SMALL_STATE(2975)] = 118405,
  [SMALL_STATE(2976)] = 118422,
  [SMALL_STATE(2977)] = 118437,
  [SMALL_STATE(2978)] = 118456,
  [SMALL_STATE(2979)] = 118475,
  [SMALL_STATE(2980)] = 118494,
  [SMALL_STATE(2981)] = 118513,
  [SMALL_STATE(2982)] = 118526,
  [SMALL_STATE(2983)] = 118545,
  [SMALL_STATE(2984)] = 118564,
  [SMALL_STATE(2985)] = 118579,
  [SMALL_STATE(2986)] = 118590,
  [SMALL_STATE(2987)] = 118601,
  [SMALL_STATE(2988)] = 118620,
  [SMALL_STATE(2989)] = 118639,
  [SMALL_STATE(2990)] = 118658,
  [SMALL_STATE(2991)] = 118677,
  [SMALL_STATE(2992)] = 118692,
  [SMALL_STATE(2993)] = 118711,
  [SMALL_STATE(2994)] = 118728,
  [SMALL_STATE(2995)] = 118739,
  [SMALL_STATE(2996)] = 118758,
  [SMALL_STATE(2997)] = 118777,
  [SMALL_STATE(2998)] = 118796,
  [SMALL_STATE(2999)] = 118807,
  [SMALL_STATE(3000)] = 118826,
  [SMALL_STATE(3001)] = 118839,
  [SMALL_STATE(3002)] = 118858,
  [SMALL_STATE(3003)] = 118875,
  [SMALL_STATE(3004)] = 118892,
  [SMALL_STATE(3005)] = 118911,
  [SMALL_STATE(3006)] = 118930,
  [SMALL_STATE(3007)] = 118949,
  [SMALL_STATE(3008)] = 118966,
  [SMALL_STATE(3009)] = 118985,
  [SMALL_STATE(3010)] = 119004,
  [SMALL_STATE(3011)] = 119023,
  [SMALL_STATE(3012)] = 119040,
  [SMALL_STATE(3013)] = 119057,
  [SMALL_STATE(3014)] = 119068,
  [SMALL_STATE(3015)] = 119079,
  [SMALL_STATE(3016)] = 119090,
  [SMALL_STATE(3017)] = 119101,
  [SMALL_STATE(3018)] = 119112,
  [SMALL_STATE(3019)] = 119123,
  [SMALL_STATE(3020)] = 119138,
  [SMALL_STATE(3021)] = 119153,
  [SMALL_STATE(3022)] = 119170,
  [SMALL_STATE(3023)] = 119185,
  [SMALL_STATE(3024)] = 119204,
  [SMALL_STATE(3025)] = 119219,
  [SMALL_STATE(3026)] = 119236,
  [SMALL_STATE(3027)] = 119255,
  [SMALL_STATE(3028)] = 119272,
  [SMALL_STATE(3029)] = 119283,
  [SMALL_STATE(3030)] = 119298,
  [SMALL_STATE(3031)] = 119317,
  [SMALL_STATE(3032)] = 119336,
  [SMALL_STATE(3033)] = 119355,
  [SMALL_STATE(3034)] = 119374,
  [SMALL_STATE(3035)] = 119389,
  [SMALL_STATE(3036)] = 119408,
  [SMALL_STATE(3037)] = 119427,
  [SMALL_STATE(3038)] = 119446,
  [SMALL_STATE(3039)] = 119463,
  [SMALL_STATE(3040)] = 119476,
  [SMALL_STATE(3041)] = 119489,
  [SMALL_STATE(3042)] = 119508,
  [SMALL_STATE(3043)] = 119527,
  [SMALL_STATE(3044)] = 119544,
  [SMALL_STATE(3045)] = 119563,
  [SMALL_STATE(3046)] = 119582,
  [SMALL_STATE(3047)] = 119601,
  [SMALL_STATE(3048)] = 119620,
  [SMALL_STATE(3049)] = 119637,
  [SMALL_STATE(3050)] = 119652,
  [SMALL_STATE(3051)] = 119667,
  [SMALL_STATE(3052)] = 119678,
  [SMALL_STATE(3053)] = 119689,
  [SMALL_STATE(3054)] = 119700,
  [SMALL_STATE(3055)] = 119711,
  [SMALL_STATE(3056)] = 119730,
  [SMALL_STATE(3057)] = 119741,
  [SMALL_STATE(3058)] = 119760,
  [SMALL_STATE(3059)] = 119771,
  [SMALL_STATE(3060)] = 119788,
  [SMALL_STATE(3061)] = 119807,
  [SMALL_STATE(3062)] = 119818,
  [SMALL_STATE(3063)] = 119829,
  [SMALL_STATE(3064)] = 119842,
  [SMALL_STATE(3065)] = 119853,
  [SMALL_STATE(3066)] = 119872,
  [SMALL_STATE(3067)] = 119883,
  [SMALL_STATE(3068)] = 119898,
  [SMALL_STATE(3069)] = 119917,
  [SMALL_STATE(3070)] = 119928,
  [SMALL_STATE(3071)] = 119947,
  [SMALL_STATE(3072)] = 119966,
  [SMALL_STATE(3073)] = 119985,
  [SMALL_STATE(3074)] = 120000,
  [SMALL_STATE(3075)] = 120015,
  [SMALL_STATE(3076)] = 120026,
  [SMALL_STATE(3077)] = 120045,
  [SMALL_STATE(3078)] = 120062,
  [SMALL_STATE(3079)] = 120081,
  [SMALL_STATE(3080)] = 120100,
  [SMALL_STATE(3081)] = 120119,
  [SMALL_STATE(3082)] = 120138,
  [SMALL_STATE(3083)] = 120153,
  [SMALL_STATE(3084)] = 120172,
  [SMALL_STATE(3085)] = 120183,
  [SMALL_STATE(3086)] = 120194,
  [SMALL_STATE(3087)] = 120213,
  [SMALL_STATE(3088)] = 120224,
  [SMALL_STATE(3089)] = 120243,
  [SMALL_STATE(3090)] = 120254,
  [SMALL_STATE(3091)] = 120265,
  [SMALL_STATE(3092)] = 120284,
  [SMALL_STATE(3093)] = 120295,
  [SMALL_STATE(3094)] = 120314,
  [SMALL_STATE(3095)] = 120325,
  [SMALL_STATE(3096)] = 120336,
  [SMALL_STATE(3097)] = 120355,
  [SMALL_STATE(3098)] = 120366,
  [SMALL_STATE(3099)] = 120385,
  [SMALL_STATE(3100)] = 120400,
  [SMALL_STATE(3101)] = 120419,
  [SMALL_STATE(3102)] = 120434,
  [SMALL_STATE(3103)] = 120453,
  [SMALL_STATE(3104)] = 120472,
  [SMALL_STATE(3105)] = 120491,
  [SMALL_STATE(3106)] = 120506,
  [SMALL_STATE(3107)] = 120523,
  [SMALL_STATE(3108)] = 120542,
  [SMALL_STATE(3109)] = 120561,
  [SMALL_STATE(3110)] = 120572,
  [SMALL_STATE(3111)] = 120591,
  [SMALL_STATE(3112)] = 120602,
  [SMALL_STATE(3113)] = 120613,
  [SMALL_STATE(3114)] = 120624,
  [SMALL_STATE(3115)] = 120635,
  [SMALL_STATE(3116)] = 120646,
  [SMALL_STATE(3117)] = 120657,
  [SMALL_STATE(3118)] = 120672,
  [SMALL_STATE(3119)] = 120691,
  [SMALL_STATE(3120)] = 120706,
  [SMALL_STATE(3121)] = 120725,
  [SMALL_STATE(3122)] = 120742,
  [SMALL_STATE(3123)] = 120761,
  [SMALL_STATE(3124)] = 120772,
  [SMALL_STATE(3125)] = 120783,
  [SMALL_STATE(3126)] = 120794,
  [SMALL_STATE(3127)] = 120805,
  [SMALL_STATE(3128)] = 120824,
  [SMALL_STATE(3129)] = 120835,
  [SMALL_STATE(3130)] = 120846,
  [SMALL_STATE(3131)] = 120857,
  [SMALL_STATE(3132)] = 120868,
  [SMALL_STATE(3133)] = 120879,
  [SMALL_STATE(3134)] = 120898,
  [SMALL_STATE(3135)] = 120913,
  [SMALL_STATE(3136)] = 120928,
  [SMALL_STATE(3137)] = 120947,
  [SMALL_STATE(3138)] = 120964,
  [SMALL_STATE(3139)] = 120975,
  [SMALL_STATE(3140)] = 120994,
  [SMALL_STATE(3141)] = 121005,
  [SMALL_STATE(3142)] = 121016,
  [SMALL_STATE(3143)] = 121027,
  [SMALL_STATE(3144)] = 121038,
  [SMALL_STATE(3145)] = 121049,
  [SMALL_STATE(3146)] = 121068,
  [SMALL_STATE(3147)] = 121083,
  [SMALL_STATE(3148)] = 121094,
  [SMALL_STATE(3149)] = 121105,
  [SMALL_STATE(3150)] = 121116,
  [SMALL_STATE(3151)] = 121133,
  [SMALL_STATE(3152)] = 121152,
  [SMALL_STATE(3153)] = 121167,
  [SMALL_STATE(3154)] = 121182,
  [SMALL_STATE(3155)] = 121201,
  [SMALL_STATE(3156)] = 121212,
  [SMALL_STATE(3157)] = 121227,
  [SMALL_STATE(3158)] = 121244,
  [SMALL_STATE(3159)] = 121255,
  [SMALL_STATE(3160)] = 121266,
  [SMALL_STATE(3161)] = 121277,
  [SMALL_STATE(3162)] = 121288,
  [SMALL_STATE(3163)] = 121299,
  [SMALL_STATE(3164)] = 121316,
  [SMALL_STATE(3165)] = 121327,
  [SMALL_STATE(3166)] = 121338,
  [SMALL_STATE(3167)] = 121349,
  [SMALL_STATE(3168)] = 121360,
  [SMALL_STATE(3169)] = 121371,
  [SMALL_STATE(3170)] = 121382,
  [SMALL_STATE(3171)] = 121393,
  [SMALL_STATE(3172)] = 121404,
  [SMALL_STATE(3173)] = 121415,
  [SMALL_STATE(3174)] = 121426,
  [SMALL_STATE(3175)] = 121445,
  [SMALL_STATE(3176)] = 121456,
  [SMALL_STATE(3177)] = 121467,
  [SMALL_STATE(3178)] = 121478,
  [SMALL_STATE(3179)] = 121489,
  [SMALL_STATE(3180)] = 121500,
  [SMALL_STATE(3181)] = 121511,
  [SMALL_STATE(3182)] = 121522,
  [SMALL_STATE(3183)] = 121533,
  [SMALL_STATE(3184)] = 121544,
  [SMALL_STATE(3185)] = 121555,
  [SMALL_STATE(3186)] = 121566,
  [SMALL_STATE(3187)] = 121577,
  [SMALL_STATE(3188)] = 121588,
  [SMALL_STATE(3189)] = 121599,
  [SMALL_STATE(3190)] = 121610,
  [SMALL_STATE(3191)] = 121627,
  [SMALL_STATE(3192)] = 121638,
  [SMALL_STATE(3193)] = 121649,
  [SMALL_STATE(3194)] = 121660,
  [SMALL_STATE(3195)] = 121671,
  [SMALL_STATE(3196)] = 121682,
  [SMALL_STATE(3197)] = 121693,
  [SMALL_STATE(3198)] = 121704,
  [SMALL_STATE(3199)] = 121715,
  [SMALL_STATE(3200)] = 121726,
  [SMALL_STATE(3201)] = 121737,
  [SMALL_STATE(3202)] = 121748,
  [SMALL_STATE(3203)] = 121759,
  [SMALL_STATE(3204)] = 121778,
  [SMALL_STATE(3205)] = 121795,
  [SMALL_STATE(3206)] = 121806,
  [SMALL_STATE(3207)] = 121817,
  [SMALL_STATE(3208)] = 121828,
  [SMALL_STATE(3209)] = 121839,
  [SMALL_STATE(3210)] = 121850,
  [SMALL_STATE(3211)] = 121861,
  [SMALL_STATE(3212)] = 121872,
  [SMALL_STATE(3213)] = 121883,
  [SMALL_STATE(3214)] = 121894,
  [SMALL_STATE(3215)] = 121905,
  [SMALL_STATE(3216)] = 121916,
  [SMALL_STATE(3217)] = 121927,
  [SMALL_STATE(3218)] = 121938,
  [SMALL_STATE(3219)] = 121949,
  [SMALL_STATE(3220)] = 121960,
  [SMALL_STATE(3221)] = 121971,
  [SMALL_STATE(3222)] = 121982,
  [SMALL_STATE(3223)] = 121993,
  [SMALL_STATE(3224)] = 122004,
  [SMALL_STATE(3225)] = 122015,
  [SMALL_STATE(3226)] = 122026,
  [SMALL_STATE(3227)] = 122037,
  [SMALL_STATE(3228)] = 122048,
  [SMALL_STATE(3229)] = 122059,
  [SMALL_STATE(3230)] = 122070,
  [SMALL_STATE(3231)] = 122081,
  [SMALL_STATE(3232)] = 122092,
  [SMALL_STATE(3233)] = 122103,
  [SMALL_STATE(3234)] = 122114,
  [SMALL_STATE(3235)] = 122125,
  [SMALL_STATE(3236)] = 122136,
  [SMALL_STATE(3237)] = 122147,
  [SMALL_STATE(3238)] = 122158,
  [SMALL_STATE(3239)] = 122169,
  [SMALL_STATE(3240)] = 122180,
  [SMALL_STATE(3241)] = 122191,
  [SMALL_STATE(3242)] = 122202,
  [SMALL_STATE(3243)] = 122216,
  [SMALL_STATE(3244)] = 122230,
  [SMALL_STATE(3245)] = 122244,
  [SMALL_STATE(3246)] = 122260,
  [SMALL_STATE(3247)] = 122276,
  [SMALL_STATE(3248)] = 122292,
  [SMALL_STATE(3249)] = 122306,
  [SMALL_STATE(3250)] = 122322,
  [SMALL_STATE(3251)] = 122338,
  [SMALL_STATE(3252)] = 122354,
  [SMALL_STATE(3253)] = 122368,
  [SMALL_STATE(3254)] = 122384,
  [SMALL_STATE(3255)] = 122400,
  [SMALL_STATE(3256)] = 122414,
  [SMALL_STATE(3257)] = 122428,
  [SMALL_STATE(3258)] = 122442,
  [SMALL_STATE(3259)] = 122456,
  [SMALL_STATE(3260)] = 122468,
  [SMALL_STATE(3261)] = 122480,
  [SMALL_STATE(3262)] = 122494,
  [SMALL_STATE(3263)] = 122508,
  [SMALL_STATE(3264)] = 122522,
  [SMALL_STATE(3265)] = 122536,
  [SMALL_STATE(3266)] = 122550,
  [SMALL_STATE(3267)] = 122564,
  [SMALL_STATE(3268)] = 122580,
  [SMALL_STATE(3269)] = 122594,
  [SMALL_STATE(3270)] = 122610,
  [SMALL_STATE(3271)] = 122626,
  [SMALL_STATE(3272)] = 122642,
  [SMALL_STATE(3273)] = 122658,
  [SMALL_STATE(3274)] = 122672,
  [SMALL_STATE(3275)] = 122688,
  [SMALL_STATE(3276)] = 122698,
  [SMALL_STATE(3277)] = 122712,
  [SMALL_STATE(3278)] = 122726,
  [SMALL_STATE(3279)] = 122742,
  [SMALL_STATE(3280)] = 122758,
  [SMALL_STATE(3281)] = 122774,
  [SMALL_STATE(3282)] = 122788,
  [SMALL_STATE(3283)] = 122802,
  [SMALL_STATE(3284)] = 122816,
  [SMALL_STATE(3285)] = 122830,
  [SMALL_STATE(3286)] = 122846,
  [SMALL_STATE(3287)] = 122860,
  [SMALL_STATE(3288)] = 122872,
  [SMALL_STATE(3289)] = 122884,
  [SMALL_STATE(3290)] = 122900,
  [SMALL_STATE(3291)] = 122914,
  [SMALL_STATE(3292)] = 122930,
  [SMALL_STATE(3293)] = 122944,
  [SMALL_STATE(3294)] = 122960,
  [SMALL_STATE(3295)] = 122970,
  [SMALL_STATE(3296)] = 122986,
  [SMALL_STATE(3297)] = 123002,
  [SMALL_STATE(3298)] = 123016,
  [SMALL_STATE(3299)] = 123032,
  [SMALL_STATE(3300)] = 123048,
  [SMALL_STATE(3301)] = 123062,
  [SMALL_STATE(3302)] = 123076,
  [SMALL_STATE(3303)] = 123092,
  [SMALL_STATE(3304)] = 123108,
  [SMALL_STATE(3305)] = 123124,
  [SMALL_STATE(3306)] = 123140,
  [SMALL_STATE(3307)] = 123154,
  [SMALL_STATE(3308)] = 123170,
  [SMALL_STATE(3309)] = 123184,
  [SMALL_STATE(3310)] = 123200,
  [SMALL_STATE(3311)] = 123216,
  [SMALL_STATE(3312)] = 123230,
  [SMALL_STATE(3313)] = 123244,
  [SMALL_STATE(3314)] = 123260,
  [SMALL_STATE(3315)] = 123274,
  [SMALL_STATE(3316)] = 123288,
  [SMALL_STATE(3317)] = 123304,
  [SMALL_STATE(3318)] = 123318,
  [SMALL_STATE(3319)] = 123332,
  [SMALL_STATE(3320)] = 123348,
  [SMALL_STATE(3321)] = 123362,
  [SMALL_STATE(3322)] = 123372,
  [SMALL_STATE(3323)] = 123386,
  [SMALL_STATE(3324)] = 123402,
  [SMALL_STATE(3325)] = 123418,
  [SMALL_STATE(3326)] = 123434,
  [SMALL_STATE(3327)] = 123450,
  [SMALL_STATE(3328)] = 123466,
  [SMALL_STATE(3329)] = 123482,
  [SMALL_STATE(3330)] = 123498,
  [SMALL_STATE(3331)] = 123514,
  [SMALL_STATE(3332)] = 123528,
  [SMALL_STATE(3333)] = 123542,
  [SMALL_STATE(3334)] = 123556,
  [SMALL_STATE(3335)] = 123570,
  [SMALL_STATE(3336)] = 123584,
  [SMALL_STATE(3337)] = 123598,
  [SMALL_STATE(3338)] = 123612,
  [SMALL_STATE(3339)] = 123626,
  [SMALL_STATE(3340)] = 123640,
  [SMALL_STATE(3341)] = 123654,
  [SMALL_STATE(3342)] = 123668,
  [SMALL_STATE(3343)] = 123682,
  [SMALL_STATE(3344)] = 123696,
  [SMALL_STATE(3345)] = 123712,
  [SMALL_STATE(3346)] = 123726,
  [SMALL_STATE(3347)] = 123742,
  [SMALL_STATE(3348)] = 123758,
  [SMALL_STATE(3349)] = 123772,
  [SMALL_STATE(3350)] = 123786,
  [SMALL_STATE(3351)] = 123800,
  [SMALL_STATE(3352)] = 123816,
  [SMALL_STATE(3353)] = 123830,
  [SMALL_STATE(3354)] = 123846,
  [SMALL_STATE(3355)] = 123859,
  [SMALL_STATE(3356)] = 123872,
  [SMALL_STATE(3357)] = 123885,
  [SMALL_STATE(3358)] = 123896,
  [SMALL_STATE(3359)] = 123907,
  [SMALL_STATE(3360)] = 123920,
  [SMALL_STATE(3361)] = 123933,
  [SMALL_STATE(3362)] = 123946,
  [SMALL_STATE(3363)] = 123959,
  [SMALL_STATE(3364)] = 123972,
  [SMALL_STATE(3365)] = 123985,
  [SMALL_STATE(3366)] = 123994,
  [SMALL_STATE(3367)] = 124007,
  [SMALL_STATE(3368)] = 124018,
  [SMALL_STATE(3369)] = 124031,
  [SMALL_STATE(3370)] = 124044,
  [SMALL_STATE(3371)] = 124055,
  [SMALL_STATE(3372)] = 124068,
  [SMALL_STATE(3373)] = 124079,
  [SMALL_STATE(3374)] = 124092,
  [SMALL_STATE(3375)] = 124105,
  [SMALL_STATE(3376)] = 124114,
  [SMALL_STATE(3377)] = 124127,
  [SMALL_STATE(3378)] = 124136,
  [SMALL_STATE(3379)] = 124149,
  [SMALL_STATE(3380)] = 124162,
  [SMALL_STATE(3381)] = 124171,
  [SMALL_STATE(3382)] = 124180,
  [SMALL_STATE(3383)] = 124193,
  [SMALL_STATE(3384)] = 124206,
  [SMALL_STATE(3385)] = 124217,
  [SMALL_STATE(3386)] = 124230,
  [SMALL_STATE(3387)] = 124243,
  [SMALL_STATE(3388)] = 124256,
  [SMALL_STATE(3389)] = 124269,
  [SMALL_STATE(3390)] = 124282,
  [SMALL_STATE(3391)] = 124295,
  [SMALL_STATE(3392)] = 124308,
  [SMALL_STATE(3393)] = 124321,
  [SMALL_STATE(3394)] = 124334,
  [SMALL_STATE(3395)] = 124347,
  [SMALL_STATE(3396)] = 124360,
  [SMALL_STATE(3397)] = 124369,
  [SMALL_STATE(3398)] = 124380,
  [SMALL_STATE(3399)] = 124393,
  [SMALL_STATE(3400)] = 124406,
  [SMALL_STATE(3401)] = 124419,
  [SMALL_STATE(3402)] = 124428,
  [SMALL_STATE(3403)] = 124441,
  [SMALL_STATE(3404)] = 124454,
  [SMALL_STATE(3405)] = 124467,
  [SMALL_STATE(3406)] = 124480,
  [SMALL_STATE(3407)] = 124493,
  [SMALL_STATE(3408)] = 124506,
  [SMALL_STATE(3409)] = 124519,
  [SMALL_STATE(3410)] = 124532,
  [SMALL_STATE(3411)] = 124545,
  [SMALL_STATE(3412)] = 124554,
  [SMALL_STATE(3413)] = 124567,
  [SMALL_STATE(3414)] = 124580,
  [SMALL_STATE(3415)] = 124589,
  [SMALL_STATE(3416)] = 124602,
  [SMALL_STATE(3417)] = 124615,
  [SMALL_STATE(3418)] = 124624,
  [SMALL_STATE(3419)] = 124633,
  [SMALL_STATE(3420)] = 124646,
  [SMALL_STATE(3421)] = 124659,
  [SMALL_STATE(3422)] = 124672,
  [SMALL_STATE(3423)] = 124681,
  [SMALL_STATE(3424)] = 124690,
  [SMALL_STATE(3425)] = 124701,
  [SMALL_STATE(3426)] = 124710,
  [SMALL_STATE(3427)] = 124723,
  [SMALL_STATE(3428)] = 124736,
  [SMALL_STATE(3429)] = 124749,
  [SMALL_STATE(3430)] = 124758,
  [SMALL_STATE(3431)] = 124771,
  [SMALL_STATE(3432)] = 124784,
  [SMALL_STATE(3433)] = 124797,
  [SMALL_STATE(3434)] = 124806,
  [SMALL_STATE(3435)] = 124817,
  [SMALL_STATE(3436)] = 124830,
  [SMALL_STATE(3437)] = 124843,
  [SMALL_STATE(3438)] = 124856,
  [SMALL_STATE(3439)] = 124869,
  [SMALL_STATE(3440)] = 124882,
  [SMALL_STATE(3441)] = 124895,
  [SMALL_STATE(3442)] = 124908,
  [SMALL_STATE(3443)] = 124921,
  [SMALL_STATE(3444)] = 124934,
  [SMALL_STATE(3445)] = 124947,
  [SMALL_STATE(3446)] = 124960,
  [SMALL_STATE(3447)] = 124973,
  [SMALL_STATE(3448)] = 124986,
  [SMALL_STATE(3449)] = 124999,
  [SMALL_STATE(3450)] = 125008,
  [SMALL_STATE(3451)] = 125021,
  [SMALL_STATE(3452)] = 125034,
  [SMALL_STATE(3453)] = 125047,
  [SMALL_STATE(3454)] = 125058,
  [SMALL_STATE(3455)] = 125069,
  [SMALL_STATE(3456)] = 125078,
  [SMALL_STATE(3457)] = 125087,
  [SMALL_STATE(3458)] = 125100,
  [SMALL_STATE(3459)] = 125109,
  [SMALL_STATE(3460)] = 125120,
  [SMALL_STATE(3461)] = 125129,
  [SMALL_STATE(3462)] = 125142,
  [SMALL_STATE(3463)] = 125155,
  [SMALL_STATE(3464)] = 125168,
  [SMALL_STATE(3465)] = 125181,
  [SMALL_STATE(3466)] = 125190,
  [SMALL_STATE(3467)] = 125199,
  [SMALL_STATE(3468)] = 125208,
  [SMALL_STATE(3469)] = 125221,
  [SMALL_STATE(3470)] = 125234,
  [SMALL_STATE(3471)] = 125243,
  [SMALL_STATE(3472)] = 125252,
  [SMALL_STATE(3473)] = 125263,
  [SMALL_STATE(3474)] = 125276,
  [SMALL_STATE(3475)] = 125289,
  [SMALL_STATE(3476)] = 125300,
  [SMALL_STATE(3477)] = 125309,
  [SMALL_STATE(3478)] = 125318,
  [SMALL_STATE(3479)] = 125327,
  [SMALL_STATE(3480)] = 125340,
  [SMALL_STATE(3481)] = 125353,
  [SMALL_STATE(3482)] = 125364,
  [SMALL_STATE(3483)] = 125377,
  [SMALL_STATE(3484)] = 125386,
  [SMALL_STATE(3485)] = 125399,
  [SMALL_STATE(3486)] = 125412,
  [SMALL_STATE(3487)] = 125425,
  [SMALL_STATE(3488)] = 125438,
  [SMALL_STATE(3489)] = 125451,
  [SMALL_STATE(3490)] = 125462,
  [SMALL_STATE(3491)] = 125475,
  [SMALL_STATE(3492)] = 125488,
  [SMALL_STATE(3493)] = 125501,
  [SMALL_STATE(3494)] = 125514,
  [SMALL_STATE(3495)] = 125527,
  [SMALL_STATE(3496)] = 125540,
  [SMALL_STATE(3497)] = 125553,
  [SMALL_STATE(3498)] = 125566,
  [SMALL_STATE(3499)] = 125575,
  [SMALL_STATE(3500)] = 125584,
  [SMALL_STATE(3501)] = 125597,
  [SMALL_STATE(3502)] = 125610,
  [SMALL_STATE(3503)] = 125619,
  [SMALL_STATE(3504)] = 125632,
  [SMALL_STATE(3505)] = 125641,
  [SMALL_STATE(3506)] = 125654,
  [SMALL_STATE(3507)] = 125665,
  [SMALL_STATE(3508)] = 125674,
  [SMALL_STATE(3509)] = 125683,
  [SMALL_STATE(3510)] = 125696,
  [SMALL_STATE(3511)] = 125709,
  [SMALL_STATE(3512)] = 125718,
  [SMALL_STATE(3513)] = 125727,
  [SMALL_STATE(3514)] = 125736,
  [SMALL_STATE(3515)] = 125749,
  [SMALL_STATE(3516)] = 125762,
  [SMALL_STATE(3517)] = 125775,
  [SMALL_STATE(3518)] = 125784,
  [SMALL_STATE(3519)] = 125797,
  [SMALL_STATE(3520)] = 125810,
  [SMALL_STATE(3521)] = 125823,
  [SMALL_STATE(3522)] = 125836,
  [SMALL_STATE(3523)] = 125847,
  [SMALL_STATE(3524)] = 125856,
  [SMALL_STATE(3525)] = 125869,
  [SMALL_STATE(3526)] = 125880,
  [SMALL_STATE(3527)] = 125893,
  [SMALL_STATE(3528)] = 125906,
  [SMALL_STATE(3529)] = 125919,
  [SMALL_STATE(3530)] = 125932,
  [SMALL_STATE(3531)] = 125941,
  [SMALL_STATE(3532)] = 125954,
  [SMALL_STATE(3533)] = 125967,
  [SMALL_STATE(3534)] = 125980,
  [SMALL_STATE(3535)] = 125993,
  [SMALL_STATE(3536)] = 126002,
  [SMALL_STATE(3537)] = 126015,
  [SMALL_STATE(3538)] = 126028,
  [SMALL_STATE(3539)] = 126041,
  [SMALL_STATE(3540)] = 126052,
  [SMALL_STATE(3541)] = 126061,
  [SMALL_STATE(3542)] = 126074,
  [SMALL_STATE(3543)] = 126087,
  [SMALL_STATE(3544)] = 126096,
  [SMALL_STATE(3545)] = 126105,
  [SMALL_STATE(3546)] = 126114,
  [SMALL_STATE(3547)] = 126123,
  [SMALL_STATE(3548)] = 126132,
  [SMALL_STATE(3549)] = 126145,
  [SMALL_STATE(3550)] = 126154,
  [SMALL_STATE(3551)] = 126167,
  [SMALL_STATE(3552)] = 126180,
  [SMALL_STATE(3553)] = 126189,
  [SMALL_STATE(3554)] = 126202,
  [SMALL_STATE(3555)] = 126215,
  [SMALL_STATE(3556)] = 126228,
  [SMALL_STATE(3557)] = 126241,
  [SMALL_STATE(3558)] = 126254,
  [SMALL_STATE(3559)] = 126267,
  [SMALL_STATE(3560)] = 126278,
  [SMALL_STATE(3561)] = 126291,
  [SMALL_STATE(3562)] = 126304,
  [SMALL_STATE(3563)] = 126313,
  [SMALL_STATE(3564)] = 126322,
  [SMALL_STATE(3565)] = 126331,
  [SMALL_STATE(3566)] = 126340,
  [SMALL_STATE(3567)] = 126349,
  [SMALL_STATE(3568)] = 126358,
  [SMALL_STATE(3569)] = 126367,
  [SMALL_STATE(3570)] = 126380,
  [SMALL_STATE(3571)] = 126393,
  [SMALL_STATE(3572)] = 126406,
  [SMALL_STATE(3573)] = 126419,
  [SMALL_STATE(3574)] = 126428,
  [SMALL_STATE(3575)] = 126437,
  [SMALL_STATE(3576)] = 126446,
  [SMALL_STATE(3577)] = 126459,
  [SMALL_STATE(3578)] = 126468,
  [SMALL_STATE(3579)] = 126481,
  [SMALL_STATE(3580)] = 126494,
  [SMALL_STATE(3581)] = 126507,
  [SMALL_STATE(3582)] = 126516,
  [SMALL_STATE(3583)] = 126529,
  [SMALL_STATE(3584)] = 126542,
  [SMALL_STATE(3585)] = 126555,
  [SMALL_STATE(3586)] = 126568,
  [SMALL_STATE(3587)] = 126581,
  [SMALL_STATE(3588)] = 126594,
  [SMALL_STATE(3589)] = 126602,
  [SMALL_STATE(3590)] = 126612,
  [SMALL_STATE(3591)] = 126622,
  [SMALL_STATE(3592)] = 126632,
  [SMALL_STATE(3593)] = 126642,
  [SMALL_STATE(3594)] = 126652,
  [SMALL_STATE(3595)] = 126662,
  [SMALL_STATE(3596)] = 126672,
  [SMALL_STATE(3597)] = 126680,
  [SMALL_STATE(3598)] = 126690,
  [SMALL_STATE(3599)] = 126698,
  [SMALL_STATE(3600)] = 126708,
  [SMALL_STATE(3601)] = 126716,
  [SMALL_STATE(3602)] = 126726,
  [SMALL_STATE(3603)] = 126736,
  [SMALL_STATE(3604)] = 126746,
  [SMALL_STATE(3605)] = 126754,
  [SMALL_STATE(3606)] = 126764,
  [SMALL_STATE(3607)] = 126774,
  [SMALL_STATE(3608)] = 126782,
  [SMALL_STATE(3609)] = 126792,
  [SMALL_STATE(3610)] = 126800,
  [SMALL_STATE(3611)] = 126810,
  [SMALL_STATE(3612)] = 126820,
  [SMALL_STATE(3613)] = 126830,
  [SMALL_STATE(3614)] = 126838,
  [SMALL_STATE(3615)] = 126848,
  [SMALL_STATE(3616)] = 126856,
  [SMALL_STATE(3617)] = 126866,
  [SMALL_STATE(3618)] = 126876,
  [SMALL_STATE(3619)] = 126886,
  [SMALL_STATE(3620)] = 126894,
  [SMALL_STATE(3621)] = 126904,
  [SMALL_STATE(3622)] = 126914,
  [SMALL_STATE(3623)] = 126924,
  [SMALL_STATE(3624)] = 126932,
  [SMALL_STATE(3625)] = 126942,
  [SMALL_STATE(3626)] = 126950,
  [SMALL_STATE(3627)] = 126960,
  [SMALL_STATE(3628)] = 126968,
  [SMALL_STATE(3629)] = 126978,
  [SMALL_STATE(3630)] = 126988,
  [SMALL_STATE(3631)] = 126998,
  [SMALL_STATE(3632)] = 127008,
  [SMALL_STATE(3633)] = 127016,
  [SMALL_STATE(3634)] = 127026,
  [SMALL_STATE(3635)] = 127036,
  [SMALL_STATE(3636)] = 127044,
  [SMALL_STATE(3637)] = 127054,
  [SMALL_STATE(3638)] = 127062,
  [SMALL_STATE(3639)] = 127072,
  [SMALL_STATE(3640)] = 127082,
  [SMALL_STATE(3641)] = 127092,
  [SMALL_STATE(3642)] = 127102,
  [SMALL_STATE(3643)] = 127112,
  [SMALL_STATE(3644)] = 127122,
  [SMALL_STATE(3645)] = 127130,
  [SMALL_STATE(3646)] = 127140,
  [SMALL_STATE(3647)] = 127150,
  [SMALL_STATE(3648)] = 127160,
  [SMALL_STATE(3649)] = 127170,
  [SMALL_STATE(3650)] = 127180,
  [SMALL_STATE(3651)] = 127190,
  [SMALL_STATE(3652)] = 127200,
  [SMALL_STATE(3653)] = 127210,
  [SMALL_STATE(3654)] = 127218,
  [SMALL_STATE(3655)] = 127228,
  [SMALL_STATE(3656)] = 127238,
  [SMALL_STATE(3657)] = 127248,
  [SMALL_STATE(3658)] = 127258,
  [SMALL_STATE(3659)] = 127266,
  [SMALL_STATE(3660)] = 127276,
  [SMALL_STATE(3661)] = 127286,
  [SMALL_STATE(3662)] = 127296,
  [SMALL_STATE(3663)] = 127306,
  [SMALL_STATE(3664)] = 127316,
  [SMALL_STATE(3665)] = 127326,
  [SMALL_STATE(3666)] = 127334,
  [SMALL_STATE(3667)] = 127344,
  [SMALL_STATE(3668)] = 127354,
  [SMALL_STATE(3669)] = 127362,
  [SMALL_STATE(3670)] = 127370,
  [SMALL_STATE(3671)] = 127378,
  [SMALL_STATE(3672)] = 127388,
  [SMALL_STATE(3673)] = 127396,
  [SMALL_STATE(3674)] = 127406,
  [SMALL_STATE(3675)] = 127416,
  [SMALL_STATE(3676)] = 127424,
  [SMALL_STATE(3677)] = 127434,
  [SMALL_STATE(3678)] = 127442,
  [SMALL_STATE(3679)] = 127450,
  [SMALL_STATE(3680)] = 127458,
  [SMALL_STATE(3681)] = 127468,
  [SMALL_STATE(3682)] = 127478,
  [SMALL_STATE(3683)] = 127488,
  [SMALL_STATE(3684)] = 127498,
  [SMALL_STATE(3685)] = 127508,
  [SMALL_STATE(3686)] = 127518,
  [SMALL_STATE(3687)] = 127528,
  [SMALL_STATE(3688)] = 127538,
  [SMALL_STATE(3689)] = 127546,
  [SMALL_STATE(3690)] = 127554,
  [SMALL_STATE(3691)] = 127564,
  [SMALL_STATE(3692)] = 127574,
  [SMALL_STATE(3693)] = 127584,
  [SMALL_STATE(3694)] = 127594,
  [SMALL_STATE(3695)] = 127604,
  [SMALL_STATE(3696)] = 127614,
  [SMALL_STATE(3697)] = 127624,
  [SMALL_STATE(3698)] = 127634,
  [SMALL_STATE(3699)] = 127644,
  [SMALL_STATE(3700)] = 127654,
  [SMALL_STATE(3701)] = 127662,
  [SMALL_STATE(3702)] = 127670,
  [SMALL_STATE(3703)] = 127680,
  [SMALL_STATE(3704)] = 127690,
  [SMALL_STATE(3705)] = 127700,
  [SMALL_STATE(3706)] = 127710,
  [SMALL_STATE(3707)] = 127718,
  [SMALL_STATE(3708)] = 127728,
  [SMALL_STATE(3709)] = 127738,
  [SMALL_STATE(3710)] = 127746,
  [SMALL_STATE(3711)] = 127756,
  [SMALL_STATE(3712)] = 127766,
  [SMALL_STATE(3713)] = 127776,
  [SMALL_STATE(3714)] = 127786,
  [SMALL_STATE(3715)] = 127794,
  [SMALL_STATE(3716)] = 127804,
  [SMALL_STATE(3717)] = 127812,
  [SMALL_STATE(3718)] = 127822,
  [SMALL_STATE(3719)] = 127832,
  [SMALL_STATE(3720)] = 127840,
  [SMALL_STATE(3721)] = 127850,
  [SMALL_STATE(3722)] = 127858,
  [SMALL_STATE(3723)] = 127868,
  [SMALL_STATE(3724)] = 127878,
  [SMALL_STATE(3725)] = 127888,
  [SMALL_STATE(3726)] = 127898,
  [SMALL_STATE(3727)] = 127906,
  [SMALL_STATE(3728)] = 127916,
  [SMALL_STATE(3729)] = 127926,
  [SMALL_STATE(3730)] = 127936,
  [SMALL_STATE(3731)] = 127946,
  [SMALL_STATE(3732)] = 127956,
  [SMALL_STATE(3733)] = 127964,
  [SMALL_STATE(3734)] = 127974,
  [SMALL_STATE(3735)] = 127982,
  [SMALL_STATE(3736)] = 127992,
  [SMALL_STATE(3737)] = 128002,
  [SMALL_STATE(3738)] = 128010,
  [SMALL_STATE(3739)] = 128020,
  [SMALL_STATE(3740)] = 128030,
  [SMALL_STATE(3741)] = 128040,
  [SMALL_STATE(3742)] = 128050,
  [SMALL_STATE(3743)] = 128060,
  [SMALL_STATE(3744)] = 128070,
  [SMALL_STATE(3745)] = 128080,
  [SMALL_STATE(3746)] = 128090,
  [SMALL_STATE(3747)] = 128100,
  [SMALL_STATE(3748)] = 128110,
  [SMALL_STATE(3749)] = 128120,
  [SMALL_STATE(3750)] = 128130,
  [SMALL_STATE(3751)] = 128138,
  [SMALL_STATE(3752)] = 128148,
  [SMALL_STATE(3753)] = 128158,
  [SMALL_STATE(3754)] = 128168,
  [SMALL_STATE(3755)] = 128176,
  [SMALL_STATE(3756)] = 128186,
  [SMALL_STATE(3757)] = 128196,
  [SMALL_STATE(3758)] = 128206,
  [SMALL_STATE(3759)] = 128214,
  [SMALL_STATE(3760)] = 128224,
  [SMALL_STATE(3761)] = 128234,
  [SMALL_STATE(3762)] = 128244,
  [SMALL_STATE(3763)] = 128254,
  [SMALL_STATE(3764)] = 128264,
  [SMALL_STATE(3765)] = 128274,
  [SMALL_STATE(3766)] = 128284,
  [SMALL_STATE(3767)] = 128294,
  [SMALL_STATE(3768)] = 128304,
  [SMALL_STATE(3769)] = 128314,
  [SMALL_STATE(3770)] = 128324,
  [SMALL_STATE(3771)] = 128334,
  [SMALL_STATE(3772)] = 128344,
  [SMALL_STATE(3773)] = 128354,
  [SMALL_STATE(3774)] = 128364,
  [SMALL_STATE(3775)] = 128374,
  [SMALL_STATE(3776)] = 128384,
  [SMALL_STATE(3777)] = 128392,
  [SMALL_STATE(3778)] = 128402,
  [SMALL_STATE(3779)] = 128412,
  [SMALL_STATE(3780)] = 128422,
  [SMALL_STATE(3781)] = 128432,
  [SMALL_STATE(3782)] = 128442,
  [SMALL_STATE(3783)] = 128452,
  [SMALL_STATE(3784)] = 128462,
  [SMALL_STATE(3785)] = 128472,
  [SMALL_STATE(3786)] = 128480,
  [SMALL_STATE(3787)] = 128490,
  [SMALL_STATE(3788)] = 128500,
  [SMALL_STATE(3789)] = 128508,
  [SMALL_STATE(3790)] = 128516,
  [SMALL_STATE(3791)] = 128524,
  [SMALL_STATE(3792)] = 128534,
  [SMALL_STATE(3793)] = 128542,
  [SMALL_STATE(3794)] = 128550,
  [SMALL_STATE(3795)] = 128560,
  [SMALL_STATE(3796)] = 128568,
  [SMALL_STATE(3797)] = 128576,
  [SMALL_STATE(3798)] = 128584,
  [SMALL_STATE(3799)] = 128592,
  [SMALL_STATE(3800)] = 128602,
  [SMALL_STATE(3801)] = 128610,
  [SMALL_STATE(3802)] = 128620,
  [SMALL_STATE(3803)] = 128630,
  [SMALL_STATE(3804)] = 128640,
  [SMALL_STATE(3805)] = 128648,
  [SMALL_STATE(3806)] = 128656,
  [SMALL_STATE(3807)] = 128664,
  [SMALL_STATE(3808)] = 128674,
  [SMALL_STATE(3809)] = 128682,
  [SMALL_STATE(3810)] = 128692,
  [SMALL_STATE(3811)] = 128700,
  [SMALL_STATE(3812)] = 128710,
  [SMALL_STATE(3813)] = 128720,
  [SMALL_STATE(3814)] = 128730,
  [SMALL_STATE(3815)] = 128740,
  [SMALL_STATE(3816)] = 128750,
  [SMALL_STATE(3817)] = 128758,
  [SMALL_STATE(3818)] = 128768,
  [SMALL_STATE(3819)] = 128778,
  [SMALL_STATE(3820)] = 128786,
  [SMALL_STATE(3821)] = 128796,
  [SMALL_STATE(3822)] = 128806,
  [SMALL_STATE(3823)] = 128816,
  [SMALL_STATE(3824)] = 128826,
  [SMALL_STATE(3825)] = 128834,
  [SMALL_STATE(3826)] = 128844,
  [SMALL_STATE(3827)] = 128852,
  [SMALL_STATE(3828)] = 128862,
  [SMALL_STATE(3829)] = 128872,
  [SMALL_STATE(3830)] = 128882,
  [SMALL_STATE(3831)] = 128890,
  [SMALL_STATE(3832)] = 128898,
  [SMALL_STATE(3833)] = 128908,
  [SMALL_STATE(3834)] = 128916,
  [SMALL_STATE(3835)] = 128926,
  [SMALL_STATE(3836)] = 128936,
  [SMALL_STATE(3837)] = 128946,
  [SMALL_STATE(3838)] = 128956,
  [SMALL_STATE(3839)] = 128966,
  [SMALL_STATE(3840)] = 128976,
  [SMALL_STATE(3841)] = 128986,
  [SMALL_STATE(3842)] = 128996,
  [SMALL_STATE(3843)] = 129003,
  [SMALL_STATE(3844)] = 129010,
  [SMALL_STATE(3845)] = 129017,
  [SMALL_STATE(3846)] = 129024,
  [SMALL_STATE(3847)] = 129031,
  [SMALL_STATE(3848)] = 129038,
  [SMALL_STATE(3849)] = 129045,
  [SMALL_STATE(3850)] = 129052,
  [SMALL_STATE(3851)] = 129059,
  [SMALL_STATE(3852)] = 129066,
  [SMALL_STATE(3853)] = 129073,
  [SMALL_STATE(3854)] = 129080,
  [SMALL_STATE(3855)] = 129087,
  [SMALL_STATE(3856)] = 129094,
  [SMALL_STATE(3857)] = 129101,
  [SMALL_STATE(3858)] = 129108,
  [SMALL_STATE(3859)] = 129115,
  [SMALL_STATE(3860)] = 129122,
  [SMALL_STATE(3861)] = 129129,
  [SMALL_STATE(3862)] = 129136,
  [SMALL_STATE(3863)] = 129143,
  [SMALL_STATE(3864)] = 129150,
  [SMALL_STATE(3865)] = 129157,
  [SMALL_STATE(3866)] = 129164,
  [SMALL_STATE(3867)] = 129171,
  [SMALL_STATE(3868)] = 129178,
  [SMALL_STATE(3869)] = 129185,
  [SMALL_STATE(3870)] = 129192,
  [SMALL_STATE(3871)] = 129199,
  [SMALL_STATE(3872)] = 129206,
  [SMALL_STATE(3873)] = 129213,
  [SMALL_STATE(3874)] = 129220,
  [SMALL_STATE(3875)] = 129227,
  [SMALL_STATE(3876)] = 129234,
  [SMALL_STATE(3877)] = 129241,
  [SMALL_STATE(3878)] = 129248,
  [SMALL_STATE(3879)] = 129255,
  [SMALL_STATE(3880)] = 129262,
  [SMALL_STATE(3881)] = 129269,
  [SMALL_STATE(3882)] = 129276,
  [SMALL_STATE(3883)] = 129283,
  [SMALL_STATE(3884)] = 129290,
  [SMALL_STATE(3885)] = 129297,
  [SMALL_STATE(3886)] = 129304,
  [SMALL_STATE(3887)] = 129311,
  [SMALL_STATE(3888)] = 129318,
  [SMALL_STATE(3889)] = 129325,
  [SMALL_STATE(3890)] = 129332,
  [SMALL_STATE(3891)] = 129339,
  [SMALL_STATE(3892)] = 129346,
  [SMALL_STATE(3893)] = 129353,
  [SMALL_STATE(3894)] = 129360,
  [SMALL_STATE(3895)] = 129367,
  [SMALL_STATE(3896)] = 129374,
  [SMALL_STATE(3897)] = 129381,
  [SMALL_STATE(3898)] = 129388,
  [SMALL_STATE(3899)] = 129395,
  [SMALL_STATE(3900)] = 129402,
  [SMALL_STATE(3901)] = 129409,
  [SMALL_STATE(3902)] = 129416,
  [SMALL_STATE(3903)] = 129423,
  [SMALL_STATE(3904)] = 129430,
  [SMALL_STATE(3905)] = 129437,
  [SMALL_STATE(3906)] = 129444,
  [SMALL_STATE(3907)] = 129451,
  [SMALL_STATE(3908)] = 129458,
  [SMALL_STATE(3909)] = 129465,
  [SMALL_STATE(3910)] = 129472,
  [SMALL_STATE(3911)] = 129479,
  [SMALL_STATE(3912)] = 129486,
  [SMALL_STATE(3913)] = 129493,
  [SMALL_STATE(3914)] = 129500,
  [SMALL_STATE(3915)] = 129507,
  [SMALL_STATE(3916)] = 129514,
  [SMALL_STATE(3917)] = 129521,
  [SMALL_STATE(3918)] = 129528,
  [SMALL_STATE(3919)] = 129535,
  [SMALL_STATE(3920)] = 129542,
  [SMALL_STATE(3921)] = 129549,
  [SMALL_STATE(3922)] = 129556,
  [SMALL_STATE(3923)] = 129563,
  [SMALL_STATE(3924)] = 129570,
  [SMALL_STATE(3925)] = 129577,
  [SMALL_STATE(3926)] = 129584,
  [SMALL_STATE(3927)] = 129591,
  [SMALL_STATE(3928)] = 129598,
  [SMALL_STATE(3929)] = 129605,
  [SMALL_STATE(3930)] = 129612,
  [SMALL_STATE(3931)] = 129619,
  [SMALL_STATE(3932)] = 129626,
  [SMALL_STATE(3933)] = 129633,
  [SMALL_STATE(3934)] = 129640,
  [SMALL_STATE(3935)] = 129647,
  [SMALL_STATE(3936)] = 129654,
  [SMALL_STATE(3937)] = 129661,
  [SMALL_STATE(3938)] = 129668,
  [SMALL_STATE(3939)] = 129675,
  [SMALL_STATE(3940)] = 129682,
  [SMALL_STATE(3941)] = 129689,
  [SMALL_STATE(3942)] = 129696,
  [SMALL_STATE(3943)] = 129703,
  [SMALL_STATE(3944)] = 129710,
  [SMALL_STATE(3945)] = 129717,
  [SMALL_STATE(3946)] = 129724,
  [SMALL_STATE(3947)] = 129731,
  [SMALL_STATE(3948)] = 129738,
  [SMALL_STATE(3949)] = 129745,
  [SMALL_STATE(3950)] = 129752,
  [SMALL_STATE(3951)] = 129759,
  [SMALL_STATE(3952)] = 129766,
  [SMALL_STATE(3953)] = 129773,
  [SMALL_STATE(3954)] = 129780,
  [SMALL_STATE(3955)] = 129787,
  [SMALL_STATE(3956)] = 129794,
  [SMALL_STATE(3957)] = 129801,
  [SMALL_STATE(3958)] = 129808,
  [SMALL_STATE(3959)] = 129815,
  [SMALL_STATE(3960)] = 129822,
  [SMALL_STATE(3961)] = 129829,
  [SMALL_STATE(3962)] = 129836,
  [SMALL_STATE(3963)] = 129843,
  [SMALL_STATE(3964)] = 129850,
  [SMALL_STATE(3965)] = 129857,
  [SMALL_STATE(3966)] = 129864,
  [SMALL_STATE(3967)] = 129871,
  [SMALL_STATE(3968)] = 129878,
  [SMALL_STATE(3969)] = 129885,
  [SMALL_STATE(3970)] = 129892,
  [SMALL_STATE(3971)] = 129899,
  [SMALL_STATE(3972)] = 129906,
  [SMALL_STATE(3973)] = 129913,
  [SMALL_STATE(3974)] = 129920,
  [SMALL_STATE(3975)] = 129927,
  [SMALL_STATE(3976)] = 129934,
  [SMALL_STATE(3977)] = 129941,
  [SMALL_STATE(3978)] = 129948,
  [SMALL_STATE(3979)] = 129955,
  [SMALL_STATE(3980)] = 129962,
  [SMALL_STATE(3981)] = 129969,
  [SMALL_STATE(3982)] = 129976,
  [SMALL_STATE(3983)] = 129983,
  [SMALL_STATE(3984)] = 129990,
  [SMALL_STATE(3985)] = 129997,
  [SMALL_STATE(3986)] = 130004,
  [SMALL_STATE(3987)] = 130011,
  [SMALL_STATE(3988)] = 130018,
  [SMALL_STATE(3989)] = 130025,
  [SMALL_STATE(3990)] = 130032,
  [SMALL_STATE(3991)] = 130039,
  [SMALL_STATE(3992)] = 130046,
  [SMALL_STATE(3993)] = 130053,
  [SMALL_STATE(3994)] = 130060,
  [SMALL_STATE(3995)] = 130067,
  [SMALL_STATE(3996)] = 130074,
  [SMALL_STATE(3997)] = 130081,
  [SMALL_STATE(3998)] = 130088,
  [SMALL_STATE(3999)] = 130095,
  [SMALL_STATE(4000)] = 130102,
  [SMALL_STATE(4001)] = 130109,
  [SMALL_STATE(4002)] = 130116,
  [SMALL_STATE(4003)] = 130123,
  [SMALL_STATE(4004)] = 130130,
  [SMALL_STATE(4005)] = 130137,
  [SMALL_STATE(4006)] = 130144,
  [SMALL_STATE(4007)] = 130151,
  [SMALL_STATE(4008)] = 130158,
  [SMALL_STATE(4009)] = 130165,
  [SMALL_STATE(4010)] = 130172,
  [SMALL_STATE(4011)] = 130179,
  [SMALL_STATE(4012)] = 130186,
  [SMALL_STATE(4013)] = 130193,
  [SMALL_STATE(4014)] = 130200,
  [SMALL_STATE(4015)] = 130207,
  [SMALL_STATE(4016)] = 130214,
  [SMALL_STATE(4017)] = 130221,
  [SMALL_STATE(4018)] = 130228,
  [SMALL_STATE(4019)] = 130235,
  [SMALL_STATE(4020)] = 130242,
  [SMALL_STATE(4021)] = 130249,
  [SMALL_STATE(4022)] = 130256,
  [SMALL_STATE(4023)] = 130263,
  [SMALL_STATE(4024)] = 130270,
  [SMALL_STATE(4025)] = 130277,
  [SMALL_STATE(4026)] = 130284,
  [SMALL_STATE(4027)] = 130291,
  [SMALL_STATE(4028)] = 130298,
  [SMALL_STATE(4029)] = 130305,
  [SMALL_STATE(4030)] = 130312,
  [SMALL_STATE(4031)] = 130319,
  [SMALL_STATE(4032)] = 130326,
  [SMALL_STATE(4033)] = 130333,
  [SMALL_STATE(4034)] = 130340,
  [SMALL_STATE(4035)] = 130347,
  [SMALL_STATE(4036)] = 130354,
  [SMALL_STATE(4037)] = 130361,
  [SMALL_STATE(4038)] = 130368,
  [SMALL_STATE(4039)] = 130375,
  [SMALL_STATE(4040)] = 130382,
  [SMALL_STATE(4041)] = 130389,
  [SMALL_STATE(4042)] = 130396,
  [SMALL_STATE(4043)] = 130403,
  [SMALL_STATE(4044)] = 130410,
  [SMALL_STATE(4045)] = 130417,
  [SMALL_STATE(4046)] = 130424,
  [SMALL_STATE(4047)] = 130431,
  [SMALL_STATE(4048)] = 130438,
  [SMALL_STATE(4049)] = 130445,
  [SMALL_STATE(4050)] = 130452,
  [SMALL_STATE(4051)] = 130459,
  [SMALL_STATE(4052)] = 130466,
  [SMALL_STATE(4053)] = 130473,
  [SMALL_STATE(4054)] = 130480,
  [SMALL_STATE(4055)] = 130487,
  [SMALL_STATE(4056)] = 130494,
  [SMALL_STATE(4057)] = 130501,
  [SMALL_STATE(4058)] = 130508,
  [SMALL_STATE(4059)] = 130515,
  [SMALL_STATE(4060)] = 130522,
  [SMALL_STATE(4061)] = 130529,
  [SMALL_STATE(4062)] = 130536,
  [SMALL_STATE(4063)] = 130543,
  [SMALL_STATE(4064)] = 130550,
  [SMALL_STATE(4065)] = 130557,
  [SMALL_STATE(4066)] = 130564,
  [SMALL_STATE(4067)] = 130571,
  [SMALL_STATE(4068)] = 130578,
  [SMALL_STATE(4069)] = 130585,
  [SMALL_STATE(4070)] = 130592,
  [SMALL_STATE(4071)] = 130599,
  [SMALL_STATE(4072)] = 130606,
  [SMALL_STATE(4073)] = 130613,
  [SMALL_STATE(4074)] = 130620,
  [SMALL_STATE(4075)] = 130627,
  [SMALL_STATE(4076)] = 130634,
  [SMALL_STATE(4077)] = 130641,
  [SMALL_STATE(4078)] = 130648,
  [SMALL_STATE(4079)] = 130655,
  [SMALL_STATE(4080)] = 130662,
  [SMALL_STATE(4081)] = 130669,
  [SMALL_STATE(4082)] = 130676,
  [SMALL_STATE(4083)] = 130683,
  [SMALL_STATE(4084)] = 130690,
  [SMALL_STATE(4085)] = 130697,
  [SMALL_STATE(4086)] = 130704,
  [SMALL_STATE(4087)] = 130711,
  [SMALL_STATE(4088)] = 130718,
  [SMALL_STATE(4089)] = 130725,
  [SMALL_STATE(4090)] = 130732,
  [SMALL_STATE(4091)] = 130739,
  [SMALL_STATE(4092)] = 130746,
  [SMALL_STATE(4093)] = 130753,
  [SMALL_STATE(4094)] = 130760,
  [SMALL_STATE(4095)] = 130767,
  [SMALL_STATE(4096)] = 130774,
  [SMALL_STATE(4097)] = 130781,
  [SMALL_STATE(4098)] = 130788,
  [SMALL_STATE(4099)] = 130795,
  [SMALL_STATE(4100)] = 130802,
  [SMALL_STATE(4101)] = 130809,
  [SMALL_STATE(4102)] = 130816,
  [SMALL_STATE(4103)] = 130823,
  [SMALL_STATE(4104)] = 130830,
  [SMALL_STATE(4105)] = 130837,
  [SMALL_STATE(4106)] = 130844,
  [SMALL_STATE(4107)] = 130851,
  [SMALL_STATE(4108)] = 130858,
  [SMALL_STATE(4109)] = 130865,
  [SMALL_STATE(4110)] = 130872,
  [SMALL_STATE(4111)] = 130879,
  [SMALL_STATE(4112)] = 130886,
  [SMALL_STATE(4113)] = 130893,
  [SMALL_STATE(4114)] = 130900,
  [SMALL_STATE(4115)] = 130907,
  [SMALL_STATE(4116)] = 130914,
  [SMALL_STATE(4117)] = 130921,
  [SMALL_STATE(4118)] = 130928,
  [SMALL_STATE(4119)] = 130935,
  [SMALL_STATE(4120)] = 130942,
  [SMALL_STATE(4121)] = 130949,
  [SMALL_STATE(4122)] = 130956,
  [SMALL_STATE(4123)] = 130963,
  [SMALL_STATE(4124)] = 130970,
  [SMALL_STATE(4125)] = 130977,
  [SMALL_STATE(4126)] = 130984,
  [SMALL_STATE(4127)] = 130991,
  [SMALL_STATE(4128)] = 130998,
  [SMALL_STATE(4129)] = 131005,
  [SMALL_STATE(4130)] = 131012,
  [SMALL_STATE(4131)] = 131019,
  [SMALL_STATE(4132)] = 131026,
  [SMALL_STATE(4133)] = 131033,
  [SMALL_STATE(4134)] = 131040,
  [SMALL_STATE(4135)] = 131047,
  [SMALL_STATE(4136)] = 131054,
  [SMALL_STATE(4137)] = 131061,
  [SMALL_STATE(4138)] = 131068,
  [SMALL_STATE(4139)] = 131075,
  [SMALL_STATE(4140)] = 131082,
  [SMALL_STATE(4141)] = 131089,
  [SMALL_STATE(4142)] = 131096,
  [SMALL_STATE(4143)] = 131103,
  [SMALL_STATE(4144)] = 131110,
  [SMALL_STATE(4145)] = 131117,
  [SMALL_STATE(4146)] = 131124,
  [SMALL_STATE(4147)] = 131131,
  [SMALL_STATE(4148)] = 131138,
  [SMALL_STATE(4149)] = 131145,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4141),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2786),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4134),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4131),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(373),
  [114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(390),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3890),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(393),
  [174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4066),
  [198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(419),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1064),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(270),
  [317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1040),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(964),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(357),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1159),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2785),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2766),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2689),
  [343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(357),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3612),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3591),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3356),
  [355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(116),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(401),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3592),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(29),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3594),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3595),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3357),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3358),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3598),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(205),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(307),
  [388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(609),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(88),
  [394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(151),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(825),
  [400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4141),
  [403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2592),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(563),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2786),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(304),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(521),
  [418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3243),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3244),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2817),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1872),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1872),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1851),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3359),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1075),
  [442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(527),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(967),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4134),
  [451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4132),
  [454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4131),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 198),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 198),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 56),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 56),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 57),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 57),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3784),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3783),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3890),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(130),
  [592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(159),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(825),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2860),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [1073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3254),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3898),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3899),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [1228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3296),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3886),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 26),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 26),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 148),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 148),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 148),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 148),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 153),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 153),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 153),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 153),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 153),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 153),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 153),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 153),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 161),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 161),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 161),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 161),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 162),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 162),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 162),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 162),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 104),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 104),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 104),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 104),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 55),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 55),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 55),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 55),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 105),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 105),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 114),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 114),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 114),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 114),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 122),
  [1442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 122),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 122),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 122),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 187),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 187),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 187),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 187),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 193),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 193),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 193),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 193),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [1564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1567] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2559),
  [1571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1575] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2327),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [1637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(31),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4032),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3260),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3259),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2235),
  [1855] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(149),
  [1859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(350),
  [1862] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3640),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3945),
  [1950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(149),
  [1953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3640),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [1958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [1968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(244),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4102),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4100),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [1985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4047),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4046),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [1999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(402),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4094),
  [2020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3888),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3887),
  [2028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 220),
  [2030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 220),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 34),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 34),
  [2036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 201),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 201),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 113),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 113),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 36),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 36),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 148),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 148),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 22),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 22),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 76),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 76),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 155),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 155),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 194),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 194),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 154),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 154),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 195),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 195),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 88),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 88),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 126),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 126),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 216),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 216),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 162),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 162),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 128),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 128),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 55),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 55),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 64),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 64),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 193),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 193),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 192),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 192),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 190),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 190),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 215),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 215),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 187),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 187),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 192),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 192),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 190),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 190),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 76),
  [2180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 76),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 114),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 114),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 188),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 188),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 153),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 153),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 153),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 153),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 152),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 152),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 87),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 87),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 132),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 132),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 121),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 121),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 86),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 86),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 33),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 33),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 72),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 72),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 105),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 105),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 104),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 104),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 104),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 104),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 160),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 160),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 116),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 116),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 78),
  [2344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 78),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 122),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 122),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 200),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 200),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 164),
  [2364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 164),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 35),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 35),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 166),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 166),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 33),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 33),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 82),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 82),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 170),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 170),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 30),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 30),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 219),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 219),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 168),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 168),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 169),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 169),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 199),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 199),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 89),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 89),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4109),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [2562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [2568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3917),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [2838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [2840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [2869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [2879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 119),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 119),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [2887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [2891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 66),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 66),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 67),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 67),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 159),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 159),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [2935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(526),
  [2938] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [2947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(851),
  [2950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(3928),
  [2953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [2956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(3799),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12),
  [2961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(887),
  [2964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4138),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [2992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [2994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(447),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [3008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3012] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12), REDUCE(sym_rest_pattern, 2),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3028] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(243),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [3039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [3042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [3044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [3046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21), SHIFT_REPEAT(3359),
  [3049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(386),
  [3052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [3060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3904),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [3066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21), SHIFT(2584),
  [3069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 66),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 66),
  [3073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [3077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3932),
  [3129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1297),
  [3132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1308),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [3139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1317),
  [3142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1904),
  [3145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1663),
  [3148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1460),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [3173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3201] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 27), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 28),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [3227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [3251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [3255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [3259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 12),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 47),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 47),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [3339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 48),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 48),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [3355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [3367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [3369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 15),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 15),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 143),
  [3409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 143),
  [3411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 142),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 142),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 144),
  [3417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 144),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 141),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 141),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 84),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 84),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 140),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 140),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 145),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 145),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [3445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [3447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 119),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 119),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 139),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 139),
  [3459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 138),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 138),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 179),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 179),
  [3467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 98),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 98),
  [3471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 180),
  [3473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 180),
  [3475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 49),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 49),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [3487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 67),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 67),
  [3491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [3495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 66),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 66),
  [3499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 181),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 181),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [3525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 50),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 50),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 53),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 53),
  [3555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [3569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 102),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 102),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 54),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 54),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 182),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 182),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 159),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 159),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 208),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 208),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 100),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 100),
  [3597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 100),
  [3600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 209),
  [3602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 209),
  [3604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [3606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [3610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [3612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 210),
  [3614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 210),
  [3616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 229),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 229),
  [3620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [3638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 99),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 99),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 18),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 18),
  [3646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 73),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 73),
  [3650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [3658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 27),
  [3706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 28),
  [3708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 27),
  [3710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [3724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 27), REDUCE(sym_object_pattern, 3, .production_id = 28),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 27),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 27),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(76),
  [3742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [3749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [3758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [3772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(76),
  [3775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 65),
  [3786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 70),
  [3788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 70),
  [3790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 69),
  [3792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 69),
  [3794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 68),
  [3796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 68),
  [3798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [3802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(76),
  [3805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [3808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 103),
  [3810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 103),
  [3812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 163),
  [3814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 163),
  [3816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 108),
  [3818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 108),
  [3820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 109),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 109),
  [3824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 158),
  [3826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 151),
  [3828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 151),
  [3830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 110),
  [3832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 110),
  [3834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 111),
  [3836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 111),
  [3838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [3840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [3842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [3844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [3846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(76),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 110),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 110),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 57),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 57),
  [3861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 115),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 115),
  [3865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 58),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 58),
  [3869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 59),
  [3871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 59),
  [3873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 60),
  [3879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 60),
  [3881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11),
  [3885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 120),
  [3899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 120),
  [3901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 123),
  [3903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 123),
  [3905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 124),
  [3907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 124),
  [3909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 63),
  [3911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 63),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 62),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [3933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [3935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [3939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 56),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [4043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(77),
  [4046] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(77),
  [4053] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [4093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(84),
  [4096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 79),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 79), REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 79), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 62), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 62),
  [4115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(77),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 28),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [4134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(84),
  [4137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(84),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2548),
  [4155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2259),
  [4158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(284),
  [4163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1969),
  [4166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3957),
  [4169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3320),
  [4172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3322),
  [4175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2420),
  [4178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3382),
  [4181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1949),
  [4184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1951),
  [4187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2074),
  [4190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1712),
  [4193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2010),
  [4196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2065),
  [4199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2225),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(84),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [4213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 56),
  [4215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 56), SHIFT(394),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(77),
  [4225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4246] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 14),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [4272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 37),
  [4274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 37),
  [4276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym__parameter_name, 2, .production_id = 37),
  [4279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 62),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 37),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 37),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [4307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 14),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [4316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(83),
  [4319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(83),
  [4322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(83),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [4331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(83),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 56),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [4338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(80),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(80),
  [4416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(80),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [4427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(80),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [4446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(78),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 27), REDUCE(sym_object_pattern, 3, .production_id = 28),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [4468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 129),
  [4470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 129),
  [4472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 131),
  [4474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 131),
  [4476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [4487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [4492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(78),
  [4495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(78),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [4500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [4505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(78),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4525] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [4529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 94),
  [4531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 94),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [4537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [4539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 171),
  [4541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 171),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [4545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 80),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [4555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [4557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [4567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [4573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(85),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 56), SHIFT(420),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [4611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [4615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [4625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(85),
  [4648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(85),
  [4651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(85),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [4704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 108), REDUCE(sym_class, 5, .production_id = 163),
  [4707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 108), REDUCE(sym_class, 5, .production_id = 163),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [4724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [4738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [4744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [4746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 55), REDUCE(sym_class, 4, .production_id = 122),
  [4749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 55), REDUCE(sym_class, 4, .production_id = 122),
  [4752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 57), REDUCE(sym_class, 4, .production_id = 123),
  [4755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 57), REDUCE(sym_class, 4, .production_id = 123),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [4764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [4772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 104), REDUCE(sym_class, 5, .production_id = 161),
  [4775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 104), REDUCE(sym_class, 5, .production_id = 161),
  [4778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 105), REDUCE(sym_class, 5, .production_id = 162),
  [4781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 105), REDUCE(sym_class, 5, .production_id = 162),
  [4784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 58), REDUCE(sym_class, 4, .production_id = 124),
  [4787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 58), REDUCE(sym_class, 4, .production_id = 124),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [4834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [4836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [4842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [4848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [4854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 73),
  [4857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 73),
  [4860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(81),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [4865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [4883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(81),
  [4886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(81),
  [4889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(81),
  [4892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 148), REDUCE(sym_class, 6, .production_id = 193),
  [4895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 148), REDUCE(sym_class, 6, .production_id = 193),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4024),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [4902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [4906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [4910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [4914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [4920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [4936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 27), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 28),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [4941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [4945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 27),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [4963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [4979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 167),
  [4981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 167),
  [4983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 114),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 114),
  [4987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 153),
  [4989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 153),
  [4991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 196),
  [4993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 196),
  [4995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 187),
  [4997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 187),
  [4999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 218),
  [5001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 218),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [5005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [5009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [5011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 217),
  [5013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 217),
  [5015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 235),
  [5017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 235),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [5025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [5031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 81),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 81),
  [5035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [5041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 257),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 257),
  [5045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 127),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 127),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 248),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 248),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [5055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 247),
  [5057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 247),
  [5059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 236),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 236),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [5065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [5077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [5081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [5099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [5121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [5123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [5125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [5129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [5137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [5139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4091),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [5227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 178),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [5261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 76),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [5277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 135),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [5293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [5327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 207),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 76),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [5363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 207),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [5367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 135),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 178),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [5377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [5397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), REDUCE(sym_type_parameter, 1, .production_id = 13),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [5402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(898),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [5407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 135),
  [5409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 76),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 178),
  [5413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 178),
  [5417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 207),
  [5419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(3799),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 207),
  [5424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 76),
  [5426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 135),
  [5428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [5434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [5452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [5458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [5466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [5478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [5486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [5512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 28),
  [5514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [5520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 234),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [5534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [5536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4087),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [5564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [5576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 106),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 238),
  [5588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [5590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [5592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 97),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 96),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 237),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [5604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 113),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 137),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [5612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [5618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 225),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 3, .production_id = 106),
  [5630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 172),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 10),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 152),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [5648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 234),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 251),
  [5656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 252),
  [5658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 258),
  [5660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 13),
  [5662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(447),
  [5665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 226),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [5675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(526),
  [5678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 202),
  [5680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 117),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [5686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 117),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [5692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [5694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 203),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [5704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 134),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [5710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [5732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3910),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [5770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 10),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [5774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [5776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4029),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [5790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 117),
  [5792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 117),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [5812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [5816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [5818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 71),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [5838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 19),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [5862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [5874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1177),
  [5877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [5899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3856),
  [5902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(245),
  [5907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [5917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2919),
  [5924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(253),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [5971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [5993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [5995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [6011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(933),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [6024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [6030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(820),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [6041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [6049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 46),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 32),
  [6069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(947),
  [6072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(841),
  [6075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [6077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(945),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [6088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [6090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(915),
  [6093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3025),
  [6096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [6098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [6100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 32),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [6114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [6126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 136),
  [6128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 84),
  [6130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(906),
  [6133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 136),
  [6137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 84),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 133),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [6143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(816),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [6148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 173),
  [6150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 174),
  [6152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 175),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [6156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 176),
  [6158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 177),
  [6160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 176),
  [6162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 177),
  [6164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(826),
  [6167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 204),
  [6173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 205),
  [6175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 206),
  [6177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 204),
  [6179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 205),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [6185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 221),
  [6187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 223),
  [6189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 224),
  [6191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 227),
  [6193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 228),
  [6195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 227),
  [6197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 228),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [6203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 239),
  [6205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 240),
  [6207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 241),
  [6209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 246),
  [6211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 249),
  [6213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 250),
  [6215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [6217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 241),
  [6219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 255),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [6233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [6237] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [6239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [6269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [6289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 39),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(177),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [6300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 52),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [6304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [6306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3276),
  [6309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [6311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3277),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [6318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [6320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 28),
  [6322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2798),
  [6325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 92),
  [6329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [6331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [6336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(917),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [6341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 107),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [6345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [6353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 4, .production_id = 149),
  [6355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 150),
  [6357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 150), SHIFT_REPEAT(441),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [6362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 156),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 156),
  [6366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 157),
  [6368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 157),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [6382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [6384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 189),
  [6386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 189), SHIFT_REPEAT(3302),
  [6389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 189),
  [6391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 76),
  [6393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [6405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 222),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [6415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [6419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [6421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [6431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [6435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [6441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [6451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [6469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [6487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 259),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [6491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [6493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(386),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [6502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [6508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 256),
  [6510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 254),
  [6512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 253),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [6518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [6532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [6538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [6542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [6548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 243),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 245),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(2072),
  [6595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [6597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 244),
  [6599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(1983),
  [6602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [6606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 214),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [6614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [6616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [6626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 242),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [6632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [6638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(176),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [6683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 76),
  [6685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [6687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 77),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [6693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 225),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [6697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 233),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [6701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 232),
  [6703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 231),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [6707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 230),
  [6709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 80),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [6717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 84),
  [6719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 85),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [6729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [6733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(157),
  [6736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 211),
  [6770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 202),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [6778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 203),
  [6780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(3674),
  [6783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 31),
  [6787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [6799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 213),
  [6801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 212),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 77),
  [6821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [6829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(3308),
  [6832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(3306),
  [6837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [6847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(786),
  [6850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [6852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [6854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [6860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 146),
  [6862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 113),
  [6864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 147),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [6878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 85),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [6886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 191), SHIFT_REPEAT(2217),
  [6889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 191),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [6917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 183),
  [6919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 152),
  [6921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 186),
  [6923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 184),
  [6925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 172),
  [6927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 77),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [6933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 185),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [7005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 165),
  [7007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 31),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [7029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, .production_id = 197),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [7035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 84),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [7069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 130),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [7075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 38),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [7083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 83),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [7097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 51),
  [7099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 125),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [7105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 101),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [7109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [7111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 32),
  [7113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 30),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [7117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 77),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [7135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 93),
  [7137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 91),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [7147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [7153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 83),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [7167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [7209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [7213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import_export, 3),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [7233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [7235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [7251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [7257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [7267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [7303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [7307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [7313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 83),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [7359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [7397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [7435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [7443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [7513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [7523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [7551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 83),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [7597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [7633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7643] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [7665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4061),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
